/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(he){for(var e=[],u=0,L=he.length;u<L;u++)e[u]=ke[he[u]];return e};define(ke[161],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const O=new Map,A=new Map,M=new Map,b=new Map;function $(C,k){C.has(k.detail)||C.set(k.detail,-k.timestamp)}function v(C,k){const c=C.get(k.detail);c&&(c>=0||C.set(k.detail,c+k.timestamp))}let R=[];typeof he=="function"&&typeof he.getStats=="function"&&(R=he.getStats().slice(0).sort((C,k)=>C.timestamp-k.timestamp));for(const C of R)switch(C.type){case 10:$(O,C);break;case 11:case 12:v(O,C);break;case 21:$(A,C);break;case 22:v(A,C);break;case 33:$(M,C);break;case 34:v(M,C);break;case 31:$(b,C);break;case 32:v(b,C);break}let I=0;M.forEach(C=>I+=C);function p(C){const k=[];return C.forEach((c,m)=>k.push([m,c])),k}return{amdLoad:p(O),amdInvoke:p(A),nodeRequire:p(M),nodeEval:p(b),nodeRequireTotal:I}}static toMarkdownTable(O,A){let M="";const b=[];return O.forEach(($,v)=>{b[v]=$.length}),A.forEach($=>{$.forEach((v,R)=>{typeof v>"u"&&(v=$[R]="-");const I=v.toString().length;b[R]=Math.max(I,b[R])})}),O.forEach(($,v)=>{M+=`| ${$+" ".repeat(b[v]-$.toString().length)} `}),M+=`|
`,O.forEach(($,v)=>{M+=`| ${"-".repeat(b[v])} `}),M+=`|
`,A.forEach($=>{$.forEach((v,R)=>{typeof v<"u"&&(M+=`| ${v+" ".repeat(b[R]-v.toString().length)} `)}),M+=`|
`}),M}}e.$U=u}),define(ke[162],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=L,e.$hb=O,e.$ib=A,e.$jb=M,e.$kb=b,e.$lb=$,e.$nb=R,e.$ob=I,e.$pb=p,e.$qb=C,e.$rb=k;function u(c,m,o){const n=L(c,m);if(n!==-1)return c[n]}function L(c,m,o=c.length-1){for(let n=o;n>=0;n--){const i=c[n];if(m(i))return n}return-1}function O(c,m){const o=A(c,m);return o===-1?void 0:c[o]}function A(c,m,o=0,n=c.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(c[s])?i=s+1:r=s}return i-1}function M(c,m){const o=b(c,m);return o===c.length?void 0:c[o]}function b(c,m,o=0,n=c.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(c[s])?r=s:i=s+1}return i}function $(c,m,o=0,n=c.length){const i=b(c,m,o,n);return i===c.length?-1:i}class v{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(v.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!m(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const o=A(this.e,m,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=v;function R(c,m){if(c.length===0)return;let o=c[0];for(let n=1;n<c.length;n++){const i=c[n];m(i,o)>0&&(o=i)}return o}function I(c,m){if(c.length===0)return;let o=c[0];for(let n=1;n<c.length;n++){const i=c[n];m(i,o)>=0&&(o=i)}return o}function p(c,m){return R(c,(o,n)=>-m(o,n))}function C(c,m){if(c.length===0)return-1;let o=0;for(let n=1;n<c.length;n++){const i=c[n];m(i,c[o])>0&&(o=n)}return o}function k(c,m){for(const o of c){const n=m(o);if(n!==void 0)return n}}}),define(ke[73],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=L,e.$M=O,e.$N=A;function u(M,b){const $=Object.create(null);for(const v of M){const R=b(v);let I=$[R];I||(I=$[R]=[]),I.push(v)}return $}function L(M,b){const $=[],v=[];for(const R of M)b.has(R)||$.push(R);for(const R of b)M.has(R)||v.push(R);return{removed:$,added:v}}function O(M,b){const $=[],v=[];for(const[R,I]of M)b.has(R)||$.push(I);for(const[R,I]of b)M.has(R)||v.push(I);return{removed:$,added:v}}function A(M,b){const $=new Set;for(const v of b)M.has(v)&&$.add(v);return $}}),define(ke[54],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=L,e.$Nh=O,e.$Oh=A;function u(M){return(b,$,v)=>{let R=null,I=null;if(typeof v.value=="function"?(R="value",I=v.value):typeof v.get=="function"&&(R="get",I=v.get),!I)throw new Error("not supported");v[R]=M(I,$)}}function L(M,b,$){let v=null,R=null;if(typeof $.value=="function"?(v="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(v="get",R=$.get),!R)throw new Error("not supported");const I=`$memoize$${b}`;$[v]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[I]}}function O(M,b,$){return u((v,R)=>{const I=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...C){this[p]||(this[p]=$?$():void 0),clearTimeout(this[I]),b&&(this[p]=b(this[p],...C),C=[this[p]]),this[I]=setTimeout(()=>{v.apply(this,C),this[p]=$?$():void 0},M)}})}function A(M,b,$){return u((v,R)=>{const I=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,C=`$throttle$lastRun$${R}`,k=`$throttle$pending$${R}`;return function(...c){if(this[p]||(this[p]=$?$():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...c)),this[k])return;const m=this[C]+M;m<=Date.now()?(this[C]=Date.now(),v.apply(this,[this[p]]),this[p]=$?$():void 0):(this[k]=!0,this[I]=setTimeout(()=>{this[k]=!1,this[C]=Date.now(),v.apply(this,[this[p]]),this[p]=$?$():void 0},m-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=O,e.$1=A,e.$2=M,e.$3=b,e.$4=v,e.$6=I,e.$7=p,e.$8=C,e.$0=c;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function L(s){e.$X.setUnexpectedErrorHandler(s)}function O(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(s){v(s)||e.$X.onUnexpectedError(s)}function M(s){v(s)||e.$X.onUnexpectedExternalError(s)}function b(s){if(s instanceof Error){const{name:t,message:f}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:f,stack:d,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const $="Canceled";function v(s){return s instanceof R?!0:s instanceof Error&&s.name===$&&s.message===$}class R extends Error{constructor(){super($),this.name=this.message}}e.$5=R;function I(){const s=new Error($);return s.name=s.message,s}function p(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function C(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function c(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const f=new i;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(ke[19],Ee([1,0,13,162]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=O,e.$tb=A,e.$ub=M,e.$vb=b,e.$wb=$,e.$xb=v,e.$yb=R,e.$zb=I,e.$Ab=p,e.$Bb=C,e.$Cb=k,e.$Db=c,e.$Eb=m,e.top=o,e.$Gb=n,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=f,e.$Lb=d,e.$Mb=l,e.$Nb=a,e.$Ob=h,e.$Pb=g,e.$Qb=S,e.$Rb=w,e.$Sb=E,e.$Tb=y,e.$Ub=D,e.$Vb=P,e.$Wb=z,e.$Xb=F,e.$Yb=T,e.$Zb=j,e.$1b=N,e.$2b=B,e.$3b=W,e.$4b=Y,e.$5b=_,e.$6b=J,e.$7b=ee,e.$8b=pe,e.$$b=U;function O(ae,ce=0){return ae[ae.length-(1+ce)]}function A(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function M(ae,ce,se=(K,te)=>K===te){if(ae===ce)return!0;if(!ae||!ce||ae.length!==ce.length)return!1;for(let K=0,te=ae.length;K<te;K++)if(!se(ae[K],ce[K]))return!1;return!0}function b(ae,ce){const se=ae.length-1;ce<se&&(ae[ce]=ae[se]),ae.pop()}function $(ae,ce,se){return v(ae.length,K=>se(ae[K],ce))}function v(ae,ce){let se=0,K=ae-1;for(;se<=K;){const te=(se+K)/2|0,le=ce(te);if(le<0)se=te+1;else if(le>0)K=te-1;else return te}return-(se+1)}function R(ae,ce,se){if(ae=ae|0,ae>=ce.length)throw new TypeError("invalid index");const K=ce[Math.floor(ce.length*Math.random())],te=[],le=[],de=[];for(const Ae of ce){const me=se(Ae,K);me<0?te.push(Ae):me>0?le.push(Ae):de.push(Ae)}return ae<te.length?R(ae,te,se):ae<te.length+de.length?de[0]:R(ae-(te.length+de.length),le,se)}function I(ae,ce){const se=[];let K;for(const te of ae.slice(0).sort(ce))!K||ce(K[0],te)!==0?(K=[te],se.push(K)):K.push(te);return se}function*p(ae,ce){let se,K;for(const te of ae)K!==void 0&&ce(K,te)?se.push(te):(se&&(yield se),se=[te]),K=te;se&&(yield se)}function C(ae,ce){for(let se=0;se<=ae.length;se++)ce(se===0?void 0:ae[se-1],se===ae.length?void 0:ae[se])}function k(ae,ce){for(let se=0;se<ae.length;se++)ce(se===0?void 0:ae[se-1],ae[se],se+1===ae.length?void 0:ae[se+1])}function c(ae,ce,se){const K=[];function te(Ae,me,Ie){if(me===0&&Ie.length===0)return;const Re=K[K.length-1];Re&&Re.start+Re.deleteCount===Ae?(Re.deleteCount+=me,Re.toInsert.push(...Ie)):K.push({start:Ae,deleteCount:me,toInsert:Ie})}let le=0,de=0;for(;;){if(le===ae.length){te(le,0,ce.slice(de));break}if(de===ce.length){te(le,ae.length-le,[]);break}const Ae=ae[le],me=ce[de],Ie=se(Ae,me);Ie===0?(le+=1,de+=1):Ie<0?(te(le,1,[]),le+=1):Ie>0&&(te(le,0,[me]),de+=1)}return K}function m(ae,ce,se){const K=c(ae,ce,se),te=[],le=[];for(const de of K)te.push(...ae.slice(de.start,de.start+de.deleteCount)),le.push(...de.toInsert);return{removed:te,added:le}}function o(ae,ce,se){if(se===0)return[];const K=ae.slice(0,se).sort(ce);return i(ae,ce,K,se,ae.length),K}function n(ae,ce,se,K,te){return se===0?Promise.resolve([]):new Promise((le,de)=>{(async()=>{const Ae=ae.length,me=ae.slice(0,se).sort(ce);for(let Ie=se,Re=Math.min(se+K,Ae);Ie<Ae;Ie=Re,Re=Math.min(Re+K,Ae)){if(Ie>se&&await new Promise(Fe=>setTimeout(Fe)),te&&te.isCancellationRequested)throw new u.$5;i(ae,ce,me,Ie,Re)}return me})().then(le,de)})}function i(ae,ce,se,K,te){for(const le=se.length;K<te;K++){const de=ae[K];if(ce(de,se[le-1])<0){se.pop();const Ae=(0,L.$kb)(se,me=>ce(de,me)<0);se.splice(Ae,0,de)}}}function r(ae){return ae.filter(ce=>!!ce)}function s(ae){let ce=0;for(let se=0;se<ae.length;se++)ae[se]&&(ae[ce]=ae[se],ce+=1);ae.length=ce}function t(ae,ce,se){ae.splice(se,0,ae.splice(ce,1)[0])}function f(ae){return!Array.isArray(ae)||ae.length===0}function d(ae){return Array.isArray(ae)&&ae.length>0}function l(ae,ce=se=>se){const se=new Set;return ae.filter(K=>{const te=ce(K);return se.has(te)?!1:(se.add(te),!0)})}function a(ae){const ce=new Set;return se=>{const K=ae(se);return ce.has(K)?!1:(ce.add(K),!0)}}function h(ae,ce){return ae.length>0?ae[0]:ce}function g(ae,ce){return ae.length>0?ae[ae.length-1]:ce}function S(ae,ce,se=(K,te)=>K===te){let K=0;for(let te=0,le=Math.min(ae.length,ce.length);te<le&&se(ae[te],ce[te]);te++)K++;return K}function w(ae){return[].concat(...ae)}function E(ae,ce){let se=typeof ce=="number"?ae:0;typeof ce=="number"?se=ae:(se=0,ce=ae);const K=[];if(se<=ce)for(let te=se;te<ce;te++)K.push(te);else for(let te=se;te>ce;te--)K.push(te);return K}function y(ae,ce,se){return ae.reduce((K,te)=>(K[ce(te)]=se?se(te):te,K),Object.create(null))}function D(ae,ce){return ae.push(ce),()=>P(ae,ce)}function P(ae,ce){const se=ae.indexOf(ce);if(se>-1)return ae.splice(se,1),ce}function z(ae,ce,se){const K=ae.slice(0,ce),te=ae.slice(ce);return K.concat(se,te)}function F(ae,ce){let se;if(typeof ce=="number"){let K=ce;se=()=>{const te=Math.sin(K++)*179426549;return te-Math.floor(te)}}else se=Math.random;for(let K=ae.length-1;K>0;K-=1){const te=Math.floor(se()*(K+1)),le=ae[K];ae[K]=ae[te],ae[te]=le}}function T(ae,ce){const se=ae.indexOf(ce);se>-1&&(ae.splice(se,1),ae.unshift(ce))}function j(ae,ce){const se=ae.indexOf(ce);se>-1&&(ae.splice(se,1),ae.push(ce))}function N(ae,ce){for(const se of ce)ae.push(se)}function B(ae,ce){return Array.isArray(ae)?ae.map(ce):ce(ae)}function W(ae){return Array.isArray(ae)?ae:[ae]}function Y(ae){return ae[Math.floor(Math.random()*ae.length)]}function _(ae,ce,se){const K=Z(ae,ce),te=ae.length,le=se.length;ae.length=te+le;for(let de=te-1;de>=K;de--)ae[de+le]=ae[de];for(let de=0;de<le;de++)ae[de+K]=se[de]}function J(ae,ce,se,K){const te=Z(ae,ce);let le=ae.splice(te,se);return le===void 0&&(le=[]),_(ae,te,K),le}function Z(ae,ce){return ce<0?Math.max(ce+ae.length,0):Math.min(ce,ae.length)}var re;(function(ae){function ce(le){return le<0}ae.isLessThan=ce;function se(le){return le<=0}ae.isLessThanOrEqual=se;function K(le){return le>0}ae.isGreaterThan=K;function te(le){return le===0}ae.isNeitherLessOrGreaterThan=te,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function ee(ae,ce){return(se,K)=>ce(ae(se),ae(K))}function pe(...ae){return(ce,se)=>{for(const K of ae){const te=K(ce,se);if(!re.isNeitherLessOrGreaterThan(te))return te}return re.neitherLessOrGreaterThan}}const De=(ae,ce)=>ae-ce;e.$9b=De;const x=(ae,ce)=>(0,e.$9b)(ae?1:0,ce?1:0);e.$0b=x;function U(ae){return(ce,se)=>-ae(ce,se)}class ie{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let se=this.c;for(;se<this.g.length&&ce(this.g[se]);)se++;const K=se===this.c?null:this.g.slice(this.c,se);return this.c=se,K}takeFromEndWhile(ce){let se=this.d;for(;se>=0&&ce(this.g[se]);)se--;const K=se===this.d?null:this.g.slice(se+1,this.d+1);return this.d=se,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const se=this.g.slice(this.c,this.c+ce);return this.c+=ce,se}}e.$_b=ie;class be{static{this.empty=new be(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(se=>(ce(se),!0))}toArray(){const ce=[];return this.iterate(se=>(ce.push(se),!0)),ce}filter(ce){return new be(se=>this.iterate(K=>ce(K)?se(K):!0))}map(ce){return new be(se=>this.iterate(K=>se(ce(K))))}some(ce){let se=!1;return this.iterate(K=>(se=ce(K),!se)),se}findFirst(ce){let se;return this.iterate(K=>ce(K)?(se=K,!1):!0),se}findLast(ce){let se;return this.iterate(K=>(ce(K)&&(se=K),!0)),se}findLastMaxBy(ce){let se,K=!0;return this.iterate(te=>((K||re.isGreaterThan(ce(te,se)))&&(K=!1,se=te),!0)),se}}e.$ac=be;class Ce{constructor(ce){this.c=ce}static createSortPermutation(ce,se){const K=Array.from(ce.keys()).sort((te,le)=>se(ce[te],ce[le]));return new Ce(K)}apply(ce){return ce.map((se,K)=>ce[this.c[K]])}inverse(){const ce=this.c.slice();for(let se=0;se<this.c.length;se++)ce[this.c[se]]=se;return new Ce(ce)}}e.$bc=Ce}),define(ke[61],Ee([1,0,13]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$0c=O,e.$$c=A,e.$_c=M,e.$ad=b,e.$bd=$;function L(v,R){if(!v)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function O(v,R="Unreachable"){throw new Error(R)}function A(v){if(!v)throw new u.$cb("Assertion Failed")}function M(v){v||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function b(v){if(!v()){debugger;v(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function $(v,R){let I=0;for(;I<v.length-1;){const p=v[I],C=v[I+1];if(!R(p,C))return!1;I++}return!0}}),define(ke[74],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(L,O){const A=this;let M=!1,b;return function(){if(M)return b;if(M=!0,O)try{b=L.apply(A,arguments)}finally{O()}else b=L.apply(A,arguments);return b}}}),define(ke[124],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0;class u{constructor(O){this.a=O,this.b=0}nextId(){return this.a+ ++this.b}}e.$RO=u,e.$SO=new u("id#")}),define(ke[38],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(L){function O(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=O;const A=Object.freeze([]);function M(){return A}L.empty=M;function*b(t){yield t}L.single=b;function $(t){return O(t)?t:b(t)}L.wrap=$;function v(t){return t||A}L.from=v;function*R(t){for(let f=t.length-1;f>=0;f--)yield t[f]}L.reverse=R;function I(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=I;function p(t){return t[Symbol.iterator]().next().value}L.first=p;function C(t,f){for(const d of t)if(f(d))return!0;return!1}L.some=C;function k(t,f){for(const d of t)if(f(d))return d}L.find=k;function*c(t,f){for(const d of t)f(d)&&(yield d)}L.filter=c;function*m(t,f){let d=0;for(const l of t)yield f(l,d++)}L.map=m;function*o(...t){for(const f of t)yield*f}L.concat=o;function n(t,f,d){let l=d;for(const a of t)l=f(l,a);return l}L.reduce=n;function*i(t,f,d=t.length){for(f<0&&(f+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);f<d;f++)yield t[f]}L.slice=i;function r(t,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,t];const l=t[Symbol.iterator]();for(let a=0;a<f;a++){const h=l.next();if(h.done)return[d,L.empty()];d.push(h.value)}return[d,{[Symbol.iterator](){return l}}]}L.consume=r;async function s(t){const f=[];for await(const d of t)f.push(d);return Promise.resolve(f)}L.asyncToArray=s})(u||(e.Iterable=u={}))}),define(ke[163],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=M,e.$un=I,e.$vn=p,e.$wn=C,e.$xn=k,e.$yn=c,e.$zn=m,e.$An=o,e.$Bn=n,e.$Cn=i,e.$Dn=r,e.$En=s;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function M(t,f=!1){let d=0;const l=t.length;let a="",h=0,g=16,S=0;function w(T){let j=0,N=0;for(;j<T;){const B=t.charCodeAt(d);if(B>=48&&B<=57)N=N*16+B-48;else if(B>=65&&B<=70)N=N*16+B-65+10;else if(B>=97&&B<=102)N=N*16+B-97+10;else break;d++,j++}return j<T&&(N=-1),N}function E(T){d=T,a="",h=0,g=16,S=0}function y(){const T=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&v(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&v(t.charCodeAt(d)))for(d++;d<t.length&&v(t.charCodeAt(d));)d++;else return S=3,t.substring(T,d);let j=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&v(t.charCodeAt(d))){for(d++;d<t.length&&v(t.charCodeAt(d));)d++;j=d}else S=3;return t.substring(T,j)}function D(){let T="",j=d;for(;;){if(d>=l){T+=t.substring(j,d),S=2;break}const N=t.charCodeAt(d);if(N===34){T+=t.substring(j,d),d++;break}if(N===92){if(T+=t.substring(j,d),d++,d>=l){S=2;break}switch(t.charCodeAt(d++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const W=w(4);W>=0?T+=String.fromCharCode(W):S=4;break}default:S=5}j=d;continue}if(N>=0&&N<=31)if($(N)){T+=t.substring(j,d),S=2;break}else S=6;d++}return T}function P(){if(a="",S=0,h=d,d>=l)return h=l,g=17;let T=t.charCodeAt(d);if(b(T)){do d++,a+=String.fromCharCode(T),T=t.charCodeAt(d);while(b(T));return g=15}if($(T))return d++,a+=String.fromCharCode(T),T===13&&t.charCodeAt(d)===10&&(d++,a+=`
`),g=14;switch(T){case 123:return d++,g=1;case 125:return d++,g=2;case 91:return d++,g=3;case 93:return d++,g=4;case 58:return d++,g=6;case 44:return d++,g=5;case 34:return d++,a=D(),g=10;case 47:{const j=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!$(t.charCodeAt(d));)d++;return a=t.substring(j,d),g=12}if(t.charCodeAt(d+1)===42){d+=2;const N=l-1;let B=!1;for(;d<N;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,B=!0;break}d++}return B||(d++,S=1),a=t.substring(j,d),g=13}return a+=String.fromCharCode(T),d++,g=16}case 45:if(a+=String.fromCharCode(T),d++,d===l||!v(t.charCodeAt(d)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=y(),g=11;default:for(;d<l&&z(T);)d++,T=t.charCodeAt(d);if(h!==d){switch(a=t.substring(h,d),a){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return a+=String.fromCharCode(T),d++,g=16}}function z(T){if(b(T)||$(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let T;do T=P();while(T>=12&&T<=15);return T}return{setPosition:E,getPosition:()=>d,scan:f?F:P,getToken:()=>g,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>S}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,f){const d=[],l=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function S(w,E,y,D){h.value=w,h.offset=E,h.length=y,h.type=D,h.colonOffset=void 0,a=h}try{i(t,{onObjectBegin:(w,E)=>{if(f<=w)throw l;a=void 0,g=f>w,d.push("")},onObjectProperty:(w,E,y)=>{if(f<E||(S(w,E,y,"property"),d[d.length-1]=w,f<=E+y))throw l},onObjectEnd:(w,E)=>{if(f<=w)throw l;a=void 0,d.pop()},onArrayBegin:(w,E)=>{if(f<=w)throw l;a=void 0,d.push(0)},onArrayEnd:(w,E)=>{if(f<=w)throw l;a=void 0,d.pop()},onLiteralValue:(w,E,y)=>{if(f<E||(S(w,E,y,s(w)),f<=E+y))throw l},onSeparator:(w,E,y)=>{if(f<=E)throw l;if(w===":"&&a&&a.type==="property")a.colonOffset=E,g=!1,a=void 0;else if(w===","){const D=d[d.length-1];typeof D=="number"?d[d.length-1]=D+1:(g=!0,d[d.length-1]=""),a=void 0}}})}catch(w){if(w!==l)throw w}return{path:d,previousNode:a,isAtPropertyKey:g,matches:w=>{let E=0;for(let y=0;E<w.length&&y<d.length;y++)if(w[E]===d[y]||w[E]==="*")E++;else if(w[E]!=="**")return!1;return E===w.length}}}function p(t,f=[],d=A.DEFAULT){let l=null,a=[];const h=[];function g(w){Array.isArray(a)?a.push(w):l!==null&&(a[l]=w)}return i(t,{onObjectBegin:()=>{const w={};g(w),h.push(a),a=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const w=[];g(w),h.push(a),a=w,l=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:g,onError:(w,E,y)=>{f.push({error:w,offset:E,length:y})}},d),a[0]}function C(t,f=[],d=A.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){l.type==="property"&&(l.length=w-l.offset,l=l.parent)}function h(w){return l.children.push(w),w}i(t,{onObjectBegin:w=>{l=h({type:"object",offset:w,length:-1,parent:l,children:[]})},onObjectProperty:(w,E,y)=>{l=h({type:"property",offset:E,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:w,offset:E,length:y,parent:l})},onObjectEnd:(w,E)=>{l.length=w+E-l.offset,l=l.parent,a(w+E)},onArrayBegin:(w,E)=>{l=h({type:"array",offset:w,length:-1,parent:l,children:[]})},onArrayEnd:(w,E)=>{l.length=w+E-l.offset,l=l.parent,a(w+E)},onLiteralValue:(w,E,y)=>{h({type:s(w),offset:E,length:y,parent:l,value:w}),a(E+y)},onSeparator:(w,E,y)=>{l.type==="property"&&(w===":"?l.colonOffset=E:w===","&&a(E))},onError:(w,E,y)=>{f.push({error:w,offset:E,length:y})}},d);const S=l.children[0];return S&&delete S.parent,S}function k(t,f){if(!t)return;let d=t;for(const l of f)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let a=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],a=!0;break}if(!a)return}else{const a=l;if(d.type!=="array"||a<0||!Array.isArray(d.children)||a>=d.children.length)return;d=d.children[a]}return d}function c(t){if(!t.parent||!t.parent.children)return[];const f=c(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;f.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&f.push(d)}return f}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(f[d.children[0].value]=m(l))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,d=!1){return f>=t.offset&&f<t.offset+t.length||d&&f===t.offset+t.length}function n(t,f,d=!1){if(o(t,f,d)){const l=t.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=f;a++){const h=n(l[a],f,d);if(h)return h}return t}}function i(t,f,d=A.DEFAULT){const l=M(t,!1);function a(ee){return ee?()=>ee(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(ee){return ee?pe=>ee(pe,l.getTokenOffset(),l.getTokenLength()):()=>!0}const g=a(f.onObjectBegin),S=h(f.onObjectProperty),w=a(f.onObjectEnd),E=a(f.onArrayBegin),y=a(f.onArrayEnd),D=h(f.onLiteralValue),P=h(f.onSeparator),z=a(f.onComment),F=h(f.onError),T=d&&d.disallowComments,j=d&&d.allowTrailingComma;function N(){for(;;){const ee=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:T||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ee){case 12:case 13:T?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return ee}}}function B(ee,pe=[],De=[]){if(F(ee),pe.length+De.length>0){let x=l.getToken();for(;x!==17;){if(pe.indexOf(x)!==-1){N();break}else if(De.indexOf(x)!==-1)break;x=N()}}}function W(ee){const pe=l.getTokenValue();return ee?D(pe):S(pe),N(),!0}function Y(){switch(l.getToken()){case 11:{let ee=0;try{ee=JSON.parse(l.getTokenValue()),typeof ee!="number"&&(B(2),ee=0)}catch{B(2)}D(ee);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return N(),!0}function _(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),l.getToken()===6?(P(":"),N(),re()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function J(){g(),N();let ee=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ee||B(4,[],[]),P(","),N(),l.getToken()===2&&j)break}else ee&&B(6,[],[]);_()||B(4,[],[2,5]),ee=!0}return w(),l.getToken()!==2?B(7,[2],[]):N(),!0}function Z(){E(),N();let ee=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ee||B(4,[],[]),P(","),N(),l.getToken()===4&&j)break}else ee&&B(6,[],[]);re()||B(4,[],[4,5]),ee=!0}return y(),l.getToken()!==4?B(8,[4],[]):N(),!0}function re(){switch(l.getToken()){case 3:return Z();case 1:return J();case 10:return W(!0);default:return Y()}}return N(),l.getToken()===17?d.allowEmptyContent?!0:(B(4,[],[]),!1):re()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,f){const d=M(t),l=[];let a,h=0,g;do switch(g=d.getPosition(),a=d.scan(),a){case 12:case 13:case 17:h!==g&&l.push(t.substring(h,g)),f!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,f)),h=d.getPosition();break}while(a!==17);return l.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[45],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(O){this.d=O,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(O){this.c=O}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[75],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(A){this.element=A,this.next=u.Undefined,this.prev=u.Undefined}}class L{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let A=this.a;for(;A!==u.Undefined;){const M=A.next;A.prev=u.Undefined,A.next=u.Undefined,A=M}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,M){const b=new u(A);if(this.a===u.Undefined)this.a=b,this.b=b;else if(M){const v=this.b;this.b=b,b.prev=v,v.next=b}else{const v=this.a;this.a=b,b.next=v,v.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==u.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==u.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==u.Undefined&&A.next!==u.Undefined){const M=A.prev;M.next=A.next,A.next.prev=M}else A.prev===u.Undefined&&A.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):A.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):A.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==u.Undefined;)yield A.element,A=A.next}}e.$5c=L}),define(ke[27],Ee([1,0]),function(he,e){"use strict";var u,L,O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=A,e.$zc=M,e.$Ac=b,e.$Ic=n;function A(i,r,s){let t=i.get(r);return t===void 0&&(t=s,i.set(r,t)),t}function M(i){const r=[];return i.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}function b(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}class ${constructor(r,s){this.uri=r,this.value=s}}function v(i){return Array.isArray(i)}class R{static{this.c=r=>r.toString()}constructor(r,s){if(this[u]="ResourceMap",r instanceof R)this.d=new Map(r.d),this.e=s??R.c;else if(v(r)){this.d=new Map,this.e=s??R.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??R.c}set(r,s){return this.d.set(this.e(r),new $(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=R;class I{constructor(r,s){this[L]="ResourceSet",!r||typeof r=="function"?this.c=new R(r):(this.c=new R(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,f)=>r.call(s,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=I;var p;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class C{constructor(){this[O]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let f=this.c.get(r);if(f)f.value=s,t!==0&&this.l(f,t);else{switch(f={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let f=this.d;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=C;class k extends C{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=k;class c{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=c;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,f)=>{r.call(s,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class o{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=o;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[s,t]of i)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!i.has(s))return!1;return!0}}),define(ke[3],Ee([1,0,19,73,27,74,38]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=R,e.$Lc=I,e.$Mc=p,e.$Nc=c,e.$Oc=m,e.$Pc=o,e.$Qc=n,e.$Rc=i,e.$Sc=r,e.$3c=w;const b=!1;let $=null;class v{constructor(){this.b=new Map}static{this.a=0}c(D){let P=this.b.get(D);return P||(P={parent:null,source:null,isSingleton:!1,value:D,idx:v.a++},this.b.set(D,P)),P}trackDisposable(D){const P=this.c(D);P.source||(P.source=new Error().stack)}setParent(D,P){const z=this.c(D);z.parent=P}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,P){const z=P.get(D);if(z)return z;const F=D.parent?this.f(this.c(D.parent),P):D;return P.set(D,F),F}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,D).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(D=10,P){let z;if(P)z=P;else{const B=new Map,W=[...this.b.values()].filter(_=>_.source!==null&&!this.f(_,B).isSingleton);if(W.length===0)return;const Y=new Set(W.map(_=>_.value));if(z=W.filter(_=>!(_.parent&&Y.has(_.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function F(B){function W(_,J){for(;_.length>0&&J.some(Z=>typeof Z=="string"?Z===_[0]:_[0].match(Z));)_.shift()}const Y=B.source.split(`
`).map(_=>_.trim().replace("at ","")).filter(_=>_!=="");return W(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const T=new O.$Hc;for(const B of z){const W=F(B);for(let Y=0;Y<=W.length;Y++)T.add(W.slice(0,Y).join(`
`),B)}z.sort((0,u.$7b)(B=>B.idx,u.$9b));let j="",N=0;for(const B of z.slice(0,D)){N++;const W=F(B),Y=[];for(let _=0;_<W.length;_++){let J=W[_];J=`(shared with ${T.get(W.slice(0,_+1).join(`
`)).size}/${z.length} leaks) at ${J}`;const re=T.get(W.slice(0,_).join(`
`)),ee=(0,L.$K)([...re].map(pe=>F(pe)[_]),pe=>pe);delete ee[W[_]];for(const[pe,De]of Object.entries(ee))Y.unshift(`    - stacktraces of ${De.length} other leaks continue with ${pe}`);Y.unshift(J)}j+=`


==================== Leaking disposable ${N}/${z.length}: ${B.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return z.length>D&&(j+=`


... and ${z.length-D} more leaking disposables

`),{leaks:z,details:j}}}e.$Jc=v;function R(y){$=y}if(b){const y="__is_disposable_tracked__";R(new class{trackDisposable(D){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[y]||console.log(P)},3e3)}setParent(D,P){if(D&&D!==t.None)try{D[y]=!0}catch{}}markAsDisposed(D){if(D&&D!==t.None)try{D[y]=!0}catch{}}markAsSingleton(D){}})}function I(y){return $?.trackDisposable(y),y}function p(y){$?.markAsDisposed(y)}function C(y,D){$?.setParent(y,D)}function k(y,D){if($)for(const P of y)$.setParent(P,D)}function c(y){return $?.markAsSingleton(y),y}function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}function o(y){if(M.Iterable.is(y)){const D=[];for(const P of y)if(P)try{P.dispose()}catch(z){D.push(z)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const D of y)m(D)&&D.dispose();return[]}function i(...y){const D=r(()=>o(y));return k(y,D),D}function r(y){const D=I({dispose:(0,A.$db)(()=>{p(D),y()})});return D}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return C(D,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),C(D,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,I(this),C(this.q,this)}dispose(){p(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}e.$Uc=t;class f{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&C(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&C(D,null),D}}e.$Vc=f;class d{constructor(D){this.a=new f,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(D){let P=D;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,p(this))},this}}e.$Yc=a;class h{constructor(){this.a=new Map}acquire(D,...P){let z=this.a.get(D);z||(z={counter:0,object:this.b(D,...P)},this.a.set(D,z));const{object:F}=z,T=(0,A.$db)(()=>{--z.counter===0&&(this.c(D,z.object),this.a.delete(D))});return z.counter++,{object:F,dispose:T}}}e.$Zc=h;class g{constructor(D){this.a=D}async acquire(D,...P){const z=this.a.acquire(D,...P);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(F){throw z.dispose(),F}}}e.$1c=g;class S{constructor(D){this.object=D}dispose(){}}e.$2c=S;function w(y){const D=new s;try{y(D)}finally{D.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,P,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(D)?.dispose(),this.a.set(D,P)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=E}),function(he,e){typeof define=="function"&&define.amd?define(ke[164],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ae,ce){for(var se=0;se<ce.length;se++){var K=ce[se];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ae,K.key,K)}}function u(ae,ce,se){return ce&&e(ae.prototype,ce),se&&e(ae,se),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function L(ae,ce){if(ae){if(typeof ae=="string")return O(ae,ce);var se=Object.prototype.toString.call(ae).slice(8,-1);if(se==="Object"&&ae.constructor&&(se=ae.constructor.name),se==="Map"||se==="Set")return Array.from(ae);if(se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(se))return O(ae,ce)}}function O(ae,ce){(ce==null||ce>ae.length)&&(ce=ae.length);for(var se=0,K=new Array(ce);se<ce;se++)K[se]=ae[se];return K}function A(ae,ce){var se=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(se)return(se=se.call(ae)).next.bind(se);if(Array.isArray(ae)||(se=L(ae))||ce&&ae&&typeof ae.length=="number"){se&&(ae=se);var K=0;return function(){return K>=ae.length?{done:!0}:{done:!1,value:ae[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=M();function b(ae){he.defaults=ae}var $=/[&<>"']/,v=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ce){return p[ce]};function k(ae,ce){if(ce){if($.test(ae))return ae.replace(v,C)}else if(R.test(ae))return ae.replace(I,C);return ae}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ae){return ae.replace(c,function(ce,se){return se=se.toLowerCase(),se==="colon"?":":se.charAt(0)==="#"?se.charAt(1)==="x"?String.fromCharCode(parseInt(se.substring(2),16)):String.fromCharCode(+se.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(ae,ce){ae=typeof ae=="string"?ae:ae.source,ce=ce||"";var se={replace:function(te,le){return le=le.source||le,le=le.replace(o,"$1"),ae=ae.replace(te,le),se},getRegex:function(){return new RegExp(ae,ce)}};return se}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ae,ce,se){if(ae){var K;try{K=decodeURIComponent(m(se)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ce&&!r.test(se)&&(se=a(ce,se));try{se=encodeURI(se).replace(/%25/g,"%")}catch{return null}return se}var t={},f=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ae,ce){t[" "+ae]||(f.test(ae)?t[" "+ae]=ae+"/":t[" "+ae]=w(ae,"/",!0)),ae=t[" "+ae];var se=ae.indexOf(":")===-1;return ce.substring(0,2)==="//"?se?ce:ae.replace(d,"$1")+ce:ce.charAt(0)==="/"?se?ce:ae.replace(l,"$1")+ce:ae+ce}var h={exec:function(){}};function g(ae){for(var ce=1,se,K;ce<arguments.length;ce++){se=arguments[ce];for(K in se)Object.prototype.hasOwnProperty.call(se,K)&&(ae[K]=se[K])}return ae}function S(ae,ce){var se=ae.replace(/\|/g,function(le,de,Ae){for(var me=!1,Ie=de;--Ie>=0&&Ae[Ie]==="\\";)me=!me;return me?"|":" |"}),K=se.split(/ \|/),te=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ce)K.splice(ce);else for(;K.length<ce;)K.push("");for(;te<K.length;te++)K[te]=K[te].trim().replace(/\\\|/g,"|");return K}function w(ae,ce,se){var K=ae.length;if(K===0)return"";for(var te=0;te<K;){var le=ae.charAt(K-te-1);if(le===ce&&!se)te++;else if(le!==ce&&se)te++;else break}return ae.slice(0,K-te)}function E(ae,ce){if(ae.indexOf(ce[1])===-1)return-1;for(var se=ae.length,K=0,te=0;te<se;te++)if(ae[te]==="\\")te++;else if(ae[te]===ce[0])K++;else if(ae[te]===ce[1]&&(K--,K<0))return te;return-1}function y(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(ae,ce){if(ce<1)return"";for(var se="";ce>1;)ce&1&&(se+=ae),ce>>=1,ae+=ae;return se+ae}function P(ae,ce,se,K){var te=ce.href,le=ce.title?k(ce.title):null,de=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){K.state.inLink=!0;var Ae={type:"link",raw:se,href:te,title:le,text:de,tokens:K.inlineTokens(de)};return K.state.inLink=!1,Ae}return{type:"image",raw:se,href:te,title:le,text:k(de)}}function z(ae,ce){var se=ae.match(/^(\s+)(?:```)/);if(se===null)return ce;var K=se[1];return ce.split(`
`).map(function(te){var le=te.match(/^\s+/);if(le===null)return te;var de=le[0];return de.length>=K.length?te.slice(K.length):te}).join(`
`)}var F=function(){function ae(se){this.options=se||he.defaults}var ce=ae.prototype;return ce.space=function(K){var te=this.rules.block.newline.exec(K);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ce.code=function(K){var te=this.rules.block.code.exec(K);if(te){var le=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?le:w(le,`
`)}}},ce.fences=function(K){var te=this.rules.block.fences.exec(K);if(te){var le=te[0],de=z(le,te[3]||"");return{type:"code",raw:le,lang:te[2]?te[2].trim():te[2],text:de}}},ce.heading=function(K){var te=this.rules.block.heading.exec(K);if(te){var le=te[2].trim();if(/#$/.test(le)){var de=w(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:le,tokens:this.lexer.inline(le)}}},ce.hr=function(K){var te=this.rules.block.hr.exec(K);if(te)return{type:"hr",raw:te[0]}},ce.blockquote=function(K){var te=this.rules.block.blockquote.exec(K);if(te){var le=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},ce.list=function(K){var te=this.rules.block.list.exec(K);if(te){var le,de,Ae,me,Ie,Re,Fe,q,V,X,Q,fe,we=te[1].trim(),Te=we.length>1,He={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var xe=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(fe=!1,!(!(te=xe.exec(K))||this.rules.block.hr.test(K)));){if(le=te[0],K=K.substring(le.length),q=te[2].split(`
`,1)[0],V=K.split(`
`,1)[0],this.options.pedantic?(me=2,Q=q.trimLeft()):(me=te[2].search(/[^ ]/),me=me>4?1:me,Q=q.slice(me),me+=te[1].length),Re=!1,!q&&/^ *$/.test(V)&&(le+=V+`
`,K=K.substring(V.length+1),fe=!0),!fe)for(var it=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,me-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,me-1)+"}#");K&&(X=K.split(`
`,1)[0],q=X,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(q)||ot.test(q)||it.test(q)||rt.test(K)));){if(q.search(/[^ ]/)>=me||!q.trim())Q+=`
`+q.slice(me);else if(!Re)Q+=`
`+q;else break;!Re&&!q.trim()&&(Re=!0),le+=X+`
`,K=K.substring(X.length+1)}He.loose||(Fe?He.loose=!0:/\n *\n *$/.test(le)&&(Fe=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Q),de&&(Ae=de[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:le,task:!!de,checked:Ae,loose:!1,text:Q}),He.raw+=le}He.items[He.items.length-1].raw=le.trimRight(),He.items[He.items.length-1].text=Q.trimRight(),He.raw=He.raw.trimRight();var Se=He.items.length;for(Ie=0;Ie<Se;Ie++){this.lexer.state.top=!1,He.items[Ie].tokens=this.lexer.blockTokens(He.items[Ie].text,[]);var Be=He.items[Ie].tokens.filter(function(Me){return Me.type==="space"}),Ge=Be.every(function(Me){for(var Qe=Me.raw.split(""),oe=0,ue=A(Qe),Pe;!(Pe=ue()).done;){var Ke=Pe.value;if(Ke===`
`&&(oe+=1),oe>1)return!0}return!1});!He.loose&&Be.length&&Ge&&(He.loose=!0,He.items[Ie].loose=!0)}return He}},ce.html=function(K){var te=this.rules.block.html.exec(K);if(te){var le={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},ce.def=function(K){var te=this.rules.block.def.exec(K);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var le=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:te[0],href:te[2],title:te[3]}}},ce.table=function(K){var te=this.rules.block.table.exec(K);if(te){var le={type:"table",header:S(te[1]).map(function(Fe){return{text:Fe}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=te[0];var de=le.align.length,Ae,me,Ie,Re;for(Ae=0;Ae<de;Ae++)/^ *-+: *$/.test(le.align[Ae])?le.align[Ae]="right":/^ *:-+: *$/.test(le.align[Ae])?le.align[Ae]="center":/^ *:-+ *$/.test(le.align[Ae])?le.align[Ae]="left":le.align[Ae]=null;for(de=le.rows.length,Ae=0;Ae<de;Ae++)le.rows[Ae]=S(le.rows[Ae],le.header.length).map(function(Fe){return{text:Fe}});for(de=le.header.length,me=0;me<de;me++)le.header[me].tokens=this.lexer.inline(le.header[me].text);for(de=le.rows.length,me=0;me<de;me++)for(Re=le.rows[me],Ie=0;Ie<Re.length;Ie++)Re[Ie].tokens=this.lexer.inline(Re[Ie].text);return le}}},ce.lheading=function(K){var te=this.rules.block.lheading.exec(K);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ce.paragraph=function(K){var te=this.rules.block.paragraph.exec(K);if(te){var le=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:le,tokens:this.lexer.inline(le)}}},ce.text=function(K){var te=this.rules.block.text.exec(K);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ce.escape=function(K){var te=this.rules.inline.escape.exec(K);if(te)return{type:"escape",raw:te[0],text:k(te[1])}},ce.tag=function(K){var te=this.rules.inline.tag.exec(K);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]):te[0]}},ce.link=function(K){var te=this.rules.inline.link.exec(K);if(te){var le=te[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=w(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Ae=E(te[2],"()");if(Ae>-1){var me=te[0].indexOf("!")===0?5:4,Ie=me+te[1].length+Ae;te[2]=te[2].substring(0,Ae),te[0]=te[0].substring(0,Ie).trim(),te[3]=""}}var Re=te[2],Fe="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);q&&(Re=q[1],Fe=q[3])}else Fe=te[3]?te[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(le)?Re=Re.slice(1):Re=Re.slice(1,-1)),P(te,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ce.reflink=function(K,te){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=te[de.toLowerCase()],!de||!de.href){var Ae=le[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return P(le,de,le[0],this.lexer)}},ce.emStrong=function(K,te,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(K);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=de[1]||de[2]||"";if(!Ae||Ae&&(le===""||this.rules.inline.punctuation.exec(le))){var me=de[0].length-1,Ie,Re,Fe=me,q=0,V=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,te=te.slice(-1*K.length+me);(de=V.exec(te))!=null;)if(Ie=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ie){if(Re=Ie.length,de[3]||de[4]){Fe+=Re;continue}else if((de[5]||de[6])&&me%3&&!((me+Re)%3)){q+=Re;continue}if(Fe-=Re,!(Fe>0)){if(Re=Math.min(Re,Re+Fe+q),Math.min(me,Re)%2){var X=K.slice(1,me+de.index+Re);return{type:"em",raw:K.slice(0,me+de.index+Re+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Q=K.slice(2,me+de.index+Re-1);return{type:"strong",raw:K.slice(0,me+de.index+Re+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},ce.codespan=function(K){var te=this.rules.inline.code.exec(K);if(te){var le=te[2].replace(/\n/g," "),de=/[^ ]/.test(le),Ae=/^ /.test(le)&&/ $/.test(le);return de&&Ae&&(le=le.substring(1,le.length-1)),le=k(le,!0),{type:"codespan",raw:te[0],text:le}}},ce.br=function(K){var te=this.rules.inline.br.exec(K);if(te)return{type:"br",raw:te[0]}},ce.del=function(K){var te=this.rules.inline.del.exec(K);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ce.autolink=function(K,te){var le=this.rules.inline.autolink.exec(K);if(le){var de,Ae;return le[2]==="@"?(de=k(this.options.mangle?te(le[1]):le[1]),Ae="mailto:"+de):(de=k(le[1]),Ae=de),{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},ce.url=function(K,te){var le;if(le=this.rules.inline.url.exec(K)){var de,Ae;if(le[2]==="@")de=k(this.options.mangle?te(le[0]):le[0]),Ae="mailto:"+de;else{var me;do me=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(me!==le[0]);de=k(le[0]),le[1]==="www."?Ae="http://"+de:Ae=de}return{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},ce.inlineText=function(K,te){var le=this.rules.inline.text.exec(K);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):k(le[0]):le[0]:de=k(this.options.smartypants?te(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},ae}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=n(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=n(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=n(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=n(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=n(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=n(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=g({},T),T.gfm=g({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=n(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=n(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=g({},T.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:n(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=n(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=n(T._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=n(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=n(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=n(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=n(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=n(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=n(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=n(j.reflink).replace("label",j._label).replace("ref",T._label).getRegex(),j.nolink=n(j.nolink).replace("ref",T._label).getRegex(),j.reflinkSearch=n(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=g({},j),j.pedantic=g({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=g({},j.normal,{escape:n(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=n(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=g({},j.gfm,{br:n(j.br).replace("{2,}","*").getRegex(),text:n(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ae){var ce="",se,K,te=ae.length;for(se=0;se<te;se++)K=ae.charCodeAt(se),Math.random()>.5&&(K="x"+K.toString(16)),ce+="&#"+K+";";return ce}var W=function(){function ae(se){this.tokens=[],this.tokens.links=Object.create(null),this.options=se||he.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:T.normal,inline:j.normal};this.options.pedantic?(K.block=T.pedantic,K.inline=j.pedantic):this.options.gfm&&(K.block=T.gfm,this.options.breaks?K.inline=j.breaks:K.inline=j.gfm),this.tokenizer.rules=K}ae.lex=function(K,te){var le=new ae(te);return le.lex(K)},ae.lexInline=function(K,te){var le=new ae(te);return le.inlineTokens(K)};var ce=ae.prototype;return ce.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ce.blockTokens=function(K,te){var le=this;te===void 0&&(te=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Fe,q,V){return q+"    ".repeat(V.length)});for(var de,Ae,me,Ie;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(de=Fe.call({lexer:le},K,te))?(K=K.substring(de.raw.length),te.push(de),!0):!1}))){if(de=this.tokenizer.space(K)){K=K.substring(de.raw.length),de.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(de);continue}if(de=this.tokenizer.code(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de);continue}if(de=this.tokenizer.fences(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.heading(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.hr(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.blockquote(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.list(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.html(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.def(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.lheading(K)){K=K.substring(de.raw.length),te.push(de);continue}if(me=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,q=K.slice(1),V=void 0;le.options.extensions.startBlock.forEach(function(X){V=X.call({lexer:this},q),typeof V=="number"&&V>=0&&(Fe=Math.min(Fe,V))}),Fe<1/0&&Fe>=0&&(me=K.substring(0,Fe+1))}(),this.state.top&&(de=this.tokenizer.paragraph(me))){Ae=te[te.length-1],Ie&&Ae.type==="paragraph"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de),Ie=me.length!==K.length,K=K.substring(de.raw.length);continue}if(de=this.tokenizer.text(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de);continue}if(K){var Re="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,te},ce.inline=function(K,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:K,tokens:te}),te},ce.inlineTokens=function(K,te){var le=this;te===void 0&&(te=[]);var de,Ae,me,Ie=K,Re,Fe,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)V.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Re.index)+"["+D("a",Re[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Re.index)+"["+D("a",Re[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Re.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Fe||(q=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(de=Q.call({lexer:le},K,te))?(K=K.substring(de.raw.length),te.push(de),!0):!1}))){if(de=this.tokenizer.escape(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.tag(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(de=this.tokenizer.link(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(de=this.tokenizer.emStrong(K,Ie,q)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.codespan(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.br(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.del(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.autolink(K,B)){K=K.substring(de.raw.length),te.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(K,B))){K=K.substring(de.raw.length),te.push(de);continue}if(me=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,fe=K.slice(1),we=void 0;le.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},fe),typeof we=="number"&&we>=0&&(Q=Math.min(Q,we))}),Q<1/0&&Q>=0&&(me=K.substring(0,Q+1))}(),de=this.tokenizer.inlineText(me,N)){K=K.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(q=de.raw.slice(-1)),Fe=!0,Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(K){var X="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return te},u(ae,null,[{key:"rules",get:function(){return{block:T,inline:j}}}]),ae}(),Y=function(){function ae(se){this.options=se||he.defaults}var ce=ae.prototype;return ce.code=function(K,te,le){var de=(te||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(K,de);Ae!=null&&Ae!==K&&(le=!0,K=Ae)}return K=K.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+k(de,!0)+'">'+(le?K:k(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:k(K,!0))+`</code></pre>
`},ce.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ce.html=function(K){return K},ce.heading=function(K,te,le,de){if(this.options.headerIds){var Ae=this.options.headerPrefix+de.slug(le);return"<h"+te+' id="'+Ae+'">'+K+"</h"+te+`>
`}return"<h"+te+">"+K+"</h"+te+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(K,te,le){var de=te?"ol":"ul",Ae=te&&le!==1?' start="'+le+'"':"";return"<"+de+Ae+`>
`+K+"</"+de+`>
`},ce.listitem=function(K){return"<li>"+K+`</li>
`},ce.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(K){return"<p>"+K+`</p>
`},ce.table=function(K,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+te+`</table>
`},ce.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ce.tablecell=function(K,te){var le=te.header?"th":"td",de=te.align?"<"+le+' align="'+te.align+'">':"<"+le+">";return de+K+("</"+le+`>
`)},ce.strong=function(K){return"<strong>"+K+"</strong>"},ce.em=function(K){return"<em>"+K+"</em>"},ce.codespan=function(K){return"<code>"+K+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(K){return"<del>"+K+"</del>"},ce.link=function(K,te,le){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<a href="'+k(K)+'"';return te&&(de+=' title="'+te+'"'),de+=">"+le+"</a>",de},ce.image=function(K,te,le){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<img src="'+K+'" alt="'+le+'"';return te&&(de+=' title="'+te+'"'),de+=this.options.xhtml?"/>":">",de},ce.text=function(K){return K},ae}(),_=function(){function ae(){}var ce=ae.prototype;return ce.strong=function(K){return K},ce.em=function(K){return K},ce.codespan=function(K){return K},ce.del=function(K){return K},ce.html=function(K){return K},ce.text=function(K){return K},ce.link=function(K,te,le){return""+le},ce.image=function(K,te,le){return""+le},ce.br=function(){return""},ae}(),J=function(){function ae(){this.seen={}}var ce=ae.prototype;return ce.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(K,te){var le=K,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[K];do de++,le=K+"-"+de;while(this.seen.hasOwnProperty(le))}return te||(this.seen[K]=de,this.seen[le]=0),le},ce.slug=function(K,te){te===void 0&&(te={});var le=this.serialize(K);return this.getNextSafeSlug(le,te.dryrun)},ae}(),Z=function(){function ae(se){this.options=se||he.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new J}ae.parse=function(K,te){var le=new ae(te);return le.parse(K)},ae.parseInline=function(K,te){var le=new ae(te);return le.parseInline(K)};var ce=ae.prototype;return ce.parse=function(K,te){te===void 0&&(te=!0);var le="",de,Ae,me,Ie,Re,Fe,q,V,X,Q,fe,we,Te,He,xe,it,rt,at,ot,Se=K.length;for(de=0;de<Se;de++){if(Q=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(ot=this.options.extensions.renderers[Q.type].call({parser:this},Q),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){le+=ot||"";continue}switch(Q.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,m(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(V="",q="",Ie=Q.header.length,Ae=0;Ae<Ie;Ae++)q+=this.renderer.tablecell(this.parseInline(Q.header[Ae].tokens),{header:!0,align:Q.align[Ae]});for(V+=this.renderer.tablerow(q),X="",Ie=Q.rows.length,Ae=0;Ae<Ie;Ae++){for(Fe=Q.rows[Ae],q="",Re=Fe.length,me=0;me<Re;me++)q+=this.renderer.tablecell(this.parseInline(Fe[me].tokens),{header:!1,align:Q.align[me]});X+=this.renderer.tablerow(q)}le+=this.renderer.table(V,X);continue}case"blockquote":{X=this.parse(Q.tokens),le+=this.renderer.blockquote(X);continue}case"list":{for(fe=Q.ordered,we=Q.start,Te=Q.loose,Ie=Q.items.length,X="",Ae=0;Ae<Ie;Ae++)xe=Q.items[Ae],it=xe.checked,rt=xe.task,He="",xe.task&&(at=this.renderer.checkbox(it),Te?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=at+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=at+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:at}):He+=at),He+=this.parse(xe.tokens,Te),X+=this.renderer.listitem(He,rt,it);le+=this.renderer.list(X,fe,we);continue}case"html":{le+=this.renderer.html(Q.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(X=Q.tokens?this.parseInline(Q.tokens):Q.text;de+1<Se&&K[de+1].type==="text";)Q=K[++de],X+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);le+=te?this.renderer.paragraph(X):X;continue}default:{var Be='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return le},ce.parseInline=function(K,te){te=te||this.renderer;var le="",de,Ae,me,Ie=K.length;for(de=0;de<Ie;de++){if(Ae=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(me=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),me!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){le+=me||"";continue}switch(Ae.type){case"escape":{le+=te.text(Ae.text);break}case"html":{le+=te.html(Ae.text);break}case"link":{le+=te.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,te));break}case"image":{le+=te.image(Ae.href,Ae.title,Ae.text);break}case"strong":{le+=te.strong(this.parseInline(Ae.tokens,te));break}case"em":{le+=te.em(this.parseInline(Ae.tokens,te));break}case"codespan":{le+=te.codespan(Ae.text);break}case"br":{le+=te.br();break}case"del":{le+=te.del(this.parseInline(Ae.tokens,te));break}case"text":{le+=te.text(Ae.text);break}default:{var Re='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return le},ae}();function re(ae,ce,se){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof ce=="function"&&(se=ce,ce=null),ce=g({},re.defaults,ce||{}),y(ce),se){var K=ce.highlight,te;try{te=W.lex(ae,ce)}catch(Ie){return se(Ie)}var le=function(Re){var Fe;if(!Re)try{ce.walkTokens&&re.walkTokens(te,ce.walkTokens),Fe=Z.parse(te,ce)}catch(q){Re=q}return ce.highlight=K,Re?se(Re):se(null,Fe)};if(!K||K.length<3||(delete ce.highlight,!te.length))return le();var de=0;re.walkTokens(te,function(Ie){Ie.type==="code"&&(de++,setTimeout(function(){K(Ie.text,Ie.lang,function(Re,Fe){if(Re)return le(Re);Fe!=null&&Fe!==Ie.text&&(Ie.text=Fe,Ie.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Ae(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+k(Ie.message+"",!0)+"</pre>";throw Ie}try{var me=W.lex(ae,ce);if(ce.walkTokens){if(ce.async)return Promise.all(re.walkTokens(me,ce.walkTokens)).then(function(){return Z.parse(me,ce)}).catch(Ae);re.walkTokens(me,ce.walkTokens)}return Z.parse(me,ce)}catch(Ie){Ae(Ie)}}re.options=re.setOptions=function(ae){return g(re.defaults,ae),b(re.defaults),re},re.getDefaults=M,re.defaults=he.defaults,re.use=function(){for(var ae=arguments.length,ce=new Array(ae),se=0;se<ae;se++)ce[se]=arguments[se];var K=g.apply(void 0,[{}].concat(ce)),te=re.defaults.extensions||{renderers:{},childTokens:{}},le;ce.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(me){if(!me.name)throw new Error("extension name required");if(me.renderer){var Ie=te.renderers?te.renderers[me.name]:null;Ie?te.renderers[me.name]=function(){for(var Re=arguments.length,Fe=new Array(Re),q=0;q<Re;q++)Fe[q]=arguments[q];var V=me.renderer.apply(this,Fe);return V===!1&&(V=Ie.apply(this,Fe)),V}:te.renderers[me.name]=me.renderer}if(me.tokenizer){if(!me.level||me.level!=="block"&&me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[me.level]?te[me.level].unshift(me.tokenizer):te[me.level]=[me.tokenizer],me.start&&(me.level==="block"?te.startBlock?te.startBlock.push(me.start):te.startBlock=[me.start]:me.level==="inline"&&(te.startInline?te.startInline.push(me.start):te.startInline=[me.start]))}me.childTokens&&(te.childTokens[me.name]=me.childTokens)})),de.renderer&&function(){var me=re.defaults.renderer||new Y,Ie=function(q){var V=me[q];me[q]=function(){for(var X=arguments.length,Q=new Array(X),fe=0;fe<X;fe++)Q[fe]=arguments[fe];var we=de.renderer[q].apply(me,Q);return we===!1&&(we=V.apply(me,Q)),we}};for(var Re in de.renderer)Ie(Re);K.renderer=me}(),de.tokenizer&&function(){var me=re.defaults.tokenizer||new F,Ie=function(q){var V=me[q];me[q]=function(){for(var X=arguments.length,Q=new Array(X),fe=0;fe<X;fe++)Q[fe]=arguments[fe];var we=de.tokenizer[q].apply(me,Q);return we===!1&&(we=V.apply(me,Q)),we}};for(var Re in de.tokenizer)Ie(Re);K.tokenizer=me}(),de.walkTokens){var Ae=re.defaults.walkTokens;K.walkTokens=function(me){var Ie=[];return Ie.push(de.walkTokens.call(this,me)),Ae&&(Ie=Ie.concat(Ae.call(this,me))),Ie}}le&&(K.extensions=te),re.setOptions(K)})},re.walkTokens=function(ae,ce){for(var se=[],K=function(){var Ae=le.value;switch(se=se.concat(ce.call(re,Ae)),Ae.type){case"table":{for(var me=A(Ae.header),Ie;!(Ie=me()).done;){var Re=Ie.value;se=se.concat(re.walkTokens(Re.tokens,ce))}for(var Fe=A(Ae.rows),q;!(q=Fe()).done;)for(var V=q.value,X=A(V),Q;!(Q=X()).done;){var fe=Q.value;se=se.concat(re.walkTokens(fe.tokens,ce))}break}case"list":{se=se.concat(re.walkTokens(Ae.items,ce));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[Ae.type]?re.defaults.extensions.childTokens[Ae.type].forEach(function(we){se=se.concat(re.walkTokens(Ae[we],ce))}):Ae.tokens&&(se=se.concat(re.walkTokens(Ae.tokens,ce)))}},te=A(ae),le;!(le=te()).done;)K();return se},re.parseInline=function(ae,ce){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");ce=g({},re.defaults,ce||{}),y(ce);try{var se=W.lexInline(ae,ce);return ce.walkTokens&&re.walkTokens(se,ce.walkTokens),Z.parseInline(se,ce)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+k(K.message+"",!0)+"</pre>";throw K}},re.Parser=Z,re.parser=Z.parse,re.Renderer=Y,re.TextRenderer=_,re.Lexer=W,re.lexer=W.lex,re.Tokenizer=F,re.Slugger=J,re.parse=re;var ee=re.options,pe=re.setOptions,De=re.use,x=re.walkTokens,U=re.parseInline,ie=re,be=Z.parse,Ce=W.lex;he.Lexer=W,he.Parser=Z,he.Renderer=Y,he.Slugger=J,he.TextRenderer=_,he.Tokenizer=F,he.getDefaults=M,he.lexer=Ce,he.marked=re,he.options=ee,he.parse=ie,he.parseInline=U,he.parser=be,he.setOptions=pe,he.use=De,he.walkTokens=x,Object.defineProperty(he,"__esModule",{value:!0})}),define(ke[165],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=u;function u(c){const m=A(c);if(m&&m.length>0)return new Uint32Array(m)}let L=0;const O=new Uint32Array(10);function A(c){if(L=0,M(c,I,4352),L>0||(M(c,p,4449),L>0)||(M(c,C,4520),L>0)||(M(c,k,12593),L))return O.subarray(0,L);if(c>=44032&&c<=55203){const m=c-44032,o=m%588,n=Math.floor(m/588),i=Math.floor(o/28),r=o%28-1;if(n<I.length?M(n,I,0):4352+n-12593<k.length&&M(4352+n,k,12593),i<p.length?M(i,p,0):4449+i-12593<k.length&&M(4449+i-12593,k,12593),r>=0&&(r<C.length?M(r,C,0):4520+r-12593<k.length&&M(4520+r-12593,k,12593)),L>0)return O.subarray(0,L)}}function M(c,m,o){c>=o&&c<o+m.length&&b(m[c-o])}function b(c){c!==0&&(O[L++]=c&255,c>>8&&(O[L++]=c>>8&255),c>>16&&(O[L++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var v;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(v||(v={}));var R;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(R||(R={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),C=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),k=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Ee([1,0,27]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=void 0,e.$Zl=O,e.$1l=M;const L=new u.$Ec(1e4);function O(v){return $(v,"NFC",L)}const A=new u.$Ec(1e4);function M(v){return $(v,"NFD",A)}const b=/[^\u0000-\u0080]/;function $(v,R,I){if(!v)return v;const p=I.get(v);if(p)return p;let C;return b.test(v)?C=v.normalize(R):C=v,I.set(v,C),C}e.$2l=function(){const v=/[\u0300-\u036f]/g;return function(R){return M(R).replace(v,"")}}()}),define(ke[125],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=u,e.rot=L;function u(b,$,v){return Math.min(Math.max(b,$),v)}function L(b,$){return($+b%$)%$}class O{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=O;class A{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=A;class M{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const v=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=M}),function(){function he(O){const A=[];typeof O=="number"&&A.push("code/timeOrigin",O);function M($){A.push($,Date.now())}function b(){const $=[];for(let v=0;v<A.length;v+=2)$.push({name:A[v],startTime:A[v+1]});return $}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const M of performance.getEntriesByType("mark"))A.push({name:M.name,startTime:Math.round(O+M.startTime)});return A}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function u(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=u(L))}(),define(ke[166],Ee([1,0,38]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;const L=Symbol("unset");class O{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert($,v,R){this.d($,I=>I._value=v,R)}mutate($,v){this.d($,R=>R._value=v(R._value===L?void 0:R._value))}delete($){const v=this.c($);if(!v)return;let R=v.length-1;const I=v[R].node._value;if(I!==L){for(this.b--,v[R].node._value=L;R>0;R--){const{node:p,part:C}=v[R];if(p.children?.size||p._value!==L)break;v[R-1].node.children.delete(C)}return I}}*deleteRecursive($){const v=this.c($);if(!v)return;const R=v[v.length-1].node;for(let I=v.length-1;I>0;I--){const p=v[I-1];if(p.node.children.delete(v[I].part),p.node.children.size>0||p.node._value!==L)break}for(const I of A(R))I._value!==L&&(this.b--,yield I._value)}find($){let v=this.a;for(const R of $){const I=v.children?.get(R);if(!I)return;v=I}return v._value===L?void 0:v._value}hasKeyOrParent($){let v=this.a;for(const R of $){const I=v.children?.get(R);if(!I)return!1;if(I._value!==L)return!0;v=I}return!1}hasKeyOrChildren($){let v=this.a;for(const R of $){const I=v.children?.get(R);if(!I)return!1;v=I}return!0}hasKey($){let v=this.a;for(const R of $){const I=v.children?.get(R);if(!I)return!1;v=I}return v._value!==L}c($){const v=[{part:"",node:this.a}];let R=0;for(const I of $){const p=v[R].node.children?.get(I);if(!p)return;v.push({part:I,node:p}),R++}return v}d($,v,R){let I=this.a;for(const k of $){if(I.children)if(I.children.has(k))I=I.children.get(k);else{const c=new M;I.children.set(k,c),I=c}else{const c=new M;I.children=new Map([[k,c]]),I=c}R?.(I)}const p=I._value===L?0:1;v(I);const C=I._value===L?0:1;this.b+=C-p}*values(){for(const{_value:$}of A(this.a))$!==L&&(yield $)}}e.$BO=O;function*A(b){const $=[b];for(;$.length>0;){const v=$.pop();if(yield v,v.children)for(const R of v.children.values())$.push(R)}}class M{constructor(){this._value=L}get value(){return this._value===L?void 0:this._value}set value($){this._value=$===void 0?L:$}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var L in u)(typeof exports=="object"?exports:he)[L]=u[L]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function u(L){if(e[L])return e[L].exports;var O=e[L]={i:L,l:!1,exports:{}};return he[L].call(O.exports,O,O.exports,u),O.l=!0,O.exports}return u.m=he,u.c=e,u.d=function(L,O,A){u.o(L,O)||Object.defineProperty(L,O,{enumerable:!0,get:A})},u.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},u.t=function(L,O){if(1&O&&(L=u(L)),8&O||4&O&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(u.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&O&&typeof L!="string")for(var M in L)u.d(A,M,function(b){return L[b]}.bind(null,M));return A},u.n=function(L){var O=L&&L.__esModule?function(){return L.default}:function(){return L};return u.d(O,"a",O),O},u.o=function(L,O){return Object.prototype.hasOwnProperty.call(L,O)},u.p="",u(u.s=0)}([function(he,e,u){(function(L){var O;e=he.exports=De,O=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],v=0,R=v++;$[R]="0|[1-9]\\d*";var I=v++;$[I]="[0-9]+";var p=v++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=v++;$[C]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var k=v++;$[k]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var c=v++;$[c]="(?:"+$[R]+"|"+$[p]+")";var m=v++;$[m]="(?:"+$[I]+"|"+$[p]+")";var o=v++;$[o]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var n=v++;$[n]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var i=v++;$[i]="[0-9A-Za-z-]+";var r=v++;$[r]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var s=v++,t="v?"+$[C]+$[o]+"?"+$[r]+"?";$[s]="^"+t+"$";var f="[v=\\s]*"+$[k]+$[n]+"?"+$[r]+"?",d=v++;$[d]="^"+f+"$";var l=v++;$[l]="((?:<|>)?=?)";var a=v++;$[a]=$[I]+"|x|X|\\*";var h=v++;$[h]=$[R]+"|x|X|\\*";var g=v++;$[g]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[o]+")?"+$[r]+"?)?)?";var S=v++;$[S]="[v=\\s]*("+$[a]+")(?:\\.("+$[a]+")(?:\\.("+$[a]+")(?:"+$[n]+")?"+$[r]+"?)?)?";var w=v++;$[w]="^"+$[l]+"\\s*"+$[g]+"$";var E=v++;$[E]="^"+$[l]+"\\s*"+$[S]+"$";var y=v++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=v++;$[D]="(?:~>?)";var P=v++;$[P]="(\\s*)"+$[D]+"\\s+",b[P]=new RegExp($[P],"g");var z=v++;$[z]="^"+$[D]+$[g]+"$";var F=v++;$[F]="^"+$[D]+$[S]+"$";var T=v++;$[T]="(?:\\^)";var j=v++;$[j]="(\\s*)"+$[T]+"\\s+",b[j]=new RegExp($[j],"g");var N=v++;$[N]="^"+$[T]+$[g]+"$";var B=v++;$[B]="^"+$[T]+$[S]+"$";var W=v++;$[W]="^"+$[l]+"\\s*("+f+")$|^$";var Y=v++;$[Y]="^"+$[l]+"\\s*("+t+")$|^$";var _=v++;$[_]="(\\s*)"+$[l]+"\\s*("+f+"|"+$[g]+")",b[_]=new RegExp($[_],"g");var J=v++;$[J]="^\\s*("+$[g]+")\\s+-\\s+("+$[g]+")\\s*$";var Z=v++;$[Z]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var re=v++;$[re]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)O(ee,$[ee]),b[ee]||(b[ee]=new RegExp($[ee]));function pe(V,X){if(V instanceof De)return V;if(typeof V!="string"||V.length>A||!(X?b[d]:b[s]).test(V))return null;try{return new De(V,X)}catch{return null}}function De(V,X){if(V instanceof De){if(V.loose===X)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof De))return new De(V,X);O("SemVer",V,X),this.loose=X;var Q=V.trim().match(X?b[d]:b[s]);if(!Q)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<M)return we}return fe}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=pe,e.valid=function(V,X){var Q=pe(V,X);return Q?Q.version:null},e.clean=function(V,X){var Q=pe(V.trim().replace(/^[=v]+/,""),X);return Q?Q.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(V){return O("SemVer.compare",this.version,this.loose,V),V instanceof De||(V=new De(V,this.loose)),this.compareMain(V)||this.comparePre(V)},De.prototype.compareMain=function(V){return V instanceof De||(V=new De(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},De.prototype.comparePre=function(V){if(V instanceof De||(V=new De(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var X=0;do{var Q=this.prerelease[X],fe=V.prerelease[X];if(O("prerelease compare",X,Q,fe),Q===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(Q===void 0)return-1;if(Q!==fe)return U(Q,fe)}while(++X)},De.prototype.inc=function(V,X){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,X,Q,fe){typeof Q=="string"&&(fe=Q,Q=void 0);try{return new De(V,Q).inc(X,fe).version}catch{return null}},e.diff=function(V,X){if(ae(V,X))return null;var Q=pe(V),fe=pe(X);if(Q.prerelease.length||fe.prerelease.length){for(var we in Q)if((we==="major"||we==="minor"||we==="patch")&&Q[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in Q)if((we==="major"||we==="minor"||we==="patch")&&Q[we]!==fe[we])return we},e.compareIdentifiers=U;var x=/^[0-9]+$/;function U(V,X){var Q=x.test(V),fe=x.test(X);return Q&&fe&&(V=+V,X=+X),Q&&!fe?-1:fe&&!Q?1:V<X?-1:V>X?1:0}function ie(V,X,Q){return new De(V,Q).compare(new De(X,Q))}function be(V,X,Q){return ie(V,X,Q)>0}function Ce(V,X,Q){return ie(V,X,Q)<0}function ae(V,X,Q){return ie(V,X,Q)===0}function ce(V,X,Q){return ie(V,X,Q)!==0}function se(V,X,Q){return ie(V,X,Q)>=0}function K(V,X,Q){return ie(V,X,Q)<=0}function te(V,X,Q,fe){var we;switch(X){case"===":typeof V=="object"&&(V=V.version),typeof Q=="object"&&(Q=Q.version),we=V===Q;break;case"!==":typeof V=="object"&&(V=V.version),typeof Q=="object"&&(Q=Q.version),we=V!==Q;break;case"":case"=":case"==":we=ae(V,Q,fe);break;case"!=":we=ce(V,Q,fe);break;case">":we=be(V,Q,fe);break;case">=":we=se(V,Q,fe);break;case"<":we=Ce(V,Q,fe);break;case"<=":we=K(V,Q,fe);break;default:throw new TypeError("Invalid operator: "+X)}return we}function le(V,X){if(V instanceof le){if(V.loose===X)return V;V=V.value}if(!(this instanceof le))return new le(V,X);O("comparator",V,X),this.loose=X,this.parse(V),this.semver===de?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(V,X){return U(X,V)},e.major=function(V,X){return new De(V,X).major},e.minor=function(V,X){return new De(V,X).minor},e.patch=function(V,X){return new De(V,X).patch},e.compare=ie,e.compareLoose=function(V,X){return ie(V,X,!0)},e.rcompare=function(V,X,Q){return ie(X,V,Q)},e.sort=function(V,X){return V.sort(function(Q,fe){return e.compare(Q,fe,X)})},e.rsort=function(V,X){return V.sort(function(Q,fe){return e.rcompare(Q,fe,X)})},e.gt=be,e.lt=Ce,e.eq=ae,e.neq=ce,e.gte=se,e.lte=K,e.cmp=te,e.Comparator=le;var de={};function Ae(V,X){if(V instanceof Ae)return V.loose===X?V:new Ae(V.raw,X);if(V instanceof le)return new Ae(V.value,X);if(!(this instanceof Ae))return new Ae(V,X);if(this.loose=X,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function me(V){return!V||V.toLowerCase()==="x"||V==="*"}function Ie(V,X,Q,fe,we,Te,He,xe,it,rt,at,ot,Se){return((X=me(Q)?"":me(fe)?">="+Q+".0.0":me(we)?">="+Q+"."+fe+".0":">="+X)+" "+(xe=me(it)?"":me(rt)?"<"+(+it+1)+".0.0":me(at)?"<"+it+"."+(+rt+1)+".0":ot?"<="+it+"."+rt+"."+at+"-"+ot:"<="+xe)).trim()}function Re(V,X){for(var Q=0;Q<V.length;Q++)if(!V[Q].test(X))return!1;if(X.prerelease.length){for(Q=0;Q<V.length;Q++)if(O(V[Q].semver),V[Q].semver!==de&&V[Q].semver.prerelease.length>0){var fe=V[Q].semver;if(fe.major===X.major&&fe.minor===X.minor&&fe.patch===X.patch)return!0}return!1}return!0}function Fe(V,X,Q){try{X=new Ae(X,Q)}catch{return!1}return X.test(V)}function q(V,X,Q,fe){var we,Te,He,xe,it;switch(V=new De(V,fe),X=new Ae(X,fe),Q){case">":we=be,Te=K,He=Ce,xe=">",it=">=";break;case"<":we=Ce,Te=se,He=be,xe="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(V,X,fe))return!1;for(var rt=0;rt<X.set.length;++rt){var at=X.set[rt],ot=null,Se=null;if(at.forEach(function(Be){Be.semver===de&&(Be=new le(">=0.0.0")),ot=ot||Be,Se=Se||Be,we(Be.semver,ot.semver,fe)?ot=Be:He(Be.semver,Se.semver,fe)&&(Se=Be)}),ot.operator===xe||ot.operator===it||(!Se.operator||Se.operator===xe)&&Te(V,Se.semver)||Se.operator===it&&He(V,Se.semver))return!1}return!0}le.prototype.parse=function(V){var X=this.loose?b[W]:b[Y],Q=V.match(X);if(!Q)throw new TypeError("Invalid comparator: "+V);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new De(Q[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(V){return O("Comparator.test",V,this.loose),this.semver===de||(typeof V=="string"&&(V=new De(V,this.loose)),te(V,this.operator,this.semver,this.loose))},le.prototype.intersects=function(V,X){if(!(V instanceof le))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Ae(V.value,X),Fe(this.value,Q,X);if(V.operator==="")return Q=new Ae(this.value,X),Fe(V.semver,Q,X);var fe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Te=this.semver.version===V.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),xe=te(this.semver,"<",V.semver,X)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),it=te(this.semver,">",V.semver,X)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return fe||we||Te&&He||xe||it},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var X=this.loose;V=V.trim(),O("range",V,X);var Q=X?b[Z]:b[J];V=V.replace(Q,Ie),O("hyphen replace",V),V=V.replace(b[_],"$1$2$3"),O("comparator trim",V,b[_]),V=(V=(V=V.replace(b[P],"$1~")).replace(b[j],"$1^")).split(/\s+/).join(" ");var fe=X?b[W]:b[Y],we=V.split(" ").map(function(Te){return function(He,xe){return O("comp",He),He=function(it,rt){return it.trim().split(/\s+/).map(function(at){return function(ot,Se){O("caret",ot,Se);var Be=Se?b[B]:b[N];return ot.replace(Be,function(Ge,Me,Qe,oe,ue){var Pe;return O("caret",ot,Ge,Me,Qe,oe,ue),me(Me)?Pe="":me(Qe)?Pe=">="+Me+".0.0 <"+(+Me+1)+".0.0":me(oe)?Pe=Me==="0"?">="+Me+"."+Qe+".0 <"+Me+"."+(+Qe+1)+".0":">="+Me+"."+Qe+".0 <"+(+Me+1)+".0.0":ue?(O("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Pe=Me==="0"?Qe==="0"?">="+Me+"."+Qe+"."+oe+ue+" <"+Me+"."+Qe+"."+(+oe+1):">="+Me+"."+Qe+"."+oe+ue+" <"+Me+"."+(+Qe+1)+".0":">="+Me+"."+Qe+"."+oe+ue+" <"+(+Me+1)+".0.0"):(O("no pr"),Pe=Me==="0"?Qe==="0"?">="+Me+"."+Qe+"."+oe+" <"+Me+"."+Qe+"."+(+oe+1):">="+Me+"."+Qe+"."+oe+" <"+Me+"."+(+Qe+1)+".0":">="+Me+"."+Qe+"."+oe+" <"+(+Me+1)+".0.0"),O("caret return",Pe),Pe})}(at,rt)}).join(" ")}(He,xe),O("caret",He),He=function(it,rt){return it.trim().split(/\s+/).map(function(at){return function(ot,Se){var Be=Se?b[F]:b[z];return ot.replace(Be,function(Ge,Me,Qe,oe,ue){var Pe;return O("tilde",ot,Ge,Me,Qe,oe,ue),me(Me)?Pe="":me(Qe)?Pe=">="+Me+".0.0 <"+(+Me+1)+".0.0":me(oe)?Pe=">="+Me+"."+Qe+".0 <"+Me+"."+(+Qe+1)+".0":ue?(O("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Pe=">="+Me+"."+Qe+"."+oe+ue+" <"+Me+"."+(+Qe+1)+".0"):Pe=">="+Me+"."+Qe+"."+oe+" <"+Me+"."+(+Qe+1)+".0",O("tilde return",Pe),Pe})}(at,rt)}).join(" ")}(He,xe),O("tildes",He),He=function(it,rt){return O("replaceXRanges",it,rt),it.split(/\s+/).map(function(at){return function(ot,Se){ot=ot.trim();var Be=Se?b[E]:b[w];return ot.replace(Be,function(Ge,Me,Qe,oe,ue,Pe){O("xRange",ot,Ge,Me,Qe,oe,ue,Pe);var Ke=me(Qe),_e=Ke||me(oe),Ne=_e||me(ue);return Me==="="&&Ne&&(Me=""),Ke?Ge=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ne?(_e&&(oe=0),Ne&&(ue=0),Me===">"?(Me=">=",_e?(Qe=+Qe+1,oe=0,ue=0):Ne&&(oe=+oe+1,ue=0)):Me==="<="&&(Me="<",_e?Qe=+Qe+1:oe=+oe+1),Ge=Me+Qe+"."+oe+"."+ue):_e?Ge=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":Ne&&(Ge=">="+Qe+"."+oe+".0 <"+Qe+"."+(+oe+1)+".0"),O("xRange return",Ge),Ge})}(at,rt)}).join(" ")}(He,xe),O("xrange",He),He=function(it,rt){return O("replaceStars",it,rt),it.trim().replace(b[re],"")}(He,xe),O("stars",He),He}(Te,X)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Te){return!!Te.match(fe)})),we=we.map(function(Te){return new le(Te,X)})},Ae.prototype.intersects=function(V,X){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(fe){return V.set.some(function(we){return we.every(function(Te){return fe.intersects(Te,X)})})})})},e.toComparators=function(V,X){return new Ae(V,X).set.map(function(Q){return Q.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new De(V,this.loose));for(var X=0;X<this.set.length;X++)if(Re(this.set[X],V))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(V,X,Q){var fe=null,we=null;try{var Te=new Ae(X,Q)}catch{return null}return V.forEach(function(He){Te.test(He)&&(fe&&we.compare(He)!==-1||(we=new De(fe=He,Q)))}),fe},e.minSatisfying=function(V,X,Q){var fe=null,we=null;try{var Te=new Ae(X,Q)}catch{return null}return V.forEach(function(He){Te.test(He)&&(fe&&we.compare(He)!==1||(we=new De(fe=He,Q)))}),fe},e.validRange=function(V,X){try{return new Ae(V,X).range||"*"}catch{return null}},e.ltr=function(V,X,Q){return q(V,X,"<",Q)},e.gtr=function(V,X,Q){return q(V,X,">",Q)},e.outside=q,e.prerelease=function(V,X){var Q=pe(V,X);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(V,X,Q){return V=new Ae(V,Q),X=new Ae(X,Q),V.intersects(X)},e.coerce=function(V){if(V instanceof De)return V;if(typeof V!="string")return null;var X=V.match(b[y]);return X==null?null:pe((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,u(1))},function(he,e){var u,L,O=he.exports={};function A(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(m){if(u===setTimeout)return setTimeout(m,0);if((u===A||!u)&&setTimeout)return u=setTimeout,setTimeout(m,0);try{return u(m,0)}catch{try{return u.call(null,m,0)}catch{return u.call(this,m,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:A}catch{u=A}try{L=typeof clearTimeout=="function"?clearTimeout:M}catch{L=M}})();var $,v=[],R=!1,I=-1;function p(){R&&$&&(R=!1,$.length?v=$.concat(v):I=-1,v.length&&C())}function C(){if(!R){var m=b(p);R=!0;for(var o=v.length;o;){for($=v,v=[];++I<o;)$&&$[I].run();I=-1,o=v.length}$=null,R=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===M||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(m)}}function k(m,o){this.fun=m,this.array=o}function c(){}O.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];v.push(new k(m,o)),v.length!==1||R||b(C)},k.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=c,O.addListener=c,O.once=c,O.off=c,O.removeListener=c,O.removeAllListeners=c,O.emit=c,O.prependListener=c,O.prependOnceListener=c,O.listeners=function(m){return[]},O.binding=function(m){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(m){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(ke[39],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this.c=u&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=L}),define(ke[4],Ee([1,0,13,74,3,75,39]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=C;const b=!1,$=!1,v=!1;var R;(function(y){y.None=()=>O.$Uc.None;function D(le){if(v){const{onDidAddListener:de}=le,Ae=c.create();let me=0;le.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),de?.()}}}function P(le,de){return J(le,()=>{},0,void 0,!0,void 0,de)}y.defer=P;function z(le){return(de,Ae=null,me)=>{let Ie=!1,Re;return Re=le(Fe=>{if(!Ie)return Re?Re.dispose():Ie=!0,de.call(Ae,Fe)},null,me),Ie&&Re.dispose(),Re}}y.once=z;function F(le,de,Ae){return Y((me,Ie=null,Re)=>le(Fe=>me.call(Ie,de(Fe)),null,Re),Ae)}y.map=F;function T(le,de,Ae){return Y((me,Ie=null,Re)=>le(Fe=>{de(Fe),me.call(Ie,Fe)},null,Re),Ae)}y.forEach=T;function j(le,de,Ae){return Y((me,Ie=null,Re)=>le(Fe=>de(Fe)&&me.call(Ie,Fe),null,Re),Ae)}y.filter=j;function N(le){return le}y.signal=N;function B(...le){return(de,Ae=null,me)=>{const Ie=(0,O.$Rc)(...le.map(Re=>Re(Fe=>de.call(Ae,Fe))));return _(Ie,me)}}y.any=B;function W(le,de,Ae,me){let Ie=Ae;return F(le,Re=>(Ie=de(Ie,Re),Ie),me)}y.reduce=W;function Y(le,de){let Ae;const me={onWillAddFirstListener(){Ae=le(Ie.fire,Ie)},onDidRemoveLastListener(){Ae?.dispose()}};de||D(me);const Ie=new s(me);return de?.add(Ie),Ie.event}function _(le,de){return de instanceof Array?de.push(le):de&&de.add(le),le}function J(le,de,Ae=100,me=!1,Ie=!1,Re,Fe){let q,V,X,Q=0,fe;const we={leakWarningThreshold:Re,onWillAddFirstListener(){q=le(He=>{Q++,V=de(V,He),me&&!X&&(Te.fire(V),V=void 0),fe=()=>{const xe=V;V=void 0,X=void 0,(!me||Q>1)&&Te.fire(xe),Q=0},typeof Ae=="number"?(clearTimeout(X),X=setTimeout(fe,Ae)):X===void 0&&(X=0,queueMicrotask(fe))})},onWillRemoveListener(){Ie&&Q>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,q.dispose()}};Fe||D(we);const Te=new s(we);return Fe?.add(Te),Te.event}y.debounce=J;function Z(le,de=0,Ae){return y.debounce(le,(me,Ie)=>me?(me.push(Ie),me):[Ie],de,void 0,!0,void 0,Ae)}y.accumulate=Z;function re(le,de=(me,Ie)=>me===Ie,Ae){let me=!0,Ie;return j(le,Re=>{const Fe=me||!de(Re,Ie);return me=!1,Ie=Re,Fe},Ae)}y.latch=re;function ee(le,de,Ae){return[y.filter(le,de,Ae),y.filter(le,me=>!de(me),Ae)]}y.split=ee;function pe(le,de=!1,Ae=[],me){let Ie=Ae.slice(),Re=le(V=>{Ie?Ie.push(V):q.fire(V)});me&&me.add(Re);const Fe=()=>{Ie?.forEach(V=>q.fire(V)),Ie=null},q=new s({onWillAddFirstListener(){Re||(Re=le(V=>q.fire(V)),me&&me.add(Re))},onDidAddFirstListener(){Ie&&(de?setTimeout(Fe):Fe())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return me&&me.add(q),q.event}y.buffer=pe;function De(le,de){return(me,Ie,Re)=>{const Fe=de(new U);return le(function(q){const V=Fe.evaluate(q);V!==x&&me.call(Ie,V)},void 0,Re)}}y.chain=De;const x=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(de){return this.f.push(de),this}forEach(de){return this.f.push(Ae=>(de(Ae),Ae)),this}filter(de){return this.f.push(Ae=>de(Ae)?Ae:x),this}reduce(de,Ae){let me=Ae;return this.f.push(Ie=>(me=de(me,Ie),me)),this}latch(de=(Ae,me)=>Ae===me){let Ae=!0,me;return this.f.push(Ie=>{const Re=Ae||!de(Ie,me);return Ae=!1,me=Ie,Re?Ie:x}),this}evaluate(de){for(const Ae of this.f)if(de=Ae(de),de===x)break;return de}}function ie(le,de,Ae=me=>me){const me=(...q)=>Fe.fire(Ae(...q)),Ie=()=>le.on(de,me),Re=()=>le.removeListener(de,me),Fe=new s({onWillAddFirstListener:Ie,onDidRemoveLastListener:Re});return Fe.event}y.fromNodeEventEmitter=ie;function be(le,de,Ae=me=>me){const me=(...q)=>Fe.fire(Ae(...q)),Ie=()=>le.addEventListener(de,me),Re=()=>le.removeEventListener(de,me),Fe=new s({onWillAddFirstListener:Ie,onDidRemoveLastListener:Re});return Fe.event}y.fromDOMEventEmitter=be;function Ce(le){return new Promise(de=>z(le)(de))}y.toPromise=Ce;function ae(le){const de=new s;return le.then(Ae=>{de.fire(Ae)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}y.fromPromise=ae;function ce(le,de,Ae){return de(Ae),le(me=>de(me))}y.runAndSubscribe=ce;class se{constructor(de,Ae){this._observable=de,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};Ae||D(me),this.emitter=new s(me),Ae&&Ae.add(this.emitter)}beginUpdate(de){this.f++}handlePossibleChange(de){}handleChange(de,Ae){this.g=!0}endUpdate(de){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function K(le,de){return new se(le,de).emitter.event}y.fromObservable=K;function te(le){return(de,Ae,me)=>{let Ie=0,Re=!1;const Fe={beginUpdate(){Ie++},endUpdate(){Ie--,Ie===0&&(le.reportChanges(),Re&&(Re=!1,de.call(Ae)))},handlePossibleChange(){},handleChange(){Re=!0}};le.addObserver(Fe),le.reportChanges();const q={dispose(){le.removeObserver(Fe)}};return me instanceof O.$Tc?me.add(q):Array.isArray(me)&&me.push(q),q}}y.fromObservableLight=te})(R||(e.Event=R={}));class I{static{this.all=new Set}static{this.f=0}constructor(D){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${D}_${I.f++}`,I.all.add(this)}start(D){this.g=new M.$3d,this.listenerCount=D}stop(){if(this.g){const D=this.g.elapsed();this.durations.push(D),this.elapsedOverall+=D,this.invocationCount+=1,this.g=void 0}}}e.$5d=I;let p=-1;function C(y){const D=p;return p=y,{dispose(){p=D}}}class k{constructor(D,P=Math.random().toString(18).slice(2,5)){this.threshold=D,this.name=P,this.g=0}dispose(){this.f?.clear()}check(D,P){const z=this.threshold;if(z<=0||P<z)return;this.f||(this.f=new Map);const F=this.f.get(D.value)||0;if(this.f.set(D.value,F+1),this.g-=1,this.g<=0){this.g=z*.5;let T,j=0;for(const[N,B]of this.f)(!T||j<B)&&(T=N,j=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${j}):`),console.warn(T)}return()=>{const T=this.f.get(D.value)||0;this.f.set(D.value,T-1)}}}class c{static create(){return new c(new Error().stack??"")}constructor(D){this.value=D}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class o{constructor(D){this.value=D,this.id=m++}}const n=2,i=(y,D)=>{if(y instanceof o)D(y);else for(let P=0;P<y.length;P++){const z=y[P];z&&D(z)}},r=b?new FinalizationRegistry(y=>{typeof y=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(y))}):void 0;class s{constructor(D){this.w=0,this.f=D,this.g=p>0||this.f?.leakWarningThreshold?new k(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new I(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const D=this.t;queueMicrotask(()=>{i(D,P=>P.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(D,P,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.$Uc.None;if(this.m)return O.$Uc.None;P&&(D=D.bind(P));const F=new o(D);let T,j;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=c.create(),T=this.g.check(F.stack,this.w+1)),$&&(F.stack=j??c.create()),this.t?this.t instanceof o?(this.u??=new f,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const N=(0,O.$Sc)(()=>{r?.unregister(N),T?.(),this.x(F)});if(z instanceof O.$Tc?z.add(N):Array.isArray(z)&&z.push(N),r){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(N,B,N)}return N},this.q}x(D){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const P=this.t,z=P.indexOf(D);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,P[z]=void 0;const F=this.u.current===this;if(this.w*n<=P.length){let T=0;for(let j=0;j<P.length;j++)P[j]?P[T++]=P[j]:F&&(this.u.end--,T<this.u.i&&this.u.i--);P.length=T}}y(D,P){if(!D)return;const z=this.f?.onListenerError||u.$1;if(!z){D.value(P);return}try{D.value(P)}catch(F){z(F)}}z(D){const P=D.current.t;for(;D.i<D.end;)this.y(P[D.i++],D.value);D.reset()}fire(D){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,D);else{const P=this.u;P.enqueue(this,D,this.t.length),this.z(P)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=s;const t=()=>new f;e.$8d=t;class f{constructor(){this.i=-1,this.end=0}enqueue(D,P,z){this.i=0,this.end=z,this.current=D,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(D,P,z){if(this.t)for(this.h||(this.h=new A.$5c),i(this.t,F=>this.h.push([F.value,D]));this.h.size>0&&!P.isCancellationRequested;){const[F,T]=this.h.shift(),j=[],N={...T,token:P,waitUntil:B=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");z&&(B=z(B,F)),j.push(B)}};try{F(N)}catch(B){(0,u.$1)(B);continue}Object.freeze(j),await Promise.allSettled(j).then(B=>{for(const W of B)W.status==="rejected"&&(0,u.$1)(W.reason)})}}}e.$9d=d;class l extends s{get isPaused(){return this.h!==0}constructor(D){super(D),this.h=0,this.s=new A.$5c,this.A=D?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const D=Array.from(this.s);this.s.clear(),super.fire(this.A(D))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(D){this.w&&(this.h!==0?this.s.push(D):super.fire(D))}}e.$0d=l;class a extends l{constructor(D){super(D),this.k=D.delay??100}fire(D){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(D)}}e.$$d=a;class h extends s{constructor(D){super(D),this.h=[],this.k=D?.merge}fire(D){this.hasListeners()&&(this.h.push(D),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}e.$_d=h;class g{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(D){const P={event:D,listener:null};this.h.push(P),this.g&&this.m(P);const z=()=>{this.g&&this.o(P);const F=this.h.indexOf(P);this.h.splice(F,1)};return(0,O.$Sc)((0,L.$db)(z))}j(){this.g=!0,this.h.forEach(D=>this.m(D))}k(){this.g=!1,this.h.forEach(D=>this.o(D))}m(D){D.listener=D.event(P=>this.f.fire(P))}o(D){D.listener?.dispose(),D.listener=null}dispose(){this.f.dispose();for(const D of this.h)D.listener?.dispose();this.h=[]}}e.$ae=g;class S{constructor(D,P,z,F){this.f=new O.$Tc;const T=this.f.add(new g),j=this.f.add(new O.$4c);function N(B){j.set(B,T.add(F(B)))}for(const B of D)N(B);this.f.add(P(B=>{N(B)})),this.f.add(z(B=>{j.deleteAndDispose(B)})),this.event=T.event}dispose(){this.f.dispose()}}e.$be=S;class w{constructor(){this.f=[]}wrapEvent(D){return(P,z,F)=>D(T=>{const j=this.f[this.f.length-1];j?j.push(()=>P.call(z,T)):P.call(z,T)},void 0,F)}bufferEvents(D){const P=[];this.f.push(P);const z=D();return this.f.pop(),P.forEach(F=>F()),z}}e.$ce=w;class E{constructor(){this.f=!1,this.g=R.None,this.h=O.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(D){this.g=D,this.f&&(this.h.dispose(),this.h=D(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=E}),define(ke[22],Ee([1,0,4]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const L=Object.freeze(function(b,$){const v=setTimeout(b.bind($),0);return{dispose(){clearTimeout(v)}}});var O;(function(b){function $(v){return v===b.None||v===b.Cancelled||v instanceof A?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(O||(e.CancellationToken=O={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new u.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=O.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=O.None}}e.$ee=M}),define(ke[167],Ee([1,0,22]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class L{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new u.$ee,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Pe=L;class O{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Qe=O;class A{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Re=A}),define(ke[98],Ee([1,0,13,3]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=O,e.$ge=A,e.$he=M,e.$ie=b,e.$je=v,e.$ke=R,e.$le=I,e.$me=p,e.$ne=C,e.$oe=k,e.$pe=c,e.$qe=m,e.$re=o,e.$se=n,e.$te=i;function O(r){const s=r;return s?typeof s.read=="function":!1}function A(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function M(r){const s=r;return s?A(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function b(r,s){return new $(r,s)}class ${constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,u.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let f;switch(s){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const d=f.indexOf(t);d>=0&&f.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(r,s){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return s(t)}function R(r,s,t){const f=[];let d;for(;(d=r.read())!==null&&f.length<t;)f.push(d);return d===null&&f.length>0?s(f):{read:()=>{if(f.length>0)return f.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}function I(r,s){return new Promise((t,f)=>{const d=[];p(r,{onData:l=>{s&&d.push(l)},onError:l=>{s?f(l):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function p(r,s,t){r.on("error",f=>{t?.isCancellationRequested||s.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||s.onData(f)})}function C(r,s){return new Promise((t,f)=>{const d=new L.$Tc,l=[],a=S=>{if(l.push(S),l.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=S=>(d.dispose(),f(S)),g=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,L.$Sc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,L.$Sc)(()=>r.removeListener("end",g))),r.on("end",g),d.add((0,L.$Sc)(()=>r.removeListener("data",a))),r.on("data",a)})}function k(r,s){const t=b(s);return t.end(r),t}function c(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function o(r,s,t){const f=b(t);return p(r,{onData:d=>f.write(s.data(d)),onError:d=>f.error(s.error?s.error(d):d),onEnd:()=>f.end()}),f}function n(r,s,t){let f=!1;return{read:()=>{const d=s.read();return f?d:(f=!0,d!==null?t([r,d]):r)}}}function i(r,s,t){let f=!1;const d=b(t);return p(s,{onData:l=>f?d.write(l):(f=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{f||(f=!0,d.write(r)),d.end()}}),d}}),define(ke[21],Ee([1,0,45,98]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=v,e.$we=R,e.$xe=I,e.$ye=p,e.$ze=C,e.$Ae=k,e.$Be=c,e.$Ce=m,e.$De=o,e.$Ee=n,e.$Fe=i,e.$Ge=r,e.$He=s,e.$Ie=t,e.$Je=f,e.$Ke=d,e.$Le=l,e.$Me=a,e.$Ne=h,e.$Oe=w;const O=typeof Buffer<"u",A=new u.$V(()=>new Uint8Array(256));let M,b;class ${static alloc(y){return O?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return O&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,D){return!(D?.dontUseNodeBuffer||!1)&&O?new $(Buffer.from(y)):(M||(M=new TextEncoder),new $(M.encode(y)))}static fromByteArray(y){const D=$.alloc(y.length);for(let P=0,z=y.length;P<z;P++)D.buffer[P]=y[P];return D}static concat(y,D){if(typeof D>"u"){D=0;for(let F=0,T=y.length;F<T;F++)D+=y[F].byteLength}const P=$.alloc(D);let z=0;for(let F=0,T=y.length;F<T;F++){const j=y[F];P.set(j,z),z+=j.byteLength}return P}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return O?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(y,D){return new $(this.buffer.subarray(y,D))}set(y,D){if(y instanceof $)this.buffer.set(y.buffer,D);else if(y instanceof Uint8Array)this.buffer.set(y,D);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),D);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return p(this.buffer,y)}writeUInt32BE(y,D){C(this.buffer,y,D)}readUInt32LE(y){return k(this.buffer,y)}writeUInt32LE(y,D){c(this.buffer,y,D)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,D){o(this.buffer,y,D)}indexOf(y,D=0){return v(this.buffer,y instanceof $?y.buffer:y,D)}}e.$ue=$;function v(E,y,D=0){const P=y.byteLength,z=E.byteLength;if(P===0)return 0;if(P===1)return E.indexOf(y[0]);if(P>z-D)return-1;const F=A.value;F.fill(y.length);for(let B=0;B<y.length;B++)F[y[B]]=y.length-B-1;let T=D+y.length-1,j=T,N=-1;for(;T<z;)if(E[T]===y[j]){if(j===0){N=T;break}T--,j--}else T+=Math.max(y.length-j,F[E[T]]),j=y.length-1;return N}function R(E,y){return E[y+0]<<0>>>0|E[y+1]<<8>>>0}function I(E,y,D){E[D+0]=y&255,y=y>>>8,E[D+1]=y&255}function p(E,y){return E[y]*2**24+E[y+1]*2**16+E[y+2]*2**8+E[y+3]}function C(E,y,D){E[D+3]=y,y=y>>>8,E[D+2]=y,y=y>>>8,E[D+1]=y,y=y>>>8,E[D]=y}function k(E,y){return E[y+0]<<0>>>0|E[y+1]<<8>>>0|E[y+2]<<16>>>0|E[y+3]<<24>>>0}function c(E,y,D){E[D+0]=y&255,y=y>>>8,E[D+1]=y&255,y=y>>>8,E[D+2]=y&255,y=y>>>8,E[D+3]=y&255}function m(E,y){return E[y]}function o(E,y,D){E[D]=y}function n(E){return L.$je(E,y=>$.concat(y))}function i(E){return L.$qe(E)}function r(E){return L.$le(E,y=>$.concat(y))}async function s(E){return E.ended?$.concat(E.buffer):$.concat([...E.buffer,await r(E.stream)])}function t(E){return L.$oe(E,y=>$.concat(y))}function f(E){return L.$re(E,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}function d(E){return L.$ie(y=>$.concat(y),E)}function l(E,y){return L.$se(E,y,D=>$.concat(D))}function a(E,y){return L.$te(E,y,D=>$.concat(D))}function h(E){let y=0,D=0,P=0;const z=new Uint8Array(Math.floor(E.length/4*3)),F=j=>{switch(D){case 3:z[P++]=y|j,D=0;break;case 2:z[P++]=y|j>>>2,y=j<<6,D=3;break;case 1:z[P++]=y|j>>>4,y=j<<4,D=2;break;default:y=j<<2,D=1}};for(let j=0;j<E.length;j++){const N=E.charCodeAt(j);if(N>=65&&N<=90)F(N-65);else if(N>=97&&N<=122)F(N-97+26);else if(N>=48&&N<=57)F(N-48+52);else if(N===43||N===45)F(62);else if(N===47||N===95)F(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${E[j]}`)}}const T=P;for(;D>0;)F(0);return $.wrap(z).slice(0,T)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:E},y=!0,D=!1){const P=D?S:g;let z="";const F=E.byteLength%3;let T=0;for(;T<E.byteLength-F;T+=3){const j=E[T+0],N=E[T+1],B=E[T+2];z+=P[j>>>2],z+=P[(j<<4|N>>>4)&63],z+=P[(N<<2|B>>>6)&63],z+=P[B&63]}if(F===1){const j=E[T+0];z+=P[j>>>2],z+=P[j<<4&63],y&&(z+="==")}else if(F===2){const j=E[T+0],N=E[T+1];z+=P[j>>>2],z+=P[(j<<4|N>>>4)&63],z+=P[N<<2&63],y&&(z+="=")}return z}}),define(ke[14],Ee([1,0,167,45]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.GraphemeBreakType=e.$If=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=O,e.$Ve=M,e.$We=$,e.$Xe=v,e.$Ye=R,e.$Ze=I,e.$1e=p,e.$2e=C,e.$3e=k,e.$4e=c,e.$5e=m,e.$6e=o,e.$7e=n,e.$8e=i,e.$9e=r,e.$0e=s,e.$$e=t,e.$_e=f,e.$af=d,e.$bf=l,e.$cf=a,e.$df=h,e.$ef=g,e.$ff=S,e.$gf=w,e.$hf=E,e.$if=y,e.$jf=D,e.$kf=P,e.$lf=z,e.$mf=F,e.$nf=T,e.$of=j,e.$pf=N,e.$qf=B,e.$rf=W,e.$sf=Y,e.$vf=re,e.$wf=ee,e.$xf=pe,e.$yf=De,e.$zf=ie,e.$Af=Ce,e.$Cf=ae,e.$Df=ce,e.$Ef=se,e.$Ff=K,e.$Gf=le,e.$Hf=de,e.$Jf=Ae,e.$Kf=me,e.$Lf=Ie,e.$Mf=Re,e.$Nf=Fe,e.$Of=q,e.$Pf=V,e.$Qf=X,e.$Rf=He;function O(Se){return!Se||typeof Se!="string"?!0:Se.trim().length===0}const A=/{(\d+)}/g;function M(Se,...Be){return Be.length===0?Se:Se.replace(A,function(Ge,Me){const Qe=parseInt(Me,10);return isNaN(Qe)||Qe<0||Qe>=Be.length?Ge:Be[Qe]})}const b=/{([^}]+)}/g;function $(Se,Be){return Object.keys(Be).length===0?Se:Se.replace(b,(Ge,Me)=>Be[Me]??Ge)}function v(Se){return Se.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function R(Se){return Se.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function I(Se){return Se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Se,Be){let Ge=0;const Me=Be.charCodeAt(0);for(let Qe=Se.length-1;Qe>=0;Qe--)Se.charCodeAt(Qe)===Me&&Ge++;return Ge}function C(Se,Be,Ge="\u2026"){return Se.length<=Be?Se:`${Se.substr(0,Be)}${Ge}`}function k(Se,Be,Ge="\u2026"){if(Se.length<=Be)return Se;const Me=Math.ceil(Be/2)-Ge.length/2,Qe=Math.floor(Be/2)-Ge.length/2;return`${Se.substr(0,Me)}${Ge}${Se.substr(Se.length-Qe)}`}function c(Se,Be=" "){const Ge=m(Se,Be);return o(Ge,Be)}function m(Se,Be){if(!Se||!Be)return Se;const Ge=Be.length;if(Ge===0||Se.length===0)return Se;let Me=0;for(;Se.indexOf(Be,Me)===Me;)Me=Me+Ge;return Se.substring(Me)}function o(Se,Be){if(!Se||!Be)return Se;const Ge=Be.length,Me=Se.length;if(Ge===0||Me===0)return Se;let Qe=Me,oe=-1;for(;oe=Se.lastIndexOf(Be,Qe-1),!(oe===-1||oe+Ge!==Qe);){if(oe===0)return"";Qe=oe}return Se.substring(0,Qe)}function n(Se){return Se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Se){return Se.replace(/\*/g,"")}function r(Se,Be,Ge={}){if(!Se)throw new Error("Cannot create regex from empty string");Be||(Se=I(Se)),Ge.wholeWord&&(/\B/.test(Se.charAt(0))||(Se="\\b"+Se),/\B/.test(Se.charAt(Se.length-1))||(Se=Se+"\\b"));let Me="";return Ge.global&&(Me+="g"),Ge.matchCase||(Me+="i"),Ge.multiline&&(Me+="m"),Ge.unicode&&(Me+="u"),new RegExp(Se,Me)}function s(Se){return Se.source==="^"||Se.source==="^$"||Se.source==="$"||Se.source==="^\\s*$"?!1:!!(Se.exec("")&&Se.lastIndex===0)}function t(Se){return Se.split(/\r\n|\r|\n/)}function f(Se){const Be=[],Ge=Se.split(/(\r\n|\r|\n)/);for(let Me=0;Me<Math.ceil(Ge.length/2);Me++)Be.push(Ge[2*Me]+(Ge[2*Me+1]??""));return Be}function d(Se){for(let Be=0,Ge=Se.length;Be<Ge;Be++){const Me=Se.charCodeAt(Be);if(Me!==32&&Me!==9)return Be}return-1}function l(Se,Be=0,Ge=Se.length){for(let Me=Be;Me<Ge;Me++){const Qe=Se.charCodeAt(Me);if(Qe!==32&&Qe!==9)return Se.substring(Be,Me)}return Se.substring(Be,Ge)}function a(Se,Be=Se.length-1){for(let Ge=Be;Ge>=0;Ge--){const Me=Se.charCodeAt(Ge);if(Me!==32&&Me!==9)return Ge}return-1}function h(Se,Be,Ge){const Me=[];let Qe=0;for(const oe of Se.matchAll(Be)){if(Me.push(Se.slice(Qe,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");Qe=oe.index+oe[0].length,Me.push(Ge(oe[0],...oe.slice(1),oe.index,Se,oe.groups))}return Me.push(Se.slice(Qe)),Promise.all(Me).then(oe=>oe.join(""))}function g(Se,Be){return Se<Be?-1:Se>Be?1:0}function S(Se,Be,Ge=0,Me=Se.length,Qe=0,oe=Be.length){for(;Ge<Me&&Qe<oe;Ge++,Qe++){const Ke=Se.charCodeAt(Ge),_e=Be.charCodeAt(Qe);if(Ke<_e)return-1;if(Ke>_e)return 1}const ue=Me-Ge,Pe=oe-Qe;return ue<Pe?-1:ue>Pe?1:0}function w(Se,Be){return E(Se,Be,0,Se.length,0,Be.length)}function E(Se,Be,Ge=0,Me=Se.length,Qe=0,oe=Be.length){for(;Ge<Me&&Qe<oe;Ge++,Qe++){let Ke=Se.charCodeAt(Ge),_e=Be.charCodeAt(Qe);if(Ke===_e)continue;if(Ke>=128||_e>=128)return S(Se.toLowerCase(),Be.toLowerCase(),Ge,Me,Qe,oe);D(Ke)&&(Ke-=32),D(_e)&&(_e-=32);const Ne=Ke-_e;if(Ne!==0)return Ne}const ue=Me-Ge,Pe=oe-Qe;return ue<Pe?-1:ue>Pe?1:0}function y(Se){return Se>=48&&Se<=57}function D(Se){return Se>=97&&Se<=122}function P(Se){return Se>=65&&Se<=90}function z(Se,Be){return Se.length===Be.length&&E(Se,Be)===0}function F(Se,Be){const Ge=Be.length;return Be.length>Se.length?!1:E(Se,Be,0,Ge)===0}function T(Se,Be){const Ge=Math.min(Se.length,Be.length);let Me;for(Me=0;Me<Ge;Me++)if(Se.charCodeAt(Me)!==Be.charCodeAt(Me))return Me;return Ge}function j(Se,Be){const Ge=Math.min(Se.length,Be.length);let Me;const Qe=Se.length-1,oe=Be.length-1;for(Me=0;Me<Ge;Me++)if(Se.charCodeAt(Qe-Me)!==Be.charCodeAt(oe-Me))return Me;return Ge}function N(Se){return 55296<=Se&&Se<=56319}function B(Se){return 56320<=Se&&Se<=57343}function W(Se,Be){return(Se-55296<<10)+(Be-56320)+65536}function Y(Se,Be,Ge){const Me=Se.charCodeAt(Ge);if(N(Me)&&Ge+1<Be){const Qe=Se.charCodeAt(Ge+1);if(B(Qe))return W(Me,Qe)}return Me}function _(Se,Be){const Ge=Se.charCodeAt(Be-1);if(B(Ge)&&Be>1){const Me=Se.charCodeAt(Be-2);if(N(Me))return W(Me,Ge)}return Ge}class J{get offset(){return this.e}constructor(Be,Ge=0){this.c=Be,this.d=Be.length,this.e=Ge}setOffset(Be){this.e=Be}prevCodePoint(){const Be=_(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=Y(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$tf=J;class Z{get offset(){return this.c.offset}constructor(Be,Ge=0){this.c=new J(Be,Ge)}nextGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Me=Ge.offset;let Qe=Be.getGraphemeBreakType(Ge.nextCodePoint());for(;!Ge.eol();){const oe=Ge.offset,ue=Be.getGraphemeBreakType(Ge.nextCodePoint());if(Q(Qe,ue)){Ge.setOffset(oe);break}Qe=ue}return Ge.offset-Me}prevGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Me=Ge.offset;let Qe=Be.getGraphemeBreakType(Ge.prevCodePoint());for(;Ge.offset>0;){const oe=Ge.offset,ue=Be.getGraphemeBreakType(Ge.prevCodePoint());if(Q(ue,Qe)){Ge.setOffset(oe);break}Qe=ue}return Me-Ge.offset}eol(){return this.c.eol()}}e.$uf=Z;function re(Se,Be){return new Z(Se,Be).nextGraphemeLength()}function ee(Se,Be){return new Z(Se,Be).prevGraphemeLength()}function pe(Se,Be){Be>0&&B(Se.charCodeAt(Be))&&Be--;const Ge=Be+re(Se,Be);return[Ge-ee(Se,Ge),Ge]}function De(Se){const Be=new Z(Se);let Ge=0;for(;!Be.eol();)Ge++,Be.nextGraphemeLength();return Ge}let x;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(Se){return x||(x=U()),x.test(Se)}const be=/^[\t\n\r\x20-\x7E]*$/;function Ce(Se){return be.test(Se)}e.$Bf=/[\u2028\u2029]/;function ae(Se){return e.$Bf.test(Se)}function ce(Se){return Se>=11904&&Se<=55215||Se>=63744&&Se<=64255||Se>=65281&&Se<=65374}function se(Se){return Se>=127462&&Se<=127487||Se===8986||Se===8987||Se===9200||Se===9203||Se>=9728&&Se<=10175||Se===11088||Se===11093||Se>=127744&&Se<=128591||Se>=128640&&Se<=128764||Se>=128992&&Se<=129008||Se>=129280&&Se<=129535||Se>=129648&&Se<=129782}function K(Se,Be,Ge=""){const Me=Se.trimStart();if(Me.length<Be)return Me;const Qe=/\b/g;let oe=0;for(;Qe.test(Me)&&!(Me.length-Qe.lastIndex<Be);)oe=Qe.lastIndex,Qe.lastIndex+=1;return oe===0?Me:Ge+Me.substring(oe).trimStart()}const te=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*le(Se){let Be=0;for(const Ge of Se.matchAll(te))Be!==Ge.index&&(yield{isCode:!1,str:Se.substring(Be,Ge.index)}),yield{isCode:!0,str:Ge[0]},Be=Ge.index+Ge[0].length;Be!==Se.length&&(yield{isCode:!1,str:Se.substring(Be)})}function de(Se){return Se&&(Se=Se.replace(te,"")),Se}e.$If="\uFEFF";function Ae(Se){return!!(Se&&Se.length>0&&Se.charCodeAt(0)===65279)}function me(Se){return Ae(Se)?Se.substr(1):Se}function Ie(Se,Be){if(!Se||!Be||Se.length<Be.length)return!1;const Ge=Be.length,Me=Se.toLowerCase();let Qe=0,oe=-1;for(;Qe<Ge;){const ue=Me.indexOf(Be[Qe],oe+1);if(ue<0)return!1;oe=ue,Qe++}return!0}function Re(Se,Be=!1){return Se?(Be&&(Se=Se.replace(/\\./g,"")),Se.toLowerCase()!==Se):!1}function Fe(Se){return Se.charAt(0).toUpperCase()+Se.slice(1)}function q(Se,Be=1){if(Be===0)return"";let Ge=-1;do Ge=Se.indexOf(`
`,Ge+1),Be--;while(Be>0&&Ge>=0);return Ge===-1?Se:(Se[Ge-1]==="\r"&&Ge--,Se.substr(0,Ge))}function V(Se){return Se=Se%(2*26),Se<26?String.fromCharCode(97+Se):String.fromCharCode(65+Se-26)}function X(Se){return we.getInstance().getGraphemeBreakType(Se)}function Q(Se,Be){return Se===0?Be!==5&&Be!==7:Se===2&&Be===3?!1:Se===4||Se===2||Se===3||Be===4||Be===2||Be===3?!0:!(Se===8&&(Be===8||Be===9||Be===11||Be===12)||(Se===11||Se===9)&&(Be===9||Be===10)||(Se===12||Se===10)&&Be===10||Be===5||Be===13||Be===7||Se===1||Se===13&&Be===14||Se===6&&Be===6)}var fe;(function(Se){Se[Se.Other=0]="Other",Se[Se.Prepend=1]="Prepend",Se[Se.CR=2]="CR",Se[Se.LF=3]="LF",Se[Se.Control=4]="Control",Se[Se.Extend=5]="Extend",Se[Se.Regional_Indicator=6]="Regional_Indicator",Se[Se.SpacingMark=7]="SpacingMark",Se[Se.L=8]="L",Se[Se.V=9]="V",Se[Se.T=10]="T",Se[Se.LV=11]="LV",Se[Se.LVT=12]="LVT",Se[Se.ZWJ=13]="ZWJ",Se[Se.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(e.GraphemeBreakType=fe={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Te()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Ge=this.d,Me=Ge.length/3;let Qe=1;for(;Qe<=Me;)if(Be<Ge[3*Qe])Qe=2*Qe;else if(Be>Ge[3*Qe+1])Qe=2*Qe+1;else return Ge[3*Qe+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Se,Be){if(Se===0)return 0;const Ge=xe(Se,Be);if(Ge!==void 0)return Ge;const Me=new J(Be,Se);return Me.prevCodePoint(),Me.offset}function xe(Se,Be){const Ge=new J(Be,Se);let Me=Ge.prevCodePoint();for(;it(Me)||Me===65039||Me===8419;){if(Ge.offset===0)return;Me=Ge.prevCodePoint()}if(!se(Me))return;let Qe=Ge.offset;return Qe>0&&Ge.prevCodePoint()===8205&&(Qe=Ge.offset),Qe}function it(Se){return 127995<=Se&&Se<=127999}var rt;(function(Se){Se[Se.zwj=8205]="zwj",Se[Se.emojiVariantSelector=65039]="emojiVariantSelector",Se[Se.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.$Sf="\xA0";class at{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Qe(Be=>{function Ge(Ne){const lt=new Map;for(let wt=0;wt<Ne.length;wt+=2)lt.set(Ne[wt],Ne[wt+1]);return lt}function Me(Ne,lt){const wt=new Map(Ne);for(const[At,zt]of lt)wt.set(At,zt);return wt}function Qe(Ne,lt){if(!Ne)return lt;const wt=new Map;for(const[At,zt]of Ne)lt.has(At)&&wt.set(At,zt);return wt}const oe=this.c.value;let ue=Be.filter(Ne=>!Ne.startsWith("_")&&Ne in oe);ue.length===0&&(ue=["_default"]);let Pe;for(const Ne of ue){const lt=Ge(oe[Ne]);Pe=Qe(Pe,lt)}const Ke=Ge(oe._common),_e=Me(Ke,Pe);return new at(_e)})}static getInstance(Be){return at.d.get(Array.from(Be))}static{this.e=new L.$V(()=>Object.keys(at.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return at.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Tf=at;class ot{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ot.c())),this.d}static isInvisibleCharacter(Be){return ot.e().has(Be)}static get codePoints(){return ot.e()}}e.$Uf=ot}),define(ke[126],Ee([1,0,27,165,14]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=A,e.$lk=b,e.$mk=$,e.$nk=I,e.$ok=h,e.$pk=g,e.$qk=P,e.$rk=z,e.$sk=F,e.$tk=T,e.$uk=ie,e.$wk=ce,e.$xk=te,e.$yk=le;function A(...me){return function(Ie,Re){for(let Fe=0,q=me.length;Fe<q;Fe++){const V=me[Fe](Ie,Re);if(V)return V}return null}}e.$jk=M.bind(void 0,!1),e.$kk=M.bind(void 0,!0);function M(me,Ie,Re){if(!Re||Re.length<Ie.length)return null;let Fe;return me?Fe=O.$mf(Re,Ie):Fe=Re.indexOf(Ie)===0,Fe?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function b(me,Ie){const Re=Ie.toLowerCase().indexOf(me.toLowerCase());return Re===-1?null:[{start:Re,end:Re+me.length}]}function $(me,Ie){return v(me.toLowerCase(),Ie.toLowerCase(),0,0)}function v(me,Ie,Re,Fe){if(Re===me.length)return[];if(Fe===Ie.length)return null;if(me[Re]===Ie[Fe]){let q=null;return(q=v(me,Ie,Re+1,Fe+1))?r({start:Fe,end:Fe+1},q):null}return v(me,Ie,Re,Fe+1)}function R(me){return 97<=me&&me<=122}function I(me){return 65<=me&&me<=90}function p(me){return 48<=me&&me<=57}function C(me){return me===32||me===9||me===10||me===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>k.add(me.charCodeAt(0)));function c(me){return C(me)||k.has(me)}function m(me,Ie){return me===Ie||c(me)&&c(Ie)}const o=new Map;function n(me){if(o.has(me))return o.get(me);let Ie;const Re=(0,L.$hk)(me);return Re&&(Ie=Re),o.set(me,Ie),Ie}function i(me){return R(me)||I(me)||p(me)}function r(me,Ie){return Ie.length===0?Ie=[me]:me.end===Ie[0].start?Ie[0].start=me.start:Ie.unshift(me),Ie}function s(me,Ie){for(let Re=Ie;Re<me.length;Re++){const Fe=me.charCodeAt(Re);if(I(Fe)||p(Fe)||Re>0&&!i(me.charCodeAt(Re-1)))return Re}return me.length}function t(me,Ie,Re,Fe){if(Re===me.length)return[];if(Fe===Ie.length)return null;if(me[Re]!==Ie[Fe].toLowerCase())return null;{let q=null,V=Fe+1;for(q=t(me,Ie,Re+1,Fe+1);!q&&(V=s(Ie,V))<Ie.length;)q=t(me,Ie,Re+1,V),V++;return q===null?null:r({start:Fe,end:Fe+1},q)}}function f(me){let Ie=0,Re=0,Fe=0,q=0,V=0;for(let Te=0;Te<me.length;Te++)V=me.charCodeAt(Te),I(V)&&Ie++,R(V)&&Re++,i(V)&&Fe++,p(V)&&q++;const X=Ie/me.length,Q=Re/me.length,fe=Fe/me.length,we=q/me.length;return{upperPercent:X,lowerPercent:Q,alphaPercent:fe,numericPercent:we}}function d(me){const{upperPercent:Ie,lowerPercent:Re}=me;return Re===0&&Ie>.6}function l(me){const{upperPercent:Ie,lowerPercent:Re,alphaPercent:Fe,numericPercent:q}=me;return Re>.2&&Ie<.8&&Fe>.6&&q<.2}function a(me){let Ie=0,Re=0,Fe=0,q=0;for(let V=0;V<me.length;V++)Fe=me.charCodeAt(V),I(Fe)&&Ie++,R(Fe)&&Re++,C(Fe)&&q++;return(Ie===0||Re===0)&&q===0?me.length<=30:Ie<=5}function h(me,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!a(me))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Re=f(Ie);if(!l(Re)){if(!d(Re))return null;Ie=Ie.toLowerCase()}let Fe=null,q=0;for(me=me.toLowerCase();q<Ie.length&&(Fe=t(me,Ie,0,q))===null;)q=s(Ie,q+1);return Fe}function g(me,Ie,Re=!1){if(!Ie||Ie.length===0)return null;let Fe=null,q=0;for(me=me.toLowerCase(),Ie=Ie.toLowerCase();q<Ie.length&&(Fe=S(me,Ie,0,q,Re),Fe===null);)q=w(Ie,q+1);return Fe}function S(me,Ie,Re,Fe,q){let V=0;if(Re===me.length)return[];if(Fe===Ie.length)return null;if(!m(me.charCodeAt(Re),Ie.charCodeAt(Fe))){const fe=n(me.charCodeAt(Re));if(!fe)return null;for(let we=0;we<fe.length;we++)if(!m(fe[we],Ie.charCodeAt(Fe+we)))return null;V+=fe.length-1}let X=null,Q=Fe+V+1;if(X=S(me,Ie,Re+1,Q,q),!q)for(;!X&&(Q=w(Ie,Q))<Ie.length;)X=S(me,Ie,Re+1,Q,q),Q++;if(!X)return null;if(me.charCodeAt(Re)!==Ie.charCodeAt(Fe)){const fe=n(me.charCodeAt(Re));if(!fe)return X;for(let we=0;we<fe.length;we++)if(fe[we]!==Ie.charCodeAt(Fe+we))return X}return r({start:Fe,end:Fe+V+1},X)}function w(me,Ie){for(let Re=Ie;Re<me.length;Re++)if(c(me.charCodeAt(Re))||Re>0&&c(me.charCodeAt(Re-1)))return Re;return me.length}const E=A(e.$kk,h,b),y=A(e.$kk,h,$),D=new u.$Ec(1e4);function P(me,Ie,Re=!1){if(typeof me!="string"||typeof Ie!="string")return null;let Fe=D.get(me);Fe||(Fe=new RegExp(O.$7e(me),"i"),D.set(me,Fe));const q=Fe.exec(Ie);return q?[{start:q.index,end:q.index+q[0].length}]:Re?y(me,Ie):E(me,Ie)}function z(me,Ie){const Re=ce(me,me.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?T(Re):null}function F(me,Ie,Re,Fe,q,V){const X=Math.min(13,me.length);for(;Re<X;Re++){const Q=ce(me,Ie,Re,Fe,q,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,V]}function T(me){if(typeof me>"u")return[];const Ie=[],Re=me[1];for(let Fe=me.length-1;Fe>1;Fe--){const q=me[Fe]+Re,V=Ie[Ie.length-1];V&&V.end===q?V.end=q+1:Ie.push({start:q,end:q+1})}return Ie}const j=128;function N(){const me=[],Ie=[];for(let Re=0;Re<=j;Re++)Ie[Re]=0;for(let Re=0;Re<=j;Re++)me.push(Ie.slice(0));return me}function B(me){const Ie=[];for(let Re=0;Re<=me;Re++)Ie[Re]=0;return Ie}const W=B(2*j),Y=B(2*j),_=N(),J=N(),Z=N(),re=!1;function ee(me,Ie,Re,Fe,q){function V(Q,fe,we=" "){for(;Q.length<fe;)Q=we+Q;return Q}let X=` |   |${Fe.split("").map(Q=>V(Q,3)).join("|")}
`;for(let Q=0;Q<=Re;Q++)Q===0?X+=" |":X+=`${Ie[Q-1]}|`,X+=me[Q].slice(0,q+1).map(fe=>V(fe.toString(),3)).join("|")+`
`;return X}function pe(me,Ie,Re,Fe){me=me.substr(Ie),Re=Re.substr(Fe),console.log(ee(J,me,me.length,Re,Re.length)),console.log(ee(Z,me,me.length,Re,Re.length)),console.log(ee(_,me,me.length,Re,Re.length))}function De(me,Ie){if(Ie<0||Ie>=me.length)return!1;const Re=me.codePointAt(Ie);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$Ef(Re)}}function x(me,Ie){if(Ie<0||Ie>=me.length)return!1;switch(me.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function U(me,Ie,Re){return Ie[me]!==Re[me]}function ie(me,Ie,Re,Fe,q,V,X=!1){for(;Ie<Re&&q<V;)me[Ie]===Fe[q]&&(X&&(W[Ie]=q),Ie+=1),q+=1;return Ie===Re}var be;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(be||(be={}));var Ce;(function(me){me.Default=[-100,0];function Ie(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}me.isDefault=Ie})(Ce||(e.FuzzyScore=Ce={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Re){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Re}}e.$vk=ae;function ce(me,Ie,Re,Fe,q,V,X=ae.default){const Q=me.length>j?j:me.length,fe=Fe.length>j?j:Fe.length;if(Re>=Q||V>=fe||Q-Re>fe-V||!ie(Ie,Re,Q,q,V,fe,!0))return;se(Q,fe,Re,V,Ie,q);let we=1,Te=1,He=Re,xe=V;const it=[!1];for(we=1,He=Re;He<Q;we++,He++){const Be=W[He],Ge=Y[He],Me=He+1<Q?Y[He+1]:fe;for(Te=Be-V+1,xe=Be;xe<Me;Te++,xe++){let Qe=Number.MIN_SAFE_INTEGER,oe=!1;xe<=Ge&&(Qe=K(me,Ie,He,Re,Fe,q,xe,fe,V,_[we-1][Te-1]===0,it));let ue=0;Qe!==Number.MAX_SAFE_INTEGER&&(oe=!0,ue=Qe+J[we-1][Te-1]);const Pe=xe>Be,Ke=Pe?J[we][Te-1]+(_[we][Te-1]>0?-5:0):0,_e=xe>Be+1&&_[we][Te-1]>0,Ne=_e?J[we][Te-2]+(_[we][Te-2]>0?-5:0):0;if(_e&&(!Pe||Ne>=Ke)&&(!oe||Ne>=ue))J[we][Te]=Ne,Z[we][Te]=3,_[we][Te]=0;else if(Pe&&(!oe||Ke>=ue))J[we][Te]=Ke,Z[we][Te]=2,_[we][Te]=0;else if(oe)J[we][Te]=ue,Z[we][Te]=1,_[we][Te]=_[we-1][Te-1]+1;else throw new Error("not possible")}}if(re&&pe(me,Re,Fe,V),!it[0]&&!X.firstMatchCanBeWeak)return;we--,Te--;const rt=[J[we][Te],V];let at=0,ot=0;for(;we>=1;){let Be=Te;do{const Ge=Z[we][Be];if(Ge===3)Be=Be-2;else if(Ge===2)Be=Be-1;else break}while(Be>=1);at>1&&Ie[Re+we-1]===q[V+Te-1]&&!U(Be+V-1,Fe,q)&&at+1>_[we][Be]&&(Be=Te),Be===Te?at++:at=1,ot||(ot=Be),we--,Te=Be-1,rt.push(Te)}fe===Q&&X.boostFullMatch&&(rt[0]+=2);const Se=ot-Q;return rt[0]-=Se,rt}function se(me,Ie,Re,Fe,q,V){let X=me-1,Q=Ie-1;for(;X>=Re&&Q>=Fe;)q[X]===V[Q]&&(Y[X]=Q,X--),Q--}function K(me,Ie,Re,Fe,q,V,X,Q,fe,we,Te){if(Ie[Re]!==V[X])return Number.MIN_SAFE_INTEGER;let He=1,xe=!1;return X===Re-Fe?He=me[Re]===q[X]?7:5:U(X,q,V)&&(X===0||!U(X-1,q,V))?(He=me[Re]===q[X]?7:5,xe=!0):De(V,X)&&(X===0||!De(V,X-1))?He=5:(De(V,X-1)||x(V,X-1))&&(He=5,xe=!0),He>1&&Re===Fe&&(Te[0]=!0),xe||(xe=U(X,q,V)||De(V,X-1)||x(V,X-1)),Re===Fe?X>fe&&(He-=xe?3:5):we?He+=xe?2:0:He+=xe?0:1,X+1===Q&&(He-=xe?3:5),He}function te(me,Ie,Re,Fe,q,V,X){return de(me,Ie,Re,Fe,q,V,!0,X)}function le(me,Ie,Re,Fe,q,V,X){return de(me,Ie,Re,Fe,q,V,!1,X)}function de(me,Ie,Re,Fe,q,V,X,Q){let fe=ce(me,Ie,Re,Fe,q,V,Q);if(fe&&!X)return fe;if(me.length>=3){const we=Math.min(7,me.length-1);for(let Te=Re+1;Te<we;Te++){const He=Ae(me,Te);if(He){const xe=ce(He,He.toLowerCase(),Re,Fe,q,V,Q);xe&&(xe[0]-=3,(!fe||xe[0]>fe[0])&&(fe=xe))}}}return fe}function Ae(me,Ie){if(Ie+1>=me.length)return;const Re=me[Ie],Fe=me[Ie+1];if(Re!==Fe)return me.slice(0,Ie)+Fe+Re+me.slice(Ie+2)}}),define(ke[55],Ee([1,0,14]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=L,e.$0i=O,e.$$i=A,e.$_i=b,e.$bj=c;function L(o){return O(o,0)}function O(o,n){switch(typeof o){case"object":return o===null?A(349,n):Array.isArray(o)?$(o,n):v(o,n);case"string":return b(o,n);case"boolean":return M(o,n);case"number":return A(o,n);case"undefined":return A(937,n);default:return A(617,n)}}function A(o,n){return(n<<5)-n+o|0}function M(o,n){return A(o?433:863,n)}function b(o,n){n=A(149417,n);for(let i=0,r=o.length;i<r;i++)n=A(o.charCodeAt(i),n);return n}function $(o,n){return n=A(104579,n),o.reduce((i,r)=>O(r,i),n)}function v(o,n){return n=A(181387,n),Object.keys(o).sort().reduce((i,r)=>(i=b(r,i),O(o[r],i)),n)}class R{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=O(n,this.g),this.g}}e.$aj=R;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(o,n,i=32){const r=i-n,s=~((1<<r)-1);return(o<<n|(s&o)>>>r)>>>0}function C(o,n=0,i=o.byteLength,r=0){for(let s=0;s<i;s++)o[n+s]=r}function k(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function c(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):k((o>>>0).toString(16),n/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let s=this.r,t=this.u,f,d;for(t!==0?(f=t,d=-1,t=0):(f=n.charCodeAt(0),d=0);;){let l=f;if(u.$pf(f))if(d+1<i){const a=n.charCodeAt(d+1);u.$qf(a)?(d++,l=u.$rf(f,a)):l=65533}else{t=f;break}else u.$qf(f)&&(l=65533);if(s=this.w(r,s,l),d++,d<i)f=n.charCodeAt(d);else break}this.r=s,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=m.g,i=this.q;for(let g=0;g<64;g+=4)n.setUint32(g,i.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)n.setUint32(g,p(n.getUint32(g-12,!1)^n.getUint32(g-32,!1)^n.getUint32(g-56,!1)^n.getUint32(g-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,f=this.n,d=this.o,l,a,h;for(let g=0;g<80;g++)g<20?(l=s&t|~s&f,a=1518500249):g<40?(l=s^t^f,a=1859775393):g<60?(l=s&t|s&f|t&f,a=2400959708):(l=s^t^f,a=3395469782),h=p(r,5)+l+d+a+n.getUint32(g*4,!1)&4294967295,d=f,f=t,t=p(s,30),s=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+d&4294967295}}e.$cj=m}),define(ke[40],Ee([1,0,14]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(L||(L={})),function(O){const A="error",M="warning",b="warn",$="info",v="ignore";function R(p){return p?u.$lf(A,p)?O.Error:u.$lf(M,p)||u.$lf(b,p)?O.Warning:u.$lf($,p)?O.Info:O.Ignore:O.Ignore}O.fromValue=R;function I(p){switch(p){case O.Error:return A;case O.Warning:return M;case O.Info:return $;default:return v}}O.toString=I}(L||(L={})),e.default=L}),define(ke[168],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(ke[77],Ee([1,0,19,14]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class O{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const k=C.charCodeAt(0),c=this.b.charCodeAt(this.c);return k-c}value(){return this.b[this.c]}}e.$ki=O;class A{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,L.$ff)(C,this.b,0,C.length,this.c,this.d):(0,L.$hf)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=A;class M{constructor(C=!0,k=!0){this.f=C,this.g=k}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let k=C.length-1;k>=0;k--,this.c--){const c=this.b.charCodeAt(k);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,L.$ff)(C,this.b,0,C.length,this.d,this.e):(0,L.$hf)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=M;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(C,k){this.f=C,this.g=k,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,L.$gf)(C,this.c.scheme);if(this.d[this.e]===2)return(0,L.$gf)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,L.$ef)(C,this.c.query);if(this.d[this.e]===5)return(0,L.$ef)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=$;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(R||(R={}));class I{static forUris(C=()=>!1,k=()=>!1){return new I(new $(C,k))}static forPaths(C=!1){return new I(new M(void 0,!C))}static forStrings(){return new I(new O)}static forConfigKeys(){return new I(new A)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,k){if(k){const c=k.slice(0);(0,u.$Xb)(c);for(const m of c)this.set(m,C)}else{const c=C.slice(0);(0,u.$Xb)(c);for(const m of c)this.set(m[0],m[1])}}set(C,k){const c=this.b.reset(C);let m;this.c||(this.c=new v,this.c.segment=c.value());const o=[];for(m=this.c;;){const i=c.cmp(m.segment);if(i>0)m.left||(m.left=new v,m.left.segment=c.value()),o.push([-1,m]),m=m.left;else if(i<0)m.right||(m.right=new v,m.right.segment=c.value()),o.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new v,m.mid.segment=c.value()),o.push([0,m]),m=m.mid;else break}const n=m.value;m.value=k,m.key=C;for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=o[i][0],f=o[i+1][0];if(t===1&&f===1)o[i][1]=r.rotateLeft();else if(t===-1&&f===-1)o[i][1]=r.rotateRight();else if(t===1&&f===-1)r.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(C){return this.d(C)?.value}d(C){const k=this.b.reset(C);let c=this.c;for(;c;){const m=k.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(k.hasNext())k.next(),c=c.mid;else break}return c}has(C){const k=this.d(C);return!(k?.value===void 0&&k?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,k){const c=this.b.reset(C),m=[];let o=this.c;for(;o;){const n=c.cmp(o.segment);if(n>0)m.push([-1,o]),o=o.left;else if(n<0)m.push([1,o]),o=o.right;else if(c.hasNext())c.next(),m.push([0,o]),o=o.mid;else break}if(o){if(k?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:r,segment:s}=n;this.e(n.key,!1),o.key=i,o.value=r,o.segment=s}}else{const n=o.left??o.right;if(m.length>0){const[i,r]=m[m.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=m.length-1;n>=0;n--){const i=m[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),m[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),m[n][1]=i.rotateRight()),n>0)switch(m[n-1][0]){case-1:m[n-1][1].left=m[n][1];break;case 1:m[n-1][1].right=m[n][1];break;case 0:m[n-1][1].mid=m[n][1];break}else this.c=m[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const k=this.b.reset(C);let c=this.c,m;for(;c;){const o=k.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(k.hasNext())k.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(C){return this.g(C,!1)}g(C,k){const c=this.b.reset(C);let m=this.c;for(;m;){const o=c.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this.h(m.mid):k?m.value:void 0}}hasElementOrSubtree(C){return this.g(C,!0)!==void 0}forEach(C){for(const[k,c]of this)C(c,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(C){const k=[];return this.j(C,k),k[Symbol.iterator]()}j(C,k){C&&(C.left&&this.j(C.left,k),C.value&&k.push([C.key,C.value]),C.mid&&this.j(C.mid,k),C.right&&this.j(C.right,k))}_isBalanced(){const C=k=>{if(!k)return!0;const c=k.balanceFactor();return c<-1||c>1?!1:C(k.left)&&C(k.right)};return C(this.c)}}e.$oi=I}),define(ke[18],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=u,e.$Wf=L,e.$Xf=O,e.$Yf=A,e.$Zf=M,e.$1f=b,e.$2f=$,e.$3f=v,e.$4f=R,e.$5f=I,e.$6f=p,e.$7f=C,e.$8f=k,e.$9f=m,e.$0f=o,e.$$f=n,e.$_f=i,e.$ag=r;function u(s){return typeof s=="string"}function L(s){return Array.isArray(s)&&s.every(t=>u(t))}function O(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function A(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function M(s){return typeof s=="number"&&!isNaN(s)}function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}function $(s){return s===!0||s===!1}function v(s){return typeof s>"u"}function R(s){return!I(s)}function I(s){return v(s)||s===null}function p(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function C(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function k(...s){const t=[];for(let f=0;f<s.length;f++){const d=s[f];if(I(d))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(d)}return t}const c=Object.prototype.hasOwnProperty;function m(s){if(!O(s))return!1;for(const t in s)if(c.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const f=Math.min(s.length,t.length);for(let d=0;d<f;d++)r(s[d],t[d])}function r(s,t){if(u(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!I(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=O,e.$Dj=A;const L=Object.create(null);function O(M,b){if((0,u.$Vf)(b)){const $=L[b];if($===void 0)throw new Error(`${M} references an unknown codicon: ${b}`);b=$}return L[M]=b,{id:M}}function A(){return L}}),define(ke[169],Ee([1,0,99]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=void 0,e.$Ej={add:(0,u.$Cj)("add",6e4),plus:(0,u.$Cj)("plus",6e4),gistNew:(0,u.$Cj)("gist-new",6e4),repoCreate:(0,u.$Cj)("repo-create",6e4),lightbulb:(0,u.$Cj)("lightbulb",60001),lightBulb:(0,u.$Cj)("light-bulb",60001),repo:(0,u.$Cj)("repo",60002),repoDelete:(0,u.$Cj)("repo-delete",60002),gistFork:(0,u.$Cj)("gist-fork",60003),repoForked:(0,u.$Cj)("repo-forked",60003),gitPullRequest:(0,u.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Cj)("record-keys",60005),keyboard:(0,u.$Cj)("keyboard",60005),tag:(0,u.$Cj)("tag",60006),gitPullRequestLabel:(0,u.$Cj)("git-pull-request-label",60006),tagAdd:(0,u.$Cj)("tag-add",60006),tagRemove:(0,u.$Cj)("tag-remove",60006),person:(0,u.$Cj)("person",60007),personFollow:(0,u.$Cj)("person-follow",60007),personOutline:(0,u.$Cj)("person-outline",60007),personFilled:(0,u.$Cj)("person-filled",60007),gitBranch:(0,u.$Cj)("git-branch",60008),gitBranchCreate:(0,u.$Cj)("git-branch-create",60008),gitBranchDelete:(0,u.$Cj)("git-branch-delete",60008),sourceControl:(0,u.$Cj)("source-control",60008),mirror:(0,u.$Cj)("mirror",60009),mirrorPublic:(0,u.$Cj)("mirror-public",60009),star:(0,u.$Cj)("star",60010),starAdd:(0,u.$Cj)("star-add",60010),starDelete:(0,u.$Cj)("star-delete",60010),starEmpty:(0,u.$Cj)("star-empty",60010),comment:(0,u.$Cj)("comment",60011),commentAdd:(0,u.$Cj)("comment-add",60011),alert:(0,u.$Cj)("alert",60012),warning:(0,u.$Cj)("warning",60012),search:(0,u.$Cj)("search",60013),searchSave:(0,u.$Cj)("search-save",60013),logOut:(0,u.$Cj)("log-out",60014),signOut:(0,u.$Cj)("sign-out",60014),logIn:(0,u.$Cj)("log-in",60015),signIn:(0,u.$Cj)("sign-in",60015),eye:(0,u.$Cj)("eye",60016),eyeUnwatch:(0,u.$Cj)("eye-unwatch",60016),eyeWatch:(0,u.$Cj)("eye-watch",60016),circleFilled:(0,u.$Cj)("circle-filled",60017),primitiveDot:(0,u.$Cj)("primitive-dot",60017),closeDirty:(0,u.$Cj)("close-dirty",60017),debugBreakpoint:(0,u.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Cj)("primitive-square",60018),edit:(0,u.$Cj)("edit",60019),pencil:(0,u.$Cj)("pencil",60019),info:(0,u.$Cj)("info",60020),issueOpened:(0,u.$Cj)("issue-opened",60020),gistPrivate:(0,u.$Cj)("gist-private",60021),gitForkPrivate:(0,u.$Cj)("git-fork-private",60021),lock:(0,u.$Cj)("lock",60021),mirrorPrivate:(0,u.$Cj)("mirror-private",60021),close:(0,u.$Cj)("close",60022),removeClose:(0,u.$Cj)("remove-close",60022),x:(0,u.$Cj)("x",60022),repoSync:(0,u.$Cj)("repo-sync",60023),sync:(0,u.$Cj)("sync",60023),clone:(0,u.$Cj)("clone",60024),desktopDownload:(0,u.$Cj)("desktop-download",60024),beaker:(0,u.$Cj)("beaker",60025),microscope:(0,u.$Cj)("microscope",60025),vm:(0,u.$Cj)("vm",60026),deviceDesktop:(0,u.$Cj)("device-desktop",60026),file:(0,u.$Cj)("file",60027),fileText:(0,u.$Cj)("file-text",60027),more:(0,u.$Cj)("more",60028),ellipsis:(0,u.$Cj)("ellipsis",60028),kebabHorizontal:(0,u.$Cj)("kebab-horizontal",60028),mailReply:(0,u.$Cj)("mail-reply",60029),reply:(0,u.$Cj)("reply",60029),organization:(0,u.$Cj)("organization",60030),organizationFilled:(0,u.$Cj)("organization-filled",60030),organizationOutline:(0,u.$Cj)("organization-outline",60030),newFile:(0,u.$Cj)("new-file",60031),fileAdd:(0,u.$Cj)("file-add",60031),newFolder:(0,u.$Cj)("new-folder",60032),fileDirectoryCreate:(0,u.$Cj)("file-directory-create",60032),trash:(0,u.$Cj)("trash",60033),trashcan:(0,u.$Cj)("trashcan",60033),history:(0,u.$Cj)("history",60034),clock:(0,u.$Cj)("clock",60034),folder:(0,u.$Cj)("folder",60035),fileDirectory:(0,u.$Cj)("file-directory",60035),symbolFolder:(0,u.$Cj)("symbol-folder",60035),logoGithub:(0,u.$Cj)("logo-github",60036),markGithub:(0,u.$Cj)("mark-github",60036),github:(0,u.$Cj)("github",60036),terminal:(0,u.$Cj)("terminal",60037),console:(0,u.$Cj)("console",60037),repl:(0,u.$Cj)("repl",60037),zap:(0,u.$Cj)("zap",60038),symbolEvent:(0,u.$Cj)("symbol-event",60038),error:(0,u.$Cj)("error",60039),stop:(0,u.$Cj)("stop",60039),variable:(0,u.$Cj)("variable",60040),symbolVariable:(0,u.$Cj)("symbol-variable",60040),array:(0,u.$Cj)("array",60042),symbolArray:(0,u.$Cj)("symbol-array",60042),symbolModule:(0,u.$Cj)("symbol-module",60043),symbolPackage:(0,u.$Cj)("symbol-package",60043),symbolNamespace:(0,u.$Cj)("symbol-namespace",60043),symbolObject:(0,u.$Cj)("symbol-object",60043),symbolMethod:(0,u.$Cj)("symbol-method",60044),symbolFunction:(0,u.$Cj)("symbol-function",60044),symbolConstructor:(0,u.$Cj)("symbol-constructor",60044),symbolBoolean:(0,u.$Cj)("symbol-boolean",60047),symbolNull:(0,u.$Cj)("symbol-null",60047),symbolNumeric:(0,u.$Cj)("symbol-numeric",60048),symbolNumber:(0,u.$Cj)("symbol-number",60048),symbolStructure:(0,u.$Cj)("symbol-structure",60049),symbolStruct:(0,u.$Cj)("symbol-struct",60049),symbolParameter:(0,u.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Cj)("symbol-type-parameter",60050),symbolKey:(0,u.$Cj)("symbol-key",60051),symbolText:(0,u.$Cj)("symbol-text",60051),symbolReference:(0,u.$Cj)("symbol-reference",60052),goToFile:(0,u.$Cj)("go-to-file",60052),symbolEnum:(0,u.$Cj)("symbol-enum",60053),symbolValue:(0,u.$Cj)("symbol-value",60053),symbolRuler:(0,u.$Cj)("symbol-ruler",60054),symbolUnit:(0,u.$Cj)("symbol-unit",60054),activateBreakpoints:(0,u.$Cj)("activate-breakpoints",60055),archive:(0,u.$Cj)("archive",60056),arrowBoth:(0,u.$Cj)("arrow-both",60057),arrowDown:(0,u.$Cj)("arrow-down",60058),arrowLeft:(0,u.$Cj)("arrow-left",60059),arrowRight:(0,u.$Cj)("arrow-right",60060),arrowSmallDown:(0,u.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Cj)("arrow-small-up",60064),arrowUp:(0,u.$Cj)("arrow-up",60065),bell:(0,u.$Cj)("bell",60066),bold:(0,u.$Cj)("bold",60067),book:(0,u.$Cj)("book",60068),bookmark:(0,u.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Cj)("briefcase",60076),broadcast:(0,u.$Cj)("broadcast",60077),browser:(0,u.$Cj)("browser",60078),bug:(0,u.$Cj)("bug",60079),calendar:(0,u.$Cj)("calendar",60080),caseSensitive:(0,u.$Cj)("case-sensitive",60081),check:(0,u.$Cj)("check",60082),checklist:(0,u.$Cj)("checklist",60083),chevronDown:(0,u.$Cj)("chevron-down",60084),chevronLeft:(0,u.$Cj)("chevron-left",60085),chevronRight:(0,u.$Cj)("chevron-right",60086),chevronUp:(0,u.$Cj)("chevron-up",60087),chromeClose:(0,u.$Cj)("chrome-close",60088),chromeMaximize:(0,u.$Cj)("chrome-maximize",60089),chromeMinimize:(0,u.$Cj)("chrome-minimize",60090),chromeRestore:(0,u.$Cj)("chrome-restore",60091),circleOutline:(0,u.$Cj)("circle-outline",60092),circle:(0,u.$Cj)("circle",60092),debugBreakpointUnverified:(0,u.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Cj)("circle-slash",60093),circuitBoard:(0,u.$Cj)("circuit-board",60094),clearAll:(0,u.$Cj)("clear-all",60095),clippy:(0,u.$Cj)("clippy",60096),closeAll:(0,u.$Cj)("close-all",60097),cloudDownload:(0,u.$Cj)("cloud-download",60098),cloudUpload:(0,u.$Cj)("cloud-upload",60099),code:(0,u.$Cj)("code",60100),collapseAll:(0,u.$Cj)("collapse-all",60101),colorMode:(0,u.$Cj)("color-mode",60102),commentDiscussion:(0,u.$Cj)("comment-discussion",60103),creditCard:(0,u.$Cj)("credit-card",60105),dash:(0,u.$Cj)("dash",60108),dashboard:(0,u.$Cj)("dashboard",60109),database:(0,u.$Cj)("database",60110),debugContinue:(0,u.$Cj)("debug-continue",60111),debugDisconnect:(0,u.$Cj)("debug-disconnect",60112),debugPause:(0,u.$Cj)("debug-pause",60113),debugRestart:(0,u.$Cj)("debug-restart",60114),debugStart:(0,u.$Cj)("debug-start",60115),debugStepInto:(0,u.$Cj)("debug-step-into",60116),debugStepOut:(0,u.$Cj)("debug-step-out",60117),debugStepOver:(0,u.$Cj)("debug-step-over",60118),debugStop:(0,u.$Cj)("debug-stop",60119),debug:(0,u.$Cj)("debug",60120),deviceCameraVideo:(0,u.$Cj)("device-camera-video",60121),deviceCamera:(0,u.$Cj)("device-camera",60122),deviceMobile:(0,u.$Cj)("device-mobile",60123),diffAdded:(0,u.$Cj)("diff-added",60124),diffIgnored:(0,u.$Cj)("diff-ignored",60125),diffModified:(0,u.$Cj)("diff-modified",60126),diffRemoved:(0,u.$Cj)("diff-removed",60127),diffRenamed:(0,u.$Cj)("diff-renamed",60128),diff:(0,u.$Cj)("diff",60129),diffSidebyside:(0,u.$Cj)("diff-sidebyside",60129),discard:(0,u.$Cj)("discard",60130),editorLayout:(0,u.$Cj)("editor-layout",60131),emptyWindow:(0,u.$Cj)("empty-window",60132),exclude:(0,u.$Cj)("exclude",60133),extensions:(0,u.$Cj)("extensions",60134),eyeClosed:(0,u.$Cj)("eye-closed",60135),fileBinary:(0,u.$Cj)("file-binary",60136),fileCode:(0,u.$Cj)("file-code",60137),fileMedia:(0,u.$Cj)("file-media",60138),filePdf:(0,u.$Cj)("file-pdf",60139),fileSubmodule:(0,u.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Cj)("file-symlink-file",60142),fileZip:(0,u.$Cj)("file-zip",60143),files:(0,u.$Cj)("files",60144),filter:(0,u.$Cj)("filter",60145),flame:(0,u.$Cj)("flame",60146),foldDown:(0,u.$Cj)("fold-down",60147),foldUp:(0,u.$Cj)("fold-up",60148),fold:(0,u.$Cj)("fold",60149),folderActive:(0,u.$Cj)("folder-active",60150),folderOpened:(0,u.$Cj)("folder-opened",60151),gear:(0,u.$Cj)("gear",60152),gift:(0,u.$Cj)("gift",60153),gistSecret:(0,u.$Cj)("gist-secret",60154),gist:(0,u.$Cj)("gist",60155),gitCommit:(0,u.$Cj)("git-commit",60156),gitCompare:(0,u.$Cj)("git-compare",60157),compareChanges:(0,u.$Cj)("compare-changes",60157),gitMerge:(0,u.$Cj)("git-merge",60158),githubAction:(0,u.$Cj)("github-action",60159),githubAlt:(0,u.$Cj)("github-alt",60160),globe:(0,u.$Cj)("globe",60161),grabber:(0,u.$Cj)("grabber",60162),graph:(0,u.$Cj)("graph",60163),gripper:(0,u.$Cj)("gripper",60164),heart:(0,u.$Cj)("heart",60165),home:(0,u.$Cj)("home",60166),horizontalRule:(0,u.$Cj)("horizontal-rule",60167),hubot:(0,u.$Cj)("hubot",60168),inbox:(0,u.$Cj)("inbox",60169),issueReopened:(0,u.$Cj)("issue-reopened",60171),issues:(0,u.$Cj)("issues",60172),italic:(0,u.$Cj)("italic",60173),jersey:(0,u.$Cj)("jersey",60174),json:(0,u.$Cj)("json",60175),kebabVertical:(0,u.$Cj)("kebab-vertical",60176),key:(0,u.$Cj)("key",60177),law:(0,u.$Cj)("law",60178),lightbulbAutofix:(0,u.$Cj)("lightbulb-autofix",60179),linkExternal:(0,u.$Cj)("link-external",60180),link:(0,u.$Cj)("link",60181),listOrdered:(0,u.$Cj)("list-ordered",60182),listUnordered:(0,u.$Cj)("list-unordered",60183),liveShare:(0,u.$Cj)("live-share",60184),loading:(0,u.$Cj)("loading",60185),location:(0,u.$Cj)("location",60186),mailRead:(0,u.$Cj)("mail-read",60187),mail:(0,u.$Cj)("mail",60188),markdown:(0,u.$Cj)("markdown",60189),megaphone:(0,u.$Cj)("megaphone",60190),mention:(0,u.$Cj)("mention",60191),milestone:(0,u.$Cj)("milestone",60192),gitPullRequestMilestone:(0,u.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Cj)("mortar-board",60193),move:(0,u.$Cj)("move",60194),multipleWindows:(0,u.$Cj)("multiple-windows",60195),mute:(0,u.$Cj)("mute",60196),noNewline:(0,u.$Cj)("no-newline",60197),note:(0,u.$Cj)("note",60198),octoface:(0,u.$Cj)("octoface",60199),openPreview:(0,u.$Cj)("open-preview",60200),package:(0,u.$Cj)("package",60201),paintcan:(0,u.$Cj)("paintcan",60202),pin:(0,u.$Cj)("pin",60203),play:(0,u.$Cj)("play",60204),run:(0,u.$Cj)("run",60204),plug:(0,u.$Cj)("plug",60205),preserveCase:(0,u.$Cj)("preserve-case",60206),preview:(0,u.$Cj)("preview",60207),project:(0,u.$Cj)("project",60208),pulse:(0,u.$Cj)("pulse",60209),question:(0,u.$Cj)("question",60210),quote:(0,u.$Cj)("quote",60211),radioTower:(0,u.$Cj)("radio-tower",60212),reactions:(0,u.$Cj)("reactions",60213),references:(0,u.$Cj)("references",60214),refresh:(0,u.$Cj)("refresh",60215),regex:(0,u.$Cj)("regex",60216),remoteExplorer:(0,u.$Cj)("remote-explorer",60217),remote:(0,u.$Cj)("remote",60218),remove:(0,u.$Cj)("remove",60219),replaceAll:(0,u.$Cj)("replace-all",60220),replace:(0,u.$Cj)("replace",60221),repoClone:(0,u.$Cj)("repo-clone",60222),repoForcePush:(0,u.$Cj)("repo-force-push",60223),repoPull:(0,u.$Cj)("repo-pull",60224),repoPush:(0,u.$Cj)("repo-push",60225),report:(0,u.$Cj)("report",60226),requestChanges:(0,u.$Cj)("request-changes",60227),rocket:(0,u.$Cj)("rocket",60228),rootFolderOpened:(0,u.$Cj)("root-folder-opened",60229),rootFolder:(0,u.$Cj)("root-folder",60230),rss:(0,u.$Cj)("rss",60231),ruby:(0,u.$Cj)("ruby",60232),saveAll:(0,u.$Cj)("save-all",60233),saveAs:(0,u.$Cj)("save-as",60234),save:(0,u.$Cj)("save",60235),screenFull:(0,u.$Cj)("screen-full",60236),screenNormal:(0,u.$Cj)("screen-normal",60237),searchStop:(0,u.$Cj)("search-stop",60238),server:(0,u.$Cj)("server",60240),settingsGear:(0,u.$Cj)("settings-gear",60241),settings:(0,u.$Cj)("settings",60242),shield:(0,u.$Cj)("shield",60243),smiley:(0,u.$Cj)("smiley",60244),sortPrecedence:(0,u.$Cj)("sort-precedence",60245),splitHorizontal:(0,u.$Cj)("split-horizontal",60246),splitVertical:(0,u.$Cj)("split-vertical",60247),squirrel:(0,u.$Cj)("squirrel",60248),starFull:(0,u.$Cj)("star-full",60249),starHalf:(0,u.$Cj)("star-half",60250),symbolClass:(0,u.$Cj)("symbol-class",60251),symbolColor:(0,u.$Cj)("symbol-color",60252),symbolConstant:(0,u.$Cj)("symbol-constant",60253),symbolEnumMember:(0,u.$Cj)("symbol-enum-member",60254),symbolField:(0,u.$Cj)("symbol-field",60255),symbolFile:(0,u.$Cj)("symbol-file",60256),symbolInterface:(0,u.$Cj)("symbol-interface",60257),symbolKeyword:(0,u.$Cj)("symbol-keyword",60258),symbolMisc:(0,u.$Cj)("symbol-misc",60259),symbolOperator:(0,u.$Cj)("symbol-operator",60260),symbolProperty:(0,u.$Cj)("symbol-property",60261),wrench:(0,u.$Cj)("wrench",60261),wrenchSubaction:(0,u.$Cj)("wrench-subaction",60261),symbolSnippet:(0,u.$Cj)("symbol-snippet",60262),tasklist:(0,u.$Cj)("tasklist",60263),telescope:(0,u.$Cj)("telescope",60264),textSize:(0,u.$Cj)("text-size",60265),threeBars:(0,u.$Cj)("three-bars",60266),thumbsdown:(0,u.$Cj)("thumbsdown",60267),thumbsup:(0,u.$Cj)("thumbsup",60268),tools:(0,u.$Cj)("tools",60269),triangleDown:(0,u.$Cj)("triangle-down",60270),triangleLeft:(0,u.$Cj)("triangle-left",60271),triangleRight:(0,u.$Cj)("triangle-right",60272),triangleUp:(0,u.$Cj)("triangle-up",60273),twitter:(0,u.$Cj)("twitter",60274),unfold:(0,u.$Cj)("unfold",60275),unlock:(0,u.$Cj)("unlock",60276),unmute:(0,u.$Cj)("unmute",60277),unverified:(0,u.$Cj)("unverified",60278),verified:(0,u.$Cj)("verified",60279),versions:(0,u.$Cj)("versions",60280),vmActive:(0,u.$Cj)("vm-active",60281),vmOutline:(0,u.$Cj)("vm-outline",60282),vmRunning:(0,u.$Cj)("vm-running",60283),watch:(0,u.$Cj)("watch",60284),whitespace:(0,u.$Cj)("whitespace",60285),wholeWord:(0,u.$Cj)("whole-word",60286),window:(0,u.$Cj)("window",60287),wordWrap:(0,u.$Cj)("word-wrap",60288),zoomIn:(0,u.$Cj)("zoom-in",60289),zoomOut:(0,u.$Cj)("zoom-out",60290),listFilter:(0,u.$Cj)("list-filter",60291),listFlat:(0,u.$Cj)("list-flat",60292),listSelection:(0,u.$Cj)("list-selection",60293),selection:(0,u.$Cj)("selection",60293),listTree:(0,u.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Cj)("symbol-string",60301),debugReverseContinue:(0,u.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Cj)("debug-step-back",60303),debugRestartFrame:(0,u.$Cj)("debug-restart-frame",60304),debugAlt:(0,u.$Cj)("debug-alt",60305),callIncoming:(0,u.$Cj)("call-incoming",60306),callOutgoing:(0,u.$Cj)("call-outgoing",60307),menu:(0,u.$Cj)("menu",60308),expandAll:(0,u.$Cj)("expand-all",60309),feedback:(0,u.$Cj)("feedback",60310),gitPullRequestReviewer:(0,u.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Cj)("ungroup-by-ref-type",60312),account:(0,u.$Cj)("account",60313),gitPullRequestAssignee:(0,u.$Cj)("git-pull-request-assignee",60313),bellDot:(0,u.$Cj)("bell-dot",60314),debugConsole:(0,u.$Cj)("debug-console",60315),library:(0,u.$Cj)("library",60316),output:(0,u.$Cj)("output",60317),runAll:(0,u.$Cj)("run-all",60318),syncIgnored:(0,u.$Cj)("sync-ignored",60319),pinned:(0,u.$Cj)("pinned",60320),githubInverted:(0,u.$Cj)("github-inverted",60321),serverProcess:(0,u.$Cj)("server-process",60322),serverEnvironment:(0,u.$Cj)("server-environment",60323),pass:(0,u.$Cj)("pass",60324),issueClosed:(0,u.$Cj)("issue-closed",60324),stopCircle:(0,u.$Cj)("stop-circle",60325),playCircle:(0,u.$Cj)("play-circle",60326),record:(0,u.$Cj)("record",60327),debugAltSmall:(0,u.$Cj)("debug-alt-small",60328),vmConnect:(0,u.$Cj)("vm-connect",60329),cloud:(0,u.$Cj)("cloud",60330),merge:(0,u.$Cj)("merge",60331),export:(0,u.$Cj)("export",60332),graphLeft:(0,u.$Cj)("graph-left",60333),magnet:(0,u.$Cj)("magnet",60334),notebook:(0,u.$Cj)("notebook",60335),redo:(0,u.$Cj)("redo",60336),checkAll:(0,u.$Cj)("check-all",60337),pinnedDirty:(0,u.$Cj)("pinned-dirty",60338),passFilled:(0,u.$Cj)("pass-filled",60339),circleLargeFilled:(0,u.$Cj)("circle-large-filled",60340),circleLarge:(0,u.$Cj)("circle-large",60341),circleLargeOutline:(0,u.$Cj)("circle-large-outline",60341),combine:(0,u.$Cj)("combine",60342),gather:(0,u.$Cj)("gather",60342),table:(0,u.$Cj)("table",60343),variableGroup:(0,u.$Cj)("variable-group",60344),typeHierarchy:(0,u.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Cj)("git-pull-request-create",60348),runAbove:(0,u.$Cj)("run-above",60349),runBelow:(0,u.$Cj)("run-below",60350),notebookTemplate:(0,u.$Cj)("notebook-template",60351),debugRerun:(0,u.$Cj)("debug-rerun",60352),workspaceTrusted:(0,u.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Cj)("workspace-unknown",60355),terminalCmd:(0,u.$Cj)("terminal-cmd",60356),terminalDebian:(0,u.$Cj)("terminal-debian",60357),terminalLinux:(0,u.$Cj)("terminal-linux",60358),terminalPowershell:(0,u.$Cj)("terminal-powershell",60359),terminalTmux:(0,u.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Cj)("terminal-ubuntu",60361),terminalBash:(0,u.$Cj)("terminal-bash",60362),arrowSwap:(0,u.$Cj)("arrow-swap",60363),copy:(0,u.$Cj)("copy",60364),personAdd:(0,u.$Cj)("person-add",60365),filterFilled:(0,u.$Cj)("filter-filled",60366),wand:(0,u.$Cj)("wand",60367),debugLineByLine:(0,u.$Cj)("debug-line-by-line",60368),inspect:(0,u.$Cj)("inspect",60369),layers:(0,u.$Cj)("layers",60370),layersDot:(0,u.$Cj)("layers-dot",60371),layersActive:(0,u.$Cj)("layers-active",60372),compass:(0,u.$Cj)("compass",60373),compassDot:(0,u.$Cj)("compass-dot",60374),compassActive:(0,u.$Cj)("compass-active",60375),azure:(0,u.$Cj)("azure",60376),issueDraft:(0,u.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Cj)("git-pull-request-draft",60379),debugAll:(0,u.$Cj)("debug-all",60380),debugCoverage:(0,u.$Cj)("debug-coverage",60381),runErrors:(0,u.$Cj)("run-errors",60382),folderLibrary:(0,u.$Cj)("folder-library",60383),debugContinueSmall:(0,u.$Cj)("debug-continue-small",60384),beakerStop:(0,u.$Cj)("beaker-stop",60385),graphLine:(0,u.$Cj)("graph-line",60386),graphScatter:(0,u.$Cj)("graph-scatter",60387),pieChart:(0,u.$Cj)("pie-chart",60388),bracket:(0,u.$Cj)("bracket",60175),bracketDot:(0,u.$Cj)("bracket-dot",60389),bracketError:(0,u.$Cj)("bracket-error",60390),lockSmall:(0,u.$Cj)("lock-small",60391),azureDevops:(0,u.$Cj)("azure-devops",60392),verifiedFilled:(0,u.$Cj)("verified-filled",60393),newline:(0,u.$Cj)("newline",60394),layout:(0,u.$Cj)("layout",60395),layoutActivitybarLeft:(0,u.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Cj)("layout-panel-right",60401),layoutPanel:(0,u.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Cj)("layout-statusbar",60405),layoutMenubar:(0,u.$Cj)("layout-menubar",60406),layoutCentered:(0,u.$Cj)("layout-centered",60407),target:(0,u.$Cj)("target",60408),indent:(0,u.$Cj)("indent",60409),recordSmall:(0,u.$Cj)("record-small",60410),errorSmall:(0,u.$Cj)("error-small",60411),terminalDecorationError:(0,u.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Cj)("layout-sidebar-left-off",60418),blank:(0,u.$Cj)("blank",60419),heartFilled:(0,u.$Cj)("heart-filled",60420),map:(0,u.$Cj)("map",60421),mapHorizontal:(0,u.$Cj)("map-horizontal",60421),foldHorizontal:(0,u.$Cj)("fold-horizontal",60421),mapFilled:(0,u.$Cj)("map-filled",60422),mapHorizontalFilled:(0,u.$Cj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,u.$Cj)("fold-horizontal-filled",60422),circleSmall:(0,u.$Cj)("circle-small",60423),bellSlash:(0,u.$Cj)("bell-slash",60424),bellSlashDot:(0,u.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Cj)("search-fuzzy",60429),commentDraft:(0,u.$Cj)("comment-draft",60430),send:(0,u.$Cj)("send",60431),sparkle:(0,u.$Cj)("sparkle",60432),insert:(0,u.$Cj)("insert",60433),mic:(0,u.$Cj)("mic",60434),thumbsdownFilled:(0,u.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Cj)("thumbsup-filled",60436),coffee:(0,u.$Cj)("coffee",60437),snake:(0,u.$Cj)("snake",60438),game:(0,u.$Cj)("game",60439),vr:(0,u.$Cj)("vr",60440),chip:(0,u.$Cj)("chip",60441),piano:(0,u.$Cj)("piano",60442),music:(0,u.$Cj)("music",60443),micFilled:(0,u.$Cj)("mic-filled",60444),repoFetch:(0,u.$Cj)("repo-fetch",60445),copilot:(0,u.$Cj)("copilot",60446),lightbulbSparkle:(0,u.$Cj)("lightbulb-sparkle",60447),robot:(0,u.$Cj)("robot",60448),sparkleFilled:(0,u.$Cj)("sparkle-filled",60449),diffSingle:(0,u.$Cj)("diff-single",60450),diffMultiple:(0,u.$Cj)("diff-multiple",60451),surroundWith:(0,u.$Cj)("surround-with",60452),share:(0,u.$Cj)("share",60453),gitStash:(0,u.$Cj)("git-stash",60454),gitStashApply:(0,u.$Cj)("git-stash-apply",60455),gitStashPop:(0,u.$Cj)("git-stash-pop",60456),vscode:(0,u.$Cj)("vscode",60457),vscodeInsiders:(0,u.$Cj)("vscode-insiders",60458),codeOss:(0,u.$Cj)("code-oss",60459),runCoverage:(0,u.$Cj)("run-coverage",60460),runAllCoverage:(0,u.$Cj)("run-all-coverage",60461),coverage:(0,u.$Cj)("coverage",60462),githubProject:(0,u.$Cj)("github-project",60463),mapVertical:(0,u.$Cj)("map-vertical",60464),foldVertical:(0,u.$Cj)("fold-vertical",60464),mapVerticalFilled:(0,u.$Cj)("map-vertical-filled",60465),foldVerticalFilled:(0,u.$Cj)("fold-vertical-filled",60465)}}),define(ke[78],Ee([1,0,99,169]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Fj=O;function O(){return Object.values(e.$Hj)}e.$Gj={dialogError:(0,u.$Cj)("dialog-error","error"),dialogWarning:(0,u.$Cj)("dialog-warning","warning"),dialogInfo:(0,u.$Cj)("dialog-info","info"),dialogClose:(0,u.$Cj)("dialog-close","close"),treeItemExpanded:(0,u.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Cj)("tree-item-loading","loading"),menuSelection:(0,u.$Cj)("menu-selection","check"),menuSubmenu:(0,u.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Cj)("toolbar-more","more"),quickInputBack:(0,u.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Cj)("drop-down-button",60084),symbolCustomColor:(0,u.$Cj)("symbol-customcolor",60252),exportIcon:(0,u.$Cj)("export",60332),workspaceUnspecified:(0,u.$Cj)("workspace-unspecified",60355),newLine:(0,u.$Cj)("newline",60394),thumbsDownFilled:(0,u.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Cj)("thumbsup-filled",60436),gitFetch:(0,u.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Cj)("debug-breakpoint-pending",60377)},e.$Hj={...L.$Ej,...e.$Gj}}),define(ke[24],Ee([1,0,18]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=L,e.$Pn=O,e.$Qn=M,e.$Rn=$,e.$Sn=v,e.$Tn=R,e.$Un=I,e.$Vn=p,e.$Wn=C,e.$Xn=k,e.$Yn=c,e.$Zn=m;function L(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?L(r):r}),n}function O(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(A.call(i,r)){const s=i[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,u.$Yf)(s)&&n.push(s)}}return o}const A=Object.prototype.hasOwnProperty;function M(o,n){return b(o,n,new Set)}function b(o,n,i){if((0,u.$5f)(o))return o;const r=n(o);if(typeof r<"u")return r;if(Array.isArray(o)){const s=[];for(const t of o)s.push(b(t,n,i));return s}if((0,u.$Xf)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)A.call(o,t)&&(s[t]=b(o[t],n,i));return i.delete(o),s}return o}function $(o,n,i=!0){return(0,u.$Xf)(o)?((0,u.$Xf)(n)&&Object.keys(n).forEach(r=>{r in o?i&&((0,u.$Xf)(o[r])&&(0,u.$Xf)(n[r])?$(o[r],n[r],i):o[r]=n[r]):o[r]=n[r]}),o):n}function v(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!v(o[i],n[i]))return!1}else{const s=[];for(r in o)s.push(r);s.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!v(s,t))return!1;for(i=0;i<s.length;i++)if(!v(o[s[i]],n[s[i]]))return!1}return!0}function R(o){const n=new Set;return JSON.stringify(o,(i,r)=>{if((0,u.$Xf)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function I(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],f=n[s];v(t,f)||(i[s]=f)}),i}function p(o,n){const i=n.toLowerCase(),r=Object.keys(o).find(s=>s.toLowerCase()===i);return r?o[r]:o[n]}function C(o,n){const i=Object.create(null);for(const[r,s]of Object.entries(o))n(r,s)&&(i[r]=s);return i}function k(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function c(o){const n=[];for(const i of k(o))typeof o[i]=="function"&&n.push(i);return n}function m(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},r={};for(const s of o)r[s]=i(s);return r}}),define(ke[56],Ee([1,0,78]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=O;var L;(function(M){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}M.isThemeColor=b})(L||(e.ThemeColor=L={}));function O(M){return{id:M}}var A;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function $(n){const i=b.exec(n.id);if(!i)return $(u.$Hj.error);const[,r,s]=i,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}M.asClassNameArray=$;function v(n){return $(n).join(" ")}M.asClassName=v;function R(n){return"."+$(n).join(".")}M.asCSSSelector=R;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}M.isThemeIcon=I;const p=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function C(n){const i=p.exec(n);if(!i)return;const[,r]=i;return{id:r}}M.fromString=C;function k(n){return{id:n}}M.fromId=k;function c(n,i){let r=n.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),i&&(r=`${r}~${i}`),{id:r}}M.modify=c;function m(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=m;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=o})(A||(e.ThemeIcon=A={}))}),define(ke[170],Ee([1,0,126,14,56]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=$,e.$Ak=R,e.$Bk=p,e.$Ck=C,e.$Dk=c,e.$Ek=m;const A="$(",M=new RegExp(`\\$\\(${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function $(o){return o.replace(b,(n,i)=>i?n:`\\${n}`)}const v=new RegExp(`\\\\${M.source}`,"g");function R(o){return o.replace(v,n=>`\\${n}`)}const I=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function p(o){return o.indexOf(A)===-1?o:o.replace(I,(n,i,r,s)=>r?n:i||s||"")}function C(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const k=new RegExp(`\\$\\(${O.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(o){k.lastIndex=0;let n="";const i=[];let r=0;for(;;){const s=k.lastIndex,t=k.exec(o),f=o.substring(s,t?.index);if(f.length>0){n+=f;for(let d=0;d<f.length;d++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function m(o,n,i=!1){const{text:r,iconOffsets:s}=n;if(!s||s.length===0)return(0,u.$qk)(o,r,i);const t=(0,L.$5e)(r," "),f=r.length-t.length,d=(0,u.$qk)(o,t,i);if(d)for(const l of d){const a=s[l.start+f]+f;l.start+=a,l.end+=a}return d}}),define(ke[127],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Se=L,e.$Te=O;var u;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function L(A){return A<0?0:A>255?255:A|0}function O(A){return A<0?0:A>4294967295?4294967295:A|0}}),define(ke[30],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=L;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(O){return u.test(O)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){O(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let $=0,v="";return v+=M[A[$++]],v+=M[A[$++]],v+=M[A[$++]],v+=M[A[$++]],v+="-",v+=M[A[$++]],v+=M[A[$++]],v+="-",v+=M[A[$++]],v+=M[A[$++]],v+="-",v+=M[A[$++]],v+=M[A[$++]],v+="-",v+=M[A[$++]],v+=M[A[$++]],v+=M[A[$++]],v+=M[A[$++]],v+=M[A[$++]],v+=M[A[$++]],v}}()}),define(ke[171],Ee([1,0,19,38,30]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.$Jt=void 0,e.$Ht=A,e.$It=M,e.$Kt=v;function A(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function M(I,p,C){const k={id:(0,O.$Eg)(),name:I,uri:p,data:C};return{asString:async()=>"",asFile:()=>k,value:void 0}}class b{constructor(){this.a=new Map}get size(){let p=0;for(const C of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const C=[...this.a.keys()];return L.Iterable.some(this,([k,c])=>c.asFile())&&C.push("files"),R($(p),C)}get(p){return this.a.get(this.b(p))?.[0]}append(p,C){const k=this.a.get(p);k?k.push(C):this.a.set(this.b(p),[C])}replace(p,C){this.a.set(this.b(p),[C])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,C]of this.a)for(const k of C)yield[p,k]}b(p){return $(p)}}e.$Jt=b;function $(I){return I.toLowerCase()}function v(I,p){return R($(I),p.map($))}function R(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const C=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[k,c,m]=C;return m==="*"?p.some(o=>o.startsWith(c+"/")):!1}e.$Lt=Object.freeze({create:I=>(0,u.$Mb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Lt.split(I).filter(p=>!p.startsWith("#"))})}),define(ke[172],Ee([1,0,62]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hg=void 0,e.$Gg=L,e.$Ig=A;function L(b,$,v,R=1){let I=!1;return new Promise(p=>{const C=setTimeout(()=>{if(!I)return I=!0,p(0)},v);O(b,$,R,k=>{if(!I)return I=!0,clearTimeout(C),p(k)})})}function O(b,$,v,R){if($===0)return R(0);const I=new u.Socket;I.once("connect",()=>(M(I),O(b+v,$-1,v,R))),I.once("data",()=>{}),I.once("error",p=>(M(I),p.code!=="ECONNREFUSED"?O(b+v,$-1,v,R):R(b))),I.connect(b,"127.0.0.1")}e.$Hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(b,$,v,R="127.0.0.1"){let I=!1,p,C=1;const k=u.createServer({pauseOnConnect:!0});function c(m,o){I||(I=!0,k.removeAllListeners(),k.close(),p&&clearTimeout(p),o(m))}return new Promise(m=>{p=setTimeout(()=>{c(0,m)},v),k.on("listening",()=>{c(b,m)}),k.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&C<$?(b++,C++,k.listen(b,R)):c(0,m)}),k.on("close",()=>{c(0,m)}),k.listen(b,R)})}function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[128],Ee([1,0,127]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=void 0;class L{constructor(b){const $=(0,u.$Se)(b);this.c=$,this.a=L.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const v=(0,u.$Se)($);b>=0&&b<256?this.a[b]=v:this.b.set(b,v)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$zt=L;var O;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(O||(O={}));class A{constructor(){this.a=new L(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$At=A}),define(ke[173],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Ot=L;var u;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function L(O){let A=0,M=0,b=0,$=0;for(let v=0,R=O.length;v<R;v++){const I=O.charCodeAt(v);I===13?(A===0&&(M=v),A++,v+1<R&&O.charCodeAt(v+1)===10?($|=2,v++):$|=3,b=v+1):I===10&&($|=1,A===0&&(M=v),A++,b=v+1)}return A===0&&(M=O.length),[A,M,O.length-b,$]}}),define(ke[49],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0;class u{constructor(O,A){this.lineNumber=O,this.column=A}with(O=this.lineNumber,A=this.column){return O===this.lineNumber&&A===this.column?this:new u(O,A)}delta(O=0,A=0){return this.with(this.lineNumber+O,this.column+A)}equals(O){return u.equals(this,O)}static equals(O,A){return!O&&!A?!0:!!O&&!!A&&O.lineNumber===A.lineNumber&&O.column===A.column}isBefore(O){return u.isBefore(this,O)}static isBefore(O,A){return O.lineNumber<A.lineNumber?!0:A.lineNumber<O.lineNumber?!1:O.column<A.column}isBeforeOrEqual(O){return u.isBeforeOrEqual(this,O)}static isBeforeOrEqual(O,A){return O.lineNumber<A.lineNumber?!0:A.lineNumber<O.lineNumber?!1:O.column<=A.column}static compare(O,A){const M=O.lineNumber|0,b=A.lineNumber|0;if(M===b){const $=O.column|0,v=A.column|0;return $-v}return M-b}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(O){return new u(O.lineNumber,O.column)}static isIPosition(O){return O&&typeof O.lineNumber=="number"&&typeof O.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$bt=u}),define(ke[29],Ee([1,0,49]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class L{constructor(A,M,b,$){A>b||A===b&&M>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=A,this.endColumn=M):(this.startLineNumber=A,this.startColumn=M,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return L.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return L.containsPosition(this,A)}static containsPosition(A,M){return!(M.lineNumber<A.startLineNumber||M.lineNumber>A.endLineNumber||M.lineNumber===A.startLineNumber&&M.column<A.startColumn||M.lineNumber===A.endLineNumber&&M.column>A.endColumn)}static strictContainsPosition(A,M){return!(M.lineNumber<A.startLineNumber||M.lineNumber>A.endLineNumber||M.lineNumber===A.startLineNumber&&M.column<=A.startColumn||M.lineNumber===A.endLineNumber&&M.column>=A.endColumn)}containsRange(A){return L.containsRange(this,A)}static containsRange(A,M){return!(M.startLineNumber<A.startLineNumber||M.endLineNumber<A.startLineNumber||M.startLineNumber>A.endLineNumber||M.endLineNumber>A.endLineNumber||M.startLineNumber===A.startLineNumber&&M.startColumn<A.startColumn||M.endLineNumber===A.endLineNumber&&M.endColumn>A.endColumn)}strictContainsRange(A){return L.strictContainsRange(this,A)}static strictContainsRange(A,M){return!(M.startLineNumber<A.startLineNumber||M.endLineNumber<A.startLineNumber||M.startLineNumber>A.endLineNumber||M.endLineNumber>A.endLineNumber||M.startLineNumber===A.startLineNumber&&M.startColumn<=A.startColumn||M.endLineNumber===A.endLineNumber&&M.endColumn>=A.endColumn)}plusRange(A){return L.plusRange(this,A)}static plusRange(A,M){let b,$,v,R;return M.startLineNumber<A.startLineNumber?(b=M.startLineNumber,$=M.startColumn):M.startLineNumber===A.startLineNumber?(b=M.startLineNumber,$=Math.min(M.startColumn,A.startColumn)):(b=A.startLineNumber,$=A.startColumn),M.endLineNumber>A.endLineNumber?(v=M.endLineNumber,R=M.endColumn):M.endLineNumber===A.endLineNumber?(v=M.endLineNumber,R=Math.max(M.endColumn,A.endColumn)):(v=A.endLineNumber,R=A.endColumn),new L(b,$,v,R)}intersectRanges(A){return L.intersectRanges(this,A)}static intersectRanges(A,M){let b=A.startLineNumber,$=A.startColumn,v=A.endLineNumber,R=A.endColumn;const I=M.startLineNumber,p=M.startColumn,C=M.endLineNumber,k=M.endColumn;return b<I?(b=I,$=p):b===I&&($=Math.max($,p)),v>C?(v=C,R=k):v===C&&(R=Math.min(R,k)),b>v||b===v&&$>R?null:new L(b,$,v,R)}equalsRange(A){return L.equalsRange(this,A)}static equalsRange(A,M){return!A&&!M?!0:!!A&&!!M&&A.startLineNumber===M.startLineNumber&&A.startColumn===M.startColumn&&A.endLineNumber===M.endLineNumber&&A.endColumn===M.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(A){return new u.$bt(A.endLineNumber,A.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(A){return new u.$bt(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,M){return new L(this.startLineNumber,this.startColumn,A,M)}setStartPosition(A,M){return new L(A,M,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(A){return new L(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(A){return new L(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new L(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,M=A){return new L(A.lineNumber,A.column,M.lineNumber,M.column)}static lift(A){return A?new L(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,M){return!(A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<M.startColumn||M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<A.startColumn)}static areIntersecting(A,M){return!(A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<=M.startColumn||M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,M){if(A&&M){const v=A.startLineNumber|0,R=M.startLineNumber|0;if(v===R){const I=A.startColumn|0,p=M.startColumn|0;if(I===p){const C=A.endLineNumber|0,k=M.endLineNumber|0;if(C===k){const c=A.endColumn|0,m=M.endColumn|0;return c-m}return C-k}return I-p}return v-R}return(A?1:0)-(M?1:0)}static compareRangesUsingEnds(A,M){return A.endLineNumber===M.endLineNumber?A.endColumn===M.endColumn?A.startLineNumber===M.startLineNumber?A.startColumn-M.startColumn:A.startLineNumber-M.startLineNumber:A.endColumn-M.endColumn:A.endLineNumber-M.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$ct=L}),define(ke[174],Ee([1,0,29]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class L{static insert(A,M){return{range:new u.$ct(A.lineNumber,A.column,A.lineNumber,A.column),text:M,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,M){return{range:A,text:M}}static replaceMove(A,M){return{range:A,text:M,forceMoveMarkers:!0}}}e.$dt=L}),define(ke[175],Ee([1,0,49,29]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.SelectionDirection=void 0;var O;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(O||(e.SelectionDirection=O={}));class A extends L.$ct{constructor(b,$,v,R){super(b,$,v,R),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=v,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return A.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,b,$):new A(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new u.$bt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$bt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new A(b,$,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new A(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new A(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new A(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new A(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let v=0,R=b.length;v<R;v++)if(!this.selectionsEqual(b[v],$[v]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,v,R,I){return I===0?new A(b,$,v,R):new A(v,R,b,$)}}e.$et=A}),define(ke[176],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0,e.$Ms={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[177],Ee([1,0,27,128]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.WordCharacterClass=void 0,e.$Ct=b;var O;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class A extends L.$zt{constructor(v,R){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=R,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let I=0,p=v.length;I<p;I++)this.set(v.charCodeAt(I),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(v,R){let I=null;for(const p of this.h(v)){if(p.index>R)break;I=p}return I}findNextIntlWordAtOrAfterOffset(v,R){for(const I of this.h(v))if(!(I.index<R))return I;return null}h(v){return this.e?this.f===v?this.g:(this.f=v,this.g=this.j(this.e.segment(v)),this.g):[]}j(v){const R=[];for(const I of v)this.k(I)&&R.push(I);return R}k(v){return!!v.isWordLike}}e.$Bt=A;const M=new u.$Ec(10);function b($,v){const R=`${$}/${v.join(",")}`;let I=M.get(R);return I||(I=new A($,v),M.set(R,I)),I}}),define(ke[129],Ee([1,0,38,3,75]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=void 0,e.$Ps=M,e.$Qs=$,e.$Rs=v,e.$Ns="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.$Ns)I.indexOf(C)>=0||(p+="\\"+C);return p+="\\s]+)",new RegExp(p,"g")}e.$Os=A();function M(I){let p=e.$Os;if(I&&I instanceof RegExp)if(I.global)p=I;else{let C="g";I.ignoreCase&&(C+="i"),I.multiline&&(C+="m"),I.unicode&&(C+="u"),p=new RegExp(I.source,C)}return p.lastIndex=0,p}const b=new O.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(I){const p=b.unshift(I);return(0,L.$Sc)(p)}function v(I,p,C,k,c){if(p=M(p),c||(c=u.Iterable.first(b)),C.length>c.maxLen){let r=I-c.maxLen/2;return r<0?r=0:k+=r,C=C.substring(r,I+c.maxLen/2),v(I,p,C,k,c)}const m=Date.now(),o=I-1-k;let n=-1,i=null;for(let r=1;!(Date.now()-m>=c.timeBudget);r++){const s=o-c.windowSize*r;p.lastIndex=Math.max(0,s);const t=R(p,C,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const r={word:i[0],startColumn:k+1+i.index,endColumn:k+1+i.index+i[0].length};return p.lastIndex=0,r}return null}function R(I,p,C,k){let c;for(;c=I.exec(p);){const m=c.index||0;if(m<=C&&I.lastIndex>=C)return c;if(k>0&&m>k)return null}return null}}),define(ke[178],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=e.$bu=e.IndentAction=void 0;var u;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class L{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,v=b.notIn.length;$<v;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const v=b.findTokenIndexAtOffset($-2),R=b.getStandardTokenType(v);return this.isOK(R)}g(b,$){for(let v=b;v<=$;v++){const R=String.fromCharCode(v);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$bu=L;class O{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)A(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),A(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),A(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),A(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&A(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$cu=O;function A(M,b,$){M.has(b)?M.get(b).push($):M.set(b,[$])}}),define(ke[179],Ee([1,0,128]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y2=e.$x2=e.State=void 0,e.$z2=p;var L;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(L||(e.State=L={}));class O{constructor(k,c,m){const o=new Uint8Array(k*c);for(let n=0,i=k*c;n<i;n++)o[n]=m;this.a=o,this.rows=k,this.cols=c}get(k,c){return this.a[k*this.cols+c]}set(k,c,m){this.a[k*this.cols+c]=m}}class A{constructor(k){let c=0,m=0;for(let n=0,i=k.length;n<i;n++){const[r,s,t]=k[n];s>c&&(c=s),r>m&&(m=r),t>m&&(m=t)}c++,m++;const o=new O(m,c,0);for(let n=0,i=k.length;n<i;n++){const[r,s,t]=k[n];o.set(r,s,t)}this.a=o,this.b=c}nextState(k,c){return c<0||c>=this.b?0:this.a.get(k,c)}}e.$x2=A;let M=null;function b(){return M===null&&(M=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var $;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})($||($={}));let v=null;function R(){if(v===null){v=new u.$zt(0);const C=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<C.length;c++)v.set(C.charCodeAt(c),1);const k=".,;:";for(let c=0;c<k.length;c++)v.set(k.charCodeAt(c),2)}return v}class I{static a(k,c,m,o,n){let i=n-1;do{const r=c.charCodeAt(i);if(k.get(r)!==2)break;i--}while(i>o);if(o>0){const r=c.charCodeAt(o-1),s=c.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:i+2},url:c.substring(o,i+1)}}static computeLinks(k,c=b()){const m=R(),o=[];for(let n=1,i=k.getLineCount();n<=i;n++){const r=k.getLineContent(n),s=r.length;let t=0,f=0,d=0,l=1,a=!1,h=!1,g=!1,S=!1;for(;t<s;){let w=!1;const E=r.charCodeAt(t);if(l===13){let y;switch(E){case 40:a=!0,y=0;break;case 41:y=a?0:1;break;case 91:g=!0,h=!0,y=0;break;case 93:g=!1,y=h?0:1;break;case 123:S=!0,y=0;break;case 125:y=S?0:1;break;case 39:case 34:case 96:d===E?y=1:d===39||d===34||d===96?y=0:y=1;break;case 42:y=d===42?1:0;break;case 124:y=d===124?1:0;break;case 32:y=g?0:1;break;default:y=m.get(E)}y===1&&(o.push(I.a(m,r,n,f,t)),w=!0)}else if(l===12){let y;E===91?(h=!0,y=0):y=m.get(E),y===1?w=!0:l=13}else l=c.nextState(l,E),l===0&&(w=!0);w&&(l=1,a=!1,h=!1,S=!1,f=t+1,d=E),t++}l===13&&o.push(I.a(m,r,n,f,s))}return o}}e.$y2=I;function p(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:I.computeLinks(C)}}),define(ke[79],Ee([1,0,24]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$wv=e.$vv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$xv=k,e.$Bv=r;var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(L||(e.OverviewRulerLane=L={}));var O;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(O||(e.GlyphMarginLane=O={}));var A;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var M;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var b;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var $;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var v;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(v||(e.DefaultEndOfLine=v={}));var R;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(R||(e.EndOfLineSequence=R={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,u.$Sn)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$vv=I;class p{constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.$wv=p;var C;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C||(e.TrackedRangeStickiness=C={}));function k(s){return s&&typeof s.read=="function"}var c;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var m;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class o{constructor(t,f,d,l,a,h){this.identifier=t,this.range=f,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=a,this._isTracked=h}}e.$yv=o;class n{constructor(t,f,d){this.regex=t,this.wordSeparators=f,this.simpleSearch=d}}e.$zv=n;class i{constructor(t,f,d){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=d}}e.$Av=i;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ke[180],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jC=e.NodeColor=e.$iC=void 0,e.$kC=O,e.$lC=A,e.$mC=v,e.$nC=R,e.$oC=I,e.$pC=p,e.$qC=C,e.$rC=k;class u{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$jC)return O(this.right);let m=this;for(;m.parent!==e.$jC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$jC?e.$jC:m.parent}prev(){if(this.left!==e.$jC)return A(this.left);let m=this;for(;m.parent!==e.$jC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$jC?e.$jC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$iC=u;var L;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$jC=new u(null,0),e.$jC.parent=e.$jC,e.$jC.left=e.$jC,e.$jC.right=e.$jC,e.$jC.color=0;function O(c){for(;c.left!==e.$jC;)c=c.left;return c}function A(c){for(;c.right!==e.$jC;)c=c.right;return c}function M(c){return c===e.$jC?0:c.size_left+c.piece.length+M(c.right)}function b(c){return c===e.$jC?0:c.lf_left+c.piece.lineFeedCnt+b(c.right)}function $(){e.$jC.parent=e.$jC}function v(c,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.$jC&&(o.left.parent=m),o.parent=m.parent,m.parent===e.$jC?c.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}function R(c,m){const o=m.left;m.left=o.right,o.right!==e.$jC&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.$jC?c.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}function I(c,m){let o,n;if(m.left===e.$jC?(n=m,o=n.right):m.right===e.$jC?(n=m,o=n.left):(n=O(m.right),o=n.right),n===c.root){c.root=o,o.color=0,m.detach(),$(),c.root.parent=e.$jC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===m?(o.parent=n.parent,k(c,o)):(n.parent===m?o.parent=n:o.parent=n.parent,k(c,o),n.left=m.left,n.right=m.right,n.parent=m.parent,n.color=m.color,m===c.root?c.root=n:m===m.parent.left?m.parent.left=n:m.parent.right=n,n.left!==e.$jC&&(n.left.parent=n),n.right!==e.$jC&&(n.right.parent=n),n.size_left=m.size_left,n.lf_left=m.lf_left,k(c,n)),m.detach(),o.parent.left===o){const s=M(o),t=b(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const f=s-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,C(c,o.parent,f,d)}}if(k(c,o.parent),i){$();return}let r;for(;o!==c.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,v(c,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,R(c,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,v(c,o.parent),o=c.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,R(c,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,v(c,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,R(c,o.parent),o=c.root));o.color=0,$()}function p(c,m){for(k(c,m);m!==c.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,v(c,m)),m.parent.color=0,m.parent.parent.color=1,R(c,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,R(c,m)),m.parent.color=0,m.parent.parent.color=1,v(c,m.parent.parent))}c.root.color=0}function C(c,m,o,n){for(;m!==c.root&&m!==e.$jC;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}function k(c,m){let o=0,n=0;if(m!==c.root){for(;m!==c.root&&m===m.parent.right;)m=m.parent;if(m!==c.root)for(m=m.parent,o=M(m.left)-m.size_left,n=b(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=n;m!==c.root&&(o!==0||n!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}}}),define(ke[181],Ee([1,0,19,127]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=void 0;class O{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,v){$=(0,L.$Te)($);const R=this.a,I=this.b,p=v.length;return p===0?!1:(this.a=new Uint32Array(R.length+p),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($),$+p),this.a.set(v,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue($,v){return $=(0,L.$Te)($),v=(0,L.$Te)(v),this.a[$]===v?!1:(this.a[$]=v,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,v){$=(0,L.$Te)($),v=(0,L.$Te)(v);const R=this.a,I=this.b;if($>=R.length)return!1;const p=R.length-$;return v>=p&&(v=p),v===0?!1:(this.a=new Uint32Array(R.length-v),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($+v),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,L.$Te)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let v=this.c[0]+1;v===0&&(this.b[0]=this.a[0],v++),$>=this.a.length&&($=this.a.length-1);for(let R=v;R<=$;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let v=0,R=this.a.length-1,I=0,p=0,C=0;for(;v<=R;)if(I=v+(R-v)/2|0,p=this.b[I],C=p-this.a[I],$<C)R=I-1;else if($>=p)v=I+1;else break;return new M(I,$-C)}}e.$Ev=O;class A{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const v=this.e[$],R=v>0?this.d[v-1]:0;return new M(v,$-R)}removeValues($,v){this.a.splice($,v),this.f($)}insertValues($,v){this.a=(0,u.$Wb)(this.a,$,v),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,v=this.a.length;$<v;$++){const R=this.a[$],I=$>0?this.d[$-1]:0;this.d[$]=I+R;for(let p=0;p<R;p++)this.e[I+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,v){this.a[$]!==v&&(this.a[$]=v,this.f($))}}e.$Fv=A;class M{constructor($,v){this.index=$,this.remainder=v,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=v}}e.$Gv=M}),define(ke[182],Ee([1,0,14,49,181]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=void 0;class A{constructor(b,$,v,R){this.d=b,this.f=$,this.g=v,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const v of $)this.o(v.range),this.p(new L.$bt(v.range.startLineNumber,v.range.startColumn),v.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,v=new Uint32Array($);for(let R=0;R<$;R++)v[R]=this.f[R].length+b;this.j=new O.$Ev(v)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const v=(0,u.$$e)($);if(v.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+v[0]+this.f[b.lineNumber-1].substring(b.column-1));return}v[v.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+v[0]);const R=new Uint32Array(v.length-1);for(let I=1;I<v.length;I++)this.f.splice(b.lineNumber+I-1,0,v[I]),R[I-1]=v[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,R)}}e.$Hv=A}),define(ke[100],Ee([1,0,14,177,49,29,79]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=e.$vC=e.$sC=void 0,e.$tC=v,e.$uC=R,e.$wC=c;const b=999;class ${constructor(n,i,r,s){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=v(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new M.$zv(i,this.wordSeparators?(0,L.$Ct)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$sC=$;function v(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const r=o.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function R(o,n,i){if(!i)return new M.$wv(o,null);const r=[];for(let s=0,t=n.length;s<t;s++)r[s]=n[s];return new M.$wv(o,r)}class I{constructor(n){const i=[];let r=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[r++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(r=t,s=t):r=t+1}return r+1}}class p{static findMatches(n,i,r,s,t){const f=i.parseSearchRequest();return f?f.regex.multiline?this.b(n,r,new m(f.wordSeparators,f.regex),s,t):this.c(n,r,f,s,t):[]}static a(n,i,r,s,t,f){let d,l=0;s?(l=s.findLineFeedCountBeforeOffset(t),d=i+t+l):d=i+t;let a;if(s){const w=s.findLineFeedCountBeforeOffset(t+f.length)-l;a=d+f.length+w}else a=d+f.length;const h=n.getPositionAt(d),g=n.getPositionAt(a);return new A.$ct(h.lineNumber,h.column,g.lineNumber,g.column)}static b(n,i,r,s,t){const f=n.getOffsetAt(i.getStartPosition()),d=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new I(d):null,a=[];let h=0,g;for(r.reset(0);g=r.next(d);)if(a[h++]=R(this.a(n,f,d,l,g.index,g[0]),g,s),h>=t)return a;return a}static c(n,i,r,s,t){const f=[];let d=0;if(i.startLineNumber===i.endLineNumber){const a=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return d=this.d(r,a,i.startLineNumber,i.startColumn-1,d,f,s,t),f}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);d=this.d(r,l,i.startLineNumber,i.startColumn-1,d,f,s,t);for(let a=i.startLineNumber+1;a<i.endLineNumber&&d<t;a++)d=this.d(r,n.getLineContent(a),a,0,d,f,s,t);if(d<t){const a=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);d=this.d(r,a,i.endLineNumber,0,d,f,s,t)}return f}static d(n,i,r,s,t,f,d,l){const a=n.wordSeparators;if(!d&&n.simpleSearch){const S=n.simpleSearch,w=S.length,E=i.length;let y=-w;for(;(y=i.indexOf(S,y+w))!==-1;)if((!a||c(a,i,E,y,w))&&(f[t++]=new M.$wv(new A.$ct(r,y+1+s,r,y+1+w+s),null),t>=l))return t;return t}const h=new m(n.wordSeparators,n.regex);let g;h.reset(0);do if(g=h.next(i),g&&(f[t++]=R(new A.$ct(r,g.index+1+s,r,g.index+1+g[0].length+s),g,d),t>=l))return t;while(g);return t}static findNextMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,f,s):this.f(n,r,f,s)}static e(n,i,r,s){const t=new O.$bt(i.lineNumber,1),f=n.getOffsetAt(t),d=n.getLineCount(),l=n.getValueInRange(new A.$ct(t.lineNumber,t.column,d,n.getLineMaxColumn(d)),1),a=n.getEOL()===`\r
`?new I(l):null;r.reset(i.column-1);const h=r.next(l);return h?R(this.a(n,f,l,a,h.index,h[0]),h,s):i.lineNumber!==1||i.column!==1?this.e(n,new O.$bt(1,1),r,s):null}static f(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f),l=this.g(r,d,f,i.column,s);if(l)return l;for(let a=1;a<=t;a++){const h=(f+a-1)%t,g=n.getLineContent(h+1),S=this.g(r,g,h+1,1,s);if(S)return S}return null}static g(n,i,r,s,t){n.reset(s-1);const f=n.next(i);return f?R(new A.$ct(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,f,s):this.j(n,r,f,s)}static h(n,i,r,s){const t=this.b(n,new A.$ct(1,1,i.lineNumber,i.column),r,s,10*b);if(t.length>0)return t[t.length-1];const f=n.getLineCount();return i.lineNumber!==f||i.column!==n.getLineMaxColumn(f)?this.h(n,new O.$bt(f,n.getLineMaxColumn(f)),r,s):null}static j(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f).substring(0,i.column-1),l=this.k(r,d,f,s);if(l)return l;for(let a=1;a<=t;a++){const h=(t+f-a-1)%t,g=n.getLineContent(h+1),S=this.k(r,g,h+1,s);if(S)return S}return null}static k(n,i,r,s){let t=null,f;for(n.reset(0);f=n.next(i);)t=R(new A.$ct(r,f.index+1,r,f.index+1+f[0].length),f,s);return t}}e.$vC=p;function C(o,n,i,r,s){if(r===0)return!0;const t=n.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r);if(o.get(f)!==0)return!0}return!1}function k(o,n,i,r,s){if(r+s===i)return!0;const t=n.charCodeAt(r+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r+s-1);if(o.get(f)!==0)return!0}return!1}function c(o,n,i,r,s){return C(o,n,i,r,s)&&k(o,n,i,r,s)}class m{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){u.$sf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||c(this._wordSeparators,n,i,s,t))return r}while(r);return null}}e.$xC=m}),define(ke[130],Ee([1,0,49,29,79,180,100]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CC=e.$BC=e.$AC=void 0,e.$yC=R,e.$zC=I;const b=65535;function $(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class v{constructor(n,i,r,s,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function R(o,n=!0){const i=[0];let r=1;for(let s=0,t=o.length;s<t;s++){const f=o.charCodeAt(s);f===13?s+1<t&&o.charCodeAt(s+1)===10?(i[r++]=s+2,s++):i[r++]=s+1:f===10&&(i[r++]=s+1)}return n?$(i):i}function I(o,n){o.length=0,o[0]=0;let i=1,r=0,s=0,t=0,f=!0;for(let l=0,a=n.length;l<a;l++){const h=n.charCodeAt(l);h===13?l+1<a&&n.charCodeAt(l+1)===10?(t++,o[i++]=l+2,l++):(r++,o[i++]=l+1):h===10?(s++,o[i++]=l+1):f&&h!==9&&(h<32||h>126)&&(f=!1)}const d=new v($(o),r,s,t,f);return o.length=0,d}class p{constructor(n,i,r,s,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$AC=p;class C{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$BC=C;class k{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==A.$jC&&n.iterate(n.root,r=>(r!==A.$jC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=n){r[s]=null,i=!0;continue}}if(i){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new C("",[0])],this.g={line:0,column:0},this.root=A.$jC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let s=null;for(let t=0,f=n.length;t<f;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=R(n[t].buffer));const d=new p(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,d)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,r=i-Math.floor(i/3),s=r*2;let t="",f=0;const d=[];if(this.iterate(this.root,l=>{const a=this.R(l),h=a.length;if(f<=r||f+h<s)return t+=a,f+=h,!0;const g=t.replace(/\r\n|\r|\n/g,n);return d.push(new C(g,R(g))),t=a,f=h,!0}),f>0){const l=t.replace(/\r\n|\r|\n/g,n);d.push(new C(l,R(l)))}this.create(d,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new k(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===A.$jC)return!0;const t=this.R(s),f=t.length,d=n.G(i),l=n.G(i+f),a=n.getValueInRange2(d,l);return i+=f,t===a})}getOffsetAt(n,i){let r=0,s=this.root;for(;s!==A.$jC;)if(s.left!==A.$jC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){r+=s.size_left;const t=this.B(s,n-s.lf_left-2);return r+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const s=n;for(;i!==A.$jC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),d=s-f;return new u.$bt(r+1,d+1)}return new u.$bt(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===A.$jC){const t=this.getOffsetAt(r+1,1),f=s-n-t;return new u.$bt(r+1,f+1)}else i=i.right;return new u.$bt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const d=n.node,l=this.a[d.piece.bufferIndex].buffer,a=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(a+n.remainder,a+i.remainder)}let r=n.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=s.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==A.$jC;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){f+=d.substring(l,l+i.remainder);break}else f+=d.substr(l,r.piece.length);r=r.next()}return f}getLinesContent(){const n=[];let i=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===A.$jC)return!0;const f=t.piece;let d=f.length;if(d===0)return!0;const l=this.a[f.bufferIndex].buffer,a=this.a[f.bufferIndex].lineStarts,h=f.start.line,g=f.end.line;let S=a[h]+f.start.column;if(s&&(l.charCodeAt(S)===10&&(S++,d--),n[i++]=r,r="",s=!1,d===0))return!0;if(h===g)return!this.f&&l.charCodeAt(S+d-1)===13?(s=!0,r+=l.substr(S,d-1)):r+=l.substr(S,d),!0;r+=this.f?l.substring(S,Math.max(S,a[h+1]-this.e)):l.substring(S,a[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let w=h+1;w<g;w++)r=this.f?l.substring(a[w],a[w+1]-this.e):l.substring(a[w],a[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&l.charCodeAt(a[g]+f.end.column-1)===13?(s=!0,f.end.column===0?i--:r=l.substr(a[g],f.end.column-1)):r=l.substr(a[g],f.end.column),!0}),s&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,s,t,f,d,l,a,h,g){const S=this.a[n.piece.bufferIndex],w=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,f);let D;const P={line:0,column:0};let z,F;i._wordSeparators?(z=S.buffer.substring(E,y),F=T=>T+E,i.reset(0)):(z=S.buffer,F=T=>T,i.reset(E));do if(D=i.next(z),D){if(F(D.index)>=y)return h;this.s(n,F(D.index)-w,P);const T=this.t(n.piece.bufferIndex,t,P),j=P.line===t.line?P.column-t.column+s:P.column+1,N=j+D[0].length;if(g[h++]=(0,M.$uC)(new L.$ct(r+T,j,r+T,N),D,l),F(D.index)+D[0].length>=y||h>=a)return h}while(D);return h}findMatchesLineByLine(n,i,r,s){const t=[];let f=0;const d=new M.$xC(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const a=this.H(n.endLineNumber,n.endColumn);if(a===null)return[];let h=this.s(l.node,l.remainder);const g=this.s(a.node,a.remainder);if(l.node===a.node)return this.findMatchesInNode(l.node,d,n.startLineNumber,n.startColumn,h,g,i,r,s,f,t),t;let S=n.startLineNumber,w=l.node;for(;w!==a.node;){const y=this.t(w.piece.bufferIndex,h,w.piece.end);if(y>=1){const P=this.a[w.piece.bufferIndex].lineStarts,z=this.u(w.piece.bufferIndex,w.piece.start),F=P[h.line+y],T=S===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(w,d,S,T,h,this.s(w,F-z),i,r,s,f,t),f>=s)return t;S+=y}const D=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const P=this.getLineContent(S).substring(D,n.endColumn-1);return f=this.n(i,d,P,n.endLineNumber,D,f,t,r,s),t}if(f=this.n(i,d,this.getLineContent(S).substr(D),S,D,f,t,r,s),f>=s)return t;S++,l=this.H(S,1),w=l.node,h=this.s(l.node,l.remainder)}if(S===n.endLineNumber){const y=S===n.startLineNumber?n.startColumn-1:0,D=this.getLineContent(S).substring(y,n.endColumn-1);return f=this.n(i,d,D,n.endLineNumber,y,f,t,r,s),t}const E=S===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(a.node,d,S,E,h,g,i,r,s,f,t),t}n(n,i,r,s,t,f,d,l,a){const h=n.wordSeparators;if(!l&&n.simpleSearch){const S=n.simpleSearch,w=S.length,E=r.length;let y=-w;for(;(y=r.indexOf(S,y+w))!==-1;)if((!h||(0,M.$wC)(h,r,E,y,w))&&(d[f++]=new O.$wv(new L.$ct(s,y+1+t,s,y+1+w+t),null),f>=a))return f;return f}let g;i.reset(0);do if(g=i.next(r),g&&(d[f++]=(0,M.$uC)(new L.$ct(s,g.index+1+t,s,g.index+1+g[0].length+t),g,l),f>=a))return f;while(g);return f}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==A.$jC){const{node:s,remainder:t,nodeStartOffset:f}=this.G(n),d=s.piece,l=d.bufferIndex,a=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&f+d.length===n&&i.length<b){this.F(s,i),this.y();return}if(f===n)this.o(i,s),this.h.validate(n);else if(f+s.piece.length>n){const h=[];let g=new p(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),this.u(l,d.end)-this.u(l,a));if(this.K()&&this.M(i)&&this.I(s,t)===10){const y={line:g.start.line+1,column:0};g=new p(g.bufferIndex,y,g.end,this.t(g.bufferIndex,y,g.end),g.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const y=this.s(s,t-1);this.C(s,y),i="\r"+i,s.piece.length===0&&h.push(s)}else this.C(s,a);else this.C(s,a);const S=this.w(i);g.length>0&&this.S(s,g);let w=s;for(let E=0;E<S.length;E++)w=this.S(w,S[E]);this.v(h)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let f=1;f<s.length;f++)t=this.S(t,s[f])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===A.$jC)return;const r=this.G(n),s=this.G(n+i),t=r.node,f=s.node;if(t===f){const S=this.s(t,r.remainder),w=this.s(t,s.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const E=t.next();(0,A.$oC)(this,t),this.N(E),this.y();return}this.D(t,w),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,S),this.O(t),this.y();return}this.E(t,S,w),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&d.push(t);const a=this.s(f,s.remainder);this.D(f,a),f.piece.length===0&&d.push(f);const h=t.next();for(let S=h;S!==A.$jC&&S!==f;S=S.next())d.push(S);const g=t.piece.length===0?t.prev():t;this.v(d),this.O(g),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const f=i.piece,d={line:f.start.line+1,column:0},l=new p(f.bufferIndex,d,f.end,this.t(f.bufferIndex,d,f.end),f.length-1);i.piece=l,n+=`
`,(0,A.$qC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let f=s.length-2;f>=0;f--)t=this.T(t,s[f]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),s=this.S(i,r[0]);let t=s;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(s)}s(n,i,r){const s=n.piece,t=n.piece.bufferIndex,f=this.a[t].lineStarts,l=f[s.start.line]+s.start.column+i;let a=s.start.line,h=s.end.line,g=0,S=0,w=0;for(;a<=h&&(g=a+(h-a)/2|0,w=f[g],g!==h);)if(S=f[g+1],l<w)h=g-1;else if(l>=S)a=g+1;else break;return r?(r.line=g,r.column=l-w,null):{line:g,column:l-w}}t(n,i,r){if(r.column===0)return r.line-i.line;const s=this.a[n].lineStarts;if(r.line===s.length-1)return r.line-i.line;const t=s[r.line+1],f=s[r.line]+r.column;if(t>f+1)return r.line-i.line;const d=f-1;return this.a[n].buffer.charCodeAt(d)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,A.$oC)(this,n[i])}w(n){if(n.length>b){const h=[];for(;n.length>b;){const S=n.charCodeAt(b-1);let w;S===13||S>=55296&&S<=56319?(w=n.substring(0,b-1),n=n.substring(b-1)):(w=n.substring(0,b),n=n.substring(b));const E=R(w);h.push(new p(this.a.length,{line:0,column:0},{line:E.length-1,column:w.length-E[E.length-1]},E.length-1,w.length)),this.a.push(new C(w,E))}const g=R(n);return h.push(new p(this.a.length,{line:0,column:0},{line:g.length-1,column:n.length-g[g.length-1]},g.length-1,n.length)),this.a.push(new C(n,g)),h}let i=this.a[0].buffer.length;const r=R(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let h=0;h<r.length;h++)r[h]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let h=0;h<r.length;h++)r[h]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[f],l={line:f,column:d},a=new p(0,s,l,this.t(0,s,l),t-i);return this.g=l,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,s="";const t=this.h.get2(n);if(t){r=t.node;const f=this.B(r,n-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)s=d.substring(l+f,l+r.piece.length);else{const a=this.B(r,n-t.nodeStartLineNumber);return d.substring(l+f,l+a-i)}}else{let f=0;const d=n;for(;r!==A.$jC;)if(r.left!==A.$jC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const l=this.B(r,n-r.lf_left-2),a=this.B(r,n-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,g=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:d-(n-1-r.lf_left)}),h.substring(g+l,g+a-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const l=this.B(r,n-r.lf_left-2),a=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);s=a.substring(h+l,h+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==A.$jC;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return s+=f.substring(l,l+d-i),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=f.substr(d,r.piece.length)}r=r.next()}return s}y(){let n=this.root,i=1,r=0;for(;n!==A.$jC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,s=this.s(n,i),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const f=this.t(n.piece.bufferIndex,r.start,s);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const r=n.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=i,d=this.u(r.bufferIndex,f),l=this.t(r.bufferIndex,r.start,f),a=l-s,h=d-t,g=r.length+h;n.piece=new p(r.bufferIndex,r.start,f,l,g),(0,A.$qC)(this,n,h,a)}D(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=i,d=this.t(r.bufferIndex,f,r.end),l=this.u(r.bufferIndex,f),a=d-s,h=t-l,g=r.length+h;n.piece=new p(r.bufferIndex,f,r.end,d,g),(0,A.$qC)(this,n,h,a)}E(n,i,r){const s=n.piece,t=s.start,f=s.end,d=s.length,l=s.lineFeedCnt,a=i,h=this.t(s.bufferIndex,s.start,a),g=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new p(s.bufferIndex,s.start,a,h,g),(0,A.$qC)(this,n,g-d,h-l);const S=new p(s.bufferIndex,r,f,this.t(s.bufferIndex,r,f),this.u(s.bufferIndex,f)-this.u(s.bufferIndex,r)),w=this.S(n,S);this.N(w)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=R(i,!1);for(let w=0;w<t.length;w++)t[w]+=s;if(r){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[f],l={line:f,column:d},a=n.piece.length+i.length,h=n.piece.lineFeedCnt,g=this.t(0,n.piece.start,l),S=g-h;n.piece=new p(n.piece.bufferIndex,n.piece.start,l,g,a),this.g=l,(0,A.$qC)(this,n,i.length,S)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let s=0;for(;i!==A.$jC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,s=0;for(;r!==A.$jC;)if(r.left!==A.$jC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),f=this.B(r,n-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+i-1,f),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:s};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==A.$jC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:f}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$jC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=r[s]+i.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$jC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,d=n.piece.lineFeedCnt-1;n.piece=new p(n.piece.bufferIndex,n.piece.start,t,d,f),(0,A.$qC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const l={line:i.piece.start.line+1,column:0},a=i.piece.length-1,h=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new p(i.piece.bufferIndex,l,i.piece.end,h,a),(0,A.$qC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const g=this.w(`\r
`);this.S(n,g[0]);for(let S=0;S<r.length;S++)(0,A.$oC)(this,r[S])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,A.$oC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},f=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new p(s.bufferIndex,t,s.end,d,f),(0,A.$qC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===A.$jC)return i(A.$jC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===A.$jC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,s)}S(n,i){const r=new A.$iC(i,1);if(r.left=A.$jC,r.right=A.$jC,r.parent=A.$jC,r.size_left=0,r.lf_left=0,this.root===A.$jC)this.root=r,r.color=0;else if(n.right===A.$jC)n.right=r,r.parent=n;else{const t=(0,A.$kC)(n.right);t.left=r,r.parent=t}return(0,A.$pC)(this,r),r}T(n,i){const r=new A.$iC(i,1);if(r.left=A.$jC,r.right=A.$jC,r.parent=A.$jC,r.size_left=0,r.lf_left=0,this.root===A.$jC)this.root=r,r.color=0;else if(n.left===A.$jC)n.left=r,r.parent=n;else{const s=(0,A.$lC)(n.left);s.right=r,r.parent=s}return(0,A.$pC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$CC=m}),define(ke[183],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0=e.$j0=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const M=this.a.get(A);return this.a.delete(A),M}}addDragOperationTransfer(A,M){this.a.set(A,M)}}e.$j0=u;class L{constructor(A){this.identifier=A}}e.$k0=L}),define(ke[184],Ee([1,0,4,3]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class O{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,L.$Sc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const v=new A(this,b,$);return this.b.set(b,v),(0,L.$Sc)(()=>{const R=this.b.get(b);!R||R!==v||(this.b.delete(b),R.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const v=this.b.get(b);return!v||v.isResolved?null:(await v.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const v=this.b.get(b);return!!(!v||v.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Nt=O;class A extends L.$Uc{get isResolved(){return this.c}constructor(b,$,v){super(),this.f=b,this.g=$,this.h=v,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[185],Ee([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(ke[186],Ee([1,0,4,3,185]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=R;class A extends L.$Uc{constructor(p,C="",k="",c=!0,m){super(),this.h=this.B(new u.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=C,this.u=k,this.w=c,this.C=m}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,C){this.C&&await this.C(p)}}e.$Zi=A;class M extends L.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$7d),this.onWillRun=this.f.event,this.m=this.B(new u.$7d),this.onDidRun=this.m.event}async run(p,C){if(!p.enabled)return;this.f.fire({action:p});let k;try{await this.u(p,C)}catch(c){k=c}this.m.fire({action:p,error:k})}async u(p,C){await p.run(C)}}e.$1i=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let C=[];for(const k of p)k.length&&(C.length?C=[...C,new b,...k]:C=k);return C}static{this.ID="vs.actions.separator"}async run(){}}e.$2i=b;class ${get actions(){return this.a}constructor(p,C,k,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=C,this.class=c,this.a=k}async run(){}}e.$3i=$;class v extends A{static{this.ID="vs.actions.empty"}constructor(){super(v.ID,O.localize(0,null),void 0,!1)}}e.$4i=v;function R(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...p)=>I.run(...p),tooltip:I.label}}}),define(ke[187],Ee([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(ke[188],Ee([1,0,187]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=v,e.$Om=R,e.$Pm=I;const L=60,O=L*60,A=O*24,M=A*7,b=A*30,$=A*365;function v(p,C,k,c){typeof p!="number"&&(p=p.getTime());const m=Math.round((new Date().getTime()-p)/1e3);if(m<-30)return(0,u.localize)(0,null,v(new Date().getTime()+m*1e3,!1));if(!c&&m<30)return(0,u.localize)(1,null);let o;return m<L?(o=m,C?o===1?k?(0,u.localize)(2,null,o):(0,u.localize)(3,null,o):k?(0,u.localize)(4,null,o):(0,u.localize)(5,null,o):o===1?k?(0,u.localize)(6,null,o):(0,u.localize)(7,null,o):k?(0,u.localize)(8,null,o):(0,u.localize)(9,null,o)):m<O?(o=Math.floor(m/L),C?o===1?k?(0,u.localize)(10,null,o):(0,u.localize)(11,null,o):k?(0,u.localize)(12,null,o):(0,u.localize)(13,null,o):o===1?k?(0,u.localize)(14,null,o):(0,u.localize)(15,null,o):k?(0,u.localize)(16,null,o):(0,u.localize)(17,null,o)):m<A?(o=Math.floor(m/O),C?o===1?k?(0,u.localize)(18,null,o):(0,u.localize)(19,null,o):k?(0,u.localize)(20,null,o):(0,u.localize)(21,null,o):o===1?k?(0,u.localize)(22,null,o):(0,u.localize)(23,null,o):k?(0,u.localize)(24,null,o):(0,u.localize)(25,null,o)):m<M?(o=Math.floor(m/A),C?o===1?(0,u.localize)(26,null,o):(0,u.localize)(27,null,o):o===1?(0,u.localize)(28,null,o):(0,u.localize)(29,null,o)):m<b?(o=Math.floor(m/M),C?o===1?k?(0,u.localize)(30,null,o):(0,u.localize)(31,null,o):k?(0,u.localize)(32,null,o):(0,u.localize)(33,null,o):o===1?k?(0,u.localize)(34,null,o):(0,u.localize)(35,null,o):k?(0,u.localize)(36,null,o):(0,u.localize)(37,null,o)):m<$?(o=Math.floor(m/b),C?o===1?k?(0,u.localize)(38,null,o):(0,u.localize)(39,null,o):k?(0,u.localize)(40,null,o):(0,u.localize)(41,null,o):o===1?k?(0,u.localize)(42,null,o):(0,u.localize)(43,null,o):k?(0,u.localize)(44,null,o):(0,u.localize)(45,null,o)):(o=Math.floor(m/$),C?o===1?k?(0,u.localize)(46,null,o):(0,u.localize)(47,null,o):k?(0,u.localize)(48,null,o):(0,u.localize)(49,null,o):o===1?k?(0,u.localize)(50,null,o):(0,u.localize)(51,null,o):k?(0,u.localize)(52,null,o):(0,u.localize)(53,null,o))}function R(p,C){const k=Math.abs(p/1e3);return k<1?C?(0,u.localize)(54,null,p):(0,u.localize)(55,null,p):k<L?C?(0,u.localize)(56,null,Math.round(p)/1e3):(0,u.localize)(57,null,Math.round(p)/1e3):k<O?C?(0,u.localize)(58,null,Math.round(p/(1e3*L))):(0,u.localize)(59,null,Math.round(p/(1e3*L))):k<A?C?(0,u.localize)(60,null,Math.round(p/(1e3*O))):(0,u.localize)(61,null,Math.round(p/(1e3*O))):(0,u.localize)(62,null,Math.round(p/(1e3*A)))}function I(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[189],Ee([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(ke[46],Ee([1,0,19,18,189]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=$,e.$7i=v,e.$8i=R;function A(I,p){return p&&(I.stack||I.stacktrace)?O.localize(0,null,b(I),M(I.stack)||M(I.stacktrace)):b(I)}function M(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?O.localize(1,null,I.message):I.message||O.localize(2,null)}function $(I=null,p=!1){if(!I)return O.localize(3,null);if(Array.isArray(I)){const C=u.$Hb(I),k=$(C[0],p);return C.length>1?O.localize(4,null,k,C.length):k}if(L.$Vf(I))return I;if(I.detail){const C=I.detail;if(C.error)return A(C.error,p);if(C.exception)return A(C.exception,p)}return I.stack?A(I,p):I.message?I.message:O.localize(5,null)}function v(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}function R(I,p){let C;return typeof I=="string"?C=new Error(I):C=I,C.actions=p,C}}),define(ke[190],Ee([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,190]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=f,e.$D=S,e.$J=w,e.$g="en";let L=!1,O=!1,A=!1,M=!1,b=!1,$=!1,v=!1,R=!1,I=!1,p=!1,C,k=e.$g,c=e.$g,m,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const r=typeof i?.versions?.electron=="string",s=r&&i?.type==="renderer";if(typeof i=="object"){L=i.platform==="win32",O=i.platform==="darwin",A=i.platform==="linux",M=A&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,v=r,I=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.$g,k=e.$g;const E=i.env.VSCODE_NLS_CONFIG;if(E)try{const y=JSON.parse(E),D=y.availableLanguages["*"];C=y.locale,c=y.osLocale,k=D||e.$g,m=y._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,L=o.indexOf("Windows")>=0,O=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=o.indexOf("Linux")>=0,p=o?.indexOf("Mobi")>=0,$=!0,C=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,k=C,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let d=0;O?d=1:L?d=3:A&&(d=2),e.$i=L,e.$j=O,e.$k=A,e.$l=M,e.$m=b,e.$n=v,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=R,e.$s=p,e.$t=I,e.$u=d,e.$v=o,e.$w=k;var l;(function(E){function y(){return e.$w}E.value=y;function D(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=D;function P(){return e.$w==="en"}E.isDefault=P})(l||(e.Language=l={})),e.$x=C,e.$y=c,e.$z=m,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const E=[];n.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let P=0,z=E.length;P<z;P++){const F=E[P];if(F.id===D.data.vscodeScheduleAsyncWork){E.splice(P,1),F.callback();return}}});let y=0;return D=>{const P=++y;E.push({id:P,callback:D}),n.postMessage({vscodeScheduleAsyncWork:P},"*")}}return E=>setTimeout(E)})();var a;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=O||R?2:L?1:3;let h=!0,g=!1;function S(){if(!g){g=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,h=new Uint16Array(E.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(E){return parseFloat(E)>=20}}),define(ke[50],Ee([1,0,11]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let L;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.process<"u"){const A=O.process;L={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$ec=L.platform,e.$fc=L.arch}),define(ke[17],Ee([1,0,50]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const L=65,O=97,A=90,M=122,b=46,$=47,v=92,R=58,I=63;class p extends Error{constructor(f,d,l){let a;typeof d=="string"&&d.indexOf("not ")===0?(a="must not be",d=d.replace(/^not /,"")):a="must be";const h=f.indexOf(".")!==-1?"property":"argument";let g=`The "${f}" ${h} ${a} of type ${d}`;g+=`. Received type ${typeof l}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function C(t,f){if(t===null||typeof t!="object")throw new p(f,"Object",t)}function k(t,f){if(typeof t!="string")throw new p(f,"string",t)}const c=u.$ec==="win32";function m(t){return t===$||t===v}function o(t){return t===$}function n(t){return t>=L&&t<=A||t>=O&&t<=M}function i(t,f,d,l){let a="",h=0,g=-1,S=0,w=0;for(let E=0;E<=t.length;++E){if(E<t.length)w=t.charCodeAt(E);else{if(l(w))break;w=$}if(l(w)){if(!(g===E-1||S===1))if(S===2){if(a.length<2||h!==2||a.charCodeAt(a.length-1)!==b||a.charCodeAt(a.length-2)!==b){if(a.length>2){const y=a.lastIndexOf(d);y===-1?(a="",h=0):(a=a.slice(0,y),h=a.length-1-a.lastIndexOf(d)),g=E,S=0;continue}else if(a.length!==0){a="",h=0,g=E,S=0;continue}}f&&(a+=a.length>0?`${d}..`:"..",h=2)}else a.length>0?a+=`${d}${t.slice(g+1,E)}`:a=t.slice(g+1,E),h=E-g-1;g=E,S=0}else w===b&&S!==-1?++S:S=-1}return a}function r(t,f){C(f,"pathObject");const d=f.dir||f.root,l=f.base||`${f.name||""}${f.ext||""}`;return d?d===f.root?`${d}${l}`:`${d}${t}${l}`:l}e.$gc={resolve(...t){let f="",d="",l=!1;for(let a=t.length-1;a>=-1;a--){let h;if(a>=0){if(h=t[a],k(h,"path"),h.length===0)continue}else f.length===0?h=u.cwd():(h=u.env[`=${f}`]||u.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==f.toLowerCase()&&h.charCodeAt(2)===v)&&(h=`${f}\\`));const g=h.length;let S=0,w="",E=!1;const y=h.charCodeAt(0);if(g===1)m(y)&&(S=1,E=!0);else if(m(y))if(E=!0,m(h.charCodeAt(1))){let D=2,P=D;for(;D<g&&!m(h.charCodeAt(D));)D++;if(D<g&&D!==P){const z=h.slice(P,D);for(P=D;D<g&&m(h.charCodeAt(D));)D++;if(D<g&&D!==P){for(P=D;D<g&&!m(h.charCodeAt(D));)D++;(D===g||D!==P)&&(w=`\\\\${z}\\${h.slice(P,D)}`,S=D)}}}else S=1;else n(y)&&h.charCodeAt(1)===R&&(w=h.slice(0,2),S=2,g>2&&m(h.charCodeAt(2))&&(E=!0,S=3));if(w.length>0)if(f.length>0){if(w.toLowerCase()!==f.toLowerCase())continue}else f=w;if(l){if(f.length>0)break}else if(d=`${h.slice(S)}\\${d}`,l=E,E&&f.length>0)break}return d=i(d,!l,"\\",m),l?`${f}\\${d}`:`${f}${d}`||"."},normalize(t){k(t,"path");const f=t.length;if(f===0)return".";let d=0,l,a=!1;const h=t.charCodeAt(0);if(f===1)return o(h)?"\\":t;if(m(h))if(a=!0,m(t.charCodeAt(1))){let S=2,w=S;for(;S<f&&!m(t.charCodeAt(S));)S++;if(S<f&&S!==w){const E=t.slice(w,S);for(w=S;S<f&&m(t.charCodeAt(S));)S++;if(S<f&&S!==w){for(w=S;S<f&&!m(t.charCodeAt(S));)S++;if(S===f)return`\\\\${E}\\${t.slice(w)}\\`;S!==w&&(l=`\\\\${E}\\${t.slice(w,S)}`,d=S)}}}else d=1;else n(h)&&t.charCodeAt(1)===R&&(l=t.slice(0,2),d=2,f>2&&m(t.charCodeAt(2))&&(a=!0,d=3));let g=d<f?i(t.slice(d),!a,"\\",m):"";return g.length===0&&!a&&(g="."),g.length>0&&m(t.charCodeAt(f-1))&&(g+="\\"),l===void 0?a?`\\${g}`:g:a?`${l}\\${g}`:`${l}${g}`},isAbsolute(t){k(t,"path");const f=t.length;if(f===0)return!1;const d=t.charCodeAt(0);return m(d)||f>2&&n(d)&&t.charCodeAt(1)===R&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,d;for(let h=0;h<t.length;++h){const g=t[h];k(g,"path"),g.length>0&&(f===void 0?f=d=g:f+=`\\${g}`)}if(f===void 0)return".";let l=!0,a=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++a;const h=d.length;h>1&&m(d.charCodeAt(1))&&(++a,h>2&&(m(d.charCodeAt(2))?++a:l=!1))}if(l){for(;a<f.length&&m(f.charCodeAt(a));)a++;a>=2&&(f=`\\${f.slice(a)}`)}return e.$gc.normalize(f)},relative(t,f){if(k(t,"from"),k(f,"to"),t===f)return"";const d=e.$gc.resolve(t),l=e.$gc.resolve(f);if(d===l||(t=d.toLowerCase(),f=l.toLowerCase(),t===f))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===v;)a++;let h=t.length;for(;h-1>a&&t.charCodeAt(h-1)===v;)h--;const g=h-a;let S=0;for(;S<f.length&&f.charCodeAt(S)===v;)S++;let w=f.length;for(;w-1>S&&f.charCodeAt(w-1)===v;)w--;const E=w-S,y=g<E?g:E;let D=-1,P=0;for(;P<y;P++){const F=t.charCodeAt(a+P);if(F!==f.charCodeAt(S+P))break;F===v&&(D=P)}if(P!==y){if(D===-1)return l}else{if(E>y){if(f.charCodeAt(S+P)===v)return l.slice(S+P+1);if(P===2)return l.slice(S+P)}g>y&&(t.charCodeAt(a+P)===v?D=P:P===2&&(D=3)),D===-1&&(D=0)}let z="";for(P=a+D+1;P<=h;++P)(P===h||t.charCodeAt(P)===v)&&(z+=z.length===0?"..":"\\..");return S+=D,z.length>0?`${z}${l.slice(S,w)}`:(l.charCodeAt(S)===v&&++S,l.slice(S,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$gc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===v){if(f.charCodeAt(1)===v){const d=f.charCodeAt(2);if(d!==I&&d!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(n(f.charCodeAt(0))&&f.charCodeAt(1)===R&&f.charCodeAt(2)===v)return`\\\\?\\${f}`;return t},dirname(t){k(t,"path");const f=t.length;if(f===0)return".";let d=-1,l=0;const a=t.charCodeAt(0);if(f===1)return m(a)?t:".";if(m(a)){if(d=l=1,m(t.charCodeAt(1))){let S=2,w=S;for(;S<f&&!m(t.charCodeAt(S));)S++;if(S<f&&S!==w){for(w=S;S<f&&m(t.charCodeAt(S));)S++;if(S<f&&S!==w){for(w=S;S<f&&!m(t.charCodeAt(S));)S++;if(S===f)return t;S!==w&&(d=l=S+1)}}}}else n(a)&&t.charCodeAt(1)===R&&(d=f>2&&m(t.charCodeAt(2))?3:2,l=d);let h=-1,g=!0;for(let S=f-1;S>=l;--S)if(m(t.charCodeAt(S))){if(!g){h=S;break}}else g=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,f){f!==void 0&&k(f,"ext"),k(t,"path");let d=0,l=-1,a=!0,h;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(d=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,S=-1;for(h=t.length-1;h>=d;--h){const w=t.charCodeAt(h);if(m(w)){if(!a){d=h+1;break}}else S===-1&&(a=!1,S=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=S))}return d===l?l=S:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(m(t.charCodeAt(h))){if(!a){d=h+1;break}}else l===-1&&(a=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){k(t,"path");let f=0,d=-1,l=0,a=-1,h=!0,g=0;t.length>=2&&t.charCodeAt(1)===R&&n(t.charCodeAt(0))&&(f=l=2);for(let S=t.length-1;S>=f;--S){const w=t.charCodeAt(S);if(m(w)){if(!h){l=S+1;break}continue}a===-1&&(h=!1,a=S+1),w===b?d===-1?d=S:g!==1&&(g=1):d!==-1&&(g=-1)}return d===-1||a===-1||g===0||g===1&&d===a-1&&d===l+1?"":t.slice(d,a)},format:r.bind(null,"\\"),parse(t){k(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.length;let l=0,a=t.charCodeAt(0);if(d===1)return m(a)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(a)){if(l=1,m(t.charCodeAt(1))){let D=2,P=D;for(;D<d&&!m(t.charCodeAt(D));)D++;if(D<d&&D!==P){for(P=D;D<d&&m(t.charCodeAt(D));)D++;if(D<d&&D!==P){for(P=D;D<d&&!m(t.charCodeAt(D));)D++;D===d?l=D:D!==P&&(l=D+1)}}}}else if(n(a)&&t.charCodeAt(1)===R){if(d<=2)return f.root=f.dir=t,f;if(l=2,m(t.charCodeAt(2))){if(d===3)return f.root=f.dir=t,f;l=3}}l>0&&(f.root=t.slice(0,l));let h=-1,g=l,S=-1,w=!0,E=t.length-1,y=0;for(;E>=l;--E){if(a=t.charCodeAt(E),m(a)){if(!w){g=E+1;break}continue}S===-1&&(w=!1,S=E+1),a===b?h===-1?h=E:y!==1&&(y=1):h!==-1&&(y=-1)}return S!==-1&&(h===-1||y===0||y===1&&h===S-1&&h===g+1?f.base=f.name=t.slice(g,S):(f.name=t.slice(g,h),f.base=t.slice(g,S),f.ext=t.slice(h,S))),g>0&&g!==l?f.dir=t.slice(0,g-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(c){const t=/\\/g;return()=>{const f=u.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let f="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const a=l>=0?t[l]:s();k(a,"path"),a.length!==0&&(f=`${a}/${f}`,d=a.charCodeAt(0)===$)}return f=i(f,!d,"/",o),d?`/${f}`:f.length>0?f:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=i(t,!f,"/",o),t.length===0?f?"/":d?"./":".":(d&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let f;for(let d=0;d<t.length;++d){const l=t[d];k(l,"path"),l.length>0&&(f===void 0?f=l:f+=`/${l}`)}return f===void 0?".":e.$hc.normalize(f)},relative(t,f){if(k(t,"from"),k(f,"to"),t===f||(t=e.$hc.resolve(t),f=e.$hc.resolve(f),t===f))return"";const d=1,l=t.length,a=l-d,h=1,g=f.length-h,S=a<g?a:g;let w=-1,E=0;for(;E<S;E++){const D=t.charCodeAt(d+E);if(D!==f.charCodeAt(h+E))break;D===$&&(w=E)}if(E===S)if(g>S){if(f.charCodeAt(h+E)===$)return f.slice(h+E+1);if(E===0)return f.slice(h+E)}else a>S&&(t.charCodeAt(d+E)===$?w=E:E===0&&(w=0));let y="";for(E=d+w+1;E<=l;++E)(E===l||t.charCodeAt(E)===$)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===$;let d=-1,l=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===$){if(!l){d=a;break}}else l=!1;return d===-1?f?"/":".":f&&d===1?"//":t.slice(0,d)},basename(t,f){f!==void 0&&k(f,"ext"),k(t,"path");let d=0,l=-1,a=!0,h;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,S=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===$){if(!a){d=h+1;break}}else S===-1&&(a=!1,S=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=S))}return d===l?l=S:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===$){if(!a){d=h+1;break}}else l===-1&&(a=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){k(t,"path");let f=-1,d=0,l=-1,a=!0,h=0;for(let g=t.length-1;g>=0;--g){const S=t.charCodeAt(g);if(S===$){if(!a){d=g+1;break}continue}l===-1&&(a=!1,l=g+1),S===b?f===-1?f=g:h!==1&&(h=1):f!==-1&&(h=-1)}return f===-1||l===-1||h===0||h===1&&f===l-1&&f===d+1?"":t.slice(f,l)},format:r.bind(null,"/"),parse(t){k(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.charCodeAt(0)===$;let l;d?(f.root="/",l=1):l=0;let a=-1,h=0,g=-1,S=!0,w=t.length-1,E=0;for(;w>=l;--w){const y=t.charCodeAt(w);if(y===$){if(!S){h=w+1;break}continue}g===-1&&(S=!1,g=w+1),y===b?a===-1?a=w:E!==1&&(E=1):a!==-1&&(E=-1)}if(g!==-1){const y=h===0&&d?1:h;a===-1||E===0||E===1&&a===g-1&&a===h+1?f.base=f.name=t.slice(y,g):(f.name=t.slice(y,a),f.base=t.slice(y,g),f.ext=t.slice(a,g))}return h>0?f.dir=t.slice(0,h-1):d&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=c?e.$gc.normalize:e.$hc.normalize,e.$jc=c?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=c?e.$gc.join:e.$hc.join,e.$lc=c?e.$gc.resolve:e.$hc.resolve,e.$mc=c?e.$gc.relative:e.$hc.relative,e.$nc=c?e.$gc.dirname:e.$hc.dirname,e.$oc=c?e.$gc.basename:e.$hc.basename,e.$pc=c?e.$gc.extname:e.$hc.extname,e.$qc=c?e.$gc.format:e.$hc.format,e.$rc=c?e.$gc.parse:e.$hc.parse,e.$sc=c?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=c?e.$gc.sep:e.$hc.sep,e.$uc=c?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,45,17]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=b,e.$4q=$,e.$5q=v,e.$6q=R,e.$7q=I,e.$8q=p,e.$9q=C,e.$0q=k,e.$$q=c,e.$_q=m,e.$ar=a,e.$br=h,e.$cr=g;const O=new u.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),A=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(S,w,E=!1){const y=S||"",D=w||"",P=O.value.collator.compare(y,D);return O.value.collatorIsNumeric&&P===0&&y!==D?y<D?-1:1:P}function $(S,w){const E=A.value.collator;return S=S||"",w=w||"",r(E,S,w)}function v(S,w){const E=A.value.collator;return S=S||"",w=w||"",d(S,w)||r(E,S,w)}function R(S,w){const E=A.value.collator;return S=S||"",w=w||"",f(S,w)||r(E,S,w)}function I(S,w){return S=S||"",w=w||"",S===w?0:S<w?-1:1}function p(S,w){const[E,y]=n(S),[D,P]=n(w);let z=O.value.collator.compare(y,P);if(z===0){if(O.value.collatorIsNumeric&&y!==P)return y<P?-1:1;if(z=O.value.collator.compare(E,D),O.value.collatorIsNumeric&&z===0&&E!==D)return E<D?-1:1}return z}function C(S,w){S=S||"",w=w||"";const E=i(S),y=i(w),D=A.value.collator,P=M.value.collator;return r(P,E,y)||r(D,S,w)}function k(S,w){S=S||"",w=w||"";const E=i(S),y=i(w),D=A.value.collator,P=M.value.collator;return r(P,E,y)||d(S,w)||r(D,S,w)}function c(S,w){S=S||"",w=w||"";const E=i(S),y=i(w),D=A.value.collator,P=M.value.collator;return r(P,E,y)||f(S,w)||r(D,S,w)}function m(S,w){S=S||"",w=w||"";const E=i(S).toLowerCase(),y=i(w).toLowerCase();return E!==y?E<y?-1:1:S!==w?S<w?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(S,w=!1){const E=S?o.exec(S):[];let y=[E&&E[1]||"",E&&E[3]||""];return w&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(S){const w=S?o.exec(S):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function r(S,w,E){const y=S.compare(w,E);return y!==0?y:w.length!==E.length?w.length<E.length?-1:1:0}function s(S){const w=S.charAt(0);return w.toLocaleUpperCase()!==w}function t(S){const w=S.charAt(0);return w.toLocaleLowerCase()!==w}function f(S,w){return s(S)&&t(w)?-1:t(S)&&s(w)?1:0}function d(S,w){return t(S)&&s(w)?-1:s(S)&&t(w)?1:0}function l(S,w,E=!1){return E||(S=S&&S.toLowerCase(),w=w&&w.toLowerCase()),S===w?0:S<w?-1:1}function a(S,w,E=!1){const y=S.split(L.sep),D=w.split(L.sep),P=y.length-1,z=D.length-1;let F,T;for(let j=0;;j++){if(F=P===j,T=z===j,F&&T)return b(y[j],D[j],E);if(F)return-1;if(T)return 1;const N=l(y[j],D[j],E);if(N!==0)return N}}function h(S,w,E){const y=S.toLowerCase(),D=w.toLowerCase(),P=g(S,w,E);if(P)return P;const z=y.endsWith(E),F=D.endsWith(E);if(z!==F)return z?-1:1;const T=b(y,D);return T!==0?T:y.localeCompare(D)}function g(S,w,E){const y=S.toLowerCase(),D=w.toLowerCase(),P=y.startsWith(E),z=D.startsWith(E);if(P!==z)return P?-1:1;if(P&&z){if(y.length<D.length)return-1;if(y.length>D.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=M,e.$cg=b,e.$dg=$,e.$eg=v,e.$fg=R,e.$gg=k,e.$hg=c,e.$ig=m,e.$jg=o,e.$kg=n,e.$lg=i,e.$mg=r,e.$ng=s,e.$og=t,e.$pg=f,e.$qg=a;function M(h){return h===47||h===92}function b(h){return h.replace(/[\\/]/g,u.$hc.sep)}function $(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function v(h,g=u.$hc.sep){if(!h)return"";const S=h.length,w=h.charCodeAt(0);if(M(w)){if(M(h.charCodeAt(1))&&!M(h.charCodeAt(2))){let y=3;const D=y;for(;y<S&&!M(h.charCodeAt(y));y++);if(D!==y&&!M(h.charCodeAt(y+1))){for(y+=1;y<S;y++)if(M(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,g)}}return g}else if(o(w)&&h.charCodeAt(1)===58)return M(h.charCodeAt(2))?h.slice(0,2)+g:h.slice(0,2);let E=h.indexOf("://");if(E!==-1){for(E+=3;E<S;E++)if(M(h.charCodeAt(E)))return h.slice(0,E+1)}return""}function R(h){if(!L.$i||!h||h.length<5)return!1;let g=h.charCodeAt(0);if(g!==92||(g=h.charCodeAt(1),g!==92))return!1;let S=2;const w=S;for(;S<h.length&&(g=h.charCodeAt(S),g!==92);S++);return!(w===S||(g=h.charCodeAt(S+1),isNaN(g)||g===92))}const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(h,g=L.$i){const S=g?I:p;return!(!h||h.length===0||/^\s+$/.test(h)||(S.lastIndex=0,S.test(h))||g&&C.test(h)||h==="."||h===".."||g&&h[h.length-1]==="."||g&&h.length!==h.trim().length||h.length>255)}function c(h,g,S){const w=h===g;return!S||w?w:!h||!g?!1:(0,O.$lf)(h,g)}function m(h,g,S,w=u.sep){if(h===g)return!0;if(!h||!g||g.length>h.length)return!1;if(S){if(!(0,O.$mf)(h,g))return!1;if(g.length===h.length)return!0;let y=g.length;return g.charAt(g.length-1)===w&&y--,h.charAt(y)===w}return g.charAt(g.length-1)!==w&&(g+=w),h.indexOf(g)===0}function o(h){return h>=65&&h<=90||h>=97&&h<=122}function n(h,g){return L.$i&&h.endsWith(":")&&(h+=u.sep),(0,u.$jc)(h)||(h=(0,u.$kc)(g,h)),h=(0,u.$ic)(h),L.$i?(h=(0,O.$6e)(h,u.sep),h.endsWith(":")&&(h+=u.sep)):(h=(0,O.$6e)(h,u.sep),h||(h=u.sep)),h}function i(h){const g=(0,u.$ic)(h);return L.$i?h.length>3?!1:r(g)&&(h.length===2||g.charCodeAt(2)===92):g===u.$hc.sep}function r(h,g=L.$i){return g?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}function s(h,g=L.$i){return r(h,g)?h[0]:void 0}function t(h,g,S){return g.length>h.length?-1:h===g?0:(S&&(h=h.toLowerCase(),g=g.toLowerCase()),h.indexOf(g))}function f(h){const g=h.split(":");let S,w,E;for(const y of g){const D=Number(y);(0,A.$Zf)(D)?w===void 0?w=D:E===void 0&&(E=D):S=S?[S,y].join(":"):y}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:w!==void 0?w:void 0,column:E!==void 0?E:w!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(h,g,S=8){let w="";for(let y=0;y<S;y++){let D;y===0&&L.$i&&!g&&(S===3||S===4)?D=l:D=d,w+=D.charAt(Math.floor(Math.random()*D.length))}let E;return g?E=`${g}-${w}`:E=w,h?(0,u.$kc)(h,E):E}}),define(ke[132],Ee([1,0,131,126,55,17,11,14]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=R,e.$er=m,e.$fr=d,e.$gr=E,e.$hr=T,e.$ir=N;const $=0,v=[$,[]];function R(B,W,Y,_){if(!B||!W)return v;const J=B.length,Z=W.length;if(J<Z)return v;const re=B.toLowerCase();return I(W,Y,Z,B,re,J,_)}function I(B,W,Y,_,J,Z,re){const ee=[],pe=[];for(let ie=0;ie<Y;ie++){const be=ie*Z,Ce=be-Z,ae=ie>0,ce=B[ie],se=W[ie];for(let K=0;K<Z;K++){const te=K>0,le=be+K,de=le-1,Ae=Ce+K-1,me=te?ee[de]:0,Ie=ae&&te?ee[Ae]:0,Re=ae&&te?pe[Ae]:0;let Fe;!Ie&&ae?Fe=0:Fe=p(ce,se,_,J,K,Re),Fe&&Ie+Fe>=me&&(re||ae||J.startsWith(W,K))?(pe[le]=Re+1,ee[le]=Ie+Fe):(pe[le]=$,ee[le]=me)}}const De=[];let x=Y-1,U=Z-1;for(;x>=0&&U>=0;){const ie=x*Z+U;pe[ie]===$||(De.push(U),x--),U--}return[ee[Y*Z-1],De.reverse()]}function p(B,W,Y,_,J,Z){let re=0;if(!C(W,_[J]))return re;if(re+=1,Z>0&&(re+=Z*5),B===Y[J]&&(re+=1),J===0)re+=8;else{const ee=k(Y.charCodeAt(J-1));ee?re+=ee:(0,L.$nk)(Y.charCodeAt(J))&&Z===0&&(re+=2)}return re}function C(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function k(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function m(B,W,Y=0,_=0){const J=W;return J.values&&J.values.length>1?o(B,J.values,Y,_):n(B,W,Y,_)}function o(B,W,Y,_){let J=0;const Z=[];for(const re of W){const[ee,pe]=n(B,re,Y,_);if(typeof ee!="number")return c;J+=ee,Z.push(...pe)}return[J,S(Z)]}function n(B,W,Y,_){const J=(0,L.$wk)(W.original,W.originalLowercase,Y,B,B.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,L.$tk)(J)]:c}const i=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function f(B,W,Y,_){const J=_.values?_.values:[_];return(0,O.$9i)({[_.normalized]:{values:J.map(re=>({value:re.normalized,expectContiguousMatch:re.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:Y}})}function d(B,W,Y,_,J){if(!B||!W.normalized)return i;const Z=_.getItemLabel(B);if(!Z)return i;const re=_.getItemDescription(B),ee=f(Z,re,Y,W),pe=J[ee];if(pe)return pe;const De=l(Z,re,_.getItemPath(B),W,Y);return J[ee]=De,De}function l(B,W,Y,_,J){const Z=!Y||!_.containsPathSeparator;return Y&&(M.$k?_.pathNormalized===Y:(0,b.$lf)(_.pathNormalized,Y))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:_.values&&_.values.length>1?a(B,W,Y,_.values,Z,J):h(B,W,Y,_,Z,J)}function a(B,W,Y,_,J,Z){let re=0;const ee=[],pe=[];for(const De of _){const{score:x,labelMatch:U,descriptionMatch:ie}=h(B,W,Y,De,J,Z);if(x===$)return i;re+=x,U&&ee.push(...U),ie&&pe.push(...ie)}return{score:re,labelMatch:S(ee),descriptionMatch:S(pe)}}function h(B,W,Y,_,J,Z){if(J||!W){const[re,ee]=R(B,_.normalized,_.normalizedLowercase,Z&&!_.expectContiguousMatch);if(re){const pe=(0,L.$kk)(_.normalized,B);let De;if(pe){De=s;const x=Math.round(_.normalized.length/B.length*100);De+=x}else De=t;return{score:De+re,labelMatch:pe||g(ee)}}}if(W){let re=W;Y&&(re=`${W}${A.sep}`);const ee=re.length,pe=`${re}${B}`,[De,x]=R(pe,_.normalized,_.normalizedLowercase,Z&&!_.expectContiguousMatch);if(De){const U=g(x),ie=[],be=[];return U.forEach(Ce=>{Ce.start<ee&&Ce.end>ee?(ie.push({start:0,end:Ce.end-ee}),be.push({start:Ce.start,end:ee})):Ce.start>=ee?ie.push({start:Ce.start-ee,end:Ce.end-ee}):be.push(Ce)}),{score:De,labelMatch:ie,descriptionMatch:be}}}return i}function g(B){const W=[];if(!B)return W;let Y;for(const _ of B)Y&&Y.end===_?Y.end+=1:(Y={start:_,end:_+1},W.push(Y));return W}function S(B){const W=B.sort((J,Z)=>J.start-Z.start),Y=[];let _;for(const J of W)!_||!w(_,J)?(_=J,Y.push(J)):(_.start=Math.min(_.start,J.start),_.end=Math.max(_.end,J.end));return Y}function w(B,W){return!(B.end<W.start||W.end<B.start)}function E(B,W,Y,_,J,Z){const re=d(B,Y,_,J,Z),ee=d(W,Y,_,J,Z),pe=re.score,De=ee.score;if((pe===r||De===r)&&pe!==De)return pe===r?-1:1;if(pe>t||De>t){if(pe!==De)return pe>De?-1:1;if(pe<s&&De<s){const ce=D(re.labelMatch,ee.labelMatch);if(ce!==0)return ce}const Ce=J.getItemLabel(B)||"",ae=J.getItemLabel(W)||"";if(Ce.length!==ae.length)return Ce.length-ae.length}if(pe!==De)return pe>De?-1:1;const x=Array.isArray(re.labelMatch)&&re.labelMatch.length>0,U=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(x&&!U)return-1;if(U&&!x)return 1;const ie=y(B,re,J),be=y(W,ee,J);return ie&&be&&ie!==be?be>ie?-1:1:P(B,W,Y,J)}function y(B,W,Y){let _=-1,J=-1;if(W.descriptionMatch&&W.descriptionMatch.length?_=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(_=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(J=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Z=Y.getItemDescription(B);Z&&(J+=Z.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(J=W.descriptionMatch[W.descriptionMatch.length-1].end);return J-_}function D(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const Y=B[0].start,J=B[B.length-1].end-Y,Z=W[0].start,ee=W[W.length-1].end-Z;return J===ee?0:ee<J?1:-1}function P(B,W,Y,_){const J=_.getItemLabel(B)||"",Z=_.getItemLabel(W)||"",re=_.getItemDescription(B),ee=_.getItemDescription(W),pe=J.length+(re?re.length:0),De=Z.length+(ee?ee.length:0);if(pe!==De)return pe-De;const x=_.getItemPath(B),U=_.getItemPath(W);return x&&U&&x.length!==U.length?x.length-U.length:J!==Z?(0,u.$br)(J,Z,Y.normalized):re&&ee&&re!==ee?(0,u.$br)(re,ee,Y.normalized):x&&U&&x!==U?(0,u.$br)(x,U,Y.normalized):0}function z(B){return B.startsWith('"')&&B.endsWith('"')}const F=" ";function T(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:Y,normalized:_,normalizedLowercase:J}=j(B),Z=Y.indexOf(A.sep)>=0,re=z(B);let ee;const pe=B.split(F);if(pe.length>1)for(const De of pe){const x=z(De),{pathNormalized:U,normalized:ie,normalizedLowercase:be}=j(De);ie&&(ee||(ee=[]),ee.push({original:De,originalLowercase:De.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:be,expectContiguousMatch:x}))}return{original:B,originalLowercase:W,pathNormalized:Y,normalized:_,normalizedLowercase:J,values:ee,containsPathSeparator:Z,expectContiguousMatch:re}}function j(B){let W;M.$i?W=B.replace(/\//g,A.sep):W=B.replace(/\\/g,A.sep);const Y=(0,b.$8e)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:Y,normalizedLowercase:Y.toLowerCase()}}function N(B){return Array.isArray(B)?T(B.map(W=>W.original).join(F)):T(B.original)}}),define(ke[101],Ee([1,0,17]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0,e.$As=A,e.$Bs=M,e.$Cs=b,e.$Ds=v,e.$zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const I=(0,u.$pc)(R),p=L[I.toLowerCase()];return p!==void 0?p:M(R)}function M(R){const I=(0,u.$pc)(R);return O[I.toLowerCase()]}function b(R){for(const I in O)if(O[I]===R)return I}const $=/^(.+)\/(.+?)(;.+)?$/;function v(R,I){const p=$.exec(R);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:R}}),define(ke[102],Ee([1,0,11]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$$l=A,e.$_l=M;var L;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(L||(e.Source=L={}));var O;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function A(b,...$){const v=$.reduce((p,C)=>(p[C]=!0,p),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!v[p]).forEach(p=>{for(let C=0;C<R.length;C++)if(p.search(R[C])!==-1){delete b[p];break}})}function M(b){b&&(delete b.DEBUG,u.$j&&delete b.DYLD_LIBRARY_PATH,u.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=k,e.$xc=r;const O=/^\w[\w\d+.-]*$/,A=/^\//,M=/^\/\//;function b(l,a){if(!l.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!O.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!A.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(l,a){return!l&&!a?"file":l}function v(l,a){switch(l){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const R="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(a){return a instanceof C?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,h,g,S,w,E=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=$(a,E),this.authority=h||R,this.path=v(this.scheme,g||R),this.query=S||R,this.fragment=w||R,b(this,E))}get fsPath(){return r(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:g,path:S,query:w,fragment:E}=a;return h===void 0?h=this.scheme:h===null&&(h=R),g===void 0?g=this.authority:g===null&&(g=R),S===void 0?S=this.path:S===null&&(S=R),w===void 0?w=this.query:w===null&&(w=R),E===void 0?E=this.fragment:E===null&&(E=R),h===this.scheme&&g===this.authority&&S===this.path&&w===this.query&&E===this.fragment?this:new m(h,g,S,w,E)}static parse(a,h=!1){const g=p.exec(a);return g?new m(g[2]||R,d(g[4]||R),d(g[5]||R),d(g[7]||R),d(g[9]||R),h):new m(R,R,R,R,R)}static file(a){let h=R;if(L.$i&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const g=a.indexOf(I,2);g===-1?(h=a.substring(2),a=I):(h=a.substring(2,g),a=a.substring(g)||I)}return new m("file",h,a,R,R)}static from(a,h){return new m(a.scheme,a.authority,a.path,a.query,a.fragment,h)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return L.$i&&a.scheme==="file"?g=C.file(u.$gc.join(r(a,!0),...h)).path:g=u.$hc.join(a.path,...h),a.with({path:g})}toString(a=!1){return s(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof C)return a;{const h=new m(a);return h._formatted=a.external??null,h._fsPath=a._sep===c?a.fsPath??null:null,h}}else return a}}e.URI=C;function k(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const c=L.$i?1:void 0;class m extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(a=!1){return a?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=c),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,a,h){let g,S=-1;for(let w=0;w<l.length;w++){const E=l.charCodeAt(w);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||a&&E===47||h&&E===91||h&&E===93||h&&E===58)S!==-1&&(g+=encodeURIComponent(l.substring(S,w)),S=-1),g!==void 0&&(g+=l.charAt(w));else{g===void 0&&(g=l.substr(0,w));const y=o[E];y!==void 0?(S!==-1&&(g+=encodeURIComponent(l.substring(S,w)),S=-1),g+=y):S===-1&&(S=w)}}return S!==-1&&(g+=encodeURIComponent(l.substring(S))),g!==void 0?g:l}function i(l){let a;for(let h=0;h<l.length;h++){const g=l.charCodeAt(h);g===35||g===63?(a===void 0&&(a=l.substr(0,h)),a+=o[g]):a!==void 0&&(a+=l[h])}return a!==void 0?a:l}function r(l,a){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?a?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,L.$i&&(h=h.replace(/\//g,"\\")),h}function s(l,a){const h=a?i:n;let g="",{scheme:S,authority:w,path:E,query:y,fragment:D}=l;if(S&&(g+=S,g+=":"),(w||S==="file")&&(g+=I,g+=I),w){let P=w.indexOf("@");if(P!==-1){const z=w.substr(0,P);w=w.substr(P+1),P=z.lastIndexOf(":"),P===-1?g+=h(z,!1,!1):(g+=h(z.substr(0,P),!1,!1),g+=":",g+=h(z.substr(P+1),!1,!0)),g+="@"}w=w.toLowerCase(),P=w.lastIndexOf(":"),P===-1?g+=h(w,!1,!0):(g+=h(w.substr(0,P),!1,!0),g+=w.substr(P))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const P=E.charCodeAt(1);P>=65&&P<=90&&(E=`/${String.fromCharCode(P+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const P=E.charCodeAt(0);P>=65&&P<=90&&(E=`${String.fromCharCode(P+32)}:${E.substr(2)}`)}g+=h(E,!0,!1)}return y&&(g+="?",g+=h(y,!1,!1)),D&&(g+="#",g+=a?D:n(D,!1,!1)),g}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(f)?l.replace(f,a=>t(a)):l}}),define(ke[191],Ee([1,0,2]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=L,e.$Gq=O,e.$Hq=A,e.log=b;function L(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function O(v){const R=[];let I;try{const p=JSON.parse(v.arguments),C=p[p.length-1];C&&C.__$stack&&(p.pop(),I=C.__$stack),R.push(...p)}catch{R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:I}}function A(v){if(typeof v!="string")return A(O(v).stack);const R=v;if(R){const I=M(R),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:u.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function M(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function b(v,R){const{args:I,stack:p}=O(v),C=typeof I[0]=="string"&&I.length===1;let k=M(p);k&&(k=`(${k.trim()})`);let c=[];if(typeof I[0]=="string"?k&&C?c=[`%c[${R}] %c${I[0]} %c${k}`,$("blue"),$(""),$("grey")]:c=[`%c[${R}] %c${I[0]}`,$("blue"),$(""),...I.slice(1)]:c=[`%c[${R}]%`,$("blue"),...I],k&&!C&&c.push(k),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,c)}function $(v){return`color: ${v}`}}),define(ke[57],Ee([1,0,21,2]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=O,e.$Qh=A,e.$Rh=b;function O($){return JSON.stringify($,M)}function A($){let v=JSON.parse($);return v=b(v),v}function M($,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:v.flags}:v}function b($,v=0){if(!$||v>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return L.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof u.$ue||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let R=0;R<$.length;++R)$[R]=b($[R],v+1);else for(const R in $)Object.hasOwnProperty.call($,R)&&($[R]=b($[R],v+1))}return $}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=$,e.$sg=v,e.$wg=I;var b;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeManagedRemoteResource="vscode-managed-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.vscodeChatCodeBlock="vscode-chat-code-block",k.vscodeChatSesssion="vscode-chat-editor",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm",k.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(k,c){return A.URI.isUri(k)?(0,O.$lf)(k.scheme,c):(0,O.$mf)(k,c+":")}function v(k,...c){return c.some(m=>$(k,m))}e.$tg="vscode-tkn",e.$ug="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,m){this.f=I(c,m)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,b.vscodeRemoteResource)}set(c,m,o){this.a[c]=m,this.b[c]=o}setConnectionToken(c,m){this.c[c]=m}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(s){return u.$1(s),c}const m=c.authority;let o=this.a[m];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[m],i=this.c[m];let r=`path=${encodeURIComponent(c.path)}`;return typeof i=="string"&&(r+=`&${e.$ug}=${encodeURIComponent(i)}`),A.URI.from({scheme:L.$o?this.d:b.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:r})}}e.$vg=new R;function I(k,c){return M.$hc.join(c??"/",`${k.quality??"oss"}-${k.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class p{static{this.a=e.$Bg}asBrowserUri(c){const m=this.b(c,he);return this.uriToBrowserUri(m)}uriToBrowserUri(c){return c.scheme===b.vscodeRemote?e.$vg.rewrite(c):c.scheme===b.file&&(L.$m||L.$q===`${b.vscodeFileResource}://${p.a}`)?c.with({scheme:b.vscodeFileResource,authority:c.authority||p.a,query:null,fragment:null}):c}asFileUri(c){const m=this.b(c,he);return this.uriToFileUri(m)}uriToFileUri(c){return c.scheme===b.vscodeFileResource?c.with({scheme:b.file,authority:c.authority!==p.a?c.authority:null,query:null,fragment:null}):c}b(c,m){return A.URI.isUri(c)?c:A.URI.parse(m.toUrl(c))}}e.$Cg=new p;var C;(function(k){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(c.get("3"));const m="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:A.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const s=r?.get(m);if(s)return c.get(s)}k.getHeadersFromQuery=o;function n(i,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(m,t):i[m]=t}k.addSearchParam=n})(C||(e.COI=C={}))}),define(ke[192],Ee([1,0,161,15,11,2]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JD=R;class M{constructor(p,C,k){this.id=p,this.dependencies=C,this.callback=k}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,C,k)=>{typeof p!="string"&&(k=C,C=p,p=null),(typeof C!="object"||!Array.isArray(C))&&(k=C,C=null),this.c.push(new M(p,C,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const C=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!C)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(C.dependencies)&&C.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${C.dependencies.join(", ")}`);return typeof C.callback=="function"?C.callback([]):C.callback}h(p){return new Promise((C,k)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",o),c.removeEventListener("error",n)},o=i=>{m(),C(this.c.pop())},n=i=>{m(),k(i)};c.addEventListener("load",o),c.addEventListener("error",n),this.f&&(p=this.f.createScriptURL(p)),c.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(p){return new Promise((C,k)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),C(this.c.pop())}catch(c){k(c)}})}async j(p){try{const C=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(p).fsPath,o=C.readFileSync(m).toString(),n=c.wrap(o.replace(/^#!.*/,""));return new k.Script(n).runInThisContext().apply(),this.c.pop()}catch(C){throw C}}}const $=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function R(I,p,C){if(u.$T){C===void 0&&(C=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[I]&&(I=v[I]);const k=`${I}/${p}`;if($.has(k))return $.get(k);let c;if(/^\w[\w\d+.-]*:\/\//.test(k))c=k;else{const i=`${C&&!O.$o?L.$zg:L.$yg}/${k}`;c=L.$Cg.asBrowserUri(i).toString(!0)}const m=b.INSTANCE.load(c);return $.set(k,m),m}else return await new Promise((k,c)=>{he([I],k,c)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=$,e.$5g=R,e.$6g=p;function $(C){return(0,b.$xc)(C,!0)}class v{constructor(k){this.a=k}compare(k,c,m=!1){return k===c?0:(0,M.$ef)(this.getComparisonKey(k,m),this.getComparisonKey(c,m))}isEqual(k,c,m=!1){return k===c?!0:!k||!c?!1:this.getComparisonKey(k,m)===this.getComparisonKey(c,m)}getComparisonKey(k,c=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,c,m=!1){if(k.scheme===c.scheme){if(k.scheme===L.Schemas.file)return u.$ig($(k),$(c),this.a(k))&&k.query===c.query&&(m||k.fragment===c.fragment);if((0,e.$1g)(k.authority,c.authority))return u.$ig(k.path,c.path,this.a(k),"/")&&k.query===c.query&&(m||k.fragment===c.fragment)}return!1}joinPath(k,...c){return b.URI.joinPath(k,...c)}basenameOrAuthority(k){return(0,e.$Sg)(k)||k.authority}basename(k){return O.$hc.basename(k.path)}extname(k){return O.$hc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let c;return k.scheme===L.Schemas.file?c=b.URI.file(O.$nc($(k))).path:(c=O.$hc.dirname(k.path),k.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),c="/")),k.with({path:c})}normalizePath(k){if(!k.path.length)return k;let c;return k.scheme===L.Schemas.file?c=b.URI.file(O.$ic($(k))).path:c=O.$hc.normalize(k.path),k.with({path:c})}relativePath(k,c){if(k.scheme!==c.scheme||!(0,e.$1g)(k.authority,c.authority))return;if(k.scheme===L.Schemas.file){const n=O.$mc($(k),$(c));return A.$i?u.$cg(n):n}let m=k.path||"/";const o=c.path||"/";if(this.a(k)){let n=0;for(const i=Math.min(m.length,o.length);n<i&&!(m.charCodeAt(n)!==o.charCodeAt(n)&&m.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);m=o.substr(0,n)+m.substr(n)}return O.$hc.relative(m,o)}resolvePath(k,c){if(k.scheme===L.Schemas.file){const m=b.URI.file(O.$lc($(k),c));return k.with({authority:m.authority,path:m.path})}return c=u.$dg(c),k.with({path:O.$hc.resolve(k.path,c)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,c){return k===c||k!==void 0&&c!==void 0&&(0,M.$lf)(k,c)}hasTrailingPathSeparator(k,c=O.sep){if(k.scheme===L.Schemas.file){const m=$(k);return m.length>u.$eg(m).length&&m[m.length-1]===c}else{const m=k.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,c=O.sep){return(0,e.$2g)(k,c)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,c=O.sep){let m=!1;if(k.scheme===L.Schemas.file){const o=$(k);m=o!==void 0&&o.length===u.$eg(o).length&&o[o.length-1]===c}else{c="/";const o=k.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.$2g)(k,c)?k.with({path:k.path+"/"}):k}}e.$Kg=v,e.$Lg=new v(()=>!1),e.$Mg=new v(C=>C.scheme===L.Schemas.file?!A.$k:!0),e.$Ng=new v(C=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function R(C,k){const c=[];for(let m=0;m<C.length;m++){const o=k(C[m]);C.some((n,i)=>i===m?!1:(0,e.$Pg)(o,k(n)))||c.push(C[m])}return c}var I;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function k(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,s]=i.split(":");r&&s&&m.set(r,s)});const n=c.path.substring(0,c.path.indexOf(";"));return n&&m.set(C.META_DATA_MIME,n),m}C.parseMetaData=k})(I||(e.DataUri=I={}));function p(C,k,c){if(k){let m=C.path;return m&&m[0]!==O.$hc.sep&&(m=O.$hc.sep+m),C.with({scheme:c,authority:k,path:m})}return C.with({scheme:c})}}),define(ke[8],Ee([1,0,22,13,4,3,23,11,168,45]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=R,e.$8g=I,e.$9g=p,e.$0g=C,e.$$g=k,e.$_g=c,e.$ah=m,e.$bh=o,e.$jh=h,e.$kh=g,e.$lh=S,e.$mh=w,e.$nh=E,e.$Ch=J,e.$Kh=ae;function R(se){return!!se&&typeof se.then=="function"}function I(se){const K=new u.$ee,te=se(K.token),le=new Promise((de,Ae)=>{const me=K.token.onCancellationRequested(()=>{me.dispose(),Ae(new L.$5)});Promise.resolve(te).then(Ie=>{me.dispose(),K.dispose(),de(Ie)},Ie=>{me.dispose(),K.dispose(),Ae(Ie)})});return new class{cancel(){K.cancel(),K.dispose()}then(de,Ae){return le.then(de,Ae)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function p(se,K,te){return new Promise((le,de)=>{const Ae=K.onCancellationRequested(()=>{Ae.dispose(),le(te)});se.then(le,de).finally(()=>Ae.dispose())})}function C(se,K){return new Promise((te,le)=>{const de=K.onCancellationRequested(()=>{de.dispose(),le(new L.$5)});se.then(te,le).finally(()=>de.dispose())})}async function k(se){let K=-1;const te=se.map((le,de)=>le.then(Ae=>(K=de,Ae)));try{return await Promise.race(te)}finally{se.forEach((le,de)=>{de!==K&&le.cancel()})}}function c(se,K,te){let le;const de=setTimeout(()=>{le?.(void 0),te?.()},K);return Promise.race([se.finally(()=>clearTimeout(de)),new Promise(Ae=>le=Ae)])}function m(se){return new Promise((K,te)=>{const le=se();R(le)?le.then(K,te):K(le)})}function o(){let se,K;return{promise:new Promise((le,de)=>{se=le,K=de}),resolve:se,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const te=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(te,te).then(le)})}return new Promise((te,le)=>{this.b.then(te,le)})}return this.a=K(),new Promise((te,le)=>{this.a.then(de=>{this.a=null,te(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$ch=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$dh=i;class r{constructor(){this.a=new Map}queue(K,te){const de=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(K)===de&&this.a.delete(K)});return this.a.set(K,de),de}}e.$eh=r;const s=(se,K)=>{let te=!0;const le=setTimeout(()=>{te=!1,K()},se);return{isTriggered:()=>te,dispose:()=>{clearTimeout(le),te=!1}}},t=se=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,se())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class f{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,te=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((de,Ae)=>{this.d=de,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=te===$.$4d?t(le):s(te,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=f;class d{constructor(K){this.a=new f(K),this.b=new n}trigger(K,te){return this.a.trigger(()=>this.b.queue(K),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=d;class l{constructor(){this.a=!1,this.b=new Promise((K,te)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=l;class a extends l{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$ih=a;function h(se,K){return K?new Promise((te,le)=>{const de=setTimeout(()=>{Ae.dispose(),te()},se),Ae=K.onCancellationRequested(()=>{clearTimeout(de),Ae.dispose(),le(new L.$5)})}):I(te=>h(se,te))}function g(se,K=0,te){const le=setTimeout(()=>{se(),te&&de.dispose()},K),de=(0,A.$Sc)(()=>{clearTimeout(le),te?.deleteAndLeak(de)});return te?.add(de),de}function S(se){const K=[];let te=0;const le=se.length;function de(){return te<le?se[te++]():null}function Ae(me){me!=null&&K.push(me);const Ie=de();return Ie?Ie.then(Ae):Promise.resolve(K)}return Promise.resolve(null).then(Ae)}function w(se,K=le=>!!le,te=null){let le=0;const de=se.length,Ae=()=>{if(le>=de)return Promise.resolve(te);const me=se[le++];return Promise.resolve(me()).then(Re=>K(Re)?Promise.resolve(Re):Ae())};return Ae()}function E(se,K=le=>!!le,te=null){if(se.length===0)return Promise.resolve(te);let le=se.length;const de=()=>{le=-1;for(const Ae of se)Ae.cancel?.()};return new Promise((Ae,me)=>{for(const Ie of se)Ie.then(Re=>{--le>=0&&K(Re)?(de(),Ae(Re)):le===0&&Ae(te)}).catch(Re=>{--le>=0&&(de(),me(Re))})})}class y{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new O.$7d}whenIdle(){return this.size>0?O.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,le)=>{this.g.push({factory:K,c:te,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const te=K.factory();te.then(K.c,K.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=y;class D extends y{constructor(){super(1)}}e.$ph=D;class P{constructor(){this.a=new Z,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$qh=P;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new pe;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,te=M.$Lg){const le=te.getComparisonKey(K);return this.a.get(le)?.size??0}queueFor(K,te,le=M.$Lg){const de=le.getComparisonKey(K);let Ae=this.a.get(de);if(!Ae){Ae=new D;const me=this.f++,Ie=O.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(me,Ie),this.a.set(de,Ae)}return Ae.queue(te)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=z;class F{constructor(K,te){this.a=-1,typeof K=="function"&&typeof te=="number"&&this.setIfNotSet(K,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},te)}setIfNotSet(K,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},te))}}e.$sh=F;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,te,le=globalThis){this.cancel();const de=le.setInterval(()=>{K()},te);this.d=(0,A.$Sc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$th=T;class j{constructor(K,te){this.b=-1,this.a=K,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=j;class N{constructor(K,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=K,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=N;class B extends j{constructor(K,te){super(K,te),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$wh=B;class W extends A.$Uc{constructor(K,te){super(),this.g=K,this.h=te,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of K)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(se,K)=>{(0,b.$B)(()=>{if(te)return;const le=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$zh=(se,K,te)=>{const le=se.requestIdleCallback(K,typeof te=="number"?{timeout:te}:void 0);let de=!1;return{dispose(){de||(de=!0,se.cancelIdleCallback(le))}}},e.$yh=se=>(0,e.$zh)(globalThis,se)}();class Y{constructor(K,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$zh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=Y;class _ extends Y{constructor(K){super(globalThis,K)}}e.$Bh=_;async function J(se,K,te){let le;for(let de=0;de<te;de++)try{return await se()}catch(Ae){le=Ae,await h(K)}throw le}class Z{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,te,le){return this.a={taskId:K,cancel:()=>le?.(),promise:te},te.then(()=>this.d(K),()=>this.d(K)),te}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:te,resolve:le,reject:de}=o();this.b={run:K,promise:te,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=Z;class re{constructor(K,te=()=>Date.now()){this.d=K,this.f=te,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Eh=re;var ee;(function(se){se[se.Resolved=0]="Resolved",se[se.Rejected=1]="Rejected"})(ee||(ee={}));class pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,te)=>{this.a=K,this.b=te})}complete(K){return new Promise(te=>{this.a(K),this.d={outcome:0,value:K},te()})}error(K){return new Promise(te=>{this.b(K),this.d={outcome:1,value:K},te()})}cancel(){return this.error(new L.$5)}}e.$Fh=pe;var De;(function(se){async function K(le){let de;const Ae=await Promise.all(le.map(me=>me.then(Ie=>Ie,Ie=>{de||(de=Ie)})));if(typeof de<"u")throw de;return Ae}se.settled=K;function te(le){return new Promise(async(de,Ae)=>{try{await le(de,Ae)}catch(me){Ae(me)}})}se.withAsyncBody=te})(De||(e.Promises=De={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=x;class U{constructor(K){this.b=K,this.a=new v.$V(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=U;var ie;(function(se){se[se.Initial=0]="Initial",se[se.DoneOK=1]="DoneOK",se[se.DoneError=2]="DoneError"})(ie||(ie={}));class be{static fromArray(K){return new be(te=>{te.emitMany(K)})}static fromPromise(K){return new be(async te=>{te.emitMany(await K)})}static fromPromises(K){return new be(async te=>{await Promise.all(K.map(async le=>te.emitOne(await le)))})}static merge(K){return new be(async te=>{await Promise.all(K.map(async le=>{for await(const de of le)te.emitOne(de)}))})}static{this.EMPTY=be.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new O.$7d,queueMicrotask(async()=>{const te={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(K(te)),this.j()}catch(le){this.k(le)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await O.Event.toPromise(this.f.event)}while(!0)}}}static map(K,te){return new be(async le=>{for await(const de of K)le.emitOne(te(de))})}map(K){return be.map(this,K)}static filter(K,te){return new be(async le=>{for await(const de of K)te(de)&&le.emitOne(de)})}filter(K){return be.filter(this,K)}static coalesce(K){return be.filter(K,te=>!!te)}coalesce(){return be.coalesce(this)}static async toPromise(K){const te=[];for await(const le of K)te.push(le);return te}toPromise(){return be.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$Ih=be;class Ce extends be{constructor(K,te){super(te),this.l=K}cancel(){this.l.cancel()}}e.$Jh=Ce;function ae(se){const K=new u.$ee,te=se(K.token);return new Ce(K,async le=>{const de=K.token.onCancellationRequested(()=>{de.dispose(),K.dispose(),le.reject(new L.$5)});try{for await(const Ae of te){if(K.token.isCancellationRequested)return;le.emitOne(Ae)}de.dispose(),K.dispose()}catch(Ae){de.dispose(),K.dispose(),le.reject(Ae)}})}class ce{constructor(){this.a=new pe,this.b=new be(le=>{if(K){le.reject(K);return}return te&&le.emitMany(te),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let K,te;this.f=le=>{te||(te=[]),te.push(le)},this.d=le=>{K||(K=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Lh=ce}),define(ke[35],Ee([1,0,19,8,34,27,17,11,14]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=v,e.$ak=k,e.$bk=D,e.$ck=P,e.$dk=z,e.$ek=F,e.$fk=T,e.$gk=W;function v(){return Object.create(null)}e.$$j="**",e.$_j="/";const R="[/\\\\]",I="[^/\\\\]",p=/\//g;function C(Y,_){switch(Y){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${_?`|${R}${I}+`:""})*?`}}function k(Y,_){if(!Y)return[];const J=[];let Z=!1,re=!1,ee="";for(const pe of Y){switch(pe){case _:if(!Z&&!re){J.push(ee),ee="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":re=!0;break;case"]":re=!1;break}ee+=pe}return ee&&J.push(ee),J}function c(Y){if(!Y)return"";let _="";const J=k(Y,e.$_j);if(J.every(Z=>Z===e.$$j))_=".*";else{let Z=!1;J.forEach((re,ee)=>{if(re===e.$$j){if(Z)return;_+=C(2,ee===J.length-1)}else{let pe=!1,De="",x=!1,U="";for(const ie of re){if(ie!=="}"&&pe){De+=ie;continue}if(x&&(ie!=="]"||!U)){let be;ie==="-"?be=ie:(ie==="^"||ie==="!")&&!U?be="^":ie===e.$_j?be="":be=(0,$.$Ze)(ie),U+=be;continue}switch(ie){case"{":pe=!0;continue;case"[":x=!0;continue;case"}":{const Ce=`(?:${k(De,",").map(ae=>c(ae)).join("|")})`;_+=Ce,pe=!1,De="";break}case"]":{_+="["+U+"]",x=!1,U="";break}case"?":_+=I;continue;case"*":_+=C(1);continue;default:_+=(0,$.$Ze)(ie)}}ee<J.length-1&&(J[ee+1]!==e.$$j||ee+2<J.length)&&(_+=R)}Z=re===e.$$j})}return _}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Ec(1e4),f=function(){return!1},d=function(){return null};function l(Y,_){if(!Y)return d;let J;typeof Y!="string"?J=Y.pattern:J=Y,J=J.trim();const Z=`${J}_${!!_.trimForExclusions}`;let re=t.get(Z);if(re)return a(re,Y);let ee;return m.test(J)?re=g(J.substr(4),J):(ee=o.exec(h(J,_)))?re=S(ee[1],J):(_.trimForExclusions?i:n).test(J)?re=w(J,_):(ee=r.exec(h(J,_)))?re=E(ee[1].substr(1),J,!0):(ee=s.exec(h(J,_)))?re=E(ee[1],J,!1):re=y(J),t.set(Z,re),a(re,Y)}function a(Y,_){if(typeof _=="string")return Y;const J=function(Z,re){return(0,O.$ig)(Z,_.base,!b.$k)?Y((0,$.$5e)(Z.substr(_.base.length),M.sep),re):null};return J.allBasenames=Y.allBasenames,J.allPaths=Y.allPaths,J.basenames=Y.basenames,J.patterns=Y.patterns,J}function h(Y,_){return _.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function g(Y,_){return function(J,Z){return typeof J=="string"&&J.endsWith(Y)?_:null}}function S(Y,_){const J=`/${Y}`,Z=`\\${Y}`,re=function(pe,De){return typeof pe!="string"?null:De?De===Y?_:null:pe===Y||pe.endsWith(J)||pe.endsWith(Z)?_:null},ee=[Y];return re.basenames=ee,re.patterns=[_],re.allBasenames=ee,re}function w(Y,_){const J=B(Y.slice(1,-1).split(",").map(De=>l(De,_)).filter(De=>De!==d),Y),Z=J.length;if(!Z)return d;if(Z===1)return J[0];const re=function(De,x){for(let U=0,ie=J.length;U<ie;U++)if(J[U](De,x))return Y;return null},ee=J.find(De=>!!De.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const pe=J.reduce((De,x)=>x.allPaths?De.concat(x.allPaths):De,[]);return pe.length&&(re.allPaths=pe),re}function E(Y,_,J){const Z=M.sep===M.$hc.sep,re=Z?Y:Y.replace(p,M.sep),ee=M.sep+re,pe=M.$hc.sep+Y;let De;return J?De=function(x,U){return typeof x=="string"&&(x===re||x.endsWith(ee)||!Z&&(x===Y||x.endsWith(pe)))?_:null}:De=function(x,U){return typeof x=="string"&&(x===re||!Z&&x===Y)?_:null},De.allPaths=[(J?"*/":"./")+Y],De}function y(Y){try{const _=new RegExp(`^${c(Y)}$`);return function(J){return _.lastIndex=0,typeof J=="string"&&_.test(J)?Y:null}}catch{return d}}function D(Y,_,J){return!Y||typeof _!="string"?!1:P(Y)(_,void 0,J)}function P(Y,_={}){if(!Y)return f;if(typeof Y=="string"||z(Y)){const J=l(Y,_);if(J===d)return f;const Z=function(re,ee){return!!J(re,ee)};return J.allBasenames&&(Z.allBasenames=J.allBasenames),J.allPaths&&(Z.allPaths=J.allPaths),Z}return j(Y,_)}function z(Y){const _=Y;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}function F(Y){return Y.allBasenames||[]}function T(Y){return Y.allPaths||[]}function j(Y,_){const J=B(Object.getOwnPropertyNames(Y).map(De=>N(De,Y[De],_)).filter(De=>De!==d)),Z=J.length;if(!Z)return d;if(!J.some(De=>!!De.requiresSiblings)){if(Z===1)return J[0];const De=function(ie,be){let Ce;for(let ae=0,ce=J.length;ae<ce;ae++){const se=J[ae](ie,be);if(typeof se=="string")return se;(0,L.$7g)(se)&&(Ce||(Ce=[]),Ce.push(se))}return Ce?(async()=>{for(const ae of Ce){const ce=await ae;if(typeof ce=="string")return ce}return null})():null},x=J.find(ie=>!!ie.allBasenames);x&&(De.allBasenames=x.allBasenames);const U=J.reduce((ie,be)=>be.allPaths?ie.concat(be.allPaths):ie,[]);return U.length&&(De.allPaths=U),De}const re=function(De,x,U){let ie,be;for(let Ce=0,ae=J.length;Ce<ae;Ce++){const ce=J[Ce];ce.requiresSiblings&&U&&(x||(x=(0,M.$oc)(De)),ie||(ie=x.substr(0,x.length-(0,M.$pc)(De).length)));const se=ce(De,x,ie,U);if(typeof se=="string")return se;(0,L.$7g)(se)&&(be||(be=[]),be.push(se))}return be?(async()=>{for(const Ce of be){const ae=await Ce;if(typeof ae=="string")return ae}return null})():null},ee=J.find(De=>!!De.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const pe=J.reduce((De,x)=>x.allPaths?De.concat(x.allPaths):De,[]);return pe.length&&(re.allPaths=pe),re}function N(Y,_,J){if(_===!1)return d;const Z=l(Y,J);if(Z===d)return d;if(typeof _=="boolean")return Z;if(_){const re=_.when;if(typeof re=="string"){const ee=(pe,De,x,U)=>{if(!U||!Z(pe,De))return null;const ie=re.replace("$(basename)",()=>x),be=U(ie);return(0,L.$7g)(be)?be.then(Ce=>Ce?Y:null):be?Y:null};return ee.requiresSiblings=!0,ee}}return Z}function B(Y,_){const J=Y.filter(De=>!!De.basenames);if(J.length<2)return Y;const Z=J.reduce((De,x)=>{const U=x.basenames;return U?De.concat(U):De},[]);let re;if(_){re=[];for(let De=0,x=Z.length;De<x;De++)re.push(_)}else re=J.reduce((De,x)=>{const U=x.patterns;return U?De.concat(U):De},[]);const ee=function(De,x){if(typeof De!="string")return null;if(!x){let ie;for(ie=De.length;ie>0;ie--){const be=De.charCodeAt(ie-1);if(be===47||be===92)break}x=De.substr(ie)}const U=Z.indexOf(x);return U!==-1?re[U]:null};ee.basenames=Z,ee.patterns=re,ee.allBasenames=Z;const pe=Y.filter(De=>!De.basenames);return pe.push(ee),pe}function W(Y,_){return(0,u.$ub)(Y,_,(J,Z)=>typeof J=="string"&&typeof Z=="string"?J===Z:typeof J!="string"&&typeof Z!="string"?J.base===Z.base&&J.pattern===Z.pattern:!1)}}),define(ke[80],Ee([1,0,13,170,23,14,2]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=v,e.$Hk=R,e.$Ik=I,e.$Jk=p,e.$Kk=C,e.$Lk=k,e.$Mk=c,e.$Nk=m;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=p(this.supportThemeIcons?(0,L.$zk)(n):n).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${C(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,A.$Ze)(i),"g");return n.replace(r,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Fk=$;function v(o){return R(o)?!o.value:Array.isArray(o)?o.every(v):!0}function R(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function I(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,O.$Og)(M.URI.from(o.baseUri),M.URI.from(n.baseUri)))}function p(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,o,`${"`".repeat(r)}`].join(`
`)}function k(o){return o.replace(/"/g,"&quot;")}function c(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const r=i[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=s?s[1]:"",d=t?t[1]:"",l=isFinite(parseInt(d)),a=isFinite(parseInt(f));l&&n.push(`width="${d}"`),a&&n.push(`height="${f}"`)}return{href:o,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=$,e.$hw=R,e.$iw=p,e.$jw=C,e.$kw=o,e.$lw=i,e.$mw=r,e.$nw=s,e.$ow=t,e.$pw=f;function $(l,a){const{os:h,tildify:g,relative:S}=a;if(S){const y=v(l,S,h);if(typeof y=="string")return y}let w=l.fsPath;if(h===1&&!A.$i?w=w.replace(/\//g,"\\"):h!==1&&A.$i&&(w=w.replace(/\\/g,"/")),h!==1&&g?.userHome){const y=g.userHome.fsPath;let D;l.scheme!==g.userHome.scheme&&l.path[0]===O.$hc.sep&&l.path[1]!==O.$hc.sep?D=g.userHome.with({path:l.path}).fsPath:D=w,w=p(D,y,h)}return(h===1?O.$gc:O.$hc).normalize(R(w,h===1))}function v(l,a,h){const g=h===1?O.$gc:O.$hc,S=h===3?M.$Lg:M.$Ng,w=a.getWorkspace(),E=(0,u.$Ob)(w.folders);if(!E)return;l.scheme!==E.uri.scheme&&l.path[0]===O.$hc.sep&&l.path[1]!==O.$hc.sep&&(l=E.uri.with({path:l.path}));const y=a.getWorkspaceFolder(l);if(!y)return;let D;if(S.isEqual(y.uri,l)?D="":D=S.relativePath(y.uri,l)??"",D&&(D=g.normalize(D)),w.folders.length>1&&!a.noPrefix){const P=y.name?y.name:S.basenameOrAuthority(y.uri);D=D?`${P} \u2022 ${D}`:P}return D}function R(l,a=A.$i){return(0,L.$mg)(l,a)?l.charAt(0).toUpperCase()+l.slice(1):l}let I=Object.create(null);function p(l,a,h=A.OS){if(h===1||!l||!a)return l;let g=I.original===a?I.normalized:void 0;g||(g=a,A.$i&&(g=(0,L.$cg)(g)),g=`${(0,b.$6e)(g,O.$hc.sep)}${O.$hc.sep}`,I={original:a,normalized:g});let S=l;return A.$i&&(S=(0,L.$cg)(S)),(h===3?S.startsWith(g):(0,b.$mf)(S,g))?`~/${S.substr(g.length)}`:l}function C(l,a){return l.replace(/^~($|\/|\\)/,`${a}$1`)}const k="\u2026",c="\\\\",m="~";function o(l,a=O.sep){const h=new Array(l.length);let g=!1;for(let S=0;S<l.length;S++){const w=l[S];if(w===""){h[S]=`.${a}`;continue}if(!w){h[S]=w;continue}g=!0;let E="",y=w;y.indexOf(c)===0?(E=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(a)===0?(E=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(m)===0&&(E=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const D=y.split(a);for(let P=1;g&&P<=D.length;P++)for(let z=D.length-P;g&&z>=0;z--){g=!1;let F=D.slice(z,z+P).join(a);for(let T=0;!g&&T<l.length;T++)if(T!==S&&l[T]&&l[T].indexOf(F)>-1){const j=z+P===D.length,N=z>0&&l[T].indexOf(a)>-1?a+F:F,B=l[T].endsWith(N);g=!j||B}if(!g){let T="";(D[0].endsWith(":")||E!=="")&&(z===1&&(z=0,P++,F=D[0]+a+F),z>0&&(T=D[0]+a),T=E+T),z>0&&(T=T+k+a),T=T+F,z+P<D.length&&(T=T+a+k),h[S]=T}}g&&(h[S]=w)}return h}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,a=Object.create(null)){const h=[];let g=!1,S="";for(const w of l)if(w==="$"||g&&w==="{")S&&h.push({value:S,type:n.TEXT}),S="",g=!0;else if(w==="}"&&g){const E=a[S];if(typeof E=="string")E.length&&h.push({value:E,type:n.VARIABLE});else if(E){const y=h[h.length-1];(!y||y.type!==n.SEPARATOR)&&h.push({value:E.label,type:n.SEPARATOR})}S="",g=!1}else S+=w;return S&&!g&&h.push({value:S,type:n.TEXT}),h.filter((w,E)=>{if(w.type===n.SEPARATOR){const y=h[E-1],D=h[E+1];return[y,D].every(P=>P&&(P.type===n.VARIABLE||P.type===n.TEXT)&&P.value.length>0)}return!0}).map(w=>w.value).join("")}function r(l,a){return A.$j||a?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(l,a){return A.$j||a?l.replace(/\(&&\w\)|&&/g,""):A.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function f(l){if(l.endsWith("]")){const a=l.lastIndexOf(" [",l.length-2);if(a!==-1){const h=d(l.substring(0,a)),g=l.substring(a);return{name:h.name+g,parentPath:h.parentPath}}}return d(l)}function d(l){const a=l.indexOf("/")!==-1?O.$hc:O.$gc,h=a.basename(l),g=a.dirname(l);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$mn=b,e.$nn=v,e.$on=R;function O(I){return I.toJSON()}class A{constructor(p){this.a=p}transformIncoming(p){const C=this.a.transformIncoming(p);return C===p?p:O(L.URI.from(C))}transformOutgoing(p){const C=this.a.transformOutgoing(p);return C===p?p:O(L.URI.from(C))}transformOutgoingURI(p){const C=this.a.transformOutgoing(p);return C===p?p:L.URI.from(C)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$kn=A,e.$ln=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function M(I,p,C){if(!I||C>200)return null;if(typeof I=="object"){if(I instanceof L.URI)return p.transformOutgoing(I);for(const k in I)if(Object.hasOwnProperty.call(I,k)){const c=M(I[k],p,C+1);c!==null&&(I[k]=c)}}return null}function b(I,p){const C=M(I,p,0);return C===null?I:C}function $(I,p,C,k){if(!I||k>200)return null;if(typeof I=="object"){if(I.$mid===1)return C?L.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof u.$ue)return null;for(const c in I)if(Object.hasOwnProperty.call(I,c)){const m=$(I[c],p,C,k+1);m!==null&&(I[c]=m)}}return null}function v(I,p){const C=$(I,p,!1,0);return C===null?I:C}function R(I,p){const C=$(I,p,!0,0);return C===null?I:C}}),define(ke[31],Ee([1,0,51,63,395,8,34,76,17,11,23,2]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=h,e.writeFileSync=S;var p;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function C(N,B=p.UNLINK,W){if((0,M.$lg)(N))throw new Error("rimraf - will refuse to recursively delete root");return B===p.UNLINK?c(N):k(N,W)}async function k(N,B=(0,M.$qg)((0,L.tmpdir)())){try{try{await u.promises.rename(N,B)}catch(W){return W.code==="ENOENT"?void 0:c(N)}c(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function c(N){return(0,O.promisify)(u.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function m(N){if((0,M.$lg)(N))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}async function o(N,B){return r(await(B?n(N):(0,O.promisify)(u.readdir)(N)))}async function n(N){try{return await(0,O.promisify)(u.readdir)(N,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const B=[],W=await o(N);for(const Y of W){let _=!1,J=!1,Z=!1;try{const re=await e.Promises.lstat((0,$.$kc)(N,Y));_=re.isFile(),J=re.isDirectory(),Z=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}B.push({name:Y,isFile:()=>_,isDirectory:()=>J,isSymbolicLink:()=>Z})}return B}function i(N){return r(u.readdirSync(N))}function r(N){return N.map(B=>typeof B=="string"?v.$j?(0,b.$Zl)(B):B:(B.name=v.$j?(0,b.$Zl)(B.name):B.name,B))}async function s(N){const B=await o(N),W=[];for(const Y of B)await f.existsDirectory((0,$.$kc)(N,Y))&&W.push(Y);return W}function t(N,B=1e3){return new Promise(W=>{let Y=!1;const _=setInterval(()=>{Y||(Y=!0,u.access(N,J=>{Y=!1,J&&(clearInterval(_),W(void 0))}))},B)})}var f;(function(N){async function B(_){let J;try{if(J=await e.Promises.lstat(_),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(v.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw re}throw Z}}N.stat=B;async function W(_){try{const{stat:J,symbolicLink:Z}=await N.stat(_);return J.isFile()&&Z?.dangling!==!0}catch{}return!1}N.existsFile=W;async function Y(_){try{const{stat:J,symbolicLink:Z}=await N.stat(_);return J.isDirectory()&&Z?.dangling!==!0}catch{}return!1}N.existsDirectory=Y})(f||(e.SymlinkSupport=f={}));const d=new A.$rh;function l(N,B,W){return d.queueFor(I.URI.file(N),()=>{const Y=w(W);return new Promise((_,J)=>g(N,B,Y,Z=>Z?J(Z):_()))},R.$Mg)}let a=!0;function h(N){a=N}function g(N,B,W,Y){if(!a)return u.writeFile(N,B,{mode:W.mode,flag:W.flag},Y);u.open(N,W.flag,W.mode,(_,J)=>{if(_)return Y(_);u.writeFile(J,B,Z=>{if(Z)return u.close(J,()=>Y(Z));u.fdatasync(J,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),h(!1)),u.close(J,ee=>Y(ee))))})})}function S(N,B,W){const Y=w(W);if(!a)return u.writeFileSync(N,B,{mode:Y.mode,flag:Y.flag});const _=u.openSync(N,Y.flag,Y.mode);try{u.writeFileSync(_,B);try{u.fdatasyncSync(_)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),h(!1)}}finally{u.closeSync(_)}}function w(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function E(N,B,W=6e4){if(N!==B)try{v.$i&&typeof W=="number"?await y(N,B,Date.now(),W):await(0,O.promisify)(u.rename)(N,B)}catch(Y){if(N.toLowerCase()!==B.toLowerCase()&&Y.code==="EXDEV"||N.endsWith("."))await D(N,B,{preserveSymlinks:!1}),await C(N,p.MOVE);else throw Y}}async function y(N,B,W,Y,_=0){try{return await(0,O.promisify)(u.rename)(N,B)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-W>=Y)throw console.error(`[node.js fs] rename failed after ${_} retries with error: ${J}`),J;if(_===0){let Z=!1;try{const{stat:re}=await f.stat(B);re.isFile()||(Z=!0)}catch{}if(Z)throw J}return await(0,A.$jh)(Math.min(100,_*10)),y(N,B,W,Y,_+1)}}async function D(N,B,W){return z(N,B,{root:{source:N,target:B},options:W,handledSourcePaths:new Set})}const P=511;async function z(N,B,W){if(W.handledSourcePaths.has(N))return;W.handledSourcePaths.add(N);const{stat:Y,symbolicLink:_}=await f.stat(N);if(_){if(W.options.preserveSymlinks)try{return await j(N,B,W)}catch{}if(_.dangling)return}return Y.isDirectory()?F(N,B,Y.mode&P,W):T(N,B,Y.mode&P)}async function F(N,B,W,Y){await e.Promises.mkdir(B,{recursive:!0,mode:W});const _=await o(N);for(const J of _)await z((0,$.$kc)(N,J),(0,$.$kc)(B,J),Y)}async function T(N,B,W){await e.Promises.copyFile(N,B),await e.Promises.chmod(B,W)}async function j(N,B,W){let Y=await e.Promises.readlink(N);(0,M.$ig)(Y,W.root.source,!v.$k)&&(Y=(0,$.$kc)(W.root.target,Y.substr(W.root.source.length+1))),await e.Promises.symlink(Y,B)}e.Promises=new class{get access(){return(0,O.promisify)(u.access)}get stat(){return(0,O.promisify)(u.stat)}get lstat(){return(0,O.promisify)(u.lstat)}get utimes(){return(0,O.promisify)(u.utimes)}get read(){return(N,B,W,Y,_)=>new Promise((J,Z)=>{u.read(N,B,W,Y,_,(re,ee,pe)=>re?Z(re):J({bytesRead:ee,buffer:pe}))})}get readFile(){return(0,O.promisify)(u.readFile)}get write(){return(N,B,W,Y,_)=>new Promise((J,Z)=>{u.write(N,B,W,Y,_,(re,ee,pe)=>re?Z(re):J({bytesWritten:ee,buffer:pe}))})}get appendFile(){return(0,O.promisify)(u.appendFile)}get fdatasync(){return(0,O.promisify)(u.fdatasync)}get truncate(){return(0,O.promisify)(u.truncate)}get copyFile(){return(0,O.promisify)(u.copyFile)}get open(){return(0,O.promisify)(u.open)}get close(){return(0,O.promisify)(u.close)}get symlink(){return(0,O.promisify)(u.symlink)}get readlink(){return(0,O.promisify)(u.readlink)}get chmod(){return(0,O.promisify)(u.chmod)}get mkdir(){return(0,O.promisify)(u.mkdir)}get unlink(){return(0,O.promisify)(u.unlink)}get rmdir(){return(0,O.promisify)(u.rmdir)}get realpath(){return(0,O.promisify)(u.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return l}get rm(){return C}get rename(){return E}get copy(){return D}}}),define(ke[104],Ee([1,0,51,17,11,14,31]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=b,e.$Oq=$,e.$Pq=v,e.$Qq=R;function b(p){if(O.$k)return p;const C=(0,L.$nc)(p);if(p===C)return p;const k=((0,L.$oc)(p)||p).toLowerCase();try{const m=(0,M.readdirSync)(C).filter(o=>o.toLowerCase()===k);if(m.length===1){const o=b(C);if(o)return(0,L.$kc)(o,m[0])}else if(m.length>1){const o=m.indexOf(k);if(o>=0){const n=b(C);if(n)return(0,L.$kc)(n,m[o])}}}catch{}return null}async function $(p,C){if(O.$k)return p;const k=(0,L.$nc)(p);if(p===k)return p;const c=((0,L.$oc)(p)||p).toLowerCase();try{if(C?.isCancellationRequested)return null;const o=(await M.Promises.readdir(k)).filter(n=>n.toLowerCase()===c);if(o.length===1){const n=await $(k,C);if(n)return(0,L.$kc)(n,o[0])}else if(o.length>1){const n=o.indexOf(c);if(n>=0){const i=await $(k,C);if(i)return(0,L.$kc)(i,o[n])}}}catch{}return null}async function v(p){try{return await M.Promises.realpath(p)}catch{const k=I(p);return await M.Promises.access(k,u.constants.R_OK),k}}function R(p){try{return u.realpathSync(p)}catch{const k=I(p);return u.accessSync(k,u.constants.R_OK),k}}function I(p){return(0,A.$6e)((0,L.$ic)(p),L.sep)}}),define(ke[105],Ee([1,0,17,11,50,102,18,31]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$am=$,e.$bm=v,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function $(I=O.env){return I.comspec||"cmd.exe"}function v(I){let p=[],C=!1;const k=function(c){if(C){p.push(c);return}(!I.send(c,o=>{if(o&&console.error(o),C=!1,p.length>0){const n=p.slice(0);p=[],n.forEach(i=>k(i))}})||L.$i)&&(C=!0)};return{send:k}}var R;(function(I){async function p(C,k,c){if(u.$jc(C))return C;if(k===void 0&&(k=O.cwd()),u.$nc(C)!=="."||(c===void 0&&M.$Vf(O.env.PATH)&&(c=O.env.PATH.split(u.$uc)),c===void 0||c.length===0))return u.$kc(k,C);async function o(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of c){let i;if(u.$jc(n)?i=u.$kc(n,C):i=u.$kc(k,n,C),await o(i))return i;let r=i+".com";if(await o(r)||(r=i+".exe",await o(r)))return r}return u.$kc(k,C)}I.findExecutable=p})(R||(e.win32=R={}))});var Je=this&&this.__decorate||function(he,e,u,L){var O=arguments.length,A=O<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,u):L,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(he,e,u,L);else for(var b=he.length-1;b>=0;b--)(M=he[b])&&(A=(O<3?M(A):O>3?M(e,u,A):M(e,u))||A);return O>3&&A&&Object.defineProperty(e,u,A),A};define(ke[81],Ee([1,0,19,8,21,22,54,13,4,3,57,14,18]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=h,e.$Vh=g,e.$1h=P,e.$2h=z;var C;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(C||(C={}));function k(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(c||(c={}));function m(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(o||(o={}));function n(_){let J=0;for(let Z=0;;Z+=7){const re=_.read(1);if(J|=(re.buffer[0]&127)<<Z,!(re.buffer[0]&128))return J}}const i=d(0);function r(_,J){if(J===0){_.write(i);return}let Z=0;for(let ee=J;ee!==0;ee=ee>>>7)Z++;const re=O.$ue.alloc(Z);for(let ee=0;J!==0;ee++)re.buffer[ee]=J&127,J=J>>>7,J>0&&(re.buffer[ee]|=128);_.write(re)}class s{constructor(J){this.b=J,this.a=0}read(J){const Z=this.b.slice(this.a,this.a+J);return this.a+=Z.byteLength,Z}}e.$Sh=s;class t{constructor(){this.a=[]}get buffer(){return O.$ue.concat(this.a)}write(J){this.a.push(J)}}e.$Th=t;var f;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(f||(f={}));function d(_){const J=O.$ue.alloc(1);return J.writeUInt8(_,0),J}const l={Undefined:d(f.Undefined),String:d(f.String),Buffer:d(f.Buffer),VSBuffer:d(f.VSBuffer),Array:d(f.Array),Object:d(f.Object),Uint:d(f.Int)},a=typeof Buffer<"u";function h(_,J){if(typeof J>"u")_.write(l.Undefined);else if(typeof J=="string"){const Z=O.$ue.fromString(J);_.write(l.String),r(_,Z.byteLength),_.write(Z)}else if(a&&Buffer.isBuffer(J)){const Z=O.$ue.wrap(J);_.write(l.Buffer),r(_,Z.byteLength),_.write(Z)}else if(J instanceof O.$ue)_.write(l.VSBuffer),r(_,J.byteLength),_.write(J);else if(Array.isArray(J)){_.write(l.Array),r(_,J.length);for(const Z of J)h(_,Z)}else if(typeof J=="number"&&(J|0)===J)_.write(l.Uint),r(_,J);else{const Z=O.$ue.fromString(JSON.stringify(J));_.write(l.Object),r(_,Z.byteLength),_.write(Z)}}function g(_){switch(_.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return _.read(n(_)).toString();case f.Buffer:return _.read(n(_)).buffer;case f.VSBuffer:return _.read(n(_));case f.Array:{const Z=n(_),re=[];for(let ee=0;ee<Z;ee++)re.push(g(_));return re}case f.Object:return JSON.parse(_.read(n(_)).toString());case f.Int:return n(_)}}class S{constructor(J,Z,re=null,ee=1e3){this.h=J,this.j=Z,this.k=re,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(pe=>this.q(pe)),this.m({type:200})}registerChannel(J,Z){this.b.set(J,Z),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const Z=this.o([J.type]);this.k?.logOutgoing(Z,0,1,m(J.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([J.type,J.id],J.data);this.k?.logOutgoing(Z,J.id,1,m(J.type),J.data);return}}}o(J,Z=void 0){const re=new t;return h(re,J),h(re,Z),this.p(re.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const Z=new s(J),re=g(Z),ee=g(Z),pe=re[0];switch(pe){case 100:return this.k?.logIncoming(J.byteLength,re[1],1,`${k(pe)}: ${re[2]}.${re[3]}`,ee),this.s({type:pe,id:re[1],channelName:re[2],name:re[3],arg:ee});case 102:return this.k?.logIncoming(J.byteLength,re[1],1,`${k(pe)}: ${re[2]}.${re[3]}`,ee),this.t({type:pe,id:re[1],channelName:re[2],name:re[3],arg:ee});case 101:return this.k?.logIncoming(J.byteLength,re[1],1,`${k(pe)}`),this.u({type:pe,id:re[1]});case 103:return this.k?.logIncoming(J.byteLength,re[1],1,`${k(pe)}`),this.u({type:pe,id:re[1]})}}s(J){const Z=this.b.get(J.channelName);if(!Z){this.v(J);return}const re=new A.$ee;let ee;try{ee=Z.call(this.j,J.name,J.arg,re.token)}catch(x){ee=Promise.reject(x)}const pe=J.id;ee.then(x=>{this.m({id:pe,data:x,type:201})},x=>{x instanceof Error?this.m({id:pe,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:pe,data:x,type:203})}).finally(()=>{De.dispose(),this.d.delete(J.id)});const De=(0,v.$Sc)(()=>re.cancel());this.d.set(J.id,De)}t(J){const Z=this.b.get(J.channelName);if(!Z){this.v(J);return}const re=J.id,pe=Z.listen(this.j,J.name,J.arg)(De=>this.m({id:re,data:De,type:204}));this.d.set(J.id,pe)}u(J){const Z=this.d.get(J.id);Z&&(Z.dispose(),this.d.delete(J.id))}v(J){let Z=this.g.get(J.channelName);Z||(Z=[],this.g.set(J.channelName,Z));const re=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:J,timeoutTimer:re})}w(J){const Z=this.g.get(J);if(Z){for(const re of Z)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=S;var w;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class E{constructor(J,Z=null){this.l=J,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=Z}getChannel(J){const Z=this;return{call(re,ee,pe){return Z.a?Promise.reject(new b.$5):Z.m(J,re,ee,pe)},listen(re,ee){return Z.a?$.Event.None:Z.o(J,re,ee)}}}m(J,Z,re,ee=A.CancellationToken.None){const pe=this.g++,x={id:pe,type:100,channelName:J,name:Z,arg:re};if(ee.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((be,Ce)=>{if(ee.isCancellationRequested)return Ce(new b.$5);const ae=()=>{const te=le=>{switch(le.type){case 201:this.f.delete(pe),be(le.data);break;case 202:{this.f.delete(pe);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,Ce(de);break}case 203:this.f.delete(pe),Ce(le.data);break}};this.f.set(pe,te),this.p(x)};let ce=null;this.b===o.Idle?ae():(ce=(0,L.$8g)(te=>this.u()),ce.then(()=>{ce=null,ae()}));const se=()=>{ce?(ce.cancel(),ce=null):this.p({id:pe,type:101}),Ce(new b.$5)},K=ee.onCancellationRequested(se);U=(0,v.$Rc)((0,v.$Sc)(se),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(J,Z,re){const ee=this.g++,De={id:ee,type:102,channelName:J,name:Z,arg:re};let x=null;const U=new $.$7d({onWillAddFirstListener:()=>{x=(0,L.$8g)(be=>this.u()),x.then(()=>{x=null,this.d.add(U),this.p(De)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(U),this.p({id:ee,type:103}))}}),ie=be=>U.fire(be.data);return this.f.set(ee,ie),U.event}p(J){switch(J.type){case 100:case 102:{const Z=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(Z,J.id,0,`${k(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const Z=this.q([J.type,J.id]);this.j?.logOutgoing(Z,J.id,0,k(J.type));return}}}q(J,Z=void 0){const re=new t;return h(re,J),h(re,Z),this.r(re.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const Z=new s(J),re=g(Z),ee=g(Z),pe=re[0];switch(pe){case 200:return this.j?.logIncoming(J.byteLength,0,0,m(pe)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,re[1],0,m(pe),ee),this.t({type:re[0],id:re[1],data:ee})}}t(J){if(J.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=E,Je([M.$Mh],E.prototype,"onDidInitializePromise",null);class y{get connections(){const J=[];return this.f.forEach(Z=>J.push(Z)),J}constructor(J,Z,re){this.a=new Map,this.f=new Set,this.g=new $.$7d,this.onDidAddConnection=this.g.event,this.h=new $.$7d,this.onDidRemoveConnection=this.h.event,this.j=new v.$Tc,this.j.add(J(({protocol:ee,onDidClientDisconnect:pe})=>{const De=$.Event.once(ee.onMessage);this.j.add(De(x=>{const U=new s(x),ie=g(U),be=new S(ee,ie,Z,re),Ce=new E(ee,Z);this.a.forEach((ce,se)=>be.registerChannel(se,ce));const ae={channelServer:be,channelClient:Ce,ctx:ie};this.f.add(ae),this.g.fire(ae),this.j.add(pe(()=>{be.dispose(),Ce.dispose(),this.f.delete(ae),this.h.fire(ae)}))}))}))}getChannel(J,Z){const re=this;return{call(ee,pe,De){let x;if((0,p.$0f)(Z)){const ie=(0,u.$4b)(re.connections.filter(Z));x=ie?Promise.resolve(ie):$.Event.toPromise($.Event.filter(re.onDidAddConnection,Z))}else x=Z.routeCall(re,ee,pe);const U=x.then(ie=>ie.channelClient.getChannel(J));return P(U).call(ee,pe,De)},listen(ee,pe){if((0,p.$0f)(Z))return re.k(J,Z,ee,pe);const De=Z.routeEvent(re,ee,pe).then(x=>x.channelClient.getChannel(J));return P(De).listen(ee,pe)}}}k(J,Z,re,ee){const pe=this;let De;const x=new $.$7d({onWillAddFirstListener:()=>{De=new v.$Tc;const U=new $.$ae,ie=new Map,be=ae=>{const se=ae.channelClient.getChannel(J).listen(re,ee),K=U.add(se);ie.set(ae,K)},Ce=ae=>{const ce=ie.get(ae);ce&&(ce.dispose(),ie.delete(ae))};pe.connections.filter(Z).forEach(be),$.Event.filter(pe.onDidAddConnection,Z)(be,void 0,De),pe.onDidRemoveConnection(Ce,void 0,De),U.event(x.fire,x,De),De.add(U)},onDidRemoveLastListener:()=>{De?.dispose(),De=void 0}});return x.event}registerChannel(J,Z){this.a.set(J,Z);for(const re of this.f)re.channelServer.registerChannel(J,Z)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=y;class D{constructor(J,Z,re=null){const ee=new t;h(ee,Z),J.send(ee.buffer),this.a=new E(J,re),this.d=new S(J,Z,re)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,Z){this.d.registerChannel(J,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=D;function P(_){return{call(J,Z,re){return _.then(ee=>ee.call(J,Z,re))},listen(J,Z){const re=new $.$de;return _.then(ee=>re.input=ee.listen(J,Z)),re.event}}}function z(_){let J=!1;return{call(Z,re,ee){return J?_.call(Z,re,ee):(0,L.$jh)(0).then(()=>J=!0).then(()=>_.call(Z,re,ee))},listen(Z,re){if(J)return _.listen(Z,re);const ee=new $.$de;return(0,L.$jh)(0).then(()=>J=!0).then(()=>ee.input=_.listen(Z,re)),ee.event}}}class F{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const Z of J.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$3h=F;var T;(function(_){function J(pe,De,x){const U=pe,ie=x&&x.disableMarshalling,be=new Map;for(const Ce in U)re(Ce)&&be.set(Ce,$.Event.buffer(U[Ce],!0,void 0,De));return new class{listen(Ce,ae,ce){const se=be.get(ae);if(se)return se;const K=U[ae];if(typeof K=="function"){if(ee(ae))return K.call(U,ce);if(re(ae))return be.set(ae,$.Event.buffer(U[ae],!0,void 0,De)),be.get(ae)}throw new b.$bb(`Event not found: ${ae}`)}call(Ce,ae,ce){const se=U[ae];if(typeof se=="function"){if(!ie&&Array.isArray(ce))for(let te=0;te<ce.length;te++)ce[te]=(0,R.$Rh)(ce[te]);let K=se.apply(U,ce);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${ae}`)}}}_.fromService=J;function Z(pe,De){const x=De&&De.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return De?.properties?.has(ie)?De.properties.get(ie):ee(ie)?function(be){return pe.listen(ie,be)}:re(ie)?pe.listen(ie):async function(...be){let Ce;De&&!(0,p.$5f)(De.context)?Ce=[De.context,...be]:Ce=be;const ae=await pe.call(ie,Ce);return x?ae:(0,R.$Rh)(ae)};throw new b.$bb(`Property not found: ${String(ie)}`)}})}_.toService=Z;function re(pe){return pe[0]==="o"&&pe[1]==="n"&&I.$kf(pe.charCodeAt(2))}function ee(pe){return/^onDynamic/.test(pe)&&I.$kf(pe.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const J=_.toString();if(J!=="[object Object]")return J}return _}function B(_){return Array.isArray(_)?_.map(N):N(_)}function W(_,J,Z,re,ee,pe,De){De=B(De);const x=j[ee],U=x[re%x.length];let ie=[`%c[${_}]%c[${String(J).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${pe}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(pe)?(ie=ie.concat(De),ie.push(")")):ie.push(De),console.log.apply(console,ie)}class Y{constructor(J,Z){this.d=J,this.f=Z,this.a=0,this.b=0}logOutgoing(J,Z,re,ee,pe){this.b+=J,W(this.d,this.b,J,Z,re,ee,pe)}logIncoming(J,Z,re,ee,pe){this.a+=J,W(this.f,this.a,J,Z,re,ee,pe)}}e.$4h=Y}),define(ke[82],Ee([1,0,21,4,3,81]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.ProtocolConstants=e.$5h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const a=new WeakMap;let h=0;function g(w,E){if(!a.has(w)){const y=String(++h);a.set(w,y)}return a.get(w)}function S(w,E,y,D){if(!l.enableDiagnostics)return;const P=g(w,E);if(D instanceof u.$ue||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const z=u.$ue.alloc(D.byteLength);z.set(D),l.records.push({timestamp:Date.now(),id:P,label:E,type:y,buff:z})}else l.records.push({timestamp:Date.now(),id:P,label:E,type:y,data:D})}l.traceSocketEvent=S})(b||(e.SocketDiagnostics=b={}));var $;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let v=null;function R(){return v||(v=u.$ue.alloc(0)),v}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,h){if(a===0)return R();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const E=this.a[0];return h&&(this.a.shift(),this.b-=a),E}if(this.a[0].byteLength>a){const E=this.a[0].slice(0,a);return h&&(this.a[0]=this.a[0].slice(a),this.b-=a),E}const g=u.$ue.alloc(a);let S=0,w=0;for(;a>0;){const E=this.a[w];if(E.byteLength>a){const y=E.slice(0,a);g.set(y,S),S+=a,h&&(this.a[w]=E.slice(a),this.b-=a),a-=a}else g.set(E,S),S+=E.byteLength,h?(this.a.shift(),this.b-=E.byteLength):w++,a-=E.byteLength}return g}}e.$5h=I;var p;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(p||(p={}));function C(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class c{constructor(a,h,g,S){this.type=a,this.id=h,this.ack=g,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends O.$Uc{constructor(a){super(),this.f=this.B(new L.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new I,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,S=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new c(g,S,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=u.$ue.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(h,a.data)}g(a,h){const g=this.f===0;return this.d.push(a,h),this.f+=a.byteLength+h.byteLength,g}h(){const a=u.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,h){this.g(a,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class n extends O.$Uc{constructor(a){super(),this.f=new L.$7d,this.onMessage=this.f.event,this.g=new L.$7d,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new o(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new c(1,0,0,a))}}e.$6h=n;class i extends A.$Zh{static fromSocket(a,h){return new i(new n(a),h)}get onDidDispose(){return this.b.onDidDispose}constructor(a,h,g=null){super(a,h,g),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$7h=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$8h=r;class s{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,h=this.a;for(;h;)h=h.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let h=0,g=this.a;for(;g;)a[h++]=g.data,g=g.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const h=new s(a);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const a=Date.now();for(let h=0;h<f.a;h++)this.c[h]=a-1e3*h;setInterval(()=>{for(let h=f.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),h=(1+f.a)*1e3;let g=0;for(let S=0;S<f.a;S++)a-this.c[S]<=h&&g++;return 1-g/f.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??f.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new O.$Tc,this.o=a.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new c(5,0,0,R());this.p.write(a),this.p.flush()}sendPause(){const a=new c(7,0,0,R());this.p.write(a)}sendResume(){const a=new c(8,0,0,R());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,h){this.a=!0,this.r.dispose(),this.r=new O.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new c(3,0,this.h,R());this.p.write(a);const h=this.b.toArray();for(let g=0,S=h.length;g<S;g++)this.p.write(h[g]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const h=this.b.peek();if(h&&h.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new c(6,0,0,R())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let g=0,S=h.length;g<S;g++)this.p.write(h[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const h=++this.c;this.h=this.g;const g=new c(1,h,this.h,a);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(a){const h=new c(2,0,0,a);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),h=Date.now()-a.writtenTime,g=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(h>=2e4&&g>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:g});return}const w=Math.max(2e4-h,2e4-g,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new c(3,0,this.h,R());this.p.write(a)}D(){this.h=this.g;const a=new c(9,0,this.h,R());this.p.write(a)}}e.$9h=d}),define(ke[193],Ee([1,0,52,8,21,22,191,13,4,3,24,105,102,81]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class k extends C.$Wh{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>O.$ue.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Jq=k;class c{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$7d,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new L.$fh(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,r,s){return n.k(o,i,r,s)},listen(i,r){return n.l(o,i,r)}}}k(o,n,i,r=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const s=this.n(o),t=(0,L.$8g)(l=>s.call(n,i,l)),f=r.onCancellationRequested(()=>t.cancel()),d=(0,v.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{f.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return $.Event.None;this.b.cancel();let r;const s=new $.$7d({onWillAddFirstListener:()=>{r=this.n(o).listen(n,i)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,R.$On)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,p.$_l)(n.env),this.d=(0,u.fork)(this.i,o,n);const i=new $.$7d,s=$.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,M.$Fq)(h)){(0,M.log)(h,`IPC Library: ${this.j.serverName}`);return}i.fire(O.$ue.wrap(Buffer.from(h,"base64")))}),t=this.j.useQueue?(0,I.$bm)(this.d):this.d,f=h=>this.d&&this.d.connected&&t.send(h.buffer.toString("base64")),d=i.event,l={send:f,onMessage:d};this.f=new C.$Xh(l);const a=()=>this.o();process.once("exit",a),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,g)=>{process.removeListener("exit",a),s.dispose(),this.c.forEach(S=>(0,v.$Pc)(S)),this.c.clear(),h!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:g})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Kq=c}),define(ke[194],Ee([1,0,8,4,3,57,18]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.StorageState=e.StorageHint=void 0,e.$Hp=$;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(p){const C=p;return C?.changed instanceof Map||C?.deleted instanceof Set}var v;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(v||(e.StorageState=v={}));class R extends O.$Uc{static{this.a=100}constructor(C,k=Object.create(null)){super(),this.r=C,this.s=k,this.b=this.B(new L.$0d),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=this.B(new u.$gh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(C=>this.u(C)))}u(C){this.b.pause();try{C.changed?.forEach((k,c)=>this.w(c,k)),C.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(C,k){if(this.c===v.Closed)return;let c=!1;(0,M.$5f)(k)?c=this.f.delete(C):this.f.get(C)!==k&&(this.f.set(C,k),c=!0),c&&this.b.fire({key:C,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(C,k){const c=this.f.get(C);return(0,M.$5f)(c)?k:c}getBoolean(C,k){const c=this.get(C);return(0,M.$5f)(c)?k:c==="true"}getNumber(C,k){const c=this.get(C);return(0,M.$5f)(c)?k:parseInt(c,10)}getObject(C,k){const c=this.get(C);return(0,M.$5f)(c)?k:(0,A.$Qh)(c)}async set(C,k,c=!1){if(this.c===v.Closed)return;if((0,M.$5f)(k))return this.delete(C,c);const m=(0,M.$Xf)(k)||Array.isArray(k)?(0,A.$Ph)(k):String(k);if(this.f.get(C)!==m)return this.f.set(C,m),this.j.set(C,m),this.h.delete(C),this.b.fire({key:C,external:c}),this.D()}async delete(C,k=!1){if(!(this.c===v.Closed||!this.f.delete(C)))return this.h.has(C)||this.h.add(C),this.j.delete(C),this.b.fire({key:C,external:k}),this.D()}async optimize(){if(this.c!==v.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=v.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const C={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(C).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(C){if(this.z)return this.D(C)}async D(C){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),C)}async whenFlushed(){if(this.z)return new Promise(C=>this.n.push(C))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Ip=R;class I{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(C){C.insert?.forEach((k,c)=>this.a.set(c,k)),C.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$Jp=I}),define(ke[195],Ee([1,0,14,11,21]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$ut=R,e.$vt=I;let A;function M(){return A||(A=new TextDecoder("UTF-16LE")),A}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let v;function R(){return v||(v=L.$D()?M():$()),v}function I(k,c,m){const o=new Uint16Array(k.buffer,c,m);return m>0&&(o[0]===65279||o[0]===65534)?p(k,c,m):M().decode(o)}function p(k,c,m){const o=[];let n=0;for(let i=0;i<m;i++){const r=O.$we(k,c);c+=2,o[n++]=String.fromCharCode(r)}return o.join("")}class C{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return R().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const m=this.a-this.d;m<=1&&(m===0||u.$pf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const m=c.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=c;return}for(let o=0;o<m;o++)this.b[this.d++]=c.charCodeAt(o)}}e.$wt=C}),define(ke[196],Ee([1,0,21,195]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0,e.$yt=M;function O($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(v,R,I,p){this.oldPosition=v,this.oldText=R,this.newPosition=I,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${O(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${O(this.oldText)}")`:`(replace@${this.oldPosition} "${O(this.oldText)}" with "${O(this.newText)}")`}static a(v){return 4+2*v.length}static c(v,R,I){const p=R.length;u.$ze(v,p,I),I+=4;for(let C=0;C<p;C++)u.$xe(v,R.charCodeAt(C),I),I+=2;return I}static d(v,R){const I=u.$ye(v,R);return R+=4,(0,L.$vt)(v,R,I)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(v,R){return u.$ze(v,this.oldPosition,R),R+=4,u.$ze(v,this.newPosition,R),R+=4,R=A.c(v,this.oldText,R),R=A.c(v,this.newText,R),R}static read(v,R,I){const p=u.$ye(v,R);R+=4;const C=u.$ye(v,R);R+=4;const k=A.d(v,R);R+=A.a(k);const c=A.d(v,R);return R+=A.a(c),I.push(new A(p,k,C,c)),R}}e.$xt=A;function M($,v){return $===null||$.length===0?v:new b($,v).compress()}class b{constructor(v,R){this.a=v,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let v=0,R=0,I=this.n(v),p=this.l(R);for(;v<this.f||R<this.h;){if(I===null){this.k(p),p=this.l(++R);continue}if(p===null){this.m(I),I=this.n(++v);continue}if(p.oldEnd<=I.newPosition){this.k(p),p=this.l(++R);continue}if(I.newEnd<=p.oldPosition){this.m(I),I=this.n(++v);continue}if(p.oldPosition<I.newPosition){const[o,n]=b.r(p,I.newPosition-p.oldPosition);this.k(o),p=n;continue}if(I.newPosition<p.oldPosition){const[o,n]=b.q(I,p.oldPosition-I.newPosition);this.m(o),I=n;continue}let c,m;if(p.oldEnd===I.newEnd)c=I,m=p,I=this.n(++v),p=this.l(++R);else if(p.oldEnd<I.newEnd){const[o,n]=b.q(I,p.oldLength);c=o,m=p,I=n,p=this.l(++R)}else{const[o,n]=b.r(p,I.newLength);c=I,m=o,I=this.n(++v),p=n}this.d[this.e++]=new A(c.oldPosition,c.oldText,m.newPosition,m.newText),this.g+=c.newLength-c.oldLength,this.j+=m.newLength-m.oldLength}const C=b.s(this.d);return b.t(C)}k(v){this.d[this.e++]=b.o(this.g,v),this.j+=v.newLength-v.oldLength}l(v){return v<this.h?this.c[v]:null}m(v){this.d[this.e++]=b.p(this.j,v),this.g+=v.newLength-v.oldLength}n(v){return v<this.f?this.a[v]:null}static o(v,R){return new A(R.oldPosition-v,R.oldText,R.newPosition,R.newText)}static p(v,R){return new A(R.oldPosition,R.oldText,R.newPosition+v,R.newText)}static q(v,R){const I=v.newText.substr(0,R),p=v.newText.substr(R);return[new A(v.oldPosition,v.oldText,v.newPosition,I),new A(v.oldEnd,"",v.newPosition+R,p)]}static r(v,R){const I=v.oldText.substr(0,R),p=v.oldText.substr(R);return[new A(v.oldPosition,I,v.newPosition,v.newText),new A(v.oldPosition+R,p,v.newEnd,"")]}static s(v){if(v.length===0)return v;const R=[];let I=0,p=v[0];for(let C=1;C<v.length;C++){const k=v[C];p.oldEnd===k.oldPosition?p=new A(p.oldPosition,p.oldText+k.oldText,p.newPosition,p.newText+k.newText):(R[I++]=p,p=k)}return R[I++]=p,R}static t(v){if(v.length===0)return v;const R=[];let I=0;for(let p=0;p<v.length;p++){const C=v[p];C.oldText!==C.newText&&(R[I++]=C)}return R}}}),define(ke[197],Ee([1,0,35,17]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=O,e.$Wt=A;function O(M,b,$,v,R,I){if(Array.isArray(M)){let p=0;for(const C of M){const k=O(C,b,$,v,R,I);if(k===10)return k;k>p&&(p=k)}return p}else{if(typeof M=="string")return v?M==="*"?5:M===$?10:0:0;if(M){const{language:p,pattern:C,scheme:k,hasAccessToAllModels:c,notebookType:m}=M;if(!v&&!c)return 0;m&&R&&(b=R);let o=0;if(k)if(k===b.scheme)o=10;else if(k==="*")o=5;else return 0;if(p)if(p===$)o=10;else if(p==="*")o=Math.max(o,5);else return 0;if(m)if(m===I)o=10;else if(m==="*"&&I!==void 0)o=Math.max(o,5);else return 0;if(C){let n;if(typeof C=="string"?n=C:n={...C,base:(0,L.$ic)(C.base)},n===b.fsPath||(0,u.$bk)(n,b.fsPath))o=10;else return 0}return o}else return 0}}function A(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(A):!!M.notebookType}}),define(ke[198],Ee([1,0,4,14,29,79,130,173,196,3]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=void 0;class R extends v.$Uc{constructor(p,C,k,c,m,o,n){super(),this.m=this.B(new u.$7d),this.onDidChangeContent=this.m.event,this.f=C,this.j=!o,this.g=c,this.h=m,this.c=new M.$CC(p,k,n)}equals(p){return!(p instanceof R)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,C){return this.c.getOffsetAt(p,C)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,C){const k=p+C,c=this.getPositionAt(p),m=this.getPositionAt(k);return new O.$ct(c.lineNumber,c.column,m.lineNumber,m.column)}getValueInRange(p,C=0){if(p.isEmpty())return"";const k=this.n(C);return this.c.getValueInRange(p,k)}getValueLengthInRange(p,C=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const k=this.getOffsetAt(p.startLineNumber,p.startColumn),c=this.getOffsetAt(p.endLineNumber,p.endColumn);let m=0;const o=this.n(C),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,r=p.endLineNumber-p.startLineNumber;m=i*r}return c-k+m}getCharacterCountInRange(p,C=0){if(this.j){let k=0;const c=p.startLineNumber,m=p.endLineNumber;for(let o=c;o<=m;o++){const n=this.getLineContent(o),i=o===c?p.startColumn-1:0,r=o===m?p.endColumn-1:n.length;for(let s=i;s<r;s++)L.$pf(n.charCodeAt(s))?(k=k+1,s=s+1):k=k+1}return k+=this.n(C).length*(m-c),k}return this.getValueLengthInRange(p,C)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,C){return this.c.getLineCharCode(p,C)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const C=L.$af(this.getLineContent(p));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(p){const C=L.$cf(this.getLineContent(p));return C===-1?0:C+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,C,k){let c=this.g,m=this.h,o=this.j,n=!0,i=[];for(let a=0;a<p.length;a++){const h=p[a];n&&h._isTracked&&(n=!1);const g=h.range;if(h.text){let D=!0;o||(D=!L.$Af(h.text),o=D),!c&&D&&(c=L.$zf(h.text)),!m&&D&&(m=L.$Cf(h.text))}let S="",w=0,E=0,y=0;if(h.text){let D;[w,E,y,D]=(0,b.$Ot)(h.text);const P=this.getEOL();D===0||D===(P===`\r
`?2:1)?S=h.text:S=h.text.replace(/\r\n|\r|\n/g,P)}i[a]={sortIndex:a,identifier:h.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:S,eolCount:w,firstLineLength:E,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}i.sort(R.u);let r=!1;for(let a=0,h=i.length-1;a<h;a++){const g=i[a].range.getEndPosition(),S=i[a+1].range.getStartPosition();if(S.isBeforeOrEqual(g)){if(S.isBefore(g))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const s=k||C?R._getInverseEditRanges(i):[],t=[];if(C)for(let a=0;a<i.length;a++){const h=i[a],g=s[a];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let S=g.startLineNumber;S<=g.endLineNumber;S++){let w="";S===g.startLineNumber&&(w=this.getLineContent(h.range.startLineNumber),L.$af(w)!==-1)||t.push({lineNumber:S,oldContent:w})}}let f=null;if(k){let a=0;f=[];for(let h=0;h<i.length;h++){const g=i[h],S=s[h],w=this.getValueInRange(g.range),E=g.rangeOffset+a;a+=g.text.length-w.length,f[h]={sortIndex:g.sortIndex,identifier:g.identifier,range:S,text:w,textChange:new $.$xt(g.rangeOffset,w,E,g.text)}}r||f.sort((h,g)=>h.sortIndex-g.sortIndex)}this.g=c,this.h=m,this.j=o;const d=this.t(i);let l=null;if(C&&t.length>0){t.sort((a,h)=>h.lineNumber-a.lineNumber),l=[];for(let a=0,h=t.length;a<h;a++){const g=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===g)continue;const S=t[a].oldContent,w=this.getLineContent(g);w.length===0||w===S||L.$af(w)!==-1||l.push(g)}}return this.m.fire(),new A.$Av(f,d,l)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let C=!1;const k=p[0].range,c=p[p.length-1].range,m=new O.$ct(k.startLineNumber,k.startColumn,c.endLineNumber,c.endColumn);let o=k.startLineNumber,n=k.startColumn;const i=[];for(let d=0,l=p.length;d<l;d++){const a=p[d],h=a.range;C=C||a.forceMoveMarkers,i.push(this.getValueInRange(new O.$ct(o,n,h.startLineNumber,h.startColumn))),a.text.length>0&&i.push(a.text),o=h.endLineNumber,n=h.endColumn}const r=i.join(""),[s,t,f]=(0,b.$Ot)(r);return{sortIndex:0,identifier:p[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:f,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}t(p){p.sort(R.w);const C=[];for(let k=0;k<p.length;k++){const c=p[k],m=c.range.startLineNumber,o=c.range.startColumn,n=c.range.endLineNumber,i=c.range.endColumn;if(m===n&&o===i&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const r=new O.$ct(m,o,n,i);C.push({range:r,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return C}findMatchesLineByLine(p,C,k,c){return this.c.findMatchesLineByLine(p,C,k,c)}getPieceTree(){return this.c}static _getInverseEditRange(p,C){const k=p.startLineNumber,c=p.startColumn,[m,o,n]=(0,b.$Ot)(C);let i;if(C.length>0){const r=m+1;r===1?i=new O.$ct(k,c,k,c+o):i=new O.$ct(k,c,k+r-1,n+1)}else i=new O.$ct(k,c,k,c);return i}static _getInverseEditRanges(p){const C=[];let k=0,c=0,m=null;for(let o=0,n=p.length;o<n;o++){const i=p[o];let r,s;m?m.range.endLineNumber===i.range.startLineNumber?(r=k,s=c+(i.range.startColumn-m.range.endColumn)):(r=k+(i.range.startLineNumber-m.range.endLineNumber),s=i.range.startColumn):(r=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const f=i.eolCount+1;f===1?t=new O.$ct(r,s,r,s+i.firstLineLength):t=new O.$ct(r,s,r+f-1,i.lastLineLength+1)}else t=new O.$ct(r,s,r,s);k=t.endLineNumber,c=t.endColumn,C.push(t),m=i}return C}static u(p,C){const k=O.$ct.compareRangesUsingEnds(p.range,C.range);return k===0?p.sortIndex-C.sortIndex:k}static w(p,C){const k=O.$ct.compareRangesUsingEnds(p.range,C.range);return k===0?C.sortIndex-p.sortIndex:-k}}e.$DC=R}),define(ke[199],Ee([1,0,14,130,198]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EC=void 0;class A{constructor($,v,R,I,p,C,k,c,m){this.a=$,this.b=v,this.c=R,this.d=I,this.e=p,this.f=C,this.g=k,this.h=c,this.j=m}k($){const v=this.c+this.d+this.e,R=this.c+this.e;return v===0?$===1?`
`:`\r
`:R>v/2?`\r
`:`
`}create($){const v=this.k($),R=this.a;if(this.j&&(v===`\r
`&&(this.c>0||this.d>0)||v===`
`&&(this.c>0||this.e>0)))for(let p=0,C=R.length;p<C;p++){const k=R[p].buffer.replace(/\r\n|\r|\n/g,v),c=(0,L.$yC)(k);R[p]=new L.$BC(k,c)}const I=new O.$DC(R,this.b,v,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&u.$Jf($)&&(this.b=u.$If,$=$.substr(1));const v=$.charCodeAt($.length-1);v===13||v>=55296&&v<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=v):(this.m($,!1),this.c=!1,this.d=v)}m($,v){!v&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const v=(0,L.$zC)(this.e,$);this.a.push(new L.$BC($,v.lineStarts)),this.f+=v.cr,this.g+=v.lf,this.h+=v.crlf,v.isBasicASCII||(this.l=!1,this.j||(this.j=u.$zf($)),this.k||(this.k=u.$Cf($)))}finish($=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const v=(0,L.$yC)($.buffer);$.lineStarts=v,this.d===13&&this.f++}}}e.$EC=M}),define(ke[134],Ee([1,0,21,11]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qab=$,e.$Rab=R;var O;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(O||(O={}));function A(I){for(let p=0,C=I.length;p<C;p+=4){const k=I[p+0],c=I[p+1],m=I[p+2],o=I[p+3];I[p+0]=o,I[p+1]=m,I[p+2]=c,I[p+3]=k}}function M(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.$D()||A(p),u.$ue.wrap(p)}function b(I){const p=I.buffer;if(L.$D()||A(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const C=new Uint8Array(p.byteLength);return C.set(p),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function $(I){const p=new Uint32Array(v(I));let C=0;if(p[C++]=I.id,I.type==="full")p[C++]=1,p[C++]=I.data.length,p.set(I.data,C),C+=I.data.length;else{p[C++]=2,p[C++]=I.deltas.length;for(const k of I.deltas)p[C++]=k.start,p[C++]=k.deleteCount,k.data?(p[C++]=k.data.length,p.set(k.data,C),C+=k.data.length):p[C++]=0}return M(p)}function v(I){let p=0;if(p+=2,I.type==="full")p+=1+I.data.length;else{p+=1,p+=3*I.deltas.length;for(const C of I.deltas)C.data&&(p+=C.data.length)}return p}function R(I){const p=b(I);let C=0;const k=p[C++];if(p[C++]===1){const n=p[C++],i=p.subarray(C,C+n);return C+=n,{id:k,type:"full",data:i}}const m=p[C++],o=[];for(let n=0;n<m;n++){const i=p[C++],r=p[C++],s=p[C++];let t;s>0&&(t=p.subarray(C,C+s),C+=s),o[n]={start:i,deleteCount:r,data:t}}return{id:k,type:"delta",deltas:o}}}),define(ke[200],Ee([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,176,129,200]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=n,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=y,e.filterValidationDecorations=de;var $;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class v{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=v;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(ue,Pe,Ke,_e){this.id=ue,this.name=Pe,this.defaultValue=Ke,this.schema=_e}applyUpdate(ue,Pe){return C(ue,Pe)}compute(ue,Pe,Ke){return Ke}}class p{constructor(ue,Pe){this.newValue=ue,this.didChange=Pe}}e.ApplyUpdateResult=p;function C(oe,ue){if(typeof oe!="object"||typeof ue!="object"||!oe||!ue)return new p(ue,oe!==ue);if(Array.isArray(oe)||Array.isArray(ue)){const Ke=Array.isArray(oe)&&Array.isArray(ue)&&u.$ub(oe,ue);return new p(ue,!Ke)}let Pe=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const _e=C(oe[Ke],ue[Ke]);_e.didChange&&(oe[Ke]=_e.newValue,Pe=!0)}return new p(oe,Pe)}class k{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Pe){return C(ue,Pe)}validate(ue){return this.defaultValue}}class c{constructor(ue,Pe,Ke,_e){this.id=ue,this.name=Pe,this.defaultValue=Ke,this.schema=_e}applyUpdate(ue,Pe){return C(ue,Pe)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Pe,Ke){return Ke}}function m(oe,ue){return typeof oe>"u"?ue:oe==="false"?!1:!!oe}class o extends c{constructor(ue,Pe,Ke,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Ke),super(ue,Pe,Ke,_e)}validate(ue){return m(ue,this.defaultValue)}}function n(oe,ue,Pe,Ke){if(typeof oe>"u")return ue;let _e=parseInt(oe,10);return isNaN(_e)?ue:(_e=Math.max(Pe,_e),_e=Math.min(Ke,_e),_e|0)}class i extends c{static clampedInt(ue,Pe,Ke,_e){return n(ue,Pe,Ke,_e)}constructor(ue,Pe,Ke,_e,Ne,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Ke,lt.minimum=_e,lt.maximum=Ne),super(ue,Pe,Ke,lt),this.minimum=_e,this.maximum=Ne}validate(ue){return i.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(oe,ue,Pe,Ke){if(typeof oe>"u")return ue;const _e=s.float(oe,ue);return s.clamp(_e,Pe,Ke)}class s extends c{static clamp(ue,Pe,Ke){return ue<Pe?Pe:ue>Ke?Ke:ue}static float(ue,Pe){if(typeof ue=="number")return ue;if(typeof ue>"u")return Pe;const Ke=parseFloat(ue);return isNaN(Ke)?Pe:Ke}constructor(ue,Pe,Ke,_e,Ne){typeof Ne<"u"&&(Ne.type="number",Ne.default=Ke),super(ue,Pe,Ke,Ne),this.validationFn=_e}validate(ue){return this.validationFn(s.float(ue,this.defaultValue))}}class t extends c{static string(ue,Pe){return typeof ue!="string"?Pe:ue}constructor(ue,Pe,Ke,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Ke),super(ue,Pe,Ke,_e)}validate(ue){return t.string(ue,this.defaultValue)}}function f(oe,ue,Pe,Ke){return typeof oe!="string"?ue:Ke&&oe in Ke?Ke[oe]:Pe.indexOf(oe)===-1?ue:oe}class d extends c{constructor(ue,Pe,Ke,_e,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=_e,Ne.default=Ke),super(ue,Pe,Ke,Ne),this.c=_e}validate(ue){return f(ue,this.defaultValue,this.c)}}class l extends I{constructor(ue,Pe,Ke,_e,Ne,lt,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=Ne,wt.default=_e),super(ue,Pe,Ke,wt),this.c=Ne,this.d=lt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function a(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Pe,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class g extends I{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{insertSpace:m(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function w(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function y(oe){switch(oe){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function D(oe){switch(oe){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class P extends k{constructor(){super(142)}compute(ue,Pe,Ke){const _e=["monaco-editor"];return Pe.get(39)&&_e.push(Pe.get(39)),ue.extraEditorClassName&&_e.push(ue.extraEditorClassName),Pe.get(74)==="default"?_e.push("mouse-default"):Pe.get(74)==="copy"&&_e.push("mouse-copy"),Pe.get(111)&&_e.push("showUnused"),Pe.get(140)&&_e.push("showDeprecated"),_e.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Pe,Ke){return Ke&&ue.emptySelectionClipboard}}class F extends I{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:O.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{cursorMoveOnType:m(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":f(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":f(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Pe.loop,this.defaultValue.loop)}}}class T extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?T.OFF:ue==="true"?T.ON:ue:ue?T.ON:T.OFF}}e.EditorFontLigatures=T;class j extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.TRANSLATE:ue:ue?j.TRANSLATE:j.OFF}compute(ue,Pe,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class N extends k{constructor(){super(50)}compute(ue,Pe,Ke){return ue.fontInfo}}class B extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Pe=s.float(ue,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Pe,6,100)}compute(ue,Pe,Ke){return ue.fontInfo.fontSize}}class W extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(i.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class Y extends I{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{multiple:f(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??f(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??f(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??f(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??f(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??f(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _ extends I{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),delay:i.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:m(Pe.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Pe.above,this.defaultValue.above)}}}var J;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class Z extends k{constructor(){super(145)}compute(ue,Pe,Ke){return Z.computeLayout(Pe,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Pe=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let _e=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(_e=Math.max(_e,Pe-1));const Ne=(Ke+ue.viewLineCount+_e)/(ue.pixelRatio*ue.height),lt=Math.floor(ue.viewLineCount/Ne);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:_e,desiredRatio:Ne,minimapLineCount:lt}}static c(ue,Pe){const Ke=ue.outerWidth,_e=ue.outerHeight,Ne=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const lt=Pe.stableMinimapLayoutInput,wt=lt&&ue.outerHeight===lt.outerHeight&&ue.lineHeight===lt.lineHeight&&ue.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===lt.pixelRatio&&ue.scrollBeyondLastLine===lt.scrollBeyondLastLine&&ue.paddingTop===lt.paddingTop&&ue.paddingBottom===lt.paddingBottom&&ue.minimap.enabled===lt.minimap.enabled&&ue.minimap.side===lt.minimap.side&&ue.minimap.size===lt.minimap.size&&ue.minimap.showSlider===lt.minimap.showSlider&&ue.minimap.renderCharacters===lt.minimap.renderCharacters&&ue.minimap.maxColumn===lt.minimap.maxColumn&&ue.minimap.scale===lt.minimap.scale&&ue.verticalScrollbarWidth===lt.verticalScrollbarWidth&&ue.isViewportWrapping===lt.isViewportWrapping,At=ue.lineHeight,zt=ue.typicalHalfwidthCharacterWidth,Qt=ue.scrollBeyondLastLine,_t=ue.minimap.renderCharacters;let Ct=Ne>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Xt=ue.minimap.maxColumn,qt=ue.minimap.size,ai=ue.minimap.side,tt=ue.verticalScrollbarWidth,ei=ue.viewLineCount,ti=ue.remainingWidth,ft=ue.isViewportWrapping,bt=_t?2:3;let si=Math.floor(Ne*_e);const ii=si/Ne;let jt=!1,mt=!1,Rt=bt*Ct,Ht=Ct/Ne,Zt=1;if(qt==="fill"||qt==="fit"){const{typicalViewportLineCount:Mt,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:ni,desiredRatio:oi,minimapLineCount:Wt}=Z.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Qt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:_e,lineHeight:At,pixelRatio:Ne});if(ei/Wt>1)jt=!0,mt=!0,Ct=1,Rt=1,Ht=Ct/Ne;else{let St=!1,Gt=Ct+1;if(qt==="fit"){const Pt=Math.ceil((Tt+ei+ni)*Rt);ft&&wt&&ti<=Pe.stableFitRemainingWidth?(St=!0,Gt=Pe.stableFitMaxMinimapScale):St=Pt>si}if(qt==="fill"||St){jt=!0;const Pt=Ct;Rt=Math.min(At*Ne,Math.max(1,Math.floor(1/oi))),ft&&wt&&ti<=Pe.stableFitRemainingWidth&&(Gt=Pe.stableFitMaxMinimapScale),Ct=Math.min(Gt,Math.max(1,Math.floor(Rt/bt))),Ct>Pt&&(Zt=Math.min(2,Ct/Pt)),Ht=Ct/Ne/Zt,si=Math.ceil(Math.max(Mt,Tt+ei+ni)*Rt),ft?(Pe.stableMinimapLayoutInput=ue,Pe.stableFitRemainingWidth=ti,Pe.stableFitMaxMinimapScale=Ct):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const Ze=Math.floor(Xt*Ht),Yt=Math.min(Ze,Math.max(0,Math.floor((ti-tt-2)*Ht/(zt+Ht)))+e.MINIMAP_GUTTER_WIDTH);let Bt=Math.floor(Ne*Yt);const Ut=Bt/Ne;Bt=Math.floor(Bt*Zt);const $t=_t?1:2,Ft=ai==="left"?0:Ke-Yt-tt;return{renderMinimap:$t,minimapLeft:Ft,minimapWidth:Yt,minimapHeightIsEditorHeight:jt,minimapIsSampling:mt,minimapScale:Ct,minimapLineHeight:Rt,minimapCanvasInnerWidth:Bt,minimapCanvasInnerHeight:si,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:ii}}static computeLayout(ue,Pe){const Ke=Pe.outerWidth|0,_e=Pe.outerHeight|0,Ne=Pe.lineHeight|0,lt=Pe.lineNumbersDigitCount|0,wt=Pe.typicalHalfwidthCharacterWidth,At=Pe.maxDigitWidth,zt=Pe.pixelRatio,Qt=Pe.viewLineCount,_t=ue.get(137),Ct=_t==="inherit"?ue.get(136):_t,Xt=Ct==="inherit"?ue.get(132):Ct,qt=ue.get(135),ai=Pe.isDominatedByLongLines,tt=ue.get(57),ei=ue.get(68).renderType!==0,ti=ue.get(69),ft=ue.get(105),bt=ue.get(84),si=ue.get(73),ii=ue.get(103),jt=ii.verticalScrollbarSize,mt=ii.verticalHasArrows,Rt=ii.arrowSize,Ht=ii.horizontalScrollbarSize,Zt=ue.get(43),Ze=ue.get(110)!=="never";let Yt=ue.get(66);Zt&&Ze&&(Yt+=16);let Bt=0;if(ei){const Dt=Math.max(lt,ti);Bt=Math.round(Dt*At)}let Ut=0;tt&&(Ut=Ne*Pe.glyphMarginDecorationLaneCount);let $t=0,Ft=$t+Ut,Mt=Ft+Bt,Tt=Mt+Yt;const ni=Ke-Ut-Bt-Yt;let oi=!1,Wt=!1,It=-1;Ct==="inherit"&&ai?(oi=!0,Wt=!0):Xt==="on"||Xt==="bounded"?Wt=!0:Xt==="wordWrapColumn"&&(It=qt);const St=Z.c({outerWidth:Ke,outerHeight:_e,lineHeight:Ne,typicalHalfwidthCharacterWidth:wt,pixelRatio:zt,scrollBeyondLastLine:ft,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:si,verticalScrollbarWidth:jt,viewLineCount:Qt,remainingWidth:ni,isViewportWrapping:Wt},Pe.memory||new R);St.renderMinimap!==0&&St.minimapLeft===0&&($t+=St.minimapWidth,Ft+=St.minimapWidth,Mt+=St.minimapWidth,Tt+=St.minimapWidth);const Gt=ni-St.minimapWidth,Pt=Math.max(1,Math.floor((Gt-jt-2)/wt)),yt=mt?Rt:0;return Wt&&(It=Math.max(1,Pt),Xt==="bounded"&&(It=Math.min(It,qt))),{width:Ke,height:_e,glyphMarginLeft:$t,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ft,lineNumbersWidth:Bt,decorationsLeft:Mt,decorationsWidth:Yt,contentLeft:Tt,contentWidth:Gt,minimap:St,viewportColumn:Pt,isWordWrapMinified:oi,isViewportWrapping:Wt,wrappingColumn:It,verticalScrollbarWidth:jt,horizontalScrollbarHeight:Ht,overviewRuler:{top:yt,width:jt,height:_e-2*yt,right:0}}}}e.EditorLayoutInfoComputer=Z;class re extends I{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return f(ue,"simple",["simple","advanced"])}compute(ue,Pe,Ke){return Pe.get(2)===2?"advanced":Ke}}var ee;(function(oe){oe.Off="off",oe.OnCode="onCode",oe.On="on"})(ee||(e.ShowLightbulbIconMode=ee={}));class pe extends I{constructor(){const ue={enabled:ee.OnCode};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ee.Off,ee.OnCode,ee.On],default:ue.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:f(ue.enabled,this.defaultValue.enabled,[ee.Off,ee.OnCode,ee.On])}}}class De extends I{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class x extends I{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,O.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,O.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:f(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:m(Pe.padding,this.defaultValue.padding)}}}class U extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):i.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Pe,Ke){return Ke<0?i.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ie extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>s.clamp(ue,0,150),{markdownDescription:b.localize(66,null)})}compute(ue,Pe,Ke){return ue.fontInfo.lineHeight}}class be extends I{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ue.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),autohide:m(Pe.autohide,this.defaultValue.autohide),size:f(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Pe.side,this.defaultValue.side,["right","left"]),showSlider:f(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Pe.scale,1,1,3),maxColumn:i.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(Pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(Pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Ce(oe){return oe==="ctrlCmd"?O.$j?"metaKey":"ctrlKey":"altKey"}class ae extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{top:i.clampedInt(Pe.top,0,0,1e3),bottom:i.clampedInt(Pe.bottom,0,0,1e3)}}}class ce extends I{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),cycle:m(Pe.cycle,this.defaultValue.cycle)}}}class se extends k{constructor(){super(143)}compute(ue,Pe,Ke){return ue.pixelRatio}}class K extends I{constructor(){const ue={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:ue.strings,description:b.localize(88,null)},comments:{anyOf:Pe,default:ue.comments,description:b.localize(89,null)},other:{anyOf:Pe,default:ue.other,description:b.localize(90,null)}},default:ue,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const zt=ue?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Pe,comments:Ke,strings:_e}=ue,Ne=["on","inline","off"];let lt,wt,At;return typeof Pe=="boolean"?lt=Pe?"on":"off":lt=f(Pe,this.defaultValue.other,Ne),typeof Ke=="boolean"?wt=Ke?"on":"off":wt=f(Ke,this.defaultValue.comments,Ne),typeof _e=="boolean"?At=_e?"on":"off":At=f(_e,this.defaultValue.strings,Ne),{other:lt,comments:wt,strings:At}}}var te;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class le extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ue){let Pe=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Pe=4,Ke=ue):ue==="interval"?Pe=3:ue==="relative"?Pe=2:ue==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:Ke}}}function de(oe){const ue=oe.get(98);return ue==="editable"?oe.get(91):ue!=="on"}class Ae extends I{constructor(){const ue=[],Pe={type:"number",description:b.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ue,description:b.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const Pe=[];for(const Ke of ue)if(typeof Ke=="number")Pe.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const _e=Ke;Pe.push({column:i.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Pe.sort((Ke,_e)=>Ke.column-_e.column),Pe}return this.defaultValue}}class me extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Ie(oe,ue){if(typeof oe!="string")return ue;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends I{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue,Ke=i.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=i.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Pe.vertical,this.defaultValue.vertical),horizontal:Ie(Pe.horizontal,this.defaultValue.horizontal),useShadows:m(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(Pe.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:i.clampedInt(Pe.verticalSliderSize,_e,0,1e3),scrollByPage:m(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Fe extends I{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ue,Pe){let Ke=!1;Pe.allowedCharacters&&ue&&(L.$Sn(ue.allowedCharacters,Pe.allowedCharacters)||(ue={...ue,allowedCharacters:Pe.allowedCharacters},Ke=!0)),Pe.allowedLocales&&ue&&(L.$Sn(ue.allowedLocales,Pe.allowedLocales)||(ue={...ue,allowedLocales:Pe.allowedLocales},Ke=!0));const _e=super.applyUpdate(ue,Pe);return Ke?new p(_e.newValue,!0):_e}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{nonBasicASCII:fe(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Pe){if(typeof ue!="object"||!ue)return Pe;const Ke={};for(const[_e,Ne]of Object.entries(ue))Ne===!0&&(Ke[_e]=!0);return Ke}}class q extends I{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:b.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),mode:f(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily)}}}class V extends I{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:b.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),showToolbar:f(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(Pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(Pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class X extends I{constructor(){const ue={enabled:A.$Ms.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$Ms.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends I{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ue.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ue.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ue.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{bracketPairs:fe(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(oe,ue,Pe){const Ke=Pe.indexOf(oe);return Ke===-1?ue:Pe[Ke]}class we extends I{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ue.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ue.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{insertMode:f(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:m(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:m(Pe.preview,this.defaultValue.preview),previewMode:f(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Pe.showMethods,this.defaultValue.showMethods),showFunctions:m(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Pe.showFields,this.defaultValue.showFields),showVariables:m(Pe.showVariables,this.defaultValue.showVariables),showClasses:m(Pe.showClasses,this.defaultValue.showClasses),showStructs:m(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:m(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Pe.showModules,this.defaultValue.showModules),showProperties:m(Pe.showProperties,this.defaultValue.showProperties),showEvents:m(Pe.showEvents,this.defaultValue.showEvents),showOperators:m(Pe.showOperators,this.defaultValue.showOperators),showUnits:m(Pe.showUnits,this.defaultValue.showUnits),showValues:m(Pe.showValues,this.defaultValue.showValues),showConstants:m(Pe.showConstants,this.defaultValue.showConstants),showEnums:m(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Pe.showKeywords,this.defaultValue.showKeywords),showWords:m(Pe.showWords,this.defaultValue.showWords),showColors:m(Pe.showColors,this.defaultValue.showColors),showFiles:m(Pe.showFiles,this.defaultValue.showFiles),showReferences:m(Pe.showReferences,this.defaultValue.showReferences),showFolders:m(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:m(Pe.showUsers,this.defaultValue.showUsers),showIssues:m(Pe.showIssues,this.defaultValue.showIssues)}}}class Te extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class He extends I{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const Pe=[];for(const Ke of ue)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Pe.push(Ke)}catch{}return Pe}return this.defaultValue}}var xe;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(xe||(e.WrappingIndent=xe={}));class it extends I{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Pe,Ke){return Pe.get(2)===2?0:Ke}}class rt extends k{constructor(){super(146)}compute(ue,Pe,Ke){const _e=Pe.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class at extends I{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),showDropSelector:f(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends I{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),showPasteSelector:f(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Se="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:O.$j?Be:O.$k?Ge:Se,fontWeight:"normal",fontSize:O.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var Qe;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.ariaRequired=5]="ariaRequired",oe[oe.autoClosingBrackets=6]="autoClosingBrackets",oe[oe.autoClosingComments=7]="autoClosingComments",oe[oe.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",oe[oe.autoClosingDelete=9]="autoClosingDelete",oe[oe.autoClosingOvertype=10]="autoClosingOvertype",oe[oe.autoClosingQuotes=11]="autoClosingQuotes",oe[oe.autoIndent=12]="autoIndent",oe[oe.automaticLayout=13]="automaticLayout",oe[oe.autoSurround=14]="autoSurround",oe[oe.bracketPairColorization=15]="bracketPairColorization",oe[oe.guides=16]="guides",oe[oe.codeLens=17]="codeLens",oe[oe.codeLensFontFamily=18]="codeLensFontFamily",oe[oe.codeLensFontSize=19]="codeLensFontSize",oe[oe.colorDecorators=20]="colorDecorators",oe[oe.colorDecoratorsLimit=21]="colorDecoratorsLimit",oe[oe.columnSelection=22]="columnSelection",oe[oe.comments=23]="comments",oe[oe.contextmenu=24]="contextmenu",oe[oe.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=26]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=28]="cursorStyle",oe[oe.cursorSurroundingLines=29]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=31]="cursorWidth",oe[oe.disableLayerHinting=32]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",oe[oe.domReadOnly=34]="domReadOnly",oe[oe.dragAndDrop=35]="dragAndDrop",oe[oe.dropIntoEditor=36]="dropIntoEditor",oe[oe.emptySelectionClipboard=37]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=39]="extraEditorClassName",oe[oe.fastScrollSensitivity=40]="fastScrollSensitivity",oe[oe.find=41]="find",oe[oe.fixedOverflowWidgets=42]="fixedOverflowWidgets",oe[oe.folding=43]="folding",oe[oe.foldingStrategy=44]="foldingStrategy",oe[oe.foldingHighlight=45]="foldingHighlight",oe[oe.foldingImportsByDefault=46]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=47]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=49]="fontFamily",oe[oe.fontInfo=50]="fontInfo",oe[oe.fontLigatures=51]="fontLigatures",oe[oe.fontSize=52]="fontSize",oe[oe.fontWeight=53]="fontWeight",oe[oe.fontVariations=54]="fontVariations",oe[oe.formatOnPaste=55]="formatOnPaste",oe[oe.formatOnType=56]="formatOnType",oe[oe.glyphMargin=57]="glyphMargin",oe[oe.gotoLocation=58]="gotoLocation",oe[oe.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",oe[oe.hover=60]="hover",oe[oe.inDiffEditor=61]="inDiffEditor",oe[oe.inlineSuggest=62]="inlineSuggest",oe[oe.inlineEdit=63]="inlineEdit",oe[oe.letterSpacing=64]="letterSpacing",oe[oe.lightbulb=65]="lightbulb",oe[oe.lineDecorationsWidth=66]="lineDecorationsWidth",oe[oe.lineHeight=67]="lineHeight",oe[oe.lineNumbers=68]="lineNumbers",oe[oe.lineNumbersMinChars=69]="lineNumbersMinChars",oe[oe.linkedEditing=70]="linkedEditing",oe[oe.links=71]="links",oe[oe.matchBrackets=72]="matchBrackets",oe[oe.minimap=73]="minimap",oe[oe.mouseStyle=74]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=76]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=78]="multiCursorModifier",oe[oe.multiCursorPaste=79]="multiCursorPaste",oe[oe.multiCursorLimit=80]="multiCursorLimit",oe[oe.occurrencesHighlight=81]="occurrencesHighlight",oe[oe.overviewRulerBorder=82]="overviewRulerBorder",oe[oe.overviewRulerLanes=83]="overviewRulerLanes",oe[oe.padding=84]="padding",oe[oe.pasteAs=85]="pasteAs",oe[oe.parameterHints=86]="parameterHints",oe[oe.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=89]="quickSuggestions",oe[oe.quickSuggestionsDelay=90]="quickSuggestionsDelay",oe[oe.readOnly=91]="readOnly",oe[oe.readOnlyMessage=92]="readOnlyMessage",oe[oe.renameOnType=93]="renameOnType",oe[oe.renderControlCharacters=94]="renderControlCharacters",oe[oe.renderFinalNewline=95]="renderFinalNewline",oe[oe.renderLineHighlight=96]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=98]="renderValidationDecorations",oe[oe.renderWhitespace=99]="renderWhitespace",oe[oe.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",oe[oe.roundedSelection=101]="roundedSelection",oe[oe.rulers=102]="rulers",oe[oe.scrollbar=103]="scrollbar",oe[oe.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=105]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=106]="scrollPredominantAxis",oe[oe.selectionClipboard=107]="selectionClipboard",oe[oe.selectionHighlight=108]="selectionHighlight",oe[oe.selectOnLineNumbers=109]="selectOnLineNumbers",oe[oe.showFoldingControls=110]="showFoldingControls",oe[oe.showUnused=111]="showUnused",oe[oe.snippetSuggestions=112]="snippetSuggestions",oe[oe.smartSelect=113]="smartSelect",oe[oe.smoothScrolling=114]="smoothScrolling",oe[oe.stickyScroll=115]="stickyScroll",oe[oe.stickyTabStops=116]="stickyTabStops",oe[oe.stopRenderingLineAfter=117]="stopRenderingLineAfter",oe[oe.suggest=118]="suggest",oe[oe.suggestFontSize=119]="suggestFontSize",oe[oe.suggestLineHeight=120]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",oe[oe.suggestSelection=122]="suggestSelection",oe[oe.tabCompletion=123]="tabCompletion",oe[oe.tabIndex=124]="tabIndex",oe[oe.unicodeHighlighting=125]="unicodeHighlighting",oe[oe.unusualLineTerminators=126]="unusualLineTerminators",oe[oe.useShadowDOM=127]="useShadowDOM",oe[oe.useTabStops=128]="useTabStops",oe[oe.wordBreak=129]="wordBreak",oe[oe.wordSegmenterLocales=130]="wordSegmenterLocales",oe[oe.wordSeparators=131]="wordSeparators",oe[oe.wordWrap=132]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=135]="wordWrapColumn",oe[oe.wordWrapOverride1=136]="wordWrapOverride1",oe[oe.wordWrapOverride2=137]="wordWrapOverride2",oe[oe.wrappingIndent=138]="wrappingIndent",oe[oe.wrappingStrategy=139]="wrappingStrategy",oe[oe.showDeprecated=140]="showDeprecated",oe[oe.inlayHints=141]="inlayHints",oe[oe.editorClassName=142]="editorClassName",oe[oe.pixelRatio=143]="pixelRatio",oe[oe.tabFocusMode=144]="tabFocusMode",oe[oe.layoutInfo=145]="layoutInfo",oe[oe.wrappingInfo=146]="wrappingInfo",oe[oe.defaultColorDecorators=147]="defaultColorDecorators",oe[oe.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",oe[oe.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Me(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Me(new h),accessibilityPageSize:Me(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Me(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Me(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Me(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Me(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Me(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Me(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Me(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Me(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Me(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Me(new o(13,"automaticLayout",!1)),autoSurround:Me(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Me(new X),bracketPairGuides:Me(new Q),stickyTabStops:Me(new o(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Me(new o(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Me(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Me(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Me(new o(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Me(new d(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Me(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Me(new o(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Me(new g),contextmenu:Me(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Me(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Me(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Me(new l(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:b.localize(260,null)})),cursorSurroundingLines:Me(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Me(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Me(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Me(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new o(34,"domReadOnly",!1)),dragAndDrop:Me(new o(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Me(new z),dropIntoEditor:Me(new at),stickyScroll:Me(new De),experimentalWhitespaceRendering:Me(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Me(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Me(new s(40,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:b.localize(271,null)})),find:Me(new F),fixedOverflowWidgets:Me(new o(42,"fixedOverflowWidgets",!1)),folding:Me(new o(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Me(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Me(new o(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Me(new o(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Me(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Me(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Me(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Me(new N),fontLigatures2:Me(new T),fontSize:Me(new B),fontWeight:Me(new W),fontVariations:Me(new j),formatOnPaste:Me(new o(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Me(new o(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Me(new o(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Me(new Y),hideCursorInOverviewRuler:Me(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Me(new _),inDiffEditor:Me(new o(61,"inDiffEditor",!1)),letterSpacing:Me(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>s.clamp(oe,-5,20),{description:b.localize(285,null)})),lightbulb:Me(new pe),lineDecorationsWidth:Me(new U),lineHeight:Me(new ie),lineNumbers:Me(new le),lineNumbersMinChars:Me(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new o(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Me(new o(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Me(new d(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Me(new be),mouseStyle:Me(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new s(75,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Me(new o(76,"mouseWheelZoom",!1,{markdownDescription:O.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Me(new o(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Me(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ce,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Me(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Me(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Me(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Me(new o(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Me(new i(83,"overviewRulerLanes",3,0,3)),padding:Me(new ae),pasteAs:Me(new ot),parameterHints:Me(new ce),peekWidgetDefaultFocus:Me(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Me(new o(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Me(new K),quickSuggestionsDelay:Me(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Me(new o(91,"readOnly",!1)),readOnlyMessage:Me(new me),renameOnType:Me(new o(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Me(new o(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Me(new d(95,"renderFinalNewline",O.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Me(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Me(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Me(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Me(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new o(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Me(new Ae),scrollbar:Me(new Re),scrollBeyondLastColumn:Me(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Me(new o(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Me(new o(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Me(new o(107,"selectionClipboard",!0,{description:b.localize(325,null),included:O.$k})),selectionHighlight:Me(new o(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Me(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Me(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Me(new o(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Me(new o(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Me(new x),snippetSuggestions:Me(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Me(new Te),smoothScrolling:Me(new o(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Me(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new we),inlineSuggest:Me(new q),inlineEdit:Me(new V),inlineCompletionsAccessibilityVerbose:Me(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Me(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new o(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Me(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Me(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Me(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new Fe),unusualLineTerminators:Me(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Me(new o(127,"useShadowDOM",!0)),useTabStops:Me(new o(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Me(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Me(new He),wordSeparators:Me(new t(131,"wordSeparators",M.$Ns,{description:b.localize(359,null)})),wordWrap:Me(new d(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Me(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Me(new d(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new d(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new P),defaultColorDecorators:Me(new o(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Me(new se),tabFocusMode:Me(new o(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Me(new Z),wrappingInfo:Me(new rt),wrappingIndent:Me(new it),wrappingStrategy:Me(new re)}}),define(ke[201],Ee([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(ke[83],Ee([1,0,78,2,174,29,184,201]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$9t=e.$8t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$7t=e.$6t=e.SymbolKinds=e.SymbolTag=e.$4t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$2t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$1t=e.$Zt=e.$Yt=void 0,e.$3t=f,e.$5t=l;class ${constructor(Y,_,J){this.offset=Y,this.type=_,this.language=J,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Yt=$;class v{constructor(Y,_){this.tokens=Y,this.endState=_,this._tokenizationResultBrand=void 0}}e.$Zt=v;class R{constructor(Y,_){this.tokens=Y,this.endState=_,this._encodedTokenizationResultBrand=void 0}}e.$1t=R;var I;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var p;(function(W){const Y=new Map;Y.set(0,u.$Hj.symbolMethod),Y.set(1,u.$Hj.symbolFunction),Y.set(2,u.$Hj.symbolConstructor),Y.set(3,u.$Hj.symbolField),Y.set(4,u.$Hj.symbolVariable),Y.set(5,u.$Hj.symbolClass),Y.set(6,u.$Hj.symbolStruct),Y.set(7,u.$Hj.symbolInterface),Y.set(8,u.$Hj.symbolModule),Y.set(9,u.$Hj.symbolProperty),Y.set(10,u.$Hj.symbolEvent),Y.set(11,u.$Hj.symbolOperator),Y.set(12,u.$Hj.symbolUnit),Y.set(13,u.$Hj.symbolValue),Y.set(15,u.$Hj.symbolEnum),Y.set(14,u.$Hj.symbolConstant),Y.set(15,u.$Hj.symbolEnum),Y.set(16,u.$Hj.symbolEnumMember),Y.set(17,u.$Hj.symbolKeyword),Y.set(27,u.$Hj.symbolSnippet),Y.set(18,u.$Hj.symbolText),Y.set(19,u.$Hj.symbolColor),Y.set(20,u.$Hj.symbolFile),Y.set(21,u.$Hj.symbolReference),Y.set(22,u.$Hj.symbolCustomColor),Y.set(23,u.$Hj.symbolFolder),Y.set(24,u.$Hj.symbolTypeParameter),Y.set(25,u.$Hj.account),Y.set(26,u.$Hj.issues);function _(re){let ee=Y.get(re);return ee||(console.info("No codicon found for CompletionItemKind "+re),ee=u.$Hj.symbolProperty),ee}W.toIcon=_;const J=new Map;J.set("method",0),J.set("function",1),J.set("constructor",2),J.set("field",3),J.set("variable",4),J.set("class",5),J.set("struct",6),J.set("interface",7),J.set("module",8),J.set("property",9),J.set("event",10),J.set("operator",11),J.set("unit",12),J.set("value",13),J.set("constant",14),J.set("enum",15),J.set("enum-member",16),J.set("enumMember",16),J.set("keyword",17),J.set("snippet",27),J.set("text",18),J.set("color",19),J.set("file",20),J.set("reference",21),J.set("customcolor",22),J.set("folder",23),J.set("type-parameter",24),J.set("typeParameter",24),J.set("account",25),J.set("issue",26);function Z(re,ee){let pe=J.get(re);return typeof pe>"u"&&!ee&&(pe=9),pe}W.fromString=Z})(p||(e.CompletionItemKinds=p={}));var C;(function(W){W[W.Deprecated=1]="Deprecated"})(C||(e.CompletionItemTag=C={}));var k;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var c;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(c||(e.PartialAcceptTriggerKind=c={}));var m;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var o;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class n{constructor(Y,_,J,Z){this.range=Y,this.text=_,this.completionKind=J,this.isSnippetText=Z}equals(Y){return A.$ct.lift(this.range).equalsRange(Y.range)&&this.text===Y.text&&this.completionKind===Y.completionKind&&this.isSnippetText===Y.isSnippetText}}e.$2t=n;var i;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(W){return W&&L.URI.isUri(W.uri)&&A.$ct.isIRange(W.range)&&(A.$ct.isIRange(W.originSelectionRange)||A.$ct.isIRange(W.targetSelectionRange))}var d;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$4t={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function l(W,Y){return(0,b.localize)(26,null,W,e.$4t[Y])}var a;(function(W){W[W.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var h;(function(W){const Y=new Map;Y.set(0,u.$Hj.symbolFile),Y.set(1,u.$Hj.symbolModule),Y.set(2,u.$Hj.symbolNamespace),Y.set(3,u.$Hj.symbolPackage),Y.set(4,u.$Hj.symbolClass),Y.set(5,u.$Hj.symbolMethod),Y.set(6,u.$Hj.symbolProperty),Y.set(7,u.$Hj.symbolField),Y.set(8,u.$Hj.symbolConstructor),Y.set(9,u.$Hj.symbolEnum),Y.set(10,u.$Hj.symbolInterface),Y.set(11,u.$Hj.symbolFunction),Y.set(12,u.$Hj.symbolVariable),Y.set(13,u.$Hj.symbolConstant),Y.set(14,u.$Hj.symbolString),Y.set(15,u.$Hj.symbolNumber),Y.set(16,u.$Hj.symbolBoolean),Y.set(17,u.$Hj.symbolArray),Y.set(18,u.$Hj.symbolObject),Y.set(19,u.$Hj.symbolKey),Y.set(20,u.$Hj.symbolNull),Y.set(21,u.$Hj.symbolEnumMember),Y.set(22,u.$Hj.symbolStruct),Y.set(23,u.$Hj.symbolEvent),Y.set(24,u.$Hj.symbolOperator),Y.set(25,u.$Hj.symbolTypeParameter);function _(J){let Z=Y.get(J);return Z||(console.info("No codicon found for SymbolKind "+J),Z=u.$Hj.symbolProperty),Z}W.toIcon=_})(h||(e.SymbolKinds=h={}));class g{static asEditOperation(Y){return O.$dt.replace(A.$ct.lift(Y.range),Y.text)}}e.$6t=g;class S{static{this.Comment=new S("comment")}static{this.Imports=new S("imports")}static{this.Region=new S("region")}static fromValue(Y){switch(Y){case"comment":return S.Comment;case"imports":return S.Imports;case"region":return S.Region}return new S(Y)}constructor(Y){this.value=Y}}e.$7t=S;var w;(function(W){W[W.AIGenerated=1]="AIGenerated"})(w||(e.NewSymbolNameTag=w={}));var E;(function(W){function Y(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}W.is=Y})(E||(e.Command=E={}));var y;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var D;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(D||(e.CommentThreadState=D={}));var P;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(P||(e.CommentThreadApplicability=P={}));var z;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var F;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(F||(e.CommentState=F={}));var T;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(T||(e.InlayHintKind=T={}));class j{constructor(Y){this.b=Y,this.a=null}dispose(){this.a&&this.a.then(Y=>{Y&&Y.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$8t=j,e.$9t=new M.$Nt;var N;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[202],Ee([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[203],Ee([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[204],Ee([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(ke[205],Ee([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[206],Ee([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[207],Ee([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[208],Ee([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[209],Ee([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(ke[210],Ee([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(ke[211],Ee([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[212],Ee([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(ke[213],Ee([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(ke[214],Ee([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[215],Ee([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[216],Ee([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(ke[217],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[218],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[219],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[220],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[221],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[222],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[223],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[224],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[225],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[226],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[227],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[228],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[229],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[230],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[231],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(ke[232],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(ke[233],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(ke[234],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[235],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[236],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[237],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[238],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[239],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[240],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[241],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[242],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[243],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[244],Ee([1,0,13,204]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var O;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...v){switch(v.length){case 1:return(0,L.localize)(0,null,v[0]);case 2:return(0,L.localize)(1,null,v[0],v[1]);case 3:return(0,L.localize)(2,null,v[0],v[1],v[2]);default:return}}const M=(0,L.localize)(3,null),b=(0,L.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,p=this.c.substring(this.d,this.e),C={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:R}),this.f.push(C)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),p=$.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,p=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(b);return}const k=this.c.charCodeAt(R);if(I)I=!1;else if(k===47&&!p){R++;break}else k===91?p=!0:k===92?I=!0:k===93&&(p=!1);R++}for(;R<this.c.length&&$.a.has(this.c.charCodeAt(R));)R++;this.e=R;const C=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:C,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=$}),define(ke[245],Ee([1,0,23,40,207,396]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=$,e.$tp=v,e.$up=R,e.$vp=I,e.$wp=p,e.$xp=C,e.$yp=k;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||M.test(o)}function v(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function R(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),f=!1);let d=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,a,h,g]=l;d=Date.UTC(Number(a),Number(h)-1,Number(g))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:d}}function I(o,n,i){let r;typeof o=="string"?r=R(v(o)):r=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=R(v(i)):t=i,!r||!t)return!1;const f=r.majorBase,d=r.minorBase,l=r.patchBase;let a=t.majorBase,h=t.minorBase,g=t.patchBase;const S=t.notBefore;let w=t.majorMustEqual,E=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>a?!0:f<a?!1:d>h?!0:d<h||s&&s<S?!1:l>=g:(f===1&&a===0&&(!w||!E||!y)&&(a=1,h=0,g=0,w=!0,E=!1,y=!1),f<a?!1:f>a?!w:d<h?!1:d>h?!E:l<g?!1:l>g?!y:!(s&&s<S))}function p(o,n,i,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([L.default.Error,O.localize(0,null)]),t;if(typeof r.name!="string")return t.push([L.default.Error,O.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([L.default.Error,O.localize(2,null,"version")]),t;if(!r.engines)return t.push([L.default.Error,O.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([L.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([L.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([L.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([L.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([L.default.Warning,O.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([L.default.Error,O.localize(9,null,"main")]),t;{const l=(0,u.$Vg)(i,r.main);(0,u.$Pg)(l,i)||t.push([L.default.Warning,O.localize(10,null,l.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([L.default.Error,O.localize(11,null,"browser")]),t;{const l=(0,u.$Vg)(i,r.browser);(0,u.$Pg)(l,i)||t.push([L.default.Warning,O.localize(12,null,l.path,i.path)])}}if(!A.valid(r.version))return t.push([L.default.Error,O.localize(13,null)]),t;const f=[];if(!C(o,n,r,s,f))for(const l of f)t.push([L.default.Error,l]);return t}function C(o,n,i,r,s){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:c(o,n,i.engines.vscode,s)}function k(o,n,i){return o==="*"||c(n,i,o)}function c(o,n,i,r=[]){const s=R(v(i));if(!s)return r.push(O.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(O.localize(15,null,i)),!1}else if(!s.majorMustEqual)return r.push(O.localize(16,null,i)),!1;return I(o,n,s)?!0:(r.push(O.localize(17,null,o,i)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ke[106],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class u{constructor(O,A=[],M=!1){this.ctor=O,this.staticArguments=A,this.supportsDelayedInstantiation=M}}e.$fi=u}),define(ke[84],Ee([1,0,106]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=A,e.$hs=M;const L=[];var O;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function A(b,$,v){$ instanceof u.$fi||($=new u.$fi($,[],!!v)),L.push([b,$])}function M(){return L}}),define(ke[246],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class u{constructor(A,M){this.key=A,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=u;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const M of this.a.values())M.outgoing.size===0&&A.push(M);return A}insertEdge(A,M){const b=this.lookupOrInsertNode(A),$=this.lookupOrInsertNode(M);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(A){const M=this.b(A);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(A){const M=this.b(A);let b=this.a.get(M);return b||(b=new u(M,A),this.a.set(M,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[M,b]of this.a)A.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,M]of this.a){const b=new Set([A]),$=this.c(M,b);if($)return $}}c(A,M){for(const[b,$]of A.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const v=this.c($,M);if(v)return v;M.delete(b)}}}e.$Xq=L}),define(ke[5],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=O,e.$ji=A;var u;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b($){return $[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(u||(e._util=u={})),e.$hi=O("instantiationService");function L(M,b,$){b[u.DI_TARGET]===b?b[u.DI_DEPENDENCIES].push({id:M,index:$}):(b[u.DI_DEPENDENCIES]=[{id:M,index:$}],b[u.DI_TARGET]=b)}function O(M){if(u.serviceIds.has(M))return u.serviceIds.get(M);const b=function($,v,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(b,$,R)};return b.toString=()=>M,u.serviceIds.set(M,b),b}function A(M){return M}}),define(ke[53],Ee([1,0,18,2,5]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=A,e.$Qi=M,e.$Ri=$,e.$Si=v,e.$Ti=R,e.$Ui=I,e.$Vi=p,e.$Wi=k,e.$Xi=c,e.$Yi=m,e.$Oi=(0,O.$ii)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof L.URI)}function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof L.URI)}var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function v(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function R(o,n){const i=Object.create(null);for(const r in o)I(i,r,o[r],n);return i}function I(o,n,i,r){const s=n.split("."),t=s.pop();let f=o;for(let d=0;d<s.length;d++){const l=s[d];let a=f[l];switch(typeof a){case"undefined":a=f[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(a)}`);return}f=a}if(typeof f=="object"&&f!==null)try{f[t]=i}catch{r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}function p(o,n){const i=n.split(".");C(o,i)}function C(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(C(r,n),Object.keys(r).length===0&&delete o[i])}}function k(o,n,i){function r(f,d){let l=f;for(const a of d){if(typeof l!="object"||l===null)return;l=l[a]}return l}const s=n.split("."),t=r(o,s);return typeof t>"u"?i:t}function c(o,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in o?u.$Xf(o[r])&&u.$Xf(n[r])?c(o[r],n[r],i):i&&(o[r]=n[r]):o[r]=n[r])})}function m(o){return o.replace(/[\[\]]/g,"")}}),define(ke[41],Ee([1,0,11,14,244,5,203,13]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=v,e.$hj=f,e.$ij=d,e.$Bj=ee;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",u.$j),$.set("isLinux",u.$k),$.set("isWindows",u.$i),$.set("isWeb",u.$o),$.set("isMacNative",u.$j&&!u.$o),$.set("isEdge",u.$H),$.set("isFirefox",u.$F),$.set("isChrome",u.$E),$.set("isSafari",u.$G);function v(x,U){if($.get(x)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(x,U)}const R=Object.prototype.hasOwnProperty;var I;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},C=(0,M.localize)(0,null),k=(0,M.localize)(1,null),c=(0,M.localize)(2,null),m=(0,M.localize)(3,null),o=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new O.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:C,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const be=this.D(),Ce=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:O.$dj.getLexeme(be),additionalInfo:Ce}),s.c}return ie}catch(ie){if(ie!==s.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,m),ie?.negate()}case 17:return this.z(),D.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,m),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const Ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ce.type!==10)throw this.B("REGEX",Ce);const ae=Ce.lexeme,ce=ae.lastIndexOf("/"),se=ce===ae.length-1?void 0:this.w(ae.substring(ce+1));let K;try{K=new RegExp(ae.substring(1,ce),se)}catch{throw this.B("REGEX",Ce)}return N.create(ie,K)}switch(Ce.type){case 10:case 19:{const ae=[Ce.lexeme];this.z();let ce=this.D(),se=0;for(let Ae=0;Ae<Ce.lexeme.length;Ae++)Ce.lexeme.charCodeAt(Ae)===40?se++:Ce.lexeme.charCodeAt(Ae)===41&&se--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let Ae=0;Ae<ce.lexeme.length;Ae++)ce.lexeme.charCodeAt(Ae)===40?se++:Ce.lexeme.charCodeAt(Ae)===41&&se--}if(se<0)break;ae.push(O.$dj.getLexeme(ce)),this.z(),ce=this.D()}const K=ae.join(""),te=K.lastIndexOf("/"),le=te===K.length-1?void 0:this.w(K.substring(te+1));let de;try{de=new RegExp(K.substring(1,te),le)}catch{throw this.B("REGEX",Ce)}return t.regex(ie,de)}case 18:{const ae=Ce.lexeme;this.z();let ce=null;if(!(0,L.$Ue)(ae)){const se=ae.indexOf("/"),K=ae.lastIndexOf("/");if(se!==K&&se>=0){const te=ae.slice(se+1,K),le=ae[K+1]==="i"?"i":"";try{ce=new RegExp(te,le)}catch{throw this.B("REGEX",Ce)}}}if(ce===null)throw this.B("REGEX",Ce);return N.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const Ce=this.u();return t.notIn(ie,Ce)}switch(this.D().type){case 3:{this.z();const Ce=this.u();if(this.x().type===18)return t.equals(ie,Ce);switch(Ce){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Ce)}}case 4:{this.z();const Ce=this.u();if(this.x().type===18)return t.notEquals(ie,Ce);switch(Ce){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Ce)}}case 5:return this.z(),T.create(ie,this.u());case 6:return this.z(),j.create(ie,this.u());case 7:return this.z(),z.create(ie,this.u());case 8:return this.z(),F.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,be){const Ce=(0,M.localize)(8,null,U,O.$dj.getLexeme(ie)),ae=ie.offset,ce=O.$dj.getLexeme(ie);return this.h.push({message:Ce,offset:ae,lexeme:ce,additionalInfo:be}),s.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=s;class t{static false(){return a.INSTANCE}static true(){return h.INSTANCE}static has(U){return g.create(U)}static equals(U,ie){return S.create(U,ie)}static notEquals(U,ie){return y.create(U,ie)}static regex(U,ie){return N.create(U,ie)}static in(U,ie){return w.create(U,ie)}static notIn(U,ie){return E.create(U,ie)}static not(U){return D.create(U)}static and(...U){return Y.create(U,null,!0)}static or(...U){return _.create(U,null,!0)}static greater(U,ie){return z.create(U,ie)}static greaterEquals(U,ie){return F.create(U,ie)}static smaller(U,ie){return T.create(U,ie)}static smallerEquals(U,ie){return j.create(U,ie)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$gj=t;function f(x){const U=new s({regexParsingWithErrorRecovery:!1});return x.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function d(x,U){const ie=x?x.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ie&&!be?!0:!ie||!be?!1:ie.equals(be)}function l(x,U){return x.cmp(U)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$jj=a;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return a.INSTANCE}}e.$kj=h;class g{static create(U,ie=null){const be=$.get(U);return typeof be=="boolean"?be?h.INSTANCE:a.INSTANCE:new g(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:a.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$lj=g;class S{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?g.create(U,be):D.create(U,be);const Ce=$.get(U);return typeof Ce=="boolean"?ie===(Ce?"true":"false")?h.INSTANCE:a.INSTANCE:new S(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?h.INSTANCE:a.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$mj=S;class w{static create(U,ie){return new w(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:re(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ie)?ie.includes(be):typeof be=="string"&&typeof ie=="object"&&ie!==null?R.call(ie,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$nj=w;class E{static create(U,ie){return new E(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=w.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=E;class y{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?D.create(U,be):g.create(U,be);const Ce=$.get(U);return typeof Ce=="boolean"?ie===(Ce?"true":"false")?a.INSTANCE:h.INSTANCE:new y(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?a.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$pj=y;class D{static create(U,ie=null){const be=$.get(U);return typeof be=="boolean"?be?a.INSTANCE:h.INSTANCE:new D(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?a.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$qj=D;function P(x,U){if(typeof x=="string"){const ie=parseFloat(x);isNaN(ie)||(x=ie)}return typeof x=="string"||typeof x=="number"?U(x):a.INSTANCE}class z{static create(U,ie,be=null){return P(ie,Ce=>new z(U,Ce,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$rj=z;class F{static create(U,ie,be=null){return P(ie,Ce=>new F(U,Ce,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$sj=F;class T{static create(U,ie,be=null){return P(ie,Ce=>new T(U,Ce,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$tj=T;class j{static create(U,ie,be=null){return P(ie,Ce=>new j(U,Ce,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$uj=j;class N{static create(U,ie){return new N(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return ie<be?-1:ie>be?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ie===be}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$vj=N;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$wj=B;function W(x){let U=null;for(let ie=0,be=x.length;ie<be;ie++){const Ce=x[ie].substituteConstants();if(x[ie]!==Ce&&U===null){U=[];for(let ae=0;ae<ie;ae++)U[ae]=x[ae]}U!==null&&(U[ie]=Ce)}return U===null?x:U}class Y{static create(U,ie,be){return Y.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const Ce=l(this.expr[ie],U.expr[ie]);if(Ce!==0)return Ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:Y.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,be){const Ce=[];let ae=!1;for(const ce of U)if(ce){if(ce.type===1){ae=!0;continue}if(ce.type===0)return a.INSTANCE;if(ce.type===6){Ce.push(...ce.expr);continue}Ce.push(ce)}if(Ce.length===0&&ae)return h.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(l);for(let ce=1;ce<Ce.length;ce++)Ce[ce-1].equals(Ce[ce])&&(Ce.splice(ce,1),ce--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const ce=Ce[Ce.length-1];if(ce.type!==9)break;Ce.pop();const se=Ce.pop(),K=Ce.length===0,te=_.create(ce.expr.map(le=>Y.create([le,se],null,be)),null,K);te&&(Ce.push(te),Ce.sort(l))}if(Ce.length===1)return Ce[0];if(be){for(let ce=0;ce<Ce.length;ce++)for(let se=ce+1;se<Ce.length;se++)if(Ce[ce].negate().equals(Ce[se]))return a.INSTANCE;if(Ce.length===1)return Ce[0]}return new Y(Ce,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new Y(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=_.create(U,this,!0)}return this.c}}e.$xj=Y;class _{static create(U,ie,be){return _.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const Ce=l(this.expr[ie],U.expr[ie]);if(Ce!==0)return Ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:_.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,be){let Ce=[],ae=!1;if(U){for(let ce=0,se=U.length;ce<se;ce++){const K=U[ce];if(K){if(K.type===0){ae=!0;continue}if(K.type===1)return h.INSTANCE;if(K.type===9){Ce=Ce.concat(K.expr);continue}Ce.push(K)}}if(Ce.length===0&&ae)return a.INSTANCE;Ce.sort(l)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let ce=1;ce<Ce.length;ce++)Ce[ce-1].equals(Ce[ce])&&(Ce.splice(ce,1),ce--);if(Ce.length===1)return Ce[0];if(be){for(let ce=0;ce<Ce.length;ce++)for(let se=ce+1;se<Ce.length;se++)if(Ce[ce].negate().equals(Ce[se]))return h.INSTANCE;if(Ce.length===1)return Ce[0]}return new _(Ce,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new _(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),be=U.shift(),Ce=[];for(const ae of De(ie))for(const ce of De(be))Ce.push(Y.create([ae,ce],null,!1));U.unshift(_.create(Ce,null,!1))}this.c=_.create(U,this,!0)}return this.c}}e.$yj=_;class J extends g{static{this.d=[]}static all(){return J.d.values()}constructor(U,ie,be){super(U,null),this.f=ie,typeof be=="object"?J.d.push({...be,key:U}):be!==!0&&J.d.push({key:U,description:be,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return S.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$zj=J,e.$Aj=(0,A.$ii)("contextKeyService");function Z(x,U){return x<U?-1:x>U?1:0}function re(x,U,ie,be){return x<ie?-1:x>ie?1:U<be?-1:U>be?1:0}function ee(x,U){if(x.type===0||U.type===1)return!0;if(x.type===9)return U.type===9?pe(x.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(ee(x,ie))return!0;return!1}if(x.type===6){if(U.type===6)return pe(U.expr,x.expr);for(const ie of x.expr)if(ee(ie,U))return!0;return!1}return x.equals(U)}function pe(x,U){let ie=0,be=0;for(;ie<x.length&&be<U.length;){const Ce=x[ie].cmp(U[be]);if(Ce<0)return!1;Ce===0&&ie++,be++}return ie===x.length}function De(x){return x.type===9?x.expr:[x]}}),define(ke[247],Ee([1,0,23,40,205,5,103,11,24]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$sw=e.$rw=e.$qw=void 0,e.$tw=C,e.$uw=k,e.$qw=(0,A.$ii)("dialogService");var v;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(v||(v={}));class R{a(m){return this.d(m,v.Confirmation)}b(m){return this.d(m,v.Prompt)}c(m){return this.d(m,v.Input)}d(m,o){const n=[];switch(o){case v.Confirmation:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,O.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,O.localize)(1,null));break}case v.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,O.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,O.localize)(3,null))),n.length===0&&n.push((0,O.localize)(4,null));break}case v.Input:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,O.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,O.localize)(6,null));break}}return n}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===L.default.Info?"info":m===L.default.Error?"error":m===L.default.Warning?"warning":"none"}f(m,o,n){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let r=i[o]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$rw=R,e.$sw=(0,A.$ii)("fileDialogService");var I;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function C(c){const m=[];return m.push(...c.slice(0,p).map(o=>typeof o=="string"?o:(0,u.$Sg)(o))),c.length>p&&(c.length-p===1?m.push((0,O.localize)(7,null)):m.push((0,O.localize)(8,null,c.length-p))),m.push(""),m.join(`
`)}function k(c,m){const o=(0,$.$On)(c);let n=(o.buttons??[]).map(t=>(0,M.$nw)(t)),i=(c.buttons||[]).map((t,f)=>f),r=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const f=i[s];i.splice(s,1),i.splice(1,0,f),s=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(s=r-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const f=i[s];i.splice(s,1),i.push(f),s=n.length-1}}return o.buttons=n,o.defaultId=r,o.cancelId=s,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,u.$ii)("environmentService"),e.$qi=(0,u.$ji)(e.$pi)}),define(ke[137],Ee([1,0,206,5]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=O,e.$Mo=A,e.$No=M,e.$Oo=b,e.$Po=$,e.$Qo=v,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function O(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,r){return r==="web"&&!i.includes("web")}function $(i,r,s){return b(r,s)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===s}function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var R;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var I;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var p;(function(i){i.Install="install",i.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var C;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.$Ro=(0,L.$ii)("extensionGalleryService");var k;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var c;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$So=m;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class n extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$To=n,e.$Uo=(0,L.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,L.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,L.$ii)("IExtensionTipsService"),e.$Zo=(0,u.localize2)(0,"Extensions"),e.$1o=(0,u.localize2)(1,"Preferences")}),define(ke[248],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.$Z5b=void 0,e.$Z5b=(0,u.$ii)("externalTerminal"),e.$15b="Terminal.app"}),define(ke[249],Ee([1,0,52,54,15,17,11,102,31,105,208,248]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=e.$1ac=void 0;const p=R.localize(0,null);class C{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends C{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(u,s,v.$am(),t)}spawnTerminal(s,t,f,d){const l=t.windowsExec||k.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const a=A.$oc(l,".exe").toLowerCase();if(a==="cmder")return s.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return l.indexOf(" ")>=0&&h.push('""'),h.push(l),a==="wt"&&h.push("-d ."),new Promise((g,S)=>{const w=o(process),E=s.spawn(f,h,{cwd:d,env:w,detached:!0});E.on("error",S),E.on("exit",()=>g())})}async runInTerminal(s,t,f,d,l){const a="windowsExec"in l&&l.windowsExec?l.windowsExec:k.getDefaultTerminalWindows(),h=await k.f();return new Promise((g,S)=>{const w=`"${t} - ${p}"`,E=`"${f.join('" "')}" & pause`,y=Object.assign({},o(process),d);Object.keys(y).filter(T=>y[T]===null).forEach(T=>delete y[T]);const D={cwd:t,env:y,windowsVerbatimArguments:!0};let P,z;A.$oc(a,".exe")==="wt"?(P=a,z=["-d",".",k.b,"/c",E]):h?(P=h,z=["-d",".",a,"/c",E]):(P=k.b,z=["/c","start",w,"/wait",a,"/c",`"${E}"`]),u.spawn(P,z,D).on("error",T=>{S(n(T))}),g(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return k.d}static async f(){try{const s=await v.win32.findExecutable("wt");return await $.Promises.exists(s)?s:void 0}catch{return}}}e.$1ac=k,Je([L.$Mh],k,"f",null);class c extends C{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const a=l.osxExec||I.$15b;return new Promise((h,g)=>{if(a===I.$15b||a==="iTerm.app"){const S=a===I.$15b?"TerminalHelper":"iTermHelper",E=[O.$Cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",s||p,"-w",t];for(const P of f)E.push("-a"),E.push(P);if(d){const P=Object.assign({},o(process),d);for(const z in P){const F=P[z];F===null?(E.push("-u"),E.push(z)):(E.push("-e"),E.push(`${z}=${F}`))}}let y="";const D=u.spawn(c.b,E);D.on("error",P=>{g(n(P))}),D.stderr.on("data",P=>{y+=P.toString()}),D.on("exit",P=>{if(P===0)h(void 0);else if(y){const z=y.split(`
`,1);g(new Error(z[0]))}else g(new Error(R.localize(1,null,S,P)))})}else g(new Error(R.localize(2,null,a)))})}spawnTerminal(s,t,f){const d=t.osxExec||I.$15b;return new Promise((l,a)=>{const h=["-a",d];f&&h.push(f);const g=o(process),S=s.spawn("/usr/bin/open",h,{cwd:f,env:g});S.on("error",a),S.on("exit",()=>l())})}}e.$2ac=c;class m extends C{static{this.b=R.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const a=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,g)=>{const S=[];a.then(w=>{w.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const E=`${i(f)}; echo; read -p "${m.b}" -n1;`;S.push(`''${E}''`);const y=Object.assign({},o(process),d);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const D={cwd:t,env:y};let P="";const z=u.spawn(w,S,D);z.on("error",F=>{g(n(F))}),z.stderr.on("data",F=>{P+=F.toString()}),z.on("exit",F=>{if(F===0)h(void 0);else if(P){const T=P.split(`
`,1);g(new Error(T[0]))}else g(new Error(R.localize(4,null,w,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!M.$k)m.d=Promise.resolve("xterm");else{const s=await $.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,f){const d=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,a)=>{d.then(h=>{const g=o(process),S=s.spawn(h,[],{cwd:f,env:g});S.on("error",a),S.on("exit",()=>l())})})}}e.$3ac=m;function o(r){const s={...r.env};return(0,b.$$l)(s),s}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(R.localize(5,null,r.path)):r}function i(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ke[32],Ee([1,0,77,17,14,18,2,209,5,11,15,45]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=p,e.$Qk=c,e.$Rk=o,e.$Sk=n,e.$Tk=i,e.$Uk=r,e.$Vk=s,e.$Wk=t,e.$Xk=f,e.$Yk=d,e.$Zk=l,e.$2k=g,e.$3k=S,e.$4k=w,e.$5k=E,e.$6k=y,e.$9k=T,e.$il=_,e.$jl=J,e.$ll=re,e.$Ok=(0,$.$ii)("fileService");function p(ee){return ee.create===!0}var C;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var k;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function c(ee){const pe=ee;return!!pe&&typeof pe.onDidChange=="function"}var m;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(ee){return!!(ee.capabilities&2)}function n(ee){return!!(ee.capabilities&8)}function i(ee){return!!(ee.capabilities&131072)}function r(ee){return!!(ee.capabilities&4)}function s(ee){return!!(ee.capabilities&16)}function t(ee){return o(ee)?!!(ee.capabilities&16384):!1}function f(ee){return o(ee)?!!(ee.capabilities&32768):!1}function d(ee){return!!(ee.capabilities&65536)}function l(ee){return!!(ee.capabilities&2048)}var a;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class h extends Error{static create(pe,De){const x=new h(pe.toString(),De);return w(x,De),x}constructor(pe,De){super(pe),this.code=De}}e.$1k=h;function g(ee,pe){return h.create(ee,pe)}function S(ee){return ee||g((0,b.localize)(0,null),a.Unknown)}function w(ee,pe){return ee.name=pe?`${pe} (FileSystemError)`:"FileSystemError",ee}function E(ee){if(!ee)return a.Unknown;if(ee instanceof h)return ee.code;const pe=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!pe)return a.Unknown;switch(pe[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}function y(ee){if(ee instanceof j)return ee.fileOperationResult;switch(E(ee)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}var D;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class P{constructor(pe,De,x){this.resource=pe,this.operation=De,this.target=x}isOperation(pe){return this.operation===pe}}e.$7k=P;var z;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class F{static{this.a=null}constructor(pe,De){this.c=De,this.b=void 0,this.d=new I.$V(()=>{const x=u.$oi.forUris(()=>this.c);return x.fill(this.rawAdded.map(U=>[U,!0])),x}),this.f=new I.$V(()=>{const x=u.$oi.forUris(()=>this.c);return x.fill(this.rawUpdated.map(U=>[U,!0])),x}),this.g=new I.$V(()=>{const x=u.$oi.forUris(()=>this.c);return x.fill(this.rawDeleted.map(U=>[U,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of pe){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==F.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(pe,...De){return this.h(pe,{includeChildren:!1},...De)}affects(pe,...De){return this.h(pe,{includeChildren:!0},...De)}h(pe,De,...x){if(!pe)return!1;const U=x.length>0;return!!((!U||x.includes(1))&&(this.d.value.get(pe)||De.includeChildren&&this.d.value.findSuperstr(pe))||(!U||x.includes(0))&&(this.f.value.get(pe)||De.includeChildren&&this.f.value.findSuperstr(pe))||(!U||x.includes(2))&&(this.g.value.findSubstr(pe)||De.includeChildren&&this.g.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.b===pe}hasCorrelation(){return typeof this.b=="number"}}e.$8k=F;function T(ee,pe,De){return!ee||!pe||ee===pe||pe.length>ee.length?!1:(pe.charAt(pe.length-1)!==L.sep&&(pe+=L.sep),De?(0,O.$mf)(ee,pe):ee.indexOf(pe)===0)}class j extends Error{constructor(pe,De,x){super(pe),this.fileOperationResult=De,this.options=x}}e.$0k=j;class N extends j{constructor(pe,De,x,U){super(pe,De,U),this.fileOperationResult=De,this.size=x}}e.$$k=N;class B extends j{constructor(pe,De,x){super(pe,2,x),this.stat=De}}e.$_k=B;var W;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var Y;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$hl="";function _(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function J(ee,pe){if(!pe.hasProvider(M.URI.from({scheme:ee.scheme})))return new Promise(De=>{const x=pe.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ee.scheme&&U.added&&(x.dispose(),De())})})}class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(pe){return(0,A.$Zf)(pe)||(pe=0),pe<Z.KB?(0,b.localize)(1,null,pe.toFixed(0)):pe<Z.MB?(0,b.localize)(2,null,(pe/Z.KB).toFixed(2)):pe<Z.GB?(0,b.localize)(3,null,(pe/Z.MB).toFixed(2)):pe<Z.TB?(0,b.localize)(4,null,(pe/Z.GB).toFixed(2)):(0,b.localize)(5,null,(pe/Z.TB).toFixed(2))}}e.$kl=Z;function re(ee){const pe=typeof ee=="string"||ee?.scheme===R.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===R.Schemas.file?1024*Z.MB:pe?10*Z.MB:v.$o?50*Z.MB:1024*Z.MB}}),define(ke[250],Ee([1,0,21,13,210,32]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=M;async function M(R,I,p,C,k,c){let m;try{await b(R,I,p,C,k,c)}catch(o){m=o}finally{m&&k.errorTransformer&&(m=k.errorTransformer(m)),typeof m<"u"&&p.error(m),p.end()}}async function b(R,I,p,C,k,c){$(c);const m=await R.open(I,{create:!1});try{$(c);let o=0,n=0,i=k&&typeof k.length=="number"?k.length:void 0,r=u.$ue.alloc(Math.min(k.bufferSize,typeof i=="number"?i:k.bufferSize)),s=k&&typeof k.position=="number"?k.position:0,t=0;do n=await R.read(m,s,r.buffer,t,r.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await p.write(C(r)),r=u.$ue.alloc(Math.min(k.bufferSize,typeof i=="number"?i:k.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(c)&&v(o,k));if(t>0){let f=t;typeof i=="number"&&(f=Math.min(t,i)),p.write(C(r.slice(0,f)))}}catch(o){throw(0,A.$3k)(o)}finally{await R.close(m)}}function $(R){if(R.isCancellationRequested)throw(0,L.$6)();return!0}function v(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,A.$2k)((0,O.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[64],Ee([1,0,35,3,17,11,2,32]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=void 0,e.$vq=$,e.$wq=v,e.$Aq=C,e.$Bq=k,e.$Cq=c,e.$Dq=m;function $(n){return typeof n.correlationId=="number"}function v(n){return n.recursive===!0}class R extends L.$Uc{static{this.a=5}constructor(i,r,s,t){super(),this.h=i,this.j=r,this.m=s,this.n=t,this.c=this.B(new L.$Vc),this.f=void 0,this.g=0}s(){const i=new L.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<R.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$xq=R;class I extends R{constructor(i,r,s){super(i,r,s,{type:"node.js",restartOnError:!1})}}e.$yq=I;class p extends R{constructor(i,r,s){super(i,r,s,{type:"universal",restartOnError:!0})}}e.$zq=p;function C(n){return n.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}function k(n){const i=new o;for(const r of n)i.processEvent(r);return i.coalesce()}function c(n,i){return typeof i=="string"&&!i.startsWith(u.$$j)&&!(0,O.$jc)(i)?{base:n,pattern:i}:i}function m(n,i){const r=[];for(const s of i)r.push((0,u.$ck)(c(n,s)));return r}class o{constructor(){this.a=new Set,this.b=new Map}c(i){return A.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let s=!1;if(r){const t=r.type,f=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:t===1&&f===2?(this.b.delete(this.c(i)),this.a.delete(r)):t===2&&f===1?r.type=0:t===1&&f===0||(r.type=f)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,b.$9k)(s.resource.fsPath,t,!A.$k))?!1:(r.push(s.resource.fsPath),!0)).concat(i)}}}),define(ke[251],Ee([1,0,51,3,64,4,2]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class b extends L.$Uc{constructor(){super(),this.a=this.B(new A.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new L.$4c),this.m=5007,this.B(this.f(v=>this.n(v)))}n(v){this.r(v)&&this.t(v)}r(v){return(0,O.$vq)(v)}async watch(v){this.h.clear(),this.g.clear();for(const R of v)this.r(R)?this.h.set(R.correlationId,R):this.g.add(R);for(const[R]of this.j)this.h.has(R)||this.j.deleteAndDispose(R);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(v=>!this.j.has(v.correlationId))])}t(v){if(this.j.has(v.correlationId))return;const R=new L.$Tc;this.j.set(v.correlationId,R),this.w(v,R),this.s()}u(v){this.j.deleteAndDispose(v.correlationId),this.s()}w(v,R){const I=M.URI.file(v.path),p=this;let C=!1;const k=(c,m)=>{if(R.isDisposed)return;const o=this.y(c),n=this.y(m),i=C;if(C=o,!o&&(n||i)){this.F(`fs.watchFile() detected ${v.path} exists again, resuming watcher (correlationId: ${v.correlationId})`);const r={resource:I,type:1,cId:v.correlationId};p.a.fire([r]),this.z(r,v),this.u(v)}};this.F(`starting fs.watchFile() on ${v.path} (correlationId: ${v.correlationId})`);try{(0,u.watchFile)(v.path,{persistent:!1,interval:this.m},k)}catch(c){this.G(`fs.watchFile() failed with error ${c} on path ${v.path} (correlationId: ${v.correlationId})`)}R.add((0,L.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${v.path} (correlationId: ${v.correlationId})`);try{(0,u.unwatchFile)(v.path,k)}catch(c){this.G(`fs.unwatchFile() failed with error ${c} on path ${v.path} (correlationId: ${v.correlationId})`)}}))}y(v){return v.ctimeMs===0&&v.ino===0}async stop(){this.j.clearAndDisposeAll()}z(v,R){const I=` >> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`;this.F(typeof R.correlationId=="number"?`${I} (correlationId: ${R.correlationId})`:I)}C(v){return`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`}}e.$Mq=b}),define(ke[252],Ee([1,0,51,8,22,34,3,76,17,11,23,2,104,31,64]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,e.$Sq=m;class c extends M.$Uc{static{this.a=100}static{this.b=75}constructor(n,i,r,s,t){super(),this.m=n,this.n=i,this.r=r,this.s=s,this.t=t,this.c=this.B(new L.$xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.n(f))),this.f=this.B(new L.$wh(f=>this.D(f),c.b)),this.g=(0,k.$Dq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$Dq)(this.m.path,this.m.includes):void 0,this.j=new O.$ee,this.ready=this.u()}async u(){try{const n=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const i=await C.Promises.stat(n);if(this.j.token.isCancellationRequested)return;this.B(await this.y(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.G(n):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${n})`),this.r?.()}}async w(n){let i=n.path;try{i=await C.Promises.realpath(n.path),n.path===i&&(i=await(0,p.$Oq)(n.path,this.j.token)??n.path),n.path!==i&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async y(n,i){if(v.$j&&(0,A.$ig)(n,"/Volumes/",!0))return this.G(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.$Uc.None;const r=new O.$ee(this.j.token),s=new M.$Tc;try{const t=I.URI.file(this.m.path),f=(0,$.$oc)(n),d=(0,u.watch)(n);s.add((0,M.$Sc)(()=>{d.removeAllListeners(),d.close()})),this.I(`Started watching: '${n}'`);const l=new Set;if(i)try{for(const h of await C.Promises.readdir(n))l.add(h)}catch(h){this.G(h)}const a=new Map;s.add((0,M.$Sc)(()=>{for(const[,h]of a)h.dispose();a.clear()})),d.on("error",(h,g)=>{this.G(`Failed to watch ${n} for changes using fs.watch() (${h}, ${g})`),this.r?.()}),d.on("change",(h,g)=>{if(r.token.isCancellationRequested)return;this.I(`[raw] ["${h}"] ${g}`);let S="";if(g&&(S=g.toString(),v.$j&&(S=(0,b.$Zl)(S))),!(!S||h!=="change"&&h!=="rename"))if(i)if(h==="rename"){a.get(S)?.dispose();const w=setTimeout(async()=>{if(a.delete(S),S===f&&!await C.Promises.exists(n)){this.z(t);return}const E=await this.F((0,$.$kc)(n,S));if(r.token.isCancellationRequested)return;let y;E?l.has(S)?y=0:(y=1,l.add(S)):(l.delete(S),y=2),this.C({resource:(0,R.$Vg)(t,S),type:y,cId:this.m.correlationId})},c.a);a.set(S,(0,M.$Sc)(()=>clearTimeout(w)))}else{let w;l.has(S)?w=0:(w=1,l.add(S)),this.C({resource:(0,R.$Vg)(t,S),type:w,cId:this.m.correlationId})}else if(h==="rename"||S!==f){const w=setTimeout(async()=>{const E=await C.Promises.exists(n);r.token.isCancellationRequested||(E?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),s.add(await this.y(n,!1))):this.z(t))},c.a);s.clear(),s.add((0,M.$Sc)(()=>clearTimeout(w)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){r.token.isCancellationRequested||this.G(`Failed to watch ${n} for changes using fs.watch() (${t.toString()})`),this.r?.()}return(0,M.$Sc)(()=>{r.dispose(!0),s.dispose()})}z(n){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:n,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(n,i=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}D(n){const i=(0,k.$Bq)(n);if(i.length>0){if(this.t)for(const s of i)this.I(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(n){if(v.$k)return C.Promises.exists(n);try{const i=(0,$.$oc)(n);return(await C.Promises.readdir((0,$.$nc)(n))).some(s=>s===i)}catch(i){return this.I(i),!1}}setVerboseLogging(n){this.t=n}G(n){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}H(n){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}I(n){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Rq=c;async function m(o,n,i,r,s=512){const t=await C.Promises.open(o,"r"),f=Buffer.allocUnsafe(s),d=new O.$ee(r);let l,a=!1;const h={path:o,excludes:[],recursive:!1},g=new c(h,S=>{(async()=>{for(const{type:w}of S)if(w===0){if(a)return;a=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:E}=await C.Promises.read(t,f,0,s,null);if(!E||d.token.isCancellationRequested)break;n(f.slice(0,E))}}catch(E){l=new Error(E),d.dispose(!0)}finally{a=!1}}})()});return await g.ready,i(),new Promise((S,w)=>{d.token.onCancellationRequested(async()=>{g.dispose();try{await C.Promises.close(t)}catch(E){l=new Error(E)}l?w(l):S()})})}}),define(ke[253],Ee([1,0,4,35,251,11,252,34]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class $ extends O.$Mq{constructor(){super(...arguments),this.onDidError=u.Event.None,this.H=new Set,this.I=!1}async D(R){R=this.O(R);const I=[],p=new Set(Array.from(this.H));for(const C of R){const k=this.L(C);k&&(0,L.$gk)(k.request.excludes,C.excludes)&&(0,L.$gk)(k.request.includes,C.includes)?p.delete(k):I.push(C)}I.length&&this.F(`Request to start watching: ${I.map(C=>this.C(C)).join(",")}`),p.size&&this.F(`Request to stop watching: ${Array.from(p).map(C=>this.C(C.request)).join(",")}`);for(const C of p)this.N(C);for(const C of I)this.M(C)}L(R){for(const I of this.H)if(typeof R.correlationId=="number"||typeof I.request.correlationId=="number"){if(I.request.correlationId===R.correlationId)return I}else if((0,b.$hg)(I.request.path,R.path,!A.$k))return I}M(R){const I=new M.$Rq(R,C=>this.a.fire(C),()=>this.c.fire(R),C=>this.b.fire(C),this.I),p={request:R,instance:I};this.H.add(p)}async stop(){await super.stop();for(const R of this.H)this.N(R)}N(R){this.F("stopping file watcher",R),this.H.delete(R),R.instance.dispose()}O(R){const I=new Map;for(const p of R){const C=A.$k?p.path:p.path.toLowerCase();let k=I.get(p.correlationId);k||(k=new Map,I.set(p.correlationId,k)),k.has(C)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(p)}`),k.set(C,p)}return Array.from(I.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(R){this.I=R;for(const I of this.H)I.instance.setVerboseLogging(R)}F(R,I){this.I&&this.b.fire({type:"trace",message:this.R(R,I)})}G(R){this.b.fire({type:"warn",message:this.R(R)})}R(R,I){return I?`[File Watcher (node.js)] ${R} (${this.C(I.request)})`:`[File Watcher (node.js)] ${R}`}}e.$Tq=$}),define(ke[254],Ee([1,0,64,253]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class O extends u.$yq{constructor(M,b,$){super(M,b,$),this.s()}r(M){return M.add(new L.$Tq)}}e.$Uq=O}),define(ke[255],Ee([1,0,15,81,193,64]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class M extends A.$zq{constructor($,v,R){super($,v,R),this.s()}r($){const v=$.add(new O.$Kq(u.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(v.onDidProcessExit(({code:R,signal:I})=>this.t(`terminated by itself with code ${R}, signal: ${I}`))),L.ProxyChannel.toService((0,L.$2h)(v.getChannel("watcher")))}}e.$Lq=M}),define(ke[107],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class u{constructor(...O){this.a=new Map;for(const[A,M]of O)this.set(A,M)}set(O,A){const M=this.a.get(O);return this.a.set(O,A),M}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$gi=u}),define(ke[256],Ee([1,0,8,13,3,106,246,5,107,75]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const R=!1;class I extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class p{constructor(m=new $.$gi,o=!1,n,i=R){this.f=m,this.g=o,this.h=n,this.i=i,this.o=new Set,this.f.set(b.$hi,this),this._globalGraph=i?n?._globalGraph??new M.$Xq(r=>r):void 0}createChild(m){return new p(m,this.g,this,this.i)}invokeFunction(m,...o){const n=k.traceInvocation(this.i,m);let i=!1;try{return m({get:s=>{if(i)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(m,...o){let n,i;return m instanceof A.$fi?(n=k.traceCreation(this.i,m.ctor),i=this.j(m.ctor,m.staticArguments.concat(o),n)):(n=k.traceCreation(this.i,m),i=this.j(m,o,n)),n.stop(),i}j(m,o=[],n){const i=b._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),r=[];for(const t of i){const f=this.m(t.id,n);f||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(m,o.concat(r))}k(m,o){if(this.f.get(m)instanceof A.$fi)this.f.set(m,o);else if(this.h)this.h.k(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const o=this.f.get(m);return!o&&this.h?this.h.l(m):o}m(m,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const n=this.l(m);return n instanceof A.$fi?this.q(m,n,o.branch(m,!0)):(o.branch(m,!1),n)}q(m,o,n){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,o,n)}finally{this.o.delete(m)}}r(m,o,n){const i=new M.$Xq(t=>t.id.toString());let r=0;const s=[{id:m,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new I(i);for(const f of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(f.id);if(d||this.u(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),d instanceof A.$fi){const l={id:f.id,desc:d,_trace:t._trace.branch(f.id,!0)};i.insertEdge(t,l),s.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:f}of t){if(this.l(f.id)instanceof A.$fi){const l=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,l)}i.removeNode(f)}}return this.l(m)}s(m,o,n=[],i,r){if(this.f.get(m)instanceof A.$fi)return this.t(m,o,n,i,r);if(this.h)return this.h.s(m,o,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(m,o,n=[],i,r){if(i){const s=new p(void 0,this.g,this,this.i);s.c=String(m);const t=new Map,f=new u.$Bh(()=>{const d=s.j(o,n,r);for(const[l,a]of t){const h=d[l];if(typeof h=="function")for(const g of a)g.disposable=h.apply(d,g.listener)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,l){if(!f.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let g=t.get(l);return g||(g=new v.$5c,t.set(l,g)),(w,E,y)=>{if(f.isInitialized)return f.value[l](w,E,y);{const D={listener:[w,E,y],disposable:void 0},P=g.push(D);return(0,O.$Sc)(()=>{P(),D.disposable?.dispose()})}}}if(l in d)return d[l];const a=f.value;let h=a[l];return typeof h!="function"||(h=h.bind(a),d[l]=h),h},set(d,l,a){return f.value[l]=a,!0},getPrototypeOf(d){return o.prototype}})}else return this.j(o,n,r)}u(m,o){if(o&&console.warn(m),this.g)throw new Error(m)}}e.$Yq=p;var C;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(C||(C={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new k(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(m,o){return m?new k(1,o.name):k.c}static{this.f=0}constructor(m,o){this.type=m,this.name=o,this.g=Date.now(),this.h=[]}branch(m,o){const n=new k(3,m.toString());return this.h.push([m,o,n]),n}stop(){const m=Date.now()-this.g;k.f+=m;let o=!1;function n(r,s){const t=[],f=new Array(r+1).join("	");for(const[d,l,a]of s.h)if(l&&a){o=!0,t.push(`${f}CREATES -> ${d}`);const h=n(r+1,a);h&&t.push(h)}else t.push(`${f}uses -> ${d}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(m>2||o)&&k.all.add(i.join(`
`))}}e.$Zq=k}),define(ke[12],Ee([1,0,212,46,4,55,3,27,11,23,18,2,41,5]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=c,e.log=o,e.$3j=g,e.$4j=S,e.$5j=w,e.$6j=E,e.$Oj=(0,C.$ii)("logService"),e.$Pj=(0,C.$ii)("loggerService");function k(){return new Date().toISOString()}function c(y){return(0,R.$Zf)(y)}var m;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Rj=m.Info;function o(y,D,P){switch(D){case m.Trace:y.trace(P);break;case m.Debug:y.debug(P);break;case m.Info:y.info(P);break;case m.Warning:y.warn(P);break;case m.Error:y.error(P);break;case m.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function n(y,D=!1){let P="";for(let z=0;z<y.length;z++){let F=y[z];if(F instanceof Error&&(F=(0,L.$6i)(F,D)),typeof F=="object")try{F=JSON.stringify(F)}catch{}P+=(z>0?" ":"")+F}return P}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new O.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==m.Off&&this.b<=D}}e.$Tj=i;class r extends i{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...P){this.f(m.Trace)&&this.g(m.Trace,n([D,...P],!0))}debug(D,...P){this.f(m.Debug)&&this.g(m.Debug,n([D,...P]))}info(D,...P){this.f(m.Info)&&this.g(m.Info,n([D,...P]))}warn(D,...P){this.f(m.Warning)&&this.g(m.Warning,n([D,...P]))}error(D,...P){if(this.f(m.Error))if(D instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=D.stack,this.g(m.Error,n(z))}else this.g(m.Error,n([D,...P]))}flush(){}}e.$Uj=r;class s extends i{constructor(D=e.$Rj){super(),this.setLevel(D),this.g=!$.$i}trace(D,...P){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,D,...P):console.log(`[main ${k()}]`,D,...P))}debug(D,...P){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,D,...P):console.log(`[main ${k()}]`,D,...P))}info(D,...P){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,D,...P):console.log(`[main ${k()}]`,D,...P))}warn(D,...P){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,D,...P):console.warn(`[main ${k()}]`,D,...P))}error(D,...P){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,D,...P):console.error(`[main ${k()}]`,D,...P))}flush(){}}e.$Vj=s;class t extends i{constructor(D=e.$Rj,P=!0){super(),this.g=P,this.setLevel(D)}trace(D,...P){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...P):console.log(D,...P))}debug(D,...P){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...P):console.log(D,...P))}info(D,...P){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...P):console.log(D,...P))}warn(D,...P){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...P):console.log(D,...P))}error(D,...P){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...P):console.error(D,...P))}flush(){}}e.$Wj=t;class f extends i{constructor(D,P=e.$Rj){super(),this.g=D,this.setLevel(P)}trace(D,...P){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(D),...P])}debug(D,...P){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(D),...P])}info(D,...P){this.f(m.Info)&&this.g.log(m.Info,[this.h(D),...P])}warn(D,...P){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(D),...P])}error(D,...P){this.f(m.Error)&&this.g.log(m.Error,[this.h(D),...P])}h(D){return typeof D=="string"?D:(0,L.$6i)(D,this.f(m.Trace))}flush(){}}e.$Xj=f;class d extends i{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const P of this.g)P.setLevel(D);super.setLevel(D)}trace(D,...P){for(const z of this.g)z.trace(D,...P)}debug(D,...P){for(const z of this.g)z.debug(D,...P)}info(D,...P){for(const z of this.g)z.info(D,...P)}warn(D,...P){for(const z of this.g)z.warn(D,...P)}error(D,...P){for(const z of this.g)z.error(D,...P)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose();super.dispose()}}e.$Yj=d;class l extends M.$Uc{constructor(D,P,z){if(super(),this.h=D,this.j=P,this.b=new b.$Bc,this.c=this.B(new O.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$7d),this.onDidChangeVisibility=this.g.event,z)for(const F of z)this.b.set(F.resource,{logger:void 0,info:F})}m(D){return(0,R.$Vf)(D)?[...this.b.values()].find(P=>P.info.id===D):this.b.get(D)}getLogger(D){return this.m(D)?.logger}createLogger(D,P){const z=this.n(D),F=(0,R.$Vf)(D)?D:P?.id??(0,A.$9i)(z.toString()).toString(16);let T=this.b.get(z)?.logger;const j=P?.logLevel==="always"?m.Trace:P?.logLevel;T||(T=this.s(z,j??this.getLogLevel(z)??this.h,{...P,id:F}));const N={logger:T,info:{resource:z,id:F,logLevel:j,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(N.info),this.b.set(z,N),T}n(D){return(0,R.$Vf)(D)?(0,v.$Vg)(this.j,`${D}.log`):D}setLogLevel(D,P){if(I.URI.isUri(D)){const z=D,F=P,T=this.b.get(z);T&&F!==T.info.logLevel&&(T.info.logLevel=F===this.h?void 0:F,T.logger?.setLevel(F),this.b.set(T.info.resource,T),this.f.fire([z,F]))}else{this.h=D;for(const[z,F]of this.b.entries())this.b.get(z)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,P){const z=this.m(D);z&&P!==!z.info.hidden&&(z.info.hidden=!P,this.b.set(z.info.resource,z),this.g.fire([z.info.resource,P]))}getLogLevel(D){let P;return D&&(P=this.b.get(D)?.info.logLevel),P??this.h}registerLogger(D){const P=this.b.get(D.resource);P?P.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const P=this.b.get(D);P&&(P.logger&&P.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=l;class a{constructor(){this.onDidChangeLogLevel=new O.$7d().event}setLevel(D){}getLevel(){return m.Info}trace(D,...P){}debug(D,...P){}info(D,...P){}warn(D,...P){}error(D,...P){}critical(D,...P){}dispose(){}flush(){}}e.$1j=a;class h extends a{}e.$2j=h;function g(y){if(y.verbose)return m.Trace;if(typeof y.logLevel=="string"){const D=E(y.logLevel.toLowerCase());if(D!==void 0)return D}return e.$Rj}function S(y){switch(y){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function w(y){switch(y){case m.Trace:return{original:"Trace",value:u.localize(0,null)};case m.Debug:return{original:"Debug",value:u.localize(1,null)};case m.Info:return{original:"Info",value:u.localize(2,null)};case m.Warning:return{original:"Warning",value:u.localize(3,null)};case m.Error:return{original:"Error",value:u.localize(4,null)};case m.Off:return{original:"Off",value:u.localize(5,null)}}}function E(y){switch(y){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$7j=new p.$zj("logLevel",S(m.Info))}),define(ke[257],Ee([1,0,19,8,13,4,3,17,64,12]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class R extends M.$Uc{constructor(p,C){super(),this.a=p,this.b=C,this.c=this.B(new A.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$gh(0)),this.w=[],this.y=this.B(new L.$gh(0))}watch(p,C){return C.recursive||this.b?.watcher?.forceUniversal?this.n(p,C):this.z(p,C)}n(p,C){const k={path:this.H(p),excludes:C.excludes,includes:C.includes,recursive:C.recursive,correlationId:C.correlationId},c=(0,u.$Ub)(this.j,k);return this.r(),(0,M.$Sc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,O.$1)(p))}s(){this.h||(this.h=this.B(this.t(C=>this.c.fire((0,$.$Aq)(C)),C=>this.G(C),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const C of this.j)(0,$.$wq)(C)&&(C.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const C of this.j)(0,$.$wq)(C)&&p.includes(C.path)&&(C.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,C){const k={path:this.H(p),excludes:C.excludes,includes:C.includes,recursive:!1,correlationId:C.correlationId},c=(0,u.$Ub)(this.w,k);return this.C(),(0,M.$Sc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,O.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,$.$Aq)(p)),p=>this.G(p),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,b.$ic)(p.fsPath)}}e.$Eq=R}),define(ke[258],Ee([1,0,51,397,8,27,21,4,34,3,17,11,23,98,31,211,32,250,257,46,255,254]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0,(()=>{try{(0,L.gracefulify)(u)}catch(f){console.error(`Error enabling graceful-fs: ${(0,i.$6i)(f)}`)}})();class t extends n.$Eq{static{this.I=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=b.Event.None,this.N=new A.$Bc(a=>p.$Mg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:l,symbolicLink:a}=await k.SymlinkSupport.stat(this.H(d));return{type:this.M(l,a),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:m.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await k.Promises.readdir(this.H(d),{withFileTypes:!0}),a=[];return await Promise.all(l.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,p.$Vg)(d,h.name))).type:g=this.M(h),a.push([h.name,g])}catch(g){this.a.trace(g)}})),a}catch(l){throw this.fb(l)}}M(d,l){let a;return l?.dangling?a=m.FileType.Unknown:d.isFile()?a=m.FileType.File:d.isDirectory()?a=m.FileType.Directory:a=m.FileType.Unknown,l&&(a|=m.FileType.SymbolicLink),a}async O(d){const l=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let a;for(;a=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await a.wait();const h=new O.$hh;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,v.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let a;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),a=await this.O(d));const h=this.H(d);return await k.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{a?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,l,a){const h=(0,C.$ie)(g=>M.$ue.concat(g.map(S=>M.$ue.wrap(S))).buffer);return(0,o.$tq)(this,d,h,g=>g.buffer,{...l,bufferSize:256*1024},a),h}async writeFile(d,l,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,p.$Vg)((0,p.$Ug)(d),`${(0,p.$Sg)(d)}${a.atomic.postfix}`),l,a):this.S(d,l,a)}async Q(d){try{const l=this.H(d),{symbolicLink:a}=await k.SymlinkSupport.stat(l);if(a)return!1}catch{}return!0}async R(d,l,a,h){const g=new v.$Tc;try{g.add(await this.O(d)),g.add(await this.O(l)),await this.S(l,a,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(S){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{g.dispose()}}async S(d,l,a,h){let g;try{const S=this.H(d);if(!a.create||!a.overwrite){if(await k.Promises.exists(S)){if(!a.overwrite)throw(0,m.$2k)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,m.$2k)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(d,{create:!0,unlock:a.unlock},h),await this.write(g,0,l,0,l.byteLength)}catch(S){throw await this.gb(d,S)}finally{typeof g=="number"&&await this.close(g)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,l,a){const h=this.H(d);let g;(0,m.$Pk)(l)&&!a&&(g=await this.O(d));let S;try{if((0,m.$Pk)(l)&&l.unlock)try{const{stat:E}=await k.SymlinkSupport.stat(h);E.mode&128||await k.Promises.chmod(h,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let w;if((0,m.$Pk)(l)){if(I.$i)try{await k.Promises.truncate(h,0),w="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}w||(w="w")}else w="r";S=await k.Promises.open(h,w)}catch(w){throw g?.dispose(),(0,m.$Pk)(l)?await this.gb(d,w):this.fb(w)}if(this.U.set(S,0),(0,m.$Pk)(l)&&this.X.set(S,d),g){const w=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${h})`),this.W.set(S,g),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${h})`),w.dispose())}return S}async close(d){const l=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await k.Promises.fdatasync(d)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await k.Promises.close(d)}catch(a){throw this.fb(a)}finally{l&&(this.W.get(d)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,a,h,g){const S=this.Z(d,l);let w=null;try{w=(await k.Promises.read(d,a,h,g,S)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(d,S,w)}return w}Z(d,l){return l===this.U.get(d)?null:l}$(d,l,a){const h=this.U.get(d);typeof h=="number"&&(typeof l=="number"||(typeof a=="number"?this.U.set(d,h+a):this.U.delete(d)))}async write(d,l,a,h,g){return(0,O.$Ch)(()=>this.ab(d,l,a,h,g),100,3)}async ab(d,l,a,h,g){const S=this.Z(d,l);let w=null;try{w=(await k.Promises.write(d,a,h,g,S)).bytesWritten}catch(E){throw await this.gb(this.X.get(d),E)}finally{this.$(d,S,w)}return w}async mkdir(d){try{await k.Promises.mkdir(this.H(d))}catch(l){throw this.fb(l)}}async delete(d,l){try{const a=this.H(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,R.$kc)((0,R.$nc)(a),`${(0,R.$oc)(a)}${l.atomic.postfix}`)),await k.Promises.rm(a,k.RimRafMode.MOVE,h)}else try{await k.Promises.unlink(a)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let g=!1;try{const{stat:S,symbolicLink:w}=await k.SymlinkSupport.stat(a);g=S.isDirectory()&&!w}catch{}if(g)await k.Promises.rmdir(a);else throw h}else throw h}}catch(a){throw this.fb(a)}}async rename(d,l,a){const h=this.H(d),g=this.H(l);if(h!==g)try{await this.bb(d,l,"move",a.overwrite),await k.Promises.rename(h,g)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,c.localize)(2,null,(0,R.$oc)(h),(0,R.$oc)((0,R.$nc)(g)),S.toString()))),this.fb(S)}}async copy(d,l,a){const h=this.H(d),g=this.H(l);if(h!==g)try{await this.bb(d,l,"copy",a.overwrite),await k.Promises.copy(h,g,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,c.localize)(3,null,(0,R.$oc)(h),(0,R.$oc)((0,R.$nc)(g)),S.toString()))),this.fb(S)}}async bb(d,l,a,h){const g=this.H(d),S=this.H(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,$.$hg)(g,S,!0)),w){if(a==="copy")throw(0,m.$2k)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const y=await this.L(d);if(!y)throw(0,m.$2k)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(l);if(D){if(!h)throw(0,m.$2k)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&D.type&m.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.cb(d,l,!1)}async cb(d,l,a){const h=this.H(d),g=this.H(l),S=!!(this.capabilities&1024);if((0,$.$hg)(h,g,!S))return;const w=new v.$Tc;try{w.add(await this.O(d)),w.add(await this.O(l)),a&&await k.Promises.mkdir((0,R.$nc)(g),{recursive:!0}),await k.Promises.copyFile(h,g)}catch(E){if(E.code==="ENOENT"&&!a)return this.cb(d,l,!0);throw this.fb(E)}finally{w.dispose()}}t(d,l,a){return new r.$Lq(h=>d(h),h=>l(h),a)}F(d,l,a){return new s.$Uq(h=>d(h),h=>l(h),a)}fb(d){if(d instanceof m.$1k)return d;let l=d,a;switch(d.code){case"ENOENT":a=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=m.FileSystemProviderErrorCode.Unknown;break;default:a=m.FileSystemProviderErrorCode.Unknown}return(0,m.$2k)(l,a)}async gb(d,l){let a=this.fb(l);if(d&&a.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await k.SymlinkSupport.stat(this.H(d));h.mode&128||(a=(0,m.$2k)(l,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return a}}e.$Vq=t}),define(ke[259],Ee([1,0,3,12]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=void 0;class O extends u.$Uc{constructor(M,b=[]){super(),this.a=new L.$Yj([M,...b]),this.B(M.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$$P=O}),define(ke[260],Ee([1,0,32,12]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=void 0;var O;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(O||(O={}));async function A(v,R,I,p,C){try{const k=await new Promise((m,o)=>{he(["@vscode/spdlog"],m,o)});k.setFlushOn(O.Trace);const c=await k.createAsyncRotatingLogger(v,R,I,p);return C?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(k){console.error(k)}return null}function M(v,R,I){switch(R){case L.LogLevel.Trace:v.trace(I);break;case L.LogLevel.Debug:v.debug(I);break;case L.LogLevel.Info:v.info(I);break;case L.LogLevel.Warning:v.warn(I);break;case L.LogLevel.Error:v.error(I);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function b(v,R){switch(R){case L.LogLevel.Trace:v.setLevel(O.Trace);break;case L.LogLevel.Debug:v.setLevel(O.Debug);break;case L.LogLevel.Info:v.setLevel(O.Info);break;case L.LogLevel.Warning:v.setLevel(O.Warning);break;case L.LogLevel.Error:v.setLevel(O.Error);break;case L.LogLevel.Off:v.setLevel(O.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class $ extends L.$Uj{constructor(R,I,p,C,k){super(),this.m=[],this.setLevel(k),this.n=this.s(R,I,p,C),this.B(this.onDidChangeLogLevel(c=>{this.r&&b(this.r,c)}))}async s(R,I,p,C){const k=p?6:1,c=30/k*u.$kl.MB,m=await A(R,I,c,k,C);if(m){this.r=m,b(this.r,this.getLevel());for(const{level:o,message:n}of this.m)M(this.r,o,n);this.m=[]}}g(R,I){this.r?M(this.r,R,I):this.getLevel()<=R&&this.m.push({level:R,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$ZP=$}),define(ke[138],Ee([1,0,40,213,5]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var M;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function($){function v(k,c){return c-k}$.compare=v;const R=Object.create(null);R[$.Error]=(0,L.localize)(0,null),R[$.Warning]=(0,L.localize)(1,null),R[$.Info]=(0,L.localize)(2,null);function I(k){return R[k]||""}$.toString=I;function p(k){switch(k){case u.default.Error:return $.Error;case u.default.Warning:return $.Warning;case u.default.Info:return $.Info;case u.default.Ignore:return $.Hint}}$.fromSeverity=p;function C(k){switch(k){case $.Error:return u.default.Error;case $.Warning:return u.default.Warning;case $.Info:return u.default.Info;case $.Hint:return u.default.Ignore}}$.toSeverity=C}(M||(e.MarkerSeverity=M={}));var b;(function($){const v="";function R(p){return I(p,!0)}$.makeKey=R;function I(p,C){const k=[v];return p.source?k.push(p.source.replace("\xA6","\\\xA6")):k.push(v),p.code?typeof p.code=="string"?k.push(p.code.replace("\xA6","\\\xA6")):k.push(p.code.value.replace("\xA6","\\\xA6")):k.push(v),p.severity!==void 0&&p.severity!==null?k.push(M.toString(p.severity)):k.push(v),p.message&&C?k.push(p.message.replace("\xA6","\\\xA6")):k.push(v),p.startLineNumber!==void 0&&p.startLineNumber!==null?k.push(p.startLineNumber.toString()):k.push(v),p.startColumn!==void 0&&p.startColumn!==null?k.push(p.startColumn.toString()):k.push(v),p.endLineNumber!==void 0&&p.endLineNumber!==null?k.push(p.endLineNumber.toString()):k.push(v),p.endColumn!==void 0&&p.endColumn!==null?k.push(p.endColumn.toString()):k.push(v),k.push(v),k.join("\xA6")}$.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$Ut=(0,O.$ii)("markerService")}),define(ke[261],Ee([1,0,4,40,5]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Lv=e.Severity=void 0,e.$Mv=b,e.Severity=L.default,e.$Lv=(0,O.$ii)("notificationService");var A;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var M;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function b(I){if(I){const p=I;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var $;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class v{constructor(){this.progress=new R,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$Nv=v;class R{infinite(){}done(){}total(p){}worked(p){}}e.$Ov=R}),define(ke[262],Ee([1,0,50]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.context<"u"){const A=O.context.configuration();if(A)L=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:A.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ke[139],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,u.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(he,e){return function(u,L){e(u,L,he)}};define(ke[108],Ee([1,0,8,22,3,5]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.ProgressLocation=e.$Pv=void 0,e.$Pv=(0,A.$ii)("progressService");var M;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Qv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$Rv=b;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const C=this.d;this.d=()=>{C?.(),p()}}):Promise.resolve()}}e.$Sv=$;let v=class extends O.$Uc{constructor(p,C){super(),this.a=new u.$Fh,C.withProgress(p,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,O.$Sc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$Tv=v,e.$Tv=v=Je([qe(1,e.$Pv)],v);class R extends O.$Uc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new O.$Tc)}start(p){this.stop();const C=++this.a,k=new L.$ee;return this.f=setTimeout(()=>{C===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,O.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,O.$Sc)(()=>k.cancel())),this.b.add((0,O.$Sc)(()=>this.c?this.c.done():void 0)),{id:C,token:k.token,stop:()=>this.h(C),isCurrent:()=>this.a===C}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$Uv=R,e.$Vv=(0,A.$ii)("editorProgressService")}),define(ke[37],Ee([1,0,61,18]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class O{constructor(){this.a=new Map}add(M,b){u.ok(L.$Vf(M)),u.ok(L.$Xf(b)),u.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$1n=new O}),define(ke[109],Ee([1,0,4,37]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function O(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new u.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,v){this.a[O($)]=v,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const M=new A;L.$1n.add(e.$2n.JSONContribution,M)}),define(ke[85],Ee([1,0,19,4,18,202,53,109,37]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=c,e.$fo=m,e.$go=o,e.$ho=i,e.$io=r;var v;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.$6n={Configuration:"base.contributions.configuration"};var R;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const I=$.$1n.as(b.$2n.JSONContribution);class p{constructor(){this.h=new Set,this.i=new L.$7d,this.onDidSchemaChange=this.i.event,this.j=new L.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const d=new Set;this.n(t,f,d),I.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const f=new Set;this.o(t,f),I.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const d=new Set;this.o(f,d),this.n(t,!1,d),I.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const d=[];for(const{overrides:l,source:a}of t)for(const h in l)if(f.add(h),e.$do.test(h)){const g=this.a.get(h),S=g?.valuesSources??new Map;if(a)for(const D of Object.keys(l[h]))S.set(D,a);const w={...g?.value||{},...l[h]};this.a.set(h,{source:a,value:w,valuesSources:S});const E=(0,M.$Yi)(h),y={type:"object",default:w,description:A.localize(1,null,E),$ref:e.$ao,defaultDefaultValue:w,source:O.$Vf(a)?void 0:a,defaultValueSource:a};d.push(...c(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:l[h],source:a});const g=this.d[h];g&&(this.w(h,g),this.r(h,g))}this.m(d)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:d,source:l}of t)for(const a in d){const h=this.a.get(a),g=O.$Vf(l)?l:l?.id,S=O.$Vf(h?.source)?h?.source:h?.source?.id;if(g===S)if(f.add(a),this.a.delete(a),e.$do.test(a))delete this.d[a],delete this.b.properties[a];else{const w=this.d[a];w&&(this.w(a,w),this.r(a,w))}}this.u()}deltaConfiguration(t){let f=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,d){t.forEach(l=>{this.p(l,f,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,f){const d=l=>{if(l.properties)for(const a in l.properties){f.add(a);const h=this.d[a];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[a],this.s(a,l.properties[a])}l.allOf?.forEach(a=>d(a))};for(const l of t){d(l);const a=this.c.indexOf(l);a!==-1&&this.c.splice(a,1)}}p(t,f=!0,d,l,a=3,h){a=O.$5f(t.scope)?a:t.scope;const g=t.properties;if(g)for(const w in g){const E=g[w];if(f&&i(w,E)){delete g[w];continue}if(E.source=d,E.defaultDefaultValue=g[w].default,this.w(w,E),e.$do.test(w)?E.scope=void 0:(E.scope=O.$5f(E.scope)?a:E.scope,E.restricted=O.$5f(E.restricted)?!!l?.includes(w):E.restricted),g[w].hasOwnProperty("included")&&!g[w].included){this.f[w]=g[w],delete g[w];continue}else this.d[w]=g[w],g[w].policy?.name&&this.e.set(g[w].policy.name,w);!g[w].deprecationMessage&&g[w].markdownDeprecationMessage&&(g[w].deprecationMessage=g[w].markdownDeprecationMessage),h.add(w)}const S=t.allOf;if(S)for(const w of S)this.p(w,f,d,l,a,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$7n.properties[t]=f,f.scope){case 1:e.$8n.properties[t]=f;break;case 2:e.$9n.properties[t]=f;break;case 6:e.$0n.properties[t]=f;break;case 3:e.$$n.properties[t]=f;break;case 4:e.$_n.properties[t]=f;break;case 5:e.$_n.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$7n.properties[t],f.scope){case 1:delete e.$8n.properties[t];break;case 2:delete e.$9n.properties[t];break;case 6:delete e.$0n.properties[t];break;case 3:delete e.$$n.properties[t];break;case 4:case 5:delete e.$_n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,d={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$ao};this.w(f,d),e.$7n.properties[f]=d,e.$8n.properties[f]=d,e.$9n.properties[f]=d,e.$0n.properties[f]=d,e.$$n.properties[f]=d,e.$_n.properties[f]=d}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=t,e.$8n.patternProperties[e.$co]=t,e.$9n.patternProperties[e.$co]=t,e.$0n.patternProperties[e.$co]=t,e.$$n.patternProperties[e.$co]=t,e.$_n.patternProperties[e.$co]=t,this.i.fire()}w(t,f){const d=this.a.get(t);let l=d?.value,a=d?.source;O.$3f(l)&&(l=f.defaultDefaultValue,a=void 0),O.$3f(l)&&(l=o(f.type)),f.default=l,f.defaultValueSource=a}}const C="\\[([^\\]]+)\\]",k=new RegExp(C,"g");e.$co=`^(${C})+$`,e.$do=new RegExp(e.$co);function c(s){const t=[];if(e.$do.test(s)){let f=k.exec(s);for(;f?.length;){const d=f[1].trim();d&&t.push(d),f=k.exec(s)}}return(0,u.$Mb)(t)}function m(s){return s.reduce((t,f)=>`${t}[${f}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new p;$.$1n.add(e.$6n.Configuration,n);function i(s,t){return s.trim()?e.$do.test(s)?A.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?A.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function r(){const s=[],t=n.getConfigurationProperties();for(const f of Object.keys(t))s.push([f,t[f].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(ke[263],Ee([1,0,19,4,163,3,27,24,18,2,53,85,37]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=i;function C(f){return Object.isFrozen(f)?f:b.$Pn(f)}class k{constructor(d={},l=[],a=[],h){this.b=d,this.c=l,this.d=a,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof k)return l;const a=new c("");return a.parseRaw(l),a.configurationModel});this.f=d.reduce((l,a)=>a===l?a:l.merge(a),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,R.$Wi)(this.contents,d):this.contents}inspect(d,l){const a=this;return{get value(){return C(a.rawConfiguration.getValue(d))},get override(){return l?C(a.rawConfiguration.getOverrideValue(d,l)):void 0},get merged(){return C(l?a.rawConfiguration.override(l).getValue(d):a.rawConfiguration.getValue(d))},get overrides(){const h=[];for(const{contents:g,identifiers:S,keys:w}of a.rawConfiguration.overrides){const E=new k(g,w).getValue(d);E!==void 0&&h.push({identifiers:S,value:E})}return h.length?C(h):void 0}}}getOverrideValue(d,l){const a=this.i(l);return a?d?(0,R.$Wi)(a,d):a:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const a of this.overrides)a.identifiers.includes(d)&&l.push(...a.keys);return u.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return u.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=b.$On(this.contents),a=b.$On(this.overrides),h=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const S of d)if(g.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(l,S.contents);for(const w of S.overrides){const[E]=a.filter(y=>u.$ub(y.identifiers,w.identifiers));E?(this.h(E.contents,w.contents),E.keys.push(...w.keys),E.keys=u.$Mb(E.keys)):a.push(b.$On(w))}for(const w of S.keys)h.indexOf(w)===-1&&h.push(w)}return new k(l,h,a,g.every(S=>S instanceof k)?void 0:g)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const a={};for(const h of u.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let g=this.contents[h];const S=l[h];S&&(typeof g=="object"&&typeof S=="object"?(g=b.$On(g),this.h(g,S)):g=S),a[h]=g}return new k(a,this.keys,this.overrides)}h(d,l){for(const a of Object.keys(l)){if(a in d&&$.$Xf(d[a])&&$.$Xf(l[a])){this.h(d[a],l[a]);continue}d[a]=b.$On(l[a])}}i(d){let l=null,a=null;const h=g=>{g&&(a?this.h(a,g):a=b.$On(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===d?l=g.contents:g.identifiers.includes(d)&&h(g.contents);return h(l),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,R.$Vi)(this.contents,d),I.$do.test(d)&&this.overrides.splice(this.overrides.findIndex(a=>u.$ub(a.identifiers,(0,I.$eo)(d))),1))}j(d,l,a){(0,R.$Ui)(this.contents,d,l,h=>console.error(h)),a=a||this.keys.indexOf(d)===-1,a&&this.keys.push(d),I.$do.test(d)&&this.overrides.push({identifiers:(0,I.$eo)(d),keys:Object.keys(this.contents[d]),contents:(0,R.$Ti)(this.contents[d],h=>console.error(h))})}}e.$jo=k;class c{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!$.$5f(d)){const a=this.g(d);this.parseRaw(a,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:a,keys:h,overrides:g,restricted:S,hasExcludedProperties:w}=this.h(d,l);this.b=new k(a,h,g,w?[d]:void 0),this.c=S||[]}g(d){let l={},a=null,h=[];const g=[],S=[];function w(y){Array.isArray(h)?h.push(y):a!==null&&(h[a]=y)}const E={onObjectBegin:()=>{const y={};w(y),g.push(h),h=y,a=null},onObjectProperty:y=>{a=y},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const y=[];w(y),g.push(h),h=y,a=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:w,onError:(y,D,P)=>{S.push({error:y,offset:D,length:P})}};if(d)try{O.$Cn(d,E),l=h[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return l}h(d,l){const a=p.$1n.as(I.$6n.Configuration).getConfigurationProperties(),h=this.i(d,a,!0,l);d=h.raw;const g=(0,R.$Ti)(d,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),S=Object.keys(d),w=this.j(d,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:g,keys:S,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,a,h){let g=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:g};const S={},w=[];for(const E in d)if(I.$do.test(E)&&a){const y=this.i(d[E],l,!1,h);S[E]=y.raw,g=g||y.hasExcludedProperties,w.push(...y.restricted)}else{const y=l[E],D=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&w.push(E),!h.exclude?.includes(E)&&(h.include?.includes(E)||(D===void 0||h.scopes===void 0||h.scopes.includes(D))&&!(h.skipRestricted&&y?.restricted))?S[E]=d[E]:g=!0}return{raw:S,restricted:w,hasExcludedProperties:g}}j(d,l){const a=[];for(const h of Object.keys(d))if(I.$do.test(h)){const g={};for(const S in d[h])g[S]=d[h][S];a.push({identifiers:(0,I.$eo)(h),keys:Object.keys(g),contents:(0,R.$Ti)(g,l)})}return a}}e.$ko=c;class m extends A.$Uc{constructor(d,l,a,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new L.$7d),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&a.isEqual(g.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=m;class o{constructor(d,l,a,h,g,S,w,E,y,D,P,z,F){this.a=d,this.b=l,this.c=a,this.overrideIdentifiers=h,this.d=g,this.f=S,this.g=w,this.h=E,this.i=y,this.j=D,this.k=P,this.l=z,this.m=F}get value(){return C(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(d,l,a,h,g=new k,S=new k,w=new M.$Bc,E=new k,y=new M.$Bc){this.c=d,this.d=l,this.f=a,this.g=h,this.h=g,this.i=S,this.j=w,this.l=E,this.m=y,this.a=null,this.b=new M.$Bc,this.n=null}getValue(d,l,a){return this.p(d,l,a).getValue(d)}updateValue(d,l,a={}){let h;a.resource?(h=this.m.get(a.resource),h||(h=new k,this.m.set(a.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),a.resource||(this.a=null)}inspect(d,l,a){const h=this.p(d,l,a),g=this.t(l.resource,a),S=l.resource?this.m.get(l.resource)||this.l:this.l,w=new Set;for(const E of h.overrides)for(const y of E.identifiers)h.getOverrideValue(d,y)!==void 0&&w.add(y);return new o(d,l,h.getValue(d),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,g||void 0,S)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const a=[];if(!l){const{added:h,updated:g,removed:S}=s(this.c,d);l=[...h,...g,...S]}for(const h of l)for(const g of(0,I.$eo)(h)){const S=this.c.getKeysForOverrideIdentifier(g),w=d.getKeysForOverrideIdentifier(g),E=[...w.filter(y=>S.indexOf(y)===-1),...S.filter(y=>w.indexOf(y)===-1),...S.filter(y=>!b.$Sn(this.c.override(g).getValue(y),d.override(g).getValue(y)))];a.push([g,E])}return this.updateDefaultConfiguration(d),{keys:l,overrides:a}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:a,removed:h}=s(this.d,d),g=[...l,...a,...h];return g.length&&this.updatePolicyConfiguration(d),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:a,removed:h,overrides:g}=s(this.applicationConfiguration,d),S=[...l,...a,...h];return S.length&&this.updateApplicationConfiguration(d),{keys:S,overrides:g}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:a,removed:h,overrides:g}=s(this.localUserConfiguration,d),S=[...l,...a,...h];return S.length&&this.updateLocalUserConfiguration(d),{keys:S,overrides:g}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:a,removed:h,overrides:g}=s(this.remoteUserConfiguration,d),S=[...l,...a,...h];return S.length&&this.updateRemoteUserConfiguration(d),{keys:S,overrides:g}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:a,removed:h,overrides:g}=s(this.workspaceConfiguration,d),S=[...l,...a,...h];return S.length&&this.updateWorkspaceConfiguration(d),{keys:S,overrides:g}}compareAndUpdateFolderConfiguration(d,l){const a=this.folderConfigurations.get(d),{added:h,updated:g,removed:S,overrides:w}=s(a,l),E=[...h,...g,...S];return(E.length||!a)&&this.updateFolderConfiguration(d,l),{keys:E,overrides:w}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:a,updated:h,removed:g,overrides:S}=s(l,void 0);return{keys:[...a,...h,...g],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,a){let h=this.q(l,a);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},l){let a=this.r();if(l&&d){const h=l.getFolder(d);h&&(a=this.s(h.uri)||a);const g=this.m.get(d);g&&(a=a.merge(g))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const a=this.r(),h=this.j.get(d);h?(l=a.merge(h),this.b.set(d,l)):l=a}return l}t(d,l){if(l&&d){const a=l.getFolder(d);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:a,overrides:h,keys:g}=this.j.get(l);return d.push([l,{contents:a,overrides:h,keys:g}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(a=>d.add(a))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(a=>d.add(a))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.i.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.w(d.defaults),a=this.w(d.policy),h=this.w(d.application),g=this.w(d.user),S=this.w(d.workspace),w=d.folders.reduce((E,y)=>(E.set(v.URI.revive(y[0]),this.w(y[1])),E),new M.$Bc);return new n(l,a,h,g,new k,S,w,new k,new M.$Bc)}static w(d){return new k(d.contents,d.keys,d.overrides)}}e.$mo=n;function i(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const d=new Set,l=new Map;for(const h of f)h.keys.forEach(g=>d.add(g)),h.overrides.forEach(([g,S])=>{const w=(0,M.$yc)(l,g,new Set);S.forEach(E=>w.add(E))});const a=[];return l.forEach((h,g)=>a.push([g,[...h.values()]])),{keys:[...d.values()],overrides:a}}class r{constructor(d,l,a,h){this.change=d,this.f=l,this.g=a,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const g of d.keys)this.affectedKeys.add(g);for(const[,g]of d.overrides)for(const S of g)this.affectedKeys.add(S);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(d,l){const a=this.a+d,h=this.d.indexOf(a);if(h<0)return!1;const g=h+a.length;if(g>=this.d.length)return!1;const S=this.d.charCodeAt(g);if(S!==this.b&&S!==this.c)return!1;if(l){const w=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,E=this.g.getValue(d,l,this.h);return!b.$Sn(w,E)}return!0}}e.$oo=r;function s(f,d){const{added:l,removed:a,updated:h}=t(d?.rawConfiguration,f?.rawConfiguration),g=[],S=f?.getAllOverrideIdentifiers()||[],w=d?.getAllOverrideIdentifiers()||[];if(d){const E=w.filter(y=>!S.includes(y));for(const y of E)g.push([y,d.getKeysForOverrideIdentifier(y)])}if(f){const E=S.filter(y=>!w.includes(y));for(const y of E)g.push([y,f.getKeysForOverrideIdentifier(y)])}if(d&&f){for(const E of S)if(w.includes(E)){const y=t({contents:f.getOverrideValue(void 0,E)||{},keys:f.getKeysForOverrideIdentifier(E)},{contents:d.getOverrideValue(void 0,E)||{},keys:d.getKeysForOverrideIdentifier(E)});g.push([E,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:a,updated:h,overrides:g}}function t(f,d){const l=f?d?f.keys.filter(g=>d.keys.indexOf(g)===-1):[...f.keys]:[],a=d?f?d.keys.filter(g=>f.keys.indexOf(g)===-1):[...d.keys]:[],h=[];if(f&&d){for(const g of d.keys)if(f.keys.indexOf(g)!==-1){const S=(0,R.$Wi)(d.contents,g),w=(0,R.$Wi)(f.contents,g);b.$Sn(S,w)||h.push(g)}}return{added:l,removed:a,updated:h}}}),define(ke[264],Ee([1,0,21,4,3,82]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yub=e.$wub=e.$vub=void 0,e.$xub=b;const M=(v,R,I)=>{const p=new Uint8Array(16);for(let c=0;c<16;c++)p[c]=Math.round(Math.random()*256);const C=(0,u.$Oe)(u.$ue.wrap(p));return[`GET ws://localhost${v}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`].join(`\r
`)+`\r
\r
`};e.$vub=M,e.$wub=u.$ue.fromString(`\r
\r
`);async function b(v,R,I,p,C){v.write(u.$ue.fromString((0,e.$vub)(R,I,p)));const k=new O.$Tc;try{return await new Promise((c,m)=>{let o;k.add(v.onData(n=>{o?o=u.$ue.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$wub);if(i===-1)return;c(v),v.pauseData();const r=o.slice(i+e.$wub.byteLength);r.byteLength&&C.onData.fire(r)})),k.add(v.onClose(n=>m(n??new Error("socket closed")))),k.add(v.onEnd(()=>m(new Error("socket ended"))))})}catch(c){throw v.dispose(),c}finally{k.dispose()}}class $ extends O.$Uc{constructor(R,I){super(),this.g=R,this.a=this.B(new L.$0d),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new L.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,I){A.SocketDiagnostics.traceSocketEvent(this,this.g,R,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$yub=$}),define(ke[65],Ee([1,0,13,5]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=v,e.$tl=(0,L.$ii)("remoteAuthorityResolverService");var O;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(O||(e.RemoteConnectionType=O={}));class A{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=A;class M{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=M;var b;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends u.$bb{static isNotAvailable(I){return I instanceof $&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof $&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof $&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof $&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof $&&I.isHandled}constructor(I,p=b.Unknown,C){super(I),this._message=I,this._code=p,this._detail=C,this.isHandled=p===b.NotAvailable&&C===!0,Object.setPrototypeOf(this,$.prototype)}}e.$wl=$;function v(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}}),define(ke[265],Ee([1,0,8,21,22,13,4,3,15,58,39,30,82,65]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Cl=S,e.$Dl=w,e.$El=y;const k=30*1e3;var c;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(x){const U=new O.$ee;return setTimeout(()=>U.cancel(),x),U.token}function n(x,U){if(x.isCancellationRequested||U.isCancellationRequested)return O.CancellationToken.Cancelled;const ie=new O.$ee;return x.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$bh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(x,U){const ie=new i(U);return ie.registerDisposable(x.onControlMessage(be=>{const Ce=JSON.parse(be.toString()),ae=J(Ce);ae?ie.reject(ae):ie.resolve(Ce)})),ie.promise}function s(x,U,ie,be,Ce,ae,ce,se){const K=new i(se),te=R.$3d.create(!1);return x.info(`Creating a socket (${ce})...`),v.mark(`code/willCreateSocket/${ae}`),U.connect(ie,be,Ce,ce).then(le=>{K.didTimeout?(v.mark(`code/didCreateSocketError/${ae}`),x.info(`Creating a socket (${ce}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(v.mark(`code/didCreateSocketOK/${ae}`),x.info(`Creating a socket (${ce}) was successful after ${te.elapsed()} ms.`),K.resolve(le))},le=>{v.mark(`code/didCreateSocketError/${ae}`),x.info(`Creating a socket (${ce}) returned an error after ${te.elapsed()} ms.`),x.error(le),K.reject(le)}),K.promise}function t(x,U){const ie=new i(U);return x.then(be=>{ie.didTimeout||ie.resolve(be)},be=>{ie.didTimeout||ie.reject(be)}),ie.promise}async function f(x,U,ie,be){const Ce=pe(x,U);x.logService.trace(`${Ce} 1/6. invoking socketFactory.connect().`);let ae;try{ae=await s(x.logService,x.remoteSocketFactoryService,x.connectTo,$.$vg.getServerRootPath(),`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${x.reconnectionToken}`,be)}catch(le){throw x.logService.error(`${Ce} socketFactory.connect() failed or timed out. Error:`),x.logService.error(le),le}x.logService.trace(`${Ce} 2/6. socketFactory.connect() was successful.`);let ce,se;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(ae,null),ce=x.reconnectionProtocol,se=!1):(ce=new p.$9h({socket:ae}),se=!0),x.logService.trace(`${Ce} 3/6. sending AuthRequest control message.`);const K=await t(x.signService.createNewMessage((0,I.$Eg)()),be),te={type:"auth",auth:x.connectionToken||"00000000000000000000",data:K.data};ce.sendControl(L.$ue.fromString(JSON.stringify(te)));try{const le=await r(ce,n(be,o(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(x.logService.trace(`${Ce} 4/6. received SignRequest control message.`),!await t(x.signService.validate(K,le.signedData),be)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const Ae=await t(x.signService.sign(le.data),be),me={type:"connectionType",commit:x.commit,signedData:Ae,desiredConnectionType:U};return ie&&(me.args=ie),x.logService.trace(`${Ce} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(L.$ue.fromString(JSON.stringify(me))),{protocol:ce,ownsProtocol:se}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(x.logService.error(`${Ce} the handshake timed out. Error:`),x.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${Ce} received error control message when negotiating connection. Error:`),x.logService.error(le)),se&&_(ce),le}}async function d(x,U,ie,be){const Ce=Date.now(),ae=pe(x,U),{protocol:ce,ownsProtocol:se}=await f(x,U,ie,be),K=new i(be);return K.registerDisposable(ce.onControlMessage(te=>{const le=JSON.parse(te.toString()),de=J(le);de?(x.logService.error(`${ae} received error control message when negotiating connection. Error:`),x.logService.error(de),se&&_(ce),K.reject(de)):(x.reconnectionProtocol?.endAcceptReconnection(),x.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${De(Ce)}!`),K.resolve({protocol:ce,firstMessage:le}))})),K.promise}async function l(x,U){const{protocol:ie}=await d(x,1,void 0,U);return{protocol:ie}}async function a(x,U,ie){const{protocol:be,firstMessage:Ce}=await d(x,2,U,ie),ae=Ce&&Ce.debugPort;return{protocol:be,debugPort:ae}}async function h(x,U,ie){const be=Date.now(),Ce=pe(x,3),{protocol:ae}=await f(x,3,U,ie);return x.logService.trace(`${Ce} 6/6. handshake finished, connection is up and running after ${De(be)}!`),ae}async function g(x,U,ie){const{connectTo:be,connectionToken:Ce}=await x.addressProvider.getAddress();return{commit:x.commit,quality:x.quality,connectTo:be,connectionToken:Ce,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:x.remoteSocketFactoryService,signService:x.signService,logService:x.logService}}async function S(x,U,ie){return E(x,async be=>{const{protocol:Ce}=await l(be,O.CancellationToken.None);return new W(x,U,ie,be.reconnectionToken,Ce)})}async function w(x,U){return E(x,async ie=>{const{protocol:be,debugPort:Ce}=await a(ie,U,O.CancellationToken.None);return new Y(x,U,ie.reconnectionToken,be,Ce)})}async function E(x,U){for(let be=1;;be++)try{const Ce=(0,I.$Eg)(),ae=await g(x,Ce,null);return await U(ae)}catch(Ce){if(be<5)x.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),x.logService.error(Ce);else throw x.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),x.logService.error(Ce),B.triggerPermanentFailure(0,0,C.$wl.isHandled(Ce)),Ce}}async function y(x,U,ie){const be=await g(x,(0,I.$Eg)(),null);return await h(be,{host:U,port:ie},O.CancellationToken.None)}function D(x){return(0,u.$8g)(U=>new Promise((ie,be)=>{const Ce=setTimeout(ie,x*1e3);U.onCancellationRequested(()=>{clearTimeout(Ce),ie()})}))}var P;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(P||(e.PersistentConnectionEventType=P={}));class z{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$Fl=z;class F{constructor(U,ie,be,Ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=be,this.c=Ce,this.type=1}skipWait(){this.c.cancel()}}e.$Gl=F;class T{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=2}}e.$Hl=T;class j{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=4}}e.$Il=j;class N{constructor(U,ie,be,Ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.handled=Ce,this.type=3}}e.$Jl=N;class B extends b.$Uc{static triggerPermanentFailure(U,ie,be){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=be,this.j.forEach(Ce=>Ce.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ie,be,Ce,ae){super(),this.t=U,this.u=ie,this.reconnectionToken=be,this.protocol=Ce,this.w=ae,this.m=this.B(new M.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(Ce.onSocketClose(ce=>{const se=ee(this.t,this.reconnectionToken,!0);ce?ce.type===0?(this.u.logService.info(`${se} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(Ce.onSocketTimeout(ce=>{const se=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Sc)(()=>{const ce=B.j.indexOf(this);ce>=0&&B.j.splice(ce,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const Ce=be<ie.length?ie[be]:ie[ie.length-1];try{if(Ce>0){const ce=D(Ce);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ce,ce)),this.u.logService.info(`${U} waiting for ${Ce} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const ae=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ae.connectTo}...`),await this.G(ae,o(k)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(ae){if(ae.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(C.$wl.isTemporarilyNotAvailable(ae)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((ae.code==="ETIMEDOUT"||ae.code==="ENETUNREACH"||ae.code==="ECONNREFUSED"||ae.code==="ECONNRESET")&&ae.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((0,A.$4)(ae)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if(ae instanceof C.$wl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,C.$wl.isHandled(ae));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,be){this.w?B.triggerPermanentFailure(U,ie,be):this.D(U,ie,be)}D(U,ie,be){this.m.fire(new N(this.reconnectionToken,U,ie,be)),_(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Kl=B;class W extends B{constructor(U,ie,be,Ce,ae){super(1,U,Ce,ae,!0),this.client=this.B(new p.$7h(ae,{remoteAuthority:ie,clientId:be},U.ipcLogger))}async G(U,ie){await l(U,ie)}}e.$Ll=W;class Y extends B{constructor(U,ie,be,Ce,ae){super(2,U,be,Ce,!1),this.H=ie,this.debugPort=ae}async G(U,ie){await a(U,this.H,ie)}}e.$Ml=Y;function _(x){try{x.acceptDisconnect();const U=x.getSocket();x.dispose(),U.dispose()}catch(U){(0,A.$1)(U)}}function J(x){if(x&&x.type==="error"){const U=new Error(`Connection error: ${x.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Z(x,U){for(;x.length<U;)x+=" ";return x}function re(x,U){return`[remote-connection][${Z(m(x),13)}][${U.substr(0,5)}\u2026]`}function ee(x,U,ie){return`${re(x,U)}[${ie?"reconnect":"initial"}]`}function pe(x,U){return`${ee(U,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.connectTo}]`}function De(x){return`${Date.now()-x} ms`}}),define(ke[86],Ee([1,0,15]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=L,e.$um=O,e.$vm=A,e.$wm=M;function L($){return $.scheme===u.Schemas.vscodeRemote?$.authority:void 0}function O($){if(!$)return;const v=$.indexOf("+");return v<0?$:$.substr(0,v)}function A($){const{host:v,port:R}=b($);if(typeof R>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:v,port:R}}function M($,v){let{host:R,port:I}=b($);return typeof I>"u"&&(I=v),{host:R,port:I}}function b($){const v=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const R=$.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const I=$.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:$,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=A,e.$Gm=I,e.$Hm=p,e.$Im=C,e.$Jm=k,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function A(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const n=typeof m=="string"?m:m.value,i=typeof o=="string"?o:o.value;return u.$lf(n,i)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Dm=$;class v{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const o of m)this.add(o)}add(m){this.c.add($.toKey(m))}delete(m){return this.c.delete($.toKey(m))}has(m){return this.c.has($.toKey(m))}}e.$Em=v;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete($.toKey(m))}get(m){return this.c.get($.toKey(m))}has(m){return this.c.has($.toKey(m))}set(m,o){this.c.set($.toKey(m),o)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=R;function I(c){return p(c)}function p(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function C(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function k(c,m){if(m){const o=`onResolveRemoteAuthority:${(0,O.$um)(m)}`;return!!c.activationEvents?.includes(o)}return!1}e.$Km=(0,L.$ii)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=void 0;class O{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const $ of M){const v=this.readActivationEvents($);v.length>0&&(b[L.$Dm.toKey($.identifier)]=v)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${L.$Dm.toKey(M.identifier)}`);if(!M.contributes)return b;for(const $ in M.contributes){const v=this.a.get($);if(!v)continue;const R=M.contributes[$],I=Array.isArray(R)?R:[R];try{v(I,b)}catch(p){(0,u.$1)(p)}}return b}}e.$SF=O,e.$TF=new O}),define(ke[266],Ee([1,0,3,5]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl=(0,L.$ii)("remoteSocketFactoryService");class O{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,u.$Sc)(()=>{const $=this.a[M]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[M]?.splice($,1)})}b(M){return(this.a[M.type]||[]).find($=>$.supports(M))}connect(M,b,$,v){const R=this.b(M);if(!R)throw new Error(`No socket factory found for ${M}`);return R.connect(M,b,$,v)}}e.$zl=O}),define(ke[267],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h0b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(O){try{const A=await this.c();if(A){const M=String(u.a++);return this.b.set(M,A),{id:M,data:A.createNewMessage(O)}}}catch{}return{id:"",data:O}}async validate(O,A){if(!O.id)return!0;const M=this.b.get(O.id);if(!M)return!1;this.b.delete(O.id);try{return M.validate(A)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(O){try{return await this.d(O)}catch{}return O}}e.$h0b=u}),define(ke[110],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=void 0,e.$Al="signService",e.$Bl=(0,u.$ii)(e.$Al)}),define(ke[141],Ee([1,0,267]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class L extends u.$h0b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(M=>new M.signer().sign(A))}h(){return new Promise((A,M)=>he(["vsda"],A,M))}}e.$dcc=L}),define(ke[268],Ee([1,0,11,50,30]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=M,e.$3o=b;function A($){if(u.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function M($,v,R,I,p,C,k,c,m){const o=Object.create(null);o["common.machineId"]=C,o["common.sqmId"]=k,o.sessionID=(0,O.$Eg)()+Date.now(),o.commitHash=I,o.version=p,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,u.$h)(u.$u),o["common.nodePlatform"]=L.$ec,o["common.nodeArch"]=R,o["common.product"]=m||"desktop",c&&(o["common.msftInternal"]=c);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(o["common.snap"]="true");const r=A(v);return r&&(o["common.platformDetail"]=r),o}function b($){const v=L.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return $.some(I=>R===I)}}),define(ke[269],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,u.$ii)("telemetryService"),e.$Ol=(0,u.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var O;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(ke[87],Ee([1,0,24,18,86,268,269]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=R,e.$_o=I,e.$ap=p,e.$bp=C,e.$cp=c,e.$dp=o,e.$ep=n,e.$fp=s;class b{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$4o=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=$,e.$6o=new $;class v{async publicLog(f,d,l){}async publicLogError(f,d,l){}}e.$7o=v,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function I(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const f=t.getValue(M.$Vl),d=t.getValue(M.$Wl);if(t.getValue(M.$Xl)===!1||d===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function C(t){const f={},d={},l={};m(t,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const h=l[a];typeof h=="number"?d[a]=h:typeof h=="boolean"?d[a]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${h.length}`),f[a]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(f[a]=h)}return{properties:f,measurements:d}}const k=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const f=(0,O.$um)(t);return k.has(f)?f:"other"}function m(t,f,d=0,l){if(t)for(const a of Object.getOwnPropertyNames(t)){const h=t[a],g=l?l+a:a;Array.isArray(h)?f[g]=(0,u.$Tn)(h):h instanceof Date?f[g]=h.toISOString():(0,L.$Xf)(h)?d<2?m(h,f,d+1,g+"."):f[g]=(0,u.$Tn)(h):f[g]=h}}function o(t,f){const d=t.msftInternalDomains||[],l=f.getValue("telemetry.internalTesting");return(0,A.$3o)(d)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const l=[];for(const S of f)for(;;){const w=S.exec(t);if(!w)break;l.push([w.index,S.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(d="";;){const S=h.exec(t);if(!S)break;const w=l.some(([E,y])=>S.index<y&&E<h.lastIndex);!a.test(S[0])&&!w&&(d+=t.substring(g,S.index)+"<REDACTED: user-file-path>",g=h.lastIndex)}return g<t.length&&(d+=t.substr(g)),d}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of f)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,f){return(0,u.$Qn)(t,d=>{if(d instanceof b||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,f);for(const a of f)l=l.replace(a,"");return l=r(l),l}})}}),define(ke[270],Ee([1,0,14,137,25,11,2,13,50,87]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=R,e.$ip=k,e.$jp=c,e.$kp=m,e.$lp=o,e.$mp=n,e.$np=i,e.$op=r,e.$qp=s,e.$rp=f;function R(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,u.$gf)(d.id,l.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(l){const a=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new p(l.identifier,a,h)}static parse(l){const a=I.exec(l);return a&&a[1]&&a[2]?new p({id:a[1]},a[2],a[4]||void 0):null}constructor(l,a,h="undefined"){this.version=a,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof p?R(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$hp=p;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(d){const l=C.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function c(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function o(d,l){return m(c(d??O.$zm,l))}function n(d,l){const a=[],h=g=>{for(const S of a)if(S.some(w=>R(l(w),l(g))))return S;return null};for(const g of d){const S=h(g);S?S.push(g):a.push([g])}return a}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new v.$4o(d.identifier.id),name:new v.$4o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$pp=new O.$Dm("pprice.better-merge");function s(d,l){const a=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const g=h.shift();if(g&&a.every(S=>!R(S.identifier,{id:g}))){const S=d.filter(w=>R(w.identifier,{id:g}));S.length===1&&(a.push(S[0]),h.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function t(d,l){if(!A.$k)return!1;let a;try{a=(await d.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await d.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){l.debug("Error while getting the os-release file.",(0,b.$0)(g))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(d,l){const a=await t(d,l),h=(0,L.$No)(a?"alpine":A.$u,$.$fc);return l.debug("ComputeTargetPlatform:",h),h}}),define(ke[271],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=u,e.$8r=L,e.$9r=O,e.$0r=A,e.$$r=M,e.$_r=b;function u($){return[...$.entries()]}function L($){return $?[...$.entries()]:[]}function O($){return new Map($)}function A($){return new Map($??[])}function M($){return Array.from($.entries()).map(v=>[v[0],u(v[1].map),L(v[1].descriptionMap)])}function b($){return new Map($.map(v=>[v[0],{map:O(v[1]),descriptionMap:A(v[2])}]))}}),define(ke[272],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qub=void 0;class u{constructor(O){this.b=O,this.a=new Map}dispose(){for(const O of this.a.values())O.dispose()}startBuffering(O,A,M=5){const b=A($=>{const v=typeof $=="string"?$:$.data;let R=this.a.get(O);if(R){R.data.push(v);return}const I=setTimeout(()=>this.flushBuffer(O),M);R={data:[v],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(O),b.dispose()}},this.a.set(O,R)});return b}stopBuffering(O){this.a.get(O)?.dispose()}flushBuffer(O){const A=this.a.get(O);A&&(this.a.delete(O),this.b(O,A.data.join("")))}}e.$Qub=u}),define(ke[273],Ee([1,0,8,78,99,56,4,18,2,214,109,37]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2w=e.$1w=e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.IconFontDefinition=e.IconContribution=e.$Tw=void 0,e.$Uw=m,e.$Vw=o,e.$Tw={IconContribution:"base.contributions.icons"};var p;(function(s){function t(f,d){let l=f.defaults;for(;A.ThemeIcon.isThemeIcon(l);){const a=c.getIcon(l.id);if(!a)return;l=a.defaults}return l}s.getDefinition=t})(p||(e.IconContribution=p={}));var C;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=t;function f(d){const l=a=>(0,b.$Vf)(a)?a:void 0;if(d&&Array.isArray(d.src)&&d.src.every(a=>(0,b.$Vf)(a.format)&&(0,b.$Vf)(a.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(a=>({format:a.format,location:$.URI.parse(a.location)}))}}s.fromJSONObject=f})(C||(e.IconFontDefinition=C={}));class k{constructor(){this.a=new M.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,v.localize)(0,null)},fontCharacter:{type:"string",description:(0,v.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,d,l){const a=this.b[t];if(a){if(d&&!a.description){a.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const S=this.e.enum.indexOf(t);S!==-1&&(this.e.enumDescriptions[S]=d),this.a.fire()}return a}const h={id:t,description:d,defaults:f,deprecationMessage:l};this.b[t]=h;const g={$ref:"#/definitions/icons"};return l&&(g.deprecationMessage=l),d&&(g.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=g,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const d=this.f[t];return d||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(a,h)=>a.id.localeCompare(h.id),f=a=>{for(;A.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(a=>this.b[a]);for(const a of l.filter(h=>!!h.description).sort(t))d.push(`|<i class="${f(a)}"></i>|${a.id}|${A.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const a of l.filter(h=>!A.ThemeIcon.isThemeIcon(h.defaults)).sort(t))d.push(`|<i class="${f(a)}"></i>|${a.id}|`);return d.join(`
`)}}const c=new k;I.$1n.add(e.$Tw.IconContribution,c);function m(s,t,f,d){return c.registerIcon(s,t,f,d)}function o(){return c}function n(){const s=(0,O.$Dj)();for(const t in s){const f="\\"+s[t].toString(16);c.registerIcon(t,{fontCharacter:f})}}n(),e.$Ww="vscode://schemas/icons";const i=I.$1n.as(R.$2n.JSONContribution);i.registerSchema(e.$Ww,c.getIconSchema());const r=new u.$uh(()=>i.notifySchemaChanged(e.$Ww),200);c.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Xw=m("widget-close",L.$Hj.close,(0,v.localize)(2,null)),e.$Yw=m("goto-previous-location",L.$Hj.arrowUp,(0,v.localize)(3,null)),e.$Zw=m("goto-next-location",L.$Hj.arrowDown,(0,v.localize)(4,null)),e.$1w=A.ThemeIcon.modify(L.$Hj.sync,"spin"),e.$2w=A.ThemeIcon.modify(L.$Hj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,53,5,12]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$4v=e.$2v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xv=e.$Wv=void 0,e.$Yv=v,e.$Zv=I,e.$1v=p,e.$3v=C,e.$5v=k,e.$6v=c,e.$Wv=(0,A.$ii)("tunnelService"),e.$Xv=(0,A.$ii)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function v(n){return!!n.forwardPort}var R;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(R||(e.ProvidedOnAutoForward=R={}));function I(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function p(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=I(L.URI.parse(s));if(t)return t}}}e.$2v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(n){return e.$2v.indexOf(n)>=0}e.$4v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(n){return e.$4v.indexOf(n)>=0}function c(n,i,r,s){if(r===1)return!1;if(r===2&&k(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class m{constructor(i,r,s){this.remoteAddress=i,this.localAddress=r,this.b=s,this.a=new u.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$7v=m;let o=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$7d,this.onTunnelOpened=this.a.event,this.b=new u.$7d,this.onTunnelClosed=this.b.event,this.c=new u.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const f of t){const d=await f.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,s,t,f){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(k(i)||C(i))&&(i=e.$2v[0]);const s=this.s(i,r);if(s)return++s.refcount,s.value}openTunnel(i,r,s,t,f,d=!1,l,a){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${f}.`);const h=this.f??i;if(!h)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(h,r,s,t,f,d,l,a);return g?g.then(S=>{if(S){if(typeof S=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),S}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(S);return(S.tunnelRemoteHost!==r||S.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&S.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const s=r.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=s.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const s=this.e.get(i);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:s})}async r(i,r){const s=this.e.get(i);if(s){const t=s.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&s.delete(r),s.size===0&&this.e.delete(i)}}s(i,r){const s=[i];C(i)?(s.push(...e.$2v),s.push(...e.$4v)):k(i)&&s.push(...e.$4v);const t=s.map(f=>this.e.get(f));for(const f of t){const d=f?.get(r);if(d)return d}}canTunnel(i){return!!I(i)}u(i,r,s,t,f,d,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const a=s;this.j.add(a);const h=t===void 0?s:t,g={elevationRequired:f?this.isPortPrivileged(h):!1},S={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==$.Private:void 0,protocol:l},w=i.forwardPort(S,g);return w?(this.q(r,s,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(a)})):this.j.delete(a),w}};e.$8v=o,e.$8v=o=Je([qe(0,M.$Oj),qe(1,O.$Oi)],o)}),define(ke[274],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,u.$ii)("IUriIdentityService")}),define(ke[275],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$9v=void 0,e.$9v=(0,u.$ii)("editSessionIdentityService");var L;(function(O){O[O.Complete=100]="Complete",O[O.Partial=50]="Partial",O[O.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(ke[276],Ee([1,0,15]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=L,e.$2L=O,e.$3L=A,e.$4L=M,e.$5L=b;function L($){return $.scheme!==u.Schemas.file&&$.scheme!==u.Schemas.vscodeRemote}function O($){if($.folders.length)return $.folders.every(v=>L(v.uri))?$.folders[0].uri:void 0;if($.configuration&&L($.configuration))return $.configuration}function A($){return O($)?.scheme}function M($){return O($)?.authority}function b($){return O($)!==void 0}}),define(ke[42],Ee([1,0,216,17,77,23,2,5,15]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=v,e.$ti=R,e.$wi=I,e.$xi=p,e.$yi=C,e.$zi=c,e.$Ai=m,e.$Di=i,e.$Ii=r,e.$Ji=s,e.$Li=t,e.$Mi=f,e.$Ni=d,e.$ri=(0,b.$ii)("contextService");function v(l){const a=l;return typeof a?.id=="string"&&M.URI.isUri(a.uri)}function R(l){return typeof l?.id=="string"&&!v(l)&&!p(l)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function I(l,a){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,L.$oc)(l)}:a?e.$ui:e.$vi;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function p(l){const a=l;return typeof a?.id=="string"&&M.URI.isUri(a.configPath)}function C(l){const a=l;if(a?.uri)return{id:a.id,uri:M.URI.revive(a.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:M.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}var k;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function c(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function m(l){const a=l;return!!(a&&typeof a=="object"&&M.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class o{constructor(a,h,g,S,w){this.h=a,this.j=g,this.k=S,this.l=w,this.c=O.$oi.forUris(this.l,()=>!0),this.folders=h}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=O.$oi.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=o;class n{constructor(a,h){this.raw=h,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.$Vg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=n;function i(l){return new n({uri:l,index:0,name:(0,A.$Rg)(l)},{uri:l.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,u.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function r(l,a){return A.$Mg.isEqualOrParent(l,a.untitledWorkspacesHome)}function s(l){let a;return M.URI.isUri(l)?a=l:a=l.configuration,a?.scheme===$.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$Ki}function f(l,a){return!r(l,a)&&!s(l)}function d(l){return(typeof l=="string"?(0,L.$pc)(l):(0,A.$Tg)(l))===e.$Fi}}),define(ke[277],Ee([1,0,55,4,3,23,2,215,136,32,5,12,42,27,274,8,30,14,18]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=r,e.$pl=s,e.$ql=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&M.URI.isUri(a.location)&&M.URI.isUri(a.globalStorageHome)&&M.URI.isUri(a.settingsResource)&&M.URI.isUri(a.keybindingsResource)&&M.URI.isUri(a.tasksResource)&&M.URI.isUri(a.snippetsHome)&&M.URI.isUri(a.extensionsResource))}e.$ol=(0,R.$ii)("IUserDataProfilesService");function s(l,a){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:M.URI.revive(l.location).with({scheme:a}),globalStorageHome:M.URI.revive(l.globalStorageHome).with({scheme:a}),settingsResource:M.URI.revive(l.settingsResource).with({scheme:a}),keybindingsResource:M.URI.revive(l.keybindingsResource).with({scheme:a}),tasksResource:M.URI.revive(l.tasksResource).with({scheme:a}),snippetsHome:M.URI.revive(l.snippetsHome).with({scheme:a}),extensionsResource:M.URI.revive(l.extensionsResource).with({scheme:a}),cacheHome:M.URI.revive(l.cacheHome).with({scheme:a}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,a,h,g,S,w){return{id:l,name:a,location:h,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:w&&S?.useDefaultFlags?.globalState?w.globalStorageHome:(0,A.$Vg)(h,"globalStorage"),settingsResource:w&&S?.useDefaultFlags?.settings?w.settingsResource:(0,A.$Vg)(h,"settings.json"),keybindingsResource:w&&S?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,A.$Vg)(h,"keybindings.json"),tasksResource:w&&S?.useDefaultFlags?.tasks?w.tasksResource:(0,A.$Vg)(h,"tasks.json"),snippetsHome:w&&S?.useDefaultFlags?.snippets?w.snippetsHome:(0,A.$Vg)(h,"snippets"),extensionsResource:w&&S?.useDefaultFlags?.extensions?w.extensionsResource:(0,A.$Vg)(h,"extensions.json"),cacheHome:(0,A.$Vg)(g,l),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let f=class extends O.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,h,g,S){super(),this.t=a,this.u=h,this.w=g,this.y=S,this.f=!0,this.h=this.B(new L.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new C.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),h=[a];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,n.$Vf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,A.$Sg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},a))}}catch(w){this.y.error(w)}const g=new C.$Bc,S=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[E,y]of Object.entries(w.workspaces)){const D=M.URI.parse(E),P=h.find(z=>z.id===y);P&&g.set(D,P)}if(w.emptyWindows)for(const[E,y]of Object.entries(w.emptyWindows)){const D=h.find(P=>P.id===y);D&&S.set(E,D)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:g,emptyWindows:S}}return this.z}D(){const a=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const h="Temp",g=new RegExp(`${(0,o.$Ze)(h)}\\s(\\d+)`);let S=0;for(const E of this.profiles){const y=g.exec(E.name),D=y?parseInt(y[1]):0;S=D>S?D:S}const w=`${h} ${S+1}`;return this.createProfile((0,u.$9i)((0,m.$Eg)()).toString(16),w,{transient:!0},a)}async createNamedProfile(a,h,g){return this.createProfile((0,u.$9i)((0,m.$Eg)()).toString(16),a,h,g)}async createProfile(a,h,g,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(a,h,g);return S&&await this.setProfileForWorkspace(S,w),w}async F(a,h,g){if(!(0,n.$Vf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(h);return S||(S=(async()=>{try{const w=this.profiles.find(D=>D.name===h||D.id===a);if(w)return w;const E=t(a,h,(0,A.$Vg)(this.profilesHome,a),this.g,g,this.defaultProfile);await this.u.createFolder(E.location);const y=[];return this.j.fire({profile:E,join(D){y.push(D)}}),await c.Promises.settled(y),this.I([E],[],[]),E}finally{this.r.delete(h)}})(),this.r.set(h,S)),S}async updateProfile(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(S=>S.id===a.id);if(!g)throw new Error(`Profile '${a.name}' does not exist`);return g=t(g.id,h.name??g.name,g.location,this.g,{shortName:h.shortName??g.shortName,icon:h.icon===null?void 0:h.icon??g.icon,transient:h.transient??g.isTransient,useDefaultFlags:h.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(S=>S.id===a.id);if(!h)throw new Error(`Profile '${a.name}' does not exist`);const g=[];this.m.fire({profile:h,join(S){g.push(S)}});try{await Promise.allSettled(g)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(S){(0,v.$6k)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(S=>S.id===h.id);if(!g)throw new Error(`Profile '${h.name}' does not exist`);this.L(a,g)}unsetWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(h=>h.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(a.map(h=>this.removeProfile(h)))}getProfileForWorkspace(a){const h=this.G(a);return M.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(a){return(0,p.$si)(a)?a.uri:(0,p.$xi)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location)))}I(a,h,g){const S=[...this.profiles,...a],w=[];this.s.profiles=[];for(let E of S)E.isDefault||h.some(y=>E.id===y.id)||(E=g.find(y=>E.id===y.id)??E,E.isTransient?this.s.profiles.push(E):w.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(w),this.z=void 0,this.J(a,h,g)}J(a,h,g){this.h.fire({added:a,removed:h,updated:g,all:this.profiles})}L(a,h,g){g=h?.isTransient?!0:g,g||this.L(a,void 0,!0);const S=this.G(a),w=g?this.s:this.C;M.URI.isUri(S)?(w.workspaces.delete(S),h&&w.workspaces.set(S,h)):(w.emptyWindows.delete(S),h&&w.emptyWindows.set(S,h)),g||this.M()}M(){const a={};for(const[g,S]of this.C.workspaces.entries())a[g.toString()]=S.id;const h={};for(const[g,S]of this.C.emptyWindows.entries())h[g.toString()]=S.id;this.R({workspaces:a,emptyWindows:h}),this.z=void 0}N(a){const h={},g=this.D();if(a.workspaces)for(const[w,E]of Object.entries(a.workspaces)){const y=M.URI.parse(E);h[w]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}const S={};if(a.emptyWindows)for(const[w,E]of Object.entries(a.emptyWindows)){const y=M.URI.parse(E);S[w]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}return{workspaces:h,emptyWindows:S}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$rl=f,e.$rl=f=Je([qe(0,$.$pi),qe(1,v.$Ok),qe(2,k.$ml),qe(3,I.$Oj)],f);class d extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$sl=d}),define(ke[278],Ee([1,0,8,4,3,58,18,194,5,277]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Op=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mp=e.$Lp=e.$Kp=void 0,e.$Np=C,e.$Pp=c,e.$Rp=o,e.$Kp="__$__isNewStorageMarker",e.$Lp="__$__targetStorageMarker",e.$Mp=(0,$.$ii)("storageService");var R;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function C(n){const i=n.get(e.$Lp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class k extends O.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:k.a}){super(),this.m=i,this.b=this.B(new L.$0d),this.c=this.B(new L.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new u.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new O.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,s){return L.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,u.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,O.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:s,external:t}=r;if(s===e.$Lp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,r,s){return this.P(r)?.get(i,s)}getBoolean(i,r,s){return this.P(r)?.getBoolean(i,s)}getNumber(i,r,s){return this.P(r)?.getNumber(i,s)}getObject(i,r,s){return this.P(r)?.getObject(i,s)}storeAll(i,r){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,r)})}store(i,r,s,t,f=!1){if((0,M.$5f)(r)){this.remove(i,s,f);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,r,f)})}remove(i,r,s=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const s=[],t=this.J(i);for(const f of Object.keys(t))t[f]===r&&s.push(f);return s}z(i,r,s,t=!1){const f=this.J(r);typeof s=="number"?f[i]!==s&&(f[i]=s,this.P(r)?.set(e.$Lp,JSON.stringify(f),t)):typeof f[i]=="number"&&(delete f[i],this.P(r)?.set(e.$Lp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?C(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Kp,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case R.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return o(i,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(R.NONE),(0,v.$nl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||c(r)&&c(i))}N(i,r,s){this.y(()=>{const t=new Set;for(const[f,d]of i)t.add(f),r.get(f)!==d&&this.u(s,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(s,{key:f,external:!0})})}}e.$Op=k;function c(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class m extends k{constructor(){super(),this.U=this.B(new b.$Ip(new b.$Jp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Ip(new b.$Jp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Ip(new b.$Jp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Qp=m;async function o(n,i,r,s,t,f){const d=D=>{try{return JSON.parse(D)}catch{return D}},l=new Map,a=new Map;n.forEach((D,P)=>{l.set(P,D),a.set(P,d(D))});const h=new Map,g=new Map;i.forEach((D,P)=>{h.set(P,D),g.set(P,d(D))});const S=new Map,w=new Map;r.forEach((D,P)=>{S.set(P,D),w.set(P,d(D))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const E=[];if(l.forEach((D,P)=>{E.push({key:P,value:D})}),console.table(E),console.groupEnd(),console.log(a),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];h.forEach((P,z)=>{D.push({key:z,value:P})}),console.table(D),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${f})`);const y=[];S.forEach((D,P)=>{y.push({key:P,value:D})}),console.table(y),console.groupEnd(),console.log(w)}}),define(ke[111],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;class u{static{this.a=!1}constructor(O){this.d=O,this.b=new Map,this.c=1}add(O){const A=this.c++;return this.b.set(A,O),this.e(),A}get(O,A){return this.b.has(O)?this.b.get(O)[A]:void 0}delete(O){this.b.delete(O),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$mjc=u}),define(ke[59],Ee([1,0,15,23,5]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=e.$rjc=void 0;class A{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new L.$Kg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$rjc=A,e.$sjc=(0,O.$ii)("IExtHostFileSystemInfo")}),define(ke[28],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=void 0,e.$3O=(0,u.$ii)("IExtHostInitDataService")}),define(ke[279],Ee([1,0,222,12,259,28]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;let M=class extends O.$$P{constructor($,v,R){const I=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=R.remote.isRemote?(0,u.localize)(0,null):$?(0,u.localize)(1,null):(0,u.localize)(2,null);super(v.createLogger(I,{name:p}))}};e.$ylc=M,e.$ylc=M=Je([qe(1,L.$Pj),qe(2,A.$3O)],M)}),define(ke[280],Ee([1,0,8]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=e.$akc=void 0;class L{constructor(M,b,$){this.h=new Map,this.a=M,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(v=>(this.f=v,this)),this.g=this.c.onDidChangeStorage(v=>{v.shared===this.b&&v.key===this.a&&(this.f=v.value)}),this.i=new u.$uh(()=>{const v=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of v.values())R.complete()}catch(R){for(const I of v.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let $=this.f[M];return typeof $>"u"&&($=b),$}update(M,b){this.f[M]=b;const $=this.h.get(M);if($!==void 0)return $.p;const v=new u.$Fh;return this.h.set(M,v),this.i.isScheduled()||this.i.schedule(),v.p}dispose(){this.g.dispose()}}e.$akc=L;class O extends L{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$bkc=O}),define(ke[281],Ee([1,0,4,2]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=void 0;class O{constructor(M){this.c=M,this.a=new u.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,$,v){const I=this.c.getNotebookDocument(L.URI.revive(M)).acceptModelChanged(b.value,$,v);this.b.fire(I)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(L.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(L.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$1kc=O}),define(ke[20],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0,e.$MO=(0,u.$ii)("IExtHostRpcService");class L{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$NO=L}),define(ke[282],Ee([1,0,25,4]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=void 0;class O{#e;constructor(M,b){this.b=new L.$7d,this.onDidChange=this.b.event,this.a=u.$Dm.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$ikc=O}),define(ke[66],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0,e.$Kjc=(0,u.$ii)("IURITransformerService");class L{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$Ljc=L}),define(ke[283],Ee([1,0,21]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nb=O,e.$aob=M;class L{constructor(){this.buffers=[]}add($){let v=this.buffers.indexOf($);return v<0&&(v=this.buffers.length,this.buffers.push($)),v}}function O(b,$){if($.serializeBuffersForPostMessage){const v=new L,I=JSON.stringify(b,(C,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:v.add(k)};if(ArrayBuffer.isView(k)){const c=A(k);if(c)return{$$vscode_array_buffer_reference$$:!0,index:v.add(k.buffer),view:{type:c,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),p=v.buffers.map(C=>{const k=new Uint8Array(C);return u.$ue.wrap(k)});return{message:I,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}function A(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,$){const v=$.map(p=>{const C=new ArrayBuffer(p.byteLength);return new Uint8Array(C).set(p.buffer),C}),R=$.length?(p,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const k=C,{index:c}=k,m=v[c];if(k.view)switch(k.view.type){case 1:return new Int8Array(m,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return C}:void 0;return{message:JSON.parse(b,R),arrayBuffers:v}}}),define(ke[284],Ee([1,0,285,398,399,62,2,12,400]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=R;const v=!1;function R(i,r,s,t,f,d){const l=d.environment.useHostProxy,a=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:w=>i.resolveProxy(w),lookupProxyAuthorization:m.bind(void 0,t,f,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(r),addCertificatesV2:()=>C(r),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return E(w)}function E(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const w=[];if(d.remote.isRemote&&w.push((0,$.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const E=i.loadCertificates();E.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),w.push(E)}return(await Promise.all(w)).flat()},env:process.env},g=(0,$.createProxyResolver)(h),S=I(h,g);return c(s,S)}function I(i,r){return{http:Object.assign(u,(0,$.createHttpPatch)(i,u,r)),https:Object.assign(L,(0,$.createHttpPatch)(i,L,r)),net:Object.assign(A,(0,$.createNetPatch)(i,A)),tls:Object.assign(O,(0,$.createTlsPatch)(i,O))}}function p(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",v)&&!!r.get("systemCertificates")}function C(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",v)&&!!r.get("systemCertificates")}const k=new Map;function c(i,r){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(l,a,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return f.apply(this,arguments);const g=s.findSubstr(M.URI.file(a.filename));let S=k.get(g);if(S||k.set(g,S={}),!S[l]){const w=r[l];S[l]={...w}}return S[l]}})}async function m(i,r,s,t,f,d,l,a){const h=t[d];l&&(t[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const g=l||h,S=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(n(r,S,f),S.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const w=await new Promise((z,F)=>{he(["kerberos"],z,F)}),E=new URL(d),y=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${y}`),"Negotiate "+await(await w.initializeClient(y)).step("")}catch(w){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let o=!1;function n(i,r,s){o||!r.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ke[286],Ee([1,0,133]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=O;function L(A){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:A,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function O(A){return new u.$kn(L(A))}}),define(ke[142],Ee([1,0,232,18,2,3,5,37,32,15,46,186,40]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$tF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$kF=e.EditorInputCapabilities=e.$jF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=void 0,e.$aF=c,e.$bF=m,e.$cF=o,e.$dF=n,e.$eF=i,e.$fF=r,e.$gF=s,e.$hF=t,e.$iF=f,e.$lF=S,e.$mF=E,e.$nF=y,e.$oF=D,e.$pF=P,e.$qF=z,e.$rF=F,e.$sF=Y,e.$uF=Z,e.$vF=ee,e.$wF=pe,e.$xF=De,e.$8E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$9E={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$0E="workbench.editor.sidebysideEditor",e.$$E="workbench.editors.textDiffEditor",e.$_E="workbench.editors.binaryResourceDiffEditor";var C;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var k;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function c(x){const U=x;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(x){const U=x;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function o(x,U,ie){for(const be of ie.visibleEditorPanes)if(be.group.id===U&&x.matches(be.input))return be.getViewState()}function n(x){if(S(x))return!1;const U=x;return O.URI.isUri(U?.resource)}function i(x){if(S(x))return!1;const U=x;return U?.original!==void 0&&U.modified!==void 0}function r(x){if(S(x))return!1;const U=x;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function s(x){if(S(x)||i(x))return!1;const U=x;return U?.primary!==void 0&&U.secondary!==void 0}function t(x){if(S(x))return!1;const U=x;return U?U.resource===void 0||U.resource.scheme===v.Schemas.untitled||U.forceUntitled===!0:!1}function f(x){if(S(x))return!1;const U=x;return O.URI.isUri(U?.base?.resource)&&O.URI.isUri(U?.input1?.resource)&&O.URI.isUri(U?.input2?.resource)&&O.URI.isUri(U?.result?.resource)}var d;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class a{constructor(){this.a=new Map}registerSource(U,ie){let be=this.a.get(U);return be||(be={source:U,label:ie},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$jF=new a;var h;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors",x[x.Scratchpad=512]="Scratchpad"})(h||(e.EditorInputCapabilities=h={}));class g extends A.$Uc{}e.$kF=g;function S(x){return x instanceof g}function w(x){const U=x;return O.URI.isUri(U?.preferredResource)}function E(x){const U=x;return S(U?.primary)&&S(U?.secondary)}function y(x){const U=x;return S(U?.modified)&&S(U?.original)}function D(x,U,ie,be,Ce){return De(be,[(0,I.$5i)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const ae={...ie,limits:{size:Number.MAX_VALUE}};x.openEditor(U,ae)}}),(0,I.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>Ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function P(x){return S(x?.editor)}function z(x){const U=x;return P(x)&&U?.group!==void 0}function F(x){const U=x;return typeof U?.groupId=="number"&&S(U.editor)}var T;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var j;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LABEL=2]="GROUP_LABEL",x[x.GROUP_LOCKED=3]="GROUP_LOCKED",x[x.EDITOR_OPEN=4]="EDITOR_OPEN",x[x.EDITOR_CLOSE=5]="EDITOR_CLOSE",x[x.EDITOR_MOVE=6]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=8]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=10]="EDITOR_PIN",x[x.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",x[x.EDITOR_STICKY=12]="EDITOR_STICKY",x[x.EDITOR_DIRTY=13]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var N;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class B{getOriginalUri(U,ie){if(!U)return;if(f(U))return e.$tF.getOriginalUri(U.result,ie);if(ie?.supportSideBySide){const{primary:Ce,secondary:ae}=this.a(U);if(Ce&&ae){if(ie?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(Ce,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===N.ANY)return this.getOriginalUri(Ce,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:ie.filterByScheme});U=ie.supportSideBySide===N.PRIMARY?Ce:ae}}if(i(U)||r(U)||s(U)||f(U))return;const be=w(U)?U.preferredResource:U.resource;return!be||!ie||!ie.filterByScheme?be:this.b(be,ie.filterByScheme)}a(U){return E(U)||s(U)?{primary:U.primary,secondary:U.secondary}:y(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ie){if(!U)return;if(f(U))return e.$tF.getCanonicalUri(U.result,ie);if(ie?.supportSideBySide){const{primary:Ce,secondary:ae}=this.a(U);if(Ce&&ae){if(ie?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(Ce,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===N.ANY)return this.getCanonicalUri(Ce,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:ie.filterByScheme});U=ie.supportSideBySide===N.PRIMARY?Ce:ae}}if(i(U)||r(U)||s(U)||f(U))return;const be=U.resource;return!be||!ie||!ie.filterByScheme?be:this.b(be,ie.filterByScheme)}b(U,ie){if(Array.isArray(ie)){if(ie.some(be=>U.scheme===be))return U}else if(ie===U.scheme)return U}}var W;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.KEYBOARD=1]="KEYBOARD",x[x.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function Y(x,U,ie,be){if(!x.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ie===W.MOUSE||ie===W.KEYBOARD;case"mouse":return ie===W.MOUSE;case"keyboard":return ie===W.KEYBOARD}return!1}e.$tF=new B;var _;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(_||(e.CloseDirection=_={}));class J{constructor(){this.c=new Map,this.d=new Map}start(U){const ie=this.a=U.get(M.$hi);for(const[be,Ce]of this.c)this.e(be,Ce,ie);this.c.clear()}e(U,ie,be){const Ce=be.createInstance(ie);this.d.set(U,Ce)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,L.$7f)(this.b)}registerEditorSerializer(U,ie){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ie,this.a):this.c.set(U,ie),(0,A.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}b.$1n.add(e.$8E.EditorFactory,new J);async function Z(x,U,ie){return!x||!x.length?[]:await Promise.all(x.map(async be=>{const Ce=O.URI.revive(be.fileUri);if(!Ce){ie.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(Ce)){ie.info("Cannot resolve the path because it cannot be handled",be);return}let ce=be.exists,se=be.type;if(typeof ce!="boolean"||typeof se!="number")try{se=(await U.stat(Ce)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ce=!0}catch(te){ie.error(te),ce=!1}if(!ce&&be.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",be);return}if(se===$.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",be);return}const K={...be.options,pinned:!0};return ce?{resource:Ce,options:K}:{resource:Ce,options:K,forceUntitled:!0}}))}var re;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(re||(e.EditorsOrder=re={}));function ee(x){const U=x;if(!U)return!1;const ie=U;if(ie.modified)return ee(ie.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function pe(x){return(0,R.$7i)(x)}function De(x,U,ie){const be=(0,R.$8i)(x,U);return be.forceMessage=ie?.forceMessage,be.forceSeverity=ie?.forceSeverity,be.allowDialog=ie?.allowDialog,be}}),define(ke[287],Ee([1,0,4,233,5,3,27,37,19,24,78,273]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FF=e.$EF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$DF=e.ViewContentGroups=e.$BF=e.ViewContainerLocation=e.Extensions=e.$AF=e.$zF=e.$yF=void 0,e.$CF=k,e.$yF="views",e.$zF=(0,L.localize)(0,null),e.$AF=(0,I.$Uw)("default-view-icon",R.$Hj.window,(0,L.localize)(1,null));var p;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var C;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.$BF=[0,1,2];function k(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class c extends A.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$7d),this.onDidRegister=this.c.event,this.f=this.B(new u.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,l,a){const h=this.get(d.id);if(h)return h;const g=d;return g.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,M.$yc)(this.g,l,[]).push(g),a?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:l}),g}deregisterViewContainer(d){for(const l of this.g.keys()){const a=this.g.get(l),h=a?.indexOf(d);if(h!==-1){a?.splice(h,1),a.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(a=>a?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}b.$1n.add(p.ViewContainersRegistry,new c);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(f,d){const l=f.group??m.More,a=d.group??m.More;return l!==a?l.localeCompare(a):(f.order??5)-(d.order??5)}class n extends A.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:a})=>this.r(l,a)),this.c.fire(d)}deregisterViews(d,l){const a=this.s(d,l);a.length&&this.f.fire({views:a,viewContainer:l})}moveViews(d,l){for(const a of this.m.keys())if(a!==l){const h=this.s(d,a);h.length&&(this.r(h,l),this.g.fire({views:h,from:a,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const a=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(a)return a}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,A.$Sc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const a=new Map;for(const[h,g]of l)this.n.add(d,g),a.set(h,(0,A.$Sc)(()=>{this.n.delete(d,g),this.h.fire(d)}));return this.h.fire(d),a}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,a=>l.push(a)),l.sort(o)}r(d,l){let a=this.m.get(l);a||(a=[],this.m.set(l,a),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,L.localize)(2,null,h.id));a.push(h)}}s(d,l){const a=this.m.get(l);if(!a)return[];const h=[],g=[];for(const S of a)d.includes(S)?h.push(S):g.push(S);return h.length&&(g.length?this.m.set(l,g):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}b.$1n.add(p.ViewsRegistry,new n),e.$DF=(0,O.$ii)("viewDescriptorService");var i;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,l){this.c=!1,this.d=!1,(0,v.$Rn)(this,d),this.d=!!l,this.resolve=async a=>{if(l&&!this.c){const h=await l(a);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$EF=s;class t extends Error{constructor(d){super((0,L.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$FF=t}),define(ke[288],Ee([1,0,4,38,3,41,5]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.ChatAgentLocation=void 0;var b;(function(R){R[R.Panel=1]="Panel",R[R.Terminal=2]="Terminal",R[R.Notebook=3]="Notebook"})(b||(e.ChatAgentLocation=b={})),function(R){function I(p){switch(p){case"panel":return R.Panel;case"terminal":return R.Terminal;case"notebook":return R.Notebook}return R.Panel}R.fromRaw=I}(b||(e.ChatAgentLocation=b={})),e.$FG=(0,M.$ii)("chatAgentService");let $=class{static{this.AGENT_LEADER="@"}constructor(I){this.e=I,this.b=[],this.d=new u.$7d,this.onDidChangeAgents=this.d.event}registerAgent(I,p){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const k=this,c=p.slashCommands;p={...p,get slashCommands(){return c.filter(o=>!o.when||k.e.contextMatchesRules(A.$gj.deserialize(o.when)))}};const m={data:p};return this.b.push(m),(0,O.$Sc)(()=>{this.b=this.b.filter(o=>o!==m),this.d.fire(void 0)})}registerAgentImplementation(I,p){const C=this.f(I);if(!C)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(C.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return C.impl=p,this.d.fire(new v(C.data,p)),(0,O.$Sc)(()=>{C.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(I,p){const C={data:I,impl:p};return this.b.push(C),this.d.fire(new v(I,p)),(0,O.$Sc)(()=>{this.b=this.b.filter(k=>k!==C),this.d.fire(void 0)})}updateAgent(I,p){const C=this.f(I);if(!C?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);C.data.metadata={...C.data.metadata,...p},this.d.fire(new v(C.data,C.impl))}getDefaultAgent(){return this.getActivatedAgents().find(I=>!!I.isDefault)}getSecondaryAgent(){return L.Iterable.find(this.b.values(),I=>!!I.data.metadata.isSecondary)?.data}f(I){return this.b.find(p=>p.data.id===I)}getAgent(I){return this.f(I)?.data}getAgents(){return this.b.map(I=>I.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(I=>!!I.impl).map(I=>new v(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(p=>p.name===I)}async invokeAgent(I,p,C,k,c){const m=this.f(I);if(!m?.impl)throw new Error(`No activated agent with id ${I}`);return await m.impl.invoke(p,C,k,c)}async getFollowups(I,p,C,k,c){const m=this.f(I);if(!m?.impl)throw new Error(`No activated agent with id ${I}`);return m.impl?.provideFollowups?m.impl.provideFollowups(p,C,k,c):[]}};e.$GG=$,e.$GG=$=Je([qe(0,A.$Aj)],$);class v{constructor(I,p){this.b=I,this.d=p}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(I,p,C,k){return this.d.invoke(I,p,C,k)}async provideFollowups(I,p,C,k){return this.d.provideFollowups?this.d.provideFollowups(I,p,C,k):[]}provideWelcomeMessage(I){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(I)}provideSampleQuestions(I){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(I)}}e.$HG=v}),define(ke[289],Ee([1,0,2,29,5]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$OF=A,e.$PF=M;function A(v){return!!v&&typeof v=="object"&&"uri"in v&&v.uri instanceof u.URI&&"version"in v&&typeof v.version=="number"&&"ranges"in v&&Array.isArray(v.ranges)&&v.ranges.every(L.$ct.isIRange)}function M(v){return!!v&&typeof v=="object"&&"documents"in v&&Array.isArray(v.documents)&&v.documents.every(A)}var b;(function(v){v[v.Down=0]="Down",v[v.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(v){v[v.Action=1]="Action",v[v.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$QF=(0,O.$ii)("IChatService"),e.$RF="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,8,234]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gob=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new u.$7d,this.o=new u.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,v,R){const I={command:b};if($&&Object.keys($).length>0&&(I.arguments=$),this.u("request",I),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const C=this.f.get(I.seq);if(C){this.f.delete(I.seq);const k={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,O.localize)(0,null,R,b)};C(k)}},R)}return v&&this.f.set(I.seq,v),I.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,L.$jh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,v=this.f.get($.request_seq);v&&(this.f.delete($.request_seq),v($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,v)=>b.set(v,$)),await(0,L.$jh)(500),b.forEach(($,v)=>{$({type:"response",seq:0,request_seq:v,success:!1,command:"canceled",message:"canceled"}),this.f.delete(v)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Gob=A}),define(ke[290],Ee([1,0,2,235,41,5]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$WI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$VI=e.MemoryRangeType=e.State=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=void 0,e.$UI=$,e.$IH="workbench.view.debug",e.$JH="workbench.debug.variablesView",e.$KH="workbench.debug.watchExpressionsView",e.$LH="workbench.debug.callStackView",e.$MH="workbench.debug.loadedScriptsView",e.$NH="workbench.debug.breakPointsView",e.$OH="workbench.debug.disassemblyView",e.$PH="workbench.panel.repl",e.$QH="workbench.panel.repl.view",e.$RH=new O.$zj("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.$SH=new O.$zj("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.$TH=new O.$zj("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.$UH="debugUx",e.$VH=new O.$zj(e.$UH,"default",{type:"string",description:L.localize(3,null)}),e.$WH=new O.$zj("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.$XH=new O.$zj("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.$YH=new O.$zj("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.$ZH=new O.$zj("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.$1H=new O.$zj("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.$2H=new O.$zj("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.$3H=new O.$zj("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.$4H=new O.$zj("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.$5H=new O.$zj("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.$6H=new O.$zj("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.$7H=new O.$zj("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.$8H=new O.$zj("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.$9H=new O.$zj("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.$0H=new O.$zj("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.$$H=new O.$zj("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.$_H=new O.$zj("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.$aI=new O.$zj("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.$bI=new O.$zj("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.$cI=new O.$zj("breakpointItemBytes",void 0,{type:"boolean",description:L.localize(22,null)}),e.$dI=new O.$zj("breakpointHasModes",!1,{type:"boolean",description:L.localize(23,null)}),e.$eI=new O.$zj("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(24,null)}),e.$fI=new O.$zj("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(25,null)}),e.$gI=new O.$zj("loadedScriptsItemType",void 0,{type:"string",description:L.localize(26,null)}),e.$hI=new O.$zj("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(27,null)}),e.$iI=new O.$zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(28,null)}),e.$jI=new O.$zj("stepBackSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.$kI=new O.$zj("restartFrameSupported",!1,{type:"boolean",description:L.localize(30,null)}),e.$lI=new O.$zj("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(31,null)}),e.$mI=new O.$zj("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.$nI=new O.$zj("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(33,null)}),e.$oI=new O.$zj("breakpointsExist",!1,{type:"boolean",description:L.localize(34,null)}),e.$pI=new O.$zj("debuggersAvailable",!1,{type:"boolean",description:L.localize(35,null)}),e.$qI=new O.$zj("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(36,null)}),e.$rI=new O.$zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(37,null)}),e.$sI=new O.$zj("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.$tI=new O.$zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.$uI=new O.$zj("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.$vI=new O.$zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.$wI=new O.$zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.$xI=new O.$zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.$yI=new O.$zj("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(44,null)}),e.$zI=new O.$zj("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(45,null)}),e.$AI=new O.$zj("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(46,null)}),e.$BI=new O.$zj("variableIsReadonly",!1,{type:"boolean",description:L.localize(47,null)}),e.$CI=new O.$zj("variableValue",!1,{type:"string",description:L.localize(48,null)}),e.$DI=new O.$zj("variableType",!1,{type:"string",description:L.localize(49,null)}),e.$EI=new O.$zj("variableInterfaces",!1,{type:"array",description:L.localize(50,null)}),e.$FI=new O.$zj("variableName",!1,{type:"string",description:L.localize(51,null)}),e.$GI=new O.$zj("variableLanguage",!1,{type:"string",description:L.localize(52,null)}),e.$HI=new O.$zj("variableExtensionId",!1,{type:"string",description:L.localize(53,null)}),e.$II=new O.$zj("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(54,null)}),e.$JI=new O.$zj("multiSessionRepl",!1,{type:"boolean",description:L.localize(55,null)}),e.$KI=new O.$zj("multiSessionDebug",!1,{type:"boolean",description:L.localize(56,null)}),e.$LI=new O.$zj("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(57,null)}),e.$MI=new O.$zj("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(58,null)}),e.$NI=new O.$zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(59,null)}),e.$OI=new O.$zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(60,null)});const M=n=>L.localize(61,null,n);e.$PI=M,e.$QI="editor.contrib.debug",e.$RI="editor.contrib.breakpoint",e.$SI="debug",e.$TI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(62,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function $(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var v;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(v||(e.MemoryRangeType=v={})),e.$VI="vscode-debug-memory";var R;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(R||(e.DataBreakpointSetType=R={}));var I;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(I||(e.DebugConfigurationProviderTriggerKind=I={}));var p;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(p||(e.DebuggerString=p={})),e.$WI=(0,A.$ii)("debugService");var C;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(C||(e.BreakpointWidgetContext=C={}));var k;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(k||(e.DebugVisualizationType=k={}));var c;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(c||(e.DebugTreeItemCollapsibleState=c={}));var m;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(m||(e.IDebugVisualizationTreeItem=m={}));var o;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:u.URI.revive(i.iconPath.light),dark:u.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(o||(e.IDebugVisualization=o={}))}),define(ke[291],Ee([1,0,14,2,17,24,15,29,22,19]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=void 0,e.$KG=I,e.$LG=p,e.$MG=C,e.$NG=k,e.$OG=c,e.$PG=m,e.$QG=o,e.$RG=i,e.$SG=t,e.$TG=f,e.$UG=l,e.$VG=h;const R=/{([^}]+)}/g;function I(S,w,E){return S.replace(R,function(y,D){return w&&D.length>0&&D[0]!=="_"?y:E&&E.hasOwnProperty(D)?E[D]:y})}function p(S){const w={};for(const E of Object.keys(S))E.startsWith("!")||(w[E]=S[E]);return w}function C(S){return S.configuration.request==="attach"&&!k(S)&&(!S.parentSession||C(S.parentSession))}function k(S){let w=S.configuration.type;if(w)return w==="vslsShare"&&(w=S.configuration.adapterProxy.configuration.type),(0,u.$lf)(w,"extensionhost")||(0,u.$lf)(w,"pwa-extensionhost")?S:S.parentSession?k(S.parentSession):void 0}function c(S){return S.type&&(S.label||S.program||S.runtime)}function m(S,w,E){let y,D=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=P.exec(S);){const F=z.index+1,T=F+z[0].length;if(F<=w&&T>=E){y=z[0],D=F;break}}if(y){const F=/\w+/g;let T=null;for(;(T=F.exec(y))&&!(T.index+1+D+T[0].length>=E););T&&(y=y.substring(0,F.lastIndex))}return y?{start:D,end:D+y.length-1}:{start:0,end:0}}async function o(S,w,E,y){if(S.evaluatableExpressionProvider.has(w)){const D=S.evaluatableExpressionProvider.ordered(w),P=(0,v.$Hb)(await Promise.all(D.map(async z=>{try{return await z.provideEvaluatableExpression(w,E,y??$.CancellationToken.None)}catch{return}})));if(P.length>0){let z=P[0].expression;const F=P[0].range;return z||(z=w.getLineContent(E.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:z}}}else{const D=w.getLineContent(E.lineNumber),{start:P,end:z}=m(D,E.column,E.column),F=D.substring(P-1,z);return{matchingExpression:F,range:new b.$ct(E.lineNumber,P,E.lineNumber,P+F.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(n))}function r(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return L.URI.parse(S.path);if((0,O.$jc)(S.path))return L.URI.file(S.path)}return S.path}function s(S){if(typeof S.path=="object"){const w=L.URI.revive(S.path);if(w)return w.scheme===M.Schemas.file?w.fsPath:w.toString()}return S.path}function t(S,w){const E=w?r:s,y=(0,A.$On)(S);return d(y,(D,P)=>{D&&P&&(P.path=E(P))}),y}function f(S,w){const E=w?r:s,y=(0,A.$On)(S);return d(y,(D,P)=>{!D&&P&&(P.path=E(P))}),y}function d(S,w){switch(S.type){case"event":{const E=S;switch(E.event){case"output":w(!1,E.body.source);break;case"loadedSource":w(!1,E.body.source);break;case"breakpoint":w(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=S;switch(E.command){case"setBreakpoints":w(!0,E.arguments.source);break;case"breakpointLocations":w(!0,E.arguments.source);break;case"source":w(!0,E.arguments.source);break;case"gotoTargets":w(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(y=>w(!1,y));break;default:break}break}case"response":{const E=S;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(y=>w(!1,y.source));break;case"loadedSources":E.body.sources.forEach(y=>w(!1,y));break;case"scopes":E.body.scopes.forEach(y=>w(!1,y.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(y=>w(!1,y.source));break;case"setBreakpoints":E.body.breakpoints.forEach(y=>w(!1,y.source));break;case"disassemble":E.body?.instructions.forEach(D=>w(!1,D.location));break;default:break}break}}}function l(S){return S.filter(w=>!w.presentation?.hidden).sort((w,E)=>w.presentation?E.presentation?w.presentation.group?E.presentation.group?w.presentation.group!==E.presentation.group?w.presentation.group.localeCompare(E.presentation.group):a(w.presentation.order,E.presentation.order):-1:E.presentation.group?1:a(w.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function a(S,w){return typeof S!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:S-w}async function h(S,w){const E=S.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(E!=="none"&&(await w.saveAll(),E==="allEditorsInActiveGroup")){const y=w.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await w.save({editor:y.input,groupId:y.group.id})}await S.reloadConfiguration()}const g=(S,w)=>!S||!w?S===w:S.name===w.name&&S.path===w.path&&S.sourceReference===w.sourceReference;e.$WG=g}),define(ke[292],Ee([1,0,52,62,24,17,11,14,31,236,143]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=e.$Glc=e.$Flc=e.$Elc=void 0;class I extends R.$Gob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",i=>this.v(i))}sendMessage(o){if(this.l){const n=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(I.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(I.b);for(const s of r){const t=s.split(I.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+I.a.length);continue}}break}}}e.$Elc=I;class p extends I{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Flc=p;class C extends p{constructor(o){super(),this.z=o}y(o){return L.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Glc=C;class k extends p{constructor(o){super(),this.z=o}y(o){return L.createConnection(this.z.path,o)}}e.$Hlc=k;class c extends I{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(A.$jc(o)){if(!await $.Promises.exists(o))throw new Error(v.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(v.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=O.$Rn(O.$On(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const f=u.fork(n[0],n.slice(1),t);if(!f.pid)throw new Error(v.localize(2,null,n[0]));this.x=f}else throw new Error(v.localize(3,null));else{const s={env:r};i.cwd&&(s.cwd=i.cwd),this.x=u.spawn(o,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((o,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return n(r)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=A.$kc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(A.$jc(o.program)?i.program=o.program:i.program=A.$kc(n,o.program)),o.args&&(i.args=o.args);const r=o;return r.win&&(i.win=c.A(r.win,n)),r.winx86&&(i.winx86=c.A(r.winx86,n)),r.windows&&(i.windows=c.A(r.windows,n)),r.osx&&(i.osx=c.A(r.osx,n)),r.linux&&(i.linux=c.A(r.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const l of o)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(h=>typeof h.type=="string"&&b.$lf(h.type,n)).forEach(h=>{const g=c.A(h,l.extensionLocation.fsPath);i=O.$Rn(i,g,l.isBuiltin)})}let r;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:M.$i?r=i.win||i.windows:M.$j?r=i.osx:M.$k&&(r=i.linux),r=r||i;const s=r.program||i.program,t=r.args||i.args,f=r.runtime||i.runtime,d=r.runtimeArgs||i.runtimeArgs;if(f)return{type:"executable",command:f,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$Ilc=c}),define(ke[293],Ee([1,0,52,34,11]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=M,e.$Klc=$;function A(v,R){return new Promise((I,p)=>{let C="";const k=u.spawn(v,R);k.pid&&k.stdout.on("data",c=>{C+=c.toString()}),k.on("error",c=>{p(c)}),k.on("close",c=>{I(C)})})}async function M(v){if(v)if(O.$i){const R=await new Promise((I,p)=>{he(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{R.getProcessTree(v,p=>{I(!!p&&p.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(v)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}var b;(function(v){v[v.cmd=0]="cmd",v[v.powershell=1]="powershell",v[v.bash=2]="bash"})(b||(b={}));function $(v,R,I,p){v=v.trim().toLowerCase();let C;v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0?C=1:v.indexOf("cmd.exe")>=0?C=0:v.indexOf("bash")>=0?C=2:O.$i?C=0:C=2;let k,c=" ";switch(C){case 1:if(k=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),p){const m=(0,L.$ng)(p);m&&(c+=`${m}:; `),c+=`cd ${k(p)}; `}if(R.length>0){const m=R.shift(),o=I?m:k(m);c+=o[0]==="'"?`& ${o} `:`${o} `;for(const n of R)c+=n==="<"||n===">"||I?n:k(n),c+=" "}break;case 0:if(k=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>m.includes(o))||m.length===0?`"${m}"`:m),p){const m=(0,L.$ng)(p);m&&(c+=`${m}: && `),c+=`cd ${k(p)} && `}for(const m of R)c+=m==="<"||m===">"||I?m:k(m),c+=" ";break;case 2:{k=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),p&&(c+=`cd ${k(p)} ; `);for(const m of R)c+=m==="<"||m===">"||I?m:k(m),c+=" ";break}}return c}}),define(ke[294],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.CellExecutionUpdateType=void 0;var L;(function(O){O[O.Output=1]="Output",O[O.OutputItems=2]="OutputItems",O[O.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$0J=(0,u.$ii)("INotebookExecutionService")}),define(ke[295],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhb=e.$Mhb=e.ProxyKernelState=e.$Lhb=void 0,e.$Lhb=100;var L;(function(O){O[O.Disconnected=1]="Disconnected",O[O.Connected=2]="Connected",O[O.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.$Mhb=(0,u.$ii)("INotebookKernelService"),e.$Nhb=(0,u.$ii)("INotebookKernelHistoryService")}),define(ke[296],Ee([1,0,3,29,199,100]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WUb=void 0;class M extends u.$Uc{constructor($,v,R){super(),this._source=$,this.b=v,this.c=R,this.a=void 0}f($){const v=$.getLineCount();return new L.$ct(1,1,v,this.g($,v))}g($,v){if(v<1||v>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(v)+1}get inputTextBuffer(){if(!this.b){const $=new O.$EC;$.acceptChunk(this._source);const v=$.finish(!0),{textBuffer:R,disposable:I}=v.create(1);this.b=R,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const v=new O.$EC;v.acceptChunk($);const R=v.finish(!0),{textBuffer:I,disposable:p}=R.create(1);return this.B(p),I})),this.a}findInInputs($){const R=new A.$sC($,!1,!1,null).parseSearchRequest();if(!R)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,R,!0,5e3)}findInOutputs($){const R=new A.$sC($,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(I=>{const p=I.findMatchesLineByLine(this.f(I),R,!0,5e3);if(p.length!==0)return{textBuffer:I,matches:p}}).filter(I=>!!I):[]}}e.$WUb=M}),define(ke[67],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(A){A.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var L;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class O{static fromExtHostTestItem(M,b,$=M.parent){if(M._isRoot)return new O([b]);const v=[M.id];for(let R=$;R&&R.id!==b;R=R.parent)v.push(R.id);return v.push(b),new O(v.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new O(M.split("\0"))}static join(M,b){return new O([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:O.isChild(M,b)?2:O.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new O(this.path,1)}get parentId(){return this.d>1?new O(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new O(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new O(this.path,M)}compare(M){if(typeof M=="string")return O.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$dL=O}),define(ke[89],Ee([1,0,2,49,29,67]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$lL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$kL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$jL=e.$iL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$hL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$gL=e.$fL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$eL=e.TestResultState=void 0;var M;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$eL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(j){j[j.Run=2]="Run",j[j.Debug=4]="Debug",j[j.Coverage=8]="Coverage",j[j.HasNonDefaultProfile=16]="HasNonDefaultProfile",j[j.HasConfigurable=32]="HasConfigurable",j[j.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$fL=[2,4,8,16,32,64];const v=j=>"runId"in j;e.$gL=v;var R;(function(j){j.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),j.deserialize=(N,B)=>({range:O.$ct.lift(B.range),uri:N.asCanonicalUri(u.URI.revive(B.uri))})})(R||(e.IRichLocation=R={}));var I;(function(j){j[j.Error=0]="Error",j[j.Output=1]="Output"})(I||(e.TestMessageType=I={}));var p;(function(j){j.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&R.serialize(N.location)}),j.deserialize=(N,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&R.deserialize(N,B.location)})})(p||(e.ITestErrorMessage=p={}));const C=(j,N)=>`${N?"s":"e"}${j}`;e.$hL=C;var k;(function(j){j.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&R.serialize(N.location)}),j.deserialize=(N,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&R.deserialize(N,B.location)})})(k||(e.ITestOutputMessage=k={}));var c;(function(j){j.serialize=N=>N.type===0?p.serialize(N):k.serialize(N),j.deserialize=(N,B)=>B.type===0?p.deserialize(N,B):k.deserialize(N,B)})(c||(e.ITestMessage=c={}));var m;(function(j){j.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),j.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(c.serialize)}),j.deserialize=(N,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>c.deserialize(N,W))})})(m||(e.ITestTaskState=m={}));const o="\0",n=(j,N)=>j+o+N;e.$iL=n;const i=j=>{const N=j.indexOf(o);return{ctrlId:j.slice(0,N),tagId:j.slice(N+1)}};e.$jL=i;var r;(function(j){j.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),j.deserialize=(N,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?N.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?O.$ct.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var s;(function(j){j[j.NotExpandable=0]="NotExpandable",j[j.Expandable=1]="Expandable",j[j.BusyExpanding=2]="BusyExpanding",j[j.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(j){j.serialize=N=>({expand:N.expand,item:r.serialize(N.item)}),j.deserialize=(N,B)=>({controllerId:A.$dL.root(B.item.extId),expand:B.expand,item:r.deserialize(N,B.item)})})(t||(e.InternalTestItem=t={}));var f;(function(j){j.serialize=N=>{let B;return N.item&&(B={},N.item.label!==void 0&&(B.label=N.item.label),N.item.tags!==void 0&&(B.tags=N.item.tags),N.item.busy!==void 0&&(B.busy=N.item.busy),N.item.uri!==void 0&&(B.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(B.range=N.item.range?.toJSON()),N.item.description!==void 0&&(B.description=N.item.description),N.item.error!==void 0&&(B.error=N.item.error),N.item.sortText!==void 0&&(B.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:B}},j.deserialize=N=>{let B;return N.item&&(B={},N.item.label!==void 0&&(B.label=N.item.label),N.item.tags!==void 0&&(B.tags=N.item.tags),N.item.busy!==void 0&&(B.busy=N.item.busy),N.item.range!==void 0&&(B.range=N.item.range?O.$ct.lift(N.item.range):null),N.item.description!==void 0&&(B.description=N.item.description),N.item.error!==void 0&&(B.error=N.item.error),N.item.sortText!==void 0&&(B.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:B}}})(f||(e.ITestItemUpdate=f={}));const d=(j,N)=>{N.expand!==void 0&&(j.expand=N.expand),N.item!==void 0&&(j.item=j.item?Object.assign(j.item,N.item):N.item)};e.$kL=d;var l;(function(j){j.serializeWithoutMessages=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(m.serializeWithoutMessages)}),j.serialize=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(m.serialize)}),j.deserialize=(N,B)=>({...t.deserialize(N,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>m.deserialize(N,W)),retired:!0})})(l||(e.TestResultItem=l={}));var a;(function(j){j.empty=()=>({covered:0,total:0}),j.sum=(N,B)=>{N.covered+=B.covered,N.total+=B.total}})(a||(e.ICoverageCount=a={}));var h;(function(j){j.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,uri:N.uri.toJSON()}),j.deserialize=(N,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:N.asCanonicalUri(u.URI.revive(B.uri))})})(h||(e.IFileCoverage=h={}));function g(j){return{...j,location:j.location?.toJSON()}}function S(j){return j.location=j.location?L.$bt.isIPosition(j.location)?L.$bt.lift(j.location):O.$ct.lift(j.location):void 0,j}e.$lL=3;var w;(function(j){j[j.Declaration=0]="Declaration",j[j.Statement=1]="Statement",j[j.Branch=2]="Branch"})(w||(e.DetailType=w={}));var E;(function(j){j.serialize=N=>N.type===0?D.serialize(N):P.serialize(N),j.deserialize=N=>N.type===0?D.deserialize(N):P.deserialize(N)})(E||(e.CoverageDetails=E={}));var y;(function(j){j.serialize=g,j.deserialize=S})(y||(e.IBranchCoverage=y={}));var D;(function(j){j.serialize=g,j.deserialize=S})(D||(e.IDeclarationCoverage=D={}));var P;(function(j){j.serialize=N=>({...g(N),branches:N.branches?.map(y.serialize)}),j.deserialize=N=>({...S(N),branches:N.branches?.map(y.deserialize)})})(P||(e.IStatementCoverage=P={}));var z;(function(j){j[j.Add=0]="Add",j[j.Update=1]="Update",j[j.DocumentSynced=2]="DocumentSynced",j[j.Remove=3]="Remove",j[j.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",j[j.Retire=5]="Retire",j[j.AddTag=6]="AddTag",j[j.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var F;(function(j){j.deserialize=(N,B)=>B.op===0?{op:B.op,item:t.deserialize(N,B.item)}:B.op===1?{op:B.op,item:f.deserialize(B.item)}:B.op===2?{op:B.op,uri:N.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,j.serialize=N=>N.op===0?{op:N.op,item:t.serialize(N.item)}:N.op===1?{op:N.op,item:f.serialize(N.item)}:N})(F||(e.TestsDiffOp=F={}));class T{constructor(N){this.l=N,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(N){const B=this.w();for(const W of N)switch(W.op){case 0:this.o(t.deserialize(this.l,W.item),B);break;case 1:this.p(f.deserialize(W.item),B);break;case 3:this.q(W.itemId,B);break;case 5:this.v(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this.f.set(W.tag.id,W.tag);break;case 7:this.f.delete(W.id);break}B.complete?.()}o(N,B){const W=A.$dL.parentId(N.item.extId)?.toString();let Y;if(!W)Y=this.x(N),this.h.add(Y),this.g.set(N.item.extId,Y);else if(this.g.has(W)){const _=this.g.get(W);_.children.add(N.item.extId),Y=this.x(N,_),this.g.set(N.item.extId,Y)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return B.add?.(Y),N.expand===2&&this.j++,Y}p(N,B){const W=this.g.get(N.extId);if(W)return N.expand!==void 0&&(W.expand===2&&this.j--,N.expand===2&&this.j++),(0,e.$kL)(W,N),B.update?.(W),W}q(N,B){const W=this.g.get(N);if(!W)return;const Y=A.$dL.parentId(W.item.extId)?.toString();Y?this.g.get(Y).children.delete(W.item.extId):this.h.delete(W);const _=[[N]];for(;_.length;)for(const J of _.pop()){const Z=this.g.get(J);Z&&(_.push(Z.children),this.g.delete(J),B.remove?.(Z,Z!==W),Z.expand===2&&this.j--)}}v(N){}updatePendingRoots(N){this.k+=N}w(){return{}}}e.$mL=T}),define(ke[112],Ee([1,0,8,4,3,61,89,67]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const v=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:v,label:v,description:v,error:v,sortText:v,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),p=(n,i)=>{let r;for(const[s,t]of I)t(n[s],i[s])||(r?r[s]=i[s]:r={[s]:i[s]});return r};class C extends O.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$uh(()=>this.flushDiff(),200)),this.g=this.B(new L.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,M.$kL)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,M.$kL)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(b.$dL.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const s of r.ops)this.w(i,s);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,A.$0c)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const s=b.$dL.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let f=this.tree.get(s.toString());if(!f){f={fullId:s,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(i)}}),this.I(i,f,r);return}if(f.actual===i){this.H(i,f,r);return}if(f.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,r);const d=this.s.getChildren(f.actual),l=f.actual,a=p(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,f.actual=i,f.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,s.toString()),delete a.tags),this.w(f,{op:4,update:a})),this.I(i,f,r);for(const[h,g]of d)this.s.getChildren(i).get(g.id)||this.O(b.$dL.joinToString(s,g.id));this.y(f.actual.uri)}C(i,r,s){const t=new Set(r.map(f=>f.id));for(const f of i)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(f=>(0,M.$iL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$iL)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$iL)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(i,r,s){this.H(i,r,s);for(const[t,f]of this.s.getChildren(i))this.z(f,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const s=[];for(const[t,f]of this.s.getChildren(i.actual)){const d=this.expand(b.$dL.joinToString(i.fullId,f.id),r);(0,u.$7g)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const f=new u.$hh;return f.open(),f}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$hh,s=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(f){s(f)}return(0,u.$7g)(t)?t.catch(s).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,d]of this.s.getChildren(t.actual))s.push(this.tree.get(b.$dL.joinToString(t.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$CO=C;class k extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$DO=k;class c extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$EO=c;class m extends Error{constructor(i,r,s){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$FO=m;const o=(n,i,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,f){for(const d of s.values())t.call(f,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const f=new Map,d=new Set(s.keys()),l={op:5,ops:[]};for(const a of t){if(!(a instanceof r))throw new c(a.id);const h=i(a).controllerId;if(h!==n.controllerId)throw new m(a.id,h,n.controllerId);if(f.has(a.id))throw new k(a.id);f.set(a.id,a),d.delete(a.id),l.ops.push({op:0,item:a})}for(const a of d.keys())l.ops.push({op:3,id:a});n.listener?.(l),s=f},add(t){if(!(t instanceof r))throw new c(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$GO=o}),define(ke[144],Ee([1,0,112]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0;const L=new WeakMap,O=(M,b)=>{const $={controllerId:b};return L.set(M,$),$};e.$HO=O;const A=M=>{const b=L.get(M);if(!b)throw new u.$EO(M?.id||"<unknown>");return b};e.$IO=A}),define(ke[113],Ee([1,0,15,2]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nzb=e.$mzb=e.$lzb=void 0,e.$ozb=O,e.$pzb=M,e.$lzb="vscode-cdn.net",e.$mzb=`vscode-resource.${e.$lzb}`,e.$nzb=`'self' https://*.${e.$lzb}`;function O(b,$){return b.scheme===u.Schemas.http||b.scheme===u.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===u.Schemas.file&&(b=L.URI.from({scheme:u.Schemas.vscodeRemote,authority:$.authority,path:b.path})),L.URI.from({scheme:u.Schemas.https,authority:`${b.scheme}+${A(b.authority)}.${e.$mzb}`,path:b.path,fragment:b.fragment,query:b.query}))}function A(b){return b.replace(/./g,$=>{const v=$.charCodeAt(0);return v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57?$:"-"+v.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,($,v)=>String.fromCharCode(parseInt(v,16)))}}),define(ke[297],Ee([1,0,4,3,113]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;class A{constructor(b,$,v){this.d=b,this.e=$,this.f=v,this.a=0,this.b=new L.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,v,R,I){let p;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){p=i;break}if(!p)throw new Error("not a visible editor");const C=this,k=this.a++,c=new u.$7d,m=new u.$7d,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,O.$ozb)(i,C.f)}get cspSource(){return O.$nzb}set options(i){this.b=i,C.d.$setOptions(k,i)}get options(){return this.b}set html(i){this.a=i,C.d.$setHtml(k,i)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(i){return C.d.$postMessage(k,i)}},n=new class{constructor(){this.editor=b,this.line=$,this.height=v,this.webview=o,this.onDidDispose=m.event}dispose(){C.c.has(k)&&(C.c.delete(k),C.d.$disposeEditorInset(k),m.fire(),m.dispose(),c.dispose())}};return this.d.$createEditorInset(k,p.id,p.value.document.uri,$+1,v,R||{},I.identifier,I.extensionLocation),this.c.set(k,{editor:b,inset:n,onDidReceiveMessage:c}),n}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$Ijc=A}),define(ke[145],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.$uL=e.$tL=void 0,e.$tL="__",e.$uL=(0,u.$ii)("IAuthenticationService"),e.$vL=(0,u.$ii)("IAuthenticationExtensionsService")}),define(ke[298],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=e.VariableKind=e.$yP=void 0,e.$yP=(0,u.$ii)("configurationResolverService");var L;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class O extends Error{constructor(M,b){super(b),this.variable=M}}e.$zP=O}),define(ke[299],Ee([1,0,17,50,18,24,11,103,239,298,14]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(C,k,c,m){this.h=new Map,this.a=C,this.b=k,this.g=c,m&&(this.c=m.then(o=>this.i(o)))}i(C){if(M.$i){const k=Object.create(null);return Object.keys(C).forEach(c=>{k[c.toLowerCase()]=C[c]}),k}return C}resolveWithEnvironment(C,k,c){return this.l({env:this.i(C),userHome:void 0},k?k.uri:void 0,c)}async resolveAsync(C,k){const c={env:await this.c,userHome:await this.g};return this.l(c,C?C.uri:void 0,k)}async j(C,k,c,m){const o=A.$On(k);M.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):M.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):M.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,C?C.uri:void 0,o,c,m)}async resolveAnyAsync(C,k,c){return this.j(C,k,c)}async resolveAnyMap(C,k,c){const m=new Map;return{newConfig:await this.j(C,k,c,m),resolvedVariables:m}}resolveWithInteractionReplace(C,k,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,k,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,k){if(this.h.has(C))throw new Error("Variable "+C+" is contributed twice.");this.h.set(C,k)}async l(C,k,c,m,o){if(O.$Vf(c))return this.m(C,k,c,m,o);if(Array.isArray(c))return Promise.all(c.map(n=>this.l(C,k,n,m,o)));if(O.$Xf(c)){const n=Object.create(null),i=await Promise.all(Object.keys(c).map(async r=>[await this.m(C,k,r,m,o),await this.l(C,k,c[r],m,o)]));for(const[r,s]of i)n[r]=s;return n}return c}m(C,k,c,m,o){return(0,R.$df)(c,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let r=await this.o(C,n,i,k,m);return o?.set(i,r),r!==n&&O.$Vf(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.m(C,k,r,m,o)),r})}n(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async o(C,k,c,m,o){let n;const i=c.split(":");i.length>1&&(c=i[0],n=i[1]);const r=f=>{const d=this.a.getFilePath();if(d)return(0,b.$hw)(d);throw new v.$zP(f,(0,$.localize)(0,null,k))},s=f=>{const d=r(f);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$hw)(l)}throw new v.$zP(f,(0,$.localize)(1,null,k,u.$oc(d)))},t=f=>{if(n){const d=this.a.getFolderUri(n);if(d)return d;throw new v.$zP(f,(0,$.localize)(2,null,k,n))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new v.$zP(f,(0,$.localize)(3,null,k)):new v.$zP(f,(0,$.localize)(4,null,k))};switch(c){case"env":if(n){if(C.env){const f=C.env[M.$i?n.toLowerCase():n];if(O.$Vf(f))return f}return""}throw new v.$zP(v.VariableKind.Env,(0,$.localize)(5,null,k));case"config":if(n){const f=this.a.getConfigurationValue(m,n);if(O.$5f(f))throw new v.$zP(v.VariableKind.Config,(0,$.localize)(6,null,k,n));if(O.$Xf(f))throw new v.$zP(v.VariableKind.Config,(0,$.localize)(7,null,k,n));return f}throw new v.$zP(v.VariableKind.Config,(0,$.localize)(8,null,k));case"command":return this.p(v.VariableKind.Command,k,n,o,"command");case"input":return this.p(v.VariableKind.Input,k,n,o,"input");case"extensionInstallFolder":if(n){const f=await this.a.getExtension(n);if(!f)throw new v.$zP(v.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,k,n));return this.n(f.extensionLocation)}throw new v.$zP(v.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,k));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,b.$hw)(this.n(t(v.VariableKind.WorkspaceFolder)));case"cwd":return m||n?(0,b.$hw)(this.n(t(v.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$hw)(u.$oc(this.n(t(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new v.$zP(v.VariableKind.UserHome,(0,$.localize)(11,null,k))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new v.$zP(v.VariableKind.LineNumber,(0,$.localize)(12,null,k))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new v.$zP(v.VariableKind.SelectedText,(0,$.localize)(13,null,k))}case"file":return r(v.VariableKind.File);case"fileWorkspaceFolder":return s(v.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(s(v.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||n?u.$mc(this.n(t(v.VariableKind.RelativeFile)),r(v.VariableKind.RelativeFile)):r(v.VariableKind.RelativeFile);case"relativeFileDirname":{const f=u.$nc(r(v.VariableKind.RelativeFileDirname));if(m||n){const d=u.$mc(this.n(t(v.VariableKind.RelativeFileDirname)),f);return d.length===0?".":d}return f}case"fileDirname":return u.$nc(r(v.VariableKind.FileDirname));case"fileExtname":return u.$pc(r(v.VariableKind.FileExtname));case"fileBasename":return u.$oc(r(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=u.$oc(r(v.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-u.$pc(f).length)}case"fileDirnameBasename":return u.$oc(u.$nc(r(v.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||k}case"execInstallFolder":{const f=this.a.getAppRoot();return f||k}case"pathSeparator":case"/":return u.sep;default:try{const f=n?`${c}:${n}`:c;return this.p(v.VariableKind.Unknown,k,f,o,void 0)}catch{return k}}}}p(C,k,c,m,o){if(c&&m){const n=o===void 0?m[c]:m[o+":"+c];if(typeof n=="string")return n;throw new v.$zP(C,(0,$.localize)(14,null,k))}return k}}e.$OP=I}),define(ke[146],Ee([1,0,5,142]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$AD=void 0,e.$BD=v,e.$CD=p,e.$DD=C,e.$AD=(0,u.$ii)("editorGroupsService");var O;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(O||(e.GroupDirection=O={}));var A;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var M;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function v(k){const c=k;return(0,L.$lF)(c?.editor)&&(0,L.$lF)(c?.replacement)}var R;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(k){const c=k;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function C(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[300],Ee([1,0,5,146]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HD=e.$GD=e.$FD=e.$ED=void 0,e.$ID=O,e.$ED=(0,u.$ii)("editorService"),e.$FD=-1,e.$GD=-2,e.$HD=-3;function O(A){const M=A;return typeof A=="number"||(0,L.$CD)(M)}}),define(ke[147],Ee([1,0,5,136]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=void 0,e.$OL=(0,u.$ji)(L.$pi)}),define(ke[148],Ee([1,0,25,4,17,3,8]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$b=e.$j$b=e.$i$b=e.$h$b=e.$g$b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$g$b=b;class ${static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const s=r.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new L.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(c),this.f=new u.$Fm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=m(this.e,i),this.e=this.e.concat(n);const r=$.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const a=i.getArcs(d);for(let h=0;h<a.length;h++)if(!l.has(a[h]))return!1;return!0}getNodes(){return this.e}},r=new u.$Fm;for(const d of n)if(r.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(u.$Dm.toKey(d.identifier),u.$Dm.toKey(l));const s=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>s.add(d));const t=i.getNodes().filter(d=>!s.has(d));let f;do{f=!1;for(let d=0;d<t.length;d++){const l=t[d];i.hasOnlyGoodArcs(l,s)&&(t.splice(d,1),d--,s.add(l),f=!0)}}while(f);return t.map(d=>r.get(d))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new v(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$h$b=$;class v{constructor(n,i){this.versionId=n,this.extensions=i}}e.$i$b=v;class R{constructor(n){this.d=new C,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new I(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$j$b=R;class I extends A.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$k$b=I;class p{constructor(n){this.name=n;const i=(0,M.$bh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class C{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new p(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,A.$Sc)(s))}}var k;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(k||(k={}));function c(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const s=O.$hc.basename(o.extensionLocation.path),t=O.$hc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function m(o,n){const i=new u.$Em(n);return o.filter(r=>!i.has(r.identifier))}}),define(ke[301],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.ExtHostConnectionType=void 0,e.$_m=b,e.$an=$;var u;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class L{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[L.ENV_KEY]=this.pipeName}}e.$9m=L;class O{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[O.ENV_KEY]="1"}}e.$0m=O;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[A.ENV_KEY]="1"}}e.$$m=A;function M(R){delete R[L.ENV_KEY],delete R[O.ENV_KEY],delete R[A.ENV_KEY]}function b(R,I){M(I),R.serialize(I)}function $(R){if(R[L.ENV_KEY])return v(R,new L(R[L.ENV_KEY]));if(R[O.ENV_KEY])return v(R,new O);if(R[A.ENV_KEY])return v(R,new A);throw new Error("No connection information defined in environment!")}function v(R,I){return M(R),I}}),define(ke[114],Ee([1,0,21]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Lm=M,e.$Mm=b;var L;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(L||(e.UIKind=L={}));var O;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(O||(e.ExtensionHostExitCode=O={}));var A;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function M(v){const R=u.$ue.alloc(1);switch(v){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}function b(v,R){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}var $;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Ee([1,0,5,4,12,28,114,86,87,24,2,3,225]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$5O=e.$4O=void 0,e.$6O=c;let C=class extends I.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new L.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$9o,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,O.$Qj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const r=this.getTelemetryDetails(),s=new k(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$um)((0,$.$cp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$4O=C,e.$4O=C=Je([qe(0,A.$3O),qe(1,O.$Pj)],C);class k{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,r,s,t,f){this.g=i,this.h=r,this.i=s,this.j=t,this.a=new L.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,$.$fp)(n,[]),this.c&&(n=(0,v.$Rn)(n,this.c)),this.b||(n=(0,v.$Rn)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,$.$fp)(i,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$5O=k;function c(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$7O=(0,u.$ii)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,270,140,25,5]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hG=e.ActivationKind=e.$eG=e.$dG=e.$aG=e.ExtensionHostStartup=e.$_F=e.$$F=e.$0F=e.$9F=void 0,e.$bG=p,e.$cG=C,e.$fG=o,e.$gG=n,e.$9F=Object.freeze({identifier:new M.$Dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$0F="extensions.webWorker",e.$$F=(0,b.$ii)("extensionService");class ${constructor(s){this.dependency=s}}e.$_F=$;var v;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(v||(e.ExtensionHostStartup=v={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,f){this.c=s,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$TF.createActivationEventsMap(this.d)}}set(s,t,f){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],l=[],a=[],h=[],g=I(this.d),S=I(t),w=(z,F)=>z.extensionLocation.toString()===F.extensionLocation.toString()||z.isBuiltin===F.isBuiltin||z.isUserBuiltin===F.isUserBuiltin||z.isUnderDevelopment===F.isUnderDevelopment;for(const z of this.d){const F=S.get(z.identifier);if(!F){d.push(z.identifier),g.delete(z.identifier);continue}if(!w(z,F)){d.push(z.identifier),g.delete(z.identifier);continue}}for(const z of t){const F=g.get(z.identifier);if(!F){l.push(z);continue}if(!w(F,z)){d.push(F.identifier),g.delete(F.identifier);continue}}const E=new M.$Em(this.e),y=new M.$Em(f);for(const z of this.e)y.has(z)||a.push(z);for(const z of f)E.has(z)||h.push(z);const D=A.$TF.createActivationEventsMap(l),P={versionId:s,toRemove:d,toAdd:l,addActivationEvents:D,myToRemove:a,myToAdd:h};return this.delta(P),P}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:d,myToAdd:l}=s,a=new M.$Em(t),h=new M.$Em(d);for(let g=0;g<this.d.length;g++)a.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)h.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of f)this.d.push(g);for(const g of l)this.e.push(g);return this.f=null,s}containsExtension(s){for(const t of this.e)if(M.$Dm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=A.$TF.readActivationEvents(t);for(const d of f)s.add(d)}return s}}e.$aG=R;function I(r){const s=new M.$Fm;for(const t of r)s.set(t.identifier,t);return s}function p(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}function C(r,s){if(!p(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class k{constructor(s,t,f,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=d}}e.$dG=k;class c{constructor(s,t){this.description=s,this.value=t}}e.$eG=c;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,O.$lp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,s){return{identifier:new M.$Dm((0,O.$jp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$hG=i}),define(ke[302],Ee([1,0,13,148,25,26,12,8]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=e.$9jc=e.$8jc=e.$7jc=e.$6jc=e.$5jc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,n,i,r){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$5jc=$;class v{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$6jc=v;class R{constructor(o,n,i,r,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=s,this.subscriptions=t}}e.$7jc=R;class I extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8jc=I;class p extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9jc=p;class C extends R{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(o,n,i,r){this.g=r,this.a=o,this.b=n,this.c=i,this.d=new O.$Fm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new C(s));return this.c.onExtensionActivationError(o.id,s,new A.$_F(o.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(s);if(f){if(!f.main&&!f.browser)continue;i.push(this.j({id:f.identifier,reason:o.reason}));continue}const d=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),a=this.k(o,n.displayName,[],new C(l));return this.c.onExtensionActivationError(n.identifier,l,new A.$_F(s)),a}return this.k(o,n.displayName,i,null)}k(o,n,i,r){const s=new c(o.id,n,o.reason,i,r,this.c,this.g);return this.d.set(o.id,s),s}l(o){return L.$h$b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$0jc=k,e.$0jc=k=Je([qe(3,M.$Oj)],k);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,r,s,t,f){this.c=o,this.d=n,this.f=i,this.g=r,this.h=s,this.j=t,this.k=f,this.a=new b.$hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new C(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new C(n),this.b&&u.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};c=Je([qe(6,M.$Oj)],c)}),define(ke[303],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[304],Ee([1,0,241,13,40,137,109,37,25,303,139,140]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=void 0;const p=b.$1n.as(M.$2n.JSONContribution);class C{constructor(s,t,f){this.a=s,this.b=t,this.c=f}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(O.default.Error,s)}warn(s){this.d(O.default.Warning,s)}info(s){this.d(O.default.Info,s)}}e.$3F=C;class k{static a(s){const t=new $.$Em;for(let f=0,d=s.length;f<d;f++)t.add(s[f].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new k(t,[]);if(!t||!t.length)return new k([],s);const f=this.a(s),d=this.a(t),l=t.filter(h=>!f.has(h.description.identifier)),a=s.filter(h=>!d.has(h.description.identifier));return new k(l,a)}constructor(s,t){this.added=s,this.removed=t}}e.$4F=k;class c{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=k.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,L.$1)(s)}}}e.$5F=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$6F={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Cm},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Fo}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Fo}},extensionKind:{description:u.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new c(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&I.$TF.register(s.extensionPoint,s.activationEventsGenerator),e.$6F.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,p.registerSchema(o,e.$6F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$7F=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$1n.add(i.ExtensionsRegistry,new n),e.$8F=b.$1n.as(i.ExtensionsRegistry),p.registerSchema(o,e.$6F),p.registerSchema(R.$9j,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}}]}}}})}),define(ke[305],Ee([1,0,237,18,24,304,41,4]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var v;(function(p){function C(k,c,m){if(!k)return;const o=L.$Vf(k.type)?k.type:void 0;if(!o||o.length===0){m.error(u.localize(3,null));return}const n=[];if(Array.isArray(k.required))for(const i of k.required)L.$Vf(i)&&n.push(i);return{extensionId:c.value,taskType:o,required:n,properties:k.properties?O.$On(k.properties):{},when:k.when?M.$gj.deserialize(k.when):void 0}}p.from=C})(v||(v={}));const R=A.$8F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,C)=>{for(const k of p)k.type&&C.push(`onTaskType:${k.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:$}});class I{constructor(){this.d=new b.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,k)=>{R.setHandler((c,m)=>{this.c=void 0;try{for(const o of m.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of m.added){const n=o.value;for(const i of n){const r=v.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const k of this.all()){const c={type:"object",additionalProperties:!1};k.required.length>0&&(c.required=k.required.slice(0)),k.properties!==void 0?c.properties=O.$On(k.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[k.taskType]},C.push(c)}this.c={oneOf:C}}return this.c}}e.$xH=new I}),define(ke[306],Ee([1,0,238,18,23,24,41,305]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HH=e.JsonSchemaVersion=e.ExecutionEngine=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BH=e.ShellQuoting=e.$AH=e.$zH=e.$yH=void 0,e.$yH="settings",e.$zH=new M.$zj("taskRunning",!1,u.localize(0,null)),e.$AH=u.localize2(2,"Tasks");var $;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$BH="$customized",function(j){function N(B){if(!B)return j.Strong;switch(B.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=N}($||(e.ShellQuoting=$={}));var v;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(v||(e.CommandOptions=v={}));var R;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(R||(e.RevealKind=R={})),function(j){function N(B){switch(B.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=N}(R||(e.RevealKind=R={}));var I;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(j){function N(B){switch(B.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=N}(I||(e.RevealProblemKind=I={}));var p;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(p||(e.PanelKind=p={})),function(j){function N(B){switch(B.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=N}(p||(e.PanelKind=p={}));var C;(function(j){j.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(C||(e.PresentationOptions=C={}));var k;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(j){function N(W){switch(W.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=N;function B(W){switch(W){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=B}(k||(e.RuntimeType=k={}));var c;(function(j){function N(B){return L.$Vf(B)?B:B.value}j.value=N})(c||(e.CommandString=c={}));var m;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function N(W){return W===j.Clean._id||W===j.Build._id||W===j.Rebuild._id||W===j.Test._id}j.is=N;function B(W){if(W!==void 0)return L.$Vf(W)?N(W)?{_id:W,isDefault:!1}:void 0:W}j.from=B})(m||(e.TaskGroup=m={}));var o;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function N(B){switch(B){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var i;(function(j){j.parallel="parallel",j.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(N,B,W,Y,_,J){this._label="",this._id=N,B&&(this._label=B),W&&(this.type=W),this.runOptions=Y,this.configurationProperties=_,this._source=J}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,B=!1){if(N===void 0)return!1;if(L.$Vf(N))return N===this._label||N===this.configurationProperties.identifier||B&&N===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$CH=t;class f extends t{constructor(N,B,W,Y,_,J,Z,re){super(N,W,void 0,Z,re,B),this.command={},this._source=B,this.hasDefinedMatchers=J,_&&(this.command=_)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case k.Shell:B="shell";break;case k.Process:B="process";break;case k.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(N){return N instanceof f}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$yH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$BH,folder:N,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?O.$Sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new f(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$DH=f;class d extends t{constructor(N,B,W,Y,_,J,Z){super(N,W,Y,J,Z,B),this._source=B,this.configures=_}static is(N){return N instanceof d}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?O.$Sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$yH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$BH,folder:N,id:B};return JSON.stringify(W)}}e.$EH=d;class l extends t{constructor(N,B,W,Y,_,J,Z,re,ee){super(N,W,Y,re,ee,B),this.defines=_,this.hasDefinedMatchers=Z,this.command=J,this.icon=ee.icon,this.hide=ee.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof l}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new l(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$FH=l;class a extends t{constructor(N,B,W,Y,_,J){super(N,W,Y,_,J,B),this._source=B}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new a(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$GH=a;var h;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(j){j._default=j.Terminal}(h||(e.ExecutionEngine=h={}));var g;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class S{constructor(N){this.c=new Map;for(let B=0;B<N.length;B++)this.c.set(N[B].uri.toString(),B)}compare(N,B){const W=N.getWorkspaceFolder(),Y=B.getWorkspaceFolder();if(W&&Y){let _=this.c.get(W.uri.toString());_=_===void 0?0:_+1;let J=this.c.get(Y.uri.toString());return J=J===void 0?0:J+1,_===J?N._label.localeCompare(B._label):_-J}else return!W&&Y?-1:W&&!Y?1:0}}e.$HH=S;var w;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(w||(e.TaskEventKind=w={}));var E;(function(j){j.SingleRun="singleRun",j.Background="background"})(E||(e.TaskRunType=E={}));var y;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var D;(function(j){function N(re){return{taskId:re._id,taskName:re.configurationProperties.name,runType:re.configurationProperties.isBackground?"background":"singleRun",group:re.configurationProperties.group,__task:re}}function B(re,ee,pe){return{...N(re),kind:"start",terminalId:ee,resolvedVariables:pe}}j.start=B;function W(re,ee,pe){return{...N(re),kind:"processStarted",terminalId:ee,processId:pe}}j.processStarted=W;function Y(re,ee,pe){return{...N(re),kind:"processEnded",terminalId:ee,exitCode:pe}}j.processEnded=Y;function _(re,ee,pe){return{...N(re),kind:"terminated",exitReason:pe,terminalId:ee}}j.terminated=_;function J(re,ee,pe){return{...N(ee),kind:re,terminalId:pe}}j.general=J;function Z(){return{kind:"changed"}}j.changed=Z})(D||(e.TaskEvent=D={}));var P;(function(j){function N(W){const Y=Object.keys(W).sort();let _="";for(const J of Y){let Z=W[J];Z instanceof Object?Z=N(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),_+=J+","+Z+","}return _}function B(W){const _={_key:N(W),type:W.taskType};return Object.assign(_,W),_}j.create=B})(P||(e.KeyedTaskIdentifier=P={}));var z;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var F;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var T;(function(j){function N(B,W){const Y=b.$xH.get(B.type);if(Y===void 0){const re=A.$On(B);return delete re._key,P.create(re)}const _=Object.create(null);_.type=Y.taskType;const J=new Set;Y.required.forEach(re=>J.add(re));const Z=Y.properties;for(const re of Object.keys(Z)){const ee=B[re];if(ee!=null)_[re]=ee;else if(J.has(re)){const pe=Z[re];if(pe.default!==void 0)_[re]=A.$On(pe.default);else switch(pe.type){case"boolean":_[re]=!1;break;case"number":case"integer":_[re]=0;break;case"string":_[re]="";break;default:W.error(u.localize(1,null,JSON.stringify(B,void 0,0),re));return}}}return P.create(_)}j.createTaskIdentifier=N})(T||(e.TaskDefinition=T={}))}),define(ke[307],Ee([1,0,13]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=e.$l$b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,u.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$l$b=L;class O extends L{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$m$b=O}),define(ke[68],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$bw=void 0,e.$cw=O,e.$dw=A;class u{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++u.count}}e.$bw=u;const L=[];function O(b){const $=new u(b);return L[$.nid]=$,$}function A(b){return L[b].sid}class M{constructor($){this.value=$}}e.$ew=M}),define(ke[6],Ee([1,0,68]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$qM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var O;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(O||(e.TabInputKind=O={}));var A;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var M;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var v;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(v||(e.NotebookEditorRevealType=v={}));var R;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(m){return m._id=I.a++,m}}e.$qM=I;var p;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var C;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var k;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$rM={MainThreadAuthentication:(0,u.$cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$cw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$cw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$cw)("MainThreadClipboard"),MainThreadCommands:(0,u.$cw)("MainThreadCommands"),MainThreadComments:(0,u.$cw)("MainThreadComments"),MainThreadConfiguration:(0,u.$cw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$cw)("MainThreadConsole"),MainThreadDebugService:(0,u.$cw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$cw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$cw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$cw)("MainThreadLanguages"),MainThreadLogger:(0,u.$cw)("MainThreadLogger"),MainThreadMessageService:(0,u.$cw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$cw)("MainThreadOutputService"),MainThreadProgress:(0,u.$cw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$cw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$cw)("MainThreadSecretState"),MainThreadStorage:(0,u.$cw)("MainThreadStorage"),MainThreadSpeech:(0,u.$cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$cw)("MainThreadTerminalService"),MainThreadWebviews:(0,u.$cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$cw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$cw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$cw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$cw)("MainThreadSCM"),MainThreadSearch:(0,u.$cw)("MainThreadSearch"),MainThreadShare:(0,u.$cw)("MainThreadShare"),MainThreadTask:(0,u.$cw)("MainThreadTask"),MainThreadWindow:(0,u.$cw)("MainThreadWindow"),MainThreadLabelService:(0,u.$cw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$cw)("MainThreadInteractive"),MainThreadChat:(0,u.$cw)("MainThreadChat"),MainThreadInlineChat:(0,u.$cw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$cw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$cw)("MainThreadTimeline"),MainThreadTesting:(0,u.$cw)("MainThreadTesting"),MainThreadLocalization:(0,u.$cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$cw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,u.$cw)("MainThreadIssueReporter")},e.$sM={ExtHostCommands:(0,u.$cw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$cw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$cw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$cw)("ExtHostStatusBar"),ExtHostShare:(0,u.$cw)("ExtHostShare"),ExtHostExtensionService:(0,u.$cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$cw)("ExtHostTerminalService"),ExtHostSCM:(0,u.$cw)("ExtHostSCM"),ExtHostSearch:(0,u.$cw)("ExtHostSearch"),ExtHostTask:(0,u.$cw)("ExtHostTask"),ExtHostWorkspace:(0,u.$cw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$cw)("ExtHostWindow"),ExtHostWebviews:(0,u.$cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$cw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$cw)("ExtHostProgress"),ExtHostComments:(0,u.$cw)("ExtHostComments"),ExtHostSecretState:(0,u.$cw)("ExtHostSecretState"),ExtHostStorage:(0,u.$cw)("ExtHostStorage"),ExtHostUrls:(0,u.$cw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$cw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$cw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$cw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$cw)("ExtHostInlineChatShape"),ExtHostChat:(0,u.$cw)("ExtHostChat"),ExtHostChatAgents2:(0,u.$cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$cw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$cw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$cw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$cw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$cw)("ExtHostTimeline"),ExtHostTesting:(0,u.$cw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$cw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$cw)("ExtHostLocalization"),ExtHostIssueReporter:(0,u.$cw)("ExtHostIssueReporter")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=e.$pjc=e.$ojc=void 0,e.$ojc=(0,u.$ii)("IExtHostApiDeprecationService");let M=class{constructor($,v){this.c=v,this.a=new Set,this.b=$.getProxy(O.$rM.MainThreadTelemetry)}report($,v,R){const I=this.d($,v);this.a.has(I)||(this.a.add(I),v.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:v.identifier.value,apiId:$}))}d($,v){return`${$}-${v.identifier.value}`}};e.$pjc=M,e.$pjc=M=Je([qe(0,A.$MO),qe(1,L.$Oj)],M),e.$qjc=Object.freeze(new class{report(b,$,v){}})}),define(ke[308],Ee([1,0,38,3,6]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=void 0;class A{static{this.a=0}constructor($,v){this.extension=$,this.provider=v,this.handle=A.a++}}class M{static{this.a=0}constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(O.$rM.MainThreadChat)}registerChatProvider($,v,R){const I=new A($,R);return this.b.set(I.handle,I),this.d.$registerChatProvider(I.handle,v),(0,L.$Sc)(()=>{this.d.$unregisterChatProvider(I.handle),this.b.delete(I.handle)})}transferChatSession($,v){const R=u.Iterable.find(this.c.keys(),I=>this.c.get(I)===$)??0;typeof R=="number"&&this.d.$transferChatSession(R,v)}async $prepareChat($,v){const R=this.b.get($);if(!R)return;const I=await R.provider.prepareSession(v);if(!I)return;const p=M.a++;return this.c.set(p,I),{id:p}}$releaseSession($){this.c.delete($)}}e.$Bjc=M}),define(ke[309],Ee([1,0,6]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class L{constructor(A){const M=A.getProxy(u.$rM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$Gjc=L}),define(ke[310],Ee([1,0,24,6,28,20]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;let M=class{constructor(R,I){this.a=R.getProxy(L.$rM.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,I){const p=this,C=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){p.e(R,I,C,arguments)}})}e(R,I,p,C){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:$(C,this.b)}),this.c&&this.f(R,p,C)}};e.$xlc=M,e.$xlc=M=Je([qe(0,A.$MO),qe(1,O.$3O)],M);const b=1e5;function $(v,R){const I=[];if(v.length)for(let p=0;p<v.length;p++){let C=v[p];if(typeof C>"u")C="undefined";else if(C instanceof Error){const k=C;k.stack?C=k.stack:C=k.toString()}I.push(C)}if(R){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,u.$Tn)(I);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(ke[311],Ee([1,0,2,6,26]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0;class A{constructor(b){this.a=b.getProxy(L.$rM.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,O.$cG)(b,"showLocal"),this.a.$showOpenDialog($).then(v=>v?v.map(R=>u.URI.revive(R)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?u.URI.revive($):void 0)}}e.$Bkc=A}),define(ke[312],Ee([1,0,3,6]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=void 0;class O{constructor(M){this.b=0,this.a=M.getProxy(L.$rM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Wkc=O}),define(ke[115],Ee([1,0,11,14,2,5,12,6,28,20]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=e.$jkc=void 0;let R=class{constructor(p,C,k){this.f=k,this.d=new Map,this.a=C.getProxy(b.$rM.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===u.$g}getMessage(p,C){const{message:k,args:c,comment:m}=C;if(this.c)return(0,L.$We)(k,c??{});let o=k;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const n=this.d.get(p)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,L.$We)(n??k,c??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let C;const k=await this.g(p);if(!k){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(k),m=JSON.parse(c);C=p.isBuiltin?m.contents?.bundle:m}catch(c){this.f.error(`Failed to load translations for ${p.identifier.value} from ${k}: ${c.message}`);return}C&&this.d.set(p.identifier.value,{contents:C,uri:k})}async g(p){if(p.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return O.URI.revive(C)}return p.l10n?O.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$jkc=R,e.$jkc=R=Je([qe(0,$.$3O),qe(1,v.$MO),qe(2,M.$Oj)],R),e.$kkc=(0,A.$ii)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,28,20,2,57]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;let $=class extends u.$Zj{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(C=>(0,b.$Rh)(C))),this.r=I.getProxy(L.$rM.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(M.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,C){return new v(this.r,I,p,C)}};e.$wlc=$,e.$wlc=$=Je([qe(0,A.$MO),qe(1,O.$3O)],$);class v extends u.$Uj{constructor(I,p,C,k){super(k?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(C),this.r.$createLogger(p,k).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const C=[[I,p]];this.m?this.u(C):this.n.push(...C)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=e.$lkc=void 0,e.$lkc=(0,L.$ii)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(u.$rM.MainThreadManagedSockets)}setFactory(I,p){for(const C of this.d.values())C.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,C=await this.c.makeConnection(),k=new O.$Tc;return this.d.set(p,new v(p,C,k)),k.add((0,O.$Sc)(()=>this.d.delete(p))),k.add(C.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),k.dispose()})),k.add(C.onDidClose(c=>{this.a.$onDidManagedSocketClose(p,c?.stack??c?.message),k.dispose()})),k.add(C.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(p,M.$ue.wrap(c)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$mkc=b,e.$mkc=b=Je([qe(0,A.$MO)],b);class ${constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class v extends O.$Uc{constructor(I,p,C){super(),this.socketId=I,this.actual=p,this.B(C)}}}),define(ke[313],Ee([1,0,6,12,26]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=void 0;function A(b){return b&&b.title}let M=class{constructor($,v){this.b=v,this.a=$.getProxy(u.$rM.MainThreadMessageService)}showMessage($,v,R,I,p){const C={source:{identifier:$.identifier,label:$.displayName||$.name}};let k;typeof I=="string"||A(I)?k=[I,...p]:(C.modal=I?.modal,C.useCustom=I?.useCustom,C.detail=I?.detail,k=p),C.useCustom&&(0,O.$cG)($,"resolvers");const c=[];let m=!1;for(let o=0;o<k.length;o++){const n=k[o];if(typeof n=="string")c.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;c.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(v,R,C,c).then(o=>{if(typeof o=="number")return k[o]})}};e.$Ykc=M,e.$Ykc=M=Je([qe(1,L.$Oj)],M)}),define(ke[314],Ee([1,0,3,18,2,26,6]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=void 0;class b{constructor(v){this.b=new Map,this.a=v.getProxy(M.$rM.MainThreadProfileContentHandlers)}registerProfileContentHandler(v,R,I){if((0,A.$cG)(v,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,v.identifier.value),(0,u.$Sc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(v,R,I,p){const C=this.b.get(v);if(!C)throw new Error(`Unknown handler with id: ${v}`);return C.saveProfile(R,I,p)}async $readProfile(v,R,I){const p=this.b.get(v);if(!p)throw new Error(`Unknown handler with id: ${v}`);return p.readProfile((0,L.$Vf)(R)?R:O.URI.revive(R),I)}}e.$8kc=b}),define(ke[117],Ee([1,0,6,4,5]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=e.$gkc=void 0;class A{constructor(b){this.b=new L.$7d,this.onDidChangePassword=this.b.event,this.a=b.getProxy(u.$rM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,v){return this.a.$setPassword(b,$,v)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$gkc=A,e.$hkc=(0,O.$ii)("IExtHostSecretState")}),define(ke[315],Ee([1,0,22,3,6]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class A{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(O.$rM.MainThreadSpeech)}async $createSpeechToTextSession(b,$,v){const R=this.c.get(b);if(!R)return;const I=new L.$Tc,p=new u.$ee;this.d.set($,p);const C=I.add(R.provideSpeechToTextSession(p.token,v?{language:v}:void 0));I.add(C.onDidChange(k=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,k)})),I.add(p.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,$){const v=this.c.get(b);if(!v)return;const R=new L.$Tc,I=new u.$ee;this.d.set($,I);const p=R.add(v.provideKeywordRecognitionSession(I.token));R.add(p.onDidChange(C=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,C)})),R.add(I.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,v){const R=A.a++;return this.c.set(R,v),this.b.$registerProvider(R,$,{extension:b,displayName:b.value}),(0,L.$Sc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$clc=A}),define(ke[118],Ee([1,0,6,4,5]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=e.$$jc=void 0;class A{constructor(b,$){this.c=$,this.b=new L.$7d,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(u.$rM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,v){const R=await this.a.$initializeExtensionStorage(b,$);let I;return R&&(I=this.d(b,$,R)),I||v}setValue(b,$,v){return this.a.$setValue(b,$,v)}$acceptValue(b,$,v){const R=this.d(b,$,v);R&&this.b.fire({shared:b,key:$,value:R})}d(b,$,v){try{return JSON.parse(v)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${R}`)}}}e.$$jc=A,e.$_jc=(0,O.$ii)("IExtHostStorage")}),define(ke[316],Ee([1,0,3,15,2,6]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;class M{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(A.$rM.MainThreadUriOpeners)}registerExternalUriOpener($,v,R,I){if(this.c.has(v))throw new Error(`Opener with id '${v}' already registered`);const p=I.schemes.find(C=>!M.a.has(C));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(v,R),this.b.$registerUriOpener(v,I.schemes,$,I.label),(0,u.$Sc)(()=>{this.c.delete(v),this.b.$unregisterUriOpener(v)})}async $canOpenUri($,v,R){const I=this.c.get($);if(!I)throw new Error(`Unknown opener with id: ${$}`);const p=O.URI.revive(v);return I.canOpenExternalUri(p,R)}async $openUri($,v,R){const I=this.c.get($);if(!I)throw new Error(`Unknown opener id: '${$}'`);return I.openExternalUri(O.URI.revive(v.resolvedUri),{sourceUri:O.URI.revive(v.sourceUri)},R)}}e.$qlc=M}),define(ke[317],Ee([1,0,6,2,3,13,25]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class b{static{this.a=0}constructor(v){this.c=new M.$Em,this.d=new Map,this.b=v.getProxy(u.$rM.MainThreadUrls)}registerUriHandler(v,R){const I=v.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=b.a++;return this.c.add(I),this.d.set(p,R),this.b.$registerUriHandler(p,I,v.displayName||v.name),(0,O.$Sc)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(v,R){const I=this.d.get(v);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(R))}catch(p){(0,A.$1)(p)}return Promise.resolve(void 0)}async createAppUri(v){return L.URI.revive(await this.b.$createAppUri(v))}}e.$rlc=b}),define(ke[92],Ee([1,0,4,3,15,24,2,245,283,113,6]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=e.$Vjc=void 0,e.$Wjc=p,e.$Yjc=c,e.$Zjc=m;class I{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,s,t,f,d,l,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$7d,this._onDidDispose=this.#h.event,this.#e=r,this.#t=s,this.#o=t,this.#n=f,this.#s=d,this.#r=l,this.#l=p(l),this.#d=C(l),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,v.$ozb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===O.Schemas.https||r.scheme===O.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+v.$nzb}return v.$nzb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),A.$Sn(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,$.$_nb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const s=this.#r.extensionLocation?.scheme===O.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===O.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,a,h,g)=>{const S=M.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),w=(0,v.$ozb)(S,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,a,h,g)=>{const S=M.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),w=(0,v.$ozb)(S,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`})}}e.$Vjc=I;function p(i){try{const r=(0,b.$up)((0,b.$tp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function C(i){try{const r=(0,b.$up)((0,b.$tp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class k extends L.$Uc{constructor(r,s,t,f,d){super(),this.c=s,this.f=t,this.g=f,this.h=d,this.b=new Map,this.a=r.getProxy(R.$rM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,s,t){const f=this.j(r);if(f){const{message:d}=(0,$.$aob)(s,t.value);f._onMessageEmitter.fire(d)}}$onMissingCsp(r,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const f=new I(r,this.a,o(s),this.c,this.f,t,this.h);this.b.set(r,f);const d=f._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Xjc=k;function c(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>M.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(he,e,u,L,O,A,M,b,$,v){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=void 0;let I=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(C){const k=this.d;return{get focused(){return k.focused},get active(){return(0,v.$cG)(C,"windowActivity"),k.active}}}constructor(C){this.c=new u.$7d,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=C.getProxy(L.$rM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:c})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(C){this.onDidChangeWindowProperty("focused",C)}$onDidChangeWindowActive(C){this.onDidChangeWindowProperty("active",C)}onDidChangeWindowProperty(C,k){k!==this.d[C]&&(this.d={...this.d,[C]:k},this.c.fire(this.d))}openUri(C,k){let c;if(typeof C=="string"){c=C;try{C=O.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,M.$Ue)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this.b.$openUri(C,c,k)}async asExternalUri(C,k){if((0,M.$Ue)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(C,k);return O.URI.from(c)}};e.$tlc=I,e.$tlc=I=R=Je([qe(0,$.$MO)],I),e.$ulc=(0,b.$ii)("IExtHostWindow")}),define(ke[318],Ee([1,0,310,28,20]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;const A=1024*1024;let M=class extends u.$xlc{constructor($,v){super($,v),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,v,R){const I=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),v.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j($,v){const R=process[$],I=R.write;let p="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(C,k,c)=>{if(!this.g){p+=C.toString(k);const m=p.length>A?p.length:p.lastIndexOf(`
`);m!==-1&&(console[v](p.slice(0,m)),p=p.slice(m+1))}I.call(R,C,k,c)}})}};e.$9lc=M,e.$9lc=M=Je([qe(0,O.$MO),qe(1,L.$3O)],M)}),define(ke[319],Ee([1,0,149,15,260,30]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;class M extends u.$wlc{s($,v,R){return $.scheme===L.Schemas.file?new O.$ZP(R?.name||(0,A.$Eg)(),$.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,v):super.s($,v,R)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$imc=M}),define(ke[320],Ee([1,0,8,21,22,13,4,3,133,307,68]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$p$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$n$b=m,e.$o$b=o;function p(y,D){try{return JSON.stringify(y,D)}catch{return"null"}}const C="$$ref$$",k={[C]:-1};class c{constructor(D,P){this.jsonString=D,this.referencedBuffers=P}}function m(y,D=null,P=!1){const z=[];return{jsonString:(P?p:JSON.stringify)(y,(T,j)=>{if(typeof j>"u")return k;if(typeof j=="object"){if(j instanceof L.$ue){const N=z.push(j)-1;return{[C]:N}}if(D)return D(T,j)}return j}),referencedBuffers:z}}function o(y,D,P){return JSON.parse(y,(z,F)=>{if(F){const T=F[C];if(typeof T=="number")return D[T];if(P&&F.$mid===1)return P.transformIncoming(F)}return F})}function n(y,D){return JSON.stringify(y,D)}function i(y){return y?(D,P)=>P&&P.$mid===1?y.transformOutgoing(P):P:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends b.$Uc{static{I=f}static{this.a=3*1e3}constructor(D,P=null,z=null){super(),this[I]=!0,this.b=this.B(new M.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=D,this.f=P,this.g=z,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,T=R.$bw.count;F<T;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$uh(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(D=>{const P=this.w[D];delete this.w[D],P.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(D){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(D){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(D){this.y!==D&&(this.y=D,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(D){return this.g?(0,$.$nn)(D,this.g):D}getProxy(D){const{nid:P,sid:z}=D;return this.s[P]||(this.s[P]=this.J(P,z)),this.s[P]}J(D,P){const z={get:(F,T)=>(typeof T=="string"&&!F[T]&&T.charCodeAt(0)===36&&(F[T]=(...j)=>this.U(D,T,j)),T===d?P:F[T])};return new Proxy(Object.create(null),z)}set(D,P){return this.m[D.nid]=P,P}assertRegistered(D){for(let P=0,z=D.length;P<z;P++){const F=D[P];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(D){if(this.j)return;const P=D.byteLength,z=h.read(D,0),F=z.readUInt8(),T=z.readUInt32();switch(F){case 1:case 2:{let{rpcId:j,method:N,args:B}=S.deserializeRequestJSONArgs(z);this.g&&(B=(0,$.$nn)(B,this.g)),this.M(P,T,j,N,B,F===2);break}case 3:case 4:{let{rpcId:j,method:N,args:B}=S.deserializeRequestMixedArgs(z);this.g&&(B=(0,$.$nn)(B,this.g)),this.M(P,T,j,N,B,F===4);break}case 5:{this.f?.logIncoming(P,T,0,"ack"),this.G(T);break}case 6:{this.N(P,T);break}case 7:{this.O(P,T,void 0);break}case 9:{let j=S.deserializeReplyOKJSON(z);this.g&&(j=(0,$.$nn)(j,this.g)),this.O(P,T,j);break}case 10:{const j=S.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(P,T,j);break}case 8:{const j=S.deserializeReplyOKVSBuffer(z);this.O(P,T,j);break}case 11:{let j=S.deserializeReplyErrError(z);this.g&&(j=(0,$.$nn)(j,this.g)),this.P(P,T,j);break}case 12:{this.P(P,T,void 0);break}default:console.error("received unexpected message"),console.error(D)}}M(D,P,z,F,T,j){this.f?.logIncoming(D,P,1,`receiveRequest ${(0,R.$dw)(z)}.${F}(`,T);const N=String(P);let B,W;if(j){const _=new O.$ee;T.push(_.token),B=this.Q(z,F,T),W=()=>_.cancel()}else B=this.Q(z,F,T),W=t;this.u[N]=W;const Y=S.serializeAcknowledged(P);this.f?.logOutgoing(Y.byteLength,P,1,"ack"),this.c.send(Y),B.then(_=>{delete this.u[N];const J=S.serializeReplyOK(P,_,this.h);this.f?.logOutgoing(J.byteLength,P,1,"reply:",_),this.c.send(J)},_=>{delete this.u[N];const J=S.serializeReplyErr(P,_);this.f?.logOutgoing(J.byteLength,P,1,"replyErr:",_),this.c.send(J)})}N(D,P){this.f?.logIncoming(D,P,1,"receiveCancel");const z=String(P);this.u[z]?.()}O(D,P,z){this.f?.logIncoming(D,P,0,"receiveReply:",z);const F=String(P);if(!this.w.hasOwnProperty(F))return;const T=this.w[F];delete this.w[F],T.resolveOk(z)}P(D,P,z){this.f?.logIncoming(D,P,0,"receiveReplyErr:",z);const F=String(P);if(!this.w.hasOwnProperty(F))return;const T=this.w[F];delete this.w[F];let j;z&&(z.$isError?(j=new Error,j.name=z.name,j.message=z.message,j.stack=z.stack):j=z),T.resolveErr(j)}Q(D,P,z){try{return Promise.resolve(this.S(D,P,z))}catch(F){return Promise.reject(F)}}S(D,P,z){const F=this.m[D];if(!F)throw new Error("Unknown actor "+(0,R.$dw)(D));const T=F[P];if(typeof T!="function")throw new Error("Unknown method "+P+" on actor "+(0,R.$dw)(D));return T.apply(F,z)}U(D,P,z){if(this.j)return new v.$m$b;let F=null;if(z.length>0&&O.CancellationToken.isCancellationToken(z[z.length-1])&&(F=z.pop()),F&&F.isCancellationRequested)return Promise.reject(A.$6());const T=S.serializeRequestArguments(z,this.h),j=++this.t,N=String(j),B=new v.$l$b,W=new b.$Tc;F&&W.add(F.onCancellationRequested(()=>{const _=S.serializeCancel(j);this.f?.logOutgoing(_.byteLength,j,0,"cancel"),this.c.send(S.serializeCancel(j))})),this.w[N]=new a(B,W),this.F(j);const Y=S.serializeRequest(j,D,P,T,!!F);return this.f?.logOutgoing(Y.byteLength,j,0,`request: ${(0,R.$dw)(D)}.${P}(`,z),this.c.send(Y),B}}e.$p$b=l;class a{constructor(D,P){this.a=D,this.b=P}resolveOk(D){this.a.resolveOk(D),this.b.dispose()}resolveErr(D){this.a.resolveErr(D),this.b.dispose()}}class h{static alloc(D,P,z){const F=new h(L.$ue.alloc(z+1+4),0);return F.writeUInt8(D),F.writeUInt32(P),F}static read(D,P){return new h(D,P)}get buffer(){return this.a}constructor(D,P){this.a=D,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(D){this.a.writeUInt8(D,this.b),this.b+=1}readUInt8(){const D=this.a.readUInt8(this.b);return this.b+=1,D}writeUInt32(D){this.a.writeUInt32BE(D,this.b),this.b+=4}readUInt32(){const D=this.a.readUInt32BE(this.b);return this.b+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this.a.writeUInt8(D.byteLength,this.b),this.b+=1,this.a.set(D,this.b),this.b+=D.byteLength}readShortString(){const D=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+D).toString();return this.b+=D,z}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readLongString(){const D=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+D).toString();return this.b+=D,z}writeBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readVSBuffer(){const D=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+D);return this.b+=D,P}static sizeMixedArray(D){let P=0;P+=1;for(let z=0,F=D.length;z<F;z++){const T=D[z];switch(P+=1,T.type){case 1:P+=this.sizeLongString(T.value);break;case 2:P+=this.sizeVSBuffer(T.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(T.value);for(let j=0;j<T.buffers.length;++j)P+=this.sizeVSBuffer(T.buffers[j]);break;case 4:break}}return P}writeMixedArray(D){this.a.writeUInt8(D.length,this.b),this.b+=1;for(let P=0,z=D.length;P<z;P++){const F=D[P];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let T=0;T<F.buffers.length;++T)this.writeBuffer(F.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this.a.readUInt8(this.b);this.b+=1;const P=new Array(D);for(let z=0;z<D;z++)switch(this.readUInt8()){case 1:P[z]=this.readLongString();break;case 2:P[z]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),j=this.readLongString(),N=[];for(let B=0;B<T;++B)N.push(this.readVSBuffer());P[z]=new R.$ew(o(j,N,null));break}case 4:P[z]=void 0;break}return P}}var g;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(g||(g={}));class S{static a(D){for(let P=0,z=D.length;P<z;P++)if(D[P]instanceof L.$ue||D[P]instanceof R.$ew||typeof D[P]>"u")return!0;return!1}static serializeRequestArguments(D,P){if(this.a(D)){const z=[];for(let F=0,T=D.length;F<T;F++){const j=D[F];if(j instanceof L.$ue)z[F]={type:2,value:j};else if(typeof j>"u")z[F]={type:4};else if(j instanceof R.$ew){const{jsonString:N,referencedBuffers:B}=m(j.value,P);z[F]={type:3,value:L.$ue.fromString(N),buffers:B}}else z[F]={type:1,value:L.$ue.fromString(n(j,P))}}return{type:1,args:z}}return{type:0,args:n(D,P)}}static serializeRequest(D,P,z,F,T){switch(F.type){case 0:return this.b(D,P,z,F.args,T);case 1:return this.c(D,P,z,F.args,T)}}static b(D,P,z,F,T){const j=L.$ue.fromString(z),N=L.$ue.fromString(F);let B=0;B+=h.sizeUInt8(),B+=h.sizeShortString(j),B+=h.sizeLongString(N);const W=h.alloc(T?2:1,D,B);return W.writeUInt8(P),W.writeShortString(j),W.writeLongString(N),W.buffer}static deserializeRequestJSONArgs(D){const P=D.readUInt8(),z=D.readShortString(),F=D.readLongString();return{rpcId:P,method:z,args:JSON.parse(F)}}static c(D,P,z,F,T){const j=L.$ue.fromString(z);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(j),N+=h.sizeMixedArray(F);const B=h.alloc(T?4:3,D,N);return B.writeUInt8(P),B.writeShortString(j),B.writeMixedArray(F),B.buffer}static deserializeRequestMixedArgs(D){const P=D.readUInt8(),z=D.readShortString(),F=D.readMixedArray(),T=new Array(F.length);for(let j=0,N=F.length;j<N;j++){const B=F[j];typeof B=="string"?T[j]=JSON.parse(B):T[j]=B}return{rpcId:P,method:z,args:T}}static serializeAcknowledged(D){return h.alloc(5,D,0).buffer}static serializeCancel(D){return h.alloc(6,D,0).buffer}static serializeReplyOK(D,P,z){if(typeof P>"u")return this.d(D);if(P instanceof L.$ue)return this.e(D,P);if(P instanceof R.$ew){const{jsonString:F,referencedBuffers:T}=m(P.value,z,!0);return this.g(D,F,T)}else return this.f(D,p(P,z))}static d(D){return h.alloc(7,D,0).buffer}static e(D,P){let z=0;z+=h.sizeVSBuffer(P);const F=h.alloc(8,D,z);return F.writeVSBuffer(P),F.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static f(D,P){const z=L.$ue.fromString(P);let F=0;F+=h.sizeLongString(z);const T=h.alloc(9,D,F);return T.writeLongString(z),T.buffer}static g(D,P,z){const F=L.$ue.fromString(P);let T=0;T+=h.sizeUInt32,T+=h.sizeLongString(F);for(const N of z)T+=h.sizeVSBuffer(N);const j=h.alloc(10,D,T);j.writeUInt32(z.length),j.writeLongString(F);for(const N of z)j.writeBuffer(N);return j.buffer}static deserializeReplyOKJSON(D){const P=D.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(D,P){const z=D.readUInt32(),F=D.readLongString(),T=[];for(let j=0;j<z;++j)T.push(D.readVSBuffer());return new R.$ew(o(F,T,P))}static serializeReplyErr(D,P){const z=P?p(A.$3(P),null):void 0;if(typeof z!="string")return this.h(D);const F=L.$ue.fromString(z);let T=0;T+=h.sizeLongString(F);const j=h.alloc(11,D,T);return j.writeLongString(F),j.buffer}static deserializeReplyErrError(D){const P=D.readLongString();return JSON.parse(P)}static h(D){return h.alloc(12,D,0).buffer}}var w;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var E;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(E||(E={}))}),define(ke[321],Ee([1,0,21,27,15,84,5]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$6J=void 0,e.$7J=R,e.$8J=I,e.$6J=(0,M.$ii)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),v=7;function R(C){if(C.scheme!==O.Schemas.vscodeNotebookCell)return;const k=C.fragment.indexOf("s");if(k<0)return;const c=parseInt(C.fragment.substring(0,k).replace($,""),v),m=(0,u.$Ne)(C.fragment.substring(k+1)).toString();if(!isNaN(c))return{handle:c,notebook:C.with({scheme:m,fragment:null})}}function I(C,k){const c=k.toString(v),o=`${c.length<b.length?b[c.length-1]:"z"}${c}s${(0,u.$Oe)(u.$ue.fromString(C.scheme),!0,!0)}`;return C.with({scheme:O.Schemas.vscodeNotebookCell,fragment:o})}class p{constructor(){this.a=new L.$Bc}getNotebook(k){if(k.scheme===O.Schemas.vscodeNotebookCell){const c=R(k);if(c){const m=this.a.get(c.notebook);if(m)return m}}return this.a.get(k)}addNotebookDocument(k){this.a.set(k.uri,k)}removeNotebookDocument(k){this.a.delete(k.uri)}}e.$9J=p,(0,A.$gs)(e.$6J,p,1)}),define(ke[119],Ee([1,0,21,35,38,101,15,17,11,41,321]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.$nK=e.CellStatusbarAlignment=e.$mK=e.NotebookEditorPriority=e.$jK=e.$iK=e.$gK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$fK=e.$eK=e.$dK=e.$cK=e.CellKind=e.$bK=e.$aK=e.$_J=void 0,e.$hK=f,e.$kK=l,e.$lK=a,e.$oK=S,e.$pK=E,e.$_J="workbench.editor.notebook",e.$aK="workbench.editor.notebookTextDiffEditor",e.$bK="workbench.editor.interactive";var I;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(I||(e.CellKind=I={})),e.$cK=["application/json","application/javascript","text/html","image/svg+xml",A.$zs.latex,A.$zs.markdown,"image/png","image/jpeg",A.$zs.text],e.$dK=[A.$zs.latex,A.$zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$zs.text],e.$eK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$fK="_notAvailable";var p;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var C;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var k;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function W(ee,pe){return(0,R.$8J)(ee,pe)}B.generate=W;function Y(ee){return(0,R.$7J)(ee)}B.parse=Y;function _(ee,pe){return ee.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${ee.scheme!==M.Schemas.file?ee.scheme:""}`})}B.generateCellOutputUri=_;function J(ee){if(ee.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ee.fragment);if(!pe)return;const De=pe[1]&&pe[1]!==""?pe[1]:void 0,x=pe[2];return{outputId:De,notebook:ee.with({scheme:x||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=J;function Z(ee,pe,De){return B.generate(ee,pe).with({scheme:De})}B.generateCellPropertyUri=Z;function re(ee,pe){if(ee.scheme===pe)return B.parse(ee.with({scheme:B.scheme}))}B.parseCellPropertyUri=re})(r||(e.CellUri=r={}));const s=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(W=[],Y=e.$cK){this.e=Y,this.d=[...new Set(W)].map(_=>({pattern:_,matches:L.$ck(s(_))}))}sort(W){const Y=new Map(O.Iterable.map(W,J=>[J,s(J)]));let _=[];for(const{matches:J}of this.d)for(const[Z,re]of Y)if(J(re)){_.push(Z),Y.delete(Z);break}return Y.size&&(_=_.concat([...Y.keys()].sort((J,Z)=>this.e.indexOf(J)-this.e.indexOf(Z)))),_}prioritize(W,Y){const _=this.f(W);if(_===-1){this.d.unshift({pattern:W,matches:L.$ck(s(W))});return}const J=new Set(Y.map(re=>this.f(re,_)));J.delete(-1);const Z=Array.from(J).sort();this.d.splice(_+1,0,...Z.map(re=>this.d[re]));for(let re=Z.length-1;re>=0;re--)this.d.splice(Z[re],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,Y=this.d.length){const _=s(W);for(let J=0;J<Y;J++)if(this.d[J].matches(_))return J;return-1}}e.$gK=t;function f(B,W,Y,_=(J,Z)=>J===Z){const J=[];function Z(pe,De,x){if(De===0&&x.length===0)return;const U=J[J.length-1];U&&U.start+U.deleteCount===pe?(U.deleteCount+=De,U.toInsert.push(...x)):J.push({start:pe,deleteCount:De,toInsert:x})}let re=0,ee=0;for(;;){if(re===B.length){Z(re,0,W.slice(ee));break}if(ee===W.length){Z(re,B.length-re,[]);break}const pe=B[re],De=W[ee];if(_(pe,De)){re+=1,ee+=1;continue}Y(De)?(Z(re,1,[]),re+=1):(Z(re,0,[De]),ee+=1)}return J}e.$iK=new v.$zj("notebookEditorCursorAtBoundary","none"),e.$jK=new v.$zj("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));function l(B){const W=B;return!!((typeof W.include=="string"||L.$dk(W.include))&&(typeof W.exclude=="string"||L.$dk(W.exclude)))}function a(B,W,Y){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const _=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,J=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(L.$bk(_,(0,b.$oc)(Y.fsPath).toLowerCase()))return!(J&&L.$bk(J,(0,b.$oc)(Y.fsPath).toLowerCase()))}return!1}e.$mK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.experimental.cellFailureDiagnostics"};var h;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class g{static{this.d="notebook/"}static create(W){return`${g.d}${W}`}static parse(W){if(W.startsWith(g.d))return W.substring(g.d.length)}}e.$nK=g;function S(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const w=new TextDecoder;function E(B){const W=[];let Y=!1;for(const re of B)(W.length===0||Y)&&(W.push(re),Y=!0);let _=P(W);const J=u.$ue.concat(W.map(re=>u.$ue.wrap(re))),Z=N(J);return _=_||Z.byteLength!==J.byteLength,{data:Z,didCompression:_}}e.$qK="\x1B[A";const y=e.$qK.split("").map(B=>B.charCodeAt(0)),D=10;function P(B){let W=!1;return B.forEach((Y,_)=>{if(_===0||Y.length<e.$qK.length)return;const J=B[_-1],Z=Y.subarray(0,e.$qK.length);if(Z[0]===y[0]&&Z[1]===y[1]&&Z[2]===y[2]){const re=J.lastIndexOf(D);if(re===-1)return;W=!0,B[_-1]=J.subarray(0,re),B[_]=Y.subarray(e.$qK.length)}}),W}function z(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function F(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let Y=B.match(/\r+(.*)$/m)[1];Y=Y+W.slice(Y.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return B}const T=8,j=13;function N(B){return!B.buffer.includes(T)&&!B.buffer.includes(j)?B:u.$ue.fromString(F(z(w.decode(B.buffer))))}}),define(ke[7],Ee([1,0,19,13,80,27,101,14,18,2,30,25,32,65,119]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k){"use strict";var c,m,o,n,i,r,s,t,f,d,l,a,h,g,S,w,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$AO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$zO=e.$yO=e.$xO=e.$wO=e.ChatLocation=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$nO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.TestRunProfileKind=e.TestResultState=e.$5N=e.$4N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$3N=e.NotebookVariablesRequestKind=e.$2N=e.$1N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$ZN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.ColorThemeKind=e.$TN=e.$SN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$RN=e.$QN=e.DebugConsoleMode=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$KN=e.$JN=e.FileChangeType=e.$IN=e.NewSymbolNameTag=e.$HN=e.$GN=e.$FN=e.$EN=e.InlineCompletionTriggerKind=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$rN=e.ConfigurationTarget=e.$qN=e.$pN=e.$oN=e.$nN=e.DocumentPasteTriggerKind=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$gN=e.ViewBadge=e.ProgressLocation=e.$fN=e.$eN=e.TaskScope=e.ShellQuoting=e.$dN=e.$cN=e.$bN=e.TaskPanelKind=e.TaskRevealKind=e.$aN=e.TerminalLocation=e.$_M=e.$$M=e.$0M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$9M=e.$8M=e.$7M=e.$6M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$4M=e.$3M=e.$2M=e.$1M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$ZM=e.$YM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.LanguageStatusSeverity=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.CodeActionTriggerKind=e.$MM=e.$LM=e.SymbolTag=e.SymbolKind=e.$KM=e.$JM=e.DocumentHighlightKind=e.$IM=e.$HM=e.$GM=e.$FM=e.DiagnosticSeverity=e.DiagnosticTag=e.$EM=e.$DM=e.FileEditType=e.$CM=e.$BM=e.$AM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$5M=lt,e.$sN=ne;function y(G){return Object.assign(G,{apply:function(...$e){if($e.length===0)return Reflect.construct(G,[]);{const je=$e.length===1?[]:$e[1];return Reflect.construct(G,je,$e[0].constructor)}},call:function(...$e){if($e.length===0)return Reflect.construct(G,[]);{const[je,...Ye]=$e;return Reflect.construct(G,Ye,je.constructor)}}})}var D;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(D||(e.TerminalOutputAnchor=D={}));var P;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let z=c=class{static from(...H){let $e=H;return new c(function(){if($e){for(const je of $e)je&&typeof je.dispose=="function"&&je.dispose();$e=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$tM=z,e.$tM=z=c=Je([y],z);let F=m=class{static Min(...H){if(H.length===0)throw new TypeError;let $e=H[0];for(let je=1;je<H.length;je++){const Ye=H[je];Ye.isBefore($e)&&($e=Ye)}return $e}static Max(...H){if(H.length===0)throw new TypeError;let $e=H[0];for(let je=1;je<H.length;je++){const Ye=H[je];Ye.isAfter($e)&&($e=Ye)}return $e}static isPosition(H){if(!H)return!1;if(H instanceof m)return!0;const{line:$e,character:je}=H;return typeof $e=="number"&&typeof je=="number"}static of(H){if(H instanceof m)return H;if(this.isPosition(H))return new m(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,$e){if(H<0)throw(0,L.$7)("line must be non-negative");if($e<0)throw(0,L.$7)("character must be non-negative");this.c=H,this.e=$e}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,$e=0){if(H===null||$e===null)throw(0,L.$7)();let je;return typeof H>"u"?je=0:typeof H=="number"?je=H:(je=typeof H.lineDelta=="number"?H.lineDelta:0,$e=typeof H.characterDelta=="number"?H.characterDelta:0),je===0&&$e===0?this:new m(this.line+je,this.character+$e)}with(H,$e=this.character){if(H===null||$e===null)throw(0,L.$7)();let je;return typeof H>"u"?je=this.line:typeof H=="number"?je=H:(je=typeof H.line=="number"?H.line:this.line,$e=typeof H.character=="number"?H.character:this.character),je===this.line&&$e===this.character?this:new m(je,$e)}toJSON(){return{line:this.line,character:this.character}}};e.$uM=F,e.$uM=F=m=Je([y],F);let T=o=class{static isRange(H){return H instanceof o?!0:H?F.isPosition(H.start)&&F.isPosition(H.end):!1}static of(H){if(H instanceof o)return H;if(this.isRange(H))return new o(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,$e,je,Ye){let nt,dt;if(typeof H=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof Ye=="number"?(nt=new F(H,$e),dt=new F(je,Ye)):F.isPosition(H)&&F.isPosition($e)&&(nt=F.of(H),dt=F.of($e)),!nt||!dt)throw new Error("Invalid arguments");nt.isBefore(dt)?(this.c=nt,this.e=dt):(this.c=dt,this.e=nt)}contains(H){return o.isRange(H)?this.contains(H.start)&&this.contains(H.end):F.isPosition(H)?!(F.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const $e=F.Max(H.start,this.c),je=F.Min(H.end,this.e);if(!$e.isAfter(je))return new o($e,je)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const $e=F.Min(H.start,this.c),je=F.Max(H.end,this.end);return new o($e,je)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,$e=this.end){if(H===null||$e===null)throw(0,L.$7)();let je;return H?F.isPosition(H)?je=H:(je=H.start||this.start,$e=H.end||this.end):je=this.start,je.isEqual(this.c)&&$e.isEqual(this.end)?this:new o(je,$e)}toJSON(){return[this.start,this.end]}};e.$vM=T,e.$vM=T=o=Je([y],T);let j=n=class extends T{static isSelection(H){return H instanceof n?!0:H?T.isRange(H)&&F.isPosition(H.anchor)&&F.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,$e,je,Ye){let nt,dt;if(typeof H=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof Ye=="number"?(nt=new F(H,$e),dt=new F(je,Ye)):F.isPosition(H)&&F.isPosition($e)&&(nt=F.of(H),dt=F.of($e)),!nt||!dt)throw new Error("Invalid arguments");super(nt,dt),this.f=nt,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$wM=j,e.$wM=j=n=Je([y],j);const N=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,L.$7)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,$e,je){if(typeof H!="string"||H.length===0)throw(0,L.$7)("host");if(typeof $e!="number"||$e===0||Math.round($e)!==$e)throw(0,L.$7)("port");typeof je<"u"&&N(je),this.host=H,this.port=Math.round($e),this.connectionToken=je}}e.$xM=B;class W{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,$e){this.makeConnection=H,this.connectionToken=$e,typeof $e<"u"&&N($e)}}e.$yM=W;class Y extends Error{static NotAvailable(H,$e){return new Y(H,C.RemoteAuthorityResolverErrorCode.NotAvailable,$e)}static TemporarilyNotAvailable(H){return new Y(H,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,$e=C.RemoteAuthorityResolverErrorCode.Unknown,je){super(H),this._message=H,this._code=$e,this._detail=je,Object.setPrototypeOf(this,Y.prototype)}}e.$zM=Y;var _;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var J;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let Z=i=class{static isTextEdit(H){return H instanceof i?!0:H?T.isRange(H)&&typeof H.newText=="string":!1}static replace(H,$e){return new i(H,$e)}static insert(H,$e){return i.replace(new T(H,H),$e)}static delete(H){return i.replace(H,"")}static setEndOfLine(H){const $e=new i(new T(new F(0,0),new F(0,0)),"");return $e.newEol=H,$e}get range(){return this.c}set range(H){if(H&&!T.isRange(H))throw(0,L.$7)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,L.$7)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,L.$7)("newEol");this.f=H}constructor(H,$e){this.c=H,this.e=$e}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$AM=Z,e.$AM=Z=i=Je([y],Z);let re=r=class{static isNotebookCellEdit(H){return H instanceof r?!0:H?Ue.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,$e){return new r(H,$e)}static insertCells(H,$e){return new r(new Ue(H,H),$e)}static deleteCells(H){return new r(H,[])}static updateCellMetadata(H,$e){const je=new r(new Ue(H,H),[]);return je.newCellMetadata=$e,je}static updateNotebookMetadata(H){const $e=new r(new Ue(0,0),[]);return $e.newNotebookMetadata=H,$e}constructor(H,$e){this.range=H,this.newCells=$e}};e.$BM=re,e.$BM=re=r=Je([y],re);class ee{static isSnippetTextEdit(H){return H instanceof ee?!0:H?T.isRange(H.range)&&x.isSnippetString(H.snippet):!1}static replace(H,$e){return new ee(H,$e)}static insert(H,$e){return ee.replace(new T(H,H),$e)}constructor(H,$e){this.range=H,this.snippet=$e}}e.$CM=ee;var pe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let De=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,$e,je,Ye){this.c.push({_type:1,from:H,to:$e,options:je,metadata:Ye})}createFile(H,$e,je){this.c.push({_type:1,from:void 0,to:H,options:$e,metadata:je})}deleteFile(H,$e,je){this.c.push({_type:1,from:H,to:void 0,options:$e,metadata:je})}e(H,$e,je){this.c.push({_type:3,metadata:je,uri:H,edit:{editType:5,metadata:$e},notebookMetadata:$e})}f(H,$e,je,Ye){const nt=$e.start,dt=$e.end;(nt!==dt||je.length>0)&&this.c.push({_type:5,uri:H,index:nt,count:dt-nt,cells:je,metadata:Ye})}g(H,$e,je,Ye){this.c.push({_type:3,metadata:Ye,uri:H,edit:{editType:3,index:$e,metadata:je}})}replace(H,$e,je,Ye){this.c.push({_type:2,uri:H,edit:new Z($e,je),metadata:Ye})}insert(H,$e,je,Ye){this.replace(H,new T($e,$e),je,Ye)}delete(H,$e,je){this.replace(H,$e,"",je)}has(H){return this.c.some($e=>$e._type===2&&$e.uri.toString()===H.toString())}set(H,$e){if($e)for(const je of $e){if(!je)continue;let Ye,nt;Array.isArray(je)?(Ye=je[0],nt=je[1]):Ye=je,re.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(H,Ye.range.start,Ye.newCellMetadata,nt):Ye.newNotebookMetadata?this.e(H,Ye.newNotebookMetadata,nt):this.f(H,Ye.range,Ye.newCells,nt):ee.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:H,range:Ye.range,edit:Ye.snippet,metadata:nt}):this.c.push({_type:2,uri:H,edit:Ye,metadata:nt})}else{for(let je=0;je<this.c.length;je++){const Ye=this.c[je];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===H.toString()&&(this.c[je]=void 0);break}}(0,u.$Ib)(this.c)}}get(H){const $e=[];for(const je of this.c)je._type===2&&je.uri.toString()===H.toString()&&$e.push(je.edit);return $e}entries(){const H=new A.$Bc;for(const $e of this.c)if($e._type===2){let je=H.get($e.uri);je||(je=[$e.uri,[]],H.set($e.uri,je)),je[1].push($e.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$DM=De,e.$DM=De=Je([y],De);let x=s=class{static isSnippetString(H){return H instanceof s?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=s.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,$e=this.e++){if(typeof H=="function"){const je=new s;je.e=this.e,H(je),this.e=je.e,H=je.value}else H=s.c(H);return this.value+="${",this.value+=$e,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,$e=this.e++){const je=H.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=$e,this.value+="|",this.value+=je,this.value+="|}",this}appendVariable(H,$e){if(typeof $e=="function"){const je=new s;je.e=this.e,$e(je),this.e=je.e,$e=je.value}else typeof $e=="string"&&($e=$e.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,$e&&(this.value+=":",this.value+=$e),this.value+="}",this}};e.$EM=x,e.$EM=x=s=Je([y],x);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ie;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let be=t=class{static isLocation(H){return H instanceof t?!0:H?T.isRange(H.range)&&v.URI.isUri(H.uri):!1}constructor(H,$e){if(this.uri=H,$e)if(T.isRange($e))this.range=T.of($e);else if(F.isPosition($e))this.range=new T($e,$e);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$FM=be,e.$FM=be=t=Je([y],be);let Ce=class{static is(H){return H?typeof H.message=="string"&&H.location&&T.isRange(H.location.range)&&v.URI.isUri(H.location.uri):!1}constructor(H,$e){this.location=H,this.message=$e}static isEqual(H,$e){return H===$e?!0:!H||!$e?!1:H.message===$e.message&&H.location.range.isEqual($e.location.range)&&H.location.uri.toString()===$e.location.uri.toString()}};e.$GM=Ce,e.$GM=Ce=Je([y],Ce);let ae=class{constructor(H,$e,je=ie.Error){if(!T.isRange(H))throw new TypeError("range must be set");if(!$e)throw new TypeError("message must be set");this.range=H,this.message=$e,this.severity=je}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,$e){return H===$e?!0:!H||!$e?!1:H.message===$e.message&&H.severity===$e.severity&&H.code===$e.code&&H.severity===$e.severity&&H.source===$e.source&&H.range.isEqual($e.range)&&(0,u.$ub)(H.tags,$e.tags)&&(0,u.$ub)(H.relatedInformation,$e.relatedInformation,Ce.isEqual)}};e.$HM=ae,e.$HM=ae=Je([y],ae);let ce=class{constructor(H,$e){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=$e}};e.$IM=ce,e.$IM=ce=Je([y],ce);var se;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let K=class{constructor(H,$e=se.Text){this.range=H,this.kind=$e}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$JM=K,e.$JM=K=Je([y],K);let te=class{constructor(H,$e){this.uri=H,this.highlights=$e}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$KM=te,e.$KM=te=Je([y],te);var le;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(G){G[G.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ae=f=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,$e,je,Ye,nt){this.name=H,this.kind=$e,this.containerName=nt,typeof je=="string"&&(this.containerName=je),Ye instanceof be?this.location=Ye:je instanceof T&&(this.location=new be(Ye,je)),f.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$LM=Ae,e.$LM=Ae=f=Je([y],Ae);let me=d=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(d.validate)}constructor(H,$e,je,Ye,nt){this.name=H,this.detail=$e,this.kind=je,this.range=Ye,this.selectionRange=nt,this.children=[],d.validate(this)}};e.$MM=me,e.$MM=me=d=Je([y],me);var Ie;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let Re=class{constructor(H,$e){this.title=H,this.kind=$e}};e.$NM=Re,e.$NM=Re=Je([y],Re);let Fe=class{static{l=this}static{this.c="."}constructor(H){this.value=H}append(H){return new l(this.value?this.value+l.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+l.c)}};e.$OM=Fe,e.$OM=Fe=l=Je([y],Fe),Fe.Empty=new Fe(""),Fe.QuickFix=Fe.Empty.append("quickfix"),Fe.Refactor=Fe.Empty.append("refactor"),Fe.RefactorExtract=Fe.Refactor.append("extract"),Fe.RefactorInline=Fe.Refactor.append("inline"),Fe.RefactorMove=Fe.Refactor.append("move"),Fe.RefactorRewrite=Fe.Refactor.append("rewrite"),Fe.Source=Fe.Empty.append("source"),Fe.SourceOrganizeImports=Fe.Source.append("organizeImports"),Fe.SourceFixAll=Fe.Source.append("fixAll"),Fe.Notebook=Fe.Empty.append("notebook");let q=class{constructor(H,$e){if(this.range=H,this.parent=$e,$e&&!$e.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$PM=q,e.$PM=q=Je([y],q);class V{constructor(H,$e,je,Ye,nt,dt){this.kind=H,this.name=$e,this.detail=je,this.uri=Ye,this.range=nt,this.selectionRange=dt}}e.$QM=V;class X{constructor(H,$e){this.fromRanges=$e,this.from=H}}e.$RM=X;class Q{constructor(H,$e){this.fromRanges=$e,this.to=H}}e.$SM=Q;var fe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(fe||(e.LanguageStatusSeverity=fe={}));let we=class{constructor(H,$e){this.range=H,this.command=$e}get isResolved(){return!!this.command}};e.$TM=we,e.$TM=we=Je([y],we);let Te=a=class{#e;static isMarkdownString(H){return H instanceof a?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,$e=!1){this.#e=new O.$Fk(H,{supportThemeIcons:$e})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,$e){return this.#e.appendCodeblock($e??"",H),this}};e.$UM=Te,e.$UM=Te=a=Je([y],Te);let He=class{constructor(H,$e){this.label=H,this.documentation=$e}};e.$VM=He,e.$VM=He=Je([y],He);let xe=class{constructor(H,$e){this.label=H,this.documentation=$e,this.parameters=[]}};e.$WM=xe,e.$WM=xe=Je([y],xe);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$XM=it,e.$XM=it=Je([y],it);var rt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(rt||(e.SignatureHelpTriggerKind=rt={}));var at;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let ot=class{constructor(H){this.value=H}};e.$YM=ot,e.$YM=ot=Je([y],ot);let Se=class{constructor(H,$e,je){this.position=H,this.label=$e,this.kind=je}};e.$ZM=Se,e.$ZM=Se=Je([y],Se);var Be;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Ge;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ge||(e.CompletionItemKind=Ge={}));var Me;(function(G){G[G.Deprecated=1]="Deprecated"})(Me||(e.CompletionItemTag=Me={}));let Qe=class{constructor(H,$e){this.label=H,this.kind=$e}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$1M=Qe,e.$1M=Qe=Je([y],Qe);let oe=class{constructor(H=[],$e=!1){this.items=H,this.isIncomplete=$e}};e.$2M=oe,e.$2M=oe=Je([y],oe);let ue=class{constructor(H,$e,je){this.insertText=H,this.range=$e,this.command=je}};e.$3M=ue,e.$3M=ue=Je([y],ue);let Pe=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$4M=Pe,e.$4M=Pe=Je([y],Pe);var Ke;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(Ke||(e.PartialAcceptTriggerKind=Ke={}));var _e;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(_e||(e.ViewColumn=_e={}));var Ne;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ne||(e.StatusBarAlignment=Ne={}));function lt(G,H){return`${I.$Dm.toKey(G)}.${H}`}var wt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var At;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(At||(e.TextDocumentSaveReason=At={}));var zt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(zt||(e.TextEditorRevealType=zt={}));var Qt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var _t;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Ct;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Ct||(e.DecorationRangeBehavior=Ct={})),function(G){function H($e){switch($e){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Xt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Xt||(e.SyntaxTokenType=Xt={})),function(G){function H($e){switch($e){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=H}(Xt||(e.SyntaxTokenType=Xt={}));let qt=class{constructor(H,$e){if($e&&!v.URI.isUri($e))throw(0,L.$7)("target");if(!T.isRange(H)||H.isEmpty)throw(0,L.$7)("range");this.range=H,this.target=$e}};e.$6M=qt,e.$6M=qt=Je([y],qt);let ai=class{constructor(H,$e,je,Ye){this.red=H,this.green=$e,this.blue=je,this.alpha=Ye}};e.$7M=ai,e.$7M=ai=Je([y],ai);let tt=class{constructor(H,$e){if($e&&!($e instanceof ai))throw(0,L.$7)("color");if(!T.isRange(H)||H.isEmpty)throw(0,L.$7)("range");this.range=H,this.color=$e}};e.$8M=tt,e.$8M=tt=Je([y],tt);let ei=class{constructor(H){if(!H||typeof H!="string")throw(0,L.$7)("label");this.label=H}};e.$9M=ei,e.$9M=ei=Je([y],ei);var ti;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ft;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(ft||(e.SourceControlInputBoxValidationType=ft={}));var bt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));class si{constructor(H,$e,je){if(this.startIndex=H,this.length=$e,this.tooltip=je,typeof H!="number"||H<0)throw(0,L.$7)("startIndex");if(typeof $e!="number"||$e<1)throw(0,L.$7)("length");if(je!==void 0&&typeof je!="string")throw(0,L.$7)("tooltip")}}e.$0M=si;class ii{constructor(H){this.uri=H}}e.$$M=ii;class jt{constructor(H){this.terminalCommand=H}}e.$_M=jt;var mt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(mt||(e.TerminalLocation=mt={}));class Rt{constructor(H){if(this.options=H,typeof H!="object")throw(0,L.$7)("options")}}e.$aN=Rt;var Ht;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ht||(e.TaskRevealKind=Ht={}));var Zt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Zt||(e.TaskPanelKind=Zt={}));let Ze=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(H){switch(H){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(H,$e){if(this.label=$e,typeof H!="string"||typeof $e!="string")throw(0,L.$7)("name");this.c=H}get id(){return this.c}};e.$bN=Ze,e.$bN=Ze=h=Je([y],Ze);function Yt(G){let H="";for(let $e=0;$e<G.length;$e++)H+=G[$e].replace(/,/g,",,")+",";return H}let Bt=class{constructor(H,$e,je){if(typeof H!="string")throw(0,L.$7)("process");this.e=[],this.c=H,$e!==void 0&&(Array.isArray($e)?(this.e=$e,this.f=je):this.f=$e)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,L.$7)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const $e of this.e)H.push($e);return Yt(H)}};e.$cN=Bt,e.$cN=Bt=Je([y],Bt);let Ut=class{constructor(H,$e,je){if(this.f=[],Array.isArray($e)){if(!H)throw(0,L.$7)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,L.$7)("command");this.e=H,this.f=$e,this.g=je}else{if(typeof H!="string")throw(0,L.$7)("commandLine");this.c=H,this.g=$e}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,L.$7)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,L.$7)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const $e of this.f)H.push(typeof $e=="string"?$e:$e.value);return Yt(H)}};e.$dN=Ut,e.$dN=Ut=Je([y],Ut);var $t;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})($t||(e.ShellQuoting=$t={}));var Ft;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Ft||(e.TaskScope=Ft={}));class Mt{constructor(H){this.c=H}computeId(){return"customExecution"+(0,R.$Eg)()}set callback(H){this.c=H}get callback(){return this.c}}e.$eN=Mt;let Tt=class{static{g=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,$e,je,Ye,nt,dt){this.k=!1,this.l=this.definition=H;let gt;typeof $e=="string"?(this.o=this.name=$e,this.w=this.source=je,this.execution=Ye,gt=nt,this.k=!0):$e===Ft.Global||$e===Ft.Workspace?(this.target=$e,this.o=this.name=je,this.w=this.source=Ye,this.execution=nt,gt=dt):(this.target=$e,this.o=this.name=je,this.w=this.source=Ye,this.execution=nt,gt=dt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:g.e,id:this.q.computeId()}:this.q instanceof Ut?this.l={type:g.f,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:g.c,id:this.q.computeId()}:this.l={type:g.g,id:(0,R.$Eg)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,L.$7)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,L.$7)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const $e=this.l.type;(g.g===$e||g.e===$e||g.f===$e||g.c===$e)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,L.$7)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$fN=Tt,e.$fN=Tt=g=Je([y],Tt);var ni;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var oi;(function(G){function H($e){const je=$e;return(0,$.$Zf)(je.value)?je.tooltip&&!(0,$.$Vf)(je.tooltip)?(console.log("INVALID view badge, invalid tooltip",je.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",je.value),!1)}G.isViewBadge=H})(oi||(e.ViewBadge=oi={}));let Wt=S=class{static isTreeItem(H,$e){const je=H;if(je.checkboxState!==void 0){const Ye=(0,$.$Zf)(je.checkboxState)?je.checkboxState:(0,$.$Xf)(je.checkboxState)&&(0,$.$Zf)(je.checkboxState.state)?je.checkboxState.state:void 0,nt=!(0,$.$Zf)(je.checkboxState)&&(0,$.$Xf)(je.checkboxState)?je.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==St.Checked&&Ye!==St.Unchecked||nt!==void 0&&!(0,$.$Vf)(nt))return console.log("INVALID tree item, invalid checkboxState",je.checkboxState),!1}if(H instanceof S)return!0;if(je.label!==void 0&&!(0,$.$Vf)(je.label)&&!je.label?.label)return console.log("INVALID tree item, invalid label",je.label),!1;if(je.id!==void 0&&!(0,$.$Vf)(je.id))return console.log("INVALID tree item, invalid id",je.id),!1;if(je.iconPath!==void 0&&!(0,$.$Vf)(je.iconPath)&&!v.URI.isUri(je.iconPath)&&(!je.iconPath||!(0,$.$Vf)(je.iconPath.id))){const Ye=je.iconPath;if(!Ye||!(0,$.$Vf)(Ye.light)&&!v.URI.isUri(Ye.light)&&!(0,$.$Vf)(Ye.dark)&&!v.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",je.iconPath),!1}return je.description!==void 0&&!(0,$.$Vf)(je.description)&&typeof je.description!="boolean"?(console.log("INVALID tree item, invalid description",je.description),!1):je.resourceUri!==void 0&&!v.URI.isUri(je.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",je.resourceUri),!1):je.tooltip!==void 0&&!(0,$.$Vf)(je.tooltip)&&!(je.tooltip instanceof Te)?(console.log("INVALID tree item, invalid tooltip",je.tooltip),!1):je.command!==void 0&&!je.command.command?(console.log("INVALID tree item, invalid command",je.command),!1):je.collapsibleState!==void 0&&je.collapsibleState<It.None&&je.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",je.collapsibleState),!1):je.contextValue!==void 0&&!(0,$.$Vf)(je.contextValue)?(console.log("INVALID tree item, invalid contextValue",je.contextValue),!1):je.accessibilityInformation!==void 0&&!je.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",je.accessibilityInformation),!1):!0}constructor(H,$e=It.None){this.collapsibleState=$e,v.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$gN=Wt,e.$gN=Wt=S=Je([y],Wt);var It;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var St;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let Gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$hN=Gt,e.$hN=Gt=Je([y],Gt);class Pt extends Gt{}e.$iN=Pt;class yt extends Pt{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$jN=yt;class Dt{constructor(H,$e,je,Ye){this.name=H,this.uri=$e,this._itemId=je,this.c=Ye}data(){return this.c()}}e.$kN=Dt;let Et=class{#e=new Map;constructor(H){for(const[$e,je]of H??[]){const Ye=this.#e.get(this.#t($e));Ye?Ye.push(je):this.#e.set(this.#t($e),[je])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,$e){this.#e.set(this.#t(H),[$e])}forEach(H,$e){for(const[je,Ye]of this.#e)for(const nt of Ye)H.call($e,nt,je,this)}*[Symbol.iterator](){for(const[H,$e]of this.#e)for(const je of $e)yield[H,je]}#t(H){return H.toLowerCase()}};e.$lN=Et,e.$lN=Et=Je([y],Et);let ui=class{constructor(H,$e,je){this.insertText=H,this.title=$e,this.kind=je}};e.$mN=ui,e.$mN=ui=Je([y],ui);var ri;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(ri||(e.DocumentPasteTriggerKind=ri={}));class li{static{this.c="."}constructor(H){this.value=H}append(...H){return new li((this.value?[this.value,...H]:H).join(li.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+li.c)}}e.$nN=li,li.Empty=new li("");let di=class{constructor(H,$e,je){this.title=$e,this.insertText=H,this.kind=je}};e.$oN=di,e.$oN=di=Je([y],di);let xt=class{constructor(H,$e){this.id=H,this.color=$e}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$pN=xt,e.$pN=xt=Je([y],xt),xt.File=new xt("file"),xt.Folder=new xt("folder");let Ot=class{constructor(H){this.id=H}};e.$qN=Ot,e.$qN=Ot=Je([y],Ot);var Oe;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Oe||(e.ConfigurationTarget=Oe={}));let ze=class{get base(){return this.c}set base(H){this.c=H,this.e=v.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,$e){if(typeof H!="string"&&(!H||!v.URI.isUri(H)&&!v.URI.isUri(H.uri)))throw(0,L.$7)("base");if(typeof $e!="string")throw(0,L.$7)("pattern");typeof H=="string"?this.baseUri=v.URI.file(H):v.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=$e}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$rN=ze,e.$rN=ze=Je([y],ze);const ve=new WeakMap;function ne(G,H){ve.set(G,H)}let Le=class{constructor(H,$e,je,Ye,nt){this.enabled=typeof H=="boolean"?H:!0,typeof $e=="string"&&(this.condition=$e),typeof je=="string"&&(this.hitCondition=je),typeof Ye=="string"&&(this.logMessage=Ye),typeof nt=="string"&&(this.mode=nt)}get id(){return this.c||(this.c=ve.get(this)??(0,R.$Eg)()),this.c}};e.$tN=Le,e.$tN=Le=Je([y],Le);let Ve=class extends Le{constructor(H,$e,je,Ye,nt,dt){if(super($e,je,Ye,nt,dt),H===null)throw(0,L.$7)("location");this.location=H}};e.$uN=Ve,e.$uN=Ve=Je([y],Ve);let et=class extends Le{constructor(H,$e,je,Ye,nt,dt){super($e,je,Ye,nt,dt),this.functionName=H}};e.$vN=et,e.$vN=et=Je([y],et);let Xe=class extends Le{constructor(H,$e,je,Ye,nt,dt,gt,Jt){if(super(Ye,nt,dt,gt,Jt),!$e)throw(0,L.$7)("dataId");this.label=H,this.dataId=$e,this.canPersist=je}};e.$wN=Xe,e.$wN=Xe=Je([y],Xe);let ct=class{constructor(H,$e,je){this.command=H,this.args=$e||[],this.options=je}};e.$xN=ct,e.$xN=ct=Je([y],ct);let kt=class{constructor(H,$e){this.port=H,this.host=$e}};e.$yN=kt,e.$yN=kt=Je([y],kt);let Kt=class{constructor(H){this.path=H}};e.$zN=Kt,e.$zN=Kt=Je([y],Kt);let Vt=class{constructor(H){this.implementation=H}};e.$AN=Vt,e.$AN=Vt=Je([y],Vt);class Lt{constructor(H,$e,je){this.session=H,this.threadId=$e,this.frameId=je}}e.$BN=Lt;class ht{constructor(H,$e){this.session=H,this.threadId=$e}}e.$CN=ht;let Pi=class{constructor(H,$e){this.range=H,this.expression=$e}};e.$DN=Pi,e.$DN=Pi=Je([y],Pi);var gi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let $i=class{constructor(H,$e){this.range=H,this.text=$e}};e.$EN=$i,e.$EN=$i=Je([y],$i);let vi=class{constructor(H,$e,je=!0){this.range=H,this.variableName=$e,this.caseSensitiveLookup=je}};e.$FN=vi,e.$FN=vi=Je([y],vi);let Ai=class{constructor(H,$e){this.range=H,this.expression=$e}};e.$GN=Ai,e.$GN=Ai=Je([y],Ai);let Ri=class{constructor(H,$e){this.frameId=H,this.stoppedLocation=$e}};e.$HN=Ri,e.$HN=Ri=Je([y],Ri);var Wi;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));class Vi{constructor(H,$e){this.newSymbolName=H,this.tags=$e}}e.$IN=Vi;var qi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(qi||(e.FileChangeType=qi={}));let yi=w=class extends Error{static FileExists(H){return new w(H,p.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(H){return new w(H,p.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(H){return new w(H,p.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(H){return new w(H,p.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(H){return new w(H,p.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(H){return new w(H,p.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(H,$e=p.FileSystemProviderErrorCode.Unknown,je){super(v.URI.isUri(H)?H.toString(!0):H),this.code=je?.name??"Unknown",(0,p.$4k)(this,$e),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof je=="function"&&Error.captureStackTrace(this,je)}};e.$JN=yi,e.$JN=yi=w=Je([y],yi);let Mi=class{constructor(H,$e,je){this.start=H,this.end=$e,this.kind=je}};e.$KN=Mi,e.$KN=Mi=Je([y],Mi);var ki;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Hi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Hi||(e.CommentMode=Hi={}));var Gi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var bi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));var Ki;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Ki||(e.CommentThreadApplicability=Ki={}));class gn{constructor(H,$e=[]){this.tokenTypes=H,this.tokenModifiers=$e}}e.$LN=gn;function mn(G){return typeof G>"u"||(0,$.$Wf)(G)}class Ci{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let $e=0,je=H.tokenTypes.length;$e<je;$e++)this.k.set(H.tokenTypes[$e],$e);for(let $e=0,je=H.tokenModifiers.length;$e<je;$e++)this.l.set(H.tokenModifiers[$e],$e)}}push(H,$e,je,Ye,nt){if(typeof H=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.q(H,$e,je,Ye,nt);if(T.isRange(H)&&typeof $e=="string"&&mn(je))return this.o(H,$e,je);throw(0,L.$7)()}o(H,$e,je){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has($e))throw new Error("`tokenType` is not in the provided legend");const Ye=H.start.line,nt=H.start.character,dt=H.end.character-H.start.character,gt=this.k.get($e);let Jt=0;if(je)for(const hi of je){if(!this.l.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(hi);Jt|=1<<fi>>>0}this.q(Ye,nt,dt,gt,Jt)}q(H,$e,je,Ye,nt){if(this.f&&(H<this.c||H===this.c&&$e<this.e)){this.f=!1;const Jt=this.g.length/5|0;let hi=0,fi=0;for(let mi=0;mi<Jt;mi++){let pi=this.g[5*mi],Bi=this.g[5*mi+1];pi===0?(pi=hi,Bi+=fi):pi+=hi,this.g[5*mi]=pi,this.g[5*mi+1]=Bi,hi=pi,fi=Bi}}let dt=H,gt=$e;this.f&&this.j>0&&(dt-=this.c,dt===0&&(gt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=gt,this.g[this.j++]=je,this.g[this.j++]=Ye,this.g[this.j++]=nt,this.c=H,this.e=$e}static r(H){const $e=[],je=H.length/5|0;for(let gt=0;gt<je;gt++)$e[gt]=gt;$e.sort((gt,Jt)=>{const hi=H[5*gt],fi=H[5*Jt];if(hi===fi){const mi=H[5*gt+1],pi=H[5*Jt+1];return mi-pi}return hi-fi});const Ye=new Uint32Array(H.length);let nt=0,dt=0;for(let gt=0;gt<je;gt++){const Jt=5*$e[gt],hi=H[Jt+0],fi=H[Jt+1],mi=H[Jt+2],pi=H[Jt+3],Bi=H[Jt+4],Ln=hi-nt,sr=Ln===0?fi-dt:fi,Ui=5*gt;Ye[Ui+0]=Ln,Ye[Ui+1]=sr,Ye[Ui+2]=mi,Ye[Ui+3]=pi,Ye[Ui+4]=Bi,nt=hi,dt=fi}return Ye}build(H){return this.f?new Oi(new Uint32Array(this.g),H):new Oi(Ci.r(this.g),H)}}e.$MN=Ci;class Oi{constructor(H,$e){this.resultId=$e,this.data=H}}e.$NN=Oi;class Ji{constructor(H,$e,je){this.start=H,this.deleteCount=$e,this.data=je}}e.$ON=Ji;class Qi{constructor(H,$e){this.resultId=$e,this.edits=H}}e.$PN=Qi;var Xi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class Zi{constructor(H){this.name=H}}e.$QN=Zi;let Si=class{static{this.Back={iconPath:new xt("arrow-left")}}constructor(){}};e.$RN=Si,e.$RN=Si=Je([y],Si);var Yi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var xi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var _i;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(H){if(typeof H.badge=="string"){let $e=(0,b.$vf)(H.badge,0);if($e<H.badge.length&&($e+=(0,b.$vf)(H.badge,$e)),H.badge.length>$e)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!xt.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,$e,je){this.badge=H,this.tooltip=$e,this.color=je}}e.$SN=$n;let wi=class{constructor(H){this.kind=H}};e.$TN=wi,e.$TN=wi=Je([y],wi);var Li;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Li||(e.ColorThemeKind=Li={}));class Ue{static isNotebookRange(H){return H instanceof Ue?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,$e){if(H<0)throw(0,L.$7)("start must be positive");if($e<0)throw(0,L.$7)("end must be positive");H<=$e?(this.c=H,this.e=$e):(this.c=$e,this.e=H)}with(H){let $e=this.c,je=this.e;return H.start!==void 0&&($e=H.start),H.end!==void 0&&(je=H.end),$e===this.c&&je===this.e?this:new Ue($e,je)}}e.$UN=Ue;class ci{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every($e=>ci.isNotebookCellData($e))}static isNotebookCellData(H){return!0}constructor(H,$e,je,Ye,nt,dt,gt){this.kind=H,this.value=$e,this.languageId=je,this.mime=Ye,this.outputs=nt??[],this.metadata=dt,this.executionSummary=gt,ci.validate(this)}}e.$VN=ci;class en{constructor(H){this.cells=H}}e.$WN=en;class st{static isNotebookCellOutputItem(H){return H instanceof st?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const $e={name:H.name,message:H.message,stack:H.stack};return st.json($e,"application/vnd.code.notebook.error")}static stdout(H){return st.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return st.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,$e="application/octet-stream"){return new st(H,$e)}static#e=new TextEncoder;static text(H,$e=M.$zs.text){const je=st.#e.encode(String(H));return new st(je,$e)}static json(H,$e="text/x-json"){const je=JSON.stringify(H,void 0,"	");return st.text(je,$e)}constructor(H,$e){this.data=H,this.mime=$e;const je=(0,M.$Ds)($e,!0);if(!je)throw new Error(`INVALID mime type: ${$e}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=je}}e.$XN=st;class pt{static isNotebookCellOutput(H){return H instanceof pt?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,$e=!1){const je=new Set,Ye=new Set;for(let nt=0;nt<H.length;nt++){const dt=H[nt],gt=(0,M.$Ds)(dt.mime);if(!je.has(gt)||(0,k.$oK)(gt)){je.add(gt);continue}Ye.add(nt),$e&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ye.size===0?H:H.filter((nt,dt)=>!Ye.has(dt))}constructor(H,$e,je){this.items=pt.ensureUniqueMimeTypes(H,!0),typeof $e=="string"?(this.id=$e,this.metadata=je):(this.id=(0,R.$Eg)(),this.metadata=$e??je)}}e.$YN=pt;var tn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var ji;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ji||(e.NotebookCellStatusBarAlignment=ji={}));var rn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class Di{constructor(H,$e){this.text=H,this.alignment=$e}}e.$ZN=Di;var sn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(H,$e=[]){this.uri=H,this.provides=(0,u.$3b)($e)}}e.$1N=pn;class an{constructor(H){this.label=H}}e.$2N=an;var cn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ni=class{constructor(H,$e){this.label=H,this.timestamp=$e}};e.$3N=Ni,e.$3N=Ni=Je([y],Ni);var un;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var ln;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var hn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class bn{constructor(H,$e){this.ranges=H,this.wordPattern=$e}}e.$4N=bn;class wn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$5N=wn;var dn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(dn||(e.TestResultState=dn={}));var fn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Fi=class{constructor(H=void 0,$e=void 0,je=void 0,Ye=!1){this.include=H,this.exclude=$e,this.profile=je,this.continuous=Ye}};e.$6N=Fi,e.$6N=Fi=Je([y],Fi);let Ti=E=class{static diff(H,$e,je){const Ye=new E(H);return Ye.expectedOutput=$e,Ye.actualOutput=je,Ye}constructor(H){this.message=H}};e.$7N=Ti,e.$7N=Ti=E=Je([y],Ti);let ge=class{constructor(H){this.id=H}};e.$8N=ge,e.$8N=ge=Je([y],ge);class ye{constructor(H,$e){this.covered=H,this.total=$e}}e.$9N=ye;const We=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class ut{static fromDetails(H,$e){const je=new ye(0,0),Ye=new ye(0,0),nt=new ye(0,0);for(const gt of $e)if("branches"in gt){je.total+=1,je.covered+=gt.executed?1:0;for(const Jt of gt.branches)Ye.total+=1,Ye.covered+=Jt.executed?1:0}else nt.total+=1,nt.covered+=gt.executed?1:0;const dt=new ut(H,je,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return dt.detailedCoverage=$e,dt}constructor(H,$e,je,Ye){this.uri=H,this.statementCoverage=$e,this.branchCoverage=je,this.declarationCoverage=Ye,We($e),We(je),We(Ye)}}e.$0N=ut;class vt{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,$e,je=[]){this.executed=H,this.location=$e,this.branches=je}}e.$$N=vt;class Nt{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,$e,je){this.executed=H,this.location=$e,this.label=je}}e.$_N=Nt;class zi{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,$e,je){this.name=H,this.executed=$e,this.location=je}}e.$aO=zi;var vn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var yn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var kn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class jn{constructor(H,$e,je,Ye,nt,dt){this.kind=H,this.name=$e,this.detail=je,this.uri=Ye,this.range=nt,this.selectionRange=dt}}e.$bO=jn;class Nn{constructor(H){this.uri=H}}e.$cO=Nn;class Fn{constructor(H,$e){this.original=H,this.modified=$e}}e.$dO=Fn;class Tn{constructor(H,$e,je,Ye){this.base=H,this.input1=$e,this.input2=je,this.result=Ye}}e.$eO=Tn;class zn{constructor(H,$e){this.uri=H,this.viewType=$e}}e.$fO=zn;class Bn{constructor(H){this.viewType=H}}e.$gO=Bn;class Un{constructor(H,$e){this.uri=H,this.notebookType=$e}}e.$hO=Un;class Wn{constructor(H,$e,je){this.original=H,this.modified=$e,this.notebookType=je}}e.$iO=Wn;class Vn{constructor(){}}e.$jO=Vn;class qn{constructor(H,$e){this.uri=H,this.inputBoxUri=$e}}e.$kO=qn;class Hn{constructor(H){this.providerId=H}}e.$lO=Hn;class Gn{constructor(H){this.textDiffs=H}}e.$mO=Gn;var En;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Cn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var Sn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Kn{constructor(H,$e){this.label=H,this.values=$e}}e.$nO=Kn;var Dn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var In;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(In||(e.ChatResultFeedbackKind=In={}));class Jn{constructor(H){this.value=typeof H=="string"?new Te(H):H}}e.$oO=Jn;class Qn{constructor(H,$e){this.value=H,this.baseUri=$e}}e.$pO=Qn;class Xn{constructor(H,$e){this.value=H,this.title=$e}}e.$qO=Xn;class Zn{constructor(H){this.value=H}}e.$rO=Zn;class Yn{constructor(H){this.value=H}}e.$sO=Yn;class xn{constructor(H){this.value=H}}e.$tO=xn;class _n{constructor(H,$e,je,Ye){this.prompt=H,this.command=$e,this.variables=je,this.participant=Ye}}e.$uO=_n;class er{constructor(H,$e,je,Ye){this.response=H,this.result=$e,this.participant=je,this.command=Ye}}e.$vO=er;var Pn;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook"})(Pn||(e.ChatLocation=Pn={}));class tr{constructor(H){this.content=H}}e.$wO=tr;class ir{constructor(H,$e){this.content=H,this.name=$e}}e.$xO=ir;class nr{constructor(H){this.content=H}}e.$yO=nr;class Ii extends Error{static NotFound(H){return new Ii(H,Ii.NotFound.name)}static NoPermissions(H){return new Ii(H,Ii.NoPermissions.name)}constructor(H,$e,je){super(H,{cause:je}),this.name="LanguageModelError",this.code=$e??""}}e.$zO=Ii;var An;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Rn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Rn||(e.SpeechToTextStatus=Rn={}));var Mn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class rr{constructor(H,$e){this.text=H,this.range=$e}}e.$AO=rr;var On;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(ke[322],Ee([1,0,6,7]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;class O{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$rM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const v=this.a.get(M);if(!v)throw new Error("related information provider not found");return await v.provideRelatedInformation(b,$)??[]}getRelatedInformation(M,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(M,b,$){const v=this.b;return this.b++,this.a.set(v,$),this.c.$registerAiRelatedInformationProvider(v,b),new L.$tM(()=>{this.c.$unregisterAiRelatedInformationProvider(v),this.a.delete(v)})}}e.$njc=O}),define(ke[120],Ee([1,0,4,6,7,25,145,5,20]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=e.$yjc=void 0,e.$yjc=(0,b.$ii)("IExtHostAuthentication");let v=class{constructor(p){this.b=new Map,this.c=new u.$7d,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=p.getProxy(L.$rM.MainThreadAuthentication)}async getSession(p,C,k,c={}){const m=A.$Dm.toKey(p.identifier),o=[...k].sort().join(" ");return await this.d.getOrCreate(`${m} ${C} ${o}`,async()=>{await this.a.$ensureProvider(C);const n=p.displayName||p.name;return this.a.$getSession(C,k,m,n,c)})}async getSessions(p,C,k){const c=A.$Dm.toKey(p.identifier),m=[...k].sort().join(" ");return await this.f.getOrCreate(`${c} ${m}`,async()=>{await this.a.$ensureProvider(C);const o=p.displayName||p.name;return this.a.$getSessions(C,k,c,o)})}async removeSession(p,C){const k=this.b.get(p);return k?k.provider.removeSession(C):this.a.$removeSession(p,C)}registerAuthenticationProvider(p,C,k,c){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:C,provider:k,options:c??{supportsMultipleAccounts:!1}});const m=k.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(p,o));return this.a.$registerAuthenticationProvider(p,C,c?.supportsMultipleAccounts??!1),new O.$tM(()=>{m.dispose(),this.b.delete(p),this.a.$unregisterAuthenticationProvider(p)})}$createSession(p,C,k){const c=this.b.get(p);if(c)return Promise.resolve(c.provider.createSession(C,k));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,C){const k=this.b.get(p);if(k)return Promise.resolve(k.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,C){const k=this.b.get(p);if(k)return Promise.resolve(k.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,C){return p.startsWith(M.$tL)||this.c.fire({provider:{id:p,label:C}}),Promise.resolve()}};e.$zjc=v,e.$zjc=v=Je([qe(0,$.$MO)],v);class R{constructor(){this.a=new Map}getOrCreate(p,C){const k=this.a.get(p);if(k)return k;const c=C().finally(()=>this.a.delete(p));return this.a.set(p,c),c}}}),define(ke[151],Ee([1,0,2,6,7,5,20,12,19,14,17,26]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=e.$zkc=void 0;let C=class{static{p=this}static{this.c=0}static{this.d=250}constructor(c,m){this.h=m,this.f=new Map,this.g=c.getProxy(L.$rM.MainThreadDecorations)}registerFileDecorationProvider(c,m){const o=p.c++;this.f.set(o,{provider:c,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const n=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,$.$3b)(i);if(r.length<=p.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,v.$1e)(d.path,"/")})),t=(0,$.$zb)(s,(d,l)=>d.rank-l.rank||(0,v.$ef)(d.uri.path,l.uri.path)),f=[];e:for(const d of t){let l;for(const a of d){const h=(0,R.$nc)(a.uri.path);if(l!==h&&(l=h,f.push(a.uri)>=p.d))break e}}this.g.$onDidChange(o,f)});return new O.$tM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(c,m,o){if(!this.f.has(c))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(c);return await Promise.all(m.map(async s=>{try{const{uri:t,id:f}=s,d=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),o));if(!d)return;try{O.$SN.validate(d),d.badge&&typeof d.badge!="string"&&(0,I.$cG)(r,"codiconDecoration"),n[f]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$zkc=C,e.$zkc=C=p=Je([qe(0,M.$MO),qe(1,b.$Oj)],C),e.$Akc=(0,A.$ii)("IExtHostDecorations")}),define(ke[323],Ee([1,0,13,2,7,6,15,22,14]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=void 0;class v{static{this.a=0}constructor(I,p,C){this.d=p,this.e=C,this.b=new Map,this.c=I.getProxy(A.$rM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(M.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const C=v.a++;this.b.set(C,p),this.c.$registerTextContentProvider(C,I);let k;if(typeof p.onDidChange=="function"){let c;k=p.onDidChange(async m=>{if(m.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;c&&await c;const o=this.$provideTextDocumentContent(C,m).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(m);if(!i)return;const r=(0,$.$$e)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(m,n)}).catch(u.$1).finally(()=>{c===o&&(c=void 0)});c=o})}return new O.$tM(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(I,p){const C=this.b.get(I);return C?Promise.resolve(C.provideTextDocumentContent(L.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$Ckc=v}),define(ke[152],Ee([1,0,61,15,14,182,129,7,19]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=e.$PO=void 0,e.$OO=R;const v=new Map;function R(k,c){c?v.set(k,c):v.delete(k)}function I(k){return v.get(k)}class p extends A.$Hv{constructor(c,m,o,n,i,r,s){super(m,o,n,i),this.c=c,this.m=r,this.q=s,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===L.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(m){return m?c.s(m):c.getText()},get eol(){return c.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(m){return c.t(m)},offsetAt(m){return c.u(m)},positionAt(m){return c.v(m)},validateRange(m){return c.w(m)},validatePosition(m){return c.x(m)},getWordRangeAtPosition(m,o){return c.y(m,o)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,u.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,u.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const m=this.w(c);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const o=this.g,n=m.start.line,i=m.end.line,r=[];r.push(this.f[n].substring(m.start.character));for(let s=n+1;s<i;s++)r.push(this.f[s]);return r.push(this.f[i].substring(0,m.end.character)),r.join(o)}t(c){let m;if(c instanceof b.$uM?m=c.line:typeof c=="number"&&(m=c),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new C(m,this.f[m],m===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const m=this.j.getIndexOf(c),o=this.f[m.index].length;return new b.$uM(m.index,Math.min(m.remainder,o))}w(c){if(!(c instanceof b.$vM))throw new Error("Invalid argument");const m=this.x(c.start),o=this.x(c.end);return m===c.start&&o===c.end?c:new b.$vM(m.line,m.character,o.line,o.character)}x(c){if(!(c instanceof b.$uM))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:m,character:o}=c,n=!1;if(m<0)m=0,o=0,n=!0;else if(m>=this.f.length)m=this.f.length-1,o=this.f[m].length,n=!0;else{const i=this.f[m].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new b.$uM(m,o):c}y(c,m){const o=this.x(c);if(!m)m=I(this.m);else if((0,O.$0e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const n=(0,M.$Rs)(o.character+1,(0,M.$Ps)(m),this.f[o.line],0);if(n)return new b.$vM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$PO=p;class C{constructor(c,m,o){this.a=c,this.b=m,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$vM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$vM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$QO=C}),define(ke[324],Ee([1,0,6,7]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;class O{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$rM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const v=this.a.get(M);if(!v)throw new Error("Embedding vector provider not found");const R=await v.provideEmbeddingVector(b,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(M,b,$){const v=this.b;return this.b++,this.a.set(v,$),this.c.$registerAiEmbeddingVectorProvider(b,v),new L.$tM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(v),this.a.delete(v)})}}e.$Ekc=O}),define(ke[69],Ee([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=e.$Rjc=void 0;let k=C=class{constructor(m,o){this.b=new Map,this.c=new R.$rh,this.a=m.getProxy(u.$rM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),r=await s.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===L.FilePermission.Readonly?1:void 0}}catch(r){C.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return C.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return C.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return C.e(r)}},async writeFile(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,A.$ue.wrap(r))}catch(s){return C.e(s)}},async delete(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return C.e(s)}},async rename(i,r,s){try{return await n.a.$rename(i,r,{overwrite:!1,...s})}catch(t){return C.e(t)}},async copy(i,r,s){try{return await n.a.$copy(i,r,{overwrite:!1,...s})}catch(t){return C.e(t)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(m,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await m.stat(n)).type&L.FileType.Directory))throw O.$JN.FileExists(`Unable to create folder '${n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(L.$5k(r)!==L.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(n)),n=o.dirname(n)}for(let r=i.length-1;r>=0;r--){n=o.joinPath(n,i[r]);try{await m.createDirectory(n)}catch(s){if(L.$5k(s)!==L.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof O.$JN)throw m;if(m instanceof L.$1k)switch(m.code){case L.FileSystemProviderErrorCode.FileExists:throw O.$JN.FileExists(m.message);case L.FileSystemProviderErrorCode.FileNotFound:throw O.$JN.FileNotFound(m.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw O.$JN.FileNotADirectory(m.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw O.$JN.FileIsADirectory(m.message);case L.FileSystemProviderErrorCode.NoPermissions:throw O.$JN.NoPermissions(m.message);case L.FileSystemProviderErrorCode.Unavailable:throw O.$JN.Unavailable(m.message);default:throw new O.$JN(m.message,m.name)}if(!(m instanceof Error))throw new O.$JN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw O.$JN.Unavailable(m.message);switch(m.name){case L.FileSystemProviderErrorCode.FileExists:throw O.$JN.FileExists(m.message);case L.FileSystemProviderErrorCode.FileNotFound:throw O.$JN.FileNotFound(m.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw O.$JN.FileNotADirectory(m.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw O.$JN.FileIsADirectory(m.message);case L.FileSystemProviderErrorCode.NoPermissions:throw O.$JN.NoPermissions(m.message);case L.FileSystemProviderErrorCode.Unavailable:throw O.$JN.Unavailable(m.message);default:throw new O.$JN(m.message,m.name)}}addFileSystemProvider(m,o,n){return this.b.set(m,{impl:o,extUri:n?.isCaseSensitive?I.$Lg:I.$Ng,isReadonly:!!n?.isReadonly}),(0,v.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??I.$Lg}};e.$Rjc=k,e.$Rjc=k=C=Je([qe(0,b.$MO),qe(1,$.$sjc)],k),e.$Sjc=(0,M.$ii)("IExtHostConsumerFileSystem")}),define(ke[325],Ee([1,0,6,7]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class O{constructor(M){this.a=new Map,this.b=new Map,this.c=M.getProxy(u.$rM.MainThreadIssueReporter)}async $getIssueReporterUri(M,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(M);if(!$)throw new Error("Issue request handler not found");const v=await $.handleIssueUrlRequest();if(!v)throw new Error("Issue request handler returned no result");return v}async $getIssueReporterData(M,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(M);if(!$)throw new Error("Issue data provider not found");const v=await $.provideIssueData(b);if(!v)throw new Error("Issue data provider returned no result");return v}async $getIssueReporterTemplate(M,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(M);if(!$)throw new Error("Issue data provider not found");const v=await $.provideIssueTemplate(b);if(!v)throw new Error("Issue template provider returned no result");return v}registerIssueUriRequestHandler(M,b){const $=M.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new L.$tM(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(M,b){const $=M.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new L.$tM(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$Vkc=O}),define(ke[93],Ee([1,0,5,28,12,69,2]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=e.$Tjc=void 0,e.$Tjc=(0,u.$ii)("IExtensionStoragePaths");let b=class{constructor(v,R,I){this.d=R,this.f=I,this.a=v.workspace??void 0,this.b=v.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(v){return M.URI.joinPath(this.b.workspaceStorageHome,v)}async h(){if(!this.a)return Promise.resolve(void 0);const v=this.a.id,R=await this.g(v);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(M.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(v){if(this.c)return M.URI.joinPath(this.c,v.identifier.value)}globalValue(v){return M.URI.joinPath(this.b.globalStorageHome,v.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ujc=b,e.$Ujc=b=Je([qe(0,L.$3O),qe(1,O.$Oj),qe(2,A.$Sjc)],b)}),define(ke[326],Ee([1,0,7,20,4]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;let A=class{constructor(b){this.a=new u.$TN(u.ColorThemeKind.Dark),this.b=new O.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=u.ColorThemeKind.Light;break;case"hcDark":$=u.ColorThemeKind.HighContrast;break;case"hcLight":$=u.ColorThemeKind.HighContrastLight;break;default:$=u.ColorThemeKind.Dark}this.a=new u.$TN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$mlc=A,e.$mlc=A=Je([qe(0,L.$MO)],A)}),define(ke[70],Ee([1,0,22,4,3,228,5,12,88,6,28,20,7]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Bb=e.$5Bb=e.TunnelDtoConverter=void 0;class C extends $.$7v{}var k;(function(m){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=n})(k||(e.TunnelDtoConverter=k={})),e.$5Bb=(0,M.$ii)("IExtHostTunnelService");let c=class extends O.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(v.$rM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const r=new C(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new p.$tM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,r,s){const t=[];for(const d of o){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(n.map(async a=>{let h;try{h=await l.provider.providePortAttributes({port:a,pid:i,commandLine:r},s)}catch{h=await l.provider.providePortAttributes(a,i,r,s)}return{providedAttributes:h,port:a}})))}const f=t.filter(d=>!!d.providedAttributes);return f.length>0?f.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await o.provideTunnel(r,s,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,O.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,O.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:s}),k.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$6Bb=c,e.$6Bb=c=Je([qe(0,I.$MO),qe(1,R.$3O),qe(2,b.$Oj)],c)}),define(ke[16],Ee([1,0,19,21,171,74,80,27,164,57,101,24,166,23,18,2,29,83,138,144,142,288,119,67,89,300,26,7]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f,d,l,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$JO=B,e.$KO=Y,e.$LO=_;var g;(function(Oe){function ze(ne){const{selectionStartLineNumber:Le,selectionStartColumn:Ve,positionLineNumber:et,positionColumn:Xe}=ne,ct=new h.$uM(Le-1,Ve-1),kt=new h.$uM(et-1,Xe-1);return new h.$wM(ct,kt)}Oe.to=ze;function ve(ne){const{anchor:Le,active:Ve}=ne;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Oe.from=ve})(g||(e.Selection=g={}));var S;(function(Oe){function ze(ne){if(!ne)return;const{start:Le,end:Ve}=ne;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Oe.from=ze;function ve(ne){if(!ne)return;const{startLineNumber:Le,startColumn:Ve,endLineNumber:et,endColumn:Xe}=ne;return new h.$vM(Le-1,Ve-1,et-1,Xe-1)}Oe.to=ve})(S||(e.Range=S={}));var w;(function(Oe){function ze(ne){return{uri:ne.uri,range:S.from(ne.range)}}Oe.from=ze;function ve(ne){return new h.$FM(c.URI.revive(ne.uri),S.to(ne.range))}Oe.to=ve})(w||(e.Location=w={}));var E;(function(Oe){function ze(ve){switch(ve){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Oe.to=ze})(E||(e.TokenType=E={}));var y;(function(Oe){function ze(ne){return new h.$uM(ne.lineNumber-1,ne.column-1)}Oe.to=ze;function ve(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Oe.from=ve})(y||(e.Position=y={}));var D;(function(Oe){function ze(Le,Ve,et){return(0,u.$Hb)((0,u.$3b)(Le).map(Xe=>ve(Xe,Ve,et)))}Oe.from=ze;function ve(Le,Ve,et){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:et?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:ne(Le.scheme,Ve),pattern:Pe.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:et?.isBuiltin}}function ne(Le,Ve){return Ve&&typeof Le=="string"?Ve.transformOutgoingScheme(Le):Le}})(D||(e.DocumentSelector=D={}));var P;(function(Oe){function ze(ne){switch(ne){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Oe.from=ze;function ve(ne){switch(ne){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Oe.to=ve})(P||(e.DiagnosticTag=P={}));var z;(function(Oe){function ze(ne){let Le;return ne.code&&((0,k.$Vf)(ne.code)||(0,k.$Zf)(ne.code)?Le=String(ne.code):Le={value:String(ne.code.value),target:ne.code.target}),{...S.from(ne.range),message:ne.message,source:ne.source,code:Le,severity:T.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(F.from),tags:Array.isArray(ne.tags)?(0,u.$Hb)(ne.tags.map(P.from)):void 0}}Oe.from=ze;function ve(ne){const Le=new h.$HM(S.to(ne),ne.message,T.to(ne.severity));return Le.source=ne.source,Le.code=(0,k.$Vf)(ne.code)?ne.code:ne.code?.value,Le.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(F.to),Le.tags=ne.tags&&(0,u.$Hb)(ne.tags.map(P.to)),Le}Oe.to=ve})(z||(e.Diagnostic=z={}));var F;(function(Oe){function ze(ne){return{...S.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Oe.from=ze;function ve(ne){return new h.$GM(new h.$FM(ne.resource,S.to(ne)),ne.message)}Oe.to=ve})(F||(e.DiagnosticRelatedInformation=F={}));var T;(function(Oe){function ze(ne){switch(ne){case h.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Oe.from=ze;function ve(ne){switch(ne){case n.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Oe.to=ve})(T||(e.DiagnosticSeverity=T={}));var j;(function(Oe){function ze(ne){return typeof ne=="number"&&ne>=h.ViewColumn.One?ne-1:ne===h.ViewColumn.Beside?l.$GD:l.$FD}Oe.from=ze;function ve(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=ve})(j||(e.ViewColumn=j={}));function N(Oe){return typeof Oe.range<"u"}function B(Oe){return Oe.length===0?!0:!!N(Oe[0])}var W;(function(Oe){function ze(Xe){return Xe.map(Oe.from)}Oe.fromMany=ze;function ve(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function ne(Xe){let ct;if(ve(Xe)){const{language:Lt,value:ht}=Xe;ct={value:"```"+Lt+`
`+ht+"\n```\n"}}else h.$UM.isMarkdownString(Xe)?ct={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?ct={value:Xe}:ct={value:""};const kt=Object.create(null);ct.uris=kt;const Kt=Lt=>{try{let ht=c.URI.parse(Lt,!0);ht=ht.with({query:Le(ht.query,kt)}),kt[Lt]=ht}catch{}return""},Vt=new $.marked.Renderer;return Vt.link=Kt,Vt.image=Lt=>typeof Lt=="string"?Kt(M.$Nk(Lt).href):"",(0,$.marked)(ct.value,{renderer:Vt}),ct}Oe.from=ne;function Le(Xe,ct){if(!Xe)return Xe;let kt;try{kt=(0,v.$Qh)(Xe)}catch{}if(!kt)return Xe;let Kt=!1;return kt=(0,I.$Qn)(kt,Vt=>{if(c.URI.isUri(Vt)){const Lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Lt]=Vt,Kt=!0,Lt}else return}),Kt?JSON.stringify(kt):Xe}function Ve(Xe){const ct=new h.$UM(Xe.value,Xe.supportThemeIcons);return ct.isTrusted=Xe.isTrusted,ct.supportHtml=Xe.supportHtml,ct.baseUri=Xe.baseUri?c.URI.from(Xe.baseUri):void 0,ct}Oe.to=Ve;function et(Xe){if(Xe)return typeof Xe=="string"?Xe:Oe.from(Xe)}Oe.fromStrict=et})(W||(e.MarkdownString=W={}));function Y(Oe){return B(Oe)?Oe.map(ze=>({range:S.from(ze.range),hoverMessage:Array.isArray(ze.hoverMessage)?W.fromMany(ze.hoverMessage):ze.hoverMessage?W.from(ze.hoverMessage):void 0,renderOptions:ze.renderOptions})):Oe.map(ze=>({range:S.from(ze)}))}function _(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?c.URI.file(Oe):Oe}var J;(function(Oe){function ze(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?_(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Oe.from=ze})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var Z;(function(Oe){function ze(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?_(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?J.from(ve.before):void 0,after:ve.after?J.from(ve.after):void 0}}Oe.from=ze})(Z||(e.ThemableDecorationRenderOptions=Z={}));var re;(function(Oe){function ze(ve){if(typeof ve>"u")return ve;switch(ve){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=ze})(re||(e.DecorationRangeBehavior=re={}));var ee;(function(Oe){function ze(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?re.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?Z.from(ve.light):void 0,dark:ve.dark?Z.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?_(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?J.from(ve.before):void 0,after:ve.after?J.from(ve.after):void 0}}Oe.from=ze})(ee||(e.DecorationRenderOptions=ee={}));var pe;(function(Oe){function ze(ne){return{text:ne.newText,eol:ne.newEol&&Ge.from(ne.newEol),range:S.from(ne.range)}}Oe.from=ze;function ve(ne){const Le=new h.$AM(S.to(ne.range),ne.text);return Le.newEol=typeof ne.eol>"u"?void 0:Ge.to(ne.eol),Le}Oe.to=ve})(pe||(e.TextEdit=pe={}));var De;(function(Oe){function ze(ne,Le){const Ve={edits:[]};if(ne instanceof h.$DM){const et=new b.$Cc;for(const Xe of ne._allEntries())Xe._type===1&&c.URI.isUri(Xe.to)&&Xe.from===void 0&&et.add(Xe.to);for(const Xe of ne._allEntries())if(Xe._type===1){let ct;Xe.options?.contents&&(ArrayBuffer.isView(Xe.options.contents)?ct={type:"base64",value:(0,L.$Oe)(L.$ue.wrap(Xe.options.contents))}:ct={type:"dataTransferItem",id:Xe.options.contents._itemId}),Ve.edits.push({oldResource:Xe.from,newResource:Xe.to,options:{...Xe.options,contents:ct},metadata:Xe.metadata})}else Xe._type===2?Ve.edits.push({resource:Xe.uri,textEdit:pe.from(Xe.edit),versionId:et.has(Xe.uri)?void 0:Le?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===6?Ve.edits.push({resource:Xe.uri,textEdit:{range:S.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:et.has(Xe.uri)?void 0:Le?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===3?Ve.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===5&&Ve.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Qt.from)}})}return Ve}Oe.from=ze;function ve(ne){const Le=new h.$DM,Ve=new b.$Bc;for(const et of ne.edits)if(et.textEdit){const Xe=et,ct=c.URI.revive(Xe.resource),kt=S.to(Xe.textEdit.range),Kt=Xe.textEdit.text,Vt=Xe.textEdit.insertAsSnippet;let Lt;Vt?Lt=h.$CM.replace(kt,new h.$EM(Kt)):Lt=h.$AM.replace(kt,Kt);const ht=Ve.get(ct);ht?ht.push(Lt):Ve.set(ct,[Lt])}else Le.renameFile(c.URI.revive(et.oldResource),c.URI.revive(et.newResource),et.options);for(const[et,Xe]of Ve)Le.set(et,Xe);return Le}Oe.to=ve})(De||(e.WorkspaceEdit=De={}));var x;(function(Oe){const ze=Object.create(null);ze[h.SymbolKind.File]=0,ze[h.SymbolKind.Module]=1,ze[h.SymbolKind.Namespace]=2,ze[h.SymbolKind.Package]=3,ze[h.SymbolKind.Class]=4,ze[h.SymbolKind.Method]=5,ze[h.SymbolKind.Property]=6,ze[h.SymbolKind.Field]=7,ze[h.SymbolKind.Constructor]=8,ze[h.SymbolKind.Enum]=9,ze[h.SymbolKind.Interface]=10,ze[h.SymbolKind.Function]=11,ze[h.SymbolKind.Variable]=12,ze[h.SymbolKind.Constant]=13,ze[h.SymbolKind.String]=14,ze[h.SymbolKind.Number]=15,ze[h.SymbolKind.Boolean]=16,ze[h.SymbolKind.Array]=17,ze[h.SymbolKind.Object]=18,ze[h.SymbolKind.Key]=19,ze[h.SymbolKind.Null]=20,ze[h.SymbolKind.EnumMember]=21,ze[h.SymbolKind.Struct]=22,ze[h.SymbolKind.Event]=23,ze[h.SymbolKind.Operator]=24,ze[h.SymbolKind.TypeParameter]=25;function ve(Le){return typeof ze[Le]=="number"?ze[Le]:6}Oe.from=ve;function ne(Le){for(const Ve in ze)if(ze[Ve]===Le)return Number(Ve);return h.SymbolKind.Property}Oe.to=ne})(x||(e.SymbolKind=x={}));var U;(function(Oe){function ze(ne){switch(ne){case h.SymbolTag.Deprecated:return 1}}Oe.from=ze;function ve(ne){switch(ne){case 1:return h.SymbolTag.Deprecated}}Oe.to=ve})(U||(e.SymbolTag=U={}));var ie;(function(Oe){function ze(ne){return{name:ne.name,kind:x.from(ne.kind),tags:ne.tags&&ne.tags.map(U.from),containerName:ne.containerName,location:se.from(ne.location)}}Oe.from=ze;function ve(ne){const Le=new h.$LM(ne.name,x.to(ne.kind),ne.containerName,se.to(ne.location));return Le.tags=ne.tags&&ne.tags.map(U.to),Le}Oe.to=ve})(ie||(e.WorkspaceSymbol=ie={}));var be;(function(Oe){function ze(ne){const Le={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:S.from(ne.range),selectionRange:S.from(ne.selectionRange),kind:x.from(ne.kind),tags:ne.tags?.map(U.from)??[]};return ne.children&&(Le.children=ne.children.map(ze)),Le}Oe.from=ze;function ve(ne){const Le=new h.$MM(ne.name,ne.detail,x.to(ne.kind),S.to(ne.range),S.to(ne.selectionRange));return(0,u.$Lb)(ne.tags)&&(Le.tags=ne.tags.map(U.to)),ne.children&&(Le.children=ne.children.map(ve)),Le}Oe.to=ve})(be||(e.DocumentSymbol=be={}));var Ce;(function(Oe){function ze(ne){const Le=new h.$QM(x.to(ne.kind),ne.name,ne.detail||"",c.URI.revive(ne.uri),S.to(ne.range),S.to(ne.selectionRange));return Le._sessionId=ne._sessionId,Le._itemId=ne._itemId,Le}Oe.to=ze;function ve(ne,Le,Ve){if(Le=Le??ne._sessionId,Ve=Ve??ne._itemId,Le===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ve,name:ne.name,detail:ne.detail,kind:x.from(ne.kind),uri:ne.uri,range:S.from(ne.range),selectionRange:S.from(ne.selectionRange),tags:ne.tags?.map(U.from)}}Oe.from=ve})(Ce||(e.CallHierarchyItem=Ce={}));var ae;(function(Oe){function ze(ve){return new h.$RM(Ce.to(ve.from),ve.fromRanges.map(ne=>S.to(ne)))}Oe.to=ze})(ae||(e.CallHierarchyIncomingCall=ae={}));var ce;(function(Oe){function ze(ve){return new h.$SM(Ce.to(ve.to),ve.fromRanges.map(ne=>S.to(ne)))}Oe.to=ze})(ce||(e.CallHierarchyOutgoingCall=ce={}));var se;(function(Oe){function ze(ne){return{range:ne.range&&S.from(ne.range),uri:ne.uri}}Oe.from=ze;function ve(ne){return new h.$FM(c.URI.revive(ne.uri),S.to(ne.range))}Oe.to=ve})(se||(e.location=se={}));var K;(function(Oe){function ze(ne){const Le=ne,Ve=ne;return{originSelectionRange:Le.originSelectionRange?S.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ve.uri,range:S.from(Le.targetRange?Le.targetRange:Ve.range),targetSelectionRange:Le.targetSelectionRange?S.from(Le.targetSelectionRange):void 0}}Oe.from=ze;function ve(ne){return{targetUri:c.URI.revive(ne.uri),targetRange:S.to(ne.range),targetSelectionRange:ne.targetSelectionRange?S.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?S.to(ne.originSelectionRange):void 0}}Oe.to=ve})(K||(e.DefinitionLink=K={}));var te;(function(Oe){function ze(ne){return{range:S.from(ne.range),contents:W.fromMany(ne.contents)}}Oe.from=ze;function ve(ne){return new h.$IM(ne.contents.map(W.to),S.to(ne.range))}Oe.to=ve})(te||(e.Hover=te={}));var le;(function(Oe){function ze(ne){return{range:S.from(ne.range),expression:ne.expression}}Oe.from=ze;function ve(ne){return new h.$DN(S.to(ne.range),ne.expression)}Oe.to=ve})(le||(e.EvaluatableExpression=le={}));var de;(function(Oe){function ze(ne){if(ne instanceof h.$EN)return{type:"text",range:S.from(ne.range),text:ne.text};if(ne instanceof h.$FN)return{type:"variable",range:S.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof h.$GN)return{type:"expression",range:S.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=ze;function ve(ne){switch(ne.type){case"text":return{range:S.to(ne.range),text:ne.text};case"variable":return{range:S.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:S.to(ne.range),expression:ne.expression}}}Oe.to=ve})(de||(e.InlineValue=de={}));var Ae;(function(Oe){function ze(ne){return{frameId:ne.frameId,stoppedLocation:S.from(ne.stoppedLocation)}}Oe.from=ze;function ve(ne){return new h.$HN(ne.frameId,S.to(ne.stoppedLocation))}Oe.to=ve})(Ae||(e.InlineValueContext=Ae={}));var me;(function(Oe){function ze(ne){return{range:S.from(ne.range),kind:ne.kind}}Oe.from=ze;function ve(ne){return new h.$JM(S.to(ne.range),ne.kind)}Oe.to=ve})(me||(e.DocumentHighlight=me={}));var Ie;(function(Oe){function ze(ne){return{uri:ne.uri,highlights:ne.highlights.map(me.from)}}Oe.from=ze;function ve(ne){return new h.$KM(c.URI.revive(ne.uri),ne.highlights.map(me.to))}Oe.to=ve})(Ie||(e.MultiDocumentHighlight=Ie={}));var Re;(function(Oe){function ze(ve){switch(ve){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Oe.to=ze})(Re||(e.CompletionTriggerKind=Re={}));var Fe;(function(Oe){function ze(ve){return{triggerKind:Re.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Oe.to=ze})(Fe||(e.CompletionContext=Fe={}));var q;(function(Oe){function ze(ne){switch(ne){case h.CompletionItemTag.Deprecated:return 1}}Oe.from=ze;function ve(ne){switch(ne){case 1:return h.CompletionItemTag.Deprecated}}Oe.to=ve})(q||(e.CompletionItemTag=q={}));var V;(function(Oe){const ze=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ve(Ve){return ze.get(Ve)??9}Oe.from=ve;const ne=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Le(Ve){return ne.get(Ve)??h.CompletionItemKind.Property}Oe.to=Le})(V||(e.CompletionItemKind=V={}));var X;(function(Oe){function ze(ve,ne){const Le=new h.$1M(ve.label);return Le.insertText=ve.insertText,Le.kind=V.to(ve.kind),Le.tags=ve.tags?.map(q.to),Le.detail=ve.detail,Le.documentation=M.$Hk(ve.documentation)?W.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,m.$ct.isIRange(ve.range)?Le.range=S.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:S.to(ve.range.insert),replacing:S.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Le.insertText=new h.$EM(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof h.$vM?new h.$AM(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(Ve=>pe.to(Ve))),Le.command=ne&&ve.command?ne.fromInternal(ve.command):void 0,Le}Oe.to=ze})(X||(e.CompletionItem=X={}));var Q;(function(Oe){function ze(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:W.fromStrict(ne.documentation)}}Oe.from=ze;function ve(ne){return{label:ne.label,documentation:M.$Hk(ne.documentation)?W.to(ne.documentation):ne.documentation}}Oe.to=ve})(Q||(e.ParameterInformation=Q={}));var fe;(function(Oe){function ze(ne){return{label:ne.label,documentation:W.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(Q.from):[],activeParameter:ne.activeParameter}}Oe.from=ze;function ve(ne){return{label:ne.label,documentation:M.$Hk(ne.documentation)?W.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(Q.to):[],activeParameter:ne.activeParameter}}Oe.to=ve})(fe||(e.SignatureInformation=fe={}));var we;(function(Oe){function ze(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(fe.from):[]}}Oe.from=ze;function ve(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(fe.to):[]}}Oe.to=ve})(we||(e.SignatureHelp=we={}));var Te;(function(Oe){function ze(ve,ne){const Le=new h.$ZM(y.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(He.to.bind(void 0,ve)),ne.kind&&xe.to(ne.kind));return Le.textEdits=ne.textEdits&&ne.textEdits.map(pe.to),Le.tooltip=M.$Hk(ne.tooltip)?W.to(ne.tooltip):ne.tooltip,Le.paddingLeft=ne.paddingLeft,Le.paddingRight=ne.paddingRight,Le}Oe.to=ze})(Te||(e.InlayHint=Te={}));var He;(function(Oe){function ze(ve,ne){const Le=new h.$YM(ne.label);return Le.tooltip=M.$Hk(ne.tooltip)?W.to(ne.tooltip):ne.tooltip,o.Command.is(ne.command)&&(Le.command=ve.fromInternal(ne.command)),ne.location&&(Le.location=se.to(ne.location)),Le}Oe.to=ze})(He||(e.InlayHintLabelPart=He={}));var xe;(function(Oe){function ze(ne){return ne}Oe.from=ze;function ve(ne){return ne}Oe.to=ve})(xe||(e.InlayHintKind=xe={}));var it;(function(Oe){function ze(ne){return{range:S.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Oe.from=ze;function ve(ne){let Le;if(ne.url)try{Le=typeof ne.url=="string"?c.URI.parse(ne.url,!0):c.URI.revive(ne.url)}catch{}return new h.$6M(S.to(ne.range),Le)}Oe.to=ve})(it||(e.DocumentLink=it={}));var rt;(function(Oe){function ze(ne){const Le=new h.$9M(ne.label);return ne.textEdit&&(Le.textEdit=pe.to(ne.textEdit)),ne.additionalTextEdits&&(Le.additionalTextEdits=ne.additionalTextEdits.map(Ve=>pe.to(Ve))),Le}Oe.to=ze;function ve(ne){return{label:ne.label,textEdit:ne.textEdit?pe.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Le=>pe.from(Le)):void 0}}Oe.from=ve})(rt||(e.ColorPresentation=rt={}));var at;(function(Oe){function ze(ne){return new h.$7M(ne[0],ne[1],ne[2],ne[3])}Oe.to=ze;function ve(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Oe.from=ve})(at||(e.Color=at={}));var ot;(function(Oe){function ze(ne){return{range:S.from(ne.range)}}Oe.from=ze;function ve(ne){return new h.$PM(S.to(ne.range))}Oe.to=ve})(ot||(e.SelectionRange=ot={}));var Se;(function(Oe){function ze(ve){switch(ve){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Oe.to=ze})(Se||(e.TextDocumentSaveReason=Se={}));var Be;(function(Oe){function ze(ne){switch(ne){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.Interval:return 3;case h.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=ze;function ve(ne){switch(ne){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 3:return h.TextEditorLineNumbersStyle.Interval;case 1:default:return h.TextEditorLineNumbersStyle.On}}Oe.to=ve})(Be||(e.TextEditorLineNumbersStyle=Be={}));var Ge;(function(Oe){function ze(ne){if(ne===h.EndOfLine.CRLF)return 1;if(ne===h.EndOfLine.LF)return 0}Oe.from=ze;function ve(ne){if(ne===1)return h.EndOfLine.CRLF;if(ne===0)return h.EndOfLine.LF}Oe.to=ve})(Ge||(e.EndOfLine=Ge={}));var Me;(function(Oe){function ze(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=ze})(Me||(e.ProgressLocation=Me={}));var Qe;(function(Oe){function ze(ne){const Le={start:ne.start+1,end:ne.end+1};return ne.kind&&(Le.kind=oe.from(ne.kind)),Le}Oe.from=ze;function ve(ne){const Le={start:ne.start-1,end:ne.end-1};return ne.kind&&(Le.kind=oe.to(ne.kind)),Le}Oe.to=ve})(Qe||(e.FoldingRange=Qe={}));var oe;(function(Oe){function ze(ne){if(ne)switch(ne){case h.FoldingRangeKind.Comment:return o.$7t.Comment;case h.FoldingRangeKind.Imports:return o.$7t.Imports;case h.FoldingRangeKind.Region:return o.$7t.Region}}Oe.from=ze;function ve(ne){if(ne)switch(ne.value){case o.$7t.Comment.value:return h.FoldingRangeKind.Comment;case o.$7t.Imports.value:return h.FoldingRangeKind.Imports;case o.$7t.Region.value:return h.FoldingRangeKind.Region}}Oe.to=ve})(oe||(e.FoldingRangeKind=oe={}));var ue;(function(Oe){function ze(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?S.from(ve.selection):void 0,override:typeof ve.override=="boolean"?r.$9E.id:void 0}}Oe.from=ze})(ue||(e.TextEditorOpenOptions=ue={}));var Pe;(function(Oe){function ze(Ve){return Ve instanceof h.$rN?Ve.toJSON():typeof Ve=="string"?Ve:ve(Ve)||ne(Ve)?new h.$rN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Oe.from=ze;function ve(Ve){const et=Ve;return et?c.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function ne(Ve){const et=Ve;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Le(Ve){return typeof Ve=="string"?Ve:new h.$rN(c.URI.revive(Ve.baseUri),Ve.pattern)}Oe.to=Le})(Pe||(e.GlobPattern=Pe={}));var Ke;(function(Oe){function ze(ve){if(ve){if(Array.isArray(ve))return ve.map(ze);if(typeof ve=="string")return ve;{const ne=ve;return{language:ne.language,scheme:ne.scheme,pattern:Pe.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Oe.from=ze})(Ke||(e.LanguageSelector=Ke={}));var _e;(function(Oe){function ze(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Le=>Array.isArray(Le)&&Le.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&c.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(et=>et instanceof h.$vM)))}Oe.is=ze;function ve(ne){return{documents:ne.documents.map(Le=>Le.map(Ve=>({uri:c.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(et=>S.from(et))})))}}Oe.from=ve})(_e||(e.MappedEditsContext=_e={}));var Ne;(function(Oe){function ze(ne){return{start:ne.start,end:ne.end}}Oe.from=ze;function ve(ne){return new h.$UN(ne.start,ne.end)}Oe.to=ve})(Ne||(e.NotebookRange=Ne={}));var lt;(function(Oe){function ze(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Oe.to=ze;function ve(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Oe.from=ve})(lt||(e.NotebookCellExecutionSummary=lt={}));var wt;(function(Oe){function ze(ve){if(ve===t.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ve===t.NotebookCellExecutionState.Pending)return;if(ve===t.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Oe.to=ze})(wt||(e.NotebookCellExecutionState=wt={}));var At;(function(Oe){function ze(ne){switch(ne){case h.NotebookCellKind.Markup:return t.CellKind.Markup;case h.NotebookCellKind.Code:default:return t.CellKind.Code}}Oe.from=ze;function ve(ne){switch(ne){case t.CellKind.Markup:return h.NotebookCellKind.Markup;case t.CellKind.Code:default:return h.NotebookCellKind.Code}}Oe.to=ve})(At||(e.NotebookCellKind=At={}));var zt;(function(Oe){function ze(ne){const Le={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ve of ne.cells)h.$VN.validate(Ve),Le.cells.push(Qt.from(Ve));return Le}Oe.from=ze;function ve(ne){const Le=new h.$WN(ne.cells.map(Qt.to));return(0,k.$9f)(ne.metadata)||(Le.metadata=ne.metadata),Le}Oe.to=ve})(zt||(e.NotebookData=zt={}));var Qt;(function(Oe){function ze(ne){return{cellKind:At.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:lt.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Ct.from):[]}}Oe.from=ze;function ve(ne){return new h.$VN(At.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Ct.to):void 0,ne.metadata,ne.internalMetadata?lt.to(ne.internalMetadata):void 0)}Oe.to=ve})(Qt||(e.NotebookCellData=Qt={}));var _t;(function(Oe){function ze(ne){return{mime:ne.mime,valueBytes:L.$ue.wrap(ne.data)}}Oe.from=ze;function ve(ne){return new h.$XN(ne.valueBytes.buffer,ne.mime)}Oe.to=ve})(_t||(e.NotebookCellOutputItem=_t={}));var Ct;(function(Oe){function ze(ne){return{outputId:ne.id,items:ne.items.map(_t.from),metadata:ne.metadata}}Oe.from=ze;function ve(ne){const Le=ne.items.map(_t.to);return new h.$YN(Le,ne.outputId,ne.metadata)}Oe.to=ve})(Ct||(e.NotebookCellOutput=Ct={}));var Xt;(function(Oe){function ze(Le){return ne(Le)?{include:Pe.from(Le.include)??void 0,exclude:Pe.from(Le.exclude)??void 0}:Pe.from(Le)??void 0}Oe.from=ze;function ve(Le){return ne(Le)?{include:Pe.to(Le.include),exclude:Pe.to(Le.exclude)}:Pe.to(Le)}Oe.to=ve;function ne(Le){const Ve=Le;return Ve?!(0,k.$5f)(Ve.include)&&!(0,k.$5f)(Ve.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var qt;(function(Oe){function ze(ve,ne,Le){const Ve=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ve,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Oe.from=ze})(qt||(e.NotebookStatusBarItem=qt={}));var ai;(function(Oe){function ze(ve,ne,Le){const Ve=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ne.toInternal(Ve,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Oe.from=ze})(ai||(e.NotebookKernelSourceAction=ai={}));var tt;(function(Oe){function ze(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Oe.from=ze})(tt||(e.NotebookDocumentContentOptions=tt={}));var ei;(function(Oe){function ze(ne){return{uri:ne.uri,provides:ne.provides}}Oe.from=ze;function ve(ne){return new h.$1N(c.URI.revive(ne.uri),ne.provides)}Oe.to=ve})(ei||(e.NotebookRendererScript=ei={}));var ti;(function(Oe){function ze(ne){return{message:W.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:S.from(ne.location.range),uri:ne.location.uri}}}Oe.from=ze;function ve(ne){const Le=new h.$7N(typeof ne.message=="string"?ne.message:W.to(ne.message));return Le.actualOutput=ne.actual,Le.expectedOutput=ne.expected,Le.contextValue=ne.contextValue,Le.location=ne.location?se.to(ne.location):void 0,Le}Oe.to=ve})(ti||(e.TestMessage=ti={}));var ft;(function(Oe){Oe.namespace=d.$iL,Oe.denamespace=d.$jL})(ft||(e.TestTag=ft={}));var bt;(function(Oe){function ze(ne){const Le=(0,i.$IO)(ne).controllerId;return{extId:f.$dL.fromExtHostTestItem(ne,Le).toString(),label:ne.label,uri:c.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ve=>ft.namespace(Le,Ve.id)),range:m.$ct.lift(S.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&W.fromStrict(ne.error)||null}}Oe.from=ze;function ve(ne){return{parent:void 0,error:void 0,id:f.$dL.fromString(ne.extId).localId,label:ne.label,uri:c.URI.revive(ne.uri),tags:(ne.tags||[]).map(Le=>{const{tagId:Ve}=ft.denamespace(Le);return new h.$8N(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:S.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Oe.toPlain=ve})(bt||(e.TestItem=bt={})),function(Oe){function ze(ne){return{id:ne.id}}Oe.from=ze;function ve(ne){return new h.$8N(ne.id)}Oe.to=ve}(ft||(e.TestTag=ft={}));var si;(function(Oe){const ze=(ne,Le)=>{const Ve=ne.value;if(!Ve)return;const et={...bt.toPlain(Ve.item),parent:Le,taskStates:Ve.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(ct=>ct.type===0).map(ti.to)})),children:[]};if(ne.children)for(const Xe of ne.children.values()){const ct=ze(Xe,et);ct&&et.children.push(ct)}return et};function ve(ne){const Le=new p.$BO;for(const Xe of ne.items)Le.insert(f.$dL.fromString(Xe.item.extId).path,Xe);const Ve=[Le.nodes],et=[];for(;Ve.length;)for(const Xe of Ve.pop())Xe.value?et.push(Xe):Xe.children&&Ve.push(Xe.children.values());return{completedAt:ne.completedAt,results:et.map(Xe=>ze(Xe)).filter(k.$4f)}}Oe.to=ve})(si||(e.TestResults=si={}));var ii;(function(Oe){function ze(Ve){return{covered:Ve.covered,total:Ve.total}}function ve(Ve){return"line"in Ve?y.from(Ve):S.from(Ve)}function ne(Ve){return"branches"in Ve?{count:Ve.executed,location:ve(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(et=>({count:et.executed,location:et.location&&ve(et.location),label:et.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:ve(Ve.location)}}Oe.fromDetails=ne;function Le(Ve,et){return{id:Ve,uri:et.uri,statement:ze(et.statementCoverage),branch:et.branchCoverage&&ze(et.branchCoverage),declaration:et.declarationCoverage&&ze(et.declarationCoverage)}}Oe.fromFile=Le})(ii||(e.TestCoverage=ii={}));var jt;(function(Oe){function ze(ve){switch(ve){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Oe.to=ze})(jt||(e.CodeActionTriggerKind=jt={}));var mt;(function(Oe){function ze(ne){const Le=new h.$bO(x.to(ne.kind),ne.name,ne.detail||"",c.URI.revive(ne.uri),S.to(ne.range),S.to(ne.selectionRange));return Le._sessionId=ne._sessionId,Le._itemId=ne._itemId,Le}Oe.to=ze;function ve(ne,Le,Ve){if(Le=Le??ne._sessionId,Ve=Ve??ne._itemId,Le===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ve,kind:x.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:S.from(ne.range),selectionRange:S.from(ne.selectionRange),tags:ne.tags?.map(U.from)}}Oe.from=ve})(mt||(e.TypeHierarchyItem=mt={}));var Rt;(function(Oe){function ze(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Oe.from=ze})(Rt||(e.ViewBadge=Rt={}));var Ht;(function(Oe){function ze(Ve,et,Xe){const ct=et.fileData;return ct?new h.$jN(new h.$kN(ct.name,c.URI.revive(ct.uri),ct.id,(0,A.$db)(()=>Xe(ct.id)))):Ve===R.$zs.uriList&&et.uriListData?new h.$iN(Le(et.uriListData)):new h.$iN(et.asString)}Oe.to=ze;async function ve(Ve,et){const Xe=await et.asString();if(Ve===R.$zs.uriList)return{asString:Xe,fileData:void 0,uriListData:ne(Xe)};const ct=et.asFile();return{asString:Xe,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Oe.from=ve;function ne(Ve){return O.$Lt.split(Ve).map(et=>{if(et.startsWith("#"))return et;try{return c.URI.parse(et)}catch{}return et})}function Le(Ve){return O.$Lt.create(Ve.map(et=>typeof et=="string"?et:c.URI.revive(et)))}})(Ht||(e.DataTransferItem=Ht={}));var Zt;(function(Oe){function ze(ne,Le){const Ve=ne.items.map(([et,Xe])=>[et,Ht.to(et,Xe,Le)]);return new h.$lN(Ve)}Oe.toDataTransfer=ze;async function ve(ne){const Le={items:[]},Ve=[];for(const[et,Xe]of ne)Ve.push((async()=>{Le.items.push([et,await Ht.from(et,Xe)])})());return await Promise.all(Ve),Le}Oe.from=ve})(Zt||(e.DataTransfer=Zt={}));var Ze;(function(Oe){function ze(ne,Le){return{kind:"reply",agentId:ne.participant??Le?.agentId??"",subCommand:ne.command??Le?.command,message:ne.prompt,title:ne.label}}Oe.from=ze;function ve(ne){return{prompt:ne.message,label:ne.title,participant:ne.agentId,command:ne.subCommand}}Oe.to=ve})(Ze||(e.ChatFollowup=Ze={}));var Yt;(function(Oe){function ze(ve){return"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",when:ve.when??"",args:ve.args}:{kind:"reply",message:ve.message,title:ve.title,tooltip:ve.tooltip}}Oe.from=ze})(Yt||(e.ChatInlineFollowup=Yt={}));var Bt;(function(Oe){function ze(ne){switch(ne.role){case 0:return new h.$wO(ne.content);case 1:return new h.$xO(ne.content);case 2:return new h.$yO(ne.content)}}Oe.to=ze;function ve(ne){if(ne instanceof h.$wO)return{role:0,content:ne.content};if(ne instanceof h.$xO)return{role:1,content:ne.content};if(ne instanceof h.$yO)return{role:2,content:ne.content};throw new Error("Invalid LanguageModelMessage")}Oe.from=ve})(Bt||(e.LanguageModelMessage=Bt={}));var Ut;(function(Oe){function ze(Le){const Ve={};for(const et of Object.keys(Le))Ve[et]=Le[et].map(Oe.to);return Ve}Oe.objectTo=ze;function ve(Le){return{level:$t.to(Le.level),kind:Le.kind,value:(0,c.$wc)(Le.value)?c.URI.revive(Le.value):Le.value,description:Le.description}}Oe.to=ve;function ne(Le){return{level:$t.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Oe.from=ne})(Ut||(e.ChatVariable=Ut={}));var $t;(function(Oe){function ze(ne){switch(ne){case"short":return h.ChatVariableLevel.Short;case"medium":return h.ChatVariableLevel.Medium;case"full":default:return h.ChatVariableLevel.Full}}Oe.to=ze;function ve(ne){switch(ne){case h.ChatVariableLevel.Short:return"short";case h.ChatVariableLevel.Medium:return"medium";case h.ChatVariableLevel.Full:default:return"full"}}Oe.from=ve})($t||(e.ChatVariableLevel=$t={}));var Ft;(function(Oe){function ze(ve){switch(ve){case 1:return h.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return h.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return h.InteractiveEditorResponseFeedbackKind.Undone;case 3:return h.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return h.InteractiveEditorResponseFeedbackKind.Bug}}Oe.to=ze})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Mt;(function(Oe){function ze(ne){return{kind:"markdownContent",content:W.from(ne.value)}}Oe.to=ze;function ve(ne){return new h.$oO(W.to(ne.content))}Oe.from=ve})(Mt||(e.ChatResponseMarkdownPart=Mt={}));var Tt;(function(Oe){function ze(ne){const{value:Le,baseUri:Ve}=ne;function et(Xe,ct){return Xe.map(kt=>{const Kt=c.URI.joinPath(ct,kt.name);return{label:kt.name,uri:Kt,children:kt.children&&et(kt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,C.$Sg)(Ve),uri:Ve,children:et(Le,Ve)}}}Oe.to=ze;function ve(ne){const Le=(0,v.$Rh)(ne.treeData);function Ve(ct){return ct.map(kt=>({name:kt.label,children:kt.children&&Ve(kt.children)}))}const et=Le.uri,Xe=Le.children?Ve(Le.children):[];return new h.$pO(Xe,et)}Oe.from=ve})(Tt||(e.ChatResponseFilesPart=Tt={}));var ni;(function(Oe){function ze(ne){return{kind:"inlineReference",name:ne.title,inlineReference:c.URI.isUri(ne.value)?ne.value:w.from(ne.value)}}Oe.to=ze;function ve(ne){const Le=(0,v.$Rh)(ne);return new h.$qO(c.URI.isUri(Le.inlineReference)?Le.inlineReference:w.to(Le.inlineReference),ne.name)}Oe.from=ve})(ni||(e.ChatResponseAnchorPart=ni={}));var oi;(function(Oe){function ze(ne){return{kind:"progressMessage",content:W.from(ne.value)}}Oe.to=ze;function ve(ne){return new h.$rO(ne.content.value)}Oe.from=ve})(oi||(e.ChatResponseProgressPart=oi={}));var Wt;(function(Oe){function ze(ne,Le,Ve){return{kind:"command",command:Le.toInternal(ne.value,Ve)??{command:ne.value.command,title:ne.value.title}}}Oe.to=ze;function ve(ne,Le){return new h.$sO(Le.fromInternal(ne.command)??{command:ne.command.id,title:ne.command.title})}Oe.from=ve})(Wt||(e.ChatResponseCommandButtonPart=Wt={}));var It;(function(Oe){function ze(ne){return{kind:"reference",reference:c.URI.isUri(ne.value)?ne.value:w.from(ne.value)}}Oe.to=ze;function ve(ne){const Le=(0,v.$Rh)(ne);return new h.$tO(c.URI.isUri(Le.reference)?Le.reference:w.to(Le.reference))}Oe.from=ve})(It||(e.ChatResponseReferencePart=It={}));var St;(function(Oe){function ze(Le,Ve,et){return Le instanceof h.$oO?Mt.to(Le):Le instanceof h.$qO?ni.to(Le):Le instanceof h.$tO?It.to(Le):Le instanceof h.$rO?oi.to(Le):Le instanceof h.$pO?Tt.to(Le):Le instanceof h.$sO?Wt.to(Le,Ve,et):{kind:"content",content:""}}Oe.to=ze;function ve(Le,Ve){switch(Le.kind){case"reference":return It.from(Le);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ne(Le,Ve)}}Oe.from=ve;function ne(Le,Ve){switch(Le.kind){case"markdownContent":return Mt.from(Le);case"inlineReference":return ni.from(Le);case"progressMessage":return;case"treeData":return Tt.from(Le);case"command":return Wt.from(Le,Ve)}}Oe.fromContent=ne})(St||(e.ChatResponsePart=St={}));var Gt;(function(Oe){function ze(Le,Ve){return"markdownContent"in Ve?((0,a.$cG)(Le,"chatParticipantAdditions"),{content:W.from(Ve.markdownContent),kind:"markdownContent"}):"content"in Ve?"vulnerabilities"in Ve&&Ve.vulnerabilities?((0,a.$cG)(Le,"chatParticipantAdditions"),{content:Ve.content,vulnerabilities:Ve.vulnerabilities,kind:"vulnerability"}):typeof Ve.content=="string"?{content:Ve.content,kind:"content"}:((0,a.$cG)(Le,"chatParticipantAdditions"),{content:W.from(Ve.content),kind:"markdownContent"}):"documents"in Ve?{documents:Ve.documents.map(et=>({uri:et.uri,version:et.version,ranges:et.ranges.map(Xe=>S.from(Xe))})),kind:"usedContext"}:"reference"in Ve?{reference:"uri"in Ve.reference?{uri:Ve.reference.uri,range:S.from(Ve.reference.range)}:Ve.reference,kind:"reference"}:"inlineReference"in Ve?{inlineReference:"uri"in Ve.inlineReference?{uri:Ve.inlineReference.uri,range:S.from(Ve.inlineReference.range)}:Ve.inlineReference,name:Ve.title,kind:"inlineReference"}:"participant"in Ve?((0,a.$cG)(Le,"chatParticipantAdditions"),{agentId:Ve.participant,command:Ve.command,kind:"agentDetection"}):"message"in Ve?{content:W.from(Ve.message),kind:"progressMessage"}:void 0}Oe.from=ze;function ve(Le){switch(Le.kind){case"markdownContent":case"inlineReference":case"treeData":return Oe.to(Le);case"content":return{content:Le.content};case"usedContext":return{documents:Le.documents.map(Ve=>({uri:c.URI.revive(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(et=>S.to(et))}))};case"reference":return{reference:(0,c.$wc)(Le.reference)?c.URI.revive(Le.reference):w.to(Le.reference)};case"agentDetection":return;case"progressMessage":return{message:Le.content.value};case"vulnerability":return{content:Le.content,vulnerabilities:Le.vulnerabilities};default:return}}Oe.to=ve;function ne(Le,Ve){switch(Le.kind){case"markdownContent":return{content:Le.content.value};case"inlineReference":return{inlineReference:(0,c.$wc)(Le.inlineReference)?c.URI.revive(Le.inlineReference):w.to(Le.inlineReference),title:Le.name};case"command":return{command:Ve.fromInternal(Le.command)??{command:Le.command.id,title:Le.command.title}};default:return}}Oe.toProgressContent=ne})(Gt||(e.ChatResponseProgress=Gt={}));var Pt;(function(Oe){function ze(ve){return{prompt:ve.message,command:ve.command,variables:ve.variables.variables.map(Dt.to),location:yt.to(ve.location)}}Oe.to=ze})(Pt||(e.ChatAgentRequest=Pt={}));var yt;(function(Oe){function ze(ve){switch(ve){case s.ChatAgentLocation.Notebook:return h.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return h.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return h.ChatLocation.Panel}}Oe.to=ze})(yt||(e.ChatLocation=yt={}));var Dt;(function(Oe){function ze(ve){return{name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],values:ve.values.map(Ut.to)}}Oe.to=ze})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var Et;(function(Oe){function ze(ve){return{label:ve.label,values:ve.values.map(Ut.from),insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation}}Oe.from=ze})(Et||(e.ChatAgentCompletionItem=Et={}));var ui;(function(Oe){function ze(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Oe.to=ze})(ui||(e.ChatAgentResult=ui={}));var ri;(function(Oe){function ze(ve,ne,Le){if(ne.action.kind==="vote")return;const Ve=ui.to(ve);return ne.action.kind==="command"?{action:{kind:"command",commandButton:Gt.toProgressContent(ne.action.commandButton,Le)},result:Ve}:ne.action.kind==="followUp"?{action:{kind:"followUp",followup:Ze.to(ne.action.followup)},result:Ve}:{action:ne.action,result:Ve}}Oe.to=ze})(ri||(e.ChatAgentUserActionEvent=ri={}));var li;(function(Oe){function ze(ve,ne,Le){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ne.toInternal(ve,Le)}Oe.from=ze})(li||(e.TerminalQuickFix=li={}));var di;(function(Oe){function ze(ve){return{kind:xt.to(ve.kind)}}Oe.to=ze})(di||(e.PartialAcceptInfo=di={}));var xt;(function(Oe){function ze(ve){switch(ve){case 0:return h.PartialAcceptTriggerKind.Word;case 1:return h.PartialAcceptTriggerKind.Line;case 2:return h.PartialAcceptTriggerKind.Suggest;default:return h.PartialAcceptTriggerKind.Unknown}}Oe.to=ze})(xt||(e.PartialAcceptTriggerKind=xt={}));var Ot;(function(Oe){function ze(ve,ne){return{id:ne,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||0,contextValue:ve.contextValue}}Oe.from=ze})(Ot||(e.DebugTreeItem=Ot={}))}),define(ke[327],Ee([1,0,6,20,16]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=void 0;let A=class{constructor(b,$){this.a=b.getProxy(u.$rM.MainThreadBulkEdits),this.b={getTextDocumentVersion:v=>$.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,v){const R=O.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,v?.isRefactoring??!1)}};e.$Ajc=A,e.$Ajc=A=Je([qe(0,L.$MO)],A)}),define(ke[328],Ee([1,0,19,8,46,4,38,3,39,18,2,217,25,6,16,7,289,26]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;class n{constructor(t,f,d,l,a,h){this.i=t,this.j=f,this.k=d,this.l=l,this.m=a,this.n=h,this.b=$.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(l){if(t.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,l),a}};const t=this;this.b.reset();const d=l=>{typeof this.d>"u"&&"content"in l&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,l)};this.g={markdown(l){f(this.markdown);const a=new c.$oO(l),h=k.ChatResponseMarkdownPart.to(a);return d(h),this},filetree(l,a){f(this.filetree);const h=new c.$pO(l,a),g=k.ChatResponseFilesPart.to(h);return d(g),this},anchor(l,a){f(this.anchor);const h=new c.$qO(l,a),g=k.ChatResponseAnchorPart.to(h);return d(g),this},button(l){f(this.anchor);const a=new c.$sO(l),h=k.ChatResponseCommandButtonPart.to(a,t.m,t.n);return d(h),this},progress(l){f(this.progress);const a=new c.$rO(l),h=k.ChatResponseProgressPart.to(a);return d(h),this},reference(l){f(this.reference);const a=new c.$tO(l),h=k.ChatResponseReferencePart.to(a);return d(h),this},push(l){f(this.push);const a=k.ChatResponsePart.to(l,t.m,t.n);return d(a),this},report(l){if(f(this.report),"placeholder"in l&&"resolvedContent"in l)return;const a=k.ChatResponseProgress.from(t.i,l);if(!a){t.l.error("Unknown progress type: "+JSON.stringify(l));return}return d(a),this}}}return this.g}}class i{static{this.b=0}constructor(t,f,d){this.i=f,this.j=d,this.c=new Map,this.g=new b.$4c,this.d=t.getProxy(C.$rM.MainThreadChatAgents2)}createChatAgent(t,f,d){const l=i.b++,a=new r(t,f,this.d,l,d);return this.c.set(l,a),this.d.$registerAgent(l,t.identifier,f,{},void 0),a.apiAgent}createDynamicChatAgent(t,f,d,l,a){const h=i.b++,g=new r(t,f,this.d,h,a);return this.c.set(h,g),this.d.$registerAgent(h,t.identifier,f,{},{name:d,description:l}),g.apiAgent}async $invokeAgent(t,f,d,l){const a=this.c.get(t);if(!a)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let h=this.g.get(f.sessionId);h||(h=new b.$Tc,this.g.set(f.sessionId,h));const g=new n(a.extension,f,this.d,this.i,this.j.converter,h);try{const S=await this.k(f.agentId,d),w=a.invoke(k.ChatAgentRequest.to(f),{history:S},g.apiObject,l);return await(0,L.$9g)(Promise.resolve(w).then(E=>{if(E?.metadata)try{JSON.stringify(E.metadata)}catch(y){const D=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${a.extension.identifier.value}] [@${a.id}] ${D}`,a.extension),{errorDetails:{message:D},timings:g.timings}}return{errorDetails:E?.errorDetails,timings:g.timings,metadata:E?.metadata}}),l)}catch(S){return this.i.error(S,a.extension),{errorDetails:{message:(0,I.localize)(0,null,(0,O.$6i)(S)),responseIsIncomplete:!0}}}finally{g.close()}}async k(t,f){const d=[];for(const l of f.history){const a=k.ChatAgentResult.to(l.result),h=t===l.request.agentId?a:{...a,metadata:void 0};d.push(new c.$uO(l.request.message,l.request.command,l.request.variables.variables.map(k.ChatAgentResolvedVariable.to),l.request.agentId));const g=(0,u.$Hb)(l.response.map(S=>k.ChatResponsePart.fromContent(S,this.j.converter)));d.push(new c.$vO(g,h,l.request.agentId,l.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,d,l,a){const h=this.c.get(f);if(!h)return Promise.resolve([]);const g=await this.k(h.id,l),S=k.ChatAgentResult.to(d);return(await h.provideFollowups(S,{history:g},a)).filter(w=>{const E=!w.participant||M.Iterable.some(this.c.values(),y=>y.id===w.participant&&p.$Dm.equals(y.extension.identifier,h.extension.identifier));return E||this.i.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),E}).map(w=>k.ChatFollowup.from(w,t))}$acceptFeedback(t,f,d,l){const a=this.c.get(t);if(!a)return;const h=k.ChatAgentResult.to(f);let g;switch(d){case m.InteractiveSessionVoteDirection.Down:g=c.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:g=c.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(l?{result:h,kind:g,reportIssue:l}:{result:h,kind:g}))}$acceptAction(t,f,d){const l=this.c.get(t);if(!l||d.action.kind==="vote")return;const a=k.ChatAgentUserActionEvent.to(f,d,this.j.converter);a&&l.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(t,f,d){const l=this.c.get(t);return l?(await l.invokeCompletionProvider(f,d)).map(k.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(f)).map(l=>k.ChatFollowup.from(l,void 0))}}e.$Cjc=i;class r{constructor(t,f,d,l,a){this.extension=t,this.id=f,this.w=d,this.x=l,this.y=a,this.n=new A.$7d,this.o=new A.$7d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,f){return this.q?await this.q.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,d){if(!this.b)return[];const l=await this.b.provideFollowups(t,f,d);return l?l.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(t);return f?f.map(d=>typeof d=="string"?d:k.MarkdownString.from(d)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const d=()=>{t||f||(f=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{fullName:this.c,icon:this.d?this.d instanceof R.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof c.$pN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:k.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:k.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:k.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,isSticky:this.t,requester:this.u}),f=!1}))},l=this;return{get id(){return l.id},get fullName(){return(0,o.$cG)(l.extension,"defaultChatParticipant"),l.c??l.extension.displayName??l.extension.name},set fullName(a){(0,o.$cG)(l.extension,"defaultChatParticipant"),l.c=a,d()},get iconPath(){return l.d},set iconPath(a){l.d=a,d()},get requestHandler(){return l.y},set requestHandler(a){(0,v.$6f)(typeof a=="function","Invalid request handler"),l.y=a},get followupProvider(){return l.b},set followupProvider(a){l.b=a,d()},get isDefault(){return(0,o.$cG)(l.extension,"defaultChatParticipant"),l.g},set isDefault(a){(0,o.$cG)(l.extension,"defaultChatParticipant"),l.g=a,d()},get helpTextPrefix(){return(0,o.$cG)(l.extension,"defaultChatParticipant"),l.i},set helpTextPrefix(a){(0,o.$cG)(l.extension,"defaultChatParticipant"),l.i=a,d()},get helpTextVariablesPrefix(){return(0,o.$cG)(l.extension,"defaultChatParticipant"),l.j},set helpTextVariablesPrefix(a){(0,o.$cG)(l.extension,"defaultChatParticipant"),l.j=a,d()},get helpTextPostfix(){return(0,o.$cG)(l.extension,"defaultChatParticipant"),l.k},set helpTextPostfix(a){(0,o.$cG)(l.extension,"defaultChatParticipant"),l.k=a,d()},get isSecondary(){return(0,o.$cG)(l.extension,"defaultChatParticipant"),l.m},set isSecondary(a){(0,o.$cG)(l.extension,"defaultChatParticipant"),l.m=a,d()},get sampleRequest(){return l.l},set sampleRequest(a){l.l=a,d()},get supportIssueReporting(){return(0,o.$cG)(l.extension,"chatParticipantAdditions"),l.p},set supportIssueReporting(a){(0,o.$cG)(l.extension,"chatParticipantAdditions"),l.p=a,d()},get onDidReceiveFeedback(){return l.n.event},set participantVariableProvider(a){if((0,o.$cG)(l.extension,"chatParticipantAdditions"),l.q=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");l.w.$registerAgentCompletionsProvider(l.x,a.triggerCharacters)}else l.w.$unregisterAgentCompletionsProvider(l.x)},get participantVariableProvider(){return(0,o.$cG)(l.extension,"chatParticipantAdditions"),l.q},set welcomeMessageProvider(a){(0,o.$cG)(l.extension,"defaultChatParticipant"),l.s=a,d()},get welcomeMessageProvider(){return(0,o.$cG)(l.extension,"defaultChatParticipant"),l.s},onDidPerformAction:(0,o.$bG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,get isSticky(){return l.t},set isSticky(a){l.t=a,d()},set requester(a){l.u=a,d()},get requester(){return l.u},dispose(){t=!0,l.b=void 0,l.n.dispose(),l.w.$unregisterAgent(l.x)}}}invoke(t,f,d,l){return this.y(t,f,d,l)}}}),define(ke[329],Ee([1,0,13,3,6,16,7,26]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;class ${static{this.a=0}constructor(I){this.b=new Map,this.c=I.getProxy(O.$rM.MainThreadChatVariables)}async $resolveVariable(I,p,C,k){const c=this.b.get(I);if(c)try{if(c.resolver.resolve2){(0,b.$cG)(c.extension,"chatParticipantAdditions");const m=new v(p,this.c),o=await c.resolver.resolve2(c.data.name,{prompt:C},m.apiObject,k);if(o)return o.map(A.ChatVariable.from)}else{const m=await c.resolver.resolve(c.data.name,{prompt:C},k);if(m)return m.map(A.ChatVariable.from)}}catch(m){(0,u.$2)(m)}}registerVariableResolver(I,p,C,k){const c=$.a++;return this.b.set(c,{extension:I,data:{name:p,description:C},resolver:k}),this.c.$registerVariable(c,{name:p,description:C}),(0,L.$Sc)(()=>{this.b.delete(c),this.c.$unregisterVariable(c)})}}e.$Fjc=$;class v{constructor(I,p){this.c=I,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(k){if(I.a){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,k),c}};const I=this,C=k=>{this.d.$handleProgressChunk(this.c,k)};this.b={progress(k){p(this.progress);const c=new M.$rO(k),m=A.ChatResponseProgressPart.to(c);return C(m),this},reference(k){p(this.reference);const c=new M.$tO(k),m=A.ChatResponseReferencePart.to(c);return C(m),this},push(k){return p(this.push),k instanceof M.$tO?C(A.ChatResponseReferencePart.to(k)):k instanceof M.$rO&&C(A.ChatResponseProgressPart.to(k)),this}}}return this.b}}}),define(ke[330],Ee([1,0,8,54,4,3,2,83,25,16,7,6,26]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=C;function C(k,c,m){const o=k.getProxy(I.$rM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Fm,c.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const S=this.b.get(g.handle);return S?S.value:g}else if(g&&g.$mid===7){const S=g,w=this.b.get(S.commentControlHandle);if(!w)return S;const E=w.getCommentThread(S.commentThreadHandle);return E?E.value:S}else if(g&&(g.$mid===9||g.$mid===8)){const S=this.b.get(g.thread.commentControlHandle);if(!S)return g;const w=S.getCommentThread(g.thread.commentThreadHandle);return w?g.$mid===8?w.value:{thread:w.value,text:g.text}:g}else if(g&&g.$mid===10){const S=this.b.get(g.thread.commentControlHandle);if(!S)return g;const w=S.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const E=g.commentUniqueId,y=w.getCommentByUniqueId(E);return y||g}else if(g&&g.$mid===11){const S=this.b.get(g.thread.commentControlHandle);if(!S)return g;const w=S.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const E=g.text,y=g.commentUniqueId,D=w.getCommentByUniqueId(y);return D?(typeof D.body=="string"?D.body=E:D.body=new R.$UM(E),D):g}return g}})}createCommentController(g,S,w){const E=n.a++,y=new r(g,E,S,w);this.b.set(y.handle,y);const D=this.c.get(g.identifier)||[];return D.push(y),this.c.set(g.identifier,D),y.value}async $createCommentThreadTemplate(g,S,w){const E=this.b.get(g);E&&E.$createCommentThreadTemplate(S,w)}async $setActiveComment(g,S){const w=this.b.get(g);w&&w.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(g,S,w){const E=this.b.get(g);E&&E.$updateCommentThreadTemplate(S,w)}$deleteCommentThread(g,S){this.b.get(g)?.$deleteCommentThread(S)}async $provideCommentingRanges(g,S,w){const E=this.b.get(g);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const y=await m.ensureDocumentData(M.URI.revive(S));return(0,u.$ah)(async()=>{const D=await E.commentingRangeProvider.provideCommentingRanges(y.document,w);let P;return Array.isArray(D)?P={ranges:D,fileComments:!1}:D?P={ranges:D.ranges||[],fileComments:D.fileComments||!1}:P=D??void 0,P}).then(D=>{let P;return D&&(P={ranges:D.ranges.map(z=>v.Range.from(z)),fileComments:D.fileComments}),P})}$toggleReaction(g,S,w,E,y){const D=this.b.get(g);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,u.$ah)(()=>{const P=D.getCommentThread(S);if(P){const z=P.getCommentByUniqueId(E.uniqueIdInThread);if(D!==void 0&&z&&D.reactionHandler)return D.reactionHandler(z,f(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,typeof g=="object"?((0,p.$cG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=g.resolved,this.b.applicability=g.applicability):this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,S,w,E,y,D,P,z){this.m=S,this.n=w,this.o=E,this.p=y,this.q=D,this.extensionDescription=P,this.r=z,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new O.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Vc,this.l.value=new A.$Tc,this.n===void 0&&(this.n=`${g}.${this.handle}`),o.$createCommentThread(S,this.handle,this.n,this.o,v.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{o.$deleteCommentThread(S,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(T){F.range=T},get comments(){return F.comments},set comments(T){F.comments=T},get collapsibleState(){return F.collapsibleState},set collapsibleState(T){F.collapsibleState=T},get canReply(){return F.canReply},set canReply(T){F.canReply=T},get contextValue(){return F.contextValue},set contextValue(T){F.contextValue=T},get label(){return F.label},set label(T){F.label=T},get state(){return F.state},set state(T){F.state=T},dispose:()=>{F.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Tc);const g=w=>Object.prototype.hasOwnProperty.call(this.b,w),S={};g("range")&&(S.range=v.Range.from(this.p)),g("label")&&(S.label=this.label),g("contextValue")&&(S.contextValue=this.contextValue??null),g("comments")&&(S.comments=this.q.map(w=>s(this,w,this.k,this.extensionDescription))),g("collapsibleState")&&(S.collapseState=d(this.g)),g("canReply")&&(S.canReply=this.canReply),g("state")&&(S.state=l(this.h)),g("applicability")&&(S.applicability=a(this.h)),g("isTemplate")&&(S.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(g){for(const S of this.k){const w=S[0],E=S[1];if(g===E)return w}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Je([(0,L.$Nh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,g?.resourceHints&&(0,p.$cG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$cG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$cG)(this.h,"activeComment"),this.f}constructor(g,S,w,E){this.h=g,this.i=S,this.j=w,this.k=E,this.a=new Map,o.$registerCommentController(this.handle,w,E,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(D){y.options=D},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(D){y.commentingRangeProvider=D},get reactionHandler(){return y.reactionHandler},set reactionHandler(D){y.reactionHandler=D},get activeCommentThread(){return y.activeCommentThread},createCommentThread(D,P,z){return y.createCommentThread(D,P,z).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(g,S,w){S===void 0&&(0,p.$cG)(this.h,"fileComments");const E=new i(this.id,this.handle,void 0,g,S,w,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(g){if(!g){this.e=void 0,this.f=void 0;return}const S=this.a.get(g.commentThreadHandle);S&&(this.e=g.uniqueIdInThread?S.getCommentByUniqueId(g.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(g,S){const w=new i(this.id,this.handle,void 0,M.URI.revive(g),v.Range.to(S),[],this.h,!0);return w.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(g,S){const w=this.a.get(g);w&&(w.range=v.Range.to(S))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.g.forEach(g=>g.dispose())}}function s(h,g,S,w){let E=S.get(g);return E||(E=++h.commentHandle,S.set(g,E)),g.state!==void 0&&(0,p.$cG)(w,"commentsDraftState"),g.reactions?.some(y=>y.reactors!==void 0)&&(0,p.$cG)(w,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:E,body:typeof g.body=="string"?g.body:v.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(y=>t(y)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(h){return{label:h.label,iconPath:h.iconPath?v.$LO(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted,reactors:h.reactors&&h.reactors.length>0&&typeof h.reactors[0]!="string"?h.reactors.map(g=>g.name):h.reactors}}function f(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?M.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1,reactors:h.reactors?.map(g=>({name:g}))}}function d(h){if(h!==void 0)switch(h){case R.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(h){let g;if(typeof h=="object"?g=h.resolved:g=h,g!==void 0)switch(g){case R.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function a(h){let g;if(typeof h=="object"&&(g=h.applicability),g!==void 0)switch(g){case R.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case R.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[331],Ee([1,0,22,55,3,15,23,2,16,92,111,6,7]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class C{constructor(f,d){this.document=f,this.b=d,this.a=1,this.c=new R.$mjc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,d){await this.f(f).undo(),d||this.disposeBackup()}async redo(f,d){await this.f(f).redo(),d||this.disposeBackup()}disposeEdits(f){for(const d of f)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=s(this.document.uri)+this.a++;return(0,M.$Vg)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const d=this.c.get(f,0);if(!d)throw new Error("No edit found");return d}}class k{constructor(){this.a=new Map}get(f,d){return this.a.get(this.b(f,d))}add(f,d,l){const a=this.b(f,d.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${f} resource:${d.uri}`);const h=new C(d,l);return this.a.set(a,h),h}delete(f,d){const l=this.b(f,d.uri);this.a.delete(l)}b(f,d){return`${f}@@@${d}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class m{constructor(){this.a=new Map}addTextProvider(f,d,l){return this.b(0,f,d,l)}addCustomProvider(f,d,l){return this.b(1,f,d,l)}get(f){return this.a.get(f)}b(f,d,l,a){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:f,extension:l,provider:a}),new p.$tM(()=>this.a.delete(d))}}class o{constructor(f,d,l,a,h){this.d=d,this.f=l,this.g=a,this.h=h,this.b=new m,this.c=new k,this.a=f.getProxy(I.$rM.MainThreadCustomEditors)}registerCustomEditorProvider(f,d,l,a){const h=new O.$Tc;return i(l)?(h.add(this.b.addTextProvider(d,f,l)),this.a.$registerTextEditorProvider((0,v.$Yjc)(f),d,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,v.$Wjc)(f))):(h.add(this.b.addCustomProvider(d,f,l)),n(l)&&h.add(l.onDidChangeCustomDocument(g=>{const S=this.i(d,g.document.uri);if(r(g)){const w=S.addEdit(g);this.a.$onDidEdit(g.document.uri,d,w,g.label)}else this.a.$onContentChange(g.document.uri,d)})),this.a.$registerCustomEditorProvider((0,v.$Yjc)(f),d,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,v.$Wjc)(f))),p.$tM.from(h,new p.$tM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(f,d,l,a,h){const g=this.b.get(d);if(!g)throw new Error(`No provider found for '${d}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${d}'`);const S=b.URI.revive(f),w=await g.provider.openCustomDocument(S,{backupId:l,untitledDocumentData:a?.buffer},h);let E;return n(g.provider)&&this.f&&(E=this.f.workspaceValue(g.extension)??this.f.globalValue(g.extension)),this.c.add(d,w,E),{editable:n(g.provider)}}async $disposeCustomDocument(f,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const a=b.URI.revive(f),{document:h}=this.i(d,a);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(f,d,l,a,h,g){const S=this.b.get(l);if(!S)throw new Error(`No provider found for '${l}'`);const w=$.ViewColumn.to(h),E=this.g.createNewWebview(d,a.contentOptions,S.extension),y=this.h.createNewWebviewPanel(d,l,a.title,w,a.options,E,a.active),D=b.URI.revive(f);switch(S.type){case 1:{const{document:P}=this.i(l,D);return S.provider.resolveCustomEditor(P,y,g)}case 0:{const P=this.d.getDocument(D);return S.provider.resolveCustomTextEditor(P,y,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,d,l){this.i(d,f).disposeEdits(l)}async $onMoveCustomEditor(f,d,l){const a=this.b.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(f);if(!h)throw new Error("No webview found");const g=b.URI.revive(d),S=this.d.getDocument(g);await a.provider.moveCustomTextEditor(S,h,u.CancellationToken.None)}async $undo(f,d,l,a){return this.i(d,f).undo(l,a)}async $redo(f,d,l,a){return this.i(d,f).redo(l,a)}async $revert(f,d,l){const a=this.i(d,f);await this.j(d).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(f,d,l){const a=this.i(d,f);await this.j(d).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(f,d,l,a){const h=this.i(d,f);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(l),a)}async $backup(f,d,l){const a=this.i(d,f),g=await this.j(d).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(g),g.id}i(f,d){const l=this.c.get(f,b.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(f){const l=this.b.get(f)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$2jc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const f=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,L.$9i)(f)+""}}),define(ke[332],Ee([1,0,218,138,2,6,7,16,4,12,27,59]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=e.$tjc=void 0;class C{#e;#t;#i;constructor(m,o,n,i,r,s,t,f){this.d=m,this.e=o,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new R.$Bc(d=>s.getComparisonKey(d)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,o){if(!m){this.clear();return}this.j();let n=[];if(O.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),n=[m]}else if(Array.isArray(m)){n=[];let s;m=[...m].sort(C.k);for(const t of m){const[f,d]=t;if((!s||f.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=f,n.push(f),this.#i.set(f,[])),d)this.#i.get(f)?.push(...d);else{const l=this.#i.get(f);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const s of n){let t=[];const f=this.#i.get(s);if(f)if(f.length>this.g){t=[];const d=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const a of f)if(a.severity===d[l]&&t.push({...b.Diagnostic.from(a),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,u.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(s)}));if(i.push([s,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,o){this.j();for(const[n,i]of this)m.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.$tjc=C;let k=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(m){const o=new R.$Bc;for(const n of m)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new $.$$d({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=m.getProxy(A.$rM.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{g:n,f:i,h:r,j:s,k:t,l:f}=this,d=new class{$changeMany(h,g){i.$changeMany(h,g),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,h,g.length===0?"CLEARING":g)}$clear(h){i.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,h)}dispose(){i.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+p.c++,l=o;else if(!n.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+p.c++;while(n.has(l))}return new class extends C{constructor(){super(o,l,p.e,p.d,h=>f.getDocument(h)?.version,t.extUri,d,r),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((r,s)=>{let t=o.get(r.toString());typeof t>"u"&&(t=n.length,o.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(m){let o=[];for(const n of this.g.values())n.has(m)&&(o=o.concat(n.get(m)));return o}$acceptMarkersChange(m){if(!this.n){const o="_generated_mirror",n=new C(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of m)this.n.set(O.URI.revive(o),n.map(b.Diagnostic.to))}};e.$ujc=k,e.$ujc=k=p=Je([qe(1,v.$Oj),qe(2,I.$sjc)],k)}),define(ke[333],Ee([1,0,2,13,7,16,75]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;class b{constructor(v,R,I,p={timeout:1500,errors:3}){this.c=v,this.d=R,this.f=I,this.g=p,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(v){return(R,I,p)=>{const k={dispose:this.a.push([R,I,v])};return Array.isArray(p)&&p.push(k),k}}async $participateInSave(v,R){const I=u.URI.revive(v);let p=!1;const C=setTimeout(()=>p=!0,this.g.timeout),k=[];try{for(const c of[...this.a]){if(p)break;const m=this.d.getDocument(I),o=await this.h(c,{document:m,reason:A.TextDocumentSaveReason.to(R)});k.push(o)}}finally{clearTimeout(C)}return k}h([v,R,I],p){const C=this.b.get(v);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(I,v,R,p).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const c=this.b.get(v);this.b.set(v,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(v,R,I,p){const C=[],k=Date.now(),{document:c,reason:m}=p,{version:o}=c,n=Object.freeze({document:c,reason:m,waitUntil(i){if(Object.isFrozen(C))throw(0,L.$8)("waitUntil can not be called async");C.push(Promise.resolve(i))}});try{R.apply(I,[n])}catch(i){return Promise.reject(i)}return Object.freeze(C),new Promise((i,r)=>{const s=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(C).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(s),i(t)}).catch(t=>{clearTimeout(s),r(t)})}).then(i=>{const r={edits:[]};for(const s of i)if(Array.isArray(s)&&s.every(t=>t instanceof O.$AM))for(const{newText:t,newEol:f,range:d}of s)r.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:d&&A.Range.from(d),text:t,eol:f&&A.EndOfLine.from(f)}});if(r.edits.length!==0)return o===c.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$Dkc=b}),define(ke[334],Ee([1,0,4,3,2,6,152,16,18,24,7]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;class I{constructor(C,k){this.a=new u.$7d,this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Tc,this.h=new Map,this.f=C.getProxy(A.$rM.MainThreadDocuments),this.g=k,this.g.onDidRemoveDocuments(c=>{for(const m of c)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const m of c)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const k=this.g.getDocument(C);if(k)return k}getDocument(C){const k=this.getDocumentData(C);if(!k?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return k.document}ensureDocumentData(C){const k=this.g.getDocument(C);if(k)return Promise.resolve(k);let c=this.h.get(C.toString());return c||(c=this.f.$tryOpenDocument(C).then(m=>{this.h.delete(C.toString());const o=O.URI.revive(m);return(0,$.$7f)(this.g.getDocument(o))},m=>(this.h.delete(C.toString()),Promise.reject(m))),this.h.set(C.toString(),c)),c}createDocumentData(C){return this.f.$tryCreateDocument(C).then(k=>O.URI.revive(k))}$acceptModelLanguageChanged(C,k){const c=O.URI.revive(C),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(k),this.a.fire(m.document)}$acceptModelSaved(C){const k=O.URI.revive(C),c=this.g.getDocument(k);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(C,k){const c=O.URI.revive(C),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(k),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,k,c){const m=O.URI.revive(C),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(c),o.onEvents(k);let n;k.isUndoing?n=R.TextDocumentChangeReason.Undo:k.isRedoing&&(n=R.TextDocumentChangeReason.Redo),this.c.fire((0,v.$Pn)({document:o.document,contentChanges:k.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(C,k){(0,M.$OO)(C,k)}}e.$vjc=I}),define(ke[71],Ee([1,0,73,4,18,2,5,6,20,16,7]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=e.$3jc=void 0,e.$3jc=(0,M.$ii)("IExtHostEditorTabs");class I{constructor(m,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$cO(A.URI.revive(this.b.input.uri));case 2:return new R.$dO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new R.$eO(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new R.$fO(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$gO(this.b.input.viewType);case 4:return new R.$hO(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$iO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$jO;case 9:return new R.$kO(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$lO(this.b.input.providerId);case 11:return new R.$mO(this.b.input.diffEditors.map(m=>new R.$dO(A.URI.revive(m.original),A.URI.revive(m.modified))));default:return}}}class p{constructor(m,o){this.c=[],this.d="",this.b=m,this.e=o;for(const n of m.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return v.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(n=>n.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const n=new I(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,n),m.tabDto.isActive&&(this.d=n.tabId),n}else if(m.kind===1){const n=this.c.splice(m.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(m.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,n),n}const o=this.c.find(n=>n.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this.d}}let C=class{constructor(m){this.b=new L.$7d,this.c=new L.$7d,this.e=[],this.a=m.getProxy(b.$rM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,o={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(n=>n.apiObject))},get activeTabGroup(){const n=m.d;return(0,O.$7f)(m.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?k(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(m){const o=new Set(this.e.map(d=>d.groupId)),n=new Set(m.map(d=>d.groupId)),i=(0,u.$L)(o,n),r=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=m.map(d=>{const l=new p(d,()=>this.d);return i.added.includes(l.groupId)?s.push(l.apiObject):t.push(l.apiObject),l});const f=(0,O.$7f)(m.find(d=>d.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const o=this.e.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this.e.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(m){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===m)return n}h(m){return this.e.find(o=>o.apiObject===m)}async i(m,o){const n=[];for(const i of m){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,o)}async j(m,o){const n=[];for(const i of m){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,o)}};e.$4jc=C,e.$4jc=C=Je([qe(0,$.$MO)],C);function k(c){return c.tabs!==void 0}}),define(ke[335],Ee([1,0,2,6,3,7,16,179,14,21,26,80]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class p{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const m=this.a.indexOf(c);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),m=[];let o,n,i=14,r=14;for(const s of c){let t=o?(0,$.$nf)(o,s):0;for(t===0?n=1:n=r;t<s.length;t++)t+1===s.length?(i=r,r=9):r+=1,m.push([n,s.toUpperCase().charCodeAt(t),r]),m.push([n,s.toLowerCase().charCodeAt(t),r]),n=r;o=s,r=i}m.push([9,58,10]),m.push([10,47,12]),this.b=new b.$x2(m)}}provideDocumentLinks(c){this.c();const m=[],o=b.$y2.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of o){const i=M.DocumentLink.to(n);i.target&&m.push(i)}return m}}class C{constructor(c,m){this.i=m,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(L.$rM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,m,o,n={}){if(C.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,o);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,R.$cG)(c,"fsChunks"),r+=4);let s;n.isReadonly&&(0,I.$Hk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,r,s).catch(f=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=o.onDidChangeFile(f=>{const d=[];for(const l of f){const{uri:a,type:h}=l;if(a.scheme!==m)continue;let g;switch(h){case A.FileChangeType.Changed:g=0;break;case A.FileChangeType.Created:g=1;break;case A.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:a,type:g})}this.a.$onFileSystemChange(i,d)});return(0,O.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:m,ctime:o,mtime:n,size:i,permissions:r}=c;return{type:m,ctime:o,mtime:n,size:i,permissions:r}}$stat(c,m){return Promise.resolve(this.l(c).stat(u.URI.revive(m))).then(o=>C.k(o))}$readdir(c,m){return Promise.resolve(this.l(c).readDirectory(u.URI.revive(m)))}$readFile(c,m){return Promise.resolve(this.l(c).readFile(u.URI.revive(m))).then(o=>v.$ue.wrap(o))}$writeFile(c,m,o,n){return Promise.resolve(this.l(c).writeFile(u.URI.revive(m),o.buffer,n))}$delete(c,m,o){return Promise.resolve(this.l(c).delete(u.URI.revive(m),o))}$rename(c,m,o,n){return Promise.resolve(this.l(c).rename(u.URI.revive(m),u.URI.revive(o),n))}$copy(c,m,o,n){const i=this.l(c);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(m),u.URI.revive(o),n))}$mkdir(c,m){return Promise.resolve(this.l(c).createDirectory(u.URI.revive(m)))}$watch(c,m,o,n){const i=this.l(c).watch(u.URI.revive(o),n);this.f.set(m,i)}$unwatch(c,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(c,m,o){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(m),o))}$close(c,m){const o=this.l(c);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(c,m,o,n){const i=this.l(c);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=v.$ue.alloc(n);return Promise.resolve(i.read(m,o,r.buffer,0,n)).then(s=>r.slice(0,s))}$write(c,m,o,n){const i=this.l(c);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,o,n.buffer,0,n.byteLength))}l(c){const m=this.c.get(c);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.$Fkc=C}),define(ke[336],Ee([1,0,4,35,2,6,16,7,45]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class v{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(C,k,c,m,o,n){this.a=Math.random(),this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,L.$ck)(o),r=typeof o=="string",s=n?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(s&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const d of f.created){const l=O.URI.revive(d);i(l.fsPath)&&(!r||k.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const d of f.changed){const l=O.URI.revive(d);i(l.fsPath)&&(!r||k.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const d of f.deleted){const l=O.URI.revive(d);i(l.fsPath)&&(!r||k.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$tM.from(this.i(C,c,o,n,n?.correlate),this.b,this.c,this.d,t)}i(C,k,c,m,o){const n=b.$tM.from();if(typeof c=="string")return n;const i=C.getProxy(A.$rM.MainThreadFileSystemEventService);let r=!1;return(c.pattern.includes(L.$$j)||c.pattern.includes(L.$_j))&&(r=!0),i.$watch(k.identifier.value,this.a,c.baseUri,{recursive:r,excludes:m?.excludes??[]},!!o),b.$tM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(C){this.a=C,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(O.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(O.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(O.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(C,k,c){this.j=C,this.k=k,this.l=c,this.a=new u.$7d,this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.g=new u.$9d,this.h=new u.$9d,this.i=new u.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(C,k,c,m){return new v(this.j,C,k,this.a.event,M.GlobPattern.from(c),m)}$onFileEvent(C){this.a.fire(new R(C))}$onDidRunFileOperation(C,k){switch(C){case 2:this.b.fire(Object.freeze({files:k.map(c=>({oldUri:O.URI.revive(c.source),newUri:O.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(c=>O.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(c=>O.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(C){return this.m(C,this.g)}getOnWillCreateFileEvent(C){return this.m(C,this.h)}getOnWillDeleteFileEvent(C){return this.m(C,this.i)}m(C,k){return(c,m,o)=>{const n=function(r){c.call(m,r)};return n.extension=C,k.event(n,void 0,o)}}async $onWillRunFileOperation(C,k,c,m){switch(C){case 2:return await this.n(this.g,{files:k.map(o=>({oldUri:O.URI.revive(o.source),newUri:O.URI.revive(o.target)}))},c,m);case 1:return await this.n(this.i,{files:k.map(o=>O.URI.revive(o.target))},c,m);case 0:case 3:return await this.n(this.h,{files:k.map(o=>O.URI.revive(o.target))},c,m)}}async n(C,k,c,m){const o=new Set,n=[];if(await C.fireAsync(k,m,async(r,s)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof b.$DM&&(n.push([s.extension,f]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:s}=M.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.$Gkc=I}),define(ke[337],Ee([1,0,19,8,22,13,124,3,24,39,14,18,2,29,175,83,134,220,25,16,7,26,111,6]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class d{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const X=this.d.getDocument(q),Q=await this.e.provideDocumentSymbols(X,V);if(!(0,u.$Kb)(Q))return Q[0]instanceof r.$MM?Q.map(i.DocumentSymbol.from):d.f(Q)}static f(q){q=q.slice(0).sort((Q,fe)=>{let we=Q.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(Q.location.range.end)),we});const V=[],X=[];for(const Q of q){const fe={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(X.length===0){X.push(fe),V.push(fe);break}const we=X[X.length-1];if(C.$ct.containsRange(we.range,fe.range)&&!C.$ct.equalsRange(we.range,fe.range)){we.children?.push(fe),X.push(fe);break}X.pop()}}return V}}class l{constructor(q,V,X,Q,fe,we){this.f=q,this.g=V,this.h=X,this.j=Q,this.k=fe,this.l=we,this.d=new t.$mjc("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const X=this.f.getDocument(q),Q=await this.h.provideCodeLenses(X,V);if(!Q||V.isCancellationRequested)return;const fe=this.d.add(Q),we=new b.$Tc;this.e.set(fe,we);const Te={cacheId:fe,lenses:[]};for(let He=0;He<Q.length;He++)Te.lenses.push({cacheId:[fe,He],range:i.Range.from(Q[He].range),command:this.g.toInternal(Q[He].command,we)});return Te}async resolveCodeLens(q,V){const X=q.cacheId&&this.d.get(...q.cacheId);if(!X)return;let Q;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?Q=X:Q=await this.h.resolveCodeLens(X,V),Q||(Q=X),V.isCancellationRequested)return;const fe=q.cacheId&&this.e.get(q.cacheId[0]);if(fe){if(!Q.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return q.command=this.g.toInternal(Q.command,fe),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function a(Fe){return Array.isArray(Fe)?Fe.map(i.DefinitionLink.from):Fe?[i.DefinitionLink.from(Fe)]:[]}class h{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,X){const Q=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideDefinition(Q,fe,X);return a(we)}}class g{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,X){const Q=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideDeclaration(Q,fe,X);return a(we)}}class S{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,X){const Q=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideImplementation(Q,fe,X);return a(we)}}class w{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,X){const Q=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideTypeDefinition(Q,fe,X);return a(we)}}class E{constructor(q,V){this.d=q,this.e=V}async provideHover(q,V,X){const Q=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideHover(Q,fe,X);if(!(!we||(0,u.$Kb)(we.contents)))return we.range||(we.range=Q.getWordRangeAtPosition(fe)),we.range||(we.range=new r.$vM(fe,fe)),i.Hover.from(we)}}class y{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,X){const Q=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideEvaluatableExpression(Q,fe,X);if(we)return i.EvaluatableExpression.from(we)}}class D{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,X,Q){const fe=this.d.getDocument(q),we=await this.e.provideInlineValues(fe,i.Range.to(V),i.InlineValueContext.to(X),Q);if(Array.isArray(we))return we.map(Te=>i.InlineValue.from(Te))}}class P{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,X){const Q=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideDocumentHighlights(Q,fe,X);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class z{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,X,Q){const fe=this.d.getDocument(q),we=X.map(xe=>this.d.getDocument(xe)),Te=i.Position.to(V),He=await this.e.provideMultiDocumentHighlights(fe,Te,we,Q);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class F{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,X){const Q=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideLinkedEditingRanges(Q,fe,X);if(we&&Array.isArray(we.ranges))return{ranges:(0,u.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class T{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,X,Q){const fe=this.d.getDocument(q),we=i.Position.to(V),Te=await this.e.provideReferences(fe,we,X,Q);if(Array.isArray(Te))return Te.map(i.location.from)}}class j{static{this.d=1e3}constructor(q,V,X,Q,fe,we,Te){this.g=q,this.h=V,this.j=X,this.k=Q,this.l=fe,this.m=we,this.n=Te,this.e=new t.$mjc("CodeAction"),this.f=new Map}async provideCodeActions(q,V,X,Q){const fe=this.g.getDocument(q),we=k.$et.isISelection(V)?i.Selection.to(V):i.Range.to(V),Te=[];for(const ot of this.j.getDiagnostics(q))if(we.intersection(ot.range)&&Te.push(ot)>j.d)break;const He={diagnostics:Te,only:X.only?new r.$OM(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},xe=await this.k.provideCodeActions(fe,we,He,Q);if(!(0,u.$Lb)(xe)||Q.isCancellationRequested)return;const it=this.e.add(xe),rt=new b.$Tc;this.f.set(it,rt);const at=[];for(let ot=0;ot<xe.length;ot++){const Se=xe[ot];if(Se)if(j.o(Se))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:Se.title,command:this.h.toInternal(Se,rt)});else{He.only&&(Se.kind?He.only.contains(Se.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${Se.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Se.ranges??[];at.push({cacheId:[it,ot],title:Se.title,command:Se.command&&this.h.toInternal(Se.command,rt),diagnostics:Se.diagnostics&&Se.diagnostics.map(i.Diagnostic.from),edit:Se.edit&&i.WorkspaceEdit.from(Se.edit,void 0),kind:Se.kind&&Se.kind.value,isPreferred:Se.isPreferred,isAI:(0,s.$bG)(this.m,"codeActionAI")?Se.isAI:!1,ranges:(0,s.$bG)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:Se.disabled?.reason})}}return{cacheId:it,actions:at}}async resolveCodeAction(q,V){const[X,Q]=q,fe=this.e.get(X,Q);if(!fe||j.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,V)??fe;let Te;we.edit&&(Te=i.WorkspaceEdit.from(we.edit,void 0));let He;if(we.command){const xe=this.f.get(X);xe&&(He=this.h.toInternal(we.command,xe))}return{edit:Te,command:He}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class N{constructor(q,V,X,Q,fe){this.e=q,this.f=V,this.g=X,this.h=Q,this.j=fe,this.d=new t.$mjc("DocumentPasteEdit")}async prepareDocumentPaste(q,V,X,Q){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(q),we=V.map(xe=>i.Range.to(xe)),Te=i.DataTransfer.toDataTransfer(X,()=>{throw new A.$$});if(await this.g.prepareDocumentPaste(fe,we,Te,Q),Q.isCancellationRequested)return;const He=Array.from(Te).filter(([,xe])=>!(xe instanceof r.$iN));return i.DataTransfer.from(He)}async providePasteEdits(q,V,X,Q,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(V),He=X.map(at=>i.Range.to(at)),xe=i.DataTransfer.toDataTransfer(Q,async at=>(await this.e.$resolvePasteFileData(this.h,q,at)).buffer),it=await this.g.provideDocumentPasteEdits(Te,He,xe,{only:fe.only?new r.$nN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!it||we.isCancellationRequested)return[];const rt=this.d.add(it);return it.map((at,ot)=>({_cacheId:[rt,ot],title:at.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(Se=>Se.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[X,Q]=q,fe=this.d.get(X,Q);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,V)??fe;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,X){const Q=this.d.getDocument(q),fe=await this.e.provideDocumentFormattingEdits(Q,V,X);if(Array.isArray(fe))return fe.map(i.TextEdit.from)}}class W{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,X,Q){const fe=this.d.getDocument(q),we=i.Range.to(V),Te=await this.e.provideDocumentRangeFormattingEdits(fe,we,X,Q);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,X,Q){(0,I.$6f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(q),we=V.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(fe,we,X,Q);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class Y{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,X,Q,fe){const we=this.d.getDocument(q),Te=i.Position.to(V),He=await this.e.provideOnTypeFormattingEdits(we,Te,X,Q,fe);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class _{constructor(q,V){this.e=q,this.f=V,this.d=new t.$mjc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const X=await this.e.provideWorkspaceSymbols(q,V);if(!(0,u.$Lb)(X))return{symbols:[]};const Q=this.d.add(X),fe={cacheId:Q,symbols:[]};for(let we=0;we<X.length;we++){const Te=X[we];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}fe.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[Q,we]})}return fe}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const X=this.d.get(...q.cacheId);if(X){const Q=await this.e.resolveWorkspaceSymbol(X,V);return Q&&(0,$.$Rn)(q,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class J{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,X){this.d=q,this.e=V,this.f=X}async provideRenameEdits(q,V,X,Q){const fe=this.d.getDocument(q),we=i.Position.to(V);try{const Te=await this.e.provideRenameEdits(fe,we,X,Q);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const He=J.g(Te);return He?{rejectReason:He,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(q,V,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(q),fe=i.Position.to(V);try{const we=await this.e.prepareRename(Q,fe,X);let Te,He;if(r.$vM.isRange(we)?(Te=we,He=Q.getText(we)):(0,I.$Xf)(we)&&(Te=we.range,He=we.placeholder),!Te||!He)return;if(Te.start.line>fe.line||Te.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:He}}catch(we){const Te=J.g(we);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(we)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Z{constructor(q,V,X){this.d=q,this.e=V,this.f=X}async provideNewSymbolNames(q,V,X){const Q=this.d.getDocument(q),fe=i.Range.to(V);try{const we=await this.e.provideNewSymbolNames(Q,fe,X);return we?we.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(we){this.f.error(Z.g(we)??JSON.stringify(we,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class re{constructor(q,V){this.resultId=q,this.tokens=V}}class ee{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,X){const Q=this.f.getDocument(q),fe=V!==0?this.d.get(V):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,fe.resultId,X):await this.g.provideDocumentSemanticTokens(Q,X);return fe&&this.d.delete(V),we?(we=ee.h(we),this.o(ee.n(fe,we),we)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return ee.j(q)?ee.k(q)?q:new r.$NN(new Uint32Array(q.data),q.resultId):ee.l(q)?ee.m(q)?q:new r.$PN(q.edits.map(V=>new r.$ON(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!ee.j(V)||!q||!q.tokens)return V;const X=q.tokens,Q=X.length,fe=V.data,we=fe.length;let Te=0;const He=Math.min(Q,we);for(;Te<He&&X[Te]===fe[Te];)Te++;if(Te===Q&&Te===we)return new r.$PN([],V.resultId);let xe=0;const it=He-Te;for(;xe<it&&X[Q-xe-1]===fe[we-xe-1];)xe++;return new r.$PN([{start:Te,deleteCount:Q-Te-xe,data:fe.subarray(Te,we-xe)}],V.resultId)}o(q,V){if(ee.j(q)){const X=this.e++;return this.d.set(X,new re(q.resultId,q.data)),(0,m.$Qab)({id:X,type:"full",data:q.data})}if(ee.l(q)){const X=this.e++;return ee.j(V)?this.d.set(X,new re(V.resultId,V.data)):this.d.set(X,new re(q.resultId)),(0,m.$Qab)({id:X,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class pe{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,X){const Q=this.d.getDocument(q),fe=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(V),X);return fe?this.f(fe):null}f(q){return(0,m.$Qab)({id:0,type:"full",data:q.data})}}class De{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,X,Q,fe){this.f=q,this.g=V,this.h=X,this.j=Q,this.k=fe,this.d=new t.$mjc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,X,Q){const fe=this.f.getDocument(q),we=i.Position.to(V),Te=fe.getWordRangeAtPosition(we)||new r.$vM(we,we),He=Te.with({end:we}),xe=new v.$3d,it=await this.h.provideCompletionItems(fe,we,Q,i.CompletionContext.to(X));if(!it||Q.isCancellationRequested)return;const rt=Array.isArray(it)?new r.$2M(it):it,at=De.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),ot=new b.$Tc;this.e.set(at,ot);const Se=[],Be={x:at,b:Se,a:{replace:i.Range.from(Te),insert:i.Range.from(He)},c:rt.isIncomplete||void 0,d:xe.elapsed()};for(let Ge=0;Ge<rt.items.length;Ge++){const Me=rt.items[Ge],Qe=this.l(Me,[at,Ge],He,Te);Se.push(Qe)}return Be}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...q);if(!X)return;const Q=this.l(X,q),fe=await this.h.resolveCompletionItem(X,V);if(!fe)return;const we=this.l(fe,q);return(Q.h!==we.h||Q.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==we.n||Q.o!==we.o||!(0,$.$Sn)(Q.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,X,Q){const fe=this.e.get(V[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(q.command,fe),Te={x:V,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=q.textEdit.newText):typeof q.insertText=="string"?Te.h=q.insertText:q.insertText instanceof r.$EM&&(Te.h=q.insertText.value,Te.i|=4);let He;return q.textEdit?He=q.textEdit.range:q.range&&(He=q.range),r.$vM.isRange(He)?Te.j=i.Range.from(He):He&&(!X?.isEqual(He.inserting)||!Q?.isEqual(He.replacing))&&(Te.j={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Te}}class x{async provideInlineCompletions(q,V,X,Q){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,X){}handlePartialAccept(q,V,X,Q){}}class U extends x{constructor(q,V,X,Q){super(),this.f=q,this.g=V,this.h=X,this.j=Q,this.d=new be,this.e=(0,s.$bG)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$bG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,X,Q){const fe=this.g.getDocument(q),we=i.Position.to(V),Te=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Q);if(!Te||Q.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,xe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],it=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:He}),items:He.map((ot,Se)=>{let Be;ot.command&&(rt||(rt=new b.$Tc),Be=this.j.toInternal(ot.command,rt));const Ge=ot.insertText;return{insertText:typeof Ge=="string"?Ge:{snippet:Ge.value},filterText:ot.filterText,range:ot.range?i.Range.from(ot.range):void 0,command:Be,idx:Se,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:xe.map(ot=>(rt||(rt=new b.$Tc),this.j.toInternal(ot,rt))),suppressSuggestions:!1,enableForwardStability:it}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,X){const Q=this.d.get(q)?.items[V];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,X)}handlePartialAccept(q,V,X,Q){const fe=this.d.get(q)?.items[V];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,X),this.h.handleDidPartiallyAcceptCompletionItem(fe,i.PartialAcceptInfo.to(Q)))}}class ie{async provideInlineEdits(q,V,X){const Q=this.f.getDocument(q),fe=await this.g.provideInlineEdit(Q,{triggerKind:this.e[V.triggerKind]},X);if(!fe||X.isCancellationRequested)return;let we;const Te=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let He;fe.accepted&&(we||(we=new b.$Tc),He=this.h.toInternal(fe.accepted,we));let xe;return fe.rejected&&(we||(we=new b.$Tc),xe=this.h.toInternal(fe.rejected,we)),{pid:Te,text:fe.text,range:i.Range.from(fe.range),accepted:He,rejected:xe}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,X,Q){this.f=V,this.g=X,this.h=Q,this.d=new be,this.e={[c.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class Ce{constructor(q,V){this.e=q,this.f=V,this.d=new t.$mjc("SignatureHelp")}async provideSignatureHelp(q,V,X,Q){const fe=this.e.getDocument(q),we=i.Position.to(V),Te=this.g(X),He=await this.f.provideSignatureHelp(fe,we,Q,Te);if(He){const xe=this.d.add([He]);return{...i.SignatureHelp.from(He),id:xe}}}g(q){let V;if(q.activeSignatureHelp){const X=i.SignatureHelp.to(q.activeSignatureHelp),Q=this.d.get(q.activeSignatureHelp.id,0);Q?(V=Q,V.activeSignature=X.activeSignature,V.activeParameter=X.activeParameter):V=X}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class ae{constructor(q,V,X,Q,fe){this.f=q,this.g=V,this.h=X,this.j=Q,this.k=fe,this.d=new t.$mjc("InlayHints"),this.e=new Map}async provideInlayHints(q,V,X){const Q=this.f.getDocument(q),fe=i.Range.to(V),we=await this.h.provideInlayHints(Q,fe,X);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(X.isCancellationRequested)return;const Te=this.d.add(we);this.e.set(Te,new b.$Tc);const He={hints:[],cacheId:Te};for(let xe=0;xe<we.length;xe++)this.l(we[xe],fe)&&He.hints.push(this.m(we[xe],[Te,xe]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),He}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...q);if(!X)return;const Q=await this.h.resolveInlayHint(X,V);if(Q&&this.l(Q))return this.m(Q,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const X=this.e.get(V[0]);if(!X)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")Q.label=q.label;else{const fe=[];Q.label=fe;for(const we of q.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};r.$FM.isLocation(we.location)&&(Te.location=i.location.from(we.location)),we.command&&(Te.command=this.g.toInternal(we.command,X)),fe.push(Te)}}return Q}}class ce{constructor(q,V){this.e=q,this.f=V,this.d=new t.$mjc("DocumentLink")}async provideLinks(q,V){const X=this.e.getDocument(q),Q=await this.f.provideDocumentLinks(X,V);if(!(!Array.isArray(Q)||Q.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ce.g).map(i.DocumentLink.from)};{const fe=this.d.add(Q),we={links:[],cacheId:fe};for(let Te=0;Te<Q.length;Te++){if(!ce.g(Q[Te]))continue;const He=i.DocumentLink.from(Q[Te]);He.cacheId=[fe,Te],we.links.push(He)}return we}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...q);if(!X)return;const Q=await this.f.resolveDocumentLink(X,V);if(!(!Q||!ce.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(q){this.d.delete(q)}}class se{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const X=this.d.getDocument(q),Q=await this.e.provideDocumentColors(X,V);return Array.isArray(Q)?Q.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(q,V,X){const Q=this.d.getDocument(q),fe=i.Range.to(V.range),we=i.Color.to(V.color),Te=await this.e.provideColorPresentations(we,{document:Q,range:fe},X);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class K{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,X){const Q=this.d.getDocument(q),fe=await this.e.provideFoldingRanges(Q,V,X);if(Array.isArray(fe))return fe.map(i.FoldingRange.from)}}class te{constructor(q,V,X){this.d=q,this.e=V,this.f=X}async provideSelectionRanges(q,V,X){const Q=this.d.getDocument(q),fe=V.map(i.Position.to),we=await this.e.provideSelectionRanges(Q,fe,X);if(!(0,u.$Lb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let He=0;He<fe.length;He++){const xe=[];Te.push(xe);let it=fe[He],rt=we[He];for(;;){if(!rt.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(i.SelectionRange.from(rt)),!rt.parent)break;it=rt.range,rt=rt.parent}}return Te}}class le{constructor(q,V){this.f=q,this.g=V,this.d=new M.$RO(""),this.e=new Map}async prepareSession(q,V,X){const Q=this.f.getDocument(q),fe=i.Position.to(V),we=await this.g.prepareCallHierarchy(Q,fe,X);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideCallsTo(q,V,X){const Q=this.j(q,V);if(!Q)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(Q,X);if(fe)return fe.map(we=>({from:this.h(q,we.from),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(q,V,X){const Q=this.j(q,V);if(!Q)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(Q,X);if(fe)return fe.map(we=>({to:this.h(q,we.to),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(q){this.e.delete(q)}h(q,V){const X=this.e.get(q),Q=i.CallHierarchyItem.from(V,q,X.size.toString(36));return X.set(Q._itemId,V),Q}j(q,V){return this.e.get(q)?.get(V)}}class de{constructor(q,V){this.f=q,this.g=V,this.d=new M.$RO(""),this.e=new Map}async prepareSession(q,V,X){const Q=this.f.getDocument(q),fe=i.Position.to(V),we=await this.g.prepareTypeHierarchy(Q,fe,X);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideSupertypes(q,V,X){const Q=this.j(q,V);if(!Q)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(Q,X);if(fe)return fe.map(we=>this.h(q,we))}async provideSubtypes(q,V,X){const Q=this.j(q,V);if(!Q)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(Q,X);if(fe)return fe.map(we=>this.h(q,we))}releaseSession(q){this.e.delete(q)}h(q,V){const X=this.e.get(q),Q=i.TypeHierarchyItem.from(V,q,X.size.toString(36));return X.set(Q._itemId,V),Q}j(q,V){return this.e.get(q)?.get(V)}}class Ae{constructor(q,V,X,Q,fe){this.d=q,this.e=V,this.f=X,this.g=Q,this.h=fe}async provideDocumentOnDropEdits(q,V,X,Q,fe){const we=this.e.getDocument(V),Te=i.Position.to(X),He=i.DataTransfer.toDataTransfer(Q,async it=>(await this.d.$resolveDocumentOnDropFileData(this.g,q,it)).buffer),xe=await this.f.provideDocumentDropEdits(we,Te,He,fe);if(xe)return(0,u.$3b)(xe).map(it=>({title:it.title??(0,o.localize)(1,null,this.h.displayName||this.h.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(rt=>rt.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}}class me{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,X,Q){const fe=p.URI.revive(q),we=this.d.getDocument(fe),Te=X.documents.map(it=>it.map(rt=>({uri:p.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(at=>i.Range.to(at))}))),He={documents:Te,selections:Te[0]?.[0]?.ranges??[]},xe=await this.e.provideMappedEdits(we,V,He,Q);return xe?i.WorkspaceEdit.from(xe):null}}class Ie{constructor(q,V){this.adapter=q,this.extension=V}}class Re{static{this.d=0}constructor(q,V,X,Q,fe,we,Te,He){this.g=V,this.h=X,this.j=Q,this.k=fe,this.l=we,this.m=Te,this.n=He,this.f=new Map,this.e=q.getProxy(f.$rM.MainThreadLanguageFeatures)}o(q,V){return i.DocumentSelector.from(q,this.g,V)}p(q){return new r.$tM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Re.d++}async s(q,V,X,Q,fe,we=!1){const Te=this.f.get(q);if(!Te||!(Te.adapter instanceof V))return Q;const He=Date.now();we||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const xe=X(Te.adapter,Te.extension);return Promise.resolve(xe).catch(it=>{(0,A.$4)(it)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(it),this.n.onExtensionError(Te.extension.identifier,it))}).finally(()=>{we||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),O.CancellationToken.isCancellationToken(fe)?(0,L.$0g)(xe,fe):xe}t(q,V){const X=this.q();return this.f.set(X,new Ie(q,V)),X}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,V,X,Q){const fe=this.t(new d(this.h,X),q),we=Q&&Q.label||Re.u(q);return this.e.$registerDocumentSymbolProvider(fe,this.o(V,q),we),this.p(fe)}$provideDocumentSymbols(q,V,X){return this.s(q,d,Q=>Q.provideDocumentSymbols(p.URI.revive(V),X),void 0,X)}registerCodeLensProvider(q,V,X){const Q=this.q(),fe=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new Ie(new l(this.h,this.j.converter,X,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(Q,this.o(V,q),fe);let we=this.p(Q);if(fe!==void 0){const Te=X.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(fe));we=r.$tM.from(we,Te)}return we}$provideCodeLenses(q,V,X){return this.s(q,l,Q=>Q.provideCodeLenses(p.URI.revive(V),X),void 0,X)}$resolveCodeLens(q,V,X){return this.s(q,l,Q=>Q.resolveCodeLens(V,X),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,l,X=>Promise.resolve(X.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,X){const Q=this.t(new h(this.h,X),q);return this.e.$registerDefinitionSupport(Q,this.o(V,q)),this.p(Q)}$provideDefinition(q,V,X,Q){return this.s(q,h,fe=>fe.provideDefinition(p.URI.revive(V),X,Q),[],Q)}registerDeclarationProvider(q,V,X){const Q=this.t(new g(this.h,X),q);return this.e.$registerDeclarationSupport(Q,this.o(V,q)),this.p(Q)}$provideDeclaration(q,V,X,Q){return this.s(q,g,fe=>fe.provideDeclaration(p.URI.revive(V),X,Q),[],Q)}registerImplementationProvider(q,V,X){const Q=this.t(new S(this.h,X),q);return this.e.$registerImplementationSupport(Q,this.o(V,q)),this.p(Q)}$provideImplementation(q,V,X,Q){return this.s(q,S,fe=>fe.provideImplementation(p.URI.revive(V),X,Q),[],Q)}registerTypeDefinitionProvider(q,V,X){const Q=this.t(new w(this.h,X),q);return this.e.$registerTypeDefinitionSupport(Q,this.o(V,q)),this.p(Q)}$provideTypeDefinition(q,V,X,Q){return this.s(q,w,fe=>fe.provideTypeDefinition(p.URI.revive(V),X,Q),[],Q)}registerHoverProvider(q,V,X,Q){const fe=this.t(new E(this.h,X),q);return this.e.$registerHoverProvider(fe,this.o(V,q)),this.p(fe)}$provideHover(q,V,X,Q){return this.s(q,E,fe=>fe.provideHover(p.URI.revive(V),X,Q),void 0,Q)}registerEvaluatableExpressionProvider(q,V,X,Q){const fe=this.t(new y(this.h,X),q);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(V,q)),this.p(fe)}$provideEvaluatableExpression(q,V,X,Q){return this.s(q,y,fe=>fe.provideEvaluatableExpression(p.URI.revive(V),X,Q),void 0,Q)}registerInlineValuesProvider(q,V,X,Q){const fe=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new D(this.h,X),q);this.e.$registerInlineValuesProvider(we,this.o(V,q),fe);let Te=this.p(we);if(fe!==void 0){const He=X.onDidChangeInlineValues(xe=>this.e.$emitInlineValuesEvent(fe));Te=r.$tM.from(Te,He)}return Te}$provideInlineValues(q,V,X,Q,fe){return this.s(q,D,we=>we.provideInlineValues(p.URI.revive(V),X,Q,fe),void 0,fe)}registerDocumentHighlightProvider(q,V,X){const Q=this.t(new P(this.h,X),q);return this.e.$registerDocumentHighlightProvider(Q,this.o(V,q)),this.p(Q)}registerMultiDocumentHighlightProvider(q,V,X){const Q=this.t(new z(this.h,X),q);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(V,q)),this.p(Q)}$provideDocumentHighlights(q,V,X,Q){return this.s(q,P,fe=>fe.provideDocumentHighlights(p.URI.revive(V),X,Q),void 0,Q)}$provideMultiDocumentHighlights(q,V,X,Q,fe){return this.s(q,z,we=>we.provideMultiDocumentHighlights(p.URI.revive(V),X,Q.map(Te=>p.URI.revive(Te)),fe),void 0,fe)}registerLinkedEditingRangeProvider(q,V,X){const Q=this.t(new F(this.h,X),q);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(V,q)),this.p(Q)}$provideLinkedEditingRanges(q,V,X,Q){return this.s(q,F,async fe=>{const we=await fe.provideLinkedEditingRanges(p.URI.revive(V),X,Q);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Re.w(we.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(q,V,X){const Q=this.t(new T(this.h,X),q);return this.e.$registerReferenceSupport(Q,this.o(V,q)),this.p(Q)}$provideReferences(q,V,X,Q,fe){return this.s(q,T,we=>we.provideReferences(p.URI.revive(V),X,Q,fe),void 0,fe)}registerCodeActionProvider(q,V,X,Q){const fe=new b.$Tc,we=this.t(new j(this.h,this.j.converter,this.k,X,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(we,this.o(V,q),{providedKinds:Q?.providedCodeActionKinds?.map(Te=>Te.value),documentation:Q?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,fe)}))},Re.u(q),!!X.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(q,V,X,Q,fe){return this.s(q,j,we=>we.provideCodeActions(p.URI.revive(V),X,Q,fe),void 0,fe)}$resolveCodeAction(q,V,X){return this.s(q,j,Q=>Q.resolveCodeAction(V,X),{},void 0)}$releaseCodeActions(q,V){this.s(q,j,X=>Promise.resolve(X.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,X){const Q=this.t(new B(this.h,X),q);return this.e.$registerDocumentFormattingSupport(Q,this.o(V,q),q.identifier,q.displayName||q.name),this.p(Q)}$provideDocumentFormattingEdits(q,V,X,Q){return this.s(q,B,fe=>fe.provideDocumentFormattingEdits(p.URI.revive(V),X,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(q,V,X){const Q=typeof X.provideDocumentRangesFormattingEdits=="function",fe=this.t(new W(this.h,X),q);return this.e.$registerRangeFormattingSupport(fe,this.o(V,q),q.identifier,q.displayName||q.name,Q),this.p(fe)}$provideDocumentRangeFormattingEdits(q,V,X,Q,fe){return this.s(q,W,we=>we.provideDocumentRangeFormattingEdits(p.URI.revive(V),X,Q,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(q,V,X,Q,fe){return this.s(q,W,we=>we.provideDocumentRangesFormattingEdits(p.URI.revive(V),X,Q,fe),void 0,fe)}registerOnTypeFormattingEditProvider(q,V,X,Q){const fe=this.t(new Y(this.h,X),q);return this.e.$registerOnTypeFormattingSupport(fe,this.o(V,q),Q,q.identifier),this.p(fe)}$provideOnTypeFormattingEdits(q,V,X,Q,fe,we){return this.s(q,Y,Te=>Te.provideOnTypeFormattingEdits(p.URI.revive(V),X,Q,fe,we),void 0,we)}registerWorkspaceSymbolProvider(q,V){const X=this.t(new _(V,this.l),q);return this.e.$registerNavigateTypeSupport(X,typeof V.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(q,V,X){return this.s(q,_,Q=>Q.provideWorkspaceSymbols(V,X),{symbols:[]},X)}$resolveWorkspaceSymbol(q,V,X){return this.s(q,_,Q=>Q.resolveWorkspaceSymbol(V,X),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,_,X=>X.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,X){const Q=this.t(new J(this.h,X,this.l),q);return this.e.$registerRenameSupport(Q,this.o(V,q),J.supportsResolving(X)),this.p(Q)}$provideRenameEdits(q,V,X,Q,fe){return this.s(q,J,we=>we.provideRenameEdits(p.URI.revive(V),X,Q,fe),void 0,fe)}$resolveRenameLocation(q,V,X,Q){return this.s(q,J,fe=>fe.resolveRenameLocation(p.URI.revive(V),X,Q),void 0,Q)}registerNewSymbolNamesProvider(q,V,X){const Q=this.t(new Z(this.h,X,this.l),q);return this.e.$registerNewSymbolNamesProvider(Q,this.o(V,q)),this.p(Q)}$provideNewSymbolNames(q,V,X,Q){return this.s(q,Z,fe=>fe.provideNewSymbolNames(p.URI.revive(V),X,Q),void 0,Q)}registerDocumentSemanticTokensProvider(q,V,X,Q){const fe=this.t(new ee(this.h,X),q),we=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(V,q),Q,we);let Te=this.p(fe);if(we){const He=X.onDidChangeSemanticTokens(xe=>this.e.$emitDocumentSemanticTokensEvent(we));Te=r.$tM.from(Te,He)}return Te}$provideDocumentSemanticTokens(q,V,X,Q){return this.s(q,ee,fe=>fe.provideDocumentSemanticTokens(p.URI.revive(V),X,Q),null,Q)}$releaseDocumentSemanticTokens(q,V){this.s(q,ee,X=>X.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,X,Q){const fe=this.t(new pe(this.h,X),q);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(V,q),Q),this.p(fe)}$provideDocumentRangeSemanticTokens(q,V,X,Q){return this.s(q,pe,fe=>fe.provideDocumentRangeSemanticTokens(p.URI.revive(V),X,Q),null,Q)}registerCompletionItemProvider(q,V,X,Q){const fe=this.t(new De(this.h,this.j.converter,X,this.m,q),q);return this.e.$registerCompletionsProvider(fe,this.o(V,q),Q,De.supportsResolving(X),q.identifier),this.p(fe)}$provideCompletionItems(q,V,X,Q,fe){return this.s(q,De,we=>we.provideCompletionItems(p.URI.revive(V),X,Q,fe),void 0,fe)}$resolveCompletionItem(q,V,X){return this.s(q,De,Q=>Q.resolveCompletionItem(V,X),void 0,X)}$releaseCompletionItems(q,V){this.s(q,De,X=>X.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,X,Q){const fe=new U(q,this.h,X,this.j.converter),we=this.t(fe,q);return this.e.$registerInlineCompletionsSupport(we,this.o(V,q),fe.supportsHandleEvents,n.$Dm.toKey(q.identifier.value),Q?.yieldTo?.map(Te=>n.$Dm.toKey(Te))||[]),this.p(we)}$provideInlineCompletions(q,V,X,Q,fe){return this.s(q,x,we=>we.provideInlineCompletions(p.URI.revive(V),X,Q,fe),void 0,fe)}$handleInlineCompletionDidShow(q,V,X,Q){this.s(q,x,async fe=>{fe.handleDidShowCompletionItem(V,X,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,X,Q,fe){this.s(q,x,async we=>{we.handlePartialAccept(V,X,Q,fe)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,x,async X=>{X.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,X){const Q=new ie(q,this.h,X,this.j.converter),fe=this.t(Q,q);return this.e.$registerInlineEditProvider(fe,this.o(V,q),q.identifier),this.p(fe)}$provideInlineEdit(q,V,X,Q){return this.s(q,ie,fe=>fe.provideInlineEdits(p.URI.revive(V),X,Q),void 0,Q)}$freeInlineEdit(q,V){this.s(q,ie,async X=>{X.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,X,Q){const fe=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,we=this.t(new Ce(this.h,X),q);return this.e.$registerSignatureHelpProvider(we,this.o(V,q),fe),this.p(we)}$provideSignatureHelp(q,V,X,Q,fe){return this.s(q,Ce,we=>we.provideSignatureHelp(p.URI.revive(V),X,Q,fe),void 0,fe)}$releaseSignatureHelp(q,V){this.s(q,Ce,X=>X.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,X){const Q=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new ae(this.h,this.j.converter,X,this.l,q),q);this.e.$registerInlayHintsProvider(fe,this.o(V,q),typeof X.resolveInlayHint=="function",Q,Re.u(q));let we=this.p(fe);if(Q!==void 0){const Te=X.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(Q));we=r.$tM.from(we,Te)}return we}$provideInlayHints(q,V,X,Q){return this.s(q,ae,fe=>fe.provideInlayHints(p.URI.revive(V),X,Q),void 0,Q)}$resolveInlayHint(q,V,X){return this.s(q,ae,Q=>Q.resolveInlayHint(V,X),void 0,X)}$releaseInlayHints(q,V){this.s(q,ae,X=>X.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,X){const Q=this.t(new ce(this.h,X),q);return this.e.$registerDocumentLinkProvider(Q,this.o(V,q),typeof X.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(q,V,X){return this.s(q,ce,Q=>Q.provideLinks(p.URI.revive(V),X),void 0,X,V.scheme==="output")}$resolveDocumentLink(q,V,X){return this.s(q,ce,Q=>Q.resolveLink(V,X),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,ce,X=>X.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,X){const Q=this.t(new se(this.h,X),q);return this.e.$registerDocumentColorProvider(Q,this.o(V,q)),this.p(Q)}$provideDocumentColors(q,V,X){return this.s(q,se,Q=>Q.provideColors(p.URI.revive(V),X),[],X)}$provideColorPresentations(q,V,X,Q){return this.s(q,se,fe=>fe.provideColorPresentations(p.URI.revive(V),X,Q),void 0,Q)}registerFoldingRangeProvider(q,V,X){const Q=this.q(),fe=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new Ie(new K(this.h,X),q)),this.e.$registerFoldingRangeProvider(Q,this.o(V,q),q.identifier,fe);let we=this.p(Q);if(fe!==void 0){const Te=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=r.$tM.from(we,Te)}return we}$provideFoldingRanges(q,V,X,Q){return this.s(q,K,fe=>fe.provideFoldingRanges(p.URI.revive(V),X,Q),void 0,Q)}registerSelectionRangeProvider(q,V,X){const Q=this.t(new te(this.h,X,this.l),q);return this.e.$registerSelectionRangeProvider(Q,this.o(V,q)),this.p(Q)}$provideSelectionRanges(q,V,X,Q){return this.s(q,te,fe=>fe.provideSelectionRanges(p.URI.revive(V),X,Q),[],Q)}registerCallHierarchyProvider(q,V,X){const Q=this.t(new le(this.h,X),q);return this.e.$registerCallHierarchyProvider(Q,this.o(V,q)),this.p(Q)}$prepareCallHierarchy(q,V,X,Q){return this.s(q,le,fe=>Promise.resolve(fe.prepareSession(p.URI.revive(V),X,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,V,X,Q){return this.s(q,le,fe=>fe.provideCallsTo(V,X,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,V,X,Q){return this.s(q,le,fe=>fe.provideCallsFrom(V,X,Q),void 0,Q)}$releaseCallHierarchy(q,V){this.s(q,le,X=>Promise.resolve(X.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,X){const Q=this.t(new de(this.h,X),q);return this.e.$registerTypeHierarchyProvider(Q,this.o(V,q)),this.p(Q)}$prepareTypeHierarchy(q,V,X,Q){return this.s(q,de,fe=>Promise.resolve(fe.prepareSession(p.URI.revive(V),X,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,V,X,Q){return this.s(q,de,fe=>fe.provideSupertypes(V,X,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,V,X,Q){return this.s(q,de,fe=>fe.provideSubtypes(V,X,Q),void 0,Q)}$releaseTypeHierarchy(q,V){this.s(q,de,X=>Promise.resolve(X.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,X,Q){const fe=this.q();return this.f.set(fe,new Ie(new Ae(this.e,this.h,X,fe,q),q)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(V,q),(0,s.$bG)(q,"dropMetadata")?Q:void 0),this.p(fe)}$provideDocumentOnDropEdits(q,V,X,Q,fe,we){return this.s(q,Ae,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(V,p.URI.revive(X),Q,fe,we)),void 0,void 0)}registerMappedEditsProvider(q,V,X){const Q=this.t(new me(this.h,X),q);return this.e.$registerMappedEditsProvider(Q,this.o(V,q)),this.p(Q)}$provideMappedEdits(q,V,X,Q,fe){return this.s(q,me,we=>Promise.resolve(we.provideMappedEdits(V,X,Q,fe)),null,fe)}registerDocumentPasteEditProvider(q,V,X,Q){const fe=this.q();return this.f.set(fe,new Ie(new N(this.e,this.h,X,fe,q),q)),this.e.$registerPasteEditProvider(fe,this.o(V,q),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(q,V,X,Q,fe){return this.s(q,N,we=>we.prepareDocumentPaste(p.URI.revive(V),X,Q,fe),void 0,fe)}$providePasteEdits(q,V,X,Q,fe,we,Te){return this.s(q,N,He=>He.providePasteEdits(V,p.URI.revive(X),Q,fe,we,Te),void 0,Te)}$resolvePasteEdit(q,V,X){return this.s(q,N,Q=>Q.resolvePasteEdit(V,X),{},void 0)}$releasePasteEdits(q,V){this.s(q,N,X=>Promise.resolve(X.releasePasteEdits(V)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Re.w(q.decreaseIndentPattern),increaseIndentPattern:Re.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Re.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Re.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Re.w(q.beforeText),afterText:q.afterText?Re.w(q.afterText):void 0,previousLineText:q.previousLineText?Re.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Re.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>r.SyntaxTokenType.toString(V)):void 0}}static D(q){return q.map(Re.C)}setLanguageConfiguration(q,V,X){const{wordPattern:Q}=X;if(Q&&(0,R.$0e)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(V,Q):this.h.setWordDefinitionFor(V,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const fe=this.q(),we={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Re.w(X.wordPattern):void 0,indentationRules:X.indentationRules?Re.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Re.B(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Re.D(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,V,we),this.p(fe)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$wjc=Re}),define(ke[121],Ee([1,0,3,6,16,7,108,25,8,4,221,145,13,5,20,120,12]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=e.$Djc=void 0,e.$Djc=(0,C.$ii)("IExtHostLanguageModels");class n{constructor(t,f){this.option=t,this.stream=new $.$Lh,this.stream=f??new $.$Lh}}class i{constructor(){this.a=new Map,this.b=new $.$Lh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new n(t.index,this.b):f=new n(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{o=this}static{this.a=1}constructor(t,f,d){this.j=f,this.k=d,this.c=new v.$7d,this.d=new v.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Fm,this.i=new Map,this.o=new Set,this.b=t.getProxy(L.$rM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,d,l){const a=o.a++;this.f.set(a,{extension:t.identifier,provider:d,languageModelId:f});let h;return l.auth&&(h={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this.b.$registerLanguageModelProvider(a,f,{extension:t.identifier,identifier:f,model:l.name??"",auth:h}),(0,u.$Sc)(()=>{this.f.delete(a),this.b.$unregisterProvider(a)})}async $provideLanguageModelResponse(t,f,d,l,a,h){const g=this.f.get(t);if(!g)return;const S=new M.$Rv(async w=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:w.index,part:w.part})});return g.provider.provideLanguageModelResponse2(l.map(O.LanguageModelMessage.to),a,b.$Dm.toKey(d),S,h)}$updateLanguageModels(t){const f=[],d=[];if(t.added)for(const l of t.added)this.g.set(l.identifier,l),f.push(l.model);if(t.removed)for(const l of t.removed){this.g.delete(l),d.push(l);for(const[a,h]of this.i)h.languageModelId===l&&(h.res.reject(new p.$5),this.i.delete(a))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:d,to:l,enabled:a}of t){const h=this.h.get(d)??new b.$Em;if(h.has(l)!==a){a?h.add(l):h.delete(l),this.h.set(d,h);const S={from:d,to:l};f.push(S),this.c.fire(S)}}}async sendChatRequest(t,f,d,l,a){const h=t.identifier,g=await this.b.$prepareChatAccess(h,f,l.justification);if(!g||!this.g.has(f))throw A.$zO.NotFound(`Language model '${f}' is unknown.`);if(this.m(h,g)&&(!await this.l(t,{identifier:g.extension,displayName:g.auth.providerLabel},l.justification,l.silent)||!this.h.get(h)?.has(g.extension)))throw A.$zO.NoPermissions(`Language model '${f}' cannot be used by '${h.value}'.`);const S=Math.random()*1e6|0,w=this.b.$fetchResponse(h,f,S,d.map(O.LanguageModelMessage.from),l.modelOptions??{},a),E=new $.$hh,y=new i;this.i.set(S,{languageModelId:f,res:y});let D;if(w.catch(P=>{E.isOpen()?y.reject(P):D=P}).finally(()=>{this.i.delete(S),y.resolve(),E.open()}),await E.wait(),D)throw new A.$zO(`Language model '${f}' errored, check cause for more details`,"Unknown",D);return y.apiObject}async $handleResponseFragment(t,f){const d=this.i.get(t);d&&d.res.handleFragment(f)}async l(t,f,d,l){const a=I.$tL+f.identifier.value;if(await this.k.getSession(t,a,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(l)return!1;try{const g=d?(0,R.localize)(0,null,f.displayName,d):(0,R.localize)(1,null,f.displayName);return await this.k.getSession(t,a,[],{forceNewSession:{detail:g}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!b.$Dm.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,d=v.Event.signal(v.Event.filter(this.c.event,a=>b.$Dm.equals(a.from,t.identifier))),l=v.Event.signal(this.d.event);return{get onDidChange(){return v.Event.any(d,l)},canSendRequest(a){const h=f.g.get(a);if(!h)return;if(!f.m(t.identifier,h))return!0;const g=f.h.get(t.identifier);if(g)return g.has(h.extension)}}}};e.$Ejc=r,e.$Ejc=r=o=Je([qe(0,k.$MO),qe(1,m.$Oj),qe(2,c.$yjc)],r)}),define(ke[338],Ee([1,0,6,16,7,40,8,3,26]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=void 0;class v{constructor(I,p,C,k){this.c=p,this.d=C,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(u.$rM.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,p){await this.a.$changeLanguage(I,p);const C=this.c.getDocumentData(I);if(!C)throw new Error(`document '${I.toString()}' NOT found`);return C.document}async tokenAtPosition(I,p){const C=I.version,k=L.Position.from(p),c=await this.a.$tokensAtPosition(I.uri,k),m={type:O.StandardTokenType.Other,range:I.getWordRangeAtPosition(p)??new O.$vM(p.line,p.character,p.line,p.character)};if(!c)return m;const o={range:L.Range.to(c.range),type:L.TokenType.to(c.type)};return!o.range.contains(p)||C!==I.version?m:o}createLanguageStatusItem(I,p,C){const k=this.f++,c=this.a,m=this.g,o=`${I.identifier.value}/${p}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);m.add(o);const n={selector:C,id:p,name:I.displayName??I.name,severity:O.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new b.$Tc,s=()=>{if(i?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${p}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$kh)(()=>{r.clear(),this.a.$setLanguageStatus(k,{id:o,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===O.LanguageStatusSeverity.Error?A.default.Error:n.severity===O.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),c.$removeLanguageStatus(k),m.delete(o)},get id(){return n.id},get name(){return n.name},set name(f){n.name=f,s()},get selector(){return n.selector},set selector(f){n.selector=f,s()},get text(){return n.text},set text(f){n.text=f,s()},set text2(f){(0,$.$cG)(I,"languageStatusText"),n.text=f,s()},get text2(){return(0,$.$cG)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(f){n.detail=f,s()},get severity(){return n.severity},set severity(f){n.severity=f,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(f){n.accessibilityInformation=f,s()},get command(){return n.command},set command(f){n.command=f,s()},get busy(){return n.busy},set busy(f){n.busy=f,s()}};return s(),t}}e.$Xkc=v}),define(ke[339],Ee([1,0,15,2,16,7,119]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=e.$Ikc=void 0;class b{constructor(I,p,C,k){this.start=I,this.deletedCount=p,this.deletedItems=C,this.items=k}asApiEvent(){return{range:new A.$UN(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,p,C){this.notebook=I,this.h=p,this.j=C,this.handle=C.handle,this.uri=L.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(O.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(O.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:O.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(k){I.g=k},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(C)}return this.f}setOutputs(I){this.a=I.map(O.NotebookCellOutput.to)}setOutputItems(I,p,C){const k=C.map(O.NotebookCellOutputItem.to),c=this.a.find(m=>m.id===I);if(c&&(p||(c.items.length=0),c.items.push(...k),c.items.length>1&&c.items.every(m=>M.$oK(m.mime)))){const m=new Map,o=[];c.items.forEach(n=>{let i;m.has(n.mime)?i=m.get(n.mime):(i=[],m.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),c.items.length=0,o.forEach(n=>{const i=M.$pK(m.get(n));c.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(O.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Ikc=$;class v{static{this.a=0}constructor(I,p,C,k,c){this.k=I,this.l=p,this.m=C,this.uri=k,this.handle=v.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===u.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(C){return C=I.n(C),I.b[C].apiCell},getCells(C){return(C?I.p(C):I.b).map(c=>c.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,C){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:C});const k={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},c=[];for(const o of I.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,k.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,k.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),c.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),c.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),c.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),c.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),c.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<c.length;o++){const n=c[o],i=m.get(n.cell);if(i===void 0){const r=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});m.set(n.cell,r-1)}else k.cellChanges[i]={...k.cellChanges[i],...n}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,C=I.end|0;return p<0&&(p=0),C>this.b.length&&(C=this.b.length),I.with({start:p,end:C})}p(I){I=this.o(I);const p=[];for(let C=I.start;C<I.end;C++)p.push(this.b[C]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,C){if(this.j)return;const k=[],c=[],m=[];if(I.reverse().forEach(o=>{const i=o[2].map(t=>{const f=new $(this,this.l,t);return p||c.push($.asModelAddData(t)),f}),r=new b(o[0],o[1],[],i),s=this.b.splice(o[0],o[1],...i);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);k.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:m}),C)for(const o of k)C.push(o.asApiEvent())}s(I,p,C,k){const c=this.b.splice(I,p);this.b.splice(C,0,...c);const m=[new b(I,p,c.map(o=>o.apiCell),[]),new b(C,0,[],c)];for(const o of m)k.push(o.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,C,k){this.b[I].setOutputItems(p,C,k)}v(I,p){const C=this.b[I];C.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(C.uri,p)}w(I,p){const C=this.b[I];C.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Jkc=v}),define(ke[340],Ee([1,0,4,2,16,7]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=void 0;class M{constructor($,v,R,I={timeout:1500,errors:3}){this.b=$,this.c=v,this.d=R,this.f=I,this.a=new u.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(v,R,I)=>{const p=function(k){v.call(R,k)};return p.extension=$,this.a.event(p,void 0,I)}}async $participateInSave($,v,R){const I=L.URI.revive($),p=this.c.getNotebookDocument(I);if(!p)throw new Error("Unable to resolve notebook document");const C=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:O.TextDocumentSaveReason.to(v)},R,async(c,m)=>{const o=Date.now(),n=await await Promise.resolve(c);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof A.$DM?C.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(C.length===0)return!0;const k={edits:[]};for(const c of C){const{edits:m}=O.WorkspaceEdit.from(c);k.edits=k.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$Zkc=M}),define(ke[153],Ee([1,0,13,16,7]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,v,R,I,p){this.id=b,this.f=$,this.notebookData=v,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=p}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(O.$UN.isNotebookRange))throw(0,u.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,v){b.f.$tryRevealRange(b.id,L.NotebookRange.from($),v??O.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(L.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Kkc=A}),define(ke[341],Ee([1,0,4,12,16]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=void 0;let A=class{constructor(b,$){this.c=b,this.d=$,this.a=new u.$7d,this.b=new u.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const v=this.d.getEditorById(b);$.visibleRanges&&v._acceptVisibleRanges($.visibleRanges.ranges.map(O.NotebookRange.to)),$.selections&&v._acceptSelections($.selections.selections.map(O.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:v.apiEditor,visibleRanges:v.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:v.apiEditor,selections:v.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(O.ViewColumn.to(b[$]))}};e.$2kc=A,e.$2kc=A=Je([qe(0,L.$Oj)],A)}),define(ke[342],Ee([1,0,4,6,153]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=void 0;class A{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(L.$rM.MainThreadNotebookRenderers)}$postRendererMessage(b,$,v){const R=this.c.getEditorById(b);this.a.get($)?.fire({editor:R.apiEditor,message:v})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,I,p)=>this.d($).event(R,I,p),postMessage:(R,I)=>{O.$Kkc.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const p=I&&O.$Kkc.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,$,R)}}}d(b){let $=this.a.get(b);return $||($=new u.$7d({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$5kc=A}),define(ke[343],Ee([1,0,16,108,22,54,13]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=void 0;class b{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,p,C){const k=this.b++,{title:c,location:m,cancellable:o}=p,n={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(k,{location:u.ProgressLocation.from(m),title:c,source:n,cancellable:o},I.isUnderDevelopment?void 0:I.identifier.value).catch(M.$2),this.d(k,C,!!o)}d(I,p,C){let k;C&&(k=new O.$ee,this.c.set(I,k));const c=o=>{this.a.$progressEnd(o),this.c.delete(o),k?.dispose()};let m;try{m=p(new v(this.a,I),C&&k?k.token:O.CancellationToken.None)}catch(o){throw c(I),o}return m.then(o=>c(I),o=>c(I)),m}$acceptProgressCanceled(I){const p=this.c.get(I);p&&(p.cancel(),this.c.delete(I))}}e.$9kc=b;function $(R,I){return R.message=I.message,typeof I.increment=="number"&&(typeof R.increment=="number"?R.increment+=I.increment:R.increment=I.increment),R}class v extends L.$Rv{constructor(I,p){super(C=>this.throttledReport(C)),this.c=I,this.d=p}throttledReport(I){this.c.$progressReport(this.d,I)}}Je([(0,A.$Oh)(100,(R,I)=>$(R,I),()=>Object.create(null))],v.prototype,"throttledReport",null)}),define(ke[344],Ee([1,0,2,6,8,16]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;class M{static{this.a=0}constructor($,v){this.d=v,this.c=new Map,this.b=$.getProxy(L.$rM.MainThreadQuickDiff)}$provideOriginalResource($,v,R){const I=u.URI.revive(v),p=this.c.get($);return p?(0,O.$ah)(()=>p.provideOriginalResource(I,R)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider($,v,R,I){const p=M.a++;return this.c.set(p,v),this.b.$registerQuickDiffProvider(p,A.DocumentSelector.from($,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$0kc=M}),define(ke[345],Ee([1,0,22,4,3,6,2,7,13,19,40,56,26,16]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=k;function k(c,m,o){const n=c.getProxy(A.$rM.MainThreadQuickOpen);class i{constructor(g,S){this.e=new Map,this.f=0,this.a=g,this.b=S}showQuickPick(g,S,w,E=u.CancellationToken.None){this.c=void 0;const y=Promise.resolve(S),D=++this.f,P=n.$show(D,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},E),z={},F=P.then(()=>z);return Promise.race([F,y]).then(T=>{if(T===z)return;const j=(0,p.$bG)(g,"quickPickItemTooltip");return y.then(N=>{const B=[];for(let W=0;W<N.length;W++){const Y=N[W];if(typeof Y=="string")B.push({label:Y,handle:W});else if(Y.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:Y.label});else{Y.tooltip&&!j&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const _=Y.iconPath?d(Y.iconPath):void 0;B.push({label:Y.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:j?C.MarkdownString.fromStrict(Y.tooltip):void 0,handle:W})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=W=>{w.onDidSelectItem(N[W])}),n.$setItems(D,B),P.then(W=>{if(typeof W=="number")return N[W];if(Array.isArray(W))return W.map(Y=>N[Y])})})}).then(void 0,T=>{if(!(0,$.$4)(T))return n.$setError(D,T),Promise.reject(T)})}$onItemSelected(g){this.c?.(g)}showInput(g,S=u.CancellationToken.None){return this.d=g?.validateInput,n.$input(g,typeof this.d=="function",S).then(void 0,w=>{if(!(0,$.$4)(w))return Promise.reject(w)})}async $validateInput(g){if(!this.d)return;const S=await this.d(g);if(!S||typeof S=="string")return S;let w;switch(S.severity){case b.InputBoxValidationSeverity.Info:w=R.default.Info;break;case b.InputBoxValidationSeverity.Warning:w=R.default.Warning;break;case b.InputBoxValidationSeverity.Error:w=R.default.Error;break;default:w=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:w}}async showWorkspaceFolderPick(g,S=u.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!w)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(y=>y.uri.toString()===w.uri.toString())}createQuickPick(g){const S=new l(g,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(g){const S=new a(g,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(g,S){this.e.get(g)?._fireDidChangeValue(S)}$onDidAccept(g){this.e.get(g)?._fireDidAccept()}$onDidChangeActive(g,S){const w=this.e.get(g);w instanceof l&&w._fireDidChangeActive(S)}$onDidChangeSelection(g,S){const w=this.e.get(g);w instanceof l&&w._fireDidChangeSelection(S)}$onDidTriggerButton(g,S){this.e.get(g)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(g,S,w){const E=this.e.get(g);E instanceof l&&E._fireDidTriggerItemButton(S,w)}$onDidHide(g){this.e.get(g)?._fireDidHide()}}class r{static{this.a=1}constructor(g,S){this.x=g,this.y=S,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$7d,this.q=new L.$7d,this.r=new L.$7d,this.s=new L.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(g){this.b=g,this.z({title:g})}get step(){return this.c}set step(g){this.c=g,this.z({step:g})}get totalSteps(){return this.d}set totalSteps(g){this.d=g,this.z({totalSteps:g})}get enabled(){return this.g}set enabled(g){this.g=g,this.z({enabled:g})}get busy(){return this.j}set busy(g){this.j=g,this.z({busy:g})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(g){this.k=g,this.z({ignoreFocusOut:g})}get value(){return this.l}set value(g){this.l=g,this.z({value:g})}get placeholder(){return this.m}set placeholder(g){this.m=g,this.z({placeholder:g})}get buttons(){return this.n}set buttons(g){this.n=g.slice(),this.o.clear(),g.forEach((S,w)=>{const E=S===b.$RN.Back?-1:w;this.o.set(E,S)}),this.z({buttons:g.map((S,w)=>({...d(S.iconPath),tooltip:S.tooltip,handle:S===b.$RN.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(g){this.l=g,this.q.fire(g)}_fireDidTriggerButton(g){const S=this.o.get(g);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,O.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(g){if(!this.v){for(const S of Object.keys(g)){const w=g[S];this.u[S]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(h){if(h instanceof b.$pN)return{id:h.id};const g=f(h),S=t(h);return{dark:typeof g=="string"?M.URI.file(g):g,light:typeof S=="string"?M.URI.file(S):S}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function f(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const g=s(h);let S,w;return"id"in g?w=I.ThemeIcon.asClassName(g):S=g,{iconPath:S,iconClass:w}}class l extends r{constructor(g,S){super(g.identifier,S),this.O=g,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$7d,this.L=[],this.M=new L.$7d,this.N=new L.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(g){this.B=g.slice(),this.C.clear(),this.D.clear(),g.forEach((E,y)=>{this.C.set(y,E),this.D.set(E,y)});const S=(0,p.$bG)(this.O,"quickPickItemTooltip"),w=[];for(let E=0;E<g.length;E++){const y=g[E];if(y.kind===b.QuickPickItemKind.Separator)w.push({type:"separator",label:y.label});else{y.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const D=y.iconPath?d(y.iconPath):void 0;w.push({handle:E,label:y.label,iconPath:D?.iconPath,iconClass:D?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:S?C.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((P,z)=>({...d(P.iconPath),tooltip:P.tooltip,handle:z}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(g){this.E=g,this.z({canSelectMany:g})}get matchOnDescription(){return this.F}set matchOnDescription(g){this.F=g,this.z({matchOnDescription:g})}get matchOnDetail(){return this.G}set matchOnDetail(g){this.G=g,this.z({matchOnDetail:g})}get sortByLabel(){return this.H}set sortByLabel(g){this.H=g,this.z({sortByLabel:g})}get keepScrollPosition(){return this.I}set keepScrollPosition(g){this.I=g,this.z({keepScrollPosition:g})}get activeItems(){return this.J}set activeItems(g){this.J=g.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(g){this.L=g.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(g){const S=(0,v.$Hb)(g.map(w=>this.C.get(w)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(g){const S=(0,v.$Hb)(g.map(w=>this.C.get(w)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(g,S){const w=this.C.get(g);if(!w||!w.buttons||!w.buttons.length)return;const E=w.buttons[S];E&&this.N.fire({button:E,item:w})}}class a extends r{constructor(g,S){super(g.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(g){this.B=g,this.z({password:g})}get prompt(){return this.C}set prompt(g){this.C=g,this.z({prompt:g})}get valueSelection(){return this.D}set valueSelection(g){this.D=g,this.z({valueSelection:g})}get validationMessage(){return this.E}set validationMessage(g){this.E=g,g?typeof g=="string"?this.z({validationMessage:g,severity:R.default.Error}):this.z({validationMessage:g.message,severity:g.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(m,o)}}),define(ke[346],Ee([1,0,2,4,54,3,8,6,19,131,12,25,56,16,26,15,11]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=e.$_kc=void 0;function n(D){return D instanceof u.URI}function i(D,P){return D.scheme===c.Schemas.file&&P.scheme===c.Schemas.file&&m.$k?D.toString()===P.toString():D.toString().toLowerCase()===P.toString().toLowerCase()}function r(D){if(D)return typeof D.iconPath=="string"?u.URI.file(D.iconPath):u.URI.isUri(D.iconPath)||p.ThemeIcon.isThemeIcon(D.iconPath)?D.iconPath:void 0}function s(D){if(D.icon){if(u.URI.isUri(D.icon))return D.icon;if(p.ThemeIcon.isThemeIcon(D.icon))return D.icon;{const P=D.icon;return{light:P.light,dark:P.dark}}}else return}function t(D,P){if(!D.iconPath&&!P.iconPath)return 0;if(D.iconPath){if(!P.iconPath)return 1}else return-1;const z=typeof D.iconPath=="string"?D.iconPath:u.URI.isUri(D.iconPath)?D.iconPath.fsPath:D.iconPath.id,F=typeof P.iconPath=="string"?P.iconPath:u.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,v.$ar)(z,F)}function f(D,P){let z=0;if(D.strikeThrough!==P.strikeThrough)return D.strikeThrough?1:-1;if(D.faded!==P.faded)return D.faded?1:-1;if(D.tooltip!==P.tooltip)return(D.tooltip||"").localeCompare(P.tooltip||"");if(z=t(D,P),z!==0)return z;if(D.light&&P.light)z=t(D.light,P.light);else{if(D.light)return 1;if(P.light)return-1}if(z!==0)return z;if(D.dark&&P.dark)z=t(D.dark,P.dark);else{if(D.dark)return 1;if(P.dark)return-1}return z}function d(D,P){if(D.command!==P.command)return D.command<P.command?-1:1;if(D.title!==P.title)return D.title<P.title?-1:1;if(D.tooltip!==P.tooltip){if(D.tooltip!==void 0&&P.tooltip!==void 0)return D.tooltip<P.tooltip?-1:1;if(D.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(D.arguments===P.arguments)return 0;if(D.arguments)if(P.arguments){if(D.arguments.length!==P.arguments.length)return D.arguments.length-P.arguments.length}else return 1;else return-1;for(let z=0;z<D.arguments.length;z++){const F=D.arguments[z],T=P.arguments[z];if(F!==T&&!(n(F)&&n(T)&&i(F,T)))return F<T?-1:1}return 0}function l(D,P){let z=(0,v.$ar)(D.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(z!==0)return z;if(D.command&&P.command)z=d(D.command,P.command);else{if(D.command)return 1;if(P.command)return-1}if(z!==0)return z;if(D.decorations&&P.decorations)z=f(D.decorations,P.decorations);else{if(D.decorations)return 1;if(P.decorations)return-1}if(D.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)z=(0,v.$ar)(D.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(D.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(D.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)z=(0,v.$ar)(D.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(D.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return z}function a(D,P){for(let z=0;z<D.length;z++)if(D[z]!==P[z])return!1;return!0}function h(D,P){return D.command===P.command&&D.title===P.title&&D.tooltip===P.tooltip&&(D.arguments&&P.arguments?a(D.arguments,P.arguments):D.arguments===P.arguments)}function g(D,P){return(0,$.$ub)(D,P,h)}class S{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,k.$cG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,k.$cG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,k.$cG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,z,F,T,j){this.k=P,this.l=T,this.m=j,this.d="",this.e=new L.$7d,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=F}showValidationMessage(P,z){(0,k.$cG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,z)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$_kc=S;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,z,F,T,j,N,B){this.q=P,this.s=z,this.t=F,this.u=T,this.v=j,this.multiDiffEditorEnableViewChanges=N,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,z){const F=this.h.get(P);return F?(0,M.$ah)(()=>this.s.executeCommand(F.command,...F.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(l),F=(0,$.$Db)(this.o,P,l).map(N=>{const B=N.toInsert.map(W=>{const Y=this.e++;this.g.set(Y,W);const _=W.resourceUri;let J;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const se=new A.$Tc;J=this.s.converter.toInternal(W.command,se),this.j.set(Y,se)}else this.h.set(Y,W.command);const Z=(0,k.$bG)(this.w,"scmMultiDiffEditor"),re=Z?W.multiDiffEditorOriginalUri:void 0,ee=Z?W.multiFileDiffEditorModifiedUri:void 0,pe=r(W.decorations),De=W.decorations&&r(W.decorations.light)||pe,x=W.decorations&&r(W.decorations.dark)||pe,U=[De,x],ie=W.decorations&&W.decorations.tooltip||"",be=W.decorations&&!!W.decorations.strikeThrough,Ce=W.decorations&&!!W.decorations.faded,ae=W.contextValue||"";return{rawResource:[Y,_,U,ie,be,Ce,ae,J,re,ee],handle:Y}});return{start:N.start,deleteCount:N.deleteCount,toInsert:B}}),T=F.map(({start:N,deleteCount:B,toInsert:W})=>[N,B,W.map(Y=>Y.rawResource)]),j=F.reverse();for(const{start:N,deleteCount:B,toInsert:W}of j){const Y=W.map(J=>J.handle),_=this.n.splice(N,B,...Y);for(const J of _)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=P,T}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let z;(0,k.$bG)(this.x,"quickDiffProvider")&&(z=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:z})}get historyProvider(){return(0,k.$cG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,k.$cG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new A.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new A.$Tc,this.o=P;const z=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,k.$cG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,k.$cG)(this.x,"scmActionButton"),this.p.value=new A.$Tc,this.q=P;const z=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(F=>F.map(T=>this.y.converter.toInternal(T,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&g(this.t,P))return;this.s.value=new A.$Tc,this.t=P;const z=(P||[]).map(F=>this.y.converter.toInternal(F,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(P,z,F,T,j,N,B){this.x=P,this.y=T,this.z=j,this.A=N,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Vc,this.m=void 0,this.n=new A.$Vc,this.o=void 0,this.p=new A.$Vc,this.s=new A.$Vc,this.t=void 0,this.u=!1,this.v=new L.$7d,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=F;const W=u.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${j}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new S(P,z,this.#e,this.w,W),this.#e.$registerSourceControl(this.w,j,N,B,W)}createResourceGroup(P,z,F){const T=(0,k.$bG)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,j=new w(this.#e,this.y,this.w,P,z,T,this.x),N=L.Event.once(j.onDidDispose)(()=>this.C.delete(j));return this.C.set(j,N),this.eventuallyAddResourceGroups(),j}eventuallyAddResourceGroups(){const P=[],z=[];for(const[F,T]of this.C){T.dispose();const j=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});L.Event.once(F.onDidDispose)(()=>{this.D.delete(F),j.dispose(),this.e.delete(F.handle),this.#e.$unregisterGroup(this.w,F.handle)}),P.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const N=F._takeResourceStateSnapshot();N.length>0&&z.push([F.handle,N]),this.e.set(F.handle,F)}this.#e.$registerGroups(this.w,P,z),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(z=>{const F=z._takeResourceStateSnapshot();F.length!==0&&P.push([z.handle,F])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,O.$Nh)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,O.$Nh)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,z,F,T){this.l=z,this.m=F,this.n=T,this.g=new Map,this.h=new I.$Fm,this.j=new L.$7d,this.e=P.getProxy(b.$rM.MainThreadSCM),this.f=P.getProxy(b.$rM.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const N=this.g.get(j.sourceControlHandle);if(!N)return j;const B=N.getResourceGroup(j.groupHandle);return B?B.getResourceState(j.handle):j}else if(j&&j.$mid===4){const N=this.g.get(j.sourceControlHandle);return N?N.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const N=this.g.get(j.handle);return N||j}return j}})}createSourceControl(P,z,F,T){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,z,F,T),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const j=o.d++,N=new E(P,this.m,this.e,this.l,z,F,T);this.g.set(j,N);const B=this.h.get(P.identifier)||[];return B.push(N),this.h.set(P.identifier,B),N}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const z=this.h.get(P.identifier),F=z&&z[z.length-1];return F&&F.inputBox}$provideOriginalResource(P,z,F){const T=u.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",P,T.toString());const j=this.g.get(P);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ah)(()=>j.quickDiffProvider.provideOriginalResource(T,F)).then(N=>N||null)}$onInputBoxValueChange(P,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const F=this.g.get(P);return F&&F.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(P,z,F,T){this.n.trace("ExtHostSCM#$executeResourceCommand",P,z,F);const j=this.g.get(P);if(!j)return Promise.resolve(void 0);const N=j.getResourceGroup(z);return N?N.$executeResourceCommand(F,T):Promise.resolve(void 0)}$validateInput(P,z,F){this.n.trace("ExtHostSCM#$validateInput",P);const T=this.g.get(P);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ah)(()=>T.inputBox.validateInput(z,F)).then(j=>{if(!j)return Promise.resolve(void 0);const N=C.MarkdownString.fromStrict(j.message);return N?Promise.resolve([N,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,z,F,T){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,F,T)??void 0}async $provideHistoryItems(P,z,F,T){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(z,F,T))?.map(B=>({...B,icon:s(B)}))??void 0}async $provideHistoryItemSummary(P,z,F,T){const j=this.g.get(P)?.historyProvider;if(typeof j?.provideHistoryItemSummary!="function")return;const N=await j.provideHistoryItemSummary(z,F,T);return N?{...N,icon:s(N)}:void 0}async $provideHistoryItemChanges(P,z,F,T){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(z,F,T)??void 0}};e.$alc=y,e.$alc=y=o=Je([qe(3,R.$Oj)],y)}),define(ke[347],Ee([1,0,6,16,2]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class A{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(u.$rM.MainThreadShare)}async $provideShare(b,$,v){return await this.c.get(b)?.provideShare({selection:L.Range.to($.selection),resourceUri:O.URI.revive($.resourceUri)},v)??void 0}registerShareProvider(b,$){const v=A.a++;return this.c.set(v,$),this.b.$registerShareProvider(v,L.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(v),this.c.delete(v)}}}}e.$blc=A}),define(ke[348],Ee([1,0,7,6,224,3,16,18]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=e.$dlc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$qN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$qN("statusBarItem.warningForeground")]])}#e;#t;constructor(p,C,k,c,m,o=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new A.$Tc,this.#e=p,this.#t=C,m&&c){this.c=(0,u.$5M)(c.identifier,m);const i=k.get(this.c);i&&(o=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=m,this.g=o,this.h=this.u(n)}u(p){if((0,b.$Zf)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new A.$Tc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let C;this.m?C=this.m:C=(0,O.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=$.b.get(this.o.id));const c=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,C,this.k,c,this.r?.internal,k,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$dlc=$;class v{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,O.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const C={message:p};return this.b.unshift(C),this.c(),new u.$tM(()=>{const k=this.b.indexOf(C);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(p,C){this.e=new Map,this.a=p.getProxy(L.$rM.MainThreadStatusBar),this.b=C,this.c=new v(this)}$acceptStaticEntries(p){for(const C of p)this.e.set(C.entryId,C)}createStatusBarEntry(p,C,k,c){return new $(this.a,this.b,this.e,p,C,k,c)}setStatusBarMessage(p,C){const k=this.c.setMessage(p);let c;return typeof C=="number"?c=setTimeout(()=>k.dispose(),C):typeof C<"u"&&C.then(()=>k.dispose(),()=>k.dispose()),new u.$tM(()=>{k.dispose(),clearTimeout(c)})}}e.$elc=R}),define(ke[154],Ee([1,0,29,144,67,112,89,16,2]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=e.$1O=e.$ZO=e.$YO=void 0;const v=(i,r,s,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(d){if(!s(f,d)){const l=f;f=d,i.listener?.(t(d,l))}}}},R=(i,r)=>i===r,I={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,r)=>!(i.length!==r.length||i.some(s=>!r.find(t=>s.id===t.id)))},p=i=>r=>({op:4,update:i(r)}),C=(i,r)=>({range:(()=>{let s;const t=p(f=>({range:u.$ct.lift(b.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return s},set(f){i.listener?.({op:6}),I.range(s,f)||(s=f,i.listener?.(t(f)))}}})(),label:v(i,r,I.label,p(s=>({label:s}))),description:v(i,void 0,I.description,p(s=>({description:s}))),sortText:v(i,void 0,I.sortText,p(s=>({sortText:s}))),canResolveChildren:v(i,!1,I.canResolveChildren,s=>({op:2,state:s})),busy:v(i,!1,I.busy,p(s=>({busy:s}))),error:v(i,void 0,I.error,p(s=>({error:b.MarkdownString.fromStrict(s)||null}))),tags:v(i,[],I.tags,(s,t)=>({op:1,new:s.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),k=i=>{const r=O.$dL.fromString(i.extId),s=new m(r.controllerId,r.localId,i.label,$.URI.revive(i.uri)||void 0);return s.range=b.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>b.TestTag.to({id:(0,M.$jL)(t).tagId})),s},c=i=>{let r;for(const s of i.tests){const t=k(s.item);(0,L.$IO)(t).parent=r,r=t}return r};e.$YO=c;class m{constructor(r,s,t,f){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,L.$HO)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,A.$GO)(d,L.$IO,m),enumerable:!0,writable:!1},...C(d,t)})}}e.$ZO=m;class o extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$1O=o;class n extends A.$CO{constructor(r,s,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:L.$IO,getChildren:f=>f.children,root:new o(r,s),toITestItem:b.TestItem.from})}}e.$2O=n}),define(ke[33],Ee([1,0,18,7,16,24,6,19,12,57,29,49,2,3,5,20,154,21,68,46,39,87,90,30]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=void 0;let d=class{#e;#t;#i;constructor(w,E,y){this.b=new Map,this.c=new Map,this.#e=w.getProxy(M.$rM.MainThreadCommands),this.d=E,this.#i=y,this.#t=w.getProxy(M.$rM.MainThreadTelemetry),this.converter=new l(this,D=>{const P=this.c.get(D);return P?.result===h.Void?P:void 0},E),this.f=[{processArgument(D){return(0,v.$Rh)(D)}},{processArgument(D){return(0,A.$Qn)(D,function(P){if(R.$ct.isIRange(P))return O.Range.to(P);if(I.$bt.isIPosition(P))return O.Position.to(P);if(R.$ct.isIRange(P.range)&&p.URI.isUri(P.uri))return O.location.to(P);if(P instanceof o.$ue)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const E=this.registerCommand(!1,w.id,async(...y)=>{const D=w.args.map((z,F)=>{if(!z.validate(y[F]))throw new Error(`Invalid argument '${z.name}' when running '${w.id}', received: ${typeof y[F]=="object"?JSON.stringify(y[F],null,"	"):y[F]} `);return z.convert(y[F])}),P=await this.executeCommand(w.internalId,...D);return w.result.convert(P,y,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new L.$tM(()=>{E.dispose(),this.c.delete(w.id)})}registerCommand(w,E,y,D,P,z){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:y,thisArg:D,metadata:P,extension:z}),w&&this.#e.$registerCommand(E),new L.$tM(()=>{this.b.delete(E)&&w&&this.#e.$unregisterCommand(E)})}executeCommand(w,...E){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,E,!0)}async g(w,E,y){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,E,!1);{let D=!1;const P=(0,A.$Qn)(E,function(z){if(z instanceof L.$uM)return O.Position.from(z);if(z instanceof L.$vM)return O.Range.from(z);if(z instanceof L.$FM)return O.location.from(z);if(L.$UN.isNotebookRange(z))return O.NotebookRange.from(z);if(z instanceof ArrayBuffer)return D=!0,o.$ue.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return D=!0,o.$ue.wrap(z);if(z instanceof o.$ue)return D=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(w,D?new n.$ew(P):P,y);return(0,v.$Rh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(w,E,!1);throw z}}}async h(w,E,y){const D=this.b.get(w);if(!D)throw new Error("Unknown command");const{callback:P,thisArg:z,metadata:F}=D;if(F?.args)for(let j=0;j<F.args.length;j++)try{(0,u.$ag)(E[j],F.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${F.args[j].name}' - ${F.args[j].description}`)}const T=r.$3d.create();try{return await P.apply(z,E)}catch(j){if(w===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...E);N&&(w=N.command)}if(this.d.error(j,w,D.extension?.identifier),!y)throw j;if(D.extension?.identifier){const N=this.#i.onExtensionError(D.extension.identifier,j);this.d.trace("forwarded error to extension?",N,D.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$6i)(j)),this.id=w,this.source=D.extension?.displayName??D.extension?.name}}}finally{this.j(D,w,T.elapsed())}}j(w,E,y){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new s.$4o(E),duration:y})}$executeContributedCommand(w,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const y=this.b.get(w);return y?(E=E.map(D=>this.f.reduce((P,z)=>z.processArgument(P,y.extension?.identifier),D)),this.h(w,E,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(E=>(w&&(E=E.filter(y=>y[0]!=="_")),E))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[E,y]of this.b){const{metadata:D}=y;D&&(w[E]=D)}return Promise.resolve(w)}};e.$8O=d,e.$8O=d=Je([qe(0,c.$MO),qe(1,$.$Oj),qe(2,t.$7O)],d),e.$9O=(0,k.$ii)("IExtHostCommands");class l{constructor(w,E,y){this.d=w,this.f=E,this.g=y,this.delegatingCommandId=`__vsc${(0,f.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,E){if(!w)return;const y={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return y;const D=this.f(w.command);if(D)y.id=D.internalId,y.arguments=D.args.map((P,z)=>P.convert(w.arguments&&w.arguments[z]));else if((0,b.$Lb)(w.arguments)){const P=`${w.command} /${++this.c}`;this.b.set(P,w),E.add((0,C.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),y.$ident=P,y.id=this.delegatingCommandId,y.arguments=[P],this.g.trace("CommandsConverter#CREATE",w.command,P)}return y}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const E=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$0O=l;class a{static{this.Uri=new a("uri","Uri of a text document",w=>p.URI.isUri(w),w=>w)}static{this.Position=new a("position","A position in a text document",w=>L.$uM.isPosition(w),O.Position.from)}static{this.Range=new a("range","A range in a text document",w=>L.$vM.isRange(w),O.Range.from)}static{this.Selection=new a("selection","A selection in a text document",w=>L.$wM.isSelection(w),O.Selection.from)}static{this.Number=new a("number","",w=>typeof w=="number",w=>w)}static{this.String=new a("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=a.Arr(a.String)}static Arr(w){return new a(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,E=>Array.isArray(E)&&E.every(y=>w.validate(y)),E=>E.map(y=>w.convert(y)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",w=>w instanceof L.$QM,O.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",w=>w instanceof L.$bO,O.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",w=>w instanceof m.$ZO,O.TestItem.from)}constructor(w,E,y,D){this.name=w,this.description=E,this.validate=y,this.convert=D}optional(){return new a(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,E){return new a(w??this.name,E??this.description,this.validate,this.convert)}}e.$$O=a;class h{static{this.Void=new h("no result",w=>w)}constructor(w,E){this.description=w,this.convert=E}}e.$_O=h;class g{constructor(w,E,y,D,P){this.id=w,this.internalId=E,this.description=y,this.args=D,this.result=P}}e.$aP=g}),define(ke[349],Ee([1,0,19,15,2,83,134,41,33,16,7]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;const I=[new $.$aP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of DocumentHighlight-instances.",C(v.DocumentHighlight.to))),new $.$aP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$$O.Uri],new $.$_O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,u.$Kb)(c))return;class o extends R.$LM{static to(i){const r=new o(i.name,v.SymbolKind.to(i.kind),i.containerName||"",new R.$FM(m[0],v.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=v.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return c.map(o.to)})),new $.$aP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$$O.Uri,new $.$$O("options","Formatting options",c=>!0,c=>c)],new $.$_O("A promise that resolves to an array of TextEdits.",C(v.TextEdit.to))),new $.$aP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$$O.Uri,$.$$O.Range,new $.$$O("options","Formatting options",c=>!0,c=>c)],new $.$_O("A promise that resolves to an array of TextEdits.",C(v.TextEdit.to))),new $.$aP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$$O.Uri,$.$$O.Position,new $.$$O("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$$O("options","Formatting options",c=>!0,c=>c)],new $.$_O("A promise that resolves to an array of TextEdits.",C(v.TextEdit.to))),new $.$aP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$aP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$aP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$aP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$aP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of Location-instances.",C(v.location.to))),new $.$aP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of Hover-instances.",C(v.Hover.to))),new $.$aP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$$O.Uri,new $.$$O("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>R.$uM.isPosition(m)),c=>c.map(v.Position.from))],new $.$_O("A promise that resolves to an array of ranges.",c=>c.map(m=>{let o;for(const n of m.reverse())o=new R.$PM(v.Range.to(n),o);return o}))),new $.$aP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$$O.String.with("query","Search string")],new $.$_O("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(v.WorkspaceSymbol.to))),new $.$aP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(v.CallHierarchyItem.to))),new $.$aP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$$O.CallHierarchyItem],new $.$_O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(v.CallHierarchyIncomingCall.to))),new $.$aP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$$O.CallHierarchyItem],new $.$_O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(v.CallHierarchyOutgoingCall.to))),new $.$aP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:v.Range.to(c.range),placeholder:c.text}})),new $.$aP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$$O.Uri,$.$$O.Position,$.$$O.String.with("newName","The new symbol name")],new $.$_O("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return v.WorkspaceEdit.to(c)}})),new $.$aP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$$O.Uri,$.$$O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$_O("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(v.DocumentLink.to))),new $.$aP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$$O.Uri],new $.$_O("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$LN(c.tokenTypes,c.tokenModifiers)})),new $.$aP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$$O.Uri],new $.$_O("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,M.$Rab)(c);if(m.type==="full")return new R.$NN(m.data,void 0)})),new $.$aP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$$O.Uri,$.$$O.Range.optional()],new $.$_O("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$LN(c.tokenTypes,c.tokenModifiers)})),new $.$aP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$$O.Uri,$.$$O.Range],new $.$_O("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,M.$Rab)(c);if(m.type==="full")return new R.$NN(m.data,void 0)})),new $.$aP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$$O.Uri,$.$$O.Position,$.$$O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$$O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$_O("A promise that resolves to a CompletionList-instance.",(c,m,o)=>{if(!c)return new R.$2M([]);const n=c.suggestions.map(i=>v.CompletionItem.to(i,o));return new R.$2M(n,c.incomplete)})),new $.$aP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$$O.Uri,$.$$O.Position,$.$$O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$_O("A promise that resolves to SignatureHelp.",c=>{if(c)return v.SignatureHelp.to(c)})),new $.$aP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$$O.Uri,$.$$O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$_O("A promise that resolves to an array of CodeLens-instances.",(c,m,o)=>C(n=>new R.$TM(v.Range.to(n.range),n.command&&o.fromInternal(n.command)))(c))),new $.$aP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$$O.Uri,new $.$$O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.$vM.isRange(c),c=>R.$wM.isSelection(c)?v.Selection.from(c):v.Range.from(c)),$.$$O.String.with("kind","Code action kind to return code actions for").optional(),$.$$O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$_O("A promise that resolves to an array of Command-instances.",(c,m,o)=>C(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new R.$NM(n.title,n.kind?new R.$OM(n.kind):void 0);return n.edit&&(i.edit=v.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(c))),new $.$aP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$$O.Uri],new $.$_O("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new R.$8M(v.Range.to(m.range),v.Color.to(m.color))):[])),new $.$aP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$$O("color","The color to show and insert",c=>c instanceof R.$7M,v.Color.from),new $.$$O("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:v.Range.from(c.range)}))],new $.$_O("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(v.ColorPresentation.to):[])),new $.$aP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$$O.Uri,$.$$O.Range],new $.$_O("A promise that resolves to an array of Inlay objects",(c,m,o)=>c.map(v.InlayHint.to.bind(void 0,o)))),new $.$aP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$$O.Uri],new $.$_O("A promise that resolves to an array of FoldingRange objects",(c,m)=>{if(c)return c.map(v.FoldingRange.to)})),new $.$aP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$_O("A promise that resolves to an array of NotebookContentProvider static info objects.",C(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>v.NotebookExclusiveDocumentPattern.to(m))})))),new $.$aP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$$O.Uri,$.$$O.Range,new $.$$O("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof R.$vM,c=>v.InlineValueContext.from(c))],new $.$_O("A promise that resolves to an array of InlineValue objects",c=>c.map(v.InlineValue.to))),new $.$aP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$$O("uriOrString","Uri-instance or string (only http/https)",c=>O.URI.isUri(c)||typeof c=="string"&&(0,L.$sg)(c,L.Schemas.http,L.Schemas.https),c=>c),new $.$$O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[v.ViewColumn.from(c),void 0]:[v.ViewColumn.from(c.viewColumn),v.TextEditorOpenOptions.from(c)])).optional(),$.$$O.String.with("label","").optional()],$.$_O.Void),new $.$aP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$$O.Uri.with("resource","Resource to open"),$.$$O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$$O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[v.ViewColumn.from(c),void 0]:[v.ViewColumn.from(c.viewColumn),v.TextEditorOpenOptions.from(c)])).optional()],$.$_O.Void),new $.$aP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$$O.Uri.with("left","Left-hand side resource of the diff editor"),$.$$O.Uri.with("right","Right-hand side resource of the diff editor"),$.$$O.String.with("title","Human readable title for the diff editor").optional(),new $.$$O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[v.ViewColumn.from(c.viewColumn),v.TextEditorOpenOptions.from(c)]).optional()],$.$_O.Void),new $.$aP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$$O.String.with("title","Human readable title for the changes editor"),new $.$$O("resourceList","List of resources to compare",c=>{for(const m of c){if(m.length!==3)return!1;const[o,n,i]=m;if(!O.URI.isUri(o)||!O.URI.isUri(n)&&n!==void 0&&n!==null||!O.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},c=>c)],$.$_O.Void),new $.$aP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$$O.Uri,$.$$O.Position],new $.$_O("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(v.TypeHierarchyItem.to))),new $.$aP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$$O.TypeHierarchyItem],new $.$_O("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(v.TypeHierarchyItem.to))),new $.$aP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$$O.TypeHierarchyItem],new $.$_O("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(v.TypeHierarchyItem.to))),new $.$aP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$$O.TestItem],$.$_O.Void),new $.$aP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$$O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$_O.Void),new $.$aP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$$O.String.with("name","The context key name"),new $.$$O("value","The context key value",()=>!0,c=>c)],$.$_O.Void),new $.$aP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$$O.Uri,$.$$O.StringArray,new $.$$O("MappedEditsContext","Mapped Edits Context",c=>v.MappedEditsContext.is(c),c=>v.MappedEditsContext.from(c))],new $.$_O("A promise that resolves to a workspace edit or null",c=>c?v.WorkspaceEdit.to(c):null))];class p{static register(m){I.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",b.$hj)}}e.$xjc=p;function C(c){return m=>{if(Array.isArray(m))return m.map(c)}}function k(c){if(!Array.isArray(c))return;const m=[];for(const o of c)A.$3t(o)?m.push(v.DefinitionLink.to(o)):m.push(v.location.to(o));return m}}),define(ke[350],Ee([1,0,8,3,2,6,33,16,7]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=void 0;class v{static{this.a=0}constructor(C,k){this.extension=C,this.provider=k,this.handle=v.a++}}class R{constructor(C){this.session=C,this.responses=[]}}class I{static{this.a=0}constructor(C,k,c,m){this.f=c,this.g=m,this.b=new Map,this.d=new Map,this.e=C.getProxy(A.$rM.MainThreadInlineChat),k.registerApiCommand(new M.$aP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$$O("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?b.Range.from(o.initialRange):void 0,initialSelection:$.$wM.isSelection(o.initialSelection)?b.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?b.Position.from(o.position):void 0}})],M.$_O.Void))}registerProvider(C,k,c){const m=new v(C,k);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,c?.label??C.displayName??C.name,C.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function",typeof k.provideFollowups=="function",c?.supportReportIssue??!1),(0,L.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(C,k,c,m){const o=this.b.get(C);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(O.URI.revive(k)),i=b.Selection.to(c),r=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=I.a++;return this.d.set(s,new R(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(r.wholeRange),message:r.message}}async $provideResponse(C,k,c,m){const o=this.b.get(C);if(!o)return;const n=this.d.get(k.id);if(!n)return;const i={prompt:c.prompt,selection:b.Selection.to(c.selection),wholeRange:b.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,previewDocument:this.f.getDocument(O.URI.revive(c.previewDocument)),withIntentDetection:c.withIntentDetection};let r=!1;const s={report:async S=>{if(!c.live&&S.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:S.message,edits:S.edits?.map(b.TextEdit.from),editsShouldBeInstant:S.editsShouldBeInstant,slashCommand:S.slashCommand?.command,markdownFragment:$.$UM.isMarkdownString(S.content)?S.content.value:S.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,s,m));let f;try{f=await(0,u.$9g)(t,m)}finally{r=!0}if(!f)return;const d=n.responses.push(f)-1,l={wholeRange:b.Range.from(f.wholeRange),placeholder:f.placeholder};if(!I.h(f))return{...l,id:d,type:"editorEdit",message:b.MarkdownString.from(f.contents),edits:[]};const{edits:a,contents:h}=f,g=h!==void 0?b.MarkdownString.from(h):void 0;return a instanceof $.$DM?{...l,id:d,type:"bulkEdit",edits:b.WorkspaceEdit.from(a),message:g}:{...l,id:d,type:"editorEdit",edits:a.map(b.TextEdit.from),message:g}}async $provideFollowups(C,k,c,m){const o=this.b.get(C),n=this.d.get(k),i=n?.responses[c];if(o&&i&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(n.session,i,m));return(await(0,u.$9g)(r,m))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(C,k,c,m){const o=this.b.get(C),n=this.d.get(k),i=n?.responses[c];if(o&&i){const r=b.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(C,k){}static h(C){return typeof C=="object"&&typeof C.edits=="object"}}e.$Hkc=I}),define(ke[351],Ee([1,0,2,33]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=void 0;class O{constructor(M,b,$,v,R){this.a=b,this.b=$,this.c=v;const I=new L.$aP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$$O("showOptions","Show Options",p=>!0,p=>p),new L.$$O("resource","Interactive resource Uri",p=>!0,p=>p),new L.$$O("controllerId","Notebook controller Id",p=>!0,p=>p),new L.$$O("title","Interactive editor title",p=>!0,p=>p)],new L.$_O("Notebook and input URI",p=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const C=this.a.getEditorById(p.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:u.URI.revive(p.notebookUri),inputUri:u.URI.revive(p.inputUri),notebookEditor:C.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:u.URI.revive(p.notebookUri),inputUri:u.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(M,b,$,v){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Ukc=O}),define(ke[352],Ee([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,113,294,26,68,295]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=void 0,e.$4kc=a;let r=class{constructor(g,S,w,E,y){this.m=S,this.n=w,this.o=E,this.q=y,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=g.getProxy(I.$rM.MainThreadNotebookKernels);const D=new p.$aP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$$O("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const F=this.n.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:F}}else if(z&&"notebookEditor"in z){const F=this.n.getIdByEditor(z.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return z})],p.$_O.Void),P=new p.$aP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$$O.Uri],new p.$_O("A promise that resolves to an array of variables",(z,F)=>z.map(T=>({variable:{name:T.name,value:T.value,expression:T.expression,type:T.type,language:T.language},hasNamedChildren:T.hasNamedChildren,indexedChildrenCount:T.indexedChildrenCount}))));this.o.registerApiCommand(D),this.o.registerApiCommand(P)}createNotebookController(g,S,w,E,y,D){for(const pe of this.j.values())if(pe.controller.id===S&&v.$Dm.equals(g.identifier,pe.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const P=this.k++,z=this;this.q.trace(`NotebookController[${P}], CREATED by ${g.identifier.value}, ${S}`);const F=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${g.identifier}'`);let T=!1;const j=new A.$7d,N=new A.$7d,B={id:a(g.identifier,S),notebookType:w,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:E||g.identifier.value,preloads:D?D.map(C.NotebookRendererScript.from):[]};let W=y??F,Y,_;this.a.$addKernel(P,B).catch(pe=>{console.log(pe),T=!0});let J=0;const Z=()=>{if(T)return;const pe=++J;Promise.resolve().then(()=>{pe===J&&this.a.$updateKernel(P,B)})},re=new b.$Bc,ee={get id(){return S},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return B.label},set label(pe){B.label=pe??g.displayName??g.name,Z()},get detail(){return B.detail??""},set detail(pe){B.detail=pe,Z()},get description(){return B.description??""},set description(pe){B.description=pe,Z()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(pe){B.supportedLanguages=pe,Z()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){B.supportsExecutionOrder=pe,Z()},get rendererScripts(){return B.preloads?B.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(pe){W=pe??F},get interruptHandler(){return Y},set interruptHandler(pe){Y=pe,B.supportsInterrupt=!!pe,Z()},set variableProvider(pe){(0,o.$cG)(g,"notebookVariableProvider"),_=pe,B.hasVariableProvider=!!pe,pe?.onDidChangeVariables(De=>z.a.$variablesUpdated(De.uri)),Z()},get variableProvider(){return _},createNotebookCellExecution(pe){if(T)throw new Error("notebook controller is DISPOSED");if(!re.has(pe.notebook.uri))throw z.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return z._createNotebookCellExecution(pe,a(g.identifier,this.id))},createNotebookExecution(pe){if((0,o.$cG)(g,"notebookExecution"),T)throw new Error("notebook controller is DISPOSED");if(!re.has(pe.uri))throw z.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return z._createNotebookExecution(pe,a(g.identifier,this.id))},dispose:()=>{T||(this.q.trace(`NotebookController[${P}], DISPOSED`),T=!0,this.j.delete(P),j.dispose(),N.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(pe,De){De===k.NotebookControllerAffinity2.Hidden&&(0,o.$cG)(g,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(P,pe.uri,De)},onDidReceiveMessage:N.event,postMessage(pe,De){return(0,o.$cG)(g,"notebookMessaging"),z.a.$postMessage(P,De&&z.n.getIdByEditor(De),pe)},asWebviewUri(pe){return(0,o.$cG)(g,"notebookMessaging"),(0,c.$ozb)(pe,z.m.remote)}};return this.j.set(P,{extensionId:g.identifier,controller:ee,onDidReceiveMessage:N,onDidChangeSelection:j,associatedNotebooks:re}),ee}getIdByController(g){for(const[S,w]of this.j)if(w.controller===g)return a(w.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,S){const w=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(w,S);const y={dispose:()=>{this.f.delete(w),E.a.$removeKernelDetectionTask(w)}};return this.f.set(w,y),y}registerKernelSourceActionProvider(g,S,w){const E=this.i++,y=typeof w.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,D=this;this.h.set(E,w),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,S);let P;return y!==void 0&&(P=w.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(E),D.a.$removeKernelSourceActionProvider(E,E),P?.dispose()}}}async $provideKernelSourceActions(g,S){const w=this.h.get(g);if(w){const E=new M.$Tc;return(await w.provideNotebookKernelSourceActions(S)??[]).map(D=>C.NotebookKernelSourceAction.from(D,this.o.converter,E))}return[]}$acceptNotebookAssociation(g,S,w){const E=this.j.get(g);if(E){const y=this.n.getNotebookDocument($.URI.revive(S));w?E.associatedNotebooks.set(y.uri,!0):E.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,y.uri.toString(),w),E.onDidChangeSelection.fire({selected:w,notebook:y.apiNotebook})}}async $executeCells(g,S,w){const E=this.j.get(g);if(!E)return;const y=this.n.getNotebookDocument($.URI.revive(S)),D=[];for(const P of w){const z=y.getCell(P);z&&D.push(z.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,y.uri.toString(),D.length),await E.controller.executeHandler.call(E.controller,D,y.apiNotebook,E.controller)}catch(P){this.q.error(`NotebookController[${g}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(g,S,w){const E=this.j.get(g);if(!E)return;const y=this.n.getNotebookDocument($.URI.revive(S));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,y.apiNotebook);else for(const D of w){const P=y.getCell(D);P&&this.b.get(P.uri)?.cancel()}if(E.controller.interruptHandler){const D=this.c.get(y.uri);w.length&&Array.isArray(D)&&D.length&&D.forEach(P=>P.dispose())}}async $provideVariables(g,S,w,E,y,D,P){const z=this.j.get(g);if(!z)return;const F=this.n.getNotebookDocument($.URI.revive(w)),T=z.controller.variableProvider;if(!T)return;let j;if(E!==void 0){if(j=this.s[E],!j)return}else this.s={};const N=y==="named"?k.NotebookVariablesRequestKind.Named:k.NotebookVariablesRequestKind.Indexed,B=T.provideVariables(F.apiNotebook,j,N,D,P);let W=0;for await(const Y of B){if(P.isCancellationRequested)return;const _={id:this.r++,name:Y.variable.name,value:Y.variable.value,type:Y.variable.type,interfaces:Y.variable.interfaces,language:Y.variable.language,expression:Y.variable.expression,hasNamedChildren:Y.hasNamedChildren,indexedChildrenCount:Y.indexedChildrenCount,extensionId:z.extensionId.value};if(this.s[_.id]=Y.variable,this.a.$receiveVariable(S,_),W++>=i.$Lhb)return}}$acceptKernelMessageFromRenderer(g,S,w){const E=this.j.get(g);if(!E)return;const y=this.n.getEditorById(S);E.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:w}))}$cellExecutionChanged(g,S,w){const y=this.n.getNotebookDocument($.URI.revive(g)).getCell(S);if(y){const D=w?C.NotebookCellExecutionState.to(w):k.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:y.apiCell,state:D})}}_createNotebookCellExecution(g,S){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const y=new t(S,E,this.a);this.b.set(E.uri,y);const D=y.onDidChangeState(()=>{y.state===s.Resolved&&(y.dispose(),D.dispose(),this.b.delete(E.uri))});return y.asApiObject()}_createNotebookExecution(g,S){const w=this.n.getNotebookDocument(g.uri),E=g.getCells().find(P=>{const z=w.getCellFromApiCell(P);return z&&this.b.has(z.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const y=new d(S,w,this.a),D=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),D.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[y,D]),y.asApiObject()}};e.$3kc=r,e.$3kc=r=Je([qe(4,R.$Oj)],r);var s;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(s||(s={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(g,S,w){super(),this.m=S,this.n=w,this.b=t.a++,this.c=new A.$7d,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new O.$ee),this.h=new l(10,E=>this.s(E)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const S=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new n.$ew(S))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let S=this.m;if(g&&(S=this.m.notebook.getCellFromApiCell(g)),!S)throw new Error("INVALID cell");return S.handle}y(g){return g.map(S=>{const w=k.$YN.ensureUniqueMimeTypes(S.items,!0);return w===S.items?C.NotebookCellOutput.from(S):C.NotebookCellOutput.from({items:w,id:S.id,metadata:S.metadata})})}async z(g,S,w){const E=this.w(S),y=this.y((0,u.$3b)(g));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:E,append:w,outputs:y})}async C(g,S,w){return g=k.$YN.ensureUniqueMimeTypes((0,u.$3b)(g),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:g.map(C.NotebookCellOutputItem.from),outputId:S.id,append:w})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(w){g.j=w,g.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(w){if(g.f===s.Resolved||g.f===s.Started)throw new Error("Cannot call start again");g.f=s.Started,g.c.fire(),g.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,E,y){if(g.f===s.Resolved)throw new Error("Cannot call resolve twice");g.f=s.Resolved,g.c.fire(),g.h.flush();const D=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;g.n.$completeExecution(g.b,new n.$ew({runEndTime:E,lastRunSuccess:w,error:D}))},clearOutput(w){return g.t(),g.z([],w,!1)},appendOutput(w,E){return g.t(),g.z(w,E,!0)},replaceOutput(w,E){return g.t(),g.z(w,E,!1)},appendOutputItems(w,E){return g.t(),g.C(w,E,!0)},replaceOutputItems(w,E){return g.t(),g.C(w,E,!1)}})}}var f;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(f||(f={}));class d extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(g,S,w){super(),this.h=S,this.j=w,this.b=d.a++,this.c=new A.$7d,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new O.$ee),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(g,S){this.f=g,this.g=S,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new L.$Fh,this.b=Date.now(),(0,L.$jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>g.complete())}}function a(h,g){return`${h.value}/${g}`}}),define(ke[47],Ee([1,0,4,6,5,2,20,3,7,226,13,271,22,30,272,56,8,16,33]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=e.$ekc=e.$dkc=e.$ckc=void 0,e.$ckc=(0,O.$ii)("IExtHostTerminalService");class i{constructor(w,E,y,D){this.l=w,this._id=E,this.m=y,this.n=D,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const P=this;this.value={get name(){return P.n||""},get processId(){return P.b},get creationOptions(){return P.m},get exitStatus(){return P.h},get state(){return P.j},get selection(){return P.k},sendText(z,F=!0){P.q(),P.l.$sendText(P._id,z,F)},show(z){P.q(),P.l.$show(P._id,z)},hide(){P.q(),P.l.$hide(P._id)},dispose(){P.a||(P.a=!0,P.l.$dispose(P._id))},get dimensions(){if(!(P.d===void 0||P.g===void 0))return{columns:P.d,rows:P.g}}}}async create(w,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??E?.cwd??void 0,env:w.env??void 0,icon:a(w.iconPath)??void 0,color:c.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.o(w.location,E?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,E,y,D,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:D,color:c.ThemeColor.isThemeColor(P)?P.id:void 0,location:E?.location||this.o(w,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,E){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in w?{viewColumn:o.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,E){this.h=Object.freeze({code:w,reason:E})}setDimensions(w,E){return w===this.d&&E===this.g||w===0||E===0?!1:(this.d=w,this.g=E,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(E=>{E!==w&&(this.b=Promise.resolve(w))})}}e.$dkc=i;class r{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new u.$7d,this.onProcessData=this.a.event,this.b=new u.$7d,this.d=new u.$7d,this.onDidChangeProperty=this.d.event,this.f=new u.$7d,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,E){this.g.setDimensions?.({columns:w,rows:E})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,E,y){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$7d,this.onDidCloseTerminal=this.H.event,this.I=new u.$7d,this.onDidOpenTerminal=this.I.event,this.J=new u.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new u.$7d,this.onDidChangeShell=this.N.event,this.O=new u.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(L.$rM.MainThreadTerminalService),this.y=new k.$Qub(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:D=>{const P=z=>{const F=z;return this.W(F.instanceId)?.value};switch(D?.$mid){case 15:return P(D);default:{if(Array.isArray(D))for(let z=0;z<D.length&&D[z].$mid===15;z++)D[z]=P(D[z]);return D}}}}),this.B({dispose:()=>{for(const[D,P]of this.g)P.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,E){const y=new i(this.a,(0,C.$Eg)(),w,w.name),D=new r(w.pty);return y.createExtensionTerminal(w.location,E,this.R(w,E).resolvedExtHostIdentifier,a(w.iconPath),h(w.color)).then(P=>{const z=this.S(P,D);this.h[P]=z}),this.f.push(y),y.value}R(w,E){if(E=E||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const y=w.location.parentTerminal;if(y){const D=this.f.find(P=>P.value===y);D&&(E.resolvedExtHostIdentifier=D._id)}}else w.location&&typeof w.location!="object"?E.location=w.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(w,E){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const D=new r(E),P=this.S(w,D);this.h[w]=P}async $acceptActiveTerminalChanged(w){const E=this.b;if(w===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const y=this.W(w);y&&(this.b=y,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,E){const y=this.W(w);y&&this.O.fire({terminal:y.value,data:E})}async $acceptTerminalDimensions(w,E,y){const D=this.W(w);D&&D.setDimensions(E,y)&&this.L.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptDidExecuteCommand(w,E){const y=this.W(w);y&&this.P.fire({terminal:y.value,...E})}async $acceptTerminalMaximumDimensions(w,E,y){this.g.get(w)?.resize(E,y)}async $acceptTerminalTitleChange(w,E){const y=this.W(w);y&&(y.name=E)}async $acceptTerminalClosed(w,E,y){const D=this.Y(this.f,w);if(D!==null){const P=this.f.splice(D,1)[0];P.setExitStatus(E,y),this.H.fire(P.value)}}$acceptTerminalOpened(w,E,y,D){if(E){const F=this.Y(this.f,E);if(F!==null){this.f[F]._id=w,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const P={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:A.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},z=new i(this.a,w,P,y);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(w,E){this.W(w)?._setProcessId(E)}async $startExtensionTerminal(w,E){const y=this.W(w);if(!y)return{message:(0,v.localize)(0,null,w)};y.isOpen||await new Promise(P=>{const z=this.onDidOpenTerminal(async F=>{F===y.value&&(z.dispose(),P())})});const D=this.g.get(w);D?D.startSendingEvents(E):this.j[w]={initialDimensions:E}}S(w,E){const y=new b.$Tc;y.add(E.onProcessReady(P=>this.a.$sendProcessReady(w,P.pid,P.cwd,P.windowsPty))),y.add(E.onDidChangeProperty(P=>this.a.$sendProcessProperty(w,P))),this.y.startBuffering(w,E.onProcessData),y.add(E.onProcessExit(P=>this.U(w,P))),this.g.set(w,E);const D=this.j[w];return D&&E instanceof r&&(E.startSendingEvents(D.initialDimensions),delete this.j[w]),y}$acceptProcessAckDataEvent(w,E){this.g.get(w)?.acknowledgeDataEvent(E)}$acceptProcessInput(w,E){this.g.get(w)?.input(E)}$acceptTerminalInteraction(w){const E=this.W(w);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(w,E){this.W(w)?.setSelection(E)}$acceptProcessResize(w,E,y){try{this.g.get(w)?.resize(E,y)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(w,E){this.g.get(w)?.shutdown(E)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(E=>this.a.$sendProcessProperty(w,{type:"cwd",value:E}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$tM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,E,y){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,y),this.a.$registerProfileProvider(E,w.identifier.value),new $.$tM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(w,E,y){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,y),this.a.$registerQuickFixProvider(w,E),new $.$tM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,E){const y=new p.$ee().token;if(y.isCancellationRequested)return;const D=this.D.get(w);if(!D)return;const P=await D.provideTerminalQuickFixes(E,y);if(P===null||Array.isArray(P)&&P.length===0)return;const z=new b.$Tc;if(this.w.value=z,!Array.isArray(P))return P?o.TerminalQuickFix.from(P,this.Q.converter,z):void 0;const F=[];for(const T of P){const j=o.TerminalQuickFix.from(T,this.Q.converter,z);j&&F.push(j)}return F}async $createContributedProfileTerminal(w,E){const y=new p.$ee().token;let D=await this.C.get(w)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,E);return}this.createTerminalFromOptions(D.options,E)}}async $provideLinks(w,E){const y=this.W(w);if(!y)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const P=new p.$ee;this.G.set(w,P);const z=[],F={terminal:y.value,line:E},T=[];for(const B of this.z)T.push(m.Promises.withAsyncBody(async W=>{P.token.onCancellationRequested(()=>W({provider:B,links:[]}));const Y=await B.provideTerminalLinks(F,P.token)||[];P.token.isCancellationRequested||W({provider:B,links:Y})}));const j=await Promise.all(T);if(P.token.isCancellationRequested)return[];const N=new Map;for(const B of j)B&&B.links.length>0&&z.push(...B.links.map(W=>{const Y={id:s++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return N.set(Y.id,{provider:B.provider,link:W}),Y}));return this.F.set(w,N),z}$activateLink(w,E){const y=this.F.get(w)?.get(E);y&&y.provider.handleTerminalLink(y.link)}U(w,E){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const y=this.h[w];y&&(y.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,E)}W(w){return this.X(this.f,w)}X(w,E){const y=this.Y(w,E);return y!==null?w[y]:null}Y(w,E){const y=w.findIndex(D=>D._id===E);return y===-1?null:y}getEnvironmentVariableCollection(w){let E=this.n.get(w.identifier.value);return E||(E=new f,this.$(w.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Z(w,E){const y=(0,I.$7r)(E.map),D=(0,I.$8r)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(w,E.persistent,y.length===0?void 0:y,D)}$initEnvironmentVariableCollections(w){w.forEach(E=>{const y=E[0],D=new f(E[1]);this.$(y,D)})}$acceptDefaultProfile(w,E){const y=this.s;this.s=w,this.u=E,y?.path!==w.path&&this.N.fire(w.path)}$(w,E){this.n.set(w,E),E.onDidChangeCollection(()=>{this.Z(w,E)})}};e.$ekc=t,e.$ekc=t=Je([qe(1,n.$9O),qe(2,M.$MO)],t);class f{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$7d,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const E=this.h(w);let y=this.a.get(E);return y||(y=new d(this,w),this.a.set(E,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(w,E,y,D){this.f(w,{value:E,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:D})}append(w,E,y,D){this.f(w,{value:E,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:D})}prepend(w,E,y,D){this.f(w,{value:E,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:D})}f(w,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(w,E.scope),D=this.map.get(y),P=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!D||D.value!==E.value||D.type!==E.type||D.options?.applyAtProcessCreation!==P.applyAtProcessCreation||D.options?.applyAtShellIntegration!==P.applyAtShellIntegration||D.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const z=this.g(w,E.scope),F={variable:w,...E,options:P};this.map.set(z,F),this.d.fire()}}get(w,E){const y=this.g(w,E),D=this.map.get(y);return D?g(D):void 0}g(w,E){const y=this.h(E);return y.length?`${w}:::${y}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const E=new Map;for(const[y,D]of this.map)this.h(D.scope)===this.h(w)&&E.set(D.variable,g(D));return E}delete(w,E){const y=this.g(w,E);this.map.delete(y),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[E,y]of this.map)y.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(E);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,E){const y=this.h(E),D=this.descriptionMap.get(y);if(!D||D.description!==w){let P;typeof w=="string"?P=w:P=w?.value.split(`

`)[0];const z={description:P,scope:E};this.descriptionMap.set(y,z),this.d.fire()}}getDescription(w){const E=this.h(w);return this.descriptionMap.get(E)?.description}k(w){const E=this.h(w);this.descriptionMap.delete(E)}}class d{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,E){this.b=w,this.d=E,this.a=new u.$7d}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,E,y){this.b.replace(w,E,y,this.d)}append(w,E,y){this.b.append(w,E,y,this.d)}prepend(w,E,y){this.b.prepend(w,E,y,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,E){this.b.getVariableMap(this.d).forEach((y,D)=>w.call(E,D,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(w,E){super(!1,w,E)}createTerminal(w,E,y){throw new R.$_}createTerminalFromOptions(w,E){throw new R.$_}};e.$fkc=l,e.$fkc=l=Je([qe(0,n.$9O),qe(1,M.$MO)],l);function a(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function h(S){return c.ThemeColor.isThemeColor(S)?S:void 0}function g(S){const w={...S};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(ke[353],Ee([1,0,8,21,22,4,74,55,3,18,30,12,6,20,154,16,7,67,112,89]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=e.$jlc=e.$ilc=void 0;let r=class extends $.$Uc{constructor(P,z,F,T){super(),this.w=T,this.f=this.B(new A.$7d),this.g=new Map,this.s=this.B(new A.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(p.$rM.MainThreadTesting),this.m=new S(this.h),this.j=new d(this.h,z),F.registerArgumentProcessor({processArgument:j=>{switch(j?.$mid){case 16:{const N=j,B=N.tests[N.tests.length-1].item.extId;return this.g.get(o.$dL.root(B))?.collection.tree.get(B)?.actual??(0,k.$YO)(j)}case 18:{const{test:N,message:B}=j,W=N.item.extId;return{test:this.g.get(o.$dL.root(W))?.collection.tree.get(W)?.actual??(0,k.$YO)({$mid:16,tests:[N]}),message:c.TestMessage.to(B)}}default:return j}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const j=await F.executeCommand("_testing.getExplorerSelection"),N=B=>{const W=this.g.get(o.$dL.root(B));if(W)return o.$dL.isRoot(B)?W.controller:W.collection.tree.get(B)?.actual};return{include:j?.include.map(N).filter(v.$4f)||[],exclude:j?.exclude.map(N).filter(v.$4f)||[]}})}createTestController(P,z,F,T){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const j=new $.$Tc,N=j.add(new k.$2O(z,F,this.w));N.root.label=F;const B=new Map,W=new Set,Y=this.h,_={items:N.root.children,get label(){return F},set label(Z){F=Z,N.root.label=Z,Y.$updateController(z,{label:F})},get refreshHandler(){return T},set refreshHandler(Z){T=Z,Y.$updateController(z,{canRefresh:!!Z})},get id(){return z},createRunProfile:(Z,re,ee,pe,De,x)=>{let U=(0,b.$9i)(Z);for(;B.has(U);)U++;return new E(this.h,B,W,this.s.event,z,U,Z,re,ee,pe,De,x)},createTestItem(Z,re,ee){return new k.$ZO(z,Z,re,ee)},createTestRun:(Z,re,ee=!0)=>this.j.createTestRun(z,N,Z,re,ee),invalidateTestResults:Z=>{if(Z===void 0)this.h.$markTestRetired(void 0);else{const re=Z instanceof Array?Z:[Z];this.h.$markTestRetired(re.map(ee=>o.$dL.fromExtHostTestItem(ee,z).toString()))}},set resolveHandler(Z){N.resolveHandler=Z},get resolveHandler(){return N.resolveHandler},dispose:()=>{j.dispose()}};Y.$registerTestController(z,F,!!T),j.add((0,$.$Sc)(()=>Y.$unregisterTestController(z)));const J={controller:_,collection:N,profiles:B,extension:P,activeProfiles:W};return this.g.set(z,J),j.add((0,$.$Sc)(()=>this.g.delete(z))),j.add(N.onDidGenerateDiff(Z=>Y.$publishDiff(z,Z.map(i.TestsDiffOp.serialize)))),_}createTestObserver(){return this.m.checkout()}async runTests(P,z=O.CancellationToken.None){const F=l(P);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.g.get(F.controllerId);if(!T)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(j=>o.$dL.fromExtHostTestItem(j,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:y[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:P.exclude?.map(j=>j.id)},z)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,z){return(await this.j.getCoverageDetails(P,z))?.map(c.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,z){this.g.get(P)?.profiles.get(z)?.configureHandler?.()}$setDefaultRunProfiles(P){const z=new Map;for(const[F,T]of Object.entries(P)){const j=this.g.get(F);if(!j)continue;const N=new Map,B=T.filter(Y=>!j.activeProfiles.has(Y)),W=[...j.activeProfiles].filter(Y=>!T.includes(Y));for(const Y of B)N.set(Y,!0),j.activeProfiles.add(Y);for(const Y of W)N.set(Y,!1),j.activeProfiles.delete(Y);N.size&&z.set(F,N)}this.s.fire(z)}async $refreshTests(P,z){await this.g.get(P)?.controller.refreshHandler?.(z)}$publishTestResults(P){this.results=Object.freeze(P.map(c.TestResults.to).concat(this.results).sort((z,F)=>F.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,z){const F=this.g.get(o.$dL.fromString(P).controllerId)?.collection;F&&(await F.expand(P,z<0?1/0:z),F.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(z=>i.TestsDiffOp.deserialize({asCanonicalUri:F=>F},z)))}async $runControllerTests(P,z){return Promise.all(P.map(F=>this.y(F,!1,z)))}async $startContinuousRun(P,z){const F=new O.$ee(z),T=await Promise.all(P.map(j=>this.y(j,!0,F.token)));return!z.isCancellationRequested&&!T.some(j=>j.error)&&await new Promise(j=>z.onCancellationRequested(j)),F.dispose(!0),T}async y(P,z,F){const T=this.g.get(P.controllerId);if(!T)return{};const{collection:j,profiles:N}=T,B=N.get(P.profileId);if(!B)return{};const W=P.testIds.map(Z=>j.tree.get(Z)).filter(v.$4f),Y=P.excludeExtIds.map(Z=>T.collection.tree.get(Z)).filter(v.$4f).filter(Z=>W.some(re=>re.fullId.compare(Z.fullId)===2));if(!W.length)return{};const _=new m.$6N(W.some(Z=>Z.actual instanceof k.$1O)?void 0:W.map(Z=>Z.actual),Y.map(Z=>Z.actual),B,z),J=(0,i.$gL)(P)&&this.j.prepareForMainThreadTestRun(_,a.fromInternal(P,T.collection),B,F);try{return await B.runHandler(_,F),{}}catch(Z){return{error:String(Z)}}finally{J&&J.hasRunningTasks&&!F.isCancellationRequested&&await A.Event.toPromise(J.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$ilc=r,e.$ilc=r=Je([qe(0,C.$MO),qe(1,I.$Oj)],r);const s=1e4;var t;(function(D){D[D.Running=0]="Running",D[D.Cancelling=1]="Cancelling",D[D.Ended=2]="Ended"})(t||(t={}));class f extends $.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(P,z,F,T,j){super(),this.z=P,this.C=z,this.D=F,this.F=T,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new A.$7d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new O.$ee(j));const N=this.B(new u.$uh(()=>this.G(),s));this.B(this.m.token.onCancellationRequested(()=>N.schedule()));const B=new A.$7d;this.w=B.event,this.B((0,$.$Sc)(()=>{B.fire(),B.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.G()}getCoverageDetails(P,z){const[,F,T]=o.$dL.fromString(P).path,j=this.y.get(T);if(!j)return[];if(j.backCompatResolve)return j.backCompatResolve(z);const N=this.h.get(F);if(!N)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(N.run,j.coverage,z)??[]}createRun(P){const z=this.z.id,F=this.z.controllerId,T=(0,R.$Eg)(),j=J=>(Z,...re)=>{if(W){this.D.warn(`Setting the state of test "${Z.id}" is a no-op after the run ends.`);return}this.z.isIncluded(Z)&&(this.I(Z),J(Z,...re))},N=(J,Z)=>{const re=Z instanceof Array?Z.map(c.TestMessage.from):[c.TestMessage.from(Z)];if(J.uri&&J.range){const ee={range:c.Range.from(J.range),uri:J.uri};for(const pe of re)pe.location=pe.location||ee}this.C.$appendTestMessagesInRun(z,T,o.$dL.fromExtHostTestItem(J,F).toString(),re)},B=(J,Z)=>{const re=J.uri.toString(),ee=new o.$dL([z,T,re]).toString();this.y.set(re,{coverage:J,backCompatResolve:Z}),this.C.$appendCoverage(z,T,c.TestCoverage.fromFile(ee,J))};let W=!1,Y;const _={isPersisted:this.z.isPersisted,token:this.m.token,name:P,onDidDispose:this.w,get coverageProvider(){return Y},set coverageProvider(J){Y=J,J&&Promise.resolve(J.provideFileCoverage(O.CancellationToken.None)).then(Z=>{Z?.forEach(re=>B(re,J.resolveFileCoverage&&(async ee=>(await J.resolveFileCoverage(re,ee)||re).detailedCoverage)))})},addCoverage:B,enqueued:j(J=>{this.C.$updateTestStateInRun(z,T,o.$dL.fromExtHostTestItem(J,F).toString(),1)}),skipped:j(J=>{this.C.$updateTestStateInRun(z,T,o.$dL.fromExtHostTestItem(J,F).toString(),5)}),started:j(J=>{this.C.$updateTestStateInRun(z,T,o.$dL.fromExtHostTestItem(J,F).toString(),2)}),errored:j((J,Z,re)=>{N(J,Z),this.C.$updateTestStateInRun(z,T,o.$dL.fromExtHostTestItem(J,F).toString(),6,re)}),failed:j((J,Z,re)=>{N(J,Z),this.C.$updateTestStateInRun(z,T,o.$dL.fromExtHostTestItem(J,F).toString(),4,re)}),passed:j((J,Z)=>{this.C.$updateTestStateInRun(z,T,o.$dL.fromExtHostTestItem(J,this.z.controllerId).toString(),3,Z)}),appendOutput:(J,Z,re)=>{W||(re&&(this.z.isIncluded(re)?this.I(re):re=void 0),this.C.$appendOutputToRun(z,T,L.$ue.fromString(J),Z&&c.location.from(Z),re&&o.$dL.fromExtHostTestItem(re,F).toString()))},end:()=>{W||(W=!0,this.C.$finishedTestRunTask(z,T),--this.g||this.H())}};return this.g++,this.h.set(T,{run:_}),this.C.$startedTestRunTask(z,{id:T,name:P,running:!0}),_}G(){for(const{run:P}of this.h.values())P.end()}H(){this.f!==2&&(this.f=2,this.s.fire())}I(P){if(!(P instanceof k.$ZO))throw new n.$EO(P.id);if(this.j.has(o.$dL.fromExtHostTestItem(P,this.z.controllerId).toString()))return;const z=[],F=this.z.colllection.root;for(;;){const T=c.TestItem.from(P);if(z.unshift(T),this.j.has(T.extId)||(this.j.add(T.extId),P===F))break;P=P.parent||F}this.C.$addTestsToRun(this.z.controllerId,this.z.id,z)}dispose(){this.H(),super.dispose()}}class d{get trackers(){return this.f.values()}constructor(P,z){this.h=P,this.j=z,this.f=new Map,this.g=new Map}getCoverageDetails(P,z){const F=o.$dL.root(P);return this.g.get(F)?.getCoverageDetails(P,z)||[]}disposeTestRun(P){this.g.get(P)?.dispose(),this.g.delete(P);for(const[z,{id:F}]of this.f)F===P&&this.f.delete(z)}prepareForMainThreadTestRun(P,z,F,T){return this.k(P,z,F,T)}cancelRunById(P){this.g.get(P)?.cancel()}cancelAllRuns(){for(const P of this.f.values())P.cancel()}createTestRun(P,z,F,T,j){const N=this.f.get(F);if(N)return N.createRun(T);const B=a.fromPublic(P,z,F,j),W=l(F);this.h.$startedExtensionTestRun({controllerId:P,continuous:!!F.continuous,profile:W&&{group:y[W.kind],id:W.profileId},exclude:F.exclude?.map(_=>o.$dL.fromExtHostTestItem(_,z.root.id).toString())??[],id:B.id,include:F.include?.map(_=>o.$dL.fromExtHostTestItem(_,z.root.id).toString())??[z.root.id],persist:j});const Y=this.k(F,B,F.profile);return A.Event.once(Y.onEnd)(()=>{this.h.$finishedExtensionTestRun(B.id)}),Y.createRun(T)}k(P,z,F,T){const j=new f(z,this.h,this.j,F,T);return this.f.set(P,j),this.g.set(j.id,j),j}}e.$jlc=d;const l=D=>{if(D.profile){if(!(D.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class a{static fromPublic(P,z,F,T){return new a(P,(0,R.$Eg)(),F.include?.map(j=>o.$dL.fromExtHostTestItem(j,P).toString())??[P],F.exclude?.map(j=>o.$dL.fromExtHostTestItem(j,P).toString())??[],T,z)}static fromInternal(P,z){return new a(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,z)}constructor(P,z,F,T,j,N){this.controllerId=P,this.id=z,this.isPersisted=j,this.colllection=N,this.f=F.map(B=>B+"\0"),this.g=T.map(B=>B+"\0")}isIncluded(P){const z=o.$dL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const F of this.g)if(z===F||z.startsWith(F))return!1;for(const F of this.f)if(z===F||z.startsWith(F))return!0;return!1}}e.$klc=a;class h{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(P){this.k=P,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(P){this.f.add(P)}update(P){Object.assign(P.revived,c.TestItem.toPlain(P.item)),this.f.has(P)||this.g.add(P)}remove(P){if(this.f.has(P)){this.f.delete(P);return}this.g.delete(P);const z=o.$dL.parentId(P.item.extId);if(z&&this.j.has(z.toString())){this.j.add(P.item.extId);return}this.h.add(P)}getChangeEvent(){const{f:P,g:z,h:F}=this;return{get added(){return[...P].map(T=>T.revived)},get updated(){return[...z].map(T=>T.revived)},get removed(){return[...F].map(T=>T.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class g extends i.$mL{constructor(){super(...arguments),this.s=new A.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(P){return this.g.get(P)}getMirroredTestDataByReference(P){return this.g.get(P.id)}x(P,z){return{...P,revived:c.TestItem.toPlain(P.item),depth:z?z.depth+1:0,children:new Set}}w(){return new h(this.s)}}class S{constructor(P){this.g=P}checkout(){this.f||(this.f=this.h());const P=this.f;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(z=>z.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(P){return this.f?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.f?.tests.apply(P)}h(){const P=new g({asCanonicalUri:z=>z});return this.g.$subscribeToDiffs(),{observers:0,tests:P}}}const w=(D,P,z,F)=>{z?Object.assign(z,F):P.$updateTestRunConfig(D.controllerId,D.profileId,F)};class E{#e;#t;#i;#n;#s;get label(){return this.g}set label(P){P!==this.g&&(this.g=P,w(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(P){P!==this.h&&(this.h=P,w(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),w(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,w(this,this.#e,this.#n,{tag:P?c.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.f}set configureHandler(P){P!==this.f&&(this.f=P,w(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return A.Event.chain(this.#i,P=>P.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(v.$4f))}constructor(P,z,F,T,j,N,B,W,Y,_=!1,J=void 0,Z=!1){this.controllerId=j,this.profileId=N,this.g=B,this.kind=W,this.runHandler=Y,this._tag=J,this.h=Z,this.#e=P,this.#s=z,this.#t=F,this.#i=T,z.set(N,this);const re=y[W];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);_&&F.add(N),this.#n={profileId:N,controllerId:j,tag:J?c.TestTag.namespace(this.controllerId,J.id):null,label:B,group:re,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:Z},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$llc=E;const y={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ke[155],Ee([1,0,61,13,124,16,7]),function(he,e,u,L,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=e.$TO=void 0;class b{static{this.c=new O.$RO("TextEditorDecorationType")}constructor(p,C,k){const c=b.c.nextId();p.$registerTextEditorDecorationType(C.identifier,c,A.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:c,dispose(){p.$removeTextEditorDecorationType(c)}})}}e.$TO=b;class ${constructor(p,C){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,C){this.k();let k=null;if(p instanceof M.$uM)k=new M.$vM(p,p);else if(p instanceof M.$vM)k=p;else throw new Error("Unrecognized location");this.l(k,C,!1)}insert(p,C){this.k(),this.l(new M.$vM(p,p),C,!0)}delete(p){this.k();let C=null;if(p instanceof M.$vM)C=p;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(p,C,k){const c=this.c.validateRange(p);this.g.push({range:c,text:C,forceMoveMarkers:k})}setEndOfLine(p){if(this.k(),p!==M.EndOfLine.LF&&p!==M.EndOfLine.CRLF)throw(0,L.$7)("endOfLine");this.h=p}}class v{constructor(p,C,k,c){this.c=p,this.d=C,this._accept(k),this.e=c;const m=this;this.value={get tabSize(){return m.f},set tabSize(o){m.n(o)},get indentSize(){return m.g},set indentSize(o){m.p(o)},get insertSpaces(){return m.j},set insertSpaces(o){m.s(o)},get cursorStyle(){return m.k},set cursorStyle(o){m.t(o)},get lineNumbers(){return m.l},set lineNumbers(o){m.u(o)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const C=Math.floor(p);return C>0?C:null}if(typeof p=="string"){const C=parseInt(p,10);return isNaN(C)?null:C>0?C:null}return null}n(p){const C=this.m(p);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const C=Math.floor(p);return C>0?C:null}if(typeof p=="string"){const C=parseInt(p,10);return isNaN(C)?null:C>0?C:null}return null}p(p){const C=this.o(p);if(C!==null){if(typeof C=="number"){if(this.h===C)return;this.g=C,this.h=C}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const C=this.q(p);if(typeof C=="boolean"){if(this.j===C)return;this.j=C}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(p)})))}assign(p){const C={};let k=!1;if(typeof p.tabSize<"u"){const c=this.m(p.tabSize);c==="auto"?(k=!0,C.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,k=!0,C.tabSize=c)}if(typeof p.indentSize<"u"){const c=this.o(p.indentSize);c==="tabSize"?(k=!0,C.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,k=!0,C.indentSize=c)}if(typeof p.insertSpaces<"u"){const c=this.q(p.insertSpaces);c==="auto"?(k=!0,C.insertSpaces=c):this.j!==c&&(this.j=c,k=!0,C.insertSpaces=c)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,k=!0,C.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,k=!0,C.lineNumbers=A.TextEditorLineNumbersStyle.from(p.lineNumbers)),k&&this.v("setOptions",this.c.$trySetOptions(this.d,C))}v(p,C){C.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(k)})}}e.$UO=v;class R{constructor(p,C,k,c,m,o,n,i){this.id=p,this.j=C,this.k=k,this.g=!1,this.h=new Set,this.c=m,this.d=new v(this.j,this.id,o,k),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return c.value},set document(s){throw new L.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof M.$wM))throw(0,L.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof M.$wM)))throw(0,L.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new L.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new L.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new $(c.value,t);return s(f),r.m(f)},insertSnippet(s,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>A.Range.from(l));else if(t instanceof M.$uM){const{lineNumber:l,column:a}=A.Position.from(t);d=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(t instanceof M.$vM)d=[A.Range.from(t)];else{d=[];for(const l of t)if(l instanceof M.$vM)d.push(A.Range.from(l));else{const{lineNumber:a,column:h}=A.Position.from(l);d.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return C.$tryInsertSnippet(p,c.value.version,s.value,d,f)},setDecorations(s,t){const f=t.length===0;f&&!r.h.has(s.key)||(f?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(A.$JO(t))return C.$trySetDecorations(p,s.key,A.$KO(t));{const d=new Array(4*t.length);for(let l=0,a=t.length;l<a;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return C.$trySetDecorationsFast(p,s.key,d)}}))},revealRange(s,t){r.n(()=>C.$tryRevealRange(p,A.Range.from(s),t||M.TextEditorRevealType.Default))},show(s){C.$tryShowEditor(p,A.ViewColumn.from(s))},hide(){C.$tryHideEditor(p)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,u.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,u.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,u.ok)(!this.g),this.f=p}_acceptSelections(p){(0,u.ok)(!this.g),this.c=p}async l(){const p=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const C=p.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const k=C.edits.map(m=>m.range);k.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=k.length-1;m<o;m++){const n=k[m].end;if(k[m+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=C.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,c,{setEndOfLine:typeof C.setEndOfLine=="number"?A.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.$VO=R}),define(ke[72],Ee([1,0,61,4,3,2,5,6,152,20,155,16,12,27,15,38,45]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new C.$Bc,this.d=new L.$7d,this.e=new L.$7d,this.f=new L.$7d,this.g=new L.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],f=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=A.URI.revive(d),a=this.c.get(l);a?.unref()&&(this.c.delete(l),s.push(a.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=A.URI.revive(d.uri);let a=this.c.get(l);if(a&&l.scheme!==k.Schemas.vscodeNotebookCell&&l.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new o(new $.$PO(this.h.getProxy(b.$rM.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,a),t.push(a.value)),a.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&f.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=A.URI.revive(d.documentUri);u.ok(this.c.has(l),`document '${l}' does not exist`),u.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const a=this.c.get(l).value,h=new R.$VO(d.id,this.h.getProxy(b.$rM.MainThreadTextEditors),this.i,new m.$V(()=>a.document),d.selections.map(I.Selection.to),d.options,d.visibleRanges.map(g=>I.Range.to(g)),typeof d.editorPosition=="number"?I.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,O.$Pc)(s),(0,O.$Pc)(f),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return c.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$WO=n,e.$WO=n=Je([qe(0,v.$MO),qe(1,p.$Oj)],n),e.$XO=(0,M.$ii)("IExtHostDocumentsAndEditors")}),define(ke[354],Ee([1,0,19,4,6,155,16,7]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class ${constructor(R,I){this.i=I,this.a=new L.$7d,this.b=new L.$7d,this.c=new L.$7d,this.d=new L.$7d,this.f=new L.$7d,this.g=new L.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(O.$rM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const I=this.i.allEditors();return R?I:I.map(p=>p.value)}async showTextDocument(R,I,p){let C;typeof I=="number"?C={position:M.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?C={position:M.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?M.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:C={preserveFocus:!1};const k=await this.h.$tryShowTextDocument(R.uri,C),c=k&&this.i.getEditor(k);if(c)return c.value;throw k?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,I){return new A.$TO(this.h,R,I).value}$acceptEditorPropertiesChanged(R,I){const p=this.i.getEditor(R);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const C=I.selections.selections.map(M.Selection.to);p._acceptSelections(C)}if(I.visibleRanges){const C=u.$Hb(I.visibleRanges.map(M.Range.to));p._acceptVisibleRanges(C)}if(I.options&&this.b.fire({textEditor:p.value,options:{...I.options,lineNumbers:M.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const C=b.TextEditorSelectionChangeKind.fromValue(I.selections.source),k=I.selections.selections.map(M.Selection.to);this.a.fire({textEditor:p.value,selections:k,kind:C})}if(I.visibleRanges){const C=u.$Hb(I.visibleRanges.map(M.Range.to));this.c.fire({textEditor:p.value,visibleRanges:C})}}$acceptEditorPositionData(R){for(const I in R){const p=this.i.getEditor(I);if(!p)throw new Error("Unknown text editor");const C=M.ViewColumn.to(R[I]);p.value.viewColumn!==C&&(p._acceptViewColumn(C),this.d.fire({textEditor:p.value,viewColumn:C}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$Hjc=$}),define(ke[355],Ee([1,0,2,5,6,3,7,16,25,18]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=e.$nlc=void 0,e.$nlc=(0,L.$ii)("IExtHostTimeline");class R{constructor(C,k){this.b=new Map,this.c=new Map,this.a=C.getProxy(O.$rM.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(c,m)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&$.$Dm.equals(m,this.b.get(c.source)?.extension)){const o=c.uri===void 0?void 0:u.URI.revive(c.uri);return this.c.get(c.source)?.get(I(o))?.get(c.handle)}else return;return c}})}async $getTimeline(C,k,c,m){return this.b.get(C)?.provider.provideTimeline(u.URI.revive(k),c,m)}registerTimelineProvider(C,k,c,m){const o=new A.$Tc,n=this.d(k.id,m,o).bind(this);let i;k.onDidChange&&(i=k.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:k.id}),this));const r=this.c;return this.f({...k,scheme:C,onDidChange:void 0,async provideTimeline(s,t,f){t?.resetCache&&(o.clear(),r.get(k.id)?.clear());const d=await k.provideTimeline(s,t,f);if(d==null)return;const l=n(s,t);return{...d,source:k.id,items:d.items.map(l)}},dispose(){for(const s of r.values())s.get(k.id)?.clear();i?.dispose(),o.dispose()}},c)}d(C,k,c){return(m,o)=>{let n;if(o?.cacheResults){let i=this.c.get(C);i===void 0&&(i=new Map,this.c.set(C,i));const r=I(m);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...s}=i,t=`${C}|${i.id??i.timestamp}`;n?.set(t,i);let f,d,l;i.iconPath&&(r instanceof M.$pN?l={id:r.id,color:r.color}:u.URI.isUri(r)?(f=r,d=r):{light:f,dark:d}=r);let a;return M.$UM.isMarkdownString(s.tooltip)?a=b.MarkdownString.from(s.tooltip):(0,v.$Vf)(s.tooltip)?a=s.tooltip:M.$UM.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=b.MarkdownString.from(s.detail)):(0,v.$Vf)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=s.detail),{...s,id:s.id??void 0,handle:t,source:C,command:i.command?k.toInternal(i.command,c):void 0,icon:f,iconDark:d,themeIcon:l,tooltip:a,accessibilityInformation:i.accessibilityInformation}}}}f(C,k){if(this.b.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this.a.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this.b.set(C.id,{provider:C,extension:k}),(0,A.$Sc)(()=>{for(const m of this.c.values())m.get(C.id)?.clear();this.b.delete(C.id),this.a.$unregisterTimelineProvider(C.id),C.dispose()})}}e.$olc=R;function I(p){return p?.toString()}}),define(ke[356],Ee([1,0,227,23,2,4,3,287,8,7,18,19,16,80,22,183,26]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;function o(r,s){if((0,R.$Vf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends M.$Uc{constructor(s,t,f){super(),this.f=s,this.g=t,this.h=f,this.a=new Map,this.b=new c.$j0;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(a=>d(a)?this.r(a):a):l})}registerTreeDataProvider(s,t,f){const d=this.createTreeView(s,{treeDataProvider:t},f);return{dispose:()=>d.dispose()}}createTreeView(s,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,g=this.m(s,t,f),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:a,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(s,S),E={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,m.$cG)(f,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,m.$cG)(f,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(y){(0,C.$Hk)(y)&&(0,m.$cG)(f,"treeViewMarkdownMessage"),g.message=y},get title(){return g.title},set title(y){g.title=y},get description(){return g.description},set description(y){g.description=y},get badge(){return g.badge},set badge(y){y!==void 0&&v.ViewBadge.isViewBadge(y)?g.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(g.badge=void 0)},reveal:(y,D)=>g.reveal(y,D),dispose:async()=>{await w,this.a.delete(s),g.dispose()}};return this.B(E),E}$getChildren(s,t){const f=this.a.get(s);return f?f.getChildren(t):Promise.reject(new b.$FF(s))}async $handleDrop(s,t,f,d,l,a,h,g){const S=this.a.get(s);if(!S)return Promise.reject(new b.$FF(s));const w=p.DataTransfer.toDataTransfer(f,async E=>(await this.f.$resolveDropFileData(s,t,E)).buffer);return h===s&&g&&await this.j(w,S,g,l,a),S.onDrop(w,d,l)}async j(s,t,f,d,l){const a=this.b.removeDragOperationTransfer(l);if(a)(await a)?.forEach((h,g)=>{h&&s.set(g,h)});else if(l&&t.handleDrag){const h=t.handleDrag(f,s,d);this.b.addDragOperationTransfer(l,h),await h}return s}async $handleDrag(s,t,f,d){const l=this.a.get(s);if(!l)return Promise.reject(new b.$FF(s));const a=await this.j(new v.$lN,l,t,d,f);if(!(!a||d.isCancellationRequested))return p.DataTransfer.from(a)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new b.$FF(s);return t.hasResolve}$resolve(s,t,f){const d=this.a.get(s);if(!d)throw new b.$FF(s);return d.resolveTreeItem(t,f)}$setExpanded(s,t,f){const d=this.a.get(s);if(!d)throw new b.$FF(s);d.setExpanded(t,f)}$setSelectionAndFocus(s,t,f){const d=this.a.get(s);if(!d)throw new b.$FF(s);d.setSelectionAndFocus(t,f)}$setVisible(s,t){const f=this.a.get(s);if(!f){if(!t)return;throw new b.$FF(s)}f.setVisible(t)}$changeCheckboxState(s,t){const f=this.a.get(s);if(!f)throw new b.$FF(s);f.setCheckboxState(t)}m(s,t,f){const d=this.B(new i(s,t,this.f,this.g.converter,this.h,f));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$plc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,R.$5f)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,f,d,l,a){if(super(),this.I=s,this.J=f,this.L=d,this.M=l,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$ee,a.contributes&&a.contributes.views)for(const w in a.contributes.views)for(const E of a.contributes.views[w])E.id===s&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,g;const S=A.Event.debounce(this.F.event,(w,E)=>(w||(w={message:!1,elements:[]}),E.element!==!1&&(h||(h=new Promise(y=>g=y),this.G=this.G.then(()=>h)),Array.isArray(E.element)?w.elements.push(...E.element):w.elements.push(E.element)),E.message&&(w.message=!0),w),200,!0);this.B(S(({message:w,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const y=g;return h=null,this.$(E).then(()=>y())})),w&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let f=this.X(s);return f||(f=await this.Y(t)),f?f.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const f=(0,R.$5f)(t.select)?!0:t.select,d=(0,R.$5f)(t.focus)?!1:t.focus,l=(0,R.$5f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(a=>this.W(s,a[a.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:a.map(g=>g.item)},{select:f,focus:d,expand:l})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:f,focus:d,expand:l})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=p.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const f=this.getExtensionElement(s);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(s,t){const f=!(0,I.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async f=>{const d=this.getExtensionElement(f.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:f.newState?v.TreeItemCheckboxState.Checked:v.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?v.TreeItemCheckboxState.Checked:v.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(s,t,f){const d=[];for(const l of s){const a=this.getExtensionElement(l);a&&d.push(a)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,f){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$ah)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(s);if(f){const d=this.m.get(f);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,f,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(d=>(f.push(d),f))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$ah)(()=>this.f.getParent(s))}W(s,t){const f=this.m.get(s);return f?Promise.resolve(f):(0,$.$ah)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const a=this.m.get(l);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const f=this.getExtensionElement(s);t=f?this.m.get(f):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new k.$ee(this.Z.token);try{const f=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const l=(0,I.$Hb)(d||[]),a=await Promise.all((0,I.$Hb)(l).map(g=>this.f.getTreeItem(g)));if(t.token.isCancellationRequested)return;const h=a.map((g,S)=>g?this.db(l[S],g,f):null);return(0,I.$Hb)(h)}finally{t.dispose()}}$(s){if(s.some(f=>!f))return this.Z.dispose(!0),this.Z=new k.$ee,this.tb(),this.J.$refresh(this.I);{const f=this.ab(s);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(s){const t=new Set,f=s.map(l=>this.m.get(l));for(const l of f)if(l&&!t.has(l.item.handle)){let a=l;for(;a&&a.parent&&f.findIndex(h=>a&&a.parent&&h&&h.item.handle===a.parent.item.handle)===-1;){const h=this.j.get(a.parent.item.handle);a=h?this.m.get(h):void 0}a&&!a.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const a=this.j.get(l);if(a){const h=this.m.get(a);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(s){const t={};return Promise.all(s.map(f=>this.cb(f).then(d=>{d&&(t[f]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,$.$ah)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,f.parent);return this.pb(t,l,f,f.parent),f.dispose(),l}return null})}return Promise.resolve(null)}db(s,t,f){const d=this.ib(s,t,f);if(t.id&&this.j.has(d.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,f),d}eb(s){return v.$UM.isMarkdownString(s)?p.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,f,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,f=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===v.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:d}}hb(s){if(!v.$gN.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,f){this.hb(t);const d=this.B(new M.$Tc),l=this.kb(s,t,f),a=this.lb(t);return{item:{handle:l,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,R.$5f)(t.collapsibleState)?v.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof v.$pN?s.iconPath:void 0}kb(s,{id:t,label:f,resourceUri:d},l,a){if(t)return`${i.b}/${t}`;const h=o(f,this.N),g=l?l.item.handle:i.a;let S=h?h.label:d?(0,L.$Sg)(d):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const w=this.m.has(s)?this.m.get(s).item.handle:void 0,E=this.X(l)||[];let y,D=0;do{if(y=`${g}/${D}:${S}`,a||!this.j.has(y)||w===y)break;D++}while(D<=E.length);return y}lb(s){if(s.iconPath&&!(s.iconPath instanceof v.$pN))return typeof s.iconPath=="string"||O.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof v.$pN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return O.URI.isUri(s)?s:O.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,f,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(s,t);const l=this.X(d)||[],a=l.filter(h=>h.item.handle===f.item.handle)[0];a&&l.splice(l.indexOf(a),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[357],Ee([1,0,4,3,2,30,16,92,6,7]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;class R extends L.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(k,c,m,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$7d),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=c,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(k){this.c(),this.#r!==k&&(this.#r=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,O.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#o=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:M.ViewColumn.from(k),preserveFocus:!!c})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends L.$Uc{static c(){return(0,A.$Eg)()}constructor(k,c,m){super(),this.j=c,this.m=m,this.g=new Map,this.h=new Map,this.f=k.getProxy($.$rM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,c,m,o,n={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,b.$Wjc)(k),t=I.c();this.f.$createWebviewPanel((0,b.$Yjc)(k),t,c,{title:m,panelOptions:p(n),webviewOptions:(0,b.$Zjc)(k,this.m,n),serializeBuffersForPostMessage:s},r);const f=this.j.createNewWebview(t,n,k);return this.createNewWebviewPanel(t,c,m,i,n,f,!0)}$onDidChangeWebviewPanelViewStates(k){const c=Object.keys(k);c.sort((m,o)=>{const n=k[m],i=k[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const m of c){const o=this.getWebviewPanel(m);if(!o)continue;const n=k[m];o._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,c,m){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:m,extension:k}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,b.$Wjc)(k)}),new v.$tM(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(k,c,m,o){const n=this.h.get(c);if(!n)throw new Error(`No serializer found for '${c}'`);const{serializer:i,extension:r}=n,s=this.j.createNewWebview(k,m.webviewOptions,r),t=this.createNewWebviewPanel(k,c,m.title,o,m.panelOptions,s,m.active);await i.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(k,c,m,o,n,i,r){const s=new R(k,this.f,i,{viewType:c,title:m,viewColumn:o,panelOptions:n,active:r});return this.g.set(k,s),s}getWebviewPanel(k){return this.g.get(k)}}e.$1jc=I;function p(C){return{enableFindWidget:C.enableFindWidget,retainContextWhenHidden:C.retainContextWhenHidden}}}),define(ke[358],Ee([1,0,4,3,92,16,6,7]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;class $ extends L.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(I,p,C,k,c,m){super(),this.#s=!1,this.#u=this.B(new u.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$7d),this.onDidDispose=this.#l.event,this.#i=C,this.#a=k,this.#e=I,this.#t=p,this.#n=c,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#o}set description(I){this.a(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#s)throw new Error("Webview is disposed")}}class v{constructor(I,p){this.d=p,this.b=new Map,this.c=new Map,this.a=I.getProxy(M.$rM.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,C,k){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:C,extension:I}),this.a.$registerWebviewViewProvider((0,O.$Yjc)(I),p,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,O.$Wjc)(I)}),new b.$tM(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,C,k,c){const m=this.b.get(p);if(!m)throw new Error(`No view provider found for '${p}'`);const{provider:o,extension:n}=m,i=this.d.createNewWebview(I,{},n),r=new $(I,this.a,p,C,i,!0);this.c.set(I,r),await o.resolveWebviewView(r,{state:k},c)}async $onDidChangeWebviewViewVisibility(I,p){this.e(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.e(I);this.c.delete(I),p.dispose(),this.d.deleteWebview(I)}e(I){const p=this.c.get(I);if(!p)throw new Error("No webview found");return p}}e.$slc=v}),define(ke[359],Ee([1,0,69,15,12,258,32,11]),function(he,e,u,L,O,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;let $=class{constructor(I,p){I.addFileSystemProvider(L.Schemas.file,new v(p),{isCaseSensitive:b.$k})}};e.$0lc=$,e.$0lc=$=Je([qe(0,u.$Sjc),qe(1,O.$Oj)],$);class v{constructor(I){this.b=I,this.a=new A.$Vq(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,C){return this.a.writeFile(I,p,{...C,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,C){return this.a.rename(I,p,C)}copy(I,p,C){return this.a.copy(I,p,C)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(ke[360],Ee([1,0,17,63,30,33,3,6,2,20]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;let R=class extends M.$Uc{constructor(p,C){super();const k=p.getProxy(b.$rM.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async c=>{const m=$.URI.file((0,u.$kc)((0,L.tmpdir)(),(0,O.$Eg)()));return await k.$download(c,m),m})}};e.$8lc=R,e.$8lc=R=Je([qe(0,v.$MO),qe(1,A.$9O)],R)}),define(ke[361],Ee([1,0,51,17,2,93,3,15,8,31]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class R extends A.$Ujc{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==b.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const d=f.fsPath;let l=0;do{let a;l===0?a=d:a=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await I(a);const h=L.$kc(a,"vscode.lock"),g=await c(this.d,h,!1);if(g)return this.i=g,process.on("exit",()=>{g.dispose()}),O.URI.file(a);l++}while(l<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$hmc=R;async function I(s){try{await v.Promises.stat(s);return}catch{}try{await v.Promises.mkdir(s,{recursive:!0})}catch{}}const p=1e3,C=10*60*1e3;class k extends M.$Uc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new $.$th),this.a.cancelAndSet(async()=>{const d=await m(t,f);(!d||d.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await v.Promises.utimes(f,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${f}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await v.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function c(s,t,f){try{const l={pid:process.pid,willReleaseAt:0};await v.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){s.error(l)}const d=await m(s,t);return!d||d.pid!==process.pid?f?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new k(s,t))}async function m(s,t){let f;try{f=await v.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(f))}catch(d){return s.error(d),null}}async function o(s,t){let f;try{f=await v.Promises.stat(t)}catch(d){return s.error(d),0}return f.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const f=await m(s,t);if(!f)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(f.willReleaseAt){let g=f.willReleaseAt-Date.now();if(g<5e3){for(g>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,$.$jh)(Math.min(100,g)),await o(s,t)===0)return r(s,t);g=f.willReleaseAt-Date.now()}return r(s,t)}}if(!n(f.pid))return s.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(s,t);const d=await o(s,t),l=Date.now()-d;if(l<=C)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$jh)(2e3);const a=await o(s,t),h=Date.now()-a;return h<=C?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await v.Promises.unlink(t)}catch{}return c(s,t,!0)}}),define(ke[362],Ee([1,0,30,20,47,33]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;let M=class extends O.$ekc{constructor($,v){super(!0,$,v)}createTerminal($,v,R){return this.createTerminalFromOptions({name:$,shellPath:v,shellArgs:R})}createTerminalFromOptions($,v){const R=new O.$dkc(this.a,(0,u.$Eg)(),$,$.name);return this.f.push(R),R.create($,this.R($,v)),R.value}};e.$Clc=M,e.$Clc=M=Je([qe(0,A.$9O),qe(1,L.$MO)],M)}),define(ke[363],Ee([1,0,4,37,41,5]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=e.$ML=e.OutputChannelUpdateMode=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=void 0,e.$zL="text/x-code-output",e.$AL="output",e.$BL="Log",e.$CL="text/x-code-log-output",e.$DL="log",e.$EL="workbench.panel.output",e.$FL=new O.$zj("inOutput",!1),e.$GL=new O.$zj("activeLogOutput",!1),e.$HL=new O.$zj("activeLogOutput.levelSettable",!1),e.$IL=new O.$zj("activeLogOutput.level",""),e.$JL=new O.$zj("activeLogOutput.levelIsDefault",!1),e.$KL=new O.$zj("outputView.scrollLock",!1),e.$LL=(0,A.$ii)("outputService");var M;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$ML={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new u.$7d,this.onDidRegisterChannel=this.b.event,this.c=new u.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(R=>v.push(R)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}L.$1n.add(e.$ML.OutputChannels,new b),e.$NL=new O.$zj("activeOutputChannel","")}),define(ke[156],Ee([1,0,6,5,20,25,12,363,69,28,59,188,21,18,32,4,3]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=e.$6kc=void 0;class o extends M.$Uj{get disposed(){return this.n}constructor(s,t,f,d,l){super(),this.id=s,this.name=t,this.r=f,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=p.$ue.fromString(t).byteLength,(0,M.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,f,d,l,a){this.i=t,this.j=f,this.k=d,this.l=l,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(u.$rM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(s,t,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,C.$Vf)(t)?t:void 0;if((0,C.$Vf)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const h=this.i.environment.extensionLogLevel?.find(([S])=>A.$Dm.equals(f.identifier,S))?.[1];h&&(a=(0,M.$6j)(h));const g=d?this.o(s,a,f):this.n(s,l,f);return g.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),d?this.r(s,a??this.m.getLevel(),g):this.q(s,g)}async n(s,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(s,l,t,f.identifier.value);return new o(h,s,a,this.a,f)}async o(s,t,f){const d=await this.p(f),l=s.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(d,`${l}.log`),h=`${f.identifier.value}.${l}`,g=this.l.createLogger(a,{id:h,name:s,logLevel:t,extensionId:f.identifier.value});return new n(h,s,g,this.a,f)}p(s){let t=this.d.get(s.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(d){if((0,k.$5k)(d)!==k.FileSystemProviderErrorCode.FileExists)throw d}return f})())}return t}q(s,t){let f=!1;const d=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return s},append(l){d(),t.then(a=>a.append(l))},appendLine(l){d(),t.then(a=>a.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(a=>a.replace(l))},show(l,a){d(),t.then(h=>h.show(l,a))},hide(){d(),t.then(l=>l.hide())},dispose(){f=!0,t.then(l=>l.dispose())}}}r(s,t,f){const d=new m.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},a=d.add(new c.$7d);function h(g){t=g,a.fire(g)}return f.then(g=>{d.add(g),g.logLevel!==t&&h(g.logLevel),d.add(g.onDidChangeLogLevel(S=>h(S)))}),{...this.q(s,f),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(g,...S){l(),f.then(w=>w.trace(g,...S))},debug(g,...S){l(),f.then(w=>w.debug(g,...S))},info(g,...S){l(),f.then(w=>w.info(g,...S))},warn(g,...S){l(),f.then(w=>w.warn(g,...S))},error(g,...S){l(),f.then(w=>w.error(g,...S))},dispose(){d.dispose()}}}};e.$6kc=i,e.$6kc=i=Je([qe(0,O.$MO),qe(1,v.$3O),qe(2,$.$Sjc),qe(3,R.$sjc),qe(4,M.$Pj),qe(5,M.$Oj)],i),e.$7kc=(0,L.$ii)("IExtHostOutputService")}),define(ke[157],Ee([1,0,5,8]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$5m=(0,u.$ii)("remoteAgentService"),e.$6m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(O){let A=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await O.getRoundTripTime();if($===void 0)return;A=Math.min(A,$/2),await(0,L.$jh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(A):M=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:M,current:A,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof M>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[364],Ee([1,0,231,85,37,42,53,3,4,157,11,24,8]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=void 0,e.$5I=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$6I=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$7I=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$8I=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$9I={ConfigurationMigration:"base.contributions.configuration.migration"};class C{constructor(){this.migrations=[],this.a=new $.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const k=new C;O.$1n.add(e.$9I.ConfigurationMigration,k);let c=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,k.migrations)})),this.c(k.migrations),this.B(k.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of s){const d=r[t];if(!d)continue;const l=[];if(d.value!==void 0){const a=await this.h(n,t,d.value,i,void 0);for(const h of a??[])l.push([h,[]])}for(const{identifiers:a,value:h}of d.overrides??[])if(h!==void 0){const g=await this.h(n,t,h,i,a);for(const S of g??[])l.push([S,a])}l.length&&await Promise.allSettled(l.map(async([[a,h],g])=>this.a.updateValue(a,h.value,{resource:i,overrideIdentifiers:g},f)))}}async h(n,i,r,s,t){const f=l=>{const h=this.a.inspect(l,{resource:s})[i];if(h)return t?h.overrides?.find(({identifiers:g})=>(0,I.$Sn)(g,t))?.value:h.value},d=await n.migrateFn(r,f);return Array.isArray(d)?d:[[n.key,d]]}};e.$0I=c,e.$0I=c=Je([qe(0,M.$Oi),qe(1,A.$ri)],c);let m=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new p.$Fh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==1)return;O.$1n.as(L.$6n.Configuration).registerConfiguration({...e.$7I,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$$I=m,e.$$I=m=Je([qe(0,v.$5m)],m)}),define(ke[365],Ee([1,0,35,15,17,23,240,364,85,5,37]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Lfb=e.$Kfb=void 0,e.$Mfb=c,e.$Nfb=m,e.$Kfb=(0,v.$ii)("editorResolverService"),e.$Lfb="workbench.editorAssociations";const I=R.$1n.as($.$6n.Configuration),p={...b.$6I,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(p);var C;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(C||(e.RegisteredEditorPriority=C={}));var k;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function c(o){switch(o){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function m(o,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(O.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,A.$Sg)(n);return u.$bk(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(ke[366],Ee([1,0,34,15,17,11,23,2,5,276,42,147,157]),function(he,e,u,L,O,A,M,b,$,v,R,I,p){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=void 0,e.$6L=(0,$.$ii)("pathService");let k=C=class{constructor(m,o,n,i){this.d=m,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(m,i,o)):this.h(m,o,n)}h(m,o,n){return m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote?(0,u.$gg)(n??(0,M.$Sg)(m),o===1):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,v.$3L)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:L.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?O.$gc:O.$hc)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(o=m.substring(2),m="/"):(o=m.substring(2,i),m=m.substring(i)||"/")}return b.URI.from({scheme:L.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.$7L=k,e.$7L=k=C=Je([qe(1,p.$5m),qe(2,I.$OL),qe(3,R.$ri)],k)}),define(ke[367],Ee([1,0,242,19,54,4,55,3,2,53,247,12,65,278,88,42,147,26,22,18,24,41]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=e.$YL=e.OnPortForward=e.$TL=e.$SL=e.TunnelSource=e.TunnelCloseReason=e.$QL=e.$PL=void 0,e.$RL=a,e.$UL=S,e.$VL=w,e.$WL=E,e.$XL=D;const t=10*1e3,f="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.$PL="onTunnel",e.$QL=new s.$zj("forwardedPortsViewEnabled",!1,u.localize(0,null));function a(F){const T=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var h;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var g;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$SL={source:g.User,description:u.localize(1,null)},e.$TL={source:g.Auto,description:u.localize(2,null)};function S(F,T,j){const N=F.get(E(T,j));if(N)return N;if((0,k.$3v)(T))for(const B of k.$2v){const W=E(B,j);if(F.has(W))return F.get(W)}else if((0,k.$5v)(T))for(const B of k.$4v){const W=E(B,j);if(F.has(W))return F.get(W)}}function w(F,T,j){const N=S(F,T,j);if(N)return N;const B=(0,k.$5v)(T)?"localhost":(0,k.$3v)(T)?"0.0.0.0":void 0;if(B)return S(F,B,j)}function E(F,T){return F+":"+T}var y;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(y||(e.OnPortForward=y={}));function D(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}class P extends b.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new A.$7d,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(j=>{(j.affectsConfiguration(P.c)||j.affectsConfiguration(P.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,j,N){let B=this.w(T,j,N,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const Y=this.j[B];Y.key===T?(W.onAutoForward=Y.onAutoForward??W.onAutoForward,W.elevateIfNeeded=Y.elevateIfNeeded!==void 0?Y.elevateIfNeeded:W.elevateIfNeeded,W.label=Y.label??W.label,W.requireLocalPort=Y.requireLocalPort,W.protocol=Y.protocol):(W.onAutoForward=W.onAutoForward??Y.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:Y.elevateIfNeeded,W.label=W.label??Y.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??Y.protocol),B=this.w(T,j,N,this.j,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,i.$Vf)(T.host)&&(0,i.$Zf)(T.port)}w(T,j,N,B,W){if(W>=B.length)return-1;const Y=!(0,k.$3v)(j)&&!(0,k.$5v)(j),J=B.slice(W).findIndex(Z=>(0,i.$Zf)(Z.key)?Y?!1:Z.key===T:this.t(Z.key)?Y?!1:T>=Z.key.start&&T<=Z.key.end:this.u(Z.key)?T===Z.key.port&&j===Z.key.host:N?Z.key.test(N):!1);return J>=0?J+W:-1}y(){const T=this.r.getValue(P.c);if(!T||!(0,i.$Xf)(T))return[];const j=[];for(const B in T){if(B===void 0)continue;const W=T[B];let Y;if(Number(B))Y=Number(B);else if((0,i.$Vf)(B))if(P.g.test(B)){const _=B.match(P.g);Y={start:Number(_[1]),end:Number(_[2])}}else if(P.h.test(B)){const _=B.match(P.h);Y={host:_[1],port:Number(_[2])}}else{let _;try{_=RegExp(B)}catch{}_&&(Y=_)}Y&&j.push({key:Y,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const N=this.r.getValue(P.f);return N&&(this.m={elevateIfNeeded:N.elevateIfNeeded,label:N.label,onAutoForward:N.onAutoForward,requireLocalPort:N.requireLocalPort,protocol:N.protocol}),this.z(j)}z(T){function j(N,B){return(0,i.$Zf)(N.key)?N.key:B.t(N.key)?N.key.start:B.u(N.key)?N.key.port:Number.MAX_VALUE}return T.sort((N,B)=>j(N,this)-j(B,this))}C(){return this.m}static providedActionToAction(T){switch(T){case k.ProvidedOnAutoForward.Notify:return y.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case k.ProvidedOnAutoForward.Silent:return y.Silent;case k.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(T,j,N){const W=this.r.inspect(P.c).userRemoteValue;let Y;!W||!(0,i.$Xf)(W)?Y={}:Y=(0,r.$On)(W),Y[`${T}`]||(Y[`${T}`]={});for(const _ in j)Y[`${T}`][_]=j[_];return this.r.updateValue(P.c,Y,N)}}e.$YL=P;let z=class extends b.$Uc{constructor(T,j,N,B,W,Y,_,J,Z,re){super(),this.H=T,this.I=j,this.J=N,this.L=B,this.M=W,this.N=Y,this.O=_,this.P=J,this.Q=Z,this.R=re,this.c=new Map,this.g=new A.$7d,this.onForwardPort=this.g.event,this.h=new A.$7d,this.onClosePort=this.h.event,this.j=new A.$7d,this.onPortName=this.j.event,this.n=new A.$7d,this.onCandidatesChanged=this.n.event,this.t=new A.$7d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$7d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new P(N),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const pe=await this.getAttributes(ee.map(De=>({port:De.tunnelRemotePort,host:De.tunnelRemoteHost})));for(const De of ee)if(De.localAddress){const x=E(De.tunnelRemoteHost,De.tunnelRemotePort),U=w(this.m??new Map,De.tunnelRemoteHost,De.tunnelRemotePort);this.forwarded.set(x,{remotePort:De.tunnelRemotePort,remoteHost:De.tunnelRemoteHost,localAddress:De.localAddress,protocol:pe?.get(De.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(De.localAddress,pe?.get(De.tunnelRemotePort)),localPort:De.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:De.privacy,source:e.$SL}),this.f.set(x,De)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const pe=E(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!w(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!w(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!w(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const De=w(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),x=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(pe,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:x?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,x),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:De?.detail,hasRunningProcess:!!De,pid:De?.pid,privacy:ee.privacy,source:e.$SL})}await this.cb(),this.f.set(pe,ee),this.g.fire(this.forwarded.get(pe))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,h.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$PL))?(this.R.createKey(e.$QL.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,j){const N=E(T.host,T.port);this.forwarded.has(N)&&(this.forwarded.delete(N),await this.cb(),this.h.fire(T))}X(T,j){if(T.startsWith("http"))return $.URI.parse(T);const N=j?.protocol??"http";return $.URI.parse(`${N}://${T}`)}async Y(T){const j=this.N.getWorkspace(),N=j.configuration?(0,M.$9i)(j.configuration.path):j.folders.length>0?(0,M.$9i)(j.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${N}`}async Z(){return this.Y(f)}async $(){return this.Y(d)}async ab(){const T=this.I.get(f,1);if(T)return this.I.remove(f,1),await this.cb(),T;const j=await this.Z();if(j)return this.I.get(j,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const j=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(N=>N.remotePort).join(", ")}`);for(const N of j){const B=w(this.detected,N.remoteHost,N.remotePort);N.source.source!==g.Extension&&!B||N.source.source===g.Extension&&B?await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,elevateIfNeeded:!0,source:N.source}):N.source.source===g.Extension&&!B&&this.D.set(E(N.remoteHost,N.remotePort),N)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new b.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async j=>{j.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(j=>j.startsWith(d));for(const j of T){const N=this.I.getNumber(j,0);if(N&&N<Date.now()){this.s=Promise.resolve(void 0);const B=j.replace(d,f);this.I.remove(j,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),j=T.map(Y=>({remoteHost:Y.remoteHost,remotePort:Y.remotePort,localPort:Y.localPort,name:Y.name,localAddress:Y.localAddress,localUri:Y.localUri,protocol:Y.protocol,source:Y.source}));let N;T.length>0&&(N=JSON.stringify(j));const B=await this.Z(),W=await this.$();!N&&B&&W?(this.I.remove(B,0),this.I.remove(W,0)):N!==this.y&&B&&W&&(this.I.store(B,N,0,0),this.I.store(W,Date.now()+l,0,0)),this.y=N}}async eb(T,j,N){if(!T.tunnelLocalPort||!N?.requireLocalPort||T.tunnelLocalPort===j)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const W=u.localize(3,null,j,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(W)}async forward(T,j){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(T,j)}async fb(T,j){await this.Q.activateByEvent(e.$PL);const N=w(this.forwarded,T.remote.host,T.remote.port);j=j??(j!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const B=T.local!==void 0?T.local:T.remote.port;let W;if(N)return this.hb(N,T,j);{const Y=this.L.remoteAuthority,_=Y?{getAddress:async()=>(await this.M.resolveAuthority(Y)).authority}:void 0,J=E(T.remote.host,T.remote.port);this.c.set(J,!0),T=this.gb(J,T);const Z=await this.H.openTunnel(_,T.remote.host,T.remote.port,void 0,B,T.elevateIfNeeded?T.elevateIfNeeded:j?.elevateIfNeeded,T.privacy,j?.protocol);if(typeof Z=="string")W=Z;else if(Z&&Z.localAddress){const re=w(this.m??new Map,T.remote.host,T.remote.port),ee=Z.protocol?Z.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:j?.protocol??k.TunnelProtocol.Http,pe={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:j?.label??T.name,closeable:!0,localAddress:Z.localAddress,protocol:ee,localUri:await this.X(Z.localAddress,j),runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,source:T.source??e.$SL,privacy:Z.privacy};return this.forwarded.set(J,pe),this.f.set(J,Z),this.c.delete(J),await this.cb(),await this.eb(Z,B,j),this.g.fire(pe),Z}this.c.delete(J)}return W}gb(T,j){const N=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(N){const B=N.get(T);N.delete(T),B&&(j.name=B.name??j.name,j.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(T,j,N){const B=N?.label??j.name;let W;(function(_){_[_.None=0]="None",_[_.Fire=1]="Fire",_[_.Reopen=2]="Reopen"})(W||(W={}));let Y=W.None;switch(B!==T.name&&(T.name=B,Y=W.Fire),(N?.protocol||T.protocol!==k.TunnelProtocol.Http)&&N?.protocol!==T.protocol&&(j.source=T.source,Y=W.Reopen),j.privacy&&T.privacy!==j.privacy&&(Y=W.Reopen),Y){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(T.remoteHost,T.remotePort,h.User),await this.fb(j,N)}return w(this.f,j.remote.host,j.remote.port)}async name(T,j,N){const B=w(this.forwarded,T,j),W=E(T,j);if(B){B.name=N,await this.cb(),this.j.fire({host:T,port:j});return}else this.detected.has(W)&&(this.detected.get(W).name=N,this.j.fire({host:T,port:j}))}async close(T,j,N){const B=E(T,j),W=this.forwarded.get(B);return N===h.AutoForwardEnd&&W&&W.source.source===g.Auto&&this.F.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(T,j),this.W({host:T,port:j},N)}address(T,j){const N=E(T,j);return(this.forwarded.get(N)||this.detected.get(N))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const j of T){const N=w(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),B=typeof j.localAddress=="string"?j.localAddress:E(j.localAddress.host,j.localAddress.port);this.detected.set(E(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:B,protocol:k.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:N?.detail,hasRunningProcess:!!N,pid:N?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,B,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let j=T;this.r&&(j=await this.r(T));const N=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(N.values()).map(B=>B.port).join(", ")}`),this.n.fire(N)}ib(T){const j=this.m??new Map,N=new Map;return this.m=N,T.forEach(B=>{const W=E(B.host,B.port);N.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),j.has(W)&&j.delete(W);const Y=w(this.forwarded,B.host,B.port);Y&&(Y.runningProcess=B.detail,Y.hasRunningProcess=!0,Y.pid=B.pid)}),j.forEach((B,W)=>{const Y=a(W);if(!Y)return;const _=w(this.forwarded,Y.host,Y.port);_&&(_.runningProcess=void 0,_.hasRunningProcess=!1,_.pid=void 0);const J=w(this.detected,Y.host,Y.port);J&&(J.runningProcess=void 0,J.hasRunningProcess=!1,J.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),j=await this.getAttributes(T.map(N=>({port:N.remotePort,host:N.remoteHost})),!1);if(j)for(const N of T){const B=j.get(N.remotePort);(B?.protocol||N.protocol!==k.TunnelProtocol.Http)&&B?.protocol!==N.protocol&&await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,source:N.source},B),B&&B.label&&B.label!==N.name&&await this.name(N.remoteHost,N.remotePort,B.label)}}async getAttributes(T,j=!0){const N=new Map,B=new Map;T.forEach(Z=>{const re=w(this.m??new Map,k.$2v[0],Z.port)??Z;if(re){N.set(Z.port,re);const ee=D(re)?re.pid:void 0;B.has(ee)||B.set(ee,[]),B.get(ee)?.push(Z.port)}});const W=new Map;if(T.forEach(Z=>{const re=this.configPortsAttributes.getAttributes(Z.port,Z.host,N.get(Z.port)?.detail);re&&W.set(Z.port,re)}),this.G.length===0||!j)return W.size>0?W:void 0;const Y=await Promise.all((0,L.$Rb)(this.G.map(Z=>Array.from(B.entries()).map(re=>{const ee=re[1],pe=N.get(ee[0]);return Z.providePortAttributes(ee,pe?.pid,pe?.detail,n.CancellationToken.None)})))),_=new Map;if(Y.forEach(Z=>Z.forEach(re=>{re&&_.set(re.port,re)})),!W&&!_)return;const J=new Map;return T.forEach(Z=>{const re=W.get(Z.port),ee=_.get(Z.port);J.set(Z.port,{elevateIfNeeded:re?.elevateIfNeeded,label:re?.label,onAutoForward:re?.onAutoForward??P.providedActionToAction(ee?.autoForwardAction),requireLocalPort:re?.requireLocalPort,protocol:re?.protocol})}),J}addAttributesProvider(T){this.G.push(T)}};e.$ZL=z,Je([(0,O.$Nh)(1e3)],z.prototype,"cb",null),e.$ZL=z=Je([qe(0,k.$Wv),qe(1,C.$Mp),qe(2,v.$Oi),qe(3,m.$OL),qe(4,p.$tl),qe(5,c.$ri),qe(6,I.$Oj),qe(7,R.$qw),qe(8,o.$$F),qe(9,s.$Aj)],z)}),define(ke[94],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$zK=e.$yK=void 0;class u{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new u(0,0)}with(M){return new u(0,0)}}e.$yK=u;class L{constructor(M,b,$,v){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(M,b),this.end=new u($,v)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new L(0,0,0,0)}with(M){return new L(0,0,0,0)}}e.$zK=L;var O;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,8]),function(he,e,u,L,O,A,M,b,$,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.$WK=e.$PK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$MK=e.$LK=e.$KK=e.$JK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.TextSearchCompleteMessageType=void 0,e.$GK=o,e.$HK=n,e.$IK=i,e.$NK=g,e.$OK=S,e.$QK=y,e.$RK=D,e.$SK=P,e.$TK=z,e.$UK=F,e.$VK=T,e.$XK=N,e.$ZK=Y,e.$1K=_,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$AK="workbench.view.search",e.$BK="workbench.panel.search",e.$CK="workbench.view.search",e.$DK="search-result",e.$EK="search.exclude";const p="\u27EA ",C=" characters skipped \u27EB",k=(p.length+C.length+5)*2;e.$FK=(0,b.$ii)("searchService");var c;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text",Z[Z.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var m;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.aiText=3]="aiText"})(m||(e.QueryType=m={}));function o(Z){return!!Z.preview}function n(Z){return!!Z.resource}function i(Z){return!!Z.message}var r;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(re){this.resource=re,this.results=[]}}e.$JK=s;class t{constructor(re,ee,pe,De){this.ranges=ee,this.webviewIndex=De;const x=Array.isArray(ee)?ee:[ee];if(pe&&pe.matchLines===1&&f(x)){re=(0,M.$Of)(re,pe.matchLines);let U="",ie=0,be=0;const Ce=Math.floor(pe.charsPerLine/5),ae=[];for(const ce of x){const se=Math.max(ce.startColumn-Ce,0),K=ce.startColumn+pe.charsPerLine;if(se>be+Ce+k){const te=p+(se-be)+C;U+=te+re.slice(se,K),ie+=se-(be+te.length)}else U+=re.slice(be,K);ae.push(new l(0,ce.startColumn-ie,ce.endColumn-ie)),be=K}this.preview={text:U,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const U=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:re,matches:(0,u.$2b)(ee,ie=>new d(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$KK=t;function f(Z){const re=Z[0].startLineNumber;for(const ee of Z)if(ee.startLineNumber!==re||ee.endLineNumber!==re)return!1;return!0}class d{constructor(re,ee,pe,De){this.startLineNumber=re,this.startColumn=ee,this.endLineNumber=pe,this.endColumn=De}}e.$LK=d;class l extends d{constructor(re,ee,pe){super(re,ee,re,pe)}}e.$MK=l;var a;(function(Z){Z.List="list",Z.Tree="tree"})(a||(e.ViewMode=a={}));var h;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function g(Z,re=!0){const ee=Z&&Z.files&&Z.files.exclude,pe=re&&Z&&Z.search&&Z.search.exclude;if(!ee&&!pe)return;if(!ee||!pe)return ee||pe;let De=Object.create(null);return De=O.$Rn(De,O.$On(ee)),De=O.$Rn(De,O.$On(pe),!0),De}function S(Z,re){return Z.excludePattern&&L.$bk(Z.excludePattern,re)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&L.$bk(Z.includePattern,re)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(ee=>{const pe=ee.folder.fsPath;if(A.$ig(re,pe)){const De=$.$mc(pe,re);return!ee.includePattern||!!L.$bk(ee.includePattern,De)}else return!1}):!1:!0}var w;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class E extends Error{constructor(re,ee){super(re),this.code=ee}}e.$PK=E;function y(Z){const re=Z.message;if((0,v.$4)(Z))return new E(re,w.canceled);try{const ee=JSON.parse(re);return new E(ee.message,ee.code)}catch{return new E(re,w.other)}}function D(Z){const re={message:Z.message,code:Z.code};return new Error(JSON.stringify(re))}function P(Z){return Z.type==="error"?!0:Z.type==="success"}function z(Z){return Z.type==="success"}function F(Z){return!!Z.path}function T(Z,re,ee=!0){const pe=Z.searchPath?Z.searchPath:Z.relativePath;return ee?(0,M.$Lf)(pe,re):L.$bk(re,pe)}class j{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$WK=j;function N(Z,re){const ee={...Z||{},...re||{}};return Object.keys(ee).filter(pe=>{const De=ee[pe];return typeof De=="boolean"&&De})}class B{constructor(re,ee){this.c=null,this.a={...re.excludePattern||{},...ee.excludePattern||{}},this.b=L.$ck(this.a);let pe=re.includePattern;ee.includePattern&&(pe?pe={...pe,...ee.includePattern}:pe=ee.includePattern),pe&&(this.c=L.$ck(pe))}matchesExcludesSync(re,ee,pe){return!!(this.b&&this.b(re,ee,pe))}includedInQuerySync(re,ee,pe){return!(this.b&&this.b(re,ee,pe)||this.c&&!this.c(re,ee,pe))}includedInQuery(re,ee,pe){const De=this.b(re,ee,pe),x=()=>this.c?!!this.c(re,ee,pe):!0;return(0,I.$7g)(De)?De.then(U=>U?!1:x()):x()}hasSiblingExcludeClauses(){return W(this.a)}}e.$YK=B;function W(Z){for(const re in Z)if(typeof Z[re]!="boolean")return!0;return!1}function Y(Z){if(!Z)return;let re;return ee=>(re||(re=(Z()||Promise.resolve([])).then(pe=>pe?J(pe):{})),re.then(pe=>!!pe[ee]))}function _(Z){if(!Z)return;let re;return ee=>{if(!re){const pe=Z();re=pe?J(pe):{}}return!!re[ee]}}function J(Z){const re={};for(const ee of Z)re[ee]=!0;return re}}),define(ke[43],Ee([1,0,19,8,22,4,3,77,15,125,23,14,2,229,5,12,261,42,59,28,20,16,7,66,36,6,57]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f,d,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=e.$Mjc=void 0;function h(z,F,T){return new R.$Kg(j=>E(j,T)).isEqual(z,F)}function g(z,F,T){return h(z.uri,F.uri,T)?0:(0,I.$ef)(z.uri.toString(),F.uri.toString())}function S(z,F,T){return z.index!==F.index?z.index<F.index?-1:1:h(z.uri,F.uri,T)?(0,I.$ef)(z.name,F.name):(0,I.$ef)(z.uri.toString(),F.uri.toString())}function w(z,F,T,j){const N=z.slice(0).sort((W,Y)=>T(W,Y,j)),B=F.slice(0).sort((W,Y)=>T(W,Y,j));return(0,u.$Eb)(N,B,(W,Y)=>T(W,Y,j))}function E(z,F){const T=F.getCapabilities(z.scheme);return!(T&&T&1024)}class y extends o.$Bi{static toExtHostWorkspace(F,T,j,N){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:Y,configuration:_,transient:J,isUntitled:Z}=F,re=[],ee=T;T?Y.forEach((U,ie)=>{const be=p.URI.revive(U.uri),Ce=y.o(j||T,be,N);Ce?(Ce.name=U.name,Ce.index=U.index,re.push(Ce)):re.push({uri:be,name:U.name,index:ie})}):re.push(...Y.map(({uri:U,name:ie,index:be})=>({uri:p.URI.revive(U),name:ie,index:be}))),re.sort((U,ie)=>U.index<ie.index?-1:1);const pe=new y(B,W,re,!!J,_?p.URI.revive(_):null,!!Z,U=>E(U,N)),{added:De,removed:x}=w(ee?ee.workspaceFolders:[],pe.workspaceFolders,g,N);return{workspace:pe,added:De,removed:x}}static o(F,T,j){for(let N=0;N<F.folders.length;N++){const B=F.workspaceFolders[N];if(h(B.uri,T,j))return B}}constructor(F,T,j,N,B,W,Y){super(F,j.map(_=>new o.$Ci(_)),N,B,Y),this.t=T,this.u=W,this.q=[],this.s=b.$oi.forUris(Y),j.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,T){return T&&this.s.get(F)&&(F=(0,R.$Ug)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let D=class{constructor(F,T,j,N,B){this.c=new A.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new A.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$9d,this.C=new Map,this.h=N,this.s=j,this.t=B,this.j=new v.$pm,this.k=new L.$hh,this.o=F.getProxy(l.$rM.MainThreadWorkspace),this.q=F.getProxy(l.$rM.MainThreadMessageService);const W=T.workspace;this.l=W?new y(W.id,W.name,[],!!W.transient,W.configuration?p.URI.revive(W.configuration):null,!!W.isUntitled,Y=>E(Y,j)):void 0}$initializeWorkspace(F,T){this.v=T,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,R.$Sg)((0,R.$Ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,T,j,...N){const B=[];if(Array.isArray(N)&&N.forEach(Z=>{p.URI.isUri(Z.uri)&&!B.some(re=>h(re.uri,Z.uri,this.s))&&B.push({uri:Z.uri,name:Z.name||(0,R.$Rg)(Z.uri)})}),this.n||[T,j].some(Z=>typeof Z!="number"||Z<0)||j===0&&B.length===0)return!1;const W=this.x?this.x.workspaceFolders:[];if(T+j>W.length)return!1;const Y=W.slice(0);Y.splice(T,j,...B.map(Z=>({uri:Z.uri,name:Z.name||(0,R.$Rg)(Z.uri),index:void 0})));for(let Z=0;Z<Y.length;Z++){const re=Y[Z];if(Y.some((ee,pe)=>pe!==Z&&h(re.uri,ee.uri,this.s)))return!1}Y.forEach((Z,re)=>Z.index=re);const{added:_,removed:J}=w(W,Y,S,this.s);if(_.length===0&&J.length===0)return!1;if(this.o){const Z=F.displayName||F.name;this.o.$updateWorkspaceFolders(Z,T,j,B).then(void 0,re=>{this.n=void 0;const ee={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(m.Severity.Error,(0,C.localize)(0,null,Z,re.toString()),ee,[])})}return this.y(Y),!0}getWorkspaceFolder(F,T){if(this.x)return this.x.getWorkspaceFolder(F,T)}async getWorkspaceFolder2(F,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,T)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,T){let j,N="";if(typeof F=="string"?(j=p.URI.file(F),N=F):typeof F<"u"&&(j=F,N=F.fsPath),!j)return N;const B=this.getWorkspaceFolder(j,!0);if(!B)return N;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let W=(0,R.$Xg)(B.uri,j);return T&&B.name&&(W=`${B.name}/${W}`),W}y(F){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:T,added:j,removed:N}=y.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:N}))}findFiles(F,T,j,N,B=O.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let W="",Y=!0;return T===null?Y=!1:T!==void 0&&(typeof T=="string"?W=T:W=T.pattern),this.z(F,void 0,{exclude:W,maxResults:j,useDefaultExcludes:Y,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(F,T={},j,N=O.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${j.value}, entryPoint: findFiles2`),this.z(void 0,F,T,N)}async z(F,T,j,N=O.CancellationToken.None){if(N&&N.isCancellationRequested)return Promise.resolve([]);const B=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,W={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof j.useDefaultSearchExcludes=="boolean"?!j.useDefaultSearchExcludes:!1,maxResults:j.maxResults,excludePattern:B,shouldGlobSearch:typeof j.fuzzy=="boolean"?!j.fuzzy:!0,_reason:"startFileSearch"};let Y;if(F){const{includePattern:_,folder:J}=P(s.GlobPattern.from(F));Y=J,W.includePattern=_}else{const{includePattern:_,folder:J}=P(s.GlobPattern.from(T));Y=J,W.filePattern=_}return this.o.$startFileSearch(Y??null,W,N).then(_=>Array.isArray(_)?_.map(J=>p.URI.revive(J)):[])}async findTextInFiles(F,T,j,N,B=O.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const W=this.j.getNext(),Y=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:_,folder:J}=P(s.GlobPattern.from(T.include)),Z=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,re={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:Y,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:_,excludePattern:Z},ee=!1;if(this.u[W]=pe=>{if(ee)return;const De=p.URI.revive(pe.resource);pe.results.forEach(x=>{const U=(0,a.$Rh)(x);(0,d.$GK)(U)?j({uri:De,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ie=>new t.$vM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,u.$2b)(U.ranges,ie=>new t.$vM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):j({uri:De,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(F,J??null,re,W,B);return delete this.u[W],pe||{}}catch(pe){throw delete this.u[W],pe}}$handleTextSearchResult(F,T){this.u[T]?.(F)}async save(F){const T=await this.o.$save(F,{saveAs:!1});return p.URI.revive(T)}async saveAs(F){const T=await this.o.$save(F,{saveAs:!0});return p.URI.revive(T)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,T){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,T);const j=this.t.transformOutgoingScheme(F),N=this.A++;return this.o.$registerEditSessionIdentityProvider(N,j),(0,M.$Sc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(F,T){this.h.info("Getting edit session identifier for workspaceFolder",F);const j=await this.resolveWorkspaceFolder(p.URI.revive(F));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const N=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!N),!N)return;const B=await N.provideEditSessionIdentity(j,T);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(F,T,j,N){this.h.info("Getting edit session identifier for workspaceFolder",F);const B=await this.resolveWorkspaceFolder(p.URI.revive(F));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const Y=await W.provideEditSessionIdentityMatch?.(T,j,N);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(F){return(T,j,N)=>{const B=function(Y){T.call(j,Y)};return B.extension=F,this.B.event(B,void 0,N)}}async $onWillCreateEditSessionIdentity(F,T,j){const N=await this.resolveWorkspaceFolder(p.URI.revive(F));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:N},T,async(B,W)=>{const Y=Date.now();await Promise.resolve(B),Date.now()-Y>j&&this.h.warn("SLOW edit session create-participant",W.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(F,T){if(this.C.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.C.set(F,T);const j=this.t.transformOutgoingScheme(F),N=this.A++;return this.o.$registerCanonicalUriProvider(N,j),(0,M.$Sc)(()=>{this.C.delete(F),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(F,T,j){const N=this.C.get(F.scheme);if(!N)return;const B=await N.provideCanonicalUri?.(p.URI.revive(F),T,j);if(B)return B}async $provideCanonicalUri(F,T,j){return this.provideCanonicalUri(p.URI.revive(F),{targetScheme:T},j)}};e.$Mjc=D,e.$Mjc=D=Je([qe(0,r.$MO),qe(1,i.$3O),qe(2,n.$sjc),qe(3,c.$Oj),qe(4,f.$Kjc)],D),e.$Njc=(0,k.$ii)("IExtHostWorkspace");function P(z){let F,T;return z&&(typeof z=="string"?F=z:(F=z.pattern,T=p.URI.revive(z.baseUri))),{includePattern:F,folder:T}}}),define(ke[44],Ee([1,0,24,4,43,6,7,263,85,18,8,5,20,12,2]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=e.$Pjc=e.$Ojc=void 0;function c(f,d){if(d){const l=d.split(".");let a=f;for(let h=0;a&&h<l.length;h++)a=a[l[h]];return a}}function m(f){return f instanceof k.URI}function o(f){return f&&f.uri instanceof k.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&f.uri instanceof k.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(m(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(i(f))return{resource:f.uri};if(f===null)return{resource:null}}let s=class{constructor(d,l,a){this.a=d.getProxy(A.$rM.MainThreadConfiguration),this.c=l,this.b=a,this.d=new R.$hh,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(d,l))}};e.$Ojc=s,e.$Ojc=s=Je([qe(0,p.$MO),qe(1,O.$Njc),qe(2,C.$Oj)],s);class t{constructor(d,l,a,h){this.a=new L.$7d,this.b=d,this.f=h,this.c=l,this.e=b.$mo.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$mo.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,a))}getConfiguration(d,l,a){const h=r(l)||{},g=this.g(d?c(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,a?.identifier);function S(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(E){return typeof c(g,E)<"u"},get:(E,y)=>{this.h(d?`${d}.${E}`:E,h,a?.identifier);let D=c(g,E);if(typeof D>"u")D=y;else{let P;const z=(F,T)=>{if((0,v.$Xf)(F)){let j;const N=()=>{P=P||(0,u.$On)(g),j=j||c(P,T)};return new Proxy(F,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return N(),()=>j;if(P)return j=j||c(P,T),j[W];const Y=B[W];return typeof W=="string"?z(Y,`${T}.${W}`):Y},set:(B,W,Y)=>(N(),j&&(j[W]=Y),!0),deleteProperty:(B,W)=>(N(),j&&delete j[W],!0),defineProperty:(B,W,Y)=>(N(),j&&Object.defineProperty(j,W,Y),!0)})}return Array.isArray(F)?(0,u.$On)(F):F};D=z(D,E)}return D},update:(E,y,D,P)=>{E=d?`${d}.${E}`:E;const z=S(D);return y!==void 0?this.b.$updateConfigurationOption(z,E,y,h,P):this.b.$removeConfigurationOption(z,E,h,P)},inspect:E=>{E=d?`${d}.${E}`:E;const y=this.e.inspect(E,h,this.c.workspace);if(y)return{key:E,defaultValue:(0,u.$On)(y.policy?.value??y.default?.value),globalValue:(0,u.$On)(y.user?.value??y.application?.value),workspaceValue:(0,u.$On)(y.workspace?.value),workspaceFolderValue:(0,u.$On)(y.workspaceFolder?.value),defaultLanguageValue:(0,u.$On)(y.default?.override),globalLanguageValue:(0,u.$On)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,u.$On)(y.workspace?.override),workspaceFolderLanguageValue:(0,u.$On)(y.workspaceFolder?.override),languageIds:(0,u.$On)(y.overrideIdentifiers)}}};return typeof g=="object"&&(0,u.$Rn)(w,g,!1),Object.freeze(w)}g(d){const l=a=>(0,v.$Xf)(a)?new Proxy(a,{get:(h,g)=>l(h[g]),set:(h,g,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(h,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(h,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(d)}h(d,l,a){const h=$.$do.test(d)?4:this.d.get(d),g=a?`[${a.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const a=new b.$oo(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,g)=>a.affectsConfiguration(h,r(g))})}k(d){return d.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.$Pjc=t,e.$Qjc=(0,I.$ii)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,8,4,6,7,43,72,44,22,47,20,28,5,15,11,12,91,306,13]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=e.$glc=e.$flc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(z){function F(j){if(j!=null)return j}z.from=F;function T(j){if(j!=null)return j}z.to=T})(s||(s={}));var t;(function(z){function F(j){if(j!=null)return j}z.from=F;function T(j){if(j!=null)return j}z.to=T})(t||(t={}));var f;(function(z){function F(j){if(j!=null)return j}z.from=F;function T(j){if(j!=null)return j}z.to=T})(f||(f={}));var d;(function(z){function F(N){if(N){const B=N;return B&&!!B.process}else return!1}z.is=F;function T(N){if(N==null)return;const B={process:N.process,args:N.args};return N.options&&(B.options=f.from(N.options)),B}z.from=T;function j(N){if(N!=null)return new M.$cN(N.process,N.args,N.options)}z.to=j})(d||(d={}));var l;(function(z){function F(j){if(j!=null)return j}z.from=F;function T(j){if(j!=null)return j}z.to=T})(l||(l={}));var a;(function(z){function F(N){if(N){const B=N;return B&&(!!B.commandLine||!!B.command)}else return!1}z.is=F;function T(N){if(N==null)return;const B={};return N.commandLine!==void 0?B.commandLine=N.commandLine:(B.command=N.command,B.args=N.args),N.options&&(B.options=l.from(N.options)),B}z.from=T;function j(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new M.$dN(N.commandLine,N.options):new M.$dN(N.command,N.args?N.args:[],N.options)}z.to=j})(a||(a={}));var h;(function(z){function F(N){if(N){const B=N;return B&&B.customExecution==="customExecution"}else return!1}z.is=F;function T(N){return{customExecution:"customExecution"}}z.from=T;function j(N,B){return B.get(N)}z.to=j})(h||(e.CustomExecutionDTO=h={}));var g;(function(z){function F(T,j){let N;return T.scope!==void 0&&typeof T.scope!="number"?N=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===M.TaskScope.Workspace&&j&&j.workspaceFile?N=j.workspaceFile:N=i.$yH),{id:T._id,workspaceFolder:N}}z.from=F})(g||(e.TaskHandleDTO=g={}));var S;(function(z){function F(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}z.from=F})(S||(S={}));var w;(function(z){function F(N,B){if(N==null)return[];const W=[];for(const Y of N){const _=T(Y,B);_&&W.push(_)}return W}z.fromMany=F;function T(N,B){if(N==null)return;let W;N.execution instanceof M.$cN?W=d.from(N.execution):N.execution instanceof M.$dN?W=a.from(N.execution):N.execution&&N.execution instanceof M.$eN&&(W=h.from(N.execution));const Y=s.from(N.definition);let _;return N.scope?typeof N.scope=="number"?_=N.scope:_=N.scope.uri:_=M.TaskScope.Workspace,!Y||!_?void 0:{_id:N._id,definition:Y,name:N.name,source:{extensionId:B.identifier.value,label:N.source,scope:_},execution:W,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}z.from=T;async function j(N,B,W){if(N==null)return;let Y;d.is(N.execution)?Y=d.to(N.execution):a.is(N.execution)?Y=a.to(N.execution):h.is(N.execution)&&(Y=h.to(N._id,W));const _=s.to(N.definition);let J;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?J=N.source.scope:J=await B.resolveWorkspaceFolder(u.URI.revive(N.source.scope)):J=M.TaskScope.Workspace),!_||!J)return;const Z=new M.$fN(_,J,N.name,N.source.label,Y,N.problemMatchers);return N.isBackground!==void 0&&(Z.isBackground=N.isBackground),N.group!==void 0&&(Z.group=M.$bN.from(N.group._id),Z.group&&N.group.isDefault&&(Z.group=new M.$bN(Z.group.id,Z.group.label),N.group.isDefault===!0&&(Z.group.isDefault=N.group.isDefault))),N.presentationOptions&&(Z.presentationOptions=t.to(N.presentationOptions)),N._id&&(Z._id=N._id),N.detail&&(Z.detail=N.detail),Z}z.to=j})(w||(e.TaskDTO=w={}));var E;(function(z){function F(j){return j}z.from=F;function T(j){if(j)return Object.assign(Object.create(null),j)}z.to=T})(E||(E={}));class y{#e;constructor(F,T,j){this._id=T,this.a=j,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let D=class{constructor(F,T,j,N,B,W,Y,_){this.q=new O.$7d,this.r=new O.$7d,this.s=new O.$7d,this.u=new O.$7d,this.a=F.getProxy(A.$rM.MainThreadTask),this.b=j,this.c=N,this.d=B,this.e=W,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Y,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,T,j){if(!j)return new M.$tM(()=>{});const N=this.x();return this.j.set(N,{type:T,provider:j,extension:F}),this.a.$registerTaskProvider(N,T),new M.$tM(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(F,T){this.a.$registerTaskSystem(F,T)}fetchTasks(F){return this.a.$fetchTasks(E.from(F)).then(async T=>{const j=[];for(const N of T){const B=await w.to(N,this.b,this.m);B&&j.push(B)}return j})}get taskExecutions(){const F=[];return this.k.forEach(T=>F.push(T)),F}terminateTask(F){if(!(F instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,T,j){const N=this.m.get(F.id);N&&(this.o.set(F.id,N),this.e.attachPtyToTerminal(T,await N.callback(j))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const T=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const T=await this.z(F.id);this.s.fire({execution:T,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const T=await this.z(F.id);this.u.fire({execution:T,exitCode:F.exitCode})}$provideTasks(F,T){const j=this.j.get(F);if(!j)return Promise.reject(new Error("no handler found"));const N=[],B=(0,L.$ah)(()=>j.provider.provideTasks(R.CancellationToken.None)).then(W=>this.v(T,N,j,W));return new Promise(W=>{B.then(Y=>{Promise.all(N).then(()=>{W(Y)})})})}async $resolveTask(F,T){const j=this.j.get(F);if(!j)return Promise.reject(new Error("no handler found"));if(T.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${j.type}].`);const N=await w.to(T,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const B=await j.provider.resolveTask(N,R.CancellationToken.None);if(!B)return;this.A(B,j);const W=w.from(B,j.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(W.execution)&&await this.y(W,B,!0),await this.w(W)}x(){return this.h++}async y(F,T,j){const N=await this.a.$createTaskId(F);!j&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,T.execution)),this.m.set(N,T.execution)}async z(F,T){if(typeof F=="string"){const B=this.l.get(F);if(!B)throw new r.$bb("Unexpected: The specified task is missing an execution");return B}const j=this.l.get(F.id);if(j)return j;let N;return T?N=Promise.resolve(new y(this,F.id,T)):N=w.to(F.task,this.b,this.m).then(B=>{if(!B)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,F.id,B)}),this.l.set(F.id,N),N.then(B=>(this.k.set(F.id,B),B))}A(F,T){F._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const j=this.n.values();let N=j.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=j.next()}};e.$flc=D,e.$flc=D=Je([qe(0,p.$MO),qe(1,C.$3O),qe(2,b.$Njc),qe(3,$.$XO),qe(4,v.$Qjc),qe(5,I.$ckc),qe(6,o.$Oj),qe(7,n.$ojc)],D);let P=class extends D{constructor(F,T,j,N,B,W,Y,_){super(F,T,j,N,B,W,Y,_),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(F,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const j=w.from(T,F);if(j===void 0)throw new Error("Task is not valid");if(h.is(j.execution))await this.y(j,T,!1);else throw new r.$_;const N=await this.z(await this.a.$getTaskExecution(j),T);return this.a.$executeTask(j).catch(B=>{throw new Error(B)}),N}v(F,T,j,N){const B=[];if(N)for(const W of N){if(this.A(W,j),!W.definition||!F[W.definition.type]){const _=W.source?W.source:"No task source";this.f.warn(`The task [${_}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const Y=w.from(W,j.extension);Y&&h.is(Y.execution)?(B.push(Y),T.push(this.y(Y,W,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:j.extension}}async w(F){if(h.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,T,j){}};e.$glc=P,e.$glc=P=Je([qe(0,p.$MO),qe(1,C.$3O),qe(2,b.$Njc),qe(3,$.$XO),qe(4,v.$Qjc),qe(5,I.$ckc),qe(6,o.$Oj),qe(7,n.$ojc)],P),e.$hlc=(0,k.$ii)("IExtHostTask")}),define(ke[368],Ee([1,0,36,29]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=void 0,e.$7K=O,e.$9K=A;function O(M){return"cellResults"in M}e.$8K="rawCell#";function A(M,b){let $=-1;const v=[];let R=[];return M.forEach(p=>{p.range.startLineNumber!==$&&R.length>0&&(v.push([...R]),R=[]),R.push(p),$=p.range.endLineNumber}),R.length>0&&v.push([...R]),v.map(p=>{const C=[],k=p[0].range.startLineNumber,c=p[p.length-1].range.endLineNumber;for(let m=k;m<=c;m++)C.push(b.getLineContent(m));return new u.$KK(C.join(`
`)+`
`,p.map(m=>new L.$ct(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[369],Ee([1,0,223,21,4,3,27,14,18,2,32,111,6,33,16,7,68,339,153,24,15,296,368,365]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,h,g,S,w,E){this.q=g,this.r=S,this.s=w,this.t=E,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new O.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new O.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new O.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new O.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$mjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(p.$rM.MainThreadNotebook),this.c=a.getProxy(p.$rM.MainThreadNotebookDocuments),this.d=a.getProxy(p.$rM.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const D=y.notebookEditor?.notebookUri,P=y.cell.handle,F=this.g.get(D)?.getCell(P);if(F)return F.apiCell}if(y&&y.$mid===14){const D=y.uri,P=this.g.get(D);if(P)return P.apiNotebook}return y}}),d.B(h)}getEditorById(a){const h=this.h.get(a);if(!h)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(a){for(const[h,g]of this.h)if(g.apiEditor===a)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,h){const g=this.g.get(a);if(!g&&!h)throw new Error(`NO notebook document for '${a}'`);return g}static u(a,h){if(!h)return;const g=h.filenamePattern.map(S=>k.NotebookExclusiveDocumentPattern.from(S)).filter(S=>S!==void 0);if(h.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:h.displayName,filenamePattern:g,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,h,g){const S=d.a++,w=typeof g.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(S,g),this.b.$registerNotebookCellStatusBarItemProvider(S,w,h);let E;return w!==void 0&&(E=g.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(w))),new c.$tM(()=>{this.f.delete(S),this.b.$unregisterNotebookCellStatusBarItemProvider(S,w),E?.dispose()})}async createNotebookDocument(a){const h=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&k.NotebookData.from(a.content)});return v.URI.revive(h)}async openNotebookDocument(a){const h=this.g.get(a);if(h)return h.apiNotebook;const g=await this.c.$tryOpenNotebook(a),S=this.g.get(v.URI.revive(g));return(0,$.$7f)(S?.apiNotebook)}async showNotebookDocument(a,h){v.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let g;typeof h=="object"?g={position:k.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(k.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const S=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,g),w=S&&this.h.get(S)?.apiEditor;if(w)return w;throw S?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,h,g,S){const w=this.f.get(a),E=v.URI.revive(h),y=this.g.get(E);if(!y||!w)return;const D=y.getCellFromIndex(g);if(!D)return;const P=await w.provideCellStatusBarItems(D.apiCell,S);if(!P)return;const z=new A.$Tc,F=this.p.add([z]),j=(Array.isArray(P)?P:[P]).map(N=>k.NotebookStatusBarItem.from(N,this.i,z));return{cacheId:F,items:j}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,h,g,S,w){if((0,b.$Ue)(h))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:h,serializer:g,options:S}),this.b.$registerNotebookSerializer(E,{id:a.identifier,location:a.extensionLocation},h,k.NotebookDocumentContentOptions.from(S),d.u(a,w)),(0,A.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(a,h,g){const S=this.x.get(a);if(!S)throw new Error("NO serializer found");const w=await S.serializer.deserializeNotebook(h.buffer,g);return new m.$ew(k.NotebookData.from(w))}async $notebookToData(a,h,g){const S=this.x.get(a);if(!S)throw new Error("NO serializer found");const w=await S.serializer.serializeNotebook(k.NotebookData.to(h.value),g);return L.$ue.wrap(w)}async $saveNotebook(a,h,g,S,w){const E=v.URI.revive(h),y=this.x.get(a);if(!y)throw new Error("NO serializer found");const D=this.g.get(E);if(!D)throw new Error("Document NOT found");if(D.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new R.$0k((0,u.localize)(0,null,this.z(E)),6);await this.y(E,S);const P={metadata:(0,i.$Wn)(D.apiNotebook.metadata,N=>!(y.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of D.apiNotebook.getCells()){const B=new c.$VN(N.kind,N.document.getText(),N.document.languageId,N.mime,y.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);B.metadata=(0,i.$Wn)(N.metadata,W=>!(y.options?.transientCellMetadata??{})[W]),P.cells.push(B)}const z=await y.serializer.serializeNotebook(P,w);await this.s.value.writeFile(E,z);const F=this.s.getFileSystemProviderExtUri(E.scheme),T=await this.s.value.stat(E);return{name:F.basename(E),isFile:(T.type&R.FileType.File)!==0,isDirectory:(T.type&R.FileType.Directory)!==0,isSymbolicLink:(T.type&R.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((T.permissions??0)&R.FilePermission.Locked),etag:R.$il({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(a,h,g,S,w){const E=this.x.get(a)?.serializer;if(!E)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(T,j,N)=>{await Promise.all(T.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const Y={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(Y,j,_=>{_.forEach(J=>{y.has(J)||S.some(re=>B.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(ee=>(0,f.$Nfb)(ee,J)))||y.add(J)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(g,w,h);const P=new M.$Bc;let z=!1;const F=Array.from(y).map(async T=>{const j=[];try{if(w.isCancellationRequested)return;if(h.maxResults&&[...P.values()].reduce((Y,_)=>Y+_.cellResults.length,0)>h.maxResults){z=!0;return}const N=[],B=this.g.get(T);if(B)B.apiNotebook.getCells().forEach(_=>N.push({input:_.document.getText(),outputs:_.outputs.flatMap(J=>J.items.map(Z=>Z.data.toString()))}));else{const Y=await this.s.value.readFile(T),_=L.$ue.fromString(Y.toString()),J=await E.deserializeNotebook(_.buffer,w);if(w.isCancellationRequested)return;k.NotebookData.from(J).cells.forEach(re=>N.push({input:re.source,outputs:re.outputs.flatMap(ee=>ee.items.map(pe=>pe.valueBytes.toString()))}))}if(w.isCancellationRequested)return;N.forEach((Y,_)=>{const J=h.contentPattern.pattern,Z=new s.$WUb(Y.input,void 0,Y.outputs),re=Z.findInInputs(J),ee=Z.findInOutputs(J),pe=ee.flatMap(De=>(0,t.$9K)(De.matches,De.textBuffer)).map((De,x)=>(De.webviewIndex=x,De));if(re.length>0||ee.length>0){const De={index:_,contentResults:(0,t.$9K)(re,Z.inputTextBuffer),webviewResults:pe};j.push(De)}});const W={resource:T,cellResults:j};P.set(T,W);return}catch{return}});return await Promise.all(F),{limitHit:z,results:[...P.values()]}}async y(a,h){const g=await this.s.value.stat(a);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==R.$hl&&typeof g.mtime=="number"&&typeof g.size=="number"&&h.mtime<g.mtime&&h.etag!==R.$il({mtime:h.mtime,size:g.size}))throw new R.$0k((0,u.localize)(1,null),3,h)}z(a){return a.scheme===r.Schemas.file?a.fsPath:a.toString()}A(a,h,g){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const S=new n.$Kkc(h,this.d,a,g.visibleRanges.map(k.NotebookRange.to),g.selections.map(k.NotebookRange.to),typeof g.viewColumn=="number"?k.ViewColumn.to(g.viewColumn):void 0);this.h.set(h,S)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const g of a.value.removedDocuments){const S=v.URI.revive(g),w=this.g.get(S);w&&(w.dispose(),this.g.delete(S),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(w.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===S.toString()&&this.h.delete(E.id)}if(a.value.addedDocuments){const g=[];for(const S of a.value.addedDocuments){const w=v.URI.revive(S.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const E=new o.$Jkc(this.c,this.q,this.r,w,S);g.push(...S.cells.map(y=>o.$Ikc.asModelAddData(y))),this.g.get(w)?.dispose(),this.g.set(w,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(E.apiNotebook)}}if(a.value.addedEditors)for(const g of a.value.addedEditors){if(this.h.has(g.id))return;const S=v.URI.revive(g.documentUri),w=this.g.get(S);w&&this.A(w,g.id,g)}const h=[];if(a.value.removedEditors)for(const g of a.value.removedEditors){const S=this.h.get(g);S&&(this.h.delete(g),this.k?.id===S.id&&(this.k=void 0),h.push(S))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(S=>this.h.get(S)).filter(S=>!!S);const g=new Set;this.l.forEach(S=>g.add(S.id));for(const S of this.h.values()){const w=g.has(S.id);S._acceptVisibility(w)}this.l=[...this.h.values()].map(S=>S).filter(S=>S.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const h=C.$$O.String.with("notebookType","A notebook type"),g=new C.$aP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new C.$$O("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>L.$ue.wrap(w))],new C.$_O("Notebook Data",w=>k.NotebookData.to(w.value))),S=new C.$aP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new C.$$O("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new m.$ew(k.NotebookData.from(w)))],new C.$_O("Bytes",w=>w.buffer));a.registerApiCommand(g),a.registerApiCommand(S)}}e.$Tkc=d}),define(ke[370],Ee([1,0,17,22,46,35,23,39,36]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;class v{constructor(p,C,k){this.k=p,this.l=C,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&A.$ck(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&A.$ck(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const C=this.k.folderQueries||[];return new Promise((k,c)=>{const m=o=>{this.f++,p(o)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(m,{base:o,basename:i})}),Promise.all(C.map(o=>this.p(o,m))).then(o=>{k({limitHit:this.e,stats:o[0]||void 0})},o=>{c(new Error((0,O.$6i)(o)))})})}async p(p,C){const k=new L.$ee,c=this.q(p),m=this.r(),o=new $.$YK(this.k,p),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(k),i=b.$3d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,k.token),s=i.elapsed(),t=b.$3d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const d=u.$hc.relative(p.folder.path,f.path);if(n){const l=u.$oc(f.path);this.v(C,{base:p.folder,relativePath:d,basename:l});return}this.s(m,p.folder,d,C)}),this.g&&!this.e)?null:(this.u(m,o,C),{providerTime:s,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(p){const C=(0,$.$XK)(this.k.includePattern,p.includePattern),k=(0,$.$XK)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:k,includes:C,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},C,k,c){if(k===this.a){const o=u.$oc(this.a);this.v(c,{base:C,relativePath:this.a,basename:o})}function m(o){const n=u.$oc(o),i=u.$nc(o);let r=p[i];r||(r=p[i]=[],m(i)),r.push({base:C,relativePath:o,basename:n})}m(k)}u({rootEntries:p,pathToEntries:C},k,c){const m=this,o=this.a;function n(i){const r=(0,$.$1K)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const f=i[s],{relativePath:d,basename:l}=f;if(k.matchesExcludesSync(d,l,o!==l?r:void 0))continue;const a=C[d];if(a)n(a);else{if(d===o)continue;m.v(c,f)}if(m.e)break}}n(p)}v(p,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(C))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,C,k,c){const m=this.c(p.cacheKey),o=new v(p,C,m&&m.token);let n=0;const i=r=>{n+=r.length,k(r.map(s=>this.d(s)))};return this.e(o,R.a,i,c).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new L.$ee),this.b.get(p)}d(p){return p.relativePath?{resource:M.$Vg(p.base,p.relativePath)}:{resource:p.base}}e(p,C,k,c){const m=c.onCancellationRequested(()=>{p.cancel()}),o=i=>{i&&(n.push(i),C>0&&n.length>=C&&(k(n),n=[]))};let n=[];return p.search(o).then(i=>(n.length&&k(n),m.dispose(),i),i=>(n.length&&k(n),m.dispose(),Promise.reject(i)))}}e.$Lkc=R}),define(ke[371],Ee([1,0,19,73,35,103,27,15,17,23,14,18,2,100,243,53,12,42,146,366,36]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=void 0,e.$9L=S;let s=class{constructor(E,y,D,P,z){this.a=E,this.b=y,this.c=D,this.d=P,this.e=z}text(E,y,D={}){E=this.f(E,D);const P=this.a.getValue(),z=y&&y.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(y?.map(o.$Di),D),type:2,contentPattern:E,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:P.search.usePCRE2||z||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}f(E,y){const D=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const P={...E,wordSeparators:D.editor.wordSeparators};return this.j(E,y)&&(P.isCaseSensitive=!0),this.k(E)&&(P.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),P}file(E,y={}){return{...this.h(E,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(E,y){return E?(E=Array.isArray(E)?E.map(a):a(E),y?this.parseSearchPaths(E):{pattern:f(...Array.isArray(E)?E:[E])}):{}}h(E=[],y={}){const D=this.g(y.includePattern,y.expandPatterns),P=this.g(y.excludePattern,y.expandPatterns),z=E.length>1,F=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(N=>this.q(N,y,P)):E.map(N=>this.r(N,y,P,z))).filter(N=>!!N),T={_reason:y._reason,folderQueries:F,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:P.pattern,includePattern:D.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const N=u.$Hb(u.$Rb(this.c.groups.map(Y=>Y.editors.map(_=>_.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const B=N.filter(Y=>(0,r.$OK)(T,Y.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...T,...W}}const j=y.extraFileResources&&y.extraFileResources.filter(N=>(0,r.$OK)(T,N.fsPath));return T.extraFileResources=j&&j.length?j:void 0,T}i(E){const y=[],D=new M.$Bc,P={};let z=!1;return E.forEach(F=>{if(F.scheme===b.Schemas.walkThrough)return;if((0,v.$Zg)(F)){const j=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$nc(F.fsPath)});let N=D.get(j);N||(z=!0,N={folder:j,includePattern:{}},y.push(N),D.set(j,N));const B=$.$mc(j.fsPath,F.fsPath);(0,I.$7f)(N.includePattern)[B.replace(/\\/g,"/")]=!0}else F.fsPath&&(z=!0,P[F.fsPath]=!0)}),{folderQueries:y,includePattern:P,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(E,y){if(y.isSmartCase){if(E.isRegExp){if(R.$Mf(E.pattern,!0))return!0}else if(R.$Mf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,C.$tC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const y=W=>$.$jc(W)||/^\.\.?([\/\\]|$)/.test(W),P=(Array.isArray(E)?E:d(E)).map(W=>{const Y=this.e.resolvedUserHome;return Y?(0,A.$jw)(W,Y.scheme===b.Schemas.file?Y.fsPath:Y.path):W}),z=L.$K(P,W=>y(W)?"searchPaths":"exprSegments"),F=(z.exprSegments||[]).map(W=>R.$6e(W,"/")).map(W=>R.$6e(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),l(W))),T={},j=this.m(z.searchPaths||[]);j&&j.length&&(T.searchPaths=j);const N=u.$Rb(F),B=f(...N);return B&&(T.pattern=B),T}l(E,y){return y.disregardExcludeSettings?void 0:(0,r.$NK)(E,!y.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const y=E.flatMap(P=>{let{pathPortion:z,globPortion:F}=t(P);return F&&(F=h(F)),this.n(z).flatMap(j=>this.o(j,F))}),D=new Map;return y.forEach(P=>{const z=P.searchPath.toString(),F=D.get(z);F?P.pattern&&(F.pattern=F.pattern||{},F.pattern[P.pattern]=!0):D.set(z,{searchPath:P.searchPath,pattern:P.pattern?f(P.pattern):void 0})}),Array.from(D.values())}n(E){if($.$jc(E)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==b.Schemas.file?[{searchPath:y[0].uri.with({path:E})}]:[{searchPath:p.URI.file($.$ic(E))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(E=a(E),E.startsWith("../")||E===".."){const P=$.$hc.resolve(y.path,E);return[{searchPath:y.with({path:P})}]}const D=h(E);return[{searchPath:y,pattern:D}]}else{if(E==="./"||E===".\\")return[];{const y=E.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(z=>{const F=y.match(new RegExp(`^${R.$Ze(z.name)}(?:/(.*)|$)`));return F?{match:F,folder:z}:null}).filter(I.$4f);if(P.length)return P.map(z=>{const F=z.match[1];return{searchPath:z.folder.uri,pattern:F&&h(F)}});{const z=E.match(/\.[\/\\](.+)[\/\\]?/),F=z?z[1]:E,T=k.localize(0,null,F);throw new Error(T)}}}}o(E,y){const D=E.pattern&&y?`${E.pattern}/${y}`:E.pattern||y,P=[{searchPath:E.searchPath,pattern:D}];return D&&!D.endsWith("**")&&P.push({searchPath:E.searchPath,pattern:D+"/**"}),P}q(E,y,D){const P=this.r((0,o.$Di)(E.searchPath),y,D,!1);return P?{...P,includePattern:E.pattern}:null}r(E,y,D,P){let z;const F=p.URI.isUri(E)?E:E.uri;if(D.searchPaths){const W=D.searchPaths.filter(Y=>(0,v.$Og)(Y.searchPath,F))[0];if(W&&!W.pattern)return null;W&&(z=W.pattern)}const T=this.a.getValue({resource:F}),N={...this.l(T,y)||{},...z||{}},B=p.URI.isUri(E)?(0,v.$Sg)(E):E.name;return{folder:F,folderName:P?B:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!T.search.followSymlinks}}};e.$8L=s,e.$8L=s=Je([qe(0,c.$Oi),qe(1,o.$ri),qe(2,n.$AD),qe(3,m.$Oj),qe(4,i.$6L)],s);function t(w){const E=w.match(/[\*\{\}\(\)\[\]\?]/);if(E){const y=E.index,D=w.substr(0,y).match(/[/|\\][^/\\]*$/);if(D){let P=w.substr(0,D.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:w.substr((D.index||0)+1)}}}return{pathPortion:w}}function f(...w){return w.length?w.reduce((E,y)=>(E[y]=!0,E),Object.create(null)):void 0}function d(w){return O.$ak(w,",").map(E=>E.trim()).filter(E=>!!E.length)}function l(w){return[`**/${w}/**`,`**/${w}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function a(w){return w.replace(/\\/g,"/")}function h(w){return a(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(w){return w.replace(/([?*[\]])/g,"[$1]")}function S(w,E){w=u.$Mb(w,P=>P.toString());const y=[],D=E.getWorkspace();return w&&w.forEach(P=>{let z;if(E.getWorkbenchState()===2)z=(0,v.$Xg)(D.folders[0].uri,P),z&&z!=="."&&(z="./"+z);else{const F=E.getWorkspaceFolder(P);if(F){const T=F.name;if(D.folders.filter(N=>N.name===T).length===1){const N=(0,v.$Xg)(F.uri,P);N===""?z=`./${F.name}`:z=`./${F.name}/${N}`}else z=P.fsPath}}z&&y.push(g(z))}),y}}),define(ke[372],Ee([1,0,23,2,22,13,5,371,36,42,8]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wvb=p,e.$xvb=c;const I=7e3;function p(m,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const a of n)if(/^workspaceContains:/.test(a)){const h=a.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||m.forceUsingSearch?r.push(h):i.push(h)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,R.$bh)(),f=a=>t({activationEvent:a}),d=Promise.all(i.map(a=>C(m,a,f))).then(()=>{}),l=k(m,o.identifier,r,f);return Promise.all([d,l]).then(()=>{t(void 0)}),s}async function C(m,o,n){for(const i of m.folders)if(await m.exists(u.$Vg(L.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function k(m,o,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new O.$ee,s=m.checkExists(m.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},I);let f=!1;try{f=await s}catch(d){A.$4(d)||A.$1(d)}r.dispose(),clearTimeout(t),f&&i(`workspaceContains:${n.join(",")}`)}function c(m,o,n,i){const r=m.get(M.$hi),s=m.get($.$FK),f=r.createInstance(b.$8L).file(o.map(d=>(0,v.$Di)(L.URI.revive(d))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(f,i).then(d=>!!d.limitHit,d=>A.$4(d)?!1:Promise.reject(d))}}),define(ke[48],Ee([1,0,219,17,58,23,8,3,77,2,12,6,44,302,118,43,26,148,13,25,21,280,7,65,5,28,93,20,107,70,47,121,4,372,117,282,15,115,39,11,116]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f,d,l,a,h,g,S,w,E,y,D,P,z,F,T,j,N,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=e.$pkc=e.$okc=e.$nkc=void 0,e.$nkc=(0,d.$ii)("IHostUtils");let Y=W=class extends b.$Uc{constructor(U,ie,be,Ce,ae,ce,se,K,te,le,de,Ae,me){super(),this.Y=Ae,this.Z=me,this.a=this.B(new y.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ie,this.g=be,this.f=se,this.j=Ce,this.m=ae,this.s=ce,this.t=te,this.u=le,this.w=de,this.y=this.g.getProxy(I.$rM.MainThreadWorkspace),this.z=this.g.getProxy(I.$rM.MainThreadTelemetry),this.C=this.g.getProxy(I.$rM.MainThreadExtensionService),this.D=new M.$hh,this.F=new M.$hh,this.G=new M.$hh,this.H=new M.$hh,this.I=new De(this.f.extensions.activationEvents),this.L=new o.$h$b(this.I,this.f.extensions.allExtensions);const Ie=new i.$Em(this.f.extensions.myExtensions);this.J=new o.$h$b(this.I,ee(this.L,Ie)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new k.$$jc(this.g,this.s),this.N=new P.$gkc(this.g),this.O=K,this.h=U.createChild(new g.$gi([k.$_jc,this.M],[P.$hkc,this.N])),this.P=this.B(new C.$0jc(this.J,this.L,{onExtensionActivationError:(Re,Fe,q)=>{this.C.$onExtensionActivationError(Re,n.$3(Fe),q)},actualActivateExtension:async(Re,Fe)=>{if(o.$h$b.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Fe),new C.$9jc;const q=this.J.getExtensionDescription(Re);return this.fb(q,Fe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),O.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(U)}terminate(U,ie=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ce=>{this.s.error(Ce)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$jh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ie=await this.C.$getExtension(U);return ie&&{...ie,identifier:new i.$Dm(ie.identifier.value),extensionLocation:v.URI.revive(ie.extensionLocation)}}ab(U,ie){return this.P.activateByEvent(U,ie)}bb(U,ie){return this.P.activateById(U,ie)}activateByIdWithErrors(U,ie){return this.bb(U,ie).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===F.Schemas.file&&this.c.fsRealpath){const ie=U.fsPath;this.R.has(ie)||this.R.set(ie,this.c.fsRealpath(ie));const be=await this.R.get(ie);return v.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new pe(U))),this.Q}async db(U){const ie=$.$oi.forUris(be=>A.$Mg.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const Ce=await this.cb(be.extensionLocation);ie.set(Ce,be)}})),ie}eb(U){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ie;const be=this.P.getActivatedExtension(U);if(!be)return ie;try{typeof be.module.deactivate=="function"&&(ie=Promise.resolve(be.module.deactivate()).then(void 0,Ce=>(this.s.error(Ce),Promise.resolve(void 0))))}catch(Ce){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Ce)}try{(0,b.$Pc)(be.subscriptions)}catch(Ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Ce)}return ie}async fb(U,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ie).then(be=>{const Ce=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,ie),this.gb(U,ie,"success",Ce),be},be=>{throw this.gb(U,ie,"failure"),be})}gb(U,ie,be,Ce){const ae=J(U,ie);this.z.$publicLog2("extensionActivationTimes",{...ae,...Ce||{},outcome:be})}hb(U,ie){const be=J(U,ie);this.z.$publicLog2("activatePlugin",be);const Ce=this.wb(U);if(!Ce)return Promise.resolve(new C.$8jc(C.$5jc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${U.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const ae=new C.$6jc(ie.startup);return Promise.all([this.xb(U,(0,A.$Vg)(U.extensionLocation,Ce),ae),this.ib(U)]).then(ce=>(O.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),W.jb(this.s,U.identifier,ce[0],ce[1],ae))).then(ce=>(O.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ce))}ib(U){const ie=this.Z.createLanguageModelAccessInformation(U),be=new s.$bkc(U,this.M),Ce=new s.$akc(U.identifier.value,!1,this.M),ae=new z.$ikc(U,this.N),ce=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,Ce.whenReady,this.O.whenReady]).then(()=>{const K=this;let te,le;const de=(0,m.$bG)(U,"ipc")?this.f.messagePorts?.get(i.$Dm.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Ce,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ae){return L.$kc(U.extensionLocation.fsPath,Ae)},get storagePath(){return K.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return K.O.globalValue(U).fsPath},get logPath(){return L.$kc(K.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return v.URI.joinPath(K.f.logsLocation,U.identifier.value)},get storageUri(){return K.O.workspaceValue(U)},get globalStorageUri(){return K.O.globalValue(U)},get extensionMode(){return ce},get extension(){return te===void 0&&(te=new re(K,U.identifier,U,se,!1)),te},get extensionRuntime(){return(0,m.$cG)(U,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!le){if(!de)return;const Ae=y.Event.buffer(y.Event.fromDOMEventEmitter(de,"message",me=>me.data));de.start(),le={onDidReceiveMessage:Ae,postMessage:de.postMessage.bind(de)}}return le}})})}static jb(U,ie,be,Ce,ae){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,ie,be,Ce,ae).then(ce=>new C.$7jc(!1,null,ae.build(),be,ce,Ce.subscriptions))}static kb(U,ie,be,Ce,ae){if(typeof be.activate=="function")try{ae.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ce=typeof global=="object"?global:self,se=be.activate.apply(ce,[Ce]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(se).then(K=>(ae.activateResolveStop(),K))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(be)}lb(U,ie){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ie}).then(void 0,be=>{this.s.error(be)})}mb(U,ie=0){const Ce=Date.now();(0,N.$B)(()=>{for(let ae=ie;ae<U.length;ae+=1){const ce=U[ae];for(const se of ce.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-Ce>50){this.mb(U,ae);break}else this.lb(ce,se)}})}nb(){this.C.$setPerformanceMarks(O.getMarks()),this.m.getConfigProvider().then(U=>{const ie=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(ie)this.mb(be);else for(const Ce of be)if(Ce.activationEvents)for(const ae of Ce.activationEvents)ae==="onStartupFinished"&&this.lb(Ce,ae)})}ob(){const U=this.ab("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.pb(ce.added)));const ie=this.j.workspace?this.j.workspace.folders:[],be=this.pb(ie),Ce=this.rb(),ae=Promise.all([Ce,U,be]).then(()=>{});return Promise.race([ae,(0,M.$jh)(1e4)]).then(()=>{this.nb()}),ae}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.qb(U,ie))).then(()=>{})}async qb(U,ie){if(this.isActivated(ie.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Ce={logService:this.s,folders:U.map(ce=>ce.uri),forceUsingSearch:be||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,se,K)=>this.y.$checkExists(ce,se,K)},ae=await(0,D.$wvb)(Ce,ie);if(ae)return this.bb(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:ae.activationEvent}).then(void 0,ce=>this.s.error(ce))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ie}=this.f.environment;if(!U||!ie)throw new Error(u.localize(0,null));const be=await this.xb(null,ie,new C.$6jc(!1));if(!be||typeof be.run!="function")throw new Error(u.localize(1,null,ie.toString()));return new Promise((Ce,ae)=>{const ce=(te,le)=>{te?(N.$t&&this.s.error("Test runner called back with error",te),ae(te)):(N.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Ce(typeof le=="number"&&le>0?1:0))},se=(0,A.$Jg)(ie),K=be.run(se,ce);K&&K.then&&K.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),Ce(0)}).catch(te=>{N.$t&&this.s.error("Test runner finished with error",te),ae(te instanceof Error&&te.stack?te.stack:String(te))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ie){return this.S[U]=ie,(0,b.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ie}=await this.ub(U);return ie?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ie=U.indexOf("+");if(ie===-1)throw new t.$zM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,ie);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,ie){const be=j.$3d.create(!1),Ce=()=>`[resolveAuthority(${(0,f.$xl)(U)},${ie})][${be.elapsed()}ms] `,ae=V=>this.s.info(`${Ce()}${V}`),ce=V=>this.s.warn(`${Ce()}${V}`),se=(V,X=void 0)=>this.s.error(`${Ce()}${V}`,X),K=V=>{if(V instanceof t.$zM)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},te=async V=>{ae(`activating resolver for ${V}...`);const{resolver:X,authorityPrefix:Q}=await this.ub(V);if(!X)throw se(`no resolver for ${Q}`),new t.$zM(`No remote extension installed to resolve ${Q}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:Q,remoteAuthority:V}},le=U.split(/@|%40/g).reverse();ae(`activating remote resolvers ${le.join(" -> ")}`);let de;try{de=await Promise.all(le.map(te)).catch(async V=>{if(!(V instanceof t.$zM)||V._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return ce(`resolving nested authorities failed: ${V.message}`),[await te(U)]})}catch(V){return K(V)}const Ae=new M.$th;Ae.cancelAndSet(()=>ae("waiting..."),1e3);let me,Ie;for(const[V,{authorityPrefix:X,resolver:Q,remoteAuthority:fe}]of de.entries())try{if(V===de.length-1)ae("invoking final resolve()..."),O.mark(`code/extHost/willResolveAuthority/${X}`),me=await Q.resolve(fe,{resolveAttempt:ie,execServer:Ie}),O.mark(`code/extHost/didResolveAuthorityOK/${X}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,t.$yM.isManagedResolvedAuthority(me)?me:void 0));else{if(ae(`invoking resolveExecServer() for ${fe}`),O.mark(`code/extHost/willResolveExecServer/${X}`),Ie=await Q.resolveExecServer?.(fe,{resolveAttempt:ie,execServer:Ie}),!Ie)throw new t.$zM(`Exec server was not available for ${fe}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);O.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(we){return O.mark(`code/extHost/didResolveAuthorityError/${X}`),se("returned an error",we),Ae.dispose(),K(we)}Ae.dispose();const Re={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures?{elevation:me.tunnelFeatures.elevation,privacyOptions:me.tunnelFeatures.privacyOptions,protocol:me.tunnelFeatures.protocol===void 0?!0:me.tunnelFeatures.protocol}:void 0},Fe={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${t.$yM.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let q;if(t.$yM.isManagedResolvedAuthority(me)){const V=ie;this.Y.setFactory(V,me.makeConnection),q={authority:U,connectTo:new f.$ul(V),connectionToken:me.connectionToken}}else q={authority:U,connectTo:new f.$vl(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:q,options:Fe,tunnelInformation:Re}}}async $getCanonicalURI(U,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$xl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const Ce=v.URI.revive(ie);if(typeof be.getCanonicalURI>"u")return Ce;const ae=await(0,M.$ah)(()=>be.getCanonicalURI(Ce));return ae||Ce}async $startExtensionHost(U){U.toAdd.forEach(ce=>ce.extensionLocation=v.URI.revive(ce.extensionLocation));const{globalRegistry:ie,myExtensions:be}=_(this.I,this.L,this.J,U),Ce=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(be),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.tb()}$activateByEvent(U,ie){return ie===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,ie){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ie),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ce=>ce.extensionLocation=v.URI.revive(ce.extensionLocation));const{globalRegistry:ie,myExtensions:be}=_(this.I,this.L,this.J,U),Ce=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(be),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ie=r.$ue.alloc(U),be=Math.random()%256;for(let Ce=0;Ce<U;Ce++)ie.writeUInt8(be,Ce);return ie}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$okc=Y,e.$okc=Y=W=Je([qe(0,d.$hi),qe(1,e.$nkc),qe(2,h.$MO),qe(3,c.$Njc),qe(4,p.$Qjc),qe(5,R.$Oj),qe(6,l.$3O),qe(7,a.$Tjc),qe(8,S.$5Bb),qe(9,w.$ckc),qe(10,T.$kkc),qe(11,B.$lkc),qe(12,E.$Djc)],Y);function _(x,U,ie,be){x.addActivationEvents(be.addActivationEvents);const Ce=new o.$h$b(x,U.getAllExtensionDescriptions());Ce.deltaExtensions(be.toAdd,be.toRemove);const ae=new i.$Em(ie.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of be.myToRemove)ae.delete(se);for(const se of be.myToAdd)ae.add(se);const ce=ee(Ce,ae);return{globalRegistry:Ce,myExtensions:ce}}function J(x,U){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function Z(x){return x.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$pkc=(0,d.$ii)("IExtHostExtensionService");class re{#e;#t;#i;constructor(U,ie,be,Ce,ae){this.#e=U,this.#t=ie,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=L.$ic((0,A.$Jg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Ce,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$qkc=re;function ee(x,U){return x.getAllExtensionDescriptions().filter(ie=>U.has(ie.identifier))}class pe{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$rkc=pe;class De{constructor(U){this.a=new i.$Fm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ie of Object.keys(U))this.a.set(ie,U[ie])}}}),define(ke[373],Ee([1,0,58,2,6,44,26,25,20,28,5,48,12,14]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;let c=class{constructor(r,s,t,f,d,l,a){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.h=l,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new o(this.c,s,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$zlc=c,e.$zlc=c=Je([qe(2,R.$hi),qe(3,A.$Qjc),qe(4,I.$pkc),qe(5,v.$3O),qe(6,p.$Oj)],c);let m=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&k.a.size){const s=(0,C.$Ze)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,f,d]=s,l=k.a.get(f);if(l!==void 0)return console.warn(`${f} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};m=k=Je([qe(0,v.$3O)],m);class o{constructor(r,s,t,f,d){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.nodeModuleName="vscode",this.a=new b.$Fm}load(r,s){const t=this.d.findSubstr(s);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((d,l)=>f+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${f}`),this.b=this.c(M.$9F,this.e,this.f)}return this.b}}let n=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(O.$rM.MainThreadTelemetry);const f=t.getProxy(O.$rM.MainThreadWindow);this.c=(d,l)=>{const a=L.URI.parse(d);return l?this.g(d,l):a.scheme==="http"||a.scheme==="https"?f.$openUri(a,d,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?f.$openUri(a,d,{}):this.g(d,l)}}load(r,s,t){const f=this.e.findSubstr(s);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,$.$MO)],n)}),define(ke[60],Ee([1,0,45,3,17,50,5,72,71,48,7,43,299,44]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=e.$skc=void 0,e.$skc=(0,M.$ii)("IExtHostVariableResolverProvider");class k extends p.$OP{constructor(o,n,i,r,s,t,f){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const a=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof R.$dO||a.input instanceof R.$iO)return a.input.modified;if(a.input instanceof R.$cO||a.input instanceof R.$hO||a.input instanceof R.$fO)return a.input.uri}}}super({getFolderUri:l=>{const a=t.folders.filter(h=>h.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,a)=>s.getConfiguration(void 0,l).get(a),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return O.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=d();if(l){const a=n.getWorkspaceFolder(l);if(a)return O.$ic(a.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(A.env))}}let c=class extends L.$Uc{constructor(o,n,i,r,s){super(),this.b=o,this.c=n,this.g=i,this.h=r,this.j=s,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$tkc=c,e.$tkc=c=Je([qe(0,v.$pkc),qe(1,I.$Njc),qe(2,b.$XO),qe(3,C.$Qjc),qe(4,$.$3jc)],c)}),define(ke[96],Ee([1,0,8,4,2,25,5,6,71,48,20,7,43,143,291,44,60,3,56,33,16]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=e.$xkc=e.$wkc=e.$vkc=e.$ukc=void 0,e.$ukc=(0,M.$ii)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(g,S,w,E,y,D,P){this.N=S,this.O=w,this.P=E,this.Q=y,this.R=D,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new L.$7d,this.o=new L.$7d,this.q=new L.$7d,this.w=new L.$7d,this.l=g.getProxy(b.$rM.MainThreadDebugService),this.A=new L.$7d,this.C=new L.$7d,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(z=>{z.onDidChange(F=>{this.V(z)}),this.V(z)})}async $getVisualizerTreeItem(g,S){const w=this.W(S);if(!w)return;const E=await this.H.get(g)?.getTreeItem?.(w);return E?this.U(g,E):void 0}registerDebugVisualizationTree(g,S,w){const E=A.$Dm.toKey(g.identifier),y=this.jb(E,S);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${S}' is already registered`);return this.H.set(y,w),this.l.$registerDebugVisualizerTree(y,!!w.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(S)})}async $getVisualizerTreeItemChildren(g,S){const w=this.J.get(S)?.item;return w?(await this.H.get(g)?.getChildren?.(w))?.map(y=>this.U(g,y))||[]:[]}async $editVisualizerTreeItem(g,S){const w=this.J.get(g);if(!w)return;const E=await this.H.get(w.provider)?.editItem?.(w.item,S);return this.U(w.provider,E||w.item)}$disposeVisualizedTree(g){const S=this.J.get(g);if(!S)return;const w=[S.children];for(const E of w)if(E)for(const y of E)w.push(this.J.get(y)?.children),this.J.delete(y)}U(g,S){let w=this.I.get(S);return w||(w=this.F++,this.I.set(S,w),this.J.set(w,{provider:g,item:S})),r.DebugTreeItem.from(S,w)}asDebugSourceUri(g,S){const w=g;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let E=`debug:${encodeURIComponent(w.path||"")}`,y="?";return S&&(E+=`${y}session=${encodeURIComponent(S.id)}`,y="&"),E+=`${y}ref=${w.sourceReference}`,O.URI.parse(E)}else{if(w.path)return O.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(g){const S=[];for(const w of g.getAllExtensionDescriptions())if(w.contributes){const E=w.contributes.debuggers;if(E&&E.length>0)for(const y of E)(0,k.$OG)(y)&&S.push(y.type)}this.l.$registerDebugTypes(S)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const g=[];return this.z.forEach(S=>g.push(S)),g}async $resolveDebugVisualizer(g,S){const w=this.L.get(g);if(!w)throw new Error(`No debug visualizer found with id '${g}'`);let{v:E,provider:y,extensionId:D}=w;if(E.visualization||(E=await y.resolveDebugVisualization?.(E,S)||E,w.v=E),!E.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(D,E.visualization)}async $executeDebugVisualizerCommand(g){const S=this.L.get(g);if(!S)throw new Error(`No debug visualizer found with id '${g}'`);const w=S.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(g){const S=this.m.get(g.sessionId);return S&&{session:S.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,S,w,E){const y=this.W(w),D=this.jb(g,S),P=this.G.get(D);if(!y||!P)return[];const z=await P.provideDebugVisualization(y,E);return z?z.map(F=>{const T=++this.M;this.L.set(T,{v:F,provider:P,extensionId:g});const j=F.iconPath?this.lb(F.iconPath):void 0;return{id:T,name:F.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.kb(g,F.visualization)}}):[]}$disposeDebugVisualizers(g){for(const S of g)this.L.delete(S)}registerDebugVisualizationProvider(g,S,w){if(!g.contributes?.debugVisualizers?.some(D=>D.id===S))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${S})`);const E=A.$Dm.toKey(g.identifier),y=this.jb(E,S);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${S}' is already registered`);return this.G.set(y,w),this.l.$registerDebugVisualizer(E,S),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(E,S),this.G.delete(S)})}addBreakpoints(g){const S=g.filter(y=>{const D=y.id;return this.z.has(D)?!1:(this.z.set(D,y),!0)});this.gb(S,[],[]);const w=[],E=new Map;for(const y of S)if(y instanceof I.$uN){let D=E.get(y.location.uri.toString());D||(D={type:"sourceMulti",uri:y.location.uri,lines:[]},E.set(y.location.uri.toString(),D),w.push(D)),D.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof I.$vN&&w.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(g){const S=g.filter(D=>this.z.delete(D.id));this.gb([],S,[]);const w=S.filter(D=>D instanceof I.$uN).map(D=>D.id),E=S.filter(D=>D instanceof I.$vN).map(D=>D.id),y=S.filter(D=>D instanceof I.$wN).map(D=>D.id);return this.l.$unregisterBreakpoints(w,E,y)}startDebugging(g,S,w){return this.l.$startDebugging(g?g.uri:void 0,S,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(g){return this.l.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,S,w){if(!S)return new I.$tM(()=>{});const E=this.d++;return this.f.push({type:g,handle:E,provider:S}),this.l.$registerDebugConfigurationProvider(g,w,!!S.provideDebugConfigurations,!!S.resolveDebugConfiguration,!!S.resolveDebugConfigurationWithSubstitutedVariables,E),new I.$tM(()=>{this.f=this.f.filter(y=>y.provider!==S),this.l.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(g,S,w){if(!w)return new I.$tM(()=>{});if(!this.cb(g,S))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${S}' debugger.`);if(this.$(S))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.g++;return this.h.push({type:S,handle:E,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(S,E),new I.$tM(()=>{this.h=this.h.filter(y=>y.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(g,S){if(!S)return new I.$tM(()=>{});const w=this.j++;return this.k.push({type:g,handle:w,factory:S}),new I.$tM(()=>{this.k=this.k.filter(E=>E.factory!==S)})}async $runInTerminal(g,S){return Promise.resolve(void 0)}async $substituteVariables(g,S){let w;const E=await this.ib(g);return E&&(w={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,S)}X(g,S){if(g.type==="implementation")return new l(g.implementation)}Y(){}async $startDASession(g,S){const w=this,E=await this.hb(S);return this.eb(this.$(E.type),E).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const D=this.Z(y),P=this.X(D,E);if(!P)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const z=P;return this.D.set(g,z),this.db(E).then(F=>(F&&this.E.set(g,F),z.onMessage(async T=>{if(T.type==="request"&&T.command==="handshake"){const j=T,N={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(j.arguments.value);N.body={signature:B},z.sendResponse(N)}else throw new Error("no signer")}catch(B){N.success=!1,N.message=B.message,z.sendResponse(N)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(T),T=(0,k.$TG)(T,!0),w.l.$acceptDAMessage(g,T)}),z.onError(T=>{F&&F.onError&&F.onError(T),this.l.$acceptDAError(g,T.name,T.message,T.stack)}),z.onExit(T=>{F&&F.onExit&&F.onExit(T??void 0,void 0),this.l.$acceptDAExit(g,T??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),z.startSession()))})}$sendDAMessage(g,S){S=(0,k.$SG)(S,!1);const w=this.E.get(g);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(S),this.D.get(g)?.sendMessage(S)}$stopDASession(g){const S=this.E.get(g);this.E.delete(g),S&&S.onWillStopSession&&S.onWillStopSession();const w=this.D.get(g);return this.D.delete(g),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const S=[],w=[],E=[];if(g.added)for(const y of g.added){const D=y.id;if(D&&!this.z.has(D)){let P;if(y.type==="function")P=new I.$vN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")P=new I.$wN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const z=O.URI.revive(y.uri);P=new I.$uN(new I.$FM(z,new I.$uM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,I.$sN)(P,D),this.z.set(D,P),S.push(P)}}if(g.removed)for(const y of g.removed){const D=this.z.get(y);D&&(this.z.delete(y),w.push(D))}if(g.changed){for(const y of g.changed)if(y.id){const D=this.z.get(y.id);if(D){if(D instanceof I.$vN&&y.type==="function"){const P=D;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.functionName=y.functionName}else if(D instanceof I.$uN&&y.type==="source"){const P=D;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.location=new I.$FM(O.URI.revive(y.uri),new I.$uM(y.line,y.character))}E.push(D)}}}this.gb(S,w,E)}async $acceptStackFrameFocus(g){let S;if(g){const w=await this.hb(g.sessionId);g.kind==="thread"?S=new I.$CN(w.api,g.threadId):S=new I.$BN(w.api,g.threadId,g.frameId)}this.B=S,this.C.fire(this.B)}$provideDebugConfigurations(g,S,w){return(0,u.$ah)(async()=>{const E=this.bb(g);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(S);return E.provideDebugConfigurations(y,w)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(g,S,w,E){return(0,u.$ah)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.ib(S);return y.resolveDebugConfiguration(D,w,E)})}$resolveDebugConfigurationWithSubstitutedVariables(g,S,w,E){return(0,u.$ah)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.ib(S);return y.resolveDebugConfigurationWithSubstitutedVariables(D,w,E)})}async $provideDebugAdapter(g,S){const w=this.ab(g);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.hb(S);return this.eb(w,E).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(g){const S=await this.hb(g);this.n.fire(S.api)}async $acceptDebugSessionTerminated(g){const S=await this.hb(g);S&&(this.o.fire(S.api),this.m.delete(S.id))}async $acceptDebugSessionActiveChanged(g){this.u=g?await this.hb(g):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(g,S){(await this.hb(g))?._acceptNameChanged(S)}async $acceptDebugSessionCustomEvent(g,S){const E={session:(await this.hb(g)).api,event:S.event,body:S.body};this.w.fire(E)}Z(g){if(g instanceof I.$xN)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof I.$yN)return{type:"server",port:g.port,host:g.host};if(g instanceof I.$zN)return{type:"pipeServer",path:g.path};if(g instanceof I.$AN)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}$(g){const S=this.h.filter(w=>w.type===g);if(S.length>0)return S[0].factory}ab(g){const S=this.h.filter(w=>w.handle===g);if(S.length>0)return S[0].factory}bb(g){const S=this.f.filter(w=>w.handle===g);if(S.length>0)return S[0].provider}cb(g,S){if(g.contributes){const w=g.contributes.debuggers;if(w&&w.length>0){for(const E of w)if(E.label&&E.type&&E.type===S)return!0}}return!1}db(g){const w=g.configuration.type,E=this.k.filter(y=>y.type===w||y.type==="*").map(y=>(0,u.$ah)(()=>y.factory.createDebugAdapterTracker(g.api)).then(D=>D,D=>null));return Promise.race([Promise.all(E).then(y=>{const D=y.filter(P=>!!P);if(D.length>0)return new d(D)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(g,S){const w=S.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new I.$yN(w));if(g){const y=await this.O.getExtensionRegistry();return(0,u.$ah)(()=>g.createDebugAdapterDescriptor(S.api,this.fb(S,y))).then(D=>{if(D)return D})}const E=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(S,E))}fb(g,S){}gb(g,S,w){(g.length>0||S.length>0||w.length>0)&&this.A.fire(Object.freeze({added:g,removed:S,changed:w}))}async hb(g){if(g)if(typeof g=="string"){const S=this.m.get(g);if(S)return S}else{let S=this.m.get(g.id);if(!S){const w=await this.ib(g.folderUri),E=g.parent?this.m.get(g.parent):void 0;S=new t(this.l,g.id,g.type,g.name,w,g.configuration,E?.api),this.m.set(S.id,S),this.l.$sessionCached(S.id)}return S}throw new Error("cannot find session")}ib(g){if(g){const S=O.URI.revive(g);return this.N.resolveWorkspaceFolder(S)}return Promise.resolve(void 0)}jb(g,S){return`${g}\0${S}`}kb(g,S){if(S){if("title"in S&&"command"in S)return{type:0};if("treeId"in S)return{type:1,id:`${g}\0${S.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(g){const S=this.mb(g);let w,E;return"id"in S?E=n.ThemeIcon.asClassName(S):w=S,{iconPath:w,iconClass:E}}mb(g){if(g instanceof I.$pN)return{id:g.id};const S=typeof g=="object"&&"dark"in g?g.dark:g,w=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof S=="string"?O.URI.file(S):S,light:typeof w=="string"?O.URI.file(w):w}}};e.$vkc=s,e.$vkc=s=Je([qe(0,R.$MO),qe(1,p.$Njc),qe(2,v.$pkc),qe(3,c.$Qjc),qe(4,$.$3jc),qe(5,m.$skc),qe(6,i.$9O)],s);class t{constructor(g,S,w,E,y,D,P){this.f=g,this.g=S,this.h=w,this.j=E,this.k=y,this.l=D,this.m=P}get api(){const g=this;return this.d??=Object.freeze({id:g.g,type:g.h,get name(){return g.j},set name(S){g.j=S,g.f.$setDebugSessionName(g.g,S)},parentSession:g.m,workspaceFolder:g.k,configuration:g.l,customRequest(S,w){return g.f.$customDebugAdapterRequest(g.g,S,w)},getDebugProtocolBreakpoint(S){return g.f.$getDebugProtocolBreakpoint(g.g,S.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(g){this.j=g}get configuration(){return this.l}}e.$wkc=t;class f{constructor(g){this.value=Object.freeze({append(S){g.$appendDebugConsole(S)},appendLine(S){this.append(S+`
`)}})}}e.$xkc=f;class d{constructor(g){this.d=g}onWillStartSession(){this.d.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.d.forEach(S=>S.onWillReceiveMessage?S.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.d.forEach(S=>S.onDidSendMessage?S.onDidSendMessage(g):void 0)}onWillStopSession(){this.d.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.d.forEach(S=>S.onError?S.onError(g):void 0)}onExit(g,S){this.d.forEach(w=>w.onExit?w.onExit(g,S):void 0)}}class l extends C.$Gob{constructor(g){super(),this.h=g,g.onDidSendMessage(S=>{this.acceptMessage(S)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.h.handleMessage(g)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends s{constructor(g,S,w,E,y,D,P){super(g,S,w,E,y,D,P)}};e.$ykc=a,e.$ykc=a=Je([qe(0,R.$MO),qe(1,p.$Njc),qe(2,v.$pkc),qe(3,c.$Qjc),qe(4,$.$3jc),qe(5,m.$skc),qe(6,i.$9O)],a)}),define(ke[374],Ee([1,0,13,58,2,6,320,12,84,107,28,256,20,66,48,90]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0;class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(b.$Oj),t=i.get(p.$MO).getProxy(A.$rM.MainThreadErrors);u.setUnexpectedErrorHandler(f=>{r.error(f);const d=u.$3(f);t.$onUnexpectedError(d)})}static async installFullHandler(i){const r=i.get(b.$Oj),s=i.get(p.$MO),t=i.get(k.$pkc),f=i.get(c.$7O),d=s.getProxy(A.$rM.MainThreadExtensionService),l=s.getProxy(A.$rM.MainThreadErrors),a=await t.getExtensionPathIndex(),h=new WeakMap;function g(E,y){if(h.has(E))return h.get(E).stack;let D="",P,z;for(const T of y)D+=`
	at ${T.toString()}`,z=T.getFileName(),!P&&z&&(P=a.findSubstr(O.URI.file(z)));const F=`${E.name||"Error"}: ${E.message||""}${D}`;return h.set(E,{extensionIdentifier:P?.identifier,stack:F}),F}const S=Symbol("prepareStackTrace wrapped");let w=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(E){if(E===g||!E||E[S]){w=E||g;return}w=function(y,D){return g(y,D),E.call(Error,y,D)},Object.assign(w,{[S]:!0})}}),u.setUnexpectedErrorHandler(E=>{r.error(E);const y=u.$3(E),D=h.get(E);if(!D?.extensionIdentifier){l.$onUnexpectedError(y);return}d.$onExtensionRuntimeError(D.extensionIdentifier,y);const P=f.onExtensionError(D.extensionIdentifier,E);r.trace("forwarded error to extension?",P,D)})}}e.$Alc=m;class o{constructor(i,r,s,t,f){this.a=s,this.b=new M.$p$b(i,null,t),r=o.e(r,this.b);const d=new v.$gi(...(0,$.$hs)());d.set(R.$3O,{_serviceBrand:void 0,...r,messagePorts:f}),d.set(p.$MO,new p.$NO(this.b)),d.set(C.$Kjc,new C.$Ljc(t)),d.set(k.$nkc,s);const l=new I.$Yq(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(a=>a.get(b.$Oj)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(a=>a.get(k.$pkc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(A.$rM.MainThreadExtensionService);return O.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=O.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=O.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>O.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=O.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=O.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=O.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=O.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=O.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=O.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$Blc=o}),define(ke[375],Ee([1,0,8,11,230,249,141,96,71,48,20,47,7,60,43,292,293,44,33,376]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;let r=class extends b.$vkc{constructor(a,h,g,S,w,E,y,D){super(a,h,g,S,E,y,D),this.pb=w,this.nb=new d}X(a,h){switch(a.type){case"server":return new c.$Glc(a);case"pipeServer":return new c.$Hlc(a);case"executable":return new c.$Ilc(a,h.type)}return super.X(a,h)}fb(a,h){const g=c.$Ilc.platformAdapterExecutable(h.getAllExtensionDescriptions(),a.type);if(g)return new p.$xN(g.command,g.args,g.options)}Y(){return new M.$dcc}async $runInTerminal(a,h){if(a.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(N=>{this.nb.onTerminalClosed(N)}));const g=await this.P.getConfigProvider(),S=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),E=a.title||O.localize(0,null),y=s(S,w,a);let D=await this.nb.checkout(y,E,!0),P,z=!1;if(D)P=a.cwd;else{const N={shellPath:S,shellArgs:w,cwd:a.cwd,name:E,iconPath:new p.$pN("debug"),env:a.env};z=!0,D=this.pb.createTerminalFromOptions(N,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(D,y)}D.show(!0);const F=await D.processId;z?await new Promise(N=>setTimeout(N,1e3)):(D.state.isInteractedWith&&D.sendText(""),g.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?D.sendText("cls"):S.indexOf("bash")>=0?D.sendText("clear"):L.$i?D.sendText("cls"):D.sendText("clear")));const T=(0,m.$Klc)(S,a.args,!!a.argsCanBeInterpretedByShell,P);D.sendText(T);const j=this.onDidTerminateDebugSession(N=>{N.id===h&&(this.nb.free(D),j.dispose())});return F}else if(a.kind==="external")return f(a,await this.P.getConfigProvider());return super.$runInTerminal(a,h)}};e.$Llc=r,e.$Llc=r=Je([qe(0,R.$MO),qe(1,k.$Njc),qe(2,v.$pkc),qe(3,o.$Qjc),qe(4,I.$ckc),qe(5,$.$3jc),qe(6,C.$skc),qe(7,n.$9O)],r);function s(l,a,h){const g=(0,i.createHash)("sha256");return g.update(JSON.stringify({shell:l,shellArgs:a})),g.update(JSON.stringify(Object.entries(h.env||{}).sort(([S],[w])=>S.localeCompare(w)))),g.digest("base64")}let t;function f(l,a){if(!t)if(L.$i)t=new A.$1ac;else if(L.$j)t=new A.$2ac;else if(L.$k)t=new A.$3ac;else throw new Error("external terminals not supported on this platform");const h=a.getConfiguration("terminal");return t.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}class d{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,h,g=!1){const w=[...this.b.entries()].map(([E,y])=>(0,u.$8g)(async D=>{if(E.name!==h||y.lastUsedAt!==-1&&await(0,m.$Jlc)(await E.processId))return null;const P=Date.now();return y.lastUsedAt+d.a>P||D.isCancellationRequested?null:y.config!==a?(g&&E.dispose(),null):(y.lastUsedAt=P,E)}));return await(0,u.$nh)(w,E=>!!E)}insert(a,h){this.b.set(a,{lastUsedAt:Date.now(),config:h})}free(a){const h=this.b.get(a);h&&(h.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(ke[377],Ee([1,0,17,2,105,43,72,44,42,47,20,28,95,15,12,91,23,63,60]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;let i=class extends p.$flc{constructor(s,t,f,d,l,a,h,g,S){super(s,t,f,d,l,a,h,g),this.C=f,this.D=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const d=p.TaskHandleDTO.from(f,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.z(l,t);return this.a.$executeTask(d).catch(()=>{}),a}else{const d=p.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const l=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}v(s,t,f,d){const l=[];if(d)for(const a of d){this.A(a,f),(!a.definition||!s[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const h=p.TaskDTO.from(a,f.extension);h&&(l.push(h),p.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,a,!0)))}return{tasks:l,extension:f.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const f=L.URI.file((0,o.homedir)());t=new $.$Ci({uri:f,name:m.$Sg(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const f=L.URI.revive(s),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(f),a=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),g=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(a);for(const S of t.variables)d.variables[S]=await h.resolveAsync(g,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(u.$uc);for(let w=0;w<S.length;w++)S[w]=await h.resolveAsync(g,S[w])}d.process=await O.win32.findExecutable(await h.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(g,t.process.cwd):void 0,S)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,f){return O.win32.findExecutable(s,t,f)}};e.$Dlc=i,e.$Dlc=i=Je([qe(0,R.$MO),qe(1,I.$3O),qe(2,A.$Njc),qe(3,M.$XO),qe(4,b.$Qjc),qe(5,v.$ckc),qe(6,k.$Oj),qe(7,c.$ojc),qe(8,n.$skc)],i)}),define(ke[378],Ee([1,0,63,60]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;class O extends L.$tkc{m(){return(0,u.homedir)()}}e.$jmc=O}),define(ke[158],Ee([1,0,19,8,22,46,15,17,23,2,36]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Nkc=e.$Mkc=void 0,e.$Okc=c;class I{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],s=new O.$ee(i);return new Promise((t,f)=>{this.a=new C(n);let d=!1;const l=(a,h)=>{if(!d&&!this.b){const g=this.h(a);c(a)&&typeof this.g.maxResults=="number"&&this.c+g>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),a=this.j(a,this.g.maxResults-this.c));const S=this.h(a);this.c+=S,(S>0||!c(a))&&this.a.add(a,h)}};Promise.all(r.map((a,h)=>this.k(a,g=>l(g,h),s.token))).then(a=>{s.dispose(),this.a.flush();const h=a.some(g=>!!g&&!!g.limitHit);t({limitHit:this.b||h,messages:(0,u.$Rb)(a.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.f}})},a=>{s.dispose();const h=(0,A.$6i)(a);f(new Error(h))})})}h(n){return c(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const s=new R.$YK(this.g,n),t=[],f={report:a=>{if(!this.l(a))return;const h=n.folder.scheme===M.Schemas.file?(0,R.$ZK)(()=>this.e.readdir($.$Ug(a.uri))):void 0,g=$.$Xg(n.folder,a.uri);if(g){const S=s.includedInQuery(g,b.$oc(g),h);(0,L.$7g)(S)?t.push(S.then(w=>{w&&i(a)})):S&&i(a)}}},d=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,f,r):l=await this.d.provider.provideTextSearchResults(p(this.d.query.contentPattern),d,f,r),t.length&&await Promise.all(t),l}l(n){if(c(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,R.$XK)(this.g.includePattern,n.includePattern),r=(0,R.$XK)(this.g.excludePattern,n.excludePattern),s={folder:v.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$Mkc=I;function p(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class C{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$Og(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(k(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Nkc=C;function k(o){return c(o)?{preview:{matches:(0,u.$2b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,u.$2b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function c(o){return!!o.preview}class m{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Pkc=m}),define(ke[97],Ee([1,0,3,6,5,370,20,66,12,2,158]),function(he,e,u,L,O,A,M,b,$,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0,e.$Skc=p,e.$Qkc=(0,O.$ii)("IExtHostSearch");let I=class{constructor(c,m,o){this.n=c,this.o=m,this.q=o,this.c=this.n.getProxy(L.$rM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$Lkc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,m){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const o=this.d++;return this.e.set(o,m),this.c.$registerTextSearchProvider(o,this.s(c)),(0,u.$Sc)(()=>{this.g.delete(c),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(c,m){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const o=this.d++;return this.h.set(o,m),this.c.$registerAITextSearchProvider(o,this.s(c)),(0,u.$Sc)(()=>{this.i.delete(c),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(c,m){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const o=this.d++;return this.j.set(o,m),this.c.$registerFileSearchProvider(o,this.s(c)),(0,u.$Sc)(()=>{this.k.delete(c),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(c,m,o,n){const i=p(o),r=this.j.get(c);if(r)return this.l.fileSearch(i,r,s=>{this.c.$handleFileMatch(c,m,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,m,o){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,m,o,n){const i=this.e.get(c);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${c}`);const r=p(o);return this.t(r,i).search(t=>this.c.$handleTextMatch(c,m,t),n)}$provideAITextSearchResults(c,m,o,n){const i=this.h.get(c);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${c}`);const r=p(o);return this.v(r,i).search(t=>this.c.$handleTextMatch(c,m,t),n)}$enableExtensionHostSearch(){}t(c,m){return new R.$Mkc({query:c,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(c,m){return new R.$Mkc({query:c,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Rkc=I,e.$Rkc=I=Je([qe(0,M.$MO),qe(1,b.$Kjc),qe(2,$.$Oj)],I);function p(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(C),extraFileResources:k.extraFileResources&&k.extraFileResources.map(c=>v.URI.revive(c))}}function C(k){return{...k,folder:v.URI.revive(k.folder)}}}),define(ke[379],Ee([1,0,22,13,4,3,15,40,2,135,197,178,79,25,32,12,86,87,275,6,322,349,91,120,327,308,328,121,329,309,297,33,330,44,331,96,151,332,311,323,333,334,72,71,324,48,335,69,336,59,28,350,351,325,312,337,338,115,116,313,369,340,281,341,352,342,156,314,343,344,345,20,346,97,117,347,315,348,118,93,95,90,47,353,354,326,355,356,70,16,7,316,66,317,92,357,358,150,43,290,114,26,94]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f,d,l,a,h,g,S,w,E,y,D,P,z,F,T,j,N,B,W,Y,_,J,Z,re,ee,pe,De,x,U,ie,be,Ce,ae,ce,se,K,te,le,de,Ae,me,Ie,Re,Fe,q,V,X,Q,fe,we,Te,He,xe,it,rt,at,ot,Se,Be,Ge,Me,Qe,oe,ue,Pe,Ke,_e,Ne,lt,wt,At,zt,Qt,_t,Ct,Xt,qt,ai,tt,ei){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=ti;function ti(ft){const bt=ft.get(x.$3O),si=ft.get(De.$sjc),ii=ft.get(ee.$Sjc),jt=ft.get(Z.$pkc),mt=ft.get(Xt.$Njc),Rt=ft.get(Be.$7O),Ht=ft.get(D.$Qjc),Zt=ft.get(wt.$Kjc),Ze=ft.get(fe.$MO),Yt=ft.get(at.$_jc),Bt=ft.get(ot.$Tjc),Ut=ft.get(c.$Pj),$t=ft.get(c.$Oj),Ft=ft.get(Ke.$5Bb),Mt=ft.get(t.$ojc),Tt=ft.get(Ct.$ulc),ni=ft.get(He.$hkc),oi=ft.get(_.$3jc),Wt=ft.get(K.$lkc),It=ft.get(f.$yjc),St=ft.get(h.$Djc);Ze.set(i.$sM.ExtHostFileSystemInfo,si),Ze.set(i.$sM.ExtHostLogLevelServiceShape,Ut),Ze.set(i.$sM.ExtHostWorkspace,mt),Ze.set(i.$sM.ExtHostConfiguration,Ht),Ze.set(i.$sM.ExtHostExtensionService,jt),Ze.set(i.$sM.ExtHostStorage,Yt),Ze.set(i.$sM.ExtHostTunnelService,Ft),Ze.set(i.$sM.ExtHostWindow,Tt),Ze.set(i.$sM.ExtHostSecretState,ni),Ze.set(i.$sM.ExtHostTelemetry,Rt),Ze.set(i.$sM.ExtHostEditorTabs,oi),Ze.set(i.$sM.ExtHostManagedSockets,Wt),Ze.set(i.$sM.ExtHostAuthentication,It),Ze.set(i.$sM.ExtHostChatProvider,St);const Gt=Ze.set(i.$sM.ExtHostDecorations,ft.get(F.$Akc)),Pt=Ze.set(i.$sM.ExtHostDocumentsAndEditors,ft.get(Y.$XO)),yt=Ze.set(i.$sM.ExtHostCommands,ft.get(E.$9O)),Dt=Ze.set(i.$sM.ExtHostTerminalService,ft.get(Ge.$ckc)),Et=Ze.set(i.$sM.ExtHostDebugService,ft.get(z.$ukc)),ui=Ze.set(i.$sM.ExtHostSearch,ft.get(Te.$Qkc)),ri=Ze.set(i.$sM.ExtHostTask,ft.get(Se.$hlc)),li=Ze.set(i.$sM.ExtHostOutputService,ft.get(Fe.$7kc)),di=Ze.set(i.$sM.ExtHostLocalization,ft.get(se.$kkc)),xt=Ze.set(i.$sM.ExtHostUrls,new At.$rlc(Ze)),Ot=Ze.set(i.$sM.ExtHostDocuments,new W.$vjc(Ze,Pt)),Oe=Ze.set(i.$sM.ExtHostDocumentContentProviders,new N.$Ckc(Ze,Pt,$t)),ze=Ze.set(i.$sM.ExtHostDocumentSaveParticipant,new B.$Dkc($t,Ot,Ze.getProxy(i.$rM.MainThreadBulkEdits))),ve=Ze.set(i.$sM.ExtHostNotebook,new le.$Tkc(Ze,yt,Pt,Ot,ii,ui)),ne=Ze.set(i.$sM.ExtHostNotebookDocuments,new Ae.$1kc(ve)),Le=Ze.set(i.$sM.ExtHostNotebookEditors,new me.$2kc($t,ve)),Ve=Ze.set(i.$sM.ExtHostNotebookKernels,new Ie.$3kc(Ze,bt,ve,yt,$t)),et=Ze.set(i.$sM.ExtHostNotebookRenderers,new Re.$5kc(Ze,ve)),Xe=Ze.set(i.$sM.ExtHostNotebookDocumentSaveParticipant,new de.$Zkc($t,ve,Ze.getProxy(i.$rM.MainThreadBulkEdits))),ct=Ze.set(i.$sM.ExtHostEditors,new Qe.$Hjc(Ze,Pt)),kt=Ze.set(i.$sM.ExtHostTreeViews,new Pe.$plc(Ze.getProxy(i.$rM.MainThreadTreeViews),yt,$t)),Kt=Ze.set(i.$sM.ExtHostEditorInsets,new w.$Ijc(Ze.getProxy(i.$rM.MainThreadEditorInsets),ct,bt.remote)),Vt=Ze.set(i.$sM.ExtHostDiagnostics,new T.$ujc(Ze,$t,si,Pt)),Lt=Ze.set(i.$sM.ExtHostLanguages,new ce.$Xkc(Ze,Ot,yt.converter,Zt)),ht=Ze.set(i.$sM.ExtHostLanguageFeatures,new ae.$wjc(Ze,Zt,Ot,yt,Vt,$t,Mt,Rt)),Pi=Ze.set(i.$sM.ExtHostFileSystem,new re.$Fkc(Ze,ht)),gi=Ze.set(i.$sM.ExtHostFileSystemEventService,new pe.$Gkc(Ze,$t,Pt)),$i=Ze.set(i.$sM.ExtHostQuickOpen,(0,Q.$$kc)(Ze,mt,yt)),vi=Ze.set(i.$sM.ExtHostSCM,new we.$alc(Ze,yt,Ot,$t)),Ai=Ze.set(i.$sM.ExtHostQuickDiff,new X.$0kc(Ze,Zt)),Ri=Ze.set(i.$sM.ExtHostShare,new xe.$blc(Ze,Zt)),Wi=Ze.set(i.$sM.ExtHostComments,(0,y.$Jjc)(Ze,yt,Ot)),Vi=Ze.set(i.$sM.ExtHostProgress,new V.$9kc(Ze.getProxy(i.$rM.MainThreadProgress))),qi=Ze.set(i.$sM.ExtHostLabelService,new Ce.$Wkc(Ze)),yi=Ze.set(i.$sM.ExtHostTheming,new oe.$mlc(Ze)),Mi=Ze.set(i.$sM.ExtHostTimeline,new ue.$olc(Ze,yt)),ki=Ze.set(i.$sM.ExtHostWebviews,new zt.$Xjc(Ze,bt.remote,mt,$t,Mt)),Ei=Ze.set(i.$sM.ExtHostWebviewPanels,new Qt.$1jc(Ze,ki,mt)),Hi=Ze.set(i.$sM.ExtHostCustomEditors,new P.$2jc(Ze,Ot,Bt,ki,Ei)),Gi=Ze.set(i.$sM.ExtHostWebviewViews,new _t.$slc(Ze,ki)),bi=Ze.set(i.$sM.ExtHostTesting,new Me.$ilc(Ze,$t,yt,Pt)),Ki=Ze.set(i.$sM.ExtHostUriOpeners,new lt.$qlc(Ze)),gn=Ze.set(i.$sM.ExtHostProfileContentHandlers,new q.$8kc(Ze));Ze.set(i.$sM.ExtHostInteractive,new ie.$Ukc(Ze,ve,Pt,yt,$t));const mn=Ze.set(i.$sM.ExtHostInlineChat,new U.$Hkc(Ze,yt,Ot,$t)),Ci=Ze.set(i.$sM.ExtHostChatAgents2,new a.$Cjc(Ze,$t,yt)),Oi=Ze.set(i.$sM.ExtHostChatVariables,new g.$Fjc(Ze)),Ji=Ze.set(i.$sM.ExtHostChat,new l.$Bjc(Ze)),Qi=Ze.set(i.$sM.ExtHostAiRelatedInformation,new r.$njc(Ze)),Xi=Ze.set(i.$sM.ExtHostAiEmbeddingVector,new J.$Ekc(Ze)),Zi=Ze.set(i.$sM.ExtHostIssueReporter,new be.$Vkc(Ze)),Si=Ze.set(i.$sM.ExtHostStatusBar,new rt.$elc(Ze,yt.converter)),Yi=Ze.set(i.$sM.ExtHostSpeech,new it.$clc(Ze)),xi=Object.values(i.$sM);Ze.assertRegistered(xi);const _i=new d.$Ajc(Ze,Pt),$n=new S.$Gjc(Ze),wi=new te.$Ykc(Ze,$t),Li=new j.$Bkc(Ze);return s.$xjc.register(yt),function(Ue,ci,en){function st(ge){return(ye,We,ut)=>{const vt=ge(Nt=>{try{ye.call(We,Nt)}catch(zi){L.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${zi.toString()}`,{cause:zi})),Rt.onExtensionError(Ue.identifier,zi)}});return ut?.push(vt),vt}}const pt=function(){let ge=!Ue.isUnderDevelopment;function ye(){ge||($t.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function We(ut){if(Array.isArray(ut))ut.forEach(We);else if(typeof ut=="string")ye();else{const vt=ut;typeof vt.scheme>"u"&&ye(),typeof vt.exclusive=="boolean"&&(0,tt.$cG)(Ue,"documentFiltersExclusive")}return ut}}(),tn={getSession(ge,ye,We){return typeof We?.forceNewSession=="object"&&We.forceNewSession.learnMore&&(0,tt.$cG)(Ue,"authLearnMore"),It.getSession(Ue,ge,ye,We)},getSessions(ge,ye){return(0,tt.$cG)(Ue,"authGetSessions"),It.getSessions(Ue,ge,ye)},async hasSession(ge,ye){return(0,tt.$cG)(Ue,"authSession"),!!await It.getSession(Ue,ge,ye,{silent:!0})},get onDidChangeSessions(){return st(It.onDidChangeSessions)},registerAuthenticationProvider(ge,ye,We,ut){return It.registerAuthenticationProvider(ge,ye,We,ut)}},nn={registerCommand(ge,ye,We){return yt.registerCommand(!0,ge,ye,We,void 0,Ue)},registerTextEditorCommand(ge,ye,We){return yt.registerCommand(!0,ge,(...ut)=>{const vt=ct.getActiveTextEditor();if(!vt){$t.warn("Cannot execute "+ge+" because there is no active text editor.");return}return vt.edit(Nt=>{ye.apply(We,[vt,Nt,...ut])}).then(Nt=>{Nt||$t.warn("Edits from command "+ge+" were not applied.")},Nt=>{$t.warn("An error occurred while running command "+ge,Nt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ge,ye,We)=>((0,tt.$cG)(Ue,"diffCommand"),yt.registerCommand(!0,ge,async(...ut)=>{const vt=Pt.activeEditor(!0);if(!vt){$t.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Nt=await ct.getDiffInformation(vt.id);ye.apply(We,[Nt,...ut])},void 0,void 0,Ue)),executeCommand(ge,...ye){return yt.executeCommand(ge,...ye)},getCommands(ge=!1){return yt.getCommands(ge)}},ji={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return st(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return st(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$cG)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$cG)(Ue,"telemetry"),st(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Be.$6O)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ye){return Be.$5O.validateSender(ge),Rt.instantiateLogger(Ue,ge,ye)},openExternal(ge,ye){return Tt.openUri(ge,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===bt.environment.appUriScheme)return xt.createAppUri(ge);try{return await Tt.asExternalUri(ge,{allowTunneling:!!bt.remote.authority})}catch(ye){if((0,M.$rg)(ge,M.Schemas.http)||(0,M.$rg)(ge,M.Schemas.https))return ge;throw ye}},get remoteName(){return(0,m.$um)(bt.remote.authority)},get remoteAuthority(){return(0,tt.$cG)(Ue,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return st($t.onDidChangeLogLevel)},registerIssueUriRequestHandler(ge){return(0,tt.$cG)(Ue,"handleIssueUri"),Zi.registerIssueUriRequestHandler(Ue,ge)},registerIssueDataProvider(ge){return(0,tt.$cG)(Ue,"handleIssueUri"),Zi.registerIssueDataProvider(Ue,ge)},get appQuality(){return(0,tt.$cG)(Ue,"resolvers"),bt.quality},get appCommit(){return(0,tt.$cG)(Ue,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(ji);const rn={createTestController(ge,ye,We){return bi.createTestController(Ue,ge,ye,We)},createTestObserver(){return(0,tt.$cG)(Ue,"testObserver"),bi.createTestObserver()},runTests(ge){return(0,tt.$cG)(Ue,"testObserver"),bi.runTests(ge)},get onDidChangeTestResults(){return(0,tt.$cG)(Ue,"testObserver"),st(bi.onResultsChanged)},get testResults(){return(0,tt.$cG)(Ue,"testObserver"),bi.results}},Di=bt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,sn={getExtension(ge,ye){(0,tt.$bG)(Ue,"extensionsAny")||(ye=!1);const We=ci.mine.getExtensionDescription(ge);if(We)return new Z.$qkc(jt,Ue.identifier,We,Di,!1);if(ye){const ut=ci.all.getExtensionDescription(ge);if(ut)return new Z.$qkc(jt,Ue.identifier,ut,Di,!0)}},get all(){const ge=[];for(const ye of ci.mine.getAllExtensionDescriptions())ge.push(new Z.$qkc(jt,Ue.identifier,ye,Di,!1));return ge},get allAcrossExtensionHosts(){(0,tt.$cG)(Ue,"extensionsAny");const ge=new C.$Em(ci.mine.getAllExtensionDescriptions().map(We=>We.identifier)),ye=[];for(const We of ci.all.getAllExtensionDescriptions()){const ut=!ge.has(We.identifier);ye.push(new Z.$qkc(jt,Ue.identifier,We,Di,ut))}return ye},get onDidChange(){return(0,tt.$bG)(Ue,"extensionsAny")?st(O.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):st(ci.mine.onDidChange)}},on={createDiagnosticCollection(ge){return Vt.createDiagnosticCollection(Ue.identifier,ge)},get onDidChangeDiagnostics(){return st(Vt.onDidChangeDiagnostics)},getDiagnostics:ge=>Vt.getDiagnostics(ge),getLanguages(){return Lt.getLanguages()},setTextDocumentLanguage(ge,ye){return Lt.changeLanguage(ge.uri,ye)},match(ge,ye){const We=_e.LanguageSelector.from(ge);let ut;return(0,R.$Wt)(We)&&(ut=ve.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Nt=>Nt.document===ye))?.apiNotebook),(0,R.$Vt)(We,ye.uri,ye.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider(ge,ye,We){return ht.registerCodeActionProvider(Ue,pt(ge),ye,We)},registerDocumentPasteEditProvider(ge,ye,We){return(0,tt.$cG)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,pt(ge),ye,We)},registerCodeLensProvider(ge,ye){return ht.registerCodeLensProvider(Ue,pt(ge),ye)},registerDefinitionProvider(ge,ye){return ht.registerDefinitionProvider(Ue,pt(ge),ye)},registerDeclarationProvider(ge,ye){return ht.registerDeclarationProvider(Ue,pt(ge),ye)},registerImplementationProvider(ge,ye){return ht.registerImplementationProvider(Ue,pt(ge),ye)},registerTypeDefinitionProvider(ge,ye){return ht.registerTypeDefinitionProvider(Ue,pt(ge),ye)},registerHoverProvider(ge,ye){return ht.registerHoverProvider(Ue,pt(ge),ye,Ue.identifier)},registerEvaluatableExpressionProvider(ge,ye){return ht.registerEvaluatableExpressionProvider(Ue,pt(ge),ye,Ue.identifier)},registerInlineValuesProvider(ge,ye){return ht.registerInlineValuesProvider(Ue,pt(ge),ye,Ue.identifier)},registerDocumentHighlightProvider(ge,ye){return ht.registerDocumentHighlightProvider(Ue,pt(ge),ye)},registerMultiDocumentHighlightProvider(ge,ye){return ht.registerMultiDocumentHighlightProvider(Ue,pt(ge),ye)},registerLinkedEditingRangeProvider(ge,ye){return ht.registerLinkedEditingRangeProvider(Ue,pt(ge),ye)},registerReferenceProvider(ge,ye){return ht.registerReferenceProvider(Ue,pt(ge),ye)},registerRenameProvider(ge,ye){return ht.registerRenameProvider(Ue,pt(ge),ye)},registerNewSymbolNamesProvider(ge,ye){return(0,tt.$cG)(Ue,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Ue,pt(ge),ye)},registerDocumentSymbolProvider(ge,ye,We){return ht.registerDocumentSymbolProvider(Ue,pt(ge),ye,We)},registerWorkspaceSymbolProvider(ge){return ht.registerWorkspaceSymbolProvider(Ue,ge)},registerDocumentFormattingEditProvider(ge,ye){return ht.registerDocumentFormattingEditProvider(Ue,pt(ge),ye)},registerDocumentRangeFormattingEditProvider(ge,ye){return ht.registerDocumentRangeFormattingEditProvider(Ue,pt(ge),ye)},registerOnTypeFormattingEditProvider(ge,ye,We,...ut){return ht.registerOnTypeFormattingEditProvider(Ue,pt(ge),ye,[We].concat(ut))},registerDocumentSemanticTokensProvider(ge,ye,We){return ht.registerDocumentSemanticTokensProvider(Ue,pt(ge),ye,We)},registerDocumentRangeSemanticTokensProvider(ge,ye,We){return ht.registerDocumentRangeSemanticTokensProvider(Ue,pt(ge),ye,We)},registerSignatureHelpProvider(ge,ye,We,...ut){return typeof We=="object"?ht.registerSignatureHelpProvider(Ue,pt(ge),ye,We):ht.registerSignatureHelpProvider(Ue,pt(ge),ye,typeof We>"u"?[]:[We,...ut])},registerCompletionItemProvider(ge,ye,...We){return ht.registerCompletionItemProvider(Ue,pt(ge),ye,We)},registerInlineCompletionItemProvider(ge,ye,We){return ye.handleDidShowCompletionItem&&(0,tt.$cG)(Ue,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,tt.$cG)(Ue,"inlineCompletionsAdditions"),We&&(0,tt.$cG)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,pt(ge),ye,We)},registerInlineEditProvider(ge,ye){return(0,tt.$cG)(Ue,"inlineEdit"),ht.registerInlineEditProvider(Ue,pt(ge),ye)},registerDocumentLinkProvider(ge,ye){return ht.registerDocumentLinkProvider(Ue,pt(ge),ye)},registerColorProvider(ge,ye){return ht.registerColorProvider(Ue,pt(ge),ye)},registerFoldingRangeProvider(ge,ye){return ht.registerFoldingRangeProvider(Ue,pt(ge),ye)},registerSelectionRangeProvider(ge,ye){return ht.registerSelectionRangeProvider(Ue,ge,ye)},registerCallHierarchyProvider(ge,ye){return ht.registerCallHierarchyProvider(Ue,ge,ye)},registerTypeHierarchyProvider(ge,ye){return ht.registerTypeHierarchyProvider(Ue,ge,ye)},setLanguageConfiguration:(ge,ye)=>ht.setLanguageConfiguration(Ue,ge,ye),getTokenInformationAtPosition(ge,ye){return(0,tt.$cG)(Ue,"tokenInformation"),Lt.tokenAtPosition(ge,ye)},registerInlayHintsProvider(ge,ye){return ht.registerInlayHintsProvider(Ue,ge,ye)},createLanguageStatusItem(ge,ye){return Lt.createLanguageStatusItem(Ue,ge,ye)},registerDocumentDropEditProvider(ge,ye,We){return ht.registerDocumentOnDropEditProvider(Ue,ge,ye,(0,tt.$bG)(Ue,"dropMetadata")?We:void 0)}},pn={get activeTextEditor(){return ct.getActiveTextEditor()},get visibleTextEditors(){return ct.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(ge,ye,We){$.URI.isUri(ge)&&ge.scheme===M.Schemas.vscodeRemote&&!ge.authority&&Mt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await($.URI.isUri(ge)?Promise.resolve(an.openTextDocument(ge)):Promise.resolve(ge));return ct.showTextDocument(ut,ye,We)},createTextEditorDecorationType(ge){return ct.createTextEditorDecorationType(Ue,ge)},onDidChangeActiveTextEditor(ge,ye,We){return st(ct.onDidChangeActiveTextEditor)(ge,ye,We)},onDidChangeVisibleTextEditors(ge,ye,We){return st(ct.onDidChangeVisibleTextEditors)(ge,ye,We)},onDidChangeTextEditorSelection(ge,ye,We){return st(ct.onDidChangeTextEditorSelection)(ge,ye,We)},onDidChangeTextEditorOptions(ge,ye,We){return st(ct.onDidChangeTextEditorOptions)(ge,ye,We)},onDidChangeTextEditorVisibleRanges(ge,ye,We){return st(ct.onDidChangeTextEditorVisibleRanges)(ge,ye,We)},onDidChangeTextEditorViewColumn(ge,ye,We){return st(ct.onDidChangeTextEditorViewColumn)(ge,ye,We)},onDidCloseTerminal(ge,ye,We){return st(Dt.onDidCloseTerminal)(ge,ye,We)},onDidOpenTerminal(ge,ye,We){return st(Dt.onDidOpenTerminal)(ge,ye,We)},onDidChangeActiveTerminal(ge,ye,We){return st(Dt.onDidChangeActiveTerminal)(ge,ye,We)},onDidChangeTerminalDimensions(ge,ye,We){return(0,tt.$cG)(Ue,"terminalDimensions"),st(Dt.onDidChangeTerminalDimensions)(ge,ye,We)},onDidChangeTerminalState(ge,ye,We){return st(Dt.onDidChangeTerminalState)(ge,ye,We)},onDidWriteTerminalData(ge,ye,We){return(0,tt.$cG)(Ue,"terminalDataWriteEvent"),st(Dt.onDidWriteTerminalData)(ge,ye,We)},onDidExecuteTerminalCommand(ge,ye,We){return(0,tt.$cG)(Ue,"terminalExecuteCommandEvent"),st(Dt.onDidExecuteTerminalCommand)(ge,ye,We)},get state(){return Tt.getState(Ue)},onDidChangeWindowState(ge,ye,We){return st(Tt.onDidChangeWindowState)(ge,ye,We)},showInformationMessage(ge,...ye){return wi.showMessage(Ue,b.default.Info,ge,ye[0],ye.slice(1))},showWarningMessage(ge,...ye){return wi.showMessage(Ue,b.default.Warning,ge,ye[0],ye.slice(1))},showErrorMessage(ge,...ye){return wi.showMessage(Ue,b.default.Error,ge,ye[0],ye.slice(1))},showQuickPick(ge,ye,We){return $i.showQuickPick(Ue,ge,ye,We)},showWorkspaceFolderPick(ge){return $i.showWorkspaceFolderPick(ge)},showInputBox(ge,ye){return $i.showInput(ge,ye)},showOpenDialog(ge){return Li.showOpenDialog(Ue,ge)},showSaveDialog(ge){return Li.showSaveDialog(ge)},createStatusBarItem(ge,ye,We){let ut,vt,Nt;return typeof ge=="string"?(ut=ge,vt=ye,Nt=We):(vt=ge,Nt=ye),Si.createStatusBarEntry(Ue,ut,vt,Nt)},setStatusBarMessage(ge,ye){return Si.setStatusBarMessage(ge,ye)},withScmProgress(ge){return Mt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Vi.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(ye,We)=>ge({report(ut){}}))},withProgress(ge,ye){return Vi.withProgress(Ue,ge,ye)},createOutputChannel(ge,ye){return li.createOutputChannel(ge,ye,Ue)},createWebviewPanel(ge,ye,We,ut){return Ei.createWebviewPanel(Ue,ge,ye,We,ut)},createWebviewTextEditorInset(ge,ye,We,ut){return(0,tt.$cG)(Ue,"editorInsets"),Kt.createWebviewEditorInset(ge,ye,We,ut,Ue)},createTerminal(ge,ye,We){return typeof ge=="object"?"pty"in ge?Dt.createExtensionTerminal(ge):Dt.createTerminalFromOptions(ge):Dt.createTerminal(ge,ye,We)},registerTerminalLinkProvider(ge){return Dt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ye){return Dt.registerProfileProvider(Ue,ge,ye)},registerTerminalQuickFixProvider(ge,ye){return(0,tt.$cG)(Ue,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(ge,Ue.identifier.value,ye)},registerTreeDataProvider(ge,ye){return kt.registerTreeDataProvider(ge,ye,Ue)},createTreeView(ge,ye){return kt.createTreeView(ge,ye,Ue)},registerWebviewPanelSerializer:(ge,ye)=>Ei.registerWebviewPanelSerializer(Ue,ge,ye),registerCustomEditorProvider:(ge,ye,We={})=>Hi.registerCustomEditorProvider(Ue,ge,ye,We),registerFileDecorationProvider(ge){return Gt.registerFileDecorationProvider(ge,Ue)},registerUriHandler(ge){return xt.registerUriHandler(Ue,ge)},createQuickPick(){return $i.createQuickPick(Ue)},createInputBox(){return $i.createInputBox(Ue)},get activeColorTheme(){return yi.activeColorTheme},onDidChangeActiveColorTheme(ge,ye,We){return st(yi.onDidChangeActiveColorTheme)(ge,ye,We)},registerWebviewViewProvider(ge,ye,We){return Gi.registerWebviewViewProvider(Ue,ge,ye,We?.webviewOptions)},get activeNotebookEditor(){return ve.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ye,We){return st(ve.onDidChangeActiveNotebookEditor)(ge,ye,We)},get visibleNotebookEditors(){return ve.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return st(ve.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ye,We){return st(Le.onDidChangeNotebookEditorSelection)(ge,ye,We)},onDidChangeNotebookEditorVisibleRanges(ge,ye,We){return st(Le.onDidChangeNotebookEditorVisibleRanges)(ge,ye,We)},showNotebookDocument(ge,ye){return ve.showNotebookDocument(ge,ye)},registerExternalUriOpener(ge,ye,We){return(0,tt.$cG)(Ue,"externalUriOpener"),Ki.registerExternalUriOpener(Ue.identifier,ge,ye,We)},registerProfileContentHandler(ge,ye){return(0,tt.$cG)(Ue,"profileContentHandlers"),gn.registerProfileContentHandler(Ue,ge,ye)},registerQuickDiffProvider(ge,ye,We,ut){return(0,tt.$cG)(Ue,"quickDiffProvider"),Ai.registerQuickDiffProvider(pt(ge),ye,We,ut)},get tabGroups(){return oi.tabGroups},registerShareProvider(ge,ye){return(0,tt.$cG)(Ue,"shareProvider"),Ri.registerShareProvider(pt(ge),ye)}},an={get rootPath(){return Mt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw new L.$9("rootPath")},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw new L.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw new L.$9("workspaceFile")},updateWorkspaceFolders:(ge,ye,...We)=>mt.updateWorkspaceFolders(Ue,ge,ye||0,...We),onDidChangeWorkspaceFolders:function(ge,ye,We){return st(mt.onDidChangeWorkspace)(ge,ye,We)},asRelativePath:(ge,ye)=>mt.getRelativePath(ge,ye),findFiles:(ge,ye,We,ut)=>mt.findFiles(ge,ye,We,Ue.identifier,ut),findFiles2:(ge,ye,We)=>((0,tt.$cG)(Ue,"findFiles2"),mt.findFiles2(ge,ye,Ue.identifier,We)),findTextInFiles:(ge,ye,We,ut)=>{(0,tt.$cG)(Ue,"findTextInFiles");let vt,Nt;return typeof ye=="object"?(vt=ye,Nt=We):(vt={},Nt=ye,ut=We),mt.findTextInFiles(ge,vt||{},Nt,Ue.identifier,ut)},save:ge=>mt.save(ge),saveAs:ge=>mt.saveAs(ge),saveAll:ge=>mt.saveAll(ge),applyEdit(ge,ye){return _i.applyWorkspaceEdit(ge,Ue,ye)},createFileSystemWatcher:(ge,ye,We,ut)=>{let vt;return typeof ye=="boolean"?vt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!ut,correlate:!1}:ye&&((0,tt.$cG)(Ue,"createFileSystemWatcher"),vt={...ye,correlate:!0}),gi.createFileSystemWatcher(mt,Ue,ge,vt)},get textDocuments(){return Ot.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new L.$9("textDocuments")},openTextDocument(ge){let ye;const We=ge;if(typeof ge=="string")ye=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ye=Promise.resolve(ge);else if(!We||typeof We=="object")ye=Ot.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ut=>(ut.scheme===M.Schemas.vscodeRemote&&!ut.authority&&Mt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Ot.ensureDocumentData(ut).then(vt=>vt.document)))},onDidOpenTextDocument:(ge,ye,We)=>st(Ot.onDidAddDocument)(ge,ye,We),onDidCloseTextDocument:(ge,ye,We)=>st(Ot.onDidRemoveDocument)(ge,ye,We),onDidChangeTextDocument:(ge,ye,We)=>st(Ot.onDidChangeDocument)(ge,ye,We),onDidSaveTextDocument:(ge,ye,We)=>st(Ot.onDidSaveDocument)(ge,ye,We),onWillSaveTextDocument:(ge,ye,We)=>st(ze.getOnWillSaveTextDocumentEvent(Ue))(ge,ye,We),get notebookDocuments(){return ve.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ye){let We;if($.URI.isUri(ge))We=ge,await ve.openNotebookDocument(ge);else if(typeof ge=="string")We=$.URI.revive(await ve.createNotebookDocument({viewType:ge,content:ye}));else throw new Error("Invalid arguments");return ve.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(ge,ye,We){return st(ne.onDidSaveNotebookDocument)(ge,ye,We)},onDidChangeNotebookDocument(ge,ye,We){return st(ne.onDidChangeNotebookDocument)(ge,ye,We)},onWillSaveNotebookDocument(ge,ye,We){return st(Xe.getOnWillSaveNotebookDocumentEvent(Ue))(ge,ye,We)},get onDidOpenNotebookDocument(){return st(ve.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return st(ve.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ye,We,ut){return ve.registerNotebookSerializer(Ue,ge,ye,We,(0,tt.$bG)(Ue,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(ge,ye,We)=>st(en.onDidChangeConfiguration)(ge,ye,We),getConfiguration(ge,ye){return ye=arguments.length===1?void 0:ye,en.getConfiguration(ge,ye,Ue)},registerTextDocumentContentProvider(ge,ye){return Oe.registerTextDocumentContentProvider(ge,ye)},registerTaskProvider:(ge,ye)=>(Mt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),ri.registerTaskProvider(Ue,ge,ye)),registerFileSystemProvider(ge,ye,We){return(0,A.$Rc)(Pi.registerFileSystemProvider(Ue,ge,ye,We),ii.addFileSystemProvider(ge,ye,We))},get fs(){return ii.value},registerFileSearchProvider:(ge,ye)=>((0,tt.$cG)(Ue,"fileSearchProvider"),ui.registerFileSearchProvider(ge,ye)),registerTextSearchProvider:(ge,ye)=>((0,tt.$cG)(Ue,"textSearchProvider"),ui.registerTextSearchProvider(ge,ye)),registerAITextSearchProvider:(ge,ye)=>((0,tt.$cG)(Ue,"aiTextSearchProvider"),(0,tt.$cG)(Ue,"textSearchProvider"),ui.registerAITextSearchProvider(ge,ye)),registerRemoteAuthorityResolver:(ge,ye)=>((0,tt.$cG)(Ue,"resolvers"),jt.registerRemoteAuthorityResolver(ge,ye)),registerResourceLabelFormatter:ge=>((0,tt.$cG)(Ue,"resolvers"),qi.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,tt.$cG)(Ue,"resolvers"),jt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ye,We)=>st(gi.onDidCreateFile)(ge,ye,We),onDidDeleteFiles:(ge,ye,We)=>st(gi.onDidDeleteFile)(ge,ye,We),onDidRenameFiles:(ge,ye,We)=>st(gi.onDidRenameFile)(ge,ye,We),onWillCreateFiles:(ge,ye,We)=>st(gi.getOnWillCreateFileEvent(Ue))(ge,ye,We),onWillDeleteFiles:(ge,ye,We)=>st(gi.getOnWillDeleteFileEvent(Ue))(ge,ye,We),onWillRenameFiles:(ge,ye,We)=>st(gi.getOnWillRenameFileEvent(Ue))(ge,ye,We),openTunnel:ge=>((0,tt.$cG)(Ue,"tunnels"),Ft.openTunnel(Ue,ge).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,tt.$cG)(Ue,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ge,ye,We)=>((0,tt.$cG)(Ue,"tunnels"),st(Ft.onDidChangeTunnels)(ge,ye,We)),registerPortAttributesProvider:(ge,ye)=>((0,tt.$cG)(Ue,"portsAttributes"),Ft.registerPortsAttributesProvider(ge,ye)),registerTunnelProvider:(ge,ye)=>((0,tt.$cG)(Ue,"tunnelFactory"),Ft.registerTunnelProvider(ge,ye)),registerTimelineProvider:(ge,ye)=>((0,tt.$cG)(Ue,"timeline"),Mi.registerTimelineProvider(ge,ye,Ue.identifier,yt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,tt.$cG)(Ue,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ye,We)=>st(mt.onDidGrantWorkspaceTrust)(ge,ye,We),registerEditSessionIdentityProvider:(ge,ye)=>((0,tt.$cG)(Ue,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,ye)),onWillCreateEditSessionIdentity:(ge,ye,We)=>((0,tt.$cG)(Ue,"editSessionIdentityProvider"),st(mt.getOnWillCreateEditSessionIdentityEvent(Ue))(ge,ye,We)),registerCanonicalUriProvider:(ge,ye)=>((0,tt.$cG)(Ue,"canonicalUriProvider"),mt.registerCanonicalUriProvider(ge,ye)),getCanonicalUri:(ge,ye,We)=>((0,tt.$cG)(Ue,"canonicalUriProvider"),mt.provideCanonicalUri(ge,ye,We))},cn={get inputBox(){return Mt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ue)},createSourceControl(ge,ye,We){return vi.createSourceControl(Ue,ge,ye,We)}},Ni={createCommentController(ge,ye){return Wi.createCommentController(Ue,ge,ye)}},un={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,tt.$bG)(Ue,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider(ge,ye){return(0,tt.$cG)(Ue,"debugVisualization"),Et.registerDebugVisualizationProvider(Ue,ge,ye)},registerDebugVisualizationTreeProvider(ge,ye){return(0,tt.$cG)(Ue,"debugVisualization"),Et.registerDebugVisualizationTree(Ue,ge,ye)},onDidStartDebugSession(ge,ye,We){return st(Et.onDidStartDebugSession)(ge,ye,We)},onDidTerminateDebugSession(ge,ye,We){return st(Et.onDidTerminateDebugSession)(ge,ye,We)},onDidChangeActiveDebugSession(ge,ye,We){return st(Et.onDidChangeActiveDebugSession)(ge,ye,We)},onDidReceiveDebugSessionCustomEvent(ge,ye,We){return st(Et.onDidReceiveDebugSessionCustomEvent)(ge,ye,We)},onDidChangeBreakpoints(ge,ye,We){return st(Et.onDidChangeBreakpoints)(ge,ye,We)},onDidChangeActiveStackItem(ge,ye,We){return(0,tt.$cG)(Ue,"debugFocus"),st(Et.onDidChangeActiveStackItem)(ge,ye,We)},registerDebugConfigurationProvider(ge,ye,We){return Et.registerDebugConfigurationProvider(ge,ye,We||qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ye){return Et.registerDebugAdapterDescriptorFactory(Ue,ge,ye)},registerDebugAdapterTrackerFactory(ge,ye){return Et.registerDebugAdapterTrackerFactory(ge,ye)},startDebugging(ge,ye,We){return!We||typeof We=="object"&&"configuration"in We?Et.startDebugging(ge,ye,{parentSession:We}):Et.startDebugging(ge,ye,We||{})},stopDebugging(ge){return Et.stopDebugging(ge)},addBreakpoints(ge){return Et.addBreakpoints(ge)},removeBreakpoints(ge){return Et.removeBreakpoints(ge)},asDebugSourceUri(ge,ye){return Et.asDebugSourceUri(ge,ye)}},ln={registerTaskProvider:(ge,ye)=>ri.registerTaskProvider(Ue,ge,ye),fetchTasks:ge=>ri.fetchTasks(ge),executeTask:ge=>ri.executeTask(Ue,ge),get taskExecutions(){return ri.taskExecutions},onDidStartTask:(ge,ye,We)=>st(ri.onDidStartTask)(ge,ye,We),onDidEndTask:(ge,ye,We)=>st(ri.onDidEndTask)(ge,ye,We),onDidStartTaskProcess:(ge,ye,We)=>st(ri.onDidStartTaskProcess)(ge,ye,We),onDidEndTaskProcess:(ge,ye,We)=>st(ri.onDidEndTaskProcess)(ge,ye,We)},hn={createNotebookController(ge,ye,We,ut,vt){return Ve.createNotebookController(Ue,ge,ye,We,ut,(0,tt.$bG)(Ue,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ye)=>ve.registerNotebookCellStatusBarItemProvider(Ue,ge,ye),createRendererMessaging(ge){return et.createRendererMessaging(Ue,ge)},createNotebookControllerDetectionTask(ge){return(0,tt.$cG)(Ue,"notebookKernelSource"),Ve.createNotebookControllerDetectionTask(Ue,ge)},registerKernelSourceActionProvider(ge,ye){return(0,tt.$cG)(Ue,"notebookKernelSource"),Ve.registerKernelSourceActionProvider(Ue,ge,ye)},onDidChangeNotebookCellExecutionState(ge,ye,We){return(0,tt.$cG)(Ue,"notebookCellExecutionState"),st(Ve.onDidChangeNotebookCellExecutionState)(ge,ye,We)}},bn={t(...ge){if(typeof ge[0]=="string"){const ye=ge.shift(),We=!ge||typeof ge[0]!="object"?ge:ge[0];return di.getMessage(Ue.identifier.value,{message:ye,args:We})}return di.getMessage(Ue.identifier.value,ge[0])},get bundle(){return di.getBundle(Ue.identifier.value)},get uri(){return di.getBundleUri(Ue.identifier.value)}},wn={_version:1,registerInteractiveEditorSessionProvider(ge,ye){return(0,tt.$cG)(Ue,"interactive"),mn.registerProvider(Ue,ge,ye)},registerInteractiveSessionProvider(ge,ye){return(0,tt.$cG)(Ue,"interactive"),Ji.registerChatProvider(Ue,ge,ye)},transferChatSession(ge,ye){return(0,tt.$cG)(Ue,"interactive"),Ji.transferChatSession(ge,ye)}},dn={getRelatedInformation(ge,ye){return(0,tt.$cG)(Ue,"aiRelatedInformation"),Qi.getRelatedInformation(Ue,ge,ye)},registerRelatedInformationProvider(ge,ye){return(0,tt.$cG)(Ue,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Ue,ge,ye)},registerEmbeddingVectorProvider(ge,ye){return(0,tt.$cG)(Ue,"aiRelatedInformation"),Xi.registerEmbeddingVectorProvider(Ue,ge,ye)}},fn={registerChatResponseProvider(ge,ye,We){return(0,tt.$cG)(Ue,"chatProvider"),St.registerLanguageModel(Ue,ge,ye,We)},registerChatVariableResolver(ge,ye,We){return(0,tt.$cG)(Ue,"chatVariableResolver"),Oi.registerVariableResolver(Ue,ge,ye,We)},registerMappedEditsProvider(ge,ye){return(0,tt.$cG)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,ge,ye)},createChatParticipant(ge,ye){return(0,tt.$cG)(Ue,"chatParticipant"),Ci.createChatAgent(Ue,ge,ye)},createDynamicChatParticipant(ge,ye,We,ut){return(0,tt.$cG)(Ue,"chatParticipantAdditions"),Ci.createDynamicChatAgent(Ue,ge,ye,We,ut)}},Fi={get languageModels(){return(0,tt.$cG)(Ue,"languageModels"),St.getLanguageModelIds()},onDidChangeLanguageModels:(ge,ye,We)=>((0,tt.$cG)(Ue,"languageModels"),St.onDidChangeProviders(ge,ye,We)),sendChatRequest(ge,ye,We,ut){return(0,tt.$cG)(Ue,"languageModels"),St.sendChatRequest(Ue,ge,ye,We,ut)}},Ti={registerSpeechProvider(ge,ye){return(0,tt.$cG)(Ue,"speech"),Yi.registerProvider(Ue.identifier,ge,ye)}};return{version:bt.version,ai:dn,authentication:tn,commands:nn,comments:Ni,chat:fn,debug:un,env:ji,extensions:sn,interactive:wn,l10n:bn,languages:on,lm:Fi,notebooks:hn,scm:cn,speech:Ti,tasks:ln,tests:rn,window:pn,workspace:an,Breakpoint:Ne.$tN,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatResultFeedbackKind:Ne.ChatResultFeedbackKind,ChatVariableLevel:Ne.ChatVariableLevel,ChatCompletionItem:Ne.$nO,CallHierarchyIncomingCall:Ne.$RM,CallHierarchyItem:Ne.$QM,CallHierarchyOutgoingCall:Ne.$SM,CancellationError:L.$5,CancellationTokenSource:u.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Ne.$NM,CodeActionKind:Ne.$OM,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$TM,Color:Ne.$7M,ColorInformation:Ne.$8M,ColorPresentation:Ne.$9M,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CommentThreadApplicability:Ne.CommentThreadApplicability,CompletionItem:Ne.$1M,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$2M,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$eN,DebugAdapterExecutable:Ne.$xN,DebugAdapterInlineImplementation:Ne.$AN,DebugAdapterNamedPipeServer:Ne.$zN,DebugAdapterServer:Ne.$yN,DebugConfigurationProviderTriggerKind:qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$QN,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$HM,DiagnosticRelatedInformation:Ne.$GM,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$tM,DocumentHighlight:Ne.$JM,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$KM,DocumentLink:Ne.$6M,DocumentSymbol:Ne.$MM,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$DN,InlineValueText:Ne.$EN,InlineValueVariableLookup:Ne.$FN,InlineValueEvaluatableExpression:Ne.$GN,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:O.$7d,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$SN,FileDecoration2:Ne.$SN,FileSystemError:Ne.$JN,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Ne.$KN,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$vN,InlineCompletionItem:Ne.$3M,InlineCompletionList:Ne.$4M,Hover:Ne.$IM,IndentAction:I.IndentAction,Location:Ne.$FM,MarkdownString:Ne.$UM,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Ne.$VM,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$uM,ProcessExecution:Ne.$cN,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$RN,Range:Ne.$vM,RelativePattern:Ne.$rN,Selection:Ne.$wM,SelectionRange:Ne.$PM,SemanticTokens:Ne.$NN,SemanticTokensBuilder:Ne.$MN,SemanticTokensEdit:Ne.$ON,SemanticTokensEdits:Ne.$PN,SemanticTokensLegend:Ne.$LN,ShellExecution:Ne.$dN,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$XM,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$WM,SnippetString:Ne.$EM,SourceBreakpoint:Ne.$uN,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$LM,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$fN,TaskGroup:Ne.$bN,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$0M,TerminalQuickFixTerminalCommand:Ne.$_M,TerminalQuickFixOpener:Ne.$$M,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$aN,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$AM,SnippetTextEdit:Ne.$CM,TextEditorCursorStyle:v.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$qN,ThemeIcon:Ne.$pN,TreeItem:Ne.$gN,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$bO,UIKind:ai.UIKind,Uri:$.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$DM,DocumentPasteTriggerKind:Ne.DocumentPasteTriggerKind,DocumentDropEdit:Ne.$mN,DocumentPasteEditKind:Ne.$nN,DocumentPasteEdit:Ne.$oN,InlayHint:Ne.$ZM,InlayHintLabelPart:Ne.$YM,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$zM,ResolvedAuthority:Ne.$xM,ManagedResolvedAuthority:Ne.$yM,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$3N,NotebookRange:Ne.$UN,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$VN,NotebookData:Ne.$WN,NotebookRendererScript:Ne.$1N,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$YN,NotebookCellOutputItem:Ne.$XN,NotebookCellStatusBarItem:Ne.$ZN,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$BM,NotebookKernelSourceAction:Ne.$2N,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$5N,LinkedEditingRanges:Ne.$4N,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$6N,TestMessage:Ne.$7N,TestTag:Ne.$8N,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:ei.TextSearchCompleteMessageType,DataTransfer:Ne.$lN,DataTransferItem:Ne.$hN,TestCoverageCount:Ne.$9N,FileCoverage:Ne.$0N,StatementCoverage:Ne.$$N,BranchCoverage:Ne.$_N,DeclarationCoverage:Ne.$aO,FunctionCoverage:Ne.$aO,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$cO,TabInputTextDiff:Ne.$dO,TabInputTextMerge:Ne.$eO,TabInputCustom:Ne.$fO,TabInputNotebook:Ne.$hO,TabInputNotebookDiff:Ne.$iO,TabInputWebview:Ne.$gO,TabInputTerminal:Ne.$jO,TabInputInteractiveWindow:Ne.$kO,TabInputChat:Ne.$lO,TabInputTextMultiDiff:Ne.$mO,TelemetryTrustedValue:o.$4o,LogLevel:c.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatCopyKind:Ne.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrame:Ne.$BN,Thread:Ne.$CN,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,PartialAcceptTriggerKind:Ne.PartialAcceptTriggerKind,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ne.$oO,ChatResponseFileTreePart:Ne.$pO,ChatResponseAnchorPart:Ne.$qO,ChatResponseProgressPart:Ne.$rO,ChatResponseReferencePart:Ne.$tO,ChatResponseCommandButtonPart:Ne.$sO,ChatRequestTurn:Ne.$uO,ChatResponseTurn:Ne.$vO,ChatLocation:Ne.ChatLocation,LanguageModelChatSystemMessage:Ne.$wO,LanguageModelChatUserMessage:Ne.$xO,LanguageModelChatAssistantMessage:Ne.$yO,LanguageModelSystemMessage:Ne.$wO,LanguageModelUserMessage:Ne.$xO,LanguageModelAssistantMessage:Ne.$yO,LanguageModelError:Ne.$zO,NewSymbolName:Ne.$IN,NewSymbolNameTag:Ne.NewSymbolNameTag,InlineEdit:Ne.$AO,InlineEditTriggerKind:Ne.InlineEditTriggerKind}}}}),define(ke[380],Ee([1,0,84,156,43,151,44,33,72,47,95,96,97,118,70,91,150,69,59,117,90,71,149,12,60,115,116,120,121]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f,d,l,a,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$gs)(l.$kkc,l.$jkc,1),(0,u.$gs)(f.$Pj,t.$wlc,1),(0,u.$gs)(c.$ojc,c.$pjc,1),(0,u.$gs)(b.$9O,b.$8O,0),(0,u.$gs)(h.$yjc,h.$zjc,0),(0,u.$gs)(g.$Djc,g.$Ejc,0),(0,u.$gs)(M.$Qjc,M.$Ojc,0),(0,u.$gs)(o.$Sjc,o.$Rjc,0),(0,u.$gs)(I.$ukc,I.$ykc,0),(0,u.$gs)(A.$Akc,A.$zkc,0),(0,u.$gs)($.$XO,$.$WO,0),(0,u.$gs)(a.$lkc,a.$mkc,0),(0,u.$gs)(n.$sjc,n.$rjc,0),(0,u.$gs)(L.$7kc,L.$6kc,1),(0,u.$gs)(p.$Qkc,p.$Rkc,0),(0,u.$gs)(C.$_jc,C.$$jc,0),(0,u.$gs)(R.$hlc,R.$glc,0),(0,u.$gs)(v.$ckc,v.$fkc,0),(0,u.$gs)(k.$5Bb,k.$6Bb,0),(0,u.$gs)(m.$ulc,m.$tlc,0),(0,u.$gs)(O.$Njc,O.$Mjc,0),(0,u.$gs)(i.$hkc,i.$gkc,0),(0,u.$gs)(r.$7O,r.$4O,0),(0,u.$gs)(s.$3jc,s.$4jc,0),(0,u.$gs)(d.$skc,d.$tkc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0,e.$Mlc=M,e.$Nlc=b;function M(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function b(I,p,C,k){const c=(0,u.$2b)(C,$),m=new O.$KK(p,c,k),o=m.preview.matches;return{ranges:(0,u.$2b)(c,v),uri:I,preview:{text:m.preview.text,matches:(0,u.$2b)(o,v)}}}function $(I){return new O.$LK(I.start.line,I.start.character,I.end.line,I.end.character)}function v(I){return new A.$zK(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(p,C){this.a=p,this.b=C}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$Olc=R,e.$Olc=R=Je([qe(1,L.$Oj)],R)}),define(ke[381],Ee([1,0,52,17,76,34,11,14,122,382]),function(he,e,u,L,O,A,M,b,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=I,e.$Qlc=m,e.$Rlc=n;const R=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,r,s,t){const f=p(i,r,s,t),d=r.folder.fsPath;return{cmd:u.spawn(R,f.args,{cwd:d}),rgDiskPath:R,siblingClauses:f.siblingClauses,rgArgs:f,cwd:d}}function p(i,r,s,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];k([r],s,!1).forEach(l=>{const a=(0,$.$Mlc)(l);if(f.push("-g",a),M.$j){const h=(0,O.$1l)(a);h!==a&&f.push("-g",h)}});const d=C([r],t,void 0,!1);return d.globArgs.forEach(l=>{const a=`!${(0,$.$Mlc)(l)}`;if(f.push("-g",a),M.$j){const h=(0,O.$1l)(a);h!==a&&f.push("-g",h)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),i.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:d.siblingClauses}}function C(i,r,s,t=!0){const f=[];let d={};return i.forEach(l=>{const a=Object.assign({},l.excludePattern||{},r||{}),h=c(a,t?l.folder.fsPath:void 0,s);f.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:f,siblingClauses:d}}function k(i,r,s=!0){const t=[];return i.forEach(f=>{const d=Object.assign({},r||{},f.includePattern||{}),l=c(d,s?f.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function c(i,r,s){const t=[],f={};return Object.keys(i).forEach(d=>{if(s&&s.has(d)||!d)return;const l=i[d];d=o(r?m(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(n(d))):l&&l.when&&(f[d]=l)}),{globArgs:t,siblingClauses:f}}function m(i,r){return L.$jc(r)?r:L.$kc(i,r)}function o(i){return i=b.$6e(i,"\\"),b.$6e(i,"/")}function n(i){return A.$eg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[383],Ee([1,0,52,51,17,384,19,46,35,76,34,11,39,14,18,31,36,381,132]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=e.$Slc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&$.$ck(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,n.$hr)(this.b).normalizedLowercase),this.u=l.excludePattern&&$.$ck(l.excludePattern),this.t=new Map,l.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),g=a.folder.fsPath;l.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==g).forEach(S=>{(0,R.$ig)(S,g)&&(h[O.$mc(g,S)]=!0)}),this.t.set(g,new t(h,g))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,a,h,g,S){if(this.m=p.$3d.create(!1),this.l)return S(null,this.j);a.forEach(w=>{const E=O.$oc(w.fsPath);this.u&&this.u(w.fsPath,E)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=p.$3d.create(!1),this.w(l,(w,E)=>{this.x(this.y,this,w,h,g,y=>{if(y){const D=(0,b.$6i)(y);console.error(D),this.q.push(D),E(y,void 0)}else E(null,void 0)})},(w,E)=>{this.m.stop();const y=w?M.$Hb(w)[0]:null;S(y,this.j)})}w(l,a,h){const g=new Array(l.length),S=new Array(l.length);let w=!1,E=0;if(l.length===0)return h(null,[]);l.forEach((y,D)=>{a(y,(P,z)=>{if(P?(w=!0,g[D]=null,S[D]=P):(g[D]=z,S[D]=null),++E===l.length)return h(w?S:null,g)})})}x(l,a,...h){try{l.apply(a,h)}catch(g){h[h.length-1](g)}}y(l,a,h,g){const S=l.folder.fsPath,w=I.$j,E=()=>F&&F.kill();i.add(E);let y=B=>{i.delete(E),y=()=>{},g(B)},D="";const P=this.D(),z=(0,o.$Plc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),F=z.cmd,T=!Object.keys(z.siblingClauses).length,j=z.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let N=`${z.rgDiskPath} ${j}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:N}),this.s=0,this.z(F,"utf8",h,(B,W,Y)=>{if(B){y(B);return}if(this.j){y();return}const J=(D+(w?v.$Zl(W||""):W)).split(`
`);if(Y){const Z=J.length;J[Z-1]=J[Z-1].trim(),J[Z-1]||J.pop()}else D=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=J.length,T){for(const Z of J)if(this.J(a,{base:S,relativePath:Z,searchPath:this.N(l,Z)}),this.j){E();break}(Y||this.j)&&y();return}this.G(l,P,S,J,a),Y&&(this.H(P,S,a),y())})}spawnFindCmd(l){const a=this.t.get(l.folder.fsPath),h=a.getBasenameTerms(),g=a.getPathTerms(),S=["-L","."];if(h.length||g.length){S.push("-not","(","(");for(const w of h)S.push("-name",w),S.push("-o");for(const w of g)S.push("-path",w),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),u.spawn("find",S,{cwd:l.folder.fsPath})}readStdout(l,a,h){let g="";this.z(l,a,()=>{},(S,w,E)=>{if(S){h(S);return}g+=w,E&&h(null,g)})}z(l,a,h,g){let S=(y,D,P)=>{(y||P)&&(S=()=>{},this.r?.stop()),g(y,D,P)},w=!1;l.stdout?(this.A(l.stdout,a,S),l.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let E;l.stderr?E=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",y=>{S(y)}),l.on("close",y=>{let D;!w&&(D=this.C(E,a))&&f(D)?S(new Error(`command failed with error code ${y}: ${this.C(E,a)}`)):(this.g&&y===0&&(this.j=!0),S(null,"",!0))})}A(l,a,h){const g=new A.StringDecoder(a);return l.on("data",S=>{h(null,g.write(S))}),g}B(l){const a=[];return l.on("data",h=>{a.push(h)}),a}C(l,a){const h=new A.StringDecoder(a);return l.map(g=>h.write(g)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:a},h,g,S){g.indexOf(this.b)!==-1&&this.J(S,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const w=E=>{const y=O.$oc(E),D=O.$nc(E);let P=a[D];P||(P=a[D]=[],w(D)),P.push({base:h,relativePath:E,basename:y,searchPath:this.N(l,E)})};g.forEach(w)}H({rootEntries:l,pathToEntries:a},h,g){const S=this,w=this.t.get(h),E=this.b;function y(D){S.o++;const P=(0,m.$1K)(()=>D.map(z=>z.basename));for(let z=0,F=D.length;z<F;z++){const T=D[z],{relativePath:j,basename:N}=T;if(w.test(j,N,E!==N?P:void 0))continue;const B=a[j];if(B)y(B);else{if(S.p++,j===E)continue;S.J(g,T)}if(S.j)break}}y(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,a,h,g,S){const w=l.folder,E=(0,m.$1K)(()=>h);this.w(h,(y,D)=>{if(this.l||this.j)return D(null);const P=a?[a,y].join(O.sep):y;if(this.t.get(l.folder.fsPath).test(P,y,this.a.filePattern!==y?E:void 0))return D(null);const z=[w.fsPath,P].join(O.sep);L.lstat(z,(F,T)=>{if(F||this.l||this.j)return D(null);this.L(z,T,(j,N)=>j||this.l||this.j?D(null):N.isDirectory()?(this.o++,this.M(z,T,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?D(null):(this.v[W]=!0,c.Promises.readdir(z).then(Y=>{if(this.l||this.j)return D(null);this.I(l,P,Y,g,_=>D(_||null))},Y=>{D(null)})))):(this.p++,P===this.b||this.h&&k.$Zf(N.size)&&N.size>this.h||this.J(g,{base:w.fsPath,relativePath:P,searchPath:this.N(l,P)}),D(null,void 0)))})},y=>{const D=y&&M.$Hb(y);return S(D&&D.length>0?D[0]:void 0)})}J(l,a){this.K(a)&&(!this.d||this.d(a.relativePath,O.$oc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(a))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$VK)(l,this.c);if(this.b)return(0,m.$VK)(l,this.b,!1)}return!0}L(l,a,h){return a.isSymbolicLink()?L.stat(l,h):h(null,a)}M(l,a,h){return a.isSymbolicLink()?L.realpath(l,(g,S)=>g?h(g):h(null,S)):h(null,l)}N(l,a){return l.folderName?O.$kc(l.folderName,a):a}}e.$Slc=r;class s{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,a,h){this.c.walk(this.a,this.b,l,a,(g,S)=>{h(g,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Tlc=s;class t{constructor(l,a){this.expression=l,this.c=a,this.d(l)}d(l){let a,h;Object.keys(l).filter(g=>l[g]).forEach(g=>{O.$jc(g)?(a=a||$.$0j(),a[g]=l[g]):(h=h||$.$0j(),h[g]=l[g])}),this.a=a&&$.$ck(a,{trimForExclusions:!0}),this.b=h&&$.$ck(h,{trimForExclusions:!0})}test(l,a,h){return this.b&&this.b(l,a,h)||this.a&&this.a(O.$kc(this.c,l),a,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...$.$ek(this.a)),this.b&&l.push(...$.$ek(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...$.$fk(this.a)),this.b&&l.push(...$.$fk(this.b)),l}}function f(d){const l=d.trim().split(`
`),a=l[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return C.$Nf(l[l.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(ke[385],Ee([1,0,98,21,192,22]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1D=e.$SD=e.DecodeStreamErrorKind=e.$RD=e.$QD=e.$PD=e.$ND=e.$MD=e.$LD=e.$KD=void 0,e.$OD=M,e.$TD=k,e.$UD=c,e.$VD=m,e.$WD=o,e.$XD=n,e.$YD=d,e.$ZD=l,e.$KD="utf8",e.$LD="utf8bom",e.$MD="utf16be",e.$ND="utf16le";function M(a){return[e.$KD,e.$LD,e.$MD,e.$ND].some(h=>h===a)}e.$PD=[254,255],e.$QD=[255,254],e.$RD=[239,187,191];const b=512,$=512,v=512*8,R=512*128;var I;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(h,g){super(h),this.decodeStreamErrorKind=g}}e.$SD=p;class C{static async create(h){let g;if(h!==e.$KD)g=(await(0,O.$JD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const S=new TextDecoder;g={write(w){return S.decode(w,{stream:!0})},end(){return S.decode()}}}return new C(g)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function k(a,h){const g=h.minBytesRequiredForDetection??h.guessEncoding?v:$;return new Promise((S,w)=>{const E=(0,u.$ie)(T=>T.join("")),y=[];let D=0,P;const z=new A.$ee,F=async()=>{try{const T=await l({buffer:L.$ue.concat(y),bytesRead:D},h.guessEncoding);if(T.seemsBinary&&h.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);T.encoding=await h.overwriteEncoding(T.encoding),P=await C.create(T.encoding);const j=P.write(L.$ue.concat(y).buffer);E.write(j),y.length=0,D=0,S({stream:E,detected:T})}catch(T){z.cancel(),E.destroy(),w(T)}};(0,u.$me)(a,{onData:async T=>{P?E.write(P.write(T.buffer)):(y.push(T),D+=T.byteLength,D>=g&&(a.pause(),await F(),setTimeout(()=>a.resume())))},onError:T=>E.error(T),onEnd:async()=>{P||await F(),E.end(P?.end())}},z.token)})}async function c(a,h,g){const w=(await(0,O.$JD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),g);let E=!1,y=!1;return{read(){if(y)return null;const D=a.read();if(typeof D!="string"){if(y=!0,!E&&g?.addBOM)switch(h){case e.$KD:case e.$LD:return L.$ue.wrap(Uint8Array.from(e.$RD));case e.$MD:return L.$ue.wrap(Uint8Array.from(e.$PD));case e.$ND:return L.$ue.wrap(Uint8Array.from(e.$QD))}const P=w.end();return P&&P.length>0?(E=!0,L.$ue.wrap(P)):null}return E=!0,L.$ue.wrap(w.write(D))}}}async function m(a){return(await(0,O.$JD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(a))}function o(a){return a===e.$LD||a===null?e.$KD:a}function n(a,h){if(!a||h<e.$PD.length)return null;const g=a.readUInt8(0),S=a.readUInt8(1);if(g===e.$PD[0]&&S===e.$PD[1])return e.$MD;if(g===e.$QD[0]&&S===e.$QD[1])return e.$ND;if(h<e.$RD.length)return null;const w=a.readUInt8(2);return g===e.$RD[0]&&S===e.$RD[1]&&w===e.$RD[2]?e.$LD:null}const i=["ascii","utf-16","utf-32"];async function r(a){const h=await(0,O.$JD)("jschardet","dist/jschardet.min.js"),g=a.slice(0,R),S=f(g.buffer),w=h.detect(S);if(!w||!w.encoding)return null;const E=w.encoding.toLowerCase();return 0<=i.indexOf(E)?null:t(w.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(a){const h=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[h]||h}function f(a){let h="";for(let g=0;g<a.length;g++)h+=String.fromCharCode(a[g]);return h}function d(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=a.match(/windows(\d+)/);return h?"windows-"+h[1]:a}}}function l({buffer:a,bytesRead:h},g){let S=n(a,h),w=!1;if(S!==e.$MD&&S!==e.$ND&&a){let E=!0,y=!0,D=!1;for(let P=0;P<h&&P<b;P++){const z=P%2===1,F=a.readUInt8(P)===0;if(F&&(D=!0),E&&(z&&!F||!z&&F)&&(E=!1),y&&(z&&F||!z&&!F)&&(y=!1),F&&!E&&!y)break}D&&(E?S=e.$ND:y?S=e.$MD:w=!0)}return g&&!w&&!S&&a?r(a.slice(0,h)).then(E=>({seemsBinary:!1,encoding:E})):{seemsBinary:w,encoding:S}}e.$1D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[159],Ee([1,0,385,31,158]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class A extends O.$Mkc{constructor(b,$,v=L,R="searchProcess"){super({query:b,provider:$},{readdir:I=>v.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,u.$YD)(I)},R)}}e.$2lc=A}),define(ke[160],Ee([1,0,52,401,384,19,73,35,14,2,36,94,402,382,122]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0,e.$Wlc=t,e.$Xlc=d,e.$Ylc=a,e.$Zlc=h,e.$1lc=S;const c=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(E){this.a=E}provideTextSearchResults(E,y,D,P){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((z,F)=>{P.onCancellationRequested(()=>J());const T=t(E,y),j=y.folder.fsPath,N=T.map(De=>De.match(/^-/)?De:`'${De}'`).join(" ");this.a.appendLine(`${c} ${N}
 - cwd: ${j}`);let B=u.spawn(c,T,{cwd:j});B.on("error",De=>{console.error(De),this.a.appendLine("Error: "+(De&&De.message)),F((0,R.$RK)(new R.$PK(De&&De.message,R.SearchErrorCode.rgProcessError)))});let W=!1;const Y=new i(y.maxResults,y.folder,y.previewOptions);Y.on("result",De=>{W=!0,re="",D.report(De)});let _=!1;const J=()=>{_=!0,B?.kill(),Y?.cancel()};let Z=!1;Y.on("hitLimit",()=>{Z=!0,J()});let re="";B.stdout.on("data",De=>{Y.handleData(De),W||(re+=De)});let ee=!1;B.stdout.once("data",()=>ee=!0);let pe="";B.stderr.on("data",De=>{const x=De.toString();this.a.appendLine(x),pe.length+x.length<1e6&&(pe+=x)}),B.on("close",()=>{if(this.a.appendLine(ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),re&&this.a.appendLine(`Got data without result: ${re}`),this.a.appendLine(""),_)z({limitHit:Z});else{Y.flush(),B=null;let De;pe&&!ee&&(De=o(pe))?F((0,R.$RK)(new R.$PK(De.message,De.code))):z({limitHit:Z})}})})}}e.$Ulc=m;function o(w){const E=w.split(`
`),y=E[0].trim();if(E.some(P=>P.startsWith("regex parse error")))return new R.$PK(n(E),R.SearchErrorCode.regexParseError);const D=y.match(/grep config error: unknown encoding: (.*)/);if(D)return new R.$PK(`Unknown encoding: ${D[1]}`,R.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new R.$PK(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new R.$PK(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new R.$PK(y,R.SearchErrorCode.regexParseError)}function n(w){const E=["Regex parse error"],y=w.filter(D=>D.startsWith("PCRE2:"));if(y.length>=1){const D=y[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const P=D.split(":")[1];E.push(":"+P)}}return E.join("")}class i extends L.EventEmitter{constructor(E,y,D){super(),this.g=E,this.h=y,this.j=D,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new O.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,y){return super.on(E,y),this}handleData(E){if(this.b)return;const y=typeof E=="string"?E:this.d.write(E);this.k(y)}k(E){let y=E.indexOf(`
`);const D=this.a+E;if(y>=0)y+=this.a.length;else{this.a=D;return}let P=0;for(;y>=0;)this.m(D.substring(P,y).trim()),P=y+1,y=D.indexOf(`
`,P);this.a=D.substring(P)}m(E){if(this.b||!E)return;let y;try{y=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(y.type==="match"){const D=r(y.data.path),P=v.URI.joinPath(this.h,D),z=this.n(y.data,P);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const D=r(y.data.path),P=v.URI.joinPath(this.h,D);this.o(y.data,P).forEach(F=>this.p(F))}}n(E,y){const D=E.line_number-1,P=r(E.lines),z=Buffer.from(P);let F=0,T=0,j=D;E.submatches.length===0&&E.submatches.push(P.length?{start:0,end:1,match:{text:P[0]}}:{start:0,end:0,match:{text:""}});const N=(0,A.$Hb)(E.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Y=r(B.match),_=z.slice(F,B.start).toString(),J=s(_),Z=J.numLines>0?J.lastLineLength:J.lastLineLength+T,re=s(Y),ee=J.numLines+j,pe=re.numLines+ee,De=re.numLines>0?re.lastLineLength:re.lastLineLength+Z;return F=B.end,T=De,j=pe,new I.$zK(ee,Z,pe,De)}));return(0,k.$Nlc)(y,P,N,this.j)}o(E,y){const D=r(E.lines),P=E.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((z,F)=>({text:z,uri:y,lineNumber:P+F}))}p(E){this.emit("result",E)}}e.$Vlc=i;function r(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function s(w){const E=/\n/g;let y=0,D=-1,P;for(;P=E.exec(w);)y++,D=P.index;const z=D>=0?w.length-D-1:w.length;return{numLines:y,lastLineLength:z}}function t(w,E){const y=["--hidden","--no-require-git"];y.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:P}=(0,M.$K)(E.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(P&&P.length){const F=new Set;P.forEach(T=>{F.add(T)}),y.push("-g","!*"),F.forEach(T=>{f(T).map(k.$Mlc).forEach(j=>{y.push("-g",j)})})}D&&D.length&&D.forEach(F=>{y.push("-g",F)}),E.excludes.map(k.$Mlc).forEach(F=>y.push("-g",`!${F}`)),E.maxFileSize&&y.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),E.followSymlinks&&y.push("--follow"),E.encoding&&E.encoding!=="utf8"&&y.push("--encoding",E.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,$.$Ze)(w.pattern),w.isRegExp=!0),E.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),w.isRegExp&&(w.pattern=d(w.pattern),y.push("--engine","auto"));let z;if(w.isWordMatch){const T=(0,$.$9e)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",T)}else if(w.isRegExp){let F=a(w.pattern);F=h(F),y.push("--regexp",F)}else z=w.pattern,y.push("--fixed-strings");return y.push("--no-config"),E.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),w.isMultiline&&y.push("--multiline"),E.beforeContext&&y.push("--before-context",E.beforeContext+""),E.afterContext&&y.push("--after-context",E.afterContext+""),y.push("--"),z&&y.push(z),y.push("."),y}function f(w){return S(w).flatMap(y=>{const D=(0,b.$ak)(y,"/");return D.map((P,z)=>D.slice(0,z+1).join("/"))})}function d(w){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(y);)w=w.replace(y,"$1\\x{$2}");return w}const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function a(w){let E;try{E=new p.RegExpParser().parsePattern(w)}catch{return w}let y="",D=0;const P=(T,j,N)=>{y+=w.slice(D,T)+N,D=j},z=[];return new p.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const j=z[0];if(!j)P(T.start,T.end,"\\r?\\n");else if(!z.some(l))if(j.type==="CharacterClass")if(j.negate){const N=w.slice(j.start+2,T.start)+w.slice(T.end,j.end-1);j.parent?.type==="Quantifier"?P(j.start,j.end,N?`[^${N}]`:"."):P(j.start,j.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=w.slice(j.start+1,T.start)+w.slice(T.end,j.end-1);P(j.start,j.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else j.type==="Quantifier"&&P(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){z.unshift(T)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(T){z.unshift(T)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(T){z.unshift(T)},onCharacterClassLeave(){z.shift()},onAssertionEnter(T){l(T)&&z.push(T)},onAssertionLeave(T){z[0]===T&&z.shift()}}).visit(E),y+=w.slice(D),y}function h(w){return w.replace(/\n/g,"\\r?\\n")}function g(w){let E=!1,y=!1,D="",P="";for(let z=0;z<w.length;z++){const F=w[z];switch(F){case"\\":y?(E?P+="\\"+F:D+="\\"+F,y=!1):y=!0;break;case"{":if(y)E?P+=F:D+=F,y=!1;else{if(E)return{strInBraces:D+"{"+P+"{"+w.substring(z+1)};E=!0}break;case"}":if(y)E?P+=F:D+=F,y=!1;else{if(E)return{fixedStart:D,strInBraces:P,fixedEnd:w.substring(z+1)};D+=F}break;default:E?P+=(y?"\\":"")+F:D+=(y?"\\":"")+F,y=!1;break}}return{strInBraces:D+(E?"{"+P:"")}}function S(w){const{fixedStart:E,strInBraces:y,fixedEnd:D}=g(w);if(E===void 0||D===void 0)return[y];let P=(0,b.$ak)(y,",");P.length||(P=[""]);const z=S(D);return P.flatMap(F=>{const T=E+F;return z.map(j=>T+j)})}}),define(ke[386],Ee([1,0,22,160,108,15]),function(he,e,u,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class M{constructor(v){this.b=v,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(v,R,I,p){const C=new L.$Ulc(this.b);if(R.folder.scheme===A.Schemas.vscodeUserData){const k={...R,folder:R.folder.with({scheme:A.Schemas.file})},c=new O.$Rv(m=>I.report({...m,uri:m.uri.with({scheme:R.folder.scheme})}));return this.c(p,m=>C.provideTextSearchResults(v,k,c,m))}else return this.c(p,k=>C.provideTextSearchResults(v,R,I,k))}async c(v,R){const I=b(v);this.a.add(I);const p=await R(I.token);return this.a.delete(I),p}d(){this.a.forEach(v=>v.cancel())}}e.$5lc=M;function b($){const v=new u.$ee;return $.onCancellationRequested(()=>v.cancel()),v}}),define(ke[387],Ee([1,0,31,160,159]),function(he,e,u,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class A{constructor($){this.a=$}search($,v,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(C){R({message:C})}},p=new O.$2lc(this.a,new L.$Ulc(I),u);return new Promise((C,k)=>p.search(c=>{v(c.map(M))},$).then(c=>C({limitHit:c.limitHit,type:"success",stats:c.stats}),k))}}e.$3lc=A;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,v)=>{if(v.ranges){const R=v;return $+(Array.isArray(R.ranges)?R.ranges.length:1)}else return $+1},0)}}}),define(ke[388],Ee([1,0,19,8,13,4,132,17,39,2,32,36,383,387]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class k{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=o(r),f=new A.$7d({onDidAddFirstListener:()=>{s=(0,L.$8g)(d=>this.doFileSearchWithEngine(p.$Tlc,t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}textSearch(r){let s;const t=o(r),f=new A.$7d({onDidAddFirstListener:()=>{s=(0,L.$8g)(d=>this.f(t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new C.$3lc(r).search(t,s,s)}g(){return{maxFileSize:16*R.$kl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine(p.$Tlc,r,s,t)}doFileSearchWithEngine(r,s,t,f,d=k.a){let l=0;const a=g=>{Array.isArray(g)?(l+=g.length,t(g.map(S=>this.h(S)))):g.relativePath?(l++,t(this.h(g))):t(g)};if(s.sortByScore){let g=this.l(s,a,f);if(!g){const S=s.maxResults?Object.assign({},s,{maxResults:null}):s,w=new r(S);g=this.j(w,s,t,a,f)}return new Promise((S,w)=>{g.then(([E,y])=>{const D=y.map(P=>this.h(P));this.o(D,t,d),S(E)},w)})}const h=new r(s);return this.r(h,a,d,f).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,f,d){const l=new A.$7d;let a=(0,L.$8g)(g=>{let S=[];const w=E=>{Array.isArray(E)?S=E:(f(E),l.fire(E))};return this.r(r,w,-1,g).then(E=>[E,S])}),h;if(s.cacheKey){h=this.k(s.cacheKey);const g={promise:a,event:l.event,resolved:!1};h.resultsToSearchCache[s.filePattern||""]=g,a.then(()=>{g.resolved=!0},S=>{delete h.resultsToSearchCache[s.filePattern||""]}),a=this.s(a)}return a.then(([g,S])=>{const w=h?h.scorerCache:Object.create(null),E=(typeof s.maxResults!="number"||s.maxResults>0)&&$.$3d.create(!1);return this.n(s,S,w,d).then(y=>{const D=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:D,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:y.length},messages:g.messages,limitHit:g.limitHit||typeof s.maxResults=="number"&&S.length>s.maxResults},y]})})}k(r){const s=this.b[r];return s||(this.b[r]=new c)}l(r,s,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const d=this.q(f,r.filePattern||"",s,t);if(d)return d.then(([l,a,h])=>{const g=$.$3d.create(!1);return this.n(r,a,f.scorerCache,t).then(S=>{const w=g.elapsed(),E={fromCache:!0,detailStats:h,type:this.d,resultCount:a.length,sortingTime:w};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&a.length>r.maxResults,stats:E},S]})})}n(r,s,t,f){const d=(0,M.$hr)(r.filePattern||""),l=(h,g)=>(0,M.$gr)(h,g,d,!0,m,t),a=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(s,l,a,1e4,f)}o(r,s,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)s(r.slice(f,f+t));else s(r)}q(r,s,t,f){const d=$.$3d.create(!1),l=s.indexOf(b.sep)>=0;let a;for(const w in r.resultsToSearchCache)if(s.startsWith(w)){if(l&&w.indexOf(b.sep)<0&&w!=="")continue;const E=r.resultsToSearchCache[w];a={promise:this.s(E.promise),event:E.event,resolved:E.resolved};break}if(!a)return null;const h=d.elapsed(),g=$.$3d.create(!1),S=a.event(t);return f&&f.onCancellationRequested(()=>{S.dispose()}),a.promise.then(([w,E])=>{if(f&&f.isCancellationRequested)throw(0,O.$6)();const y=[],D=(0,M.$hr)(s).normalizedLowercase;for(const P of E)(0,I.$VK)(P,D)&&y.push(P);return[w,y,{cacheWasResolved:a.resolved,cacheLookupTime:h,cacheFilterTime:g.elapsed(),cacheEntryCount:E.length}]})}r(r,s,t,f){return new Promise((d,l)=>{let a=[];f?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(a.push(h),t>0&&a.length>=t&&(s(a),a=[])):s(h))},h=>{s(h)},(h,g)=>{a.length&&s(a),h?(s({message:"Search finished. Error: "+h.message}),l(h)):(s({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),d(g))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$4lc=k;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,b.$oc)(i.relativePath)}getItemDescription(i){return(0,b.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>v.URI.revive(r))}}function n(i){return{...i,folder:v.URI.revive(i.folder)}}}),define(ke[389],Ee([1,0,3,15,2,31,12,28,20,97,66,36,388,386,122,159]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;let m=class extends v.$Rkc{constructor(n,i,r,s){super(n,r,s),this.w=A,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new k.$Olc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.vscodeUserData,new C.$5lc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new k.$Olc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.file,new C.$5lc(n))),this.A.add(this.C(L.Schemas.file,new p.$4lc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,s){const t=(0,v.$Skc)(r);if(n===this.x){const f=Date.now();return this.D(n,i,t,s).then(d=>{const l=Date.now()-f;return this.q.debug(`Ext host file search time: ${l}ms`),d})}return super.$provideFileSearchResults(n,i,r,s)}doInternalFileSearchWithCustomCallback(n,i,r){const s=t=>{if((0,I.$UK)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>O.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new c.$2lc(n,i,void 0,"textSearchProvider")}};e.$6lc=m,e.$6lc=m=Je([qe(0,$.$MO),qe(1,b.$3O),qe(2,R.$Kjc),qe(3,M.$Oj)],m)}),define(ke[123],Ee([1,0,376,62,63,403,21,13,4,3,17,11,30,81,82]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$_h=e.$$h=e.$0h=void 0,e.$ai=d,e.$bi=l,e.$di=g,e.$ei=S;class c{traceSocketEvent(E,y){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,y)}constructor(E,y=""){this.f=!0,this.debugLabel=y,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,b.$1)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const y=D=>{this.traceSocketEvent("read",D),E(M.$ue.wrap(D))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(E){const y=D=>{E({type:0,hadError:D,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(E){const y=()=>{E()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$0h=c;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(o||(o={}));class n extends v.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,y){this.socket.traceSocketEvent(E,y)}constructor(E,y,D,P){super(),this.f=this.B(new $.$7d),this.g=this.B(new $.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:D?.byteLength||0,recordInflateBytes:P}),this.a=this.B(new i(this,y,D,P,this.f,(z,F)=>this.m(z,F))),this.B(this.a.onError(z=>{console.error(z),(0,b.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new k.$5h,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let y=0;for(;y<E.byteLength;)this.a.writeMessage(E.slice(y,Math.min(y+262144,E.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(E,{compressed:y,opcode:D}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let P=2;E.byteLength<126?P+=0:E.byteLength<2**16?P+=2:P+=8;const z=M.$ue.alloc(P),F=y?64:0,T=D&15;if(z.writeUInt8(128|F|T,0),E.byteLength<126)z.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){z.writeUInt8(126,1);let j=1;z.writeUInt8(E.byteLength>>>8&255,++j),z.writeUInt8(E.byteLength>>>0&255,++j)}else{z.writeUInt8(127,1);let j=1;z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(E.byteLength>>>24&255,++j),z.writeUInt8(E.byteLength>>>16&255,++j),z.writeUInt8(E.byteLength>>>8&255,++j),z.writeUInt8(E.byteLength>>>0&255,++j)}this.socket.write(M.$ue.concat([z,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),D=y.readUInt8(0),P=(D&128)>>>7,z=(D&64)>>>6,F=D&15,T=y.readUInt8(1),j=(T&128)>>>7,N=T&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(N===126?2:0)+(N===127?8:0),this.j.fin=P,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!P,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),D=y.readUInt8(1),P=(D&128)>>>7;let z=D&127,F=1;z===126?z=y.readUInt8(++F)*2**8+y.readUInt8(++F):z===127&&(z=y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F));let T=0;P&&(T=y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F)),this.j.state=3,this.j.readLen=z,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$$h=n;class i extends v.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$ue.alloc(0)}constructor(E,y,D,P,z,F){super(),this.n=E,this.r=z,this.s=F,this.a=this.B(new $.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,P,D,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(E,y){this.g.push({data:E,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:y}=this.g.shift();if(this.f&&y.compressed){const D=await this.w(this.f,E);this.s(D,y)}else this.s(E,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,y){return new Promise((D,P)=>{E.write(y),E.flush(z=>D(z))})}acceptFrame(E,y,D){this.h.push({data:E,isCompressed:y,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const y=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,y,D){return new Promise((P,z)=>{E.write(y),D&&E.write(M.$ue.fromByteArray([0,0,255,255])),E.flush(F=>P(F))})}}class r extends v.$Uc{get recordedInflateBytes(){return this.j?M.$ue.concat(this.f):M.$ue.alloc(0)}constructor(E,y,D,P){super(),this.h=E,this.j=y,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(P),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(M.$ue.wrap(z))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=M.$ue.concat(this.g);this.g.length=0,E(y)})}}class s extends v.$Uc{constructor(E,y){super(),this.g=E,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(M.$ue.wrap(D))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=M.$ue.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),E(y)})}}function t(w,E){if(E===0)return;const y=w.byteLength>>>2;for(let j=0;j<y;j++){const N=w.readUInt32BE(j*4);w.writeUInt32BE(N^E,j*4)}const D=y*4,P=w.byteLength-D,z=E>>>24&255,F=E>>>16&255,T=E>>>8&255;P>=1&&w.writeUInt8(w.readUInt8(D)^z,D),P>=2&&w.writeUInt8(w.readUInt8(D+1)^F,D+1),P>=3&&w.writeUInt8(w.readUInt8(D+2)^T,D+2)}e.$_h=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function d(){const w=(0,p.$Eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const E=process.platform!=="darwin"&&e.$_h?e.$_h:(0,O.tmpdir)(),y=(0,R.$kc)(E,`vscode-ipc-${w}.sock`);return a(y),y}function l(w,E,y){const P=(0,u.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${y}-${E}-sock`;const z=y.substr(0,4),F=E.substr(0,6);let T;return process.platform!=="darwin"&&e.$_h&&!process.env.VSCODE_PORTABLE?T=(0,R.$kc)(e.$_h,`vscode-${P}-${z}-${F}.sock`):T=(0,R.$kc)(w,`${z}-${F}.sock`),a(T),T}function a(w){const E=f[I.$u];typeof E=="number"&&w.length>=E&&console.warn(`WARNING: IPC handle "${w}" is longer than ${E} chars, try a shorter --user-data-dir`)}class h extends C.$Yh{static b(E){const y=$.Event.fromNodeEventEmitter(E,"connection");return $.Event.map(y,D=>({protocol:new k.$6h(new c(D,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(D,"close"))}))}constructor(E){super(h.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ci=h;function g(w){return new Promise((E,y)=>{const D=(0,L.createServer)();D.on("error",y),D.listen(w,()=>{D.removeListener("error",y),E(new h(D))})})}function S(w,E){return new Promise((y,D)=>{const P=(0,L.createConnection)(w,()=>{P.removeListener("error",D),y(k.$7h.fromSocket(new c(P,`ipc-client${E}`),E))});P.once("error",D)})}}),define(ke[390],Ee([1,0,62,63,172,123,8,3,11,53,12,139,265,266,110,88,21]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=e.$_bc=e.$$bc=void 0;async function o(t,f,d,l,a){let h;for(let g=3;g&&(h?.dispose(),h=await new n(t,f,d,l,a).waitForReady(),!(a&&O.$Hg[a]||!O.$Hg[h.tunnelLocalPort]));g--);return h}class n extends b.$Uc{constructor(f,d,l,a,h){super(),this.m=d,this.n=h,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=u.createServer(),this.c=new M.$hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,d=(0,c.$5v)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,O.$Ig)(f,2,1e3,d),a=null;return this.b.listen(l,this.m),await this.c.wait(),a=this.b.address(),a||(l=0,this.b.listen(l,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(f){f.pause();const d=(0,c.$3v)(this.tunnelRemoteHost)||(0,c.$5v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,p.$El)(this.a,d,this.tunnelRemotePort),a=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&f.write(h.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),a.end()}),f.on("close",()=>a.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),a instanceof A.$0h?a.socket.destroy():a.end()}),a instanceof A.$0h?this.t(f,a):this.s(f,a),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),a.end()})}s(f,d){d.onClose(()=>f.destroy()),d.onEnd(()=>f.end()),d.onData(l=>f.write(l.buffer)),f.on("data",l=>d.write(m.$ue.wrap(l))),f.resume()}t(f,d){const l=d.socket;l.on("end",()=>f.end()),l.on("close",()=>f.end()),l.on("error",()=>{f.destroy()}),l.pipe(f),f.pipe(l)}}e.$$bc=n;let i=class extends c.$8v{constructor(f,d,l,a,h){super(d,h),this.v=f,this.w=l,this.y=a}isPortPrivileged(f){return(0,c.$6v)(f,this.m,$.OS,L.release())}t(f,d,l,a,h,g,S,w){const E=this.s(d,l);if(E)return++E.refcount,E.value;if((0,c.$Yv)(f))return this.u(f,d,l,h,g,S,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},D=o(y,a,d,l,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,l,D),D}}};e.$_bc=i,e.$_bc=i=Je([qe(0,C.$yl),qe(1,R.$Oj),qe(2,k.$Bl),qe(3,I.$8j),qe(4,v.$Oi)],i);let r=class extends i{constructor(f,d,l,a,h){super(f,d,l,a,h)}};e.$acc=r,e.$acc=r=Je([qe(0,C.$yl),qe(1,R.$Oj),qe(2,k.$Bl),qe(3,I.$8j),qe(4,v.$Oi)],r);let s=class extends b.$Uc{constructor(f,d,l,a,h){super(),this.b=f,this.c=d,this.f=l,this.g=a,this.h=h,this.a=new Map}async openTunnel(f,d,l,a,h,g,S,w,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${a} on local port ${g}.`),!this.a.has(f)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(d,l,a,h,g,S,w,E)}};e.$bcc=s,e.$bcc=s=Je([qe(0,C.$yl),qe(1,R.$Oj),qe(2,I.$8j),qe(3,k.$Bl),qe(4,v.$Oi)],s)}),define(ke[391],Ee([1,0,123,285,51,33,2,12,42]),function(he,e,u,L,O,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$bP=void 0;class v{constructor(p,C,k){this.b=p,this.c=C,this.f=k,this.a=L.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(C.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,C){const k=(m,o)=>{C.writeHead(m,{"content-type":"application/json"}),C.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},c=[];p.setEncoding("utf8"),p.on("data",m=>c.push(m)),p.on("end",async()=>{try{const m=JSON.parse(c.join(""));let o;switch(m.type){case"open":o=await this.i(m);break;case"openExternal":o=await this.j(m);break;case"status":o=await this.l(m);break;case"extensionManagement":o=await this.k(m);break;default:k(404,`Unknown message type: ${m.type}`);break}k(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);k(500,o),this.c.error("Error while processing pipe request",m)}})}async i(p){const{fileURIs:C,folderURIs:k,forceNewWindow:c,diffMode:m,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=p,f=[];if(Array.isArray(k))for(const h of k)try{f.push({folderUri:M.URI.parse(h)})}catch{}if(Array.isArray(C))for(const h of C)try{(0,$.$Ni)(h)?f.push({workspaceUri:M.URI.parse(h)}):f.push({fileUri:M.URI.parse(h)})}catch{}const d=s?M.URI.file(s):void 0,a={forceNewWindow:c,diffMode:m,mergeMode:o,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!d&&!n,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,a)}async j(p){for(const C of p.uris){const k=M.URI.parse(C),c=k.scheme==="file"?k:C;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(p){const C=c=>c?.map(m=>/\.vsix$/i.test(m)?M.URI.parse(m):m),k={list:p.list,install:C(p.install),uninstall:C(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&O.existsSync(this.f)&&O.unlinkSync(this.f)}}e.$bP=v;let R=class extends v{constructor(p,C){super(p,C,(0,u.$ai)())}};e.$cP=R,e.$cP=R=Je([qe(0,A.$9O),qe(1,b.$Oj)],R)}),define(ke[392],Ee([1,0,58,379,373,284,48,360,2,15,7,391,104,318,359]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class c extends O.$zlc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(d,l,a){return d=t(d),n.a.has(d)?n.a.get(d).load(d,$.URI.file((0,p.$Qq)(l.filename)),h=>r.apply(this,[h,l,a])):r.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(f,d)=>s.call(this,t(f),d);const t=f=>{for(const d of n.b){const l=d(f);if(l){f=l;break}}return f}}}class m extends M.$okc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async vb(){this.h.createInstance(C.$9lc);const n=this.h.invokeFunction(L.$vlc);if(this.h.createInstance(b.$8lc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(I.$cP);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(k.$0lc),await this.h.createInstance(c,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,A.$7lc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,r){if(i.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),s=he.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$$lc=m}),define(ke[393],Ee([1,0,52,21,4,3,125,11,23,2,31,12,264,65,110,88,390,28,20,70,367]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0,e.$_lc=s,e.$amc=t,e.$bmc=f,e.$cmc=d,e.$dmc=a,e.$emc=h,e.$fmc=g;function s(E){const y=E.trim().split(`
`),D=[];return y.forEach(z=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);F&&F.length>=3&&D.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),D.reduce((z,F)=>(z[F.socket]=F,z),{})}function t(...E){const y=[].concat(...E.map(d));return[...new Map(y.filter(D=>D.st==="0A").map(D=>{const P=D.local_address.split(":");return{socket:parseInt(D.inode,10),ip:f(P[0]),port:parseInt(P[1],16)}}).map(D=>[D.ip+":"+D.port,D])).values()]}function f(E){let y="";if(E.length===8)for(let D=E.length-2;D>=0;D-=2)y+=parseInt(E.substr(D,2),16),D!==0&&(y+=".");else for(let D=0;D<E.length;D+=8){const P=E.substring(D,D+8);let z="";for(let F=8;F>=2;F-=2)z+=P.substring(F-2,F),(F===6||F===2)&&(z=parseInt(z,16).toString(16),y+=`${z}`,z="",D+F!==E.length-6&&(y+=":"))}return y}function d(E){const y=E.trim().split(`
`),D=y.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return y.map(z=>z.trim().split(/\s+/).reduce((F,T,j)=>(F[D[j]||j]=T,F),{}))}function l(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function a(E){const y=E.trim().split(`
`),D=[];return y.forEach(P=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(P);z&&z.length>=4&&D.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),D}async function h(E,y,D){const P=D.reduce((F,T)=>(F[T.pid]=T,F),{}),z=[];return E.forEach(({socket:F,ip:T,port:j})=>{const N=y[F]?y[F].pid:void 0,B=N?P[N]?.cmd:void 0;N&&B&&!l(B)&&z.push({host:T,port:j,detail:B,pid:N})}),z}function g(E,y,D){const P=new Map,z=a(y);for(const F of E){const T=D.get(F.port);if(T){P.set(F.port,T);continue}const j=z.find(N=>N.cmd.includes(`${F.port}`));if(j){let N=j,B;do B=z.find(W=>W.ppid===N.pid),B&&(N=B);while(B);P.set(F.port,{host:F.ip,port:F.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else P.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return P}let S=class extends i.$6Bb{constructor(y,D,P,z){super(y,D,P),this.D=D,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&D.remote.isRemote&&D.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let D;this.y&&(D=this.y,await this.a.$onFoundNewCandidates(this.y));const P=new M.$qm;let z=0;for(;this.C;){const F=new Date().getTime(),T=(await this.I()).filter(B=>(0,c.$3v)(B.host)||(0,c.$5v)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(B=>B.port).join(", ")}`);const j=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),z++>3&&P.update(j),(!D||JSON.stringify(D)!==JSON.stringify(T))&&(D=T,await this.a.$onFoundNewCandidates(D));const N=this.G(P.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${N} ms.`),await new Promise(B=>setTimeout(()=>B(),N))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",D="";try{y=await R.Promises.readFile("/proc/net/tcp","utf8"),D=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const P=t(y,D),z=await new Promise(_=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,Z,re)=>{_(Z)})}),F=s(z),T=await R.Promises.readdir("/proc"),j=[];for(const _ of T)try{const J=Number(_),Z=$.$Vg(v.URI.file("/proc"),_);if((await R.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(J)){const ee=await R.Promises.readlink($.$Vg(Z,"cwd").fsPath),pe=await R.Promises.readFile($.$Vg(Z,"cmdline").fsPath,"utf8");j.push({pid:J,cwd:ee,cmd:pe})}}catch{}const N=[],B=P.filter(_=>{const J=F[_.socket];return J||N.push(_),J}),W=h(B,F,j);let Y;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const _=await new Promise(J=>{(0,u.exec)("ps -F -A -l | grep root",(Z,re,ee)=>{J(re)})});this.z=g(N,_,this.z),Y=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Y.map(J=>J.port).join(", ")}`)}return W.then(_=>Y?_.concat(Y):_)}w(y){return async D=>{const P=new m.$$bc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,T,j,N){const B=await y.makeConnection();return w.connect(B,T,j,N)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new C.$ul(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",D.remoteAddress.host||"localhost",D.remoteAddress.port,D.localAddressPort);await P.waitForReady();const z=new O.$7d;return{localAddress:(0,r.$RL)(P.localAddress)??P.localAddress,remoteAddress:{port:P.tunnelRemotePort,host:P.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{P.dispose(),z.fire(),z.dispose()}}}}};e.$gmc=S,e.$gmc=S=Je([qe(0,n.$MO),qe(1,o.$3O),qe(2,I.$Oj),qe(3,k.$Bl)],S);class w extends p.$yub{static connect(y,D,P,z){const F=new A.$Tc,T={onClose:F.add(new O.$7d),onData:F.add(new O.$7d),onEnd:F.add(new O.$7d)};F.add(y.onDidReceiveMessage(N=>T.onData.fire(L.$ue.wrap(N)))),F.add(y.onDidEnd(()=>T.onEnd.fire())),F.add(y.onDidClose(N=>T.onClose.fire({type:0,error:N,hadError:!!N})));const j=new w(y,z,T);return j.B(F),(0,p.$xub)(j,D,P,z,T)}constructor(y,D,P){super(D,P),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[394],Ee([1,0,84,362,377,375,389,392,393,96,48,97,95,47,70,93,361,319,12,378,60,279,106,110,141]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o,n,i,r,s,t,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$gs)(R.$pkc,b.$$lc,0),(0,u.$gs)(n.$Pj,o.$imc,1),(0,u.$gs)(n.$Oj,new t.$fi(s.$ylc,[!1],!0)),(0,u.$gs)(f.$Bl,d.$dcc,1),(0,u.$gs)(c.$Tjc,m.$hmc,0),(0,u.$gs)(v.$ukc,A.$Llc,0),(0,u.$gs)(I.$Qkc,M.$6lc,0),(0,u.$gs)(p.$hlc,O.$Dlc,0),(0,u.$gs)(C.$ckc,L.$Clc,0),(0,u.$gs)(k.$5Bb,$.$gmc,0),(0,u.$gs)(r.$skc,i.$jmc,0)}),define(ke[404],Ee([1,0,62,405,58,13,82,123,262,114,374,21,31,104,8,135,286,301,380,394]),function(he,e,u,L,O,A,M,b,$,v,R,I,p,C,k,c,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const n=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,g=h._load;h._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function s(h){process.exit=function(g){if(h)i(g);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(g,S){g==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),r(g,S)}}let t=function(h){i()};function f(){const h=(0,o.$an)(process.env);if(h.type===3)return new Promise((g,S)=>{const w=E=>{const y=E[0],D=new M.$8h;y.on("message",P=>D.fire(I.$ue.wrap(P.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),g({onMessage:D.event,send:P=>y.postMessage(P.buffer)})};process.parentPort.on("message",E=>w(E.ports))});if(h.type===2)return new Promise((g,S)=>{let w=null;const E=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,D=3e5,P=new k.$vh(()=>t("renderer disconnected for too long (1)"),y),z=new k.$vh(()=>t("renderer disconnected for too long (2)"),D);process.on("message",(T,j)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const N=I.$ue.wrap(Buffer.from(T.initialDataChunk,"base64"));let B;if(T.skipWebSocketFrames)B=new b.$0h(j,"extHost-socket");else{const W=I.$ue.wrap(Buffer.from(T.inflateBytes,"base64"));B=new b.$$h(new b.$0h(j,"extHost-socket"),T.permessageDeflate,W,!1)}w?(P.cancel(),z.cancel(),w.beginAcceptReconnection(B,N),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(E),w=new M.$9h({socket:B,initialChunk:N}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),g(w),w.onSocketClose(()=>{P.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;P.isScheduled()&&z.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const g=h.pipeName;return new Promise((S,w)=>{const E=u.createConnection(g,()=>{E.removeListener("error",w);const y=new M.$9h({socket:new b.$0h(E,"extHost-renderer")});y.sendResume(),S(y)});E.once("error",w),E.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await f();return new class{constructor(){this.a=new M.$8h,this.onMessage=this.a.event,this.b=!1,h.onMessage(g=>{(0,v.$Mm)(g,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(g)})}send(g){this.b||h.send(g)}async drain(){if(h.drain)return h.drain()}}}function l(h){return new Promise(g=>{const S=h.onMessage(w=>{S.dispose();const E=JSON.parse(w.toString()),y=E.commit,D=$.default.commit;if(y&&D&&y!==D&&i(55),E.parentPid){let P=0;setInterval(function(){try{process.kill(E.parentPid,0),P=0}catch(F){F&&F.code==="EPERM"?(P++,P>=3&&t(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${E.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(E.parentPid)}catch(F){(0,A.$1)(F)}}h.send((0,v.$Lm)(0)),g({protocol:h,initData:E})});h.send((0,v.$Lm)(1))})}async function a(){const h=[];process.on("unhandledRejection",(P,z)=>{h.push(z),setTimeout(()=>{const F=h.indexOf(z);F>=0&&z.catch(T=>{h.splice(F,1),(0,A.$4)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),P&&(0,A.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const z=h.indexOf(P);z>=0&&h.splice(z,1)}),process.on("uncaughtException",function(P){(0,A.$Z)(P)||(0,A.$1)(P)}),O.mark("code/extHost/willConnectToRenderer");const g=await d();O.mark("code/extHost/didConnectToRenderer");const S=await l(g);O.mark("code/extHost/didWaitForInitData");const{initData:w}=S;s(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,c.boolean)(n.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(z){i(z)}fsExists(z){return p.Promises.exists(z)}fsRealpath(z){return(0,C.$Pq)(z)}};let y=null;w.remote.authority&&n.transformURIs&&(y=(0,m.$ks)(w.remote.authority));const D=new R.$Blc(S.protocol,w,E,y);t=P=>D.terminate(P)}a().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b40321263dbe14515f436b9b34ab5c7d8d5526ae/core/vs/workbench/api/node/extensionHostProcess.js.map
